/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2021, PgPool Global Development Group
 * Portions Copyright (c) 1996-2021, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "pool_string.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_attribute.h
 */
#define		  ATTRIBUTE_IDENTITY_ALWAYS	'a'
#define		  ATTRIBUTE_IDENTITY_BY_DEFAULT 'd'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node *limitOffset;
	Node *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool	distinct;
	List   *list;
} GroupClause;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeStringConst(char *str, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 311 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_BASE_YY_Y_TAB_H_INCLUDED
# define YY_BASE_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSOLUTE_P = 276,
    ACCESS = 277,
    ACTION = 278,
    ADD_P = 279,
    ADMIN = 280,
    AFTER = 281,
    AGGREGATE = 282,
    ALL = 283,
    ALSO = 284,
    ALTER = 285,
    ALWAYS = 286,
    ANALYSE = 287,
    ANALYZE = 288,
    AND = 289,
    ANY = 290,
    ARRAY = 291,
    AS = 292,
    ASC = 293,
    ASENSITIVE = 294,
    ASSERTION = 295,
    ASSIGNMENT = 296,
    ASYMMETRIC = 297,
    ATOMIC = 298,
    AT = 299,
    ATTACH = 300,
    ATTRIBUTE = 301,
    AUTHORIZATION = 302,
    BACKWARD = 303,
    BEFORE = 304,
    BEGIN_P = 305,
    BETWEEN = 306,
    BIGINT = 307,
    BINARY = 308,
    BIT = 309,
    BOOLEAN_P = 310,
    BOTH = 311,
    BREADTH = 312,
    BY = 313,
    CACHE = 314,
    CALL = 315,
    CALLED = 316,
    CASCADE = 317,
    CASCADED = 318,
    CASE = 319,
    CAST = 320,
    CATALOG_P = 321,
    CHAIN = 322,
    CHAR_P = 323,
    CHARACTER = 324,
    CHARACTERISTICS = 325,
    CHECK = 326,
    CHECKPOINT = 327,
    CLASS = 328,
    CLOSE = 329,
    CLUSTER = 330,
    COALESCE = 331,
    COLLATE = 332,
    COLLATION = 333,
    COLUMN = 334,
    COLUMNS = 335,
    COMMENT = 336,
    COMMENTS = 337,
    COMMIT = 338,
    COMMITTED = 339,
    COMPRESSION = 340,
    CONCURRENTLY = 341,
    CONFIGURATION = 342,
    CONFLICT = 343,
    CONNECTION = 344,
    CONSTRAINT = 345,
    CONSTRAINTS = 346,
    CONTENT_P = 347,
    CONTINUE_P = 348,
    CONVERSION_P = 349,
    COPY = 350,
    COST = 351,
    CREATE = 352,
    CROSS = 353,
    CSV = 354,
    CUBE = 355,
    CURRENT_P = 356,
    CURRENT_CATALOG = 357,
    CURRENT_DATE = 358,
    CURRENT_ROLE = 359,
    CURRENT_SCHEMA = 360,
    CURRENT_TIME = 361,
    CURRENT_TIMESTAMP = 362,
    CURRENT_USER = 363,
    CURSOR = 364,
    CYCLE = 365,
    DATA_P = 366,
    DATABASE = 367,
    DAY_P = 368,
    DEALLOCATE = 369,
    DEC = 370,
    DECIMAL_P = 371,
    DECLARE = 372,
    DEFAULT = 373,
    DEFAULTS = 374,
    DEFERRABLE = 375,
    DEFERRED = 376,
    DEFINER = 377,
    DELETE_P = 378,
    DELIMITER = 379,
    DELIMITERS = 380,
    DEPENDS = 381,
    DEPTH = 382,
    DESC = 383,
    DETACH = 384,
    DICTIONARY = 385,
    DISABLE_P = 386,
    DISCARD = 387,
    DISTINCT = 388,
    DO = 389,
    DOCUMENT_P = 390,
    DOMAIN_P = 391,
    DOUBLE_P = 392,
    DROP = 393,
    EACH = 394,
    ELSE = 395,
    ENABLE_P = 396,
    ENCODING = 397,
    ENCRYPTED = 398,
    END_P = 399,
    ENUM_P = 400,
    ESCAPE = 401,
    EVENT = 402,
    EXCEPT = 403,
    EXCLUDE = 404,
    EXCLUDING = 405,
    EXCLUSIVE = 406,
    EXECUTE = 407,
    EXISTS = 408,
    EXPLAIN = 409,
    EXPRESSION = 410,
    EXTENSION = 411,
    EXTERNAL = 412,
    EXTRACT = 413,
    FALSE_P = 414,
    FAMILY = 415,
    FETCH = 416,
    FILTER = 417,
    FINALIZE = 418,
    FIRST_P = 419,
    FLOAT_P = 420,
    FOLLOWING = 421,
    FOR = 422,
    FORCE = 423,
    FOREIGN = 424,
    FORWARD = 425,
    FREEZE = 426,
    FROM = 427,
    FULL = 428,
    FUNCTION = 429,
    FUNCTIONS = 430,
    GENERATED = 431,
    GLOBAL = 432,
    GRANT = 433,
    GRANTED = 434,
    GREATEST = 435,
    GROUP_P = 436,
    GROUPING = 437,
    GROUPS = 438,
    HANDLER = 439,
    HAVING = 440,
    HEADER_P = 441,
    HOLD = 442,
    HOUR_P = 443,
    IDENTITY_P = 444,
    IF_P = 445,
    ILIKE = 446,
    IMMEDIATE = 447,
    IMMUTABLE = 448,
    IMPLICIT_P = 449,
    IMPORT_P = 450,
    IN_P = 451,
    INCLUDE = 452,
    INCLUDING = 453,
    INCREMENT = 454,
    INDEX = 455,
    INDEXES = 456,
    INHERIT = 457,
    INHERITS = 458,
    INITIALLY = 459,
    INLINE_P = 460,
    INNER_P = 461,
    INOUT = 462,
    INPUT_P = 463,
    INSENSITIVE = 464,
    INSERT = 465,
    INSTEAD = 466,
    INT_P = 467,
    INTEGER = 468,
    INTERSECT = 469,
    INTERVAL = 470,
    INTO = 471,
    INVOKER = 472,
    IS = 473,
    ISNULL = 474,
    ISOLATION = 475,
    JOIN = 476,
    KEY = 477,
    LABEL = 478,
    LANGUAGE = 479,
    LARGE_P = 480,
    LAST_P = 481,
    LATERAL_P = 482,
    LEADING = 483,
    LEAKPROOF = 484,
    LEAST = 485,
    LEFT = 486,
    LEVEL = 487,
    LIKE = 488,
    LIMIT = 489,
    LISTEN = 490,
    LOAD = 491,
    LOCAL = 492,
    LOCALTIME = 493,
    LOCALTIMESTAMP = 494,
    LOCATION = 495,
    LOCK_P = 496,
    LOCKED = 497,
    LOGGED = 498,
    MAPPING = 499,
    MATCH = 500,
    MATERIALIZED = 501,
    MAXVALUE = 502,
    METHOD = 503,
    MINUTE_P = 504,
    MINVALUE = 505,
    MODE = 506,
    MONTH_P = 507,
    MOVE = 508,
    NAME_P = 509,
    NAMES = 510,
    NATIONAL = 511,
    NATURAL = 512,
    NCHAR = 513,
    NEW = 514,
    NEXT = 515,
    NFC = 516,
    NFD = 517,
    NFKC = 518,
    NFKD = 519,
    NO = 520,
    NONE = 521,
    NORMALIZE = 522,
    NORMALIZED = 523,
    NOT = 524,
    NOTHING = 525,
    NOTIFY = 526,
    NOTNULL = 527,
    NOWAIT = 528,
    NULL_P = 529,
    NULLIF = 530,
    NULLS_P = 531,
    NUMERIC = 532,
    OBJECT_P = 533,
    OF = 534,
    OFF = 535,
    OFFSET = 536,
    OIDS = 537,
    OLD = 538,
    ON = 539,
    ONLY = 540,
    OPERATOR = 541,
    OPTION = 542,
    OPTIONS = 543,
    OR = 544,
    ORDER = 545,
    ORDINALITY = 546,
    OTHERS = 547,
    OUT_P = 548,
    OUTER_P = 549,
    OVER = 550,
    OVERLAPS = 551,
    OVERLAY = 552,
    OVERRIDING = 553,
    OWNED = 554,
    OWNER = 555,
    PARALLEL = 556,
    PARSER = 557,
    PARTIAL = 558,
    PARTITION = 559,
    PASSING = 560,
    PASSWORD = 561,
    PGPOOL = 562,
    PLACING = 563,
    PLANS = 564,
    POLICY = 565,
    POSITION = 566,
    PRECEDING = 567,
    PRECISION = 568,
    PRESERVE = 569,
    PREPARE = 570,
    PREPARED = 571,
    PRIMARY = 572,
    PRIOR = 573,
    PRIVILEGES = 574,
    PROCEDURAL = 575,
    PROCEDURE = 576,
    PROCEDURES = 577,
    PROGRAM = 578,
    PUBLICATION = 579,
    QUOTE = 580,
    RANGE = 581,
    READ = 582,
    REAL = 583,
    REASSIGN = 584,
    RECHECK = 585,
    RECURSIVE = 586,
    REF = 587,
    REFERENCES = 588,
    REFERENCING = 589,
    REFRESH = 590,
    REINDEX = 591,
    RELATIVE_P = 592,
    RELEASE = 593,
    RENAME = 594,
    REPEATABLE = 595,
    REPLACE = 596,
    REPLICA = 597,
    RESET = 598,
    RESTART = 599,
    RESTRICT = 600,
    RETURN = 601,
    RETURNING = 602,
    RETURNS = 603,
    REVOKE = 604,
    RIGHT = 605,
    ROLE = 606,
    ROLLBACK = 607,
    ROLLUP = 608,
    ROUTINE = 609,
    ROUTINES = 610,
    ROW = 611,
    ROWS = 612,
    RULE = 613,
    SAVEPOINT = 614,
    SCHEMA = 615,
    SCHEMAS = 616,
    SCROLL = 617,
    SEARCH = 618,
    SECOND_P = 619,
    SECURITY = 620,
    SELECT = 621,
    SEQUENCE = 622,
    SEQUENCES = 623,
    SERIALIZABLE = 624,
    SERVER = 625,
    SESSION = 626,
    SESSION_USER = 627,
    SET = 628,
    SETS = 629,
    SETOF = 630,
    SHARE = 631,
    SHOW = 632,
    SIMILAR = 633,
    SIMPLE = 634,
    SKIP = 635,
    SMALLINT = 636,
    SNAPSHOT = 637,
    SOME = 638,
    SQL_P = 639,
    STABLE = 640,
    STANDALONE_P = 641,
    START = 642,
    STATEMENT = 643,
    STATISTICS = 644,
    STDIN = 645,
    STDOUT = 646,
    STORAGE = 647,
    STORED = 648,
    STRICT_P = 649,
    STRIP_P = 650,
    SUBSCRIPTION = 651,
    SUBSTRING = 652,
    SUPPORT = 653,
    SYMMETRIC = 654,
    SYSID = 655,
    SYSTEM_P = 656,
    TABLE = 657,
    TABLES = 658,
    TABLESAMPLE = 659,
    TABLESPACE = 660,
    TEMP = 661,
    TEMPLATE = 662,
    TEMPORARY = 663,
    TEXT_P = 664,
    THEN = 665,
    TIES = 666,
    TIME = 667,
    TIMESTAMP = 668,
    TO = 669,
    TRAILING = 670,
    TRANSACTION = 671,
    TRANSFORM = 672,
    TREAT = 673,
    TRIGGER = 674,
    TRIM = 675,
    TRUE_P = 676,
    TRUNCATE = 677,
    TRUSTED = 678,
    TYPE_P = 679,
    TYPES_P = 680,
    UESCAPE = 681,
    UNBOUNDED = 682,
    UNCOMMITTED = 683,
    UNENCRYPTED = 684,
    UNION = 685,
    UNIQUE = 686,
    UNKNOWN = 687,
    UNLISTEN = 688,
    UNLOGGED = 689,
    UNTIL = 690,
    UPDATE = 691,
    USER = 692,
    USING = 693,
    VACUUM = 694,
    VALID = 695,
    VALIDATE = 696,
    VALIDATOR = 697,
    VALUE_P = 698,
    VALUES = 699,
    VARCHAR = 700,
    VARIADIC = 701,
    VARYING = 702,
    VERBOSE = 703,
    VERSION_P = 704,
    VIEW = 705,
    VIEWS = 706,
    VOLATILE = 707,
    WHEN = 708,
    WHERE = 709,
    WHITESPACE_P = 710,
    WINDOW = 711,
    WITH = 712,
    WITHIN = 713,
    WITHOUT = 714,
    WORK = 715,
    WRAPPER = 716,
    WRITE = 717,
    XML_P = 718,
    XMLATTRIBUTES = 719,
    XMLCONCAT = 720,
    XMLELEMENT = 721,
    XMLEXISTS = 722,
    XMLFOREST = 723,
    XMLNAMESPACES = 724,
    XMLPARSE = 725,
    XMLPI = 726,
    XMLROOT = 727,
    XMLSERIALIZE = 728,
    XMLTABLE = 729,
    YEAR_P = 730,
    YES_P = 731,
    ZONE = 732,
    NOT_LA = 733,
    NULLS_LA = 734,
    WITH_LA = 735,
    MODE_TYPE_NAME = 736,
    MODE_PLPGSQL_EXPR = 737,
    MODE_PLPGSQL_ASSIGN1 = 738,
    MODE_PLPGSQL_ASSIGN2 = 739,
    MODE_PLPGSQL_ASSIGN3 = 740,
    UMINUS = 741
  };
#endif
/* Tokens.  */
#define IDENT 258
#define UIDENT 259
#define FCONST 260
#define SCONST 261
#define USCONST 262
#define BCONST 263
#define XCONST 264
#define Op 265
#define ICONST 266
#define PARAM 267
#define TYPECAST 268
#define DOT_DOT 269
#define COLON_EQUALS 270
#define EQUALS_GREATER 271
#define LESS_EQUALS 272
#define GREATER_EQUALS 273
#define NOT_EQUALS 274
#define ABORT_P 275
#define ABSOLUTE_P 276
#define ACCESS 277
#define ACTION 278
#define ADD_P 279
#define ADMIN 280
#define AFTER 281
#define AGGREGATE 282
#define ALL 283
#define ALSO 284
#define ALTER 285
#define ALWAYS 286
#define ANALYSE 287
#define ANALYZE 288
#define AND 289
#define ANY 290
#define ARRAY 291
#define AS 292
#define ASC 293
#define ASENSITIVE 294
#define ASSERTION 295
#define ASSIGNMENT 296
#define ASYMMETRIC 297
#define ATOMIC 298
#define AT 299
#define ATTACH 300
#define ATTRIBUTE 301
#define AUTHORIZATION 302
#define BACKWARD 303
#define BEFORE 304
#define BEGIN_P 305
#define BETWEEN 306
#define BIGINT 307
#define BINARY 308
#define BIT 309
#define BOOLEAN_P 310
#define BOTH 311
#define BREADTH 312
#define BY 313
#define CACHE 314
#define CALL 315
#define CALLED 316
#define CASCADE 317
#define CASCADED 318
#define CASE 319
#define CAST 320
#define CATALOG_P 321
#define CHAIN 322
#define CHAR_P 323
#define CHARACTER 324
#define CHARACTERISTICS 325
#define CHECK 326
#define CHECKPOINT 327
#define CLASS 328
#define CLOSE 329
#define CLUSTER 330
#define COALESCE 331
#define COLLATE 332
#define COLLATION 333
#define COLUMN 334
#define COLUMNS 335
#define COMMENT 336
#define COMMENTS 337
#define COMMIT 338
#define COMMITTED 339
#define COMPRESSION 340
#define CONCURRENTLY 341
#define CONFIGURATION 342
#define CONFLICT 343
#define CONNECTION 344
#define CONSTRAINT 345
#define CONSTRAINTS 346
#define CONTENT_P 347
#define CONTINUE_P 348
#define CONVERSION_P 349
#define COPY 350
#define COST 351
#define CREATE 352
#define CROSS 353
#define CSV 354
#define CUBE 355
#define CURRENT_P 356
#define CURRENT_CATALOG 357
#define CURRENT_DATE 358
#define CURRENT_ROLE 359
#define CURRENT_SCHEMA 360
#define CURRENT_TIME 361
#define CURRENT_TIMESTAMP 362
#define CURRENT_USER 363
#define CURSOR 364
#define CYCLE 365
#define DATA_P 366
#define DATABASE 367
#define DAY_P 368
#define DEALLOCATE 369
#define DEC 370
#define DECIMAL_P 371
#define DECLARE 372
#define DEFAULT 373
#define DEFAULTS 374
#define DEFERRABLE 375
#define DEFERRED 376
#define DEFINER 377
#define DELETE_P 378
#define DELIMITER 379
#define DELIMITERS 380
#define DEPENDS 381
#define DEPTH 382
#define DESC 383
#define DETACH 384
#define DICTIONARY 385
#define DISABLE_P 386
#define DISCARD 387
#define DISTINCT 388
#define DO 389
#define DOCUMENT_P 390
#define DOMAIN_P 391
#define DOUBLE_P 392
#define DROP 393
#define EACH 394
#define ELSE 395
#define ENABLE_P 396
#define ENCODING 397
#define ENCRYPTED 398
#define END_P 399
#define ENUM_P 400
#define ESCAPE 401
#define EVENT 402
#define EXCEPT 403
#define EXCLUDE 404
#define EXCLUDING 405
#define EXCLUSIVE 406
#define EXECUTE 407
#define EXISTS 408
#define EXPLAIN 409
#define EXPRESSION 410
#define EXTENSION 411
#define EXTERNAL 412
#define EXTRACT 413
#define FALSE_P 414
#define FAMILY 415
#define FETCH 416
#define FILTER 417
#define FINALIZE 418
#define FIRST_P 419
#define FLOAT_P 420
#define FOLLOWING 421
#define FOR 422
#define FORCE 423
#define FOREIGN 424
#define FORWARD 425
#define FREEZE 426
#define FROM 427
#define FULL 428
#define FUNCTION 429
#define FUNCTIONS 430
#define GENERATED 431
#define GLOBAL 432
#define GRANT 433
#define GRANTED 434
#define GREATEST 435
#define GROUP_P 436
#define GROUPING 437
#define GROUPS 438
#define HANDLER 439
#define HAVING 440
#define HEADER_P 441
#define HOLD 442
#define HOUR_P 443
#define IDENTITY_P 444
#define IF_P 445
#define ILIKE 446
#define IMMEDIATE 447
#define IMMUTABLE 448
#define IMPLICIT_P 449
#define IMPORT_P 450
#define IN_P 451
#define INCLUDE 452
#define INCLUDING 453
#define INCREMENT 454
#define INDEX 455
#define INDEXES 456
#define INHERIT 457
#define INHERITS 458
#define INITIALLY 459
#define INLINE_P 460
#define INNER_P 461
#define INOUT 462
#define INPUT_P 463
#define INSENSITIVE 464
#define INSERT 465
#define INSTEAD 466
#define INT_P 467
#define INTEGER 468
#define INTERSECT 469
#define INTERVAL 470
#define INTO 471
#define INVOKER 472
#define IS 473
#define ISNULL 474
#define ISOLATION 475
#define JOIN 476
#define KEY 477
#define LABEL 478
#define LANGUAGE 479
#define LARGE_P 480
#define LAST_P 481
#define LATERAL_P 482
#define LEADING 483
#define LEAKPROOF 484
#define LEAST 485
#define LEFT 486
#define LEVEL 487
#define LIKE 488
#define LIMIT 489
#define LISTEN 490
#define LOAD 491
#define LOCAL 492
#define LOCALTIME 493
#define LOCALTIMESTAMP 494
#define LOCATION 495
#define LOCK_P 496
#define LOCKED 497
#define LOGGED 498
#define MAPPING 499
#define MATCH 500
#define MATERIALIZED 501
#define MAXVALUE 502
#define METHOD 503
#define MINUTE_P 504
#define MINVALUE 505
#define MODE 506
#define MONTH_P 507
#define MOVE 508
#define NAME_P 509
#define NAMES 510
#define NATIONAL 511
#define NATURAL 512
#define NCHAR 513
#define NEW 514
#define NEXT 515
#define NFC 516
#define NFD 517
#define NFKC 518
#define NFKD 519
#define NO 520
#define NONE 521
#define NORMALIZE 522
#define NORMALIZED 523
#define NOT 524
#define NOTHING 525
#define NOTIFY 526
#define NOTNULL 527
#define NOWAIT 528
#define NULL_P 529
#define NULLIF 530
#define NULLS_P 531
#define NUMERIC 532
#define OBJECT_P 533
#define OF 534
#define OFF 535
#define OFFSET 536
#define OIDS 537
#define OLD 538
#define ON 539
#define ONLY 540
#define OPERATOR 541
#define OPTION 542
#define OPTIONS 543
#define OR 544
#define ORDER 545
#define ORDINALITY 546
#define OTHERS 547
#define OUT_P 548
#define OUTER_P 549
#define OVER 550
#define OVERLAPS 551
#define OVERLAY 552
#define OVERRIDING 553
#define OWNED 554
#define OWNER 555
#define PARALLEL 556
#define PARSER 557
#define PARTIAL 558
#define PARTITION 559
#define PASSING 560
#define PASSWORD 561
#define PGPOOL 562
#define PLACING 563
#define PLANS 564
#define POLICY 565
#define POSITION 566
#define PRECEDING 567
#define PRECISION 568
#define PRESERVE 569
#define PREPARE 570
#define PREPARED 571
#define PRIMARY 572
#define PRIOR 573
#define PRIVILEGES 574
#define PROCEDURAL 575
#define PROCEDURE 576
#define PROCEDURES 577
#define PROGRAM 578
#define PUBLICATION 579
#define QUOTE 580
#define RANGE 581
#define READ 582
#define REAL 583
#define REASSIGN 584
#define RECHECK 585
#define RECURSIVE 586
#define REF 587
#define REFERENCES 588
#define REFERENCING 589
#define REFRESH 590
#define REINDEX 591
#define RELATIVE_P 592
#define RELEASE 593
#define RENAME 594
#define REPEATABLE 595
#define REPLACE 596
#define REPLICA 597
#define RESET 598
#define RESTART 599
#define RESTRICT 600
#define RETURN 601
#define RETURNING 602
#define RETURNS 603
#define REVOKE 604
#define RIGHT 605
#define ROLE 606
#define ROLLBACK 607
#define ROLLUP 608
#define ROUTINE 609
#define ROUTINES 610
#define ROW 611
#define ROWS 612
#define RULE 613
#define SAVEPOINT 614
#define SCHEMA 615
#define SCHEMAS 616
#define SCROLL 617
#define SEARCH 618
#define SECOND_P 619
#define SECURITY 620
#define SELECT 621
#define SEQUENCE 622
#define SEQUENCES 623
#define SERIALIZABLE 624
#define SERVER 625
#define SESSION 626
#define SESSION_USER 627
#define SET 628
#define SETS 629
#define SETOF 630
#define SHARE 631
#define SHOW 632
#define SIMILAR 633
#define SIMPLE 634
#define SKIP 635
#define SMALLINT 636
#define SNAPSHOT 637
#define SOME 638
#define SQL_P 639
#define STABLE 640
#define STANDALONE_P 641
#define START 642
#define STATEMENT 643
#define STATISTICS 644
#define STDIN 645
#define STDOUT 646
#define STORAGE 647
#define STORED 648
#define STRICT_P 649
#define STRIP_P 650
#define SUBSCRIPTION 651
#define SUBSTRING 652
#define SUPPORT 653
#define SYMMETRIC 654
#define SYSID 655
#define SYSTEM_P 656
#define TABLE 657
#define TABLES 658
#define TABLESAMPLE 659
#define TABLESPACE 660
#define TEMP 661
#define TEMPLATE 662
#define TEMPORARY 663
#define TEXT_P 664
#define THEN 665
#define TIES 666
#define TIME 667
#define TIMESTAMP 668
#define TO 669
#define TRAILING 670
#define TRANSACTION 671
#define TRANSFORM 672
#define TREAT 673
#define TRIGGER 674
#define TRIM 675
#define TRUE_P 676
#define TRUNCATE 677
#define TRUSTED 678
#define TYPE_P 679
#define TYPES_P 680
#define UESCAPE 681
#define UNBOUNDED 682
#define UNCOMMITTED 683
#define UNENCRYPTED 684
#define UNION 685
#define UNIQUE 686
#define UNKNOWN 687
#define UNLISTEN 688
#define UNLOGGED 689
#define UNTIL 690
#define UPDATE 691
#define USER 692
#define USING 693
#define VACUUM 694
#define VALID 695
#define VALIDATE 696
#define VALIDATOR 697
#define VALUE_P 698
#define VALUES 699
#define VARCHAR 700
#define VARIADIC 701
#define VARYING 702
#define VERBOSE 703
#define VERSION_P 704
#define VIEW 705
#define VIEWS 706
#define VOLATILE 707
#define WHEN 708
#define WHERE 709
#define WHITESPACE_P 710
#define WINDOW 711
#define WITH 712
#define WITHIN 713
#define WITHOUT 714
#define WORK 715
#define WRAPPER 716
#define WRITE 717
#define XML_P 718
#define XMLATTRIBUTES 719
#define XMLCONCAT 720
#define XMLELEMENT 721
#define XMLEXISTS 722
#define XMLFOREST 723
#define XMLNAMESPACES 724
#define XMLPARSE 725
#define XMLPI 726
#define XMLROOT 727
#define XMLSERIALIZE 728
#define XMLTABLE 729
#define YEAR_P 730
#define YES_P 731
#define ZONE 732
#define NOT_LA 733
#define NULLS_LA 734
#define WITH_LA 735
#define MODE_TYPE_NAME 736
#define MODE_PLPGSQL_EXPR 737
#define MODE_PLPGSQL_ASSIGN1 738
#define MODE_PLPGSQL_ASSIGN2 739
#define MODE_PLPGSQL_ASSIGN3 740
#define UMINUS 741

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 249 "gram.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs		*objwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	StatsElem			*selem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	InferClause			*infer;
	OnConflictClause	*onconflict;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	struct ImportQual	*importqual;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;
	PartitionElem		*partelem;
	PartitionSpec		*partspec;
	PartitionBoundSpec	*partboundspec;
	RoleSpec			*rolespec;
	struct SelectLimit	*selectlimit;
	SetQuantifier	 setquantifier;
	struct GroupClause  *groupclause;

#line 1371 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1401 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  899
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   109242

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  504
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  676
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3163
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5989

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   741

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   493,     2,     2,
     498,   499,   491,   489,   502,   490,   500,   492,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   503,   501,
     486,   488,   487,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   496,     2,   497,   494,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   495
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   860,   860,   864,   868,   873,   880,   887,   906,   918,
     932,   933,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1061,  1070,  1085,  1096,  1097,
    1098,  1107,  1108,  1112,  1113,  1117,  1122,  1126,  1136,  1144,
    1148,  1152,  1157,  1161,  1209,  1211,  1215,  1219,  1223,  1227,
    1241,  1259,  1267,  1278,  1279,  1283,  1291,  1299,  1307,  1328,
    1335,  1342,  1349,  1356,  1363,  1380,  1398,  1409,  1410,  1421,
    1431,  1441,  1456,  1474,  1475,  1479,  1486,  1494,  1495,  1496,
    1497,  1498,  1499,  1513,  1520,  1526,  1532,  1541,  1549,  1557,
    1561,  1569,  1577,  1584,  1594,  1595,  1603,  1614,  1622,  1630,
    1641,  1649,  1657,  1664,  1673,  1683,  1684,  1688,  1689,  1692,
    1694,  1698,  1699,  1700,  1701,  1705,  1706,  1707,  1713,  1725,
    1729,  1733,  1748,  1755,  1756,  1757,  1761,  1762,  1763,  1767,
    1768,  1772,  1773,  1782,  1783,  1790,  1797,  1807,  1814,  1824,
    1825,  1830,  1831,  1837,  1843,  1849,  1855,  1861,  1867,  1873,
    1883,  1893,  1894,  1898,  1899,  1907,  1922,  1928,  1934,  1940,
    1946,  1965,  1974,  1983,  1992,  2001,  2012,  2023,  2032,  2041,
    2050,  2061,  2072,  2081,  2090,  2099,  2108,  2117,  2126,  2137,
    2148,  2157,  2169,  2170,  2175,  2189,  2202,  2218,  2235,  2244,
    2253,  2262,  2271,  2280,  2288,  2296,  2304,  2313,  2322,  2338,
    2347,  2356,  2365,  2374,  2391,  2400,  2409,  2418,  2428,  2441,
    2456,  2465,  2474,  2489,  2497,  2507,  2517,  2524,  2532,  2540,
    2547,  2554,  2562,  2570,  2578,  2585,  2592,  2600,  2607,  2614,
    2622,  2630,  2638,  2646,  2654,  2662,  2672,  2679,  2687,  2695,
    2703,  2711,  2719,  2726,  2733,  2740,  2746,  2756,  2757,  2761,
    2762,  2763,  2767,  2775,  2779,  2780,  2784,  2791,  2798,  2805,
    2815,  2818,  2819,  2823,  2824,  2829,  2833,  2837,  2842,  2849,
    2851,  2856,  2860,  2864,  2875,  2883,  2936,  2949,  2963,  2975,
    2982,  2986,  3000,  3013,  3014,  3019,  3028,  3038,  3048,  3074,
    3080,  3113,  3148,  3170,  3171,  3175,  3176,  3185,  3186,  3187,
    3190,  3191,  3196,  3197,  3201,  3205,  3209,  3213,  3217,  3221,
    3225,  3229,  3233,  3237,  3241,  3245,  3249,  3258,  3262,  3266,
    3270,  3274,  3275,  3280,  3284,  3291,  3298,  3299,  3300,  3301,
    3302,  3306,  3310,  3318,  3329,  3348,  3367,  3387,  3407,  3427,
    3460,  3461,  3462,  3463,  3464,  3471,  3478,  3479,  3483,  3484,
    3488,  3489,  3493,  3497,  3504,  3508,  3515,  3516,  3517,  3521,
    3522,  3525,  3547,  3565,  3586,  3587,  3591,  3592,  3596,  3597,
    3601,  3608,  3609,  3610,  3641,  3648,  3655,  3666,  3677,  3689,
    3700,  3709,  3732,  3750,  3751,  3770,  3777,  3784,  3791,  3802,
    3813,  3814,  3815,  3819,  3820,  3821,  3822,  3823,  3824,  3825,
    3826,  3827,  3828,  3837,  3844,  3848,  3861,  3877,  3892,  3908,
    3923,  3942,  3963,  3964,  3968,  3969,  3973,  3974,  3977,  3983,
    3984,  3987,  3991,  3999,  4004,  4010,  4011,  4015,  4020,  4027,
    4028,  4038,  4040,  4042,  4044,  4047,  4050,  4053,  4057,  4058,
    4059,  4060,  4061,  4064,  4065,  4069,  4070,  4073,  4085,  4086,
    4089,  4100,  4111,  4125,  4126,  4131,  4132,  4133,  4136,  4137,
    4138,  4139,  4142,  4143,  4146,  4147,  4150,  4168,  4180,  4201,
    4202,  4205,  4211,  4217,  4234,  4242,  4263,  4276,  4292,  4308,
    4309,  4310,  4322,  4335,  4351,  4365,  4366,  4378,  4398,  4408,
    4421,  4429,  4440,  4441,  4444,  4445,  4448,  4449,  4452,  4456,
    4460,  4464,  4468,  4472,  4476,  4480,  4484,  4488,  4492,  4497,
    4501,  4505,  4511,  4512,  4516,  4517,  4518,  4523,  4526,  4527,
    4539,  4554,  4569,  4570,  4578,  4579,  4583,  4584,  4588,  4589,
    4593,  4594,  4598,  4599,  4609,  4620,  4621,  4634,  4641,  4658,
    4666,  4677,  4680,  4684,  4688,  4692,  4699,  4711,  4721,  4724,
    4728,  4741,  4750,  4759,  4768,  4777,  4786,  4795,  4804,  4813,
    4822,  4831,  4840,  4849,  4867,  4878,  4879,  4880,  4881,  4885,
    4886,  4890,  4891,  4901,  4909,  4921,  4922,  4926,  4930,  4938,
    4942,  4946,  4953,  4957,  4962,  4967,  4974,  4981,  4986,  4996,
    5008,  5023,  5024,  5029,  5030,  5034,  5035,  5045,  5054,  5062,
    5079,  5099,  5119,  5140,  5173,  5188,  5189,  5193,  5201,  5216,
    5225,  5237,  5238,  5250,  5258,  5275,  5299,  5316,  5330,  5331,
    5335,  5336,  5340,  5341,  5345,  5346,  5350,  5364,  5368,  5369,
    5373,  5374,  5375,  5376,  5377,  5387,  5398,  5399,  5410,  5432,
    5463,  5464,  5465,  5469,  5471,  5493,  5495,  5497,  5499,  5501,
    5506,  5507,  5511,  5512,  5516,  5527,  5528,  5532,  5541,  5545,
    5549,  5554,  5564,  5565,  5569,  5570,  5574,  5575,  5579,  5580,
    5584,  5585,  5586,  5590,  5594,  5595,  5596,  5600,  5601,  5606,
    5607,  5634,  5635,  5636,  5637,  5638,  5639,  5652,  5662,  5676,
    5678,  5683,  5688,  5690,  5695,  5705,  5706,  5707,  5708,  5719,
    5738,  5749,  5761,  5771,  5781,  5792,  5801,  5808,  5815,  5824,
    5833,  5842,  5851,  5860,  5870,  5879,  5891,  5894,  5895,  5898,
    5902,  5909,  5910,  5911,  5912,  5913,  5914,  5917,  5920,  5921,
    5929,  5936,  5937,  5940,  5942,  5953,  5964,  5975,  5986,  5999,
    6000,  6016,  6031,  6032,  6036,  6048,  6058,  6066,  6075,  6084,
    6085,  6088,  6089,  6092,  6093,  6094,  6097,  6111,  6116,  6126,
    6135,  6147,  6148,  6152,  6160,  6172,  6182,  6195,  6205,  6227,
    6237,  6255,  6265,  6275,  6285,  6295,  6305,  6315,  6325,  6335,
    6345,  6355,  6365,  6379,  6380,  6381,  6382,  6383,  6384,  6385,
    6386,  6387,  6388,  6389,  6390,  6391,  6401,  6402,  6403,  6404,
    6405,  6409,  6410,  6411,  6412,  6413,  6414,  6415,  6416,  6421,
    6422,  6423,  6427,  6428,  6431,  6432,  6435,  6437,  6442,  6443,
    6454,  6465,  6466,  6467,  6477,  6485,  6493,  6501,  6509,  6517,
    6525,  6533,  6541,  6549,  6562,  6570,  6578,  6586,  6594,  6602,
    6610,  6618,  6629,  6630,  6644,  6654,  6664,  6674,  6684,  6694,
    6704,  6714,  6724,  6734,  6746,  6747,  6750,  6751,  6761,  6767,
    6775,  6783,  6791,  6799,  6807,  6815,  6823,  6831,  6839,  6847,
    6855,  6863,  6871,  6879,  6887,  6895,  6905,  6906,  6909,  6910,
    6920,  6937,  6952,  6979,  6981,  6983,  6985,  6992,  7001,  7002,
    7005,  7012,  7019,  7026,  7040,  7048,  7056,  7064,  7072,  7080,
    7088,  7096,  7104,  7112,  7120,  7128,  7136,  7144,  7152,  7160,
    7168,  7176,  7184,  7192,  7204,  7205,  7209,  7210,  7215,  7216,
    7226,  7239,  7249,  7261,  7262,  7265,  7266,  7276,  7286,  7287,
    7291,  7295,  7299,  7310,  7323,  7337,  7354,  7355,  7356,  7357,
    7358,  7359,  7371,  7401,  7434,  7435,  7439,  7440,  7444,  7445,
    7449,  7450,  7453,  7454,  7459,  7471,  7490,  7495,  7500,  7507,
    7508,  7511,  7512,  7515,  7516,  7519,  7520,  7523,  7524,  7525,
    7528,  7529,  7530,  7546,  7559,  7573,  7586,  7602,  7603,  7606,
    7607,  7611,  7612,  7616,  7617,  7622,  7635,  7642,  7649,  7664,
    7665,  7669,  7670,  7685,  7694,  7703,  7712,  7721,  7733,  7734,
    7735,  7736,  7737,  7743,  7747,  7762,  7763,  7769,  7779,  7783,
    7788,  7796,  7838,  7842,  7846,  7850,  7858,  7859,  7863,  7874,
    7875,  7880,  7881,  7886,  7887,  7894,  7898,  7902,  7906,  7910,
    7914,  7918,  7922,  7926,  7930,  7934,  7938,  7942,  7946,  7950,
    7954,  7959,  7966,  7970,  7974,  7978,  7982,  7988,  7989,  7995,
    8004,  8008,  8019,  8025,  8034,  8040,  8041,  8045,  8046,  8050,
    8051,  8054,  8066,  8070,  8085,  8093,  8101,  8113,  8114,  8119,
    8120,  8137,  8147,  8157,  8167,  8177,  8187,  8200,  8210,  8223,
    8233,  8246,  8254,  8256,  8258,  8263,  8265,  8270,  8271,  8276,
    8294,  8303,  8304,  8308,  8312,  8324,  8335,  8346,  8359,  8360,
    8361,  8365,  8377,  8378,  8388,  8400,  8404,  8408,  8412,  8419,
    8439,  8451,  8463,  8475,  8489,  8490,  8493,  8494,  8495,  8505,
    8514,  8531,  8540,  8549,  8558,  8567,  8576,  8585,  8594,  8603,
    8612,  8621,  8630,  8639,  8649,  8659,  8668,  8677,  8686,  8695,
    8704,  8713,  8723,  8733,  8743,  8753,  8763,  8773,  8783,  8793,
    8803,  8813,  8823,  8833,  8844,  8855,  8866,  8877,  8888,  8899,
    8909,  8919,  8930,  8941,  8951,  8961,  8969,  8978,  8987,  8996,
    9005,  9014,  9023,  9032,  9041,  9050,  9064,  9065,  9068,  9069,
    9079,  9088,  9097,  9106,  9116,  9125,  9136,  9137,  9147,  9156,
    9165,  9174,  9183,  9192,  9201,  9210,  9219,  9228,  9237,  9246,
    9255,  9264,  9273,  9282,  9291,  9300,  9309,  9318,  9327,  9336,
    9345,  9354,  9363,  9372,  9381,  9399,  9408,  9409,  9412,  9414,
    9420,  9421,  9422,  9423,  9424,  9436,  9451,  9459,  9467,  9475,
    9483,  9491,  9499,  9507,  9515,  9523,  9531,  9539,  9547,  9555,
    9563,  9571,  9579,  9587,  9595,  9603,  9611,  9619,  9627,  9635,
    9653,  9672,  9673,  9677,  9681,  9701,  9708,  9716,  9724,  9741,
    9760,  9769,  9778,  9787,  9797,  9807,  9817,  9827,  9845,  9853,
    9869,  9886,  9887,  9888,  9893,  9899,  9908,  9909,  9910,  9911,
    9912,  9916,  9917,  9920,  9921,  9922,  9923,  9927,  9928,  9929,
    9941,  9951,  9952,  9955,  9964,  9970,  9989,  9997, 10004, 10012,
   10020, 10027, 10034, 10041, 10048, 10055, 10062, 10069, 10079, 10086,
   10096, 10097, 10098, 10102, 10105, 10108, 10111, 10114, 10121, 10123,
   10125, 10130, 10132, 10136, 10137, 10138, 10150, 10163, 10176, 10194,
   10215, 10216, 10217, 10218, 10228, 10244, 10254, 10255, 10259, 10260,
   10264, 10268, 10272, 10290, 10291, 10292, 10293, 10294, 10295, 10296,
   10303, 10304, 10315, 10322, 10329, 10340, 10357, 10365, 10373, 10381,
   10392, 10396, 10407, 10419, 10436, 10442, 10458, 10471, 10480, 10488,
   10496, 10505, 10516, 10527, 10537, 10538, 10549, 10559, 10570, 10581,
   10592, 10603, 10612, 10624, 10625, 10639, 10663, 10674, 10682, 10693,
   10706, 10707, 10719, 10739, 10749, 10760, 10771, 10775, 10782, 10783,
   10787, 10794, 10795, 10799, 10800, 10801, 10805, 10806, 10810, 10811,
   10814, 10815, 10818, 10819, 10823, 10824, 10828, 10835, 10837, 10842,
   10843, 10856, 10863, 10873, 10880, 10890, 10891, 10892, 10893, 10894,
   10895, 10896, 10897, 10898, 10908, 10918, 10919, 10923, 10924, 10925,
   10926, 10936, 10943, 10960, 10979, 10980, 10990, 10996, 11002, 11008,
   11024, 11042, 11046, 11054, 11060, 11067, 11073, 11080, 11089, 11090,
   11094, 11096, 11101, 11112, 11122, 11132, 11138, 11147, 11156, 11162,
   11163, 11174, 11188, 11189, 11200, 11211, 11212, 11215, 11216, 11217,
   11218, 11219, 11220, 11221, 11222, 11225, 11226, 11230, 11231, 11232,
   11243, 11260, 11261, 11265, 11270, 11294, 11305, 11306, 11316, 11327,
   11330, 11331, 11332, 11333, 11334, 11335, 11338, 11339, 11340, 11388,
   11389, 11393, 11394, 11409, 11410, 11417, 11425, 11433, 11441, 11449,
   11457, 11468, 11469, 11501, 11516, 11532, 11533, 11552, 11556, 11560,
   11575, 11582, 11589, 11599, 11600, 11603, 11618, 11619, 11620, 11624,
   11633, 11643, 11649, 11660, 11672, 11678, 11679, 11683, 11695, 11703,
   11708, 11713, 11718, 11723, 11731, 11739, 11744, 11749, 11756, 11757,
   11761, 11762, 11763, 11770, 11771, 11775, 11776, 11780, 11781, 11785,
   11786, 11790, 11794, 11795, 11798, 11807, 11820, 11825, 11830, 11834,
   11845, 11846, 11850, 11858, 11874, 11882, 11890, 11898, 11909, 11912,
   11917, 11918, 11926, 11946, 11947, 11949, 11954, 11955, 11959, 11960,
   11963, 11964, 11989, 11997, 12006, 12007, 12011, 12012, 12013, 12014,
   12015, 12019, 12032, 12039, 12046, 12053, 12054, 12058, 12059, 12063,
   12064, 12068, 12069, 12073, 12084, 12085, 12086, 12087, 12091, 12092,
   12102, 12108, 12126, 12127, 12131, 12132, 12138, 12143, 12151, 12158,
   12166, 12172, 12179, 12214, 12239, 12243, 12269, 12273, 12286, 12306,
   12327, 12339, 12355, 12361, 12366, 12372, 12379, 12380, 12390, 12396,
   12404, 12408, 12412, 12418, 12425, 12430, 12431, 12432, 12433, 12437,
   12438, 12453, 12457, 12465, 12472, 12479, 12486, 12497, 12498, 12511,
   12515, 12522, 12535, 12548, 12549, 12564, 12574, 12586, 12591, 12592,
   12595, 12596, 12599, 12600, 12605, 12606, 12611, 12612, 12620, 12625,
   12626, 12630, 12634, 12640, 12664, 12674, 12687, 12688, 12692, 12706,
   12763, 12777, 12779, 12784, 12786, 12788, 12790, 12795, 12797, 12802,
   12810, 12830, 12835, 12842, 12847, 12853, 12858, 12867, 12869, 12872,
   12876, 12877, 12878, 12879, 12880, 12881, 12886, 12906, 12907, 12908,
   12909, 12920, 12926, 12934, 12935, 12941, 12946, 12951, 12956, 12961,
   12966, 12971, 12976, 12982, 12988, 12994, 13001, 13023, 13032, 13036,
   13044, 13048, 13056, 13068, 13089, 13093, 13099, 13103, 13116, 13124,
   13134, 13136, 13138, 13140, 13142, 13144, 13149, 13150, 13157, 13166,
   13174, 13183, 13194, 13202, 13203, 13204, 13208, 13210, 13212, 13214,
   13216, 13218, 13220, 13225, 13230, 13236, 13244, 13249, 13256, 13263,
   13267, 13271, 13307, 13308, 13310, 13318, 13334, 13336, 13338, 13340,
   13342, 13344, 13346, 13348, 13350, 13352, 13354, 13356, 13358, 13360,
   13363, 13365, 13368, 13370, 13372, 13374, 13377, 13382, 13391, 13396,
   13405, 13410, 13419, 13424, 13434, 13443, 13452, 13461, 13480, 13488,
   13496, 13504, 13512, 13529, 13537, 13545, 13553, 13561, 13569, 13577,
   13581, 13585, 13593, 13601, 13609, 13617, 13637, 13659, 13670, 13677,
   13693, 13698, 13704, 13711, 13718, 13726, 13734, 13759, 13761, 13763,
   13765, 13767, 13769, 13771, 13773, 13775, 13777, 13779, 13781, 13783,
   13785, 13787, 13789, 13791, 13793, 13795, 13799, 13803, 13808, 13824,
   13825, 13826, 13841, 13853, 13855, 13857, 13868, 13892, 13903, 13914,
   13921, 13931, 13941, 13950, 13956, 13964, 13973, 13982, 13994, 14003,
   14033, 14068, 14079, 14080, 14087, 14094, 14098, 14102, 14106, 14110,
   14114, 14118, 14122, 14126, 14130, 14134, 14138, 14142, 14146, 14150,
   14154, 14156, 14163, 14170, 14177, 14184, 14195, 14209, 14219, 14230,
   14246, 14256, 14263, 14270, 14277, 14281, 14288, 14296, 14304, 14308,
   14312, 14316, 14320, 14324, 14333, 14337, 14346, 14350, 14354, 14359,
   14373, 14375, 14379, 14381, 14383, 14386, 14389, 14392, 14393, 14396,
   14404, 14414, 14415, 14418, 14419, 14420, 14425, 14429, 14433, 14437,
   14444, 14445, 14453, 14454, 14458, 14459, 14467, 14468, 14472, 14473,
   14478, 14486, 14488, 14502, 14505, 14532, 14533, 14536, 14537, 14545,
   14552, 14559, 14567, 14576, 14593, 14638, 14646, 14654, 14662, 14670,
   14681, 14682, 14683, 14684, 14685, 14699, 14700, 14701, 14704, 14705,
   14708, 14711, 14712, 14713, 14716, 14717, 14720, 14721, 14722, 14723,
   14724, 14725, 14726, 14727, 14728, 14729, 14730, 14731, 14734, 14736,
   14741, 14743, 14748, 14750, 14752, 14754, 14756, 14758, 14770, 14774,
   14781, 14785, 14791, 14795, 14804, 14815, 14816, 14819, 14820, 14823,
   14827, 14831, 14837, 14838, 14843, 14853, 14854, 14855, 14856, 14857,
   14858, 14859, 14860, 14864, 14865, 14866, 14867, 14872, 14877, 14886,
   14907, 14911, 14916, 14927, 14944, 14950, 14951, 14952, 14955, 14962,
   14972, 14986, 14987, 14991, 15002, 15003, 15006, 15007, 15010, 15014,
   15021, 15025, 15029, 15037, 15048, 15049, 15053, 15054, 15058, 15059,
   15062, 15063, 15073, 15074, 15078, 15079, 15082, 15090, 15098, 15106,
   15128, 15129, 15140, 15144, 15171, 15173, 15178, 15180, 15182, 15192,
   15194, 15205, 15209, 15213, 15217, 15221, 15230, 15237, 15269, 15273,
   15279, 15286, 15290, 15294, 15300, 15301, 15303, 15304, 15305, 15309,
   15349, 15376, 15380, 15384, 15390, 15392, 15406, 15442, 15455, 15456,
   15459, 15460, 15477, 15478, 15479, 15484, 15485, 15486, 15491, 15492,
   15493, 15494, 15500, 15501, 15502, 15503, 15504, 15510, 15511, 15531,
   15532, 15533, 15534, 15535, 15536, 15537, 15538, 15539, 15540, 15541,
   15542, 15543, 15544, 15545, 15546, 15547, 15548, 15549, 15550, 15551,
   15552, 15553, 15554, 15555, 15556, 15557, 15558, 15559, 15560, 15561,
   15562, 15563, 15564, 15565, 15566, 15567, 15568, 15569, 15570, 15571,
   15572, 15573, 15574, 15575, 15576, 15577, 15578, 15579, 15580, 15581,
   15582, 15583, 15584, 15585, 15586, 15587, 15588, 15589, 15590, 15591,
   15592, 15593, 15594, 15595, 15596, 15597, 15598, 15599, 15600, 15601,
   15602, 15603, 15604, 15605, 15606, 15607, 15608, 15609, 15610, 15611,
   15612, 15613, 15614, 15615, 15616, 15617, 15618, 15619, 15620, 15621,
   15622, 15623, 15624, 15625, 15626, 15627, 15628, 15629, 15630, 15631,
   15632, 15633, 15634, 15635, 15636, 15637, 15638, 15639, 15640, 15641,
   15642, 15643, 15644, 15645, 15646, 15647, 15648, 15649, 15650, 15651,
   15652, 15653, 15654, 15655, 15656, 15657, 15658, 15659, 15660, 15661,
   15662, 15663, 15664, 15665, 15666, 15667, 15668, 15669, 15670, 15671,
   15672, 15673, 15674, 15675, 15676, 15677, 15678, 15679, 15680, 15681,
   15682, 15683, 15684, 15685, 15686, 15687, 15688, 15689, 15690, 15691,
   15692, 15693, 15694, 15695, 15696, 15697, 15698, 15699, 15700, 15701,
   15702, 15703, 15704, 15705, 15706, 15707, 15708, 15709, 15710, 15711,
   15712, 15713, 15714, 15715, 15716, 15717, 15718, 15719, 15720, 15721,
   15722, 15723, 15724, 15725, 15726, 15727, 15728, 15729, 15730, 15731,
   15732, 15733, 15734, 15735, 15736, 15737, 15738, 15739, 15740, 15741,
   15742, 15743, 15744, 15745, 15746, 15747, 15748, 15749, 15750, 15751,
   15752, 15753, 15754, 15755, 15756, 15757, 15758, 15759, 15760, 15761,
   15762, 15763, 15764, 15765, 15766, 15767, 15768, 15769, 15770, 15771,
   15772, 15773, 15774, 15775, 15776, 15777, 15778, 15779, 15780, 15781,
   15782, 15783, 15784, 15785, 15786, 15787, 15788, 15789, 15790, 15791,
   15792, 15793, 15794, 15795, 15796, 15797, 15798, 15799, 15800, 15801,
   15802, 15803, 15804, 15805, 15806, 15807, 15808, 15809, 15810, 15811,
   15812, 15813, 15814, 15815, 15816, 15817, 15818, 15819, 15820, 15821,
   15822, 15823, 15824, 15825, 15826, 15827, 15828, 15829, 15830, 15831,
   15832, 15833, 15834, 15835, 15836, 15850, 15851, 15852, 15853, 15854,
   15855, 15856, 15857, 15858, 15859, 15860, 15861, 15862, 15863, 15864,
   15865, 15866, 15867, 15868, 15869, 15870, 15871, 15872, 15873, 15874,
   15875, 15876, 15877, 15878, 15879, 15880, 15881, 15882, 15883, 15884,
   15885, 15886, 15887, 15888, 15889, 15890, 15891, 15892, 15893, 15894,
   15895, 15896, 15897, 15898, 15899, 15900, 15914, 15915, 15916, 15917,
   15918, 15919, 15920, 15921, 15922, 15923, 15924, 15925, 15926, 15927,
   15928, 15929, 15930, 15931, 15932, 15933, 15934, 15935, 15936, 15946,
   15947, 15948, 15949, 15950, 15951, 15952, 15953, 15954, 15955, 15956,
   15957, 15958, 15959, 15960, 15961, 15962, 15963, 15964, 15965, 15966,
   15967, 15968, 15969, 15970, 15971, 15972, 15973, 15974, 15975, 15976,
   15977, 15978, 15979, 15980, 15981, 15982, 15983, 15984, 15985, 15986,
   15987, 15988, 15989, 15990, 15991, 15992, 15993, 15994, 15995, 15996,
   15997, 15998, 15999, 16000, 16001, 16002, 16003, 16004, 16005, 16006,
   16007, 16008, 16009, 16010, 16011, 16012, 16013, 16014, 16015, 16016,
   16017, 16018, 16019, 16020, 16021, 16022, 16035, 16036, 16037, 16038,
   16039, 16040, 16041, 16042, 16043, 16044, 16045, 16046, 16047, 16048,
   16049, 16050, 16051, 16052, 16053, 16054, 16055, 16056, 16057, 16058,
   16059, 16060, 16061, 16062, 16063, 16064, 16065, 16066, 16067, 16068,
   16069, 16070, 16071, 16072, 16073, 16074, 16075, 16076, 16077, 16078,
   16079, 16080, 16081, 16082, 16083, 16084, 16085, 16086, 16087, 16088,
   16089, 16090, 16091, 16092, 16093, 16094, 16095, 16096, 16097, 16098,
   16099, 16100, 16101, 16102, 16103, 16104, 16105, 16106, 16107, 16108,
   16109, 16110, 16111, 16112, 16113, 16114, 16115, 16116, 16117, 16118,
   16119, 16120, 16121, 16122, 16123, 16124, 16125, 16126, 16127, 16128,
   16129, 16130, 16131, 16132, 16133, 16134, 16135, 16136, 16137, 16138,
   16139, 16140, 16141, 16142, 16143, 16144, 16145, 16146, 16147, 16148,
   16149, 16150, 16151, 16152, 16153, 16154, 16155, 16156, 16157, 16158,
   16159, 16160, 16161, 16162, 16163, 16164, 16165, 16166, 16167, 16168,
   16169, 16170, 16171, 16172, 16173, 16174, 16175, 16176, 16177, 16178,
   16179, 16180, 16181, 16182, 16183, 16184, 16185, 16186, 16187, 16188,
   16189, 16190, 16191, 16192, 16193, 16194, 16195, 16196, 16197, 16198,
   16199, 16200, 16201, 16202, 16203, 16204, 16205, 16206, 16207, 16208,
   16209, 16210, 16211, 16212, 16213, 16214, 16215, 16216, 16217, 16218,
   16219, 16220, 16221, 16222, 16223, 16224, 16225, 16226, 16227, 16228,
   16229, 16230, 16231, 16232, 16233, 16234, 16235, 16236, 16237, 16238,
   16239, 16240, 16241, 16242, 16243, 16244, 16245, 16246, 16247, 16248,
   16249, 16250, 16251, 16252, 16253, 16254, 16255, 16256, 16257, 16258,
   16259, 16260, 16261, 16262, 16263, 16264, 16265, 16266, 16267, 16268,
   16269, 16270, 16271, 16272, 16273, 16274, 16275, 16276, 16277, 16278,
   16279, 16280, 16281, 16282, 16283, 16284, 16285, 16286, 16287, 16288,
   16289, 16290, 16291, 16292, 16293, 16294, 16295, 16296, 16297, 16298,
   16299, 16300, 16301, 16302, 16303, 16304, 16305, 16306, 16307, 16308,
   16309, 16310, 16311, 16312, 16313, 16314, 16315, 16316, 16317, 16318,
   16319, 16320, 16321, 16322, 16323, 16324, 16325, 16326, 16327, 16328,
   16329, 16330, 16331, 16332, 16333, 16334, 16335, 16336, 16337, 16338,
   16339, 16340, 16341, 16342, 16343, 16344, 16345, 16346, 16347, 16348,
   16349, 16350, 16351, 16352, 16353, 16354, 16355, 16356, 16357, 16358,
   16359, 16360, 16361, 16362, 16363, 16364, 16365, 16366, 16367, 16368,
   16369, 16370, 16371, 16372, 16373, 16374, 16375, 16376, 16377, 16378,
   16379, 16380, 16381, 16382, 16383, 16384, 16385, 16386, 16387, 16388,
   16389, 16390, 16391, 16392, 16393, 16394, 16395, 16396, 16397, 16398,
   16399, 16400, 16401, 16402, 16403, 16404, 16405, 16406, 16407, 16408,
   16409, 16410, 16411, 16412, 16413, 16414, 16415, 16416, 16417, 16418,
   16419, 16420, 16421, 16422, 16423, 16424, 16425, 16426, 16427, 16428,
   16429, 16430, 16431, 16432, 16433, 16434, 16435, 16436, 16437, 16438,
   16439, 16440, 16441, 16442, 16443, 16444, 16445, 16446, 16447, 16448,
   16449, 16450, 16451, 16452
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASENSITIVE", "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "ATOMIC", "AT",
  "ATTACH", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P",
  "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BREADTH",
  "BY", "CACHE", "CALL", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COLUMNS", "COMMENT", "COMMENTS", "COMMIT",
  "COMMITTED", "COMPRESSION", "CONCURRENTLY", "CONFIGURATION", "CONFLICT",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CROSS", "CSV", "CUBE",
  "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE",
  "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER",
  "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC",
  "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED",
  "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH",
  "DESC", "DETACH", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO",
  "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P",
  "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT",
  "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN",
  "EXPRESSION", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY",
  "FETCH", "FILTER", "FINALIZE", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR",
  "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST",
  "GROUP_P", "GROUPING", "GROUPS", "HANDLER", "HAVING", "HEADER_P", "HOLD",
  "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE",
  "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE", "INCLUDING", "INCREMENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P",
  "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P", "MINVALUE",
  "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL",
  "NCHAR", "NEW", "NEXT", "NFC", "NFD", "NFKC", "NFKD", "NO", "NONE",
  "NORMALIZE", "NORMALIZED", "NOT", "NOTHING", "NOTIFY", "NOTNULL",
  "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF",
  "OFF", "OFFSET", "OIDS", "OLD", "ON", "ONLY", "OPERATOR", "OPTION",
  "OPTIONS", "OR", "ORDER", "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OVERRIDING", "OWNED", "OWNER",
  "PARALLEL", "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD",
  "PGPOOL", "PLACING", "PLANS", "POLICY", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROCEDURES", "PROGRAM",
  "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFERENCING", "REFRESH", "REINDEX",
  "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA",
  "RESET", "RESTART", "RESTRICT", "RETURN", "RETURNING", "RETURNS",
  "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE", "ROUTINES",
  "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCHEMAS", "SCROLL",
  "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES",
  "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET", "SETS",
  "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP", "SMALLINT",
  "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P", "START",
  "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STORED",
  "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING", "SUPPORT",
  "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESAMPLE",
  "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIES",
  "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TRANSFORM",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "TYPES_P", "UESCAPE", "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION",
  "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER",
  "USING", "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA",
  "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR", "MODE_PLPGSQL_ASSIGN1",
  "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3", "'<'", "'>'", "'='",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['", "']'", "'('",
  "')'", "'.'", "';'", "','", "':'", "$accept", "parse_toplevel",
  "stmtmulti", "toplevel_stmt", "stmt", "CallStmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "CreateSchemaStmt", "OptSchemaName",
  "OptSchemaEltList", "schema_stmt", "VariableSetStmt", "set_rest",
  "generic_set", "set_rest_more", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_drop_behavior", "opt_collate_clause", "alter_using",
  "replica_identity", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "column_compression",
  "opt_column_compression", "ColQualList", "ColConstraint",
  "ColConstraintElem", "generated_when", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "opt_c_include", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem", "OptWhereClause",
  "key_actions", "key_update", "key_delete", "key_action", "OptInherit",
  "OptPartitionSpec", "PartitionSpec", "part_params", "part_elem",
  "table_access_method_clause", "OptWith", "OnCommitOption",
  "OptTableSpace", "OptConsTableSpace", "ExistingIndex", "CreateStatsStmt",
  "stats_params", "stats_param", "AlterStatsStmt", "CreateAsStmt",
  "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "GrantRoleStmt", "RevokeRoleStmt", "opt_grant_admin_option",
  "opt_granted_by", "AlterDefaultPrivilegesStmt", "DefACLOptionList",
  "DefACLOption", "DefACLAction", "defacl_privilege_target", "IndexStmt",
  "opt_unique", "opt_concurrently", "opt_index_name",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_class", "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "opt_createfunc_opt_list", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "ReturnStmt", "opt_routine_body",
  "routine_body_stmt_list", "routine_body_stmt", "transform_type_list",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "operator_with_argtypes_list", "operator_with_argtypes",
  "DoStmt", "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_type", "reindex_target_multitable", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "opt_no", "AlterObjectSchemaStmt", "AlterOperatorStmt",
  "operator_def_list", "operator_def_elem", "operator_def_arg",
  "AlterTypeStmt", "AlterOwnerStmt", "CreatePublicationStmt",
  "opt_publication_for_tables", "publication_for_tables",
  "AlterPublicationStmt", "CreateSubscriptionStmt",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "TransactionStmtLegacy", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty",
  "opt_transaction_chain", "ViewStmt", "opt_check_option", "LoadStmt",
  "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "set_target", "set_target_list", "DeclareCursorStmt", "cursor_name",
  "cursor_options", "opt_hold", "SelectStmt", "select_with_parens",
  "select_no_parens", "select_clause", "simple_select", "with_clause",
  "cte_list", "common_table_expr", "opt_materialized", "opt_search_clause",
  "opt_cycle_clause", "opt_with_clause", "into_clause", "OptTempTableName",
  "opt_table", "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "relation_expr_list", "relation_expr_opt_alias",
  "tablesample_clause", "opt_repeatable_clause", "func_table",
  "rowsfrom_item", "rowsfrom_list", "opt_col_def_list", "opt_ordinality",
  "where_clause", "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "xmltable",
  "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "xml_passing_mech", "within_group_clause",
  "filter_clause", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "opt_window_exclusion_clause", "row",
  "explicit_row", "implicit_row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "func_arg_list_opt", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "unicode_normal_form",
  "overlay_list", "position_list", "substr_list", "trim_list", "in_expr",
  "case_expr", "when_clause_list", "when_clause", "case_default",
  "case_arg", "columnref", "indirection_el", "opt_slice_bound",
  "indirection", "opt_indirection", "opt_asymmetric", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "attr_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "PLpgSQL_Expr", "PLAssignStmt", "plassign_target", "plassign_equals",
  "ColId", "type_function_name", "NonReservedWord", "ColLabel",
  "BareColLabel", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", "bare_label_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,    60,    62,    61,    43,
      45,    42,    47,    37,    94,   741,    91,    93,    40,    41,
      46,    59,    44,    58
};
# endif

#define YYPACT_NINF -5359

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5359)))

#define YYTABLE_NINF -2776

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2776)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
    7153,  1388, 20736, -5359, -5359,  1388, 65205, -5359, 73280,    -3,
     172,    96,   164, 13331, 73755, 82780,   562,   365,  7385,  1388,
   82780,  2043, 56180, 70430,   297, 82780,   479,   805, 56180, 82780,
    1761, 83255,  1010,  1172,   179, 83730, 74230, 69005,  1101, 82780,
    1480,  1231, 84205, 74705,  1300, 75180,   805, 52404,   135,  1337,
   84680, 82780,106460,  1231, 75655, 75655, 75655,  1992,  1872,  1386,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359,  1401, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359,  1397, -5359,   899,
    2087,  1294,   871,  1389, -5359, -5359,  1961, 65205, 82780, 82780,
   82780,  1654, 82780,  1742, 82780,   205, 65205, 61405, 76130,  1887,
    1618, 48502, 85155, -5359, 65205, 82780, 59030, 65205, 82780, 82780,
   85630, 82780, 86105, 82780,  1581, 71855, 82780,  1824, 82780, 82780,
   59505, 86580,  1970,  1227,   239, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359,  1714,  1635, -5359,   255,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, 63780,
   82780, 18789,   479,  1961, -5359,  1992, 82780,  1983, 82780,  1751,
   87055, 82780, -5359, 82780,  1891, 87530,   206,  1674, 61405,  1886,
   48994,  2014, 82780, 82780, 61405, 88005, 88480, 88955, 82780, 82780,
   -5359, -5359,  1864, 82780, -5359,  2079, 61880,  1526,  2126,  2282,
    2183,   990, -5359, 76605, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, 64730,   365, -5359, -5359,  2143, 65680,  2206, -5359,
   -5359, 89430,106921,  1988, -5359,   481, 66155, 62355,  2326,  2038,
   49486,  2426, -5359, 66630, -5359, 62830, 67105, -5359, -5359, -5359,
   -5359, -5359, 89905, -5359, 90380,  2135,  2206, -5359,107382, 63305,
   -5359,  2297, 90855, 91330, 91805,  1961,  2018,  1979,  2109, 43670,
   -5359, -5359, -5359,  2083, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359,   287,  1766,   230,   215,   251, -5359, -5359,   223,
     231,   242,   287,  2526,  2526, -5359, 82780, -5359, -5359,  1766,
     677,  2060,  2060,  2060,  2289,    22, -5359,  2060,  2209, -5359,
   -5359, -5359, -5359, 75180, -5359,  2076, 77080, 82780, 77555,   479,
    2090,  2535,  2148, -5359, -5359, -5359, -5359, -5359, 63780,  2522,
    2522, 82780, -5359, -5359,  2574,  2175,  2416,  2178, -5359, -5359,
   -5359,  2371,  2399,  2387,   155,   479,   331, -5359,  2508, -5359,
    2407, 30048, 30048,   479, 78030, 92280,   278, 64730,   479, 78505,
    2248,   909,  2459, -5359, -5359, -5359,   777, -5359,  2688,  2302,
    2549,  2178,  1227, 45107, -5359,  2294,  1635, 75180, -5359, -5359,
   -5359, 63780,  2621, 32503, 82780,  2298, -5359,  2308,  2298, -5359,
   -5359,  2422, -5359,  2422,  2422,  2325,  2325,  2483,  2327, -5359,
   -5359, -5359,  2333,  2422,  2325, -5359,108304, -5359,  1773,  1779,
   -5359, -5359,  2798, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359,  2348, -5359,   421,  1851, -5359, -5359, -5359, 30048, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359,  2390,  2410,  1294, -5359,
   11084, 63780, 82780,  1383,  1383,  2853,  1383,  1708,  1769, -5359,
    2089, -5359,  2746,  2707, 75180,  2450,   321, -5359,  1495,  2455,
    1786,  2463,  1588,  1073, -5359,   320, 82780,   323,  2468, 78980,
    5863,  2478,  1635,  2495, -5359, -5359, -5359, -5359,  2643,   398,
   -5359, -5359, -5359, -5359,  2792,  2842,  5276,   221, 79455, -5359,
   -5359, -5359, -5359, 82780, 82780, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359,  2501,   143, -5359, -5359,  2510,  2854,
    2727,  8479,   941,  2819,  2678,  1483, 10621,  2736,   152,  2868,
    8786,  1277,  2871,  1594,   989, 77080, 82780,  2829,  2874,  6766,
    1900,  1074,  2744,  1135,  2819,  2863,  2692,  1483,  2879,  5970,
   82780, -5359,  2801,  2914,   682, -5359,   156, -5359, 23718, 32503,
   51929, -5359,  1635,  1318, -5359, -5359, 55230, -5359,  2599,  2758,
     728, 65205,  2546, 82780, 82780, -5359,106460, 65205, -5359,  2765,
   49978, 65205, -5359, 65205, -5359, -5359,  2878,106460, 82780, 82780,
   -5359, 82780, -5359, -5359,  2547, -5359, -5359, -5359, -5359,  2060,
   82780,  2976,106460,  2780,   121,  1226,  3013, 82780,  2782,  1226,
    2591, 92755, -5359, -5359,  1226, -5359, -5359, -5359, 82780, 82780,
    2555,  1965,  2770,  2889,  1226,  2788,  3014,  3017,  2791,  2641,
    2802,  2308,  2978,  2772,  1278,   176,  1767,  1226,  2623, 93230,
   93705, 82780,  2624, 82780,  2522, 65205,  2656, 65205, 65205, 82780,
    2910, 82780, -5359,  2759, -5359, -5359,  1201, -5359, -5359, -5359,
   -5359, -5359,  2925, -5359,   177,  2927,  2583,  2929,  1712,  2931,
     178, -5359, -5359,  2625, -5359,  2935,   185, -5359,  2936, -5359,
    2588, 94180, -5359, 94655, 95130,  2939,   187, -5359, 61405,  2940,
     185,  2941,  2588,  2942,   185,  2943,   498,  2944, -5359,  1346,
    2932,  2949,   178,  2951,  2051,  2588, -5359,  2953,   248, -5359,
    2957,   305, -5359,  2958,  2830, -5359, 32503, -5359,  2711, -5359,
    1337,  1646,  2109,  1766, -5359, 82780,  1766, 82780,  1766, 82780,
    1766, 82780,  1766, 82780, 82780, 82780,  1766, -5359, -5359, -5359,
   82780,  2617, 82780, 82780, -5359, -5359, -5359, 70905, 61405, 71380,
   -5359, 82780, -5359,   122,   479, -5359, -5359, -5359,   894, -5359,
    2178, -5359,106460,  3087, 61405,  2522,  1827, -5359, 82780, 82780,
   -5359, -5359, -5359,  2894, 82780,  2961,  2963, 70905, 61405, -5359,
   95605, -5359, 64730,  2848,  2636, -5359, -5359, -5359, -5359, -5359,
    1899,  3129,   219,  3133, 32503,  2644,   219,   219,  2647,  2974,
   -5359, -5359, -5359,   266,  2648,  2649, -5359,   238,   238, -5359,
    2651,  2654, -5359,   253,  2655,  2657,  3148,  3150,   258,  2659,
    2661,  2662,  2333,   219,  2663, 32503, -5359,  2667,   238,  2668,
    2673,  2674,  3164,  2675, -5359,  3168,  2681,   259,   290,  2683,
    2684, -5359,  2651, -5359,   267,  2689,  2696,  2700,  2701,  2703,
    2705,  2709,  2712, 32503, 32503, 32503, -5359, 27588,  1635,   479,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,   269, 48010,
   -5359,  2728, -5359, -5359,  2913, -5359, -5359, 32503, -5359, -5359,
     379, -5359,   271, -5359, -5359, -5359,  1635,  2995,  2710, -5359,
   -5359,   318,  2715, -5359,  2176, -5359, -5359, -5359, -5359, -5359,
   -5359, 64255,  3176, -5359,   300,   479,   156,  1790,  3113, 54280,
   54755, -5359, -5359,  2989, -5359, 82780, -5359, -5359,  1635,   144,
    1855, -5359,  2083, 19795,  1890,  2298, 82780, 82780,  3185, -5359,
    2726, -5359, -5359, 32503, -5359, -5359, -5359,  2526, -5359,  2422,
    2422, -5359, -5359,  3189,  2814,  2816,  2526, -5359,  2526, -5359,
    2734,  2737,  2526,  2818,  2821,  2825, -5359,  2738,  2826,  2526,
   -5359, -5359, 57130,  1884, -5359,  3069,   298, -5359, -5359, -5359,
    1909, -5359,  2741, -5359,  2308, -5359, -5359,  1294,  1294, 32503,
    1294,  1341,  1285, 30539, 32994,  3077,  2964,  1652,  1217,  3079,
   -5359,  2969,  1708,  1769, 75180, 82780, 96080,  2876, 32503, -5359,
    3183,  2840,  2841,  2896, 53354, -5359,  2846,  2812,  2849,  2902,
    2764,  2851,  2852,  2907, -5359,  3036, -5359, -5359,  2857,  2930,
    2858, 96555, -5359, -5359,   995, -5359, -5359, -5359,   995, -5359,
    2786,  1163,   457,   917,  2861,   381,   227,  3186, -5359,  1017,
   -5359, -5359,  2918, -5359,  9435, 82780,  3127,  8208,  2998,   221,
    2919, -5359, -5359, -5359,  3054,  2872, 82780,  2873,  3011,   221,
     901, 97030, -5359, -5359, 82780, -5359, -5359, -5359, -5359,  4743,
    3162, 26666, -5359,  1852,  2877,  2856,  2885, 82780, 68055,  2054,
    2988,  3012,  1317,  2189,   542,  2945, 82780,   295,  3018, 82780,
    2808,  2895,  2903,  3110,  2810,  1402,  3230,  2820, -5359, -5359,
   -5359,  3195, -5359,   470,  2152,  3023, -5359,  3130,  3172,  8337,
    2890,  2891,105077, -5359,  2917,    50, 50470, 82780, 82780,  2920,
    2921, 97505,  4743,  3201,  2934,  2946,  2923,  2924,    40,  3221,
    1297,  2947, -5359, -5359, -5359,  1297,  2948,  2950, 97980,  4743,
    3215, 82780,  2954,  2956, 82780,108304,   221, -5359,  3285,   221,
     221,  1676,  3291,  2959,   330,  3096,  1246,  1226,  2820,  1367,
   -5359,  2960,  2962,   317, -5359,  3067, 82780,  2965,  2966,   630,
    3032,   479, -5359,  3035, -5359,  2967,  3039,  2970,    70, -5359,
   -5359,  2955, 75180,  3061,  3062,   295,   207,  1391,  2820, -5359,
    2972,  2973,  2810,  2810, 82780, 82780, 82780, 82780, 82780,   232,
    3321,  3325,  2975,   211,   651,  2881, -5359,  1297, 59980,  2980,
   -5359,  1297, 82780,   184,  1732,  2820,  1052,  1835, -5359, -5359,
   -5359,  1227, -5359, 32503, 32503, 32503,  2893, -5359,  2249, 19795,
     609, -5359,   274, 14930,  2875, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, 82780, 63780, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   82780, -5359, 82780,  3177,106460,  3181,  3119,  3188,  3193,   221,
   82780, 82780,  3194,  3198,  3199,106460,  3200,  3203,  3204,  3120,
    3005,   171,  3000,  2933,  3388,  3274, 82780, 57130, -5359,   995,
   -5359,106460,  3144,  3279, -5359, 82780,  3167,   687, -5359,  3315,
    3001, -5359, -5359,    85, 82780,   261,  2981, -5359, -5359,  3287,
   61405,  1103,  3295,   479,  3003,  3296,  3166,   479, 61405,  3213,
   82780, 82780, 82780, 82780,   174, -5359, 59980,  3187, -5359, 82780,
    3190,  1367,  3191,  3417,    74,  2060, 98455,  3290, 98930,  2971,
   82780,  2979,  2979,  3421,106460,  1000,  3237, -5359, -5359,  1959,
   -5359,  3101, -5359, 65205, -5359, -5359, 65205, -5359, -5359,106460,
   82780,  2982,106460,106460, -5359, -5359, 65205, 65205, -5359, 61405,
   61405,  3311,   248,  3312,  3029,  3317,  3030, 50470, 50470, -5359,
     310, 65205, -5359, 61405, 65205, -5359, 82780, -5359, 82780, -5359,
   -5359, -5359, -5359,106460,106460, -5359, 61405, 59980,  3318, 82780,
   82780, -5359, 82780, 82780, -5359, 82780, 82780,  1915, 99405,  2109,
   -5359, 82780, -5359, 82780, -5359, 82780, -5359, 82780, -5359, 82780,
   -5359, -5359, -5359, 82780, -5359, 82780,  1930, -5359, -5359,  1939,
    1097, 82780, 82780,   229, 65205, 82780,  3205, 65205, 65205, 82780,
   82780, 82780, 82780, 82780,  3059,  2715,  1622, -5359,   284,   273,
   75180,  3206, -5359, -5359,  1951,  1992,    23, 82780,  1055, -5359,
   -5359, -5359, -5359, 71380, 70430,  3304,   133, 82780, -5359, -5359,
   11403, 32503,  1635, 29552, -5359, -5359, 19795,  3025, 32503, 32503,
    2986,  2526,  2526, -5359,   980, 32503, 32503, 32503,  2526,  2526,
   32503,  4467, 32503, 50470, 32503, 37904, 24712, 32503, 32503, 28079,
   -5359, 32503,  3232, 38880, 32503,  1790,  3233, 32503,  1790,  4467,
    3475,  3475,  2147,  6267,  2987,  1635, -5359,  2526,   882, -5359,
     416,106460, 32503, 32503, 32503, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, 32503,
   -5359, 57130, -5359, -5359, -5359, -5359, -5359, -5359,  3078, -5359,
   -5359, -5359, -5359, -5359, -5359,  3358, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, 82780,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, 28570, -5359, -5359, -5359, -5359,  2993, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359,  3146, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, 29061, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
    2994, -5359, -5359, 32503, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359,  3080, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359,  1207, 32503, 32503, 32503,
   32503, 32503, 32503, 32503, 32503, 32503, -5359, 32503,   418, -5359,
   -5359,  3314,  3334,   681,   463, 79930, 30048,  3069, 23718, -5359,
     246,  3069, -5359, -5359, -5359, 82780,  3176, -5359, -5359,  3081,
   -5359, -5359, -5359, -5359, -5359,   281, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359,  2999, -5359, -5359, -5359, -5359,  2999, -5359,
    3004,  3313,  3316,   498, 82780,  2310, 32503,  3078,   252, 82780,
   32503,  2993,  3146, 32503,  2994, 32503,  3080, -5359, 32503, -5359,
    1952,  1982, 32503,  1953,  3008, -5359, -5359,  3015,  2737,  3031,
    3037,  3019,  3021,  2526,   201,  3022,  1261,  1236,  3149,  2526,
    3264,  3024, -5359, 57130, -5359, 40796,  3070, -5359, -5359, -5359,
    1231, 82780, 82780, -5359,  3323, -5359,  3026, -5359, 14948,  3323,
   -5359, -5359, 38392,  3151,  3307,  3247, -5359, -5359, -5359,  3033,
   19795, 33485, 33485, -5359,  2068, 19795,  2503, -5359, -5359, -5359,
   -5359, -5359, -5359,   806, -5359, 82780,  1177,  3077,  1217,  3100,
    1233,  3503, 82780, -5359, 45586,  1974, -5359, 61405, 82780, 82780,
    3249, -5359,  3493, -5359,108304, -5359,  3053, -5359,107843,103680,
   -5359, -5359,   602, -5359,   534, 61405, -5359, 82780, 82780, 61405,
   82780, 82780, -5359, 61405, 82780, 82780, -5359, -5359, -5359, -5359,
   -5359, 55705,  1361, 70430,  3196, 69480, -5359, -5359,  3057, 82780,
    3116,  3335,  3339,  1344, -5359, -5359, 99880, -5359,  3289, 61405,
   82780, 82780, 32503,  3292, 82780, 82780, -5359,   536,  3154,  3155,
   -5359, 82780,  3156, 65205,  3066,106460, 65205, 50962, 65205, 65205,
    3404,106460, 82780, 82780,  1283, 75180,   220,  1808,  2820,  3301,
   -5359,   918, -5359, 61405, -5359, 82780,  3293, -5359, -5359, -5359,
   80405,  3532,  3202, -5359, -5359, -5359,100355, -5359, -5359,  3297,
   -5359,  1984, -5359, 61405, 61405, 82780,  9698,100830,  1467,  3319,
   -5359, -5359,106460, -5359, 82780, 80880, 82780, 82780,  3348, 82780,
   72330,101305,101780,  1333,  1414,  3350, 82780, 72805,  3351, -5359,
    3235, 82780, -5359, -5359, 57605, 61405, 82780,   833, 57130, -5359,
   -5359, 82780, -5359,   314, -5359, 82780,  7225,  3302, -5359, -5359,
    3175,  3197, 82780,   411,  2121,  2820,  3467, 82780, 82780,  3092,
    1990, 61405, 82780, 57130, -5359,  3320,  1214, 61405, 82780, 80405,
   -5359,  3322, 75180, 75180, 61405, 82780, 75180, -5359, 82780, 92280,
   -5359, 61405,  1916, -5359, 61405, 82780, 80405, -5359,  3324,  3256,
   61405, 82780, 10313, -5359, -5359, -5359,   221, -5359, -5359, -5359,
   -5359, -5359, 82780, 82780,   221, 82780, 82780,   221,  1245, -5359,
   61405, 82780, -5359, -5359, -5359,  3234, 61405, 82780, 82780,   287,
   82780, -5359, 82780, 61405,  2981, 82780, 82780, -5359, 82780,  7669,
   82780, 82780, 82780, 82780, 82780, 82780, 61405, 82780, -5359, -5359,
    1430,  1441,   116,  1710,   743, 82780,  3413, 82780,102255, 61405,
   82780, 82780,   479, 82780, 57130,  1543, -5359, -5359,  3239, -5359,
   61405,  1916, -5359,  9926, 82780, 82780, 82780,  3209,  3211,   225,
    3278, -5359, -5359, -5359,   674,   674,  3326, -5359, 32503, 32503,
   31030,  3111, -5359, -5359, 32503,  2599, -5359, -5359, -5359,   327,
    3574,   327,102730,   327,   327,  3394,  3179,  3180,   327,   327,
     327,  3389,   327,   327,   327, 82780,  3303, -5359, -5359,  3303,
     653, 32503,106460, 82780, -5359,  1994, -5359,  3126, -5359, -5359,
   57130, 82780,   355,   801,  3466,  3341, 68530,  1347,  3460, 82780,
    3182, 82780,  3592,  3227, 75180,  2555, -5359,  1347, 82780, -5359,
    2395, 70430, -5359, -5359, -5359, -5359, -5359, -5359, -5359, 82780,
   -5359, -5359,  3462, 82780, 41275,  3309, -5359,   479,  2555,  2555,
    2555,  2555,  3136,  2555, 82780,  3265,  3483,  1347,  3139,  3485,
   -5359,  1367,  3487,  1320, 82780,  3362, 68530,  3207,  3208,  3374,
    3613,  2060,   479,  3383,  3369, -5359, 53817, -5359,  2555,  3629,
   27127,  2062,  8938,  3375,  3434, -5359, -5359,  3381,   191, 82780,
    3474,  3477,  3495, -5359,   177, -5359,  3630,  1712,  3500,   178,
   -5359,   185, -5359,  2588, -5359, 82780, -5359, 82780, 82780, 82780,
   82780,   187, -5359, -5359,   185,  2588,   185,   498, -5359,  3445,
     178,  2588,  3300,  3505,   248, -5359,   305, -5359,  3390,   498,
   -5359,  3406,  2060, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
    1995, -5359, 82780, -5359,  3480,  3481,  3482,  3484,  3486,  3171,
    3184,  3218, 82780,  3210,  3171,   221,  3210,  3210,  3171,  2715,
    2715,  3171,  3184, 60455,  3656,  3504, -5359,  3273,  3192,  3516,
     188, -5359,   208,  1268,  3438, -5359, -5359, -5359, -5359,106460,
   -5359, 61405,  3240,  2522,  2522,   312,  3407,  3216, 60455,  3638,
     498, -5359, 65205, 82780,106460, 65205,  3420, 65205, 65205,106460,
   82780, 82780,  2023, -5359,   986, -5359,  1783, 32503,   235, -5359,
   17293,  2031, 32503,  3212,  3214, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359,  3220,  3528, -5359,  2036,  2048,  2061,  3222,  3223,
    1620,  6004,  3225, 17603,  3224,  3228,  3229,  3217, 37904, 37904,
   27588,  1104, -5359, 37904,  3231,  3408,  2065, 15756,  3236,  3241,
   17427, 31521, 32503, 31521, 31521, 17951,  3245,  3242,  2072, 57130,
    3397, 17995,  2092, -5359, 32503, 57130,  6141, 32503, -5359, 32503,
    3243, -5359, -5359,  6965,  6965,  6965,  4467, -5359,  3226, -5359,
   37904, 37904, -5359,  1424, 27588, -5359, -5359,  3534, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359,  3083, -5359, -5359, -5359,  3439,
    2349, 50470,  6947, 32503,   262, 32503,  2993, 32503,  3294,  6965,
    6965,  6965,   338,   338,   277,   277,   277,  1975,   463, -5359,
   -5359, -5359,  3219,  3250,  3251,  3415,  3252, 32503, -5359,  2025,
    2034, 82780,  3725,  5168,  5616, -5359, -5359, -5359,  3070,   609,
    3070, -5359,  1227,  2526,   882, 55230, -5359, -5359, -5359, -5359,
   -5359, -5359, 82780, 19795, -5359, -5359,  3488,  3253,  2107, -5359,
   -5359,  2526, -5359, -5359,  1484,  1484,  3255, -5359,  3257, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359,  3254, -5359, -5359, -5359,
   41754,  3548,  3258, 40317, 81355,  3259,  1415, -5359, 81355, 81830,
   81355, -5359,  3275, -5359,  1635, 32503,  3550, -5359, -5359, -5359,
   32503, -5359, -5359,  1033,  3280,   655,   112,  2204,  2204,  2068,
     817, -5359, -5359,  3328, -5359, 32503,  2525, -5359,  2545, -5359,
   -5359, -5359, -5359,  2715, -5359,  3491, -5359, -5359, -5359, 40796,
    3284,  3327,  1150, 44628,  3478, -5359, 82780, -5359, 82780,   357,
   -5359,  3270, -5359, -5359, -5359, -5359, -5359, -5359,103680,  1851,
   -5359,107843, -5359,107843, -5359,  1851,  3671, -5359,103680,   575,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, 61405, 61405,  3490, 82780,  3479,  3494, 32503,   236,
   82780,  3267,  3269,  1604,  3569, 82780, -5359,  3617,   498, -5359,
   -5359,  3361, -5359, 19795, -5359, -5359, -5359, -5359, -5359, 61405,
   82780, -5359, 64730, -5359, -5359,106460, -5359, -5359, 82780, 82780,
   -5359, -5359, -5359,106460, -5359, -5359, -5359, 82780,   136,  3363,
    3365, 82780, -5359,   821,  3067, 10147, 82780, 82780, 82780,  3564,
   -5359, -5359, -5359, -5359,  3507, -5359,  3626, -5359,103680, -5359,
    2588,  1436,  3372,  2820,  3514, -5359,  3634,  3704, -5359,  3418,
    1406, -5359, -5359,  3425, -5359, -5359, -5359, -5359,  3639,   498,
    3640,   498, 82780, 82780, 82780, 82780,  3435, -5359, -5359, -5359,
   -5359,  3436,  3567, -5359, 57130, 57130, 57130,  2114, -5359, -5359,
     479, -5359, -5359, -5359, -5359, -5359, -5359,  3602, -5359,  2129,
   -5359,   982, -5359, -5359, -5359, -5359, -5359,  3647, 61405, 82780,
   10416, 82780, 82780, 82780,  3520,  1754,  1303,106460, -5359,105538,
   -5359, -5359,  2149, -5359,  3329, 82780,  3391, 61405,  3368, -5359,
   -5359, -5359,  3652,  3330,  3330, -5359, -5359,  3330, -5359, -5359,
   -5359,  3579,  3512, -5359,   343,  3513, 61405,  3376, -5359, -5359,
   -5359, -5359,  3664,  3409, -5359, -5359,  3410,  2191,  2820,  1367,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,  3432,
   -5359, -5359, -5359, -5359,  1644,  1644, -5359, -5359, -5359,  1644,
    1486,   408,  2196,  2820, -5359,  1729,   348,  3411, -5359,  3414,
   -5359, -5359, -5359,  3583,  3585,  3586,  3422,  3423,  3471,  3426,
    3430,  3489, -5359,  3437,  3492,  3441,  3496,  3447,  3708,   498,
  106460,  3566,   479,  3497,  3695,   498, -5359,  3450, -5359,  3452,
   -5359,  2158,  3804, -5359, 82780, -5359,   413,  2205,  2820, -5359,
    3453, -5359, 61405, 82780, -5359, -5359, -5359, 32503,  3354,  3370,
    3373, 19795, 19795, 32503, -5359, -5359, 19795,  3377, -5359, -5359,
   -5359, -5359,106460, -5359, 82780,  3653, -5359, -5359,   327, 82780,
   82780, -5359, -5359, -5359, 82780, -5359, -5359, -5359,  3657, -5359,
     473,   473, -5359, -5359,  3692,  6311,  3378,   369, -5359, 57130,
   47026,  2270,   163,  1226, -5359, 64730, 82780, 64730, -5359,   801,
    3590, 82780, 82780, 82780,  3380,  3379, -5359, -5359, -5359, -5359,
   61405,   739, 61405,  2526, -5359, -5359,  3456, -5359, 82780,  2060,
    3879,  3716, -5359,  3330, -5359,  3837,  3017,  1103,  1655,   303,
    2641,  3776,  2308, 32503,   370, -5359, -5359,  1635, 82780,  3208,
   -5359, -5359, -5359, -5359,   479, -5359,  3392,  3387, -5359, 82780,
    3723, 82780, 82780, 82780, 82780,  3240,  3395, 82780,  3396,106460,
   82780,  2000,  2810,  3859,  3745,  1992,  3207,  3515,  3748, 75180,
    3429,  2160, -5359, -5359,   191, -5359,  2166,   142, -5359,   479,
   64730,104616,  3738, -5359,   533,  8938, -5359, -5359,   533,   895,
   82780, -5359, -5359, -5359, -5359,  3649,  2020, -5359,  3724, -5359,
   -5359,  1992, -5359,106460,  3440, -5359,  2171, -5359, -5359, -5359,
     248,  3499,   498,  3502,   498, -5359, -5359, -5359, -5359, 82780,
   -5359, 82780, 59980, -5359, -5359, 82780, -5359,  3756, -5359, -5359,
    3570,  3575,  3588,  3591,  3593, 82780,  3171, -5359,  3444, 61405,
    1686, -5359, -5359,  3663, -5359, -5359, 75180,  3573, -5359, -5359,
   -5359, -5359,  3783,  3801, -5359, -5359, -5359,   956, -5359, 82780,
   82780, 61405, 70905,   373, 61405, -5359,  3736,  3740,  3743,  3746,
     221,  3747,  3749,  3750,  3751,  3752, -5359, -5359, -5359,  3470,
   18100, 32503, -5359,  3819,106460, -5359,  7698, -5359, -5359, -5359,
   32503, -5359, -5359, -5359, -5359, -5359, -5359,  2159, 32503, -5359,
   32503, -5359, -5359, 25209,  3958,  3958,  3476,106460, 37904, 37904,
   37904, 37904,   965,  2668, 37904, 37904, 37904, 37904, 37904, 37904,
   37904, 37904, 37904, 37904,   486, -5359,  3677, 32503, 32503, 32012,
   -5359, -5359,106460,  3501,  3245,  3508,  3509, 32503, -5359, -5359,
    2188, 39359,  3524, 57130, -5359, 32503, 15707,  2193,  3530, 18120,
    1635,  8070,   479, 32503,  1269,  3726, 32503,  2197, 32503,  3805,
   -5359, -5359, -5359, -5359, -5359, -5359,  3714, -5359, 32503,  3529,
    2952, 37904, 37904,  3056, -5359,  3107, 32503, 27588, -5359,  3326,
    3531, 46065, -5359, 25706,  3511,   805,   805,   805,   805, -5359,
   82780, 82780, 82780,  3550,  3533,  3550,   156,  3535, -5359, -5359,
   -5359, -5359,  1992, -5359,  3498, -5359, -5359, -5359, -5359, -5359,
   81355, 81830, 81355,  3506, 39838, 26186,  1415,  3536, 82780, -5359,
   -5359,  3521, 40796,  3762,  3690, -5359, 40796,  3690,  1600,  3690,
    3765,  3594, 46544, -5359, -5359,  3538, -5359,  3703, -5359,  1852,
   19795,  3938,  3814, -5359,  3539, -5359,  3280,  1565, -5359, -5359,
   -5359,   858, -5359,  3600, -5359, -5359, -5359,  3259, 33976,  3654,
   -5359, -5359, -5359,  3559,  2212, -5359, -5359,  3915,  3654, -5359,
   -5359,  2217, 45586,  3284, 32503,  1635,  2221,  1834, -5359, -5359,
  103680, -5359,  3603,  2588,  2588,  1372,  3171,  3862,  1372,  8304,
   -5359, -5359, 42233, 82780, 82780, -5359, 82780,  2222,  1455, 82780,
   -5359, 82780, -5359, -5359, -5359,  3994,  3595,  3601,  3816, -5359,
    2463, -5359, -5359, 61405, 82780, -5359, -5359, -5359,   422,  2215,
    2820, -5359,  3624, -5359, -5359,  3834, 82780, -5359,  3985,  3642,
   82780,  3891, 82780, 82305, -5359,  3590,  1455,  3659,  3869,  1690,
    2810,   330,  5061, -5359,  1568, -5359, -5359,  3625, -5359, 82780,
   -5359, 82780, -5359, -5359, -5359, -5359, -5359, -5359, -5359,  3685,
   -5359, -5359, -5359, -5359, 57605, -5359, -5359, 82780, -5359, 57130,
   47026, 57130, 82780, -5359,  1489,   434,  2338,  2820, -5359,  3637,
   -5359,  3896,  3643,  3646,  3693,   715,   257,  3650,  3651,  3694,
    3557,  3562,  3576, -5359, 57130, 47518,  3734, 82780,  2588,  3578,
    3620, 82780,   287,   479, -5359, -5359,   479,  2588,   479, 82780,
   82780, 82780, 82780,   287, -5359, -5359, -5359,  4016,  3674, 82780,
   82780, 82780, 82780, -5359,  3636, -5359, -5359, -5359, 82780, 82780,
    3914,   830,  2091, 61405, 82780, 82780, 61405, 82780, 82780, 82780,
   82780, 82780, 82780, 82780,  3799, -5359,  4008,  3933,  2203,  3976,
    3665, 82780, -5359, 82780,   479, -5359,  3067, 82780, 82780, 82780,
   82780, -5359, -5359, -5359, -5359, -5359,  3326, -5359,  3596,  3872,
     327, -5359,  3873,  3874,  3875,   327, -5359, -5359,  1226, -5359,
     432, 82780, -5359,  2046, 82780, -5359, -5359, -5359,  3539,   470,
    2152, -5359, -5359, -5359, -5359, -5359, -5359,  3599, 82780, 82780,
   37904, -5359,  1913,  1649,  1184, -5359,  3876, 82780,  2981, -5359,
   -5359, -5359,  1329, 82780, -5359, -5359, -5359, -5359,  3604, -5359,
     689,  3395, -5359,  3900, 68530,  2588, 61405, 61405,  2588, -5359,
  106460,  3606,  3208, -5359,   814,  3680, 61405,  1103,103205,  3003,
    3644,  3815,  8448, 40796, 41275,  1644, -5359,  3607,  3605, -5359,
   -5359, 82780,  3590, 59980,  2230,  1367,  4071,    76,  2018, -5359,
   69955,  3808,  3395,  3900, -5359,  2810,  3827,  3831, -5359,  1992,
   82780,  3240,  3208,   479, 82780,  3116, 47026, -5359,  4113,  2044,
   -5359,103680, 32503, 32503, -5359,  3621, -5359,  3627,  8938, -5359,
    3702,  3628,  4076, 32503, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359,  3715,  3633, 82780, 82780,   191, 82780, -5359,  3635,
    3500, -5359,  3500, -5359, 82780, -5359, 82780, -5359,   498, -5359,
    3758,   498, 82780, 82780, 82780, 82780, 82780, 82780,  3171,   221,
   -5359,  3954, 60455,  3504, -5359,  2234, 82780, -5359, -5359, -5359,
    4022, -5359, -5359,   133,  3963,   498, -5359,   344,   344,   344,
     344,  3918,   344,   344,   344,   344,   344, -5359, 32503, 19795,
   -5359,  3641, -5359, 19795,  3645,  9071, 18643, -5359,  2235, 32503,
   -5359,  1046,  1046,  1046,  4434,  3965, -5359,  2374,  1046,  1046,
    1046,   324,   324,   214,   214,   214,  3958,   486, 18974, 19068,
   19305,  3648, -5359, -5359, -5359,  3245, -5359, 34467,   729,  4081,
   38880, -5359, -5359, -5359,  3686,  3687,  3655, -5359, 32503, 34958,
    3658,108304,  3847, -5359,   427, 32503, 32503,  2822, -5359,  6636,
   32503, -5359,  2822,   474, 32503,  3828,  4401, 32503, 32503,  3577,
    9225,  3660, 32503,104141, -5359, -5359, -5359,  2243, 32503, 82780,
   82780, 82780, 82780, -5359, -5359, -5359,  3814,   479,  3814,   479,
    3662, -5359, -5359, -5359, -5359, 58080,  3666,  3397, 81355,  3667,
   82780,  1415, 40796, -5359, -5359,  1776, -5359, 40796,  3927, -5359,
   40796, 65205, -5359, 82780,  3668, 82780, -5359,  1383, 32503,  3697,
   50470, -5359, -5359, -5359, -5359,  3739, -5359,  3870, 19795, 30048,
   -5359,  1992,  2578, 82780,  1635,   107, -5359,  3669, 82780, -5359,
    3654, 19795, -5359,  3727,  2245, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359,  3742, 70430,  3986, -5359, 32503,  2255, -5359,  3705,
    4086,   145,  2257,  2261,  1455, -5359,  3970, -5359,  1673,  3967,
     362, -5359,   498, -5359,106460, 82780, 82780, 82780,  2764, -5359,
   -5359, 82780, 82780, 82780, 82780, -5359, -5359, 61405, 82780, -5359,
   82780, -5359, -5359, -5359, -5359,   287,  1913,  3980,  3981,  3902,
   -5359,   221, -5359,  1913,  3903,   287, 82780, -5359, -5359, -5359,
    2672, -5359,106460,   498,   498, -5359, -5359, -5359, -5359, -5359,
    3696, -5359,  4120,  3775, 82780, 82780, 82780, 82780, 82780, 61405,
   82780, 82780,  2526,  2526,106460,  3681, -5359,  2526,  2526,  3689,
   -5359, 61405, 82780, 82780, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359,  3773, -5359, 32503,  4117, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
   61405, 82780,  3778, -5359,  3779, -5359,   788, -5359, -5359, 82780,
   82780, 82780, 82780,  4036, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359,  4038, 82780, -5359, -5359,   479,
     479,106460,   498,   498, -5359, -5359, -5359,  3781, -5359, -5359,
    3698,  3978,   327, -5359,   327,   327,   327, -5359,  3706, -5359,
    1226,  4075, -5359,  1455,   867,  4027, -5359, 32503, -5359,  1001,
    4434, -5359,  4084,  4168, -5359, -5359, -5359, -5359,  2981,  2060,
    3768, -5359, -5359, 65205,  1005, -5359,  4011,   355, 57130,  3929,
   68530,  1729,  1421,  3712,  3852, -5359,  2588,  2588,  3785, 82780,
    4190, -5359, -5359, -5359, -5359, -5359, -5359, 61405,  3368, -5359,
    3960,   102,  4061, 82780, 41275, -5359,  3259, -5359, -5359, -5359,
     479, -5359, -5359,  3863,  3208, -5359,  1366, 82780,  3953, 68530,
    3240,  2263, -5359, -5359, -5359,  3777,  4178,  3207, -5359,  1729,
    3808, -5359, -5359,  4155,  3836,  3786,  4205, -5359,  3836,  4072,
    3962,  3753, -5359,  3429, -5359, 82780, -5359, 19795, 19795,   479,
  108765,   533,106460,  4082, -5359, 19795, 82780,   189,  3754,  3916,
   -5359,  4043,   498,  2274, -5359,   498,   498, -5359, 82780, -5359,
    3171,  3171,  3171,  3171,  3171, -5359,  3968, -5359, -5359, -5359,
    4041, -5359,   498, 60455, -5359, -5359, -5359, -5359, -5359, -5359,
   -5359,   344, -5359, -5359, -5359, -5359, -5359, 19795, -5359, -5359,
   -5359, 32503, -5359,  9904, 37904,  4080, -5359, 32503, 32503, 32503,
   -5359,  3760,  2285,  2287, -5359, -5359,   729, -5359,  4081, -5359,
   -5359, -5359, 11422,  3811, 19795,  3877,  3761,  3763,  2822,  2822,
    6636,  2822, 32503, 32503,  2822,  2822, 32503, -5359, -5359, 11922,
    3955, -5359, -5359, 12252, -5359, -5359, -5359, -5359,  3697, -5359,
    3697, -5359,  3898, -5359,  2291,  4227, 36922,  4185, -5359, 82780,
    2292, -5359, 32503,  3769, -5359, -5359, 40796,  1776,  3770,  2303,
   82780,  2309,106460, 35449, 19795, 82780,  3326,  3767, -5359, 82780,
    2710, -5359,  1150, -5359, -5359,  4179, 42233,  4136, 32503, -5359,
   -5359, -5359, -5359, 60455,  3988, 60455,  1455, 12299,  3970, 42233,
   51454, 82780, -5359, 82780, -5359,  3940,  3970,  3780,  2981, -5359,
   -5359, -5359, -5359, -5359, -5359,  3782, -5359, -5359, -5359, -5359,
    3860, -5359, -5359,    56,  3206, -5359,  2270, -5359,  4239,  4124,
    4129, -5359, -5359, -5359, -5359, -5359, -5359,  4008, -5359, -5359,
   47026, 61405, 82780, -5359,  3871, -5359, -5359, -5359, -5359, -5359,
   -5359, 44149, 50470, -5359,   715,  3788,  3792,   257, -5359, -5359,
   -5359, 82780, 12443,  3793,   920,  3206, 82780, 82780,  3794,  3795,
    3796,  1601,  1161,  1825,  3171,  4130, 82780, -5359, -5359, -5359,
    4008, -5359, -5359, 82780, -5359,   327, -5359, -5359, -5359, -5359,
   57130, -5359,  2855,  3706,   479, 65205,  4247,  4247, 12798,  4024,
   -5359, -5359,   382,  3768,  4051,  4100, -5359,  3803, 82780,  1329,
    3810,  2313, -5359, 82780,  3807,  3932,  1310,  1310, 82780, 82780,
   82780,  2314,  1992,  2588,  3620,  1103,  4150, 68530,  4198,  3590,
     372, -5359, 82780,  4273, 82780,  3240,  3395, 82780,  3812, -5359,
   -5359, 69955,  4025,  2270, 82780,  2000,  3808,  3207,  1130, 82780,
   -5359,   329, -5359,  1992, -5359, 82780, 75180, 42233,  4140, -5359,
  107843, -5359,  2318, -5359, -5359, -5359,  3899, 20298,  3070,  3941,
    3942,  3825,  1804,  4160, 82780,   108, -5359, -5359, -5359, -5359,
   -5359, -5359, 82780, -5359,   373, -5359, 19425, -5359,  4570, 37904,
   19795, 19795, 19795, 32503, -5359, 32503, -5359, -5359, -5359, -5359,
     139, -5359, -5359,  2822,  2822,  2822, -5359,  4271,  3326, -5359,
   -5359, -5359,  1342,  4218,  3275, 58080,  3835, -5359, 37904,  2319,
   -5359,  4270, 82780,  2320, -5359, 19795, 82780, -5359, -5359, 32503,
   -5359,  2345, -5359,  3838,   750,  3839, 24215,  3830, -5359, -5359,
   -5359, -5359, -5359, 19795,  3840, -5359,  4301,  1217, -5359, -5359,
    3901, 82780,  2355, -5359,   702, 19795,  1686,  1372,   337,  4086,
    2981, -5359,  3843, -5359, -5359,  2810,   403, 82780,  2981, 82780,
    3768, -5359, 82780,  3944, -5359,  4154, -5359, -5359,  3907, -5359,
     929,  3206, 82780,106460, -5359,   134,  4183, -5359,106460,106460,
   -5359, -5359, -5359, 32503,  3946, -5359, -5359, -5359, 32503, 32503,
   67580, -5359, -5359, 82780, 82780, 82780, 82780, 82780, -5359,   498,
   -5359, -5359,  2362, -5359, 43191, -5359, -5359,  3013,   479,  3013,
    1468, -5359, -5359,  3013,  3013, -5359,  3070, -5359,  4247,   932,
   -5359, -5359,  4087,  3848, 32503, -5359,   887,  4069,  3949,  3856,
   -5359, 65205,  4350, -5359, 57130,  3395,  3900, 82780, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,
    2368,  3590,  4201,  3208,  3786, -5359, 82780,  3905, -5359, 40796,
    3590,  1992,  2018, -5359,  3808,  3395,  3900, -5359, -5359,  3864,
    3831,  3207,  2000,  4006, -5359,  4007, -5359,  4296,  4083,  4297,
    3240, -5359,  3116,  2376, 82780, -5359, -5359,  8938,108765,106460,
   -5359, -5359, -5359,  3868,  4238,  3917,  3919, -5359, -5359, -5359,
    1804, -5359,   101,  4234,  3922, -5359,  3936, 82780, -5359, -5359,
    3590,   498, 32503,  4570,  2378,  2384,  3939, -5359, 32503,   799,
    4215,  4219, 82780, -5359, -5359, -5359, 82780,  4434,  3886, 36922,
   57130,  2388, -5359,105999, -5359,  2389,  2398, -5359, 32503,  3892,
   32503, -5359, 35449, 82780,  3894,  3077,  1992, -5359,  3070, 42233,
   -5359,  4020, -5359,  4217, -5359, -5359,  3768, 50470,   403,  3280,
    2060,  3768,  2408, -5359, -5359, 82780,  3848, 32503, -5359,  3989,
   -5359, -5359,  2418,   158,  4065,  4065,  2425,  2429, 12838, 82780,
    2431,  2437, -5359,  2443,  2526,  3184,  1825,  3184, -5359,  3171,
   -5359, -5359, 57130, -5359, 60930, -5359, -5359, -5359,   479, -5359,
     479,  4122, 82780, 52879,   479,   479, -5359, -5359, -5359, -5359,
    4196, -5359,  1367, -5359, 13028, -5359, -5359, -5359,   440, -5359,
    4115,  4116, 82780, -5359,  3904, -5359,  2448, -5359,  1729,  4031,
    3590, -5359, -5359, 82780,  4366,  4367, -5359,   683, 82780,  3259,
   -5359,  3786,  3240,  3207,  1729,  3808,  2270, 42712,  3836,  2000,
    3831, -5359, -5359,  4118, -5359,  4121, -5359,  3911,  4213, -5359,
    1928,   533, -5359, -5359, -5359,   340,  4248,  4250, -5359, -5359,
   -5359,  3013, -5359,  1515,  3923,  4260, -5359, -5359, -5359, -5359,
   19795, -5359, -5359, -5359,  3245, 35940, 35940, 35940,  3926,  4355,
    4368,  1100,  2456, 38880, -5359, -5359, -5359, 82780,  4137,   978,
    4390,  4091,  2458, 35449,  2462, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359, 45586, 60455,  3979,  3935,  3280, -5359,  4051, -5359,
   -5359,  1455,  3206, -5359, 19795, 82780, 65205,  4374, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359,  3206,  4029, -5359, -5359, 67580,
   -5359, 82780, -5359, -5359,  2471, -5359, -5359, -5359, 82780,  3754,
   -5359,  3754, -5359, -5359, -5359,   889,  4045,   850,   850,  4316,
   -5359,  4009, -5359, -5359,  3950, -5359,  4442,  4085, 82780, -5359,
   -5359,   715,  1992, 68530,  3590, -5359, -5359,  2000,  3808,  3207,
   32503,  2473, -5359,  4086,   145, -5359,  3831,  3836, -5359, -5359,
   42233,  3952,  3208,  4315, -5359, -5359, -5359,  2104, 65205, 65205,
   82780, -5359, -5359, -5359, 32503,  1329, 37413,  4101,   243, 16793,
    4307, -5359,  4307,  4307, -5359, 82780, 82780, 82780, -5359,  3397,
   -5359, -5359, 37904, 37904,  4186, -5359,   978, -5359, 82780, -5359,
    3966, -5359, -5359,  2475, -5359,  1327,   337,  3969, -5359, -5359,
   -5359,  4069,  1455, -5359,  3206, -5359, 82780, -5359,  3971, -5359,
   -5359, -5359, 60930,  3754, -5359, -5359, -5359,  4438, -5359,   896,
   -5359, -5359, -5359, -5359, 82780,  3590,  3681,  3786, -5359,  3831,
    3207,  2000, 13115, -5359, 42712, 82780, 82780,  3836, -5359,  2479,
   42233,  3836,  4107, -5359,  2405, -5359, -5359, -5359, -5359, -5359,
   -5359, -5359,  3972,  3973, -5359, -5359, 13804, 65205,  4431, -5359,
   -5359, -5359, -5359, -5359,   952, -5359, -5359, -5359,  1106,  1121,
    1715,  4388,  4434,  4434, -5359, -5359, -5359, 32503, -5359, -5359,
   -5359, 32503,  1455, -5359, -5359, -5359, 32503, -5359, -5359, -5359,
   -5359,  3590, -5359, -5359,  3836,  2000,  3831,  4086, -5359, -5359,
   -5359, -5359, -5359,  4213, -5359,  2484,  3070,  3922,  2113, -5359,
   -5359,  2201,  2410,  4056,  4299, -5359,  3983, 36431,  4126, -5359,
    4184, -5359, 82780, 82780, 58555, 82780, 82780, 14156, 14300,  1455,
    2485, -5359, -5359,  3831,  3836, 82780,  3208, -5359, 42233, -5359,
    4326, -5359,  2405,  4099,  4103, 56655, -5359, -5359, -5359, -5359,
   -5359,   282,  4371, -5359,  2490, -5359, -5359, -5359,  3836, -5359,
   -5359,  3836, -5359,  1329, -5359,  4033,  4034, -5359,  2506, -5359,
   -5359, -5359, -5359, 32503, 58555, -5359, -5359,  3070, 65205,  4319,
    4320, -5359, 56655,   674,  4057, -5359,  3999, 65205, 65205, -5359,
    4000, 82780, 56655, -5359, -5359,   479, -5359,  2507, -5359
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1656,  1422,   643,  1509,  1508,  1422,     0,   265,     0,  1519,
       0,  1422,   428,  1088,     0,     0,     0,     0,   643,  1422,
       0,  1656,     0,     0,     0,     0,     0,  1669,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1422,     0,
       0,  1676,     0,     0,     0,     0,  1669,     0,  1521,     0,
       0,     0,     0,  1676,     0,     0,     0,     0,     0,     2,
       9,    10,    45,    80,    81,    38,    37,    98,    63,    24,
      71,   132,   131,   133,    50,    46,    88,    33,    35,    47,
      51,    73,    75,    40,    53,    64,   110,    72,    31,    70,
      76,    96,    58,    19,    20,    59,    21,    60,    22,    61,
     106,    82,    99,    43,    69,    30,    52,    78,    79,    12,
      54,    86,    18,    65,    66,    68,    91,    92,    93,   115,
      94,   127,    49,   124,   103,   104,   121,   105,   122,    16,
     107,    62,    23,   118,   117,   119,    89,    55,    90,    77,
      97,   116,    34,   120,    25,    26,    28,    29,    27,    67,
      36,    74,    39,    95,   123,   113,   109,   128,   126,    11,
     134,   111,    83,    14,    15,   100,    13,    32,    57,    17,
      42,    41,    56,    48,   130,    44,  1519,   102,   114,   101,
      84,   108,    87,   112,   129,    85,   125,  1620,  1619,  1680,
    1623,  1655,     0,  1635,  1421,  1420,  1435,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   642,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1432,  2272,  2289,  2290,  2291,  2292,  2293,
    2294,  2295,  2296,  2297,  2298,  2299,  2300,  2301,  2302,  2304,
    2303,  2305,  2306,  2646,  2307,  2308,  2309,  2595,  2596,  2647,
    2597,  2598,  2310,  2311,  2312,  2313,  2314,  2315,  2316,  2317,
    2318,  2599,  2600,  2319,  2320,  2321,  2322,  2323,  2601,  2648,
    2324,  2325,  2326,  2327,  2328,  2329,  2649,  2330,  2331,  2332,
    2333,  2334,  2335,  2336,  2337,  2338,  2650,  2339,  2340,  2341,
    2651,  2342,  2343,  2344,  2345,  2346,  2347,  2602,  2603,  2348,
    2349,  2350,  2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,
    2359,  2360,  2361,  2362,  2363,  2364,  2365,  2366,  2367,  2368,
    2369,  2370,  2371,  2372,  2373,  2374,  2375,  2604,  2376,  2377,
    2378,  2379,  2605,  2380,  2381,  2382,  2383,  2606,  2384,  2385,
    2386,  2652,  2653,  2387,  2388,  2389,  2390,  2391,  2607,  2608,
    2392,  2393,  2394,  2395,  2396,  2397,  2398,  2654,  2399,  2400,
    2401,  2402,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,
    2655,  2609,  2411,  2412,  2413,  2414,  2610,  2611,  2612,  2415,
    2656,  2657,  2416,  2658,  2417,  2418,  2419,  2420,  2421,  2422,
    2613,  2659,  2423,  2660,  2424,  2425,  2426,  2427,  2428,  2429,
    2430,  2431,  2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,
    2440,  2441,  2442,  2614,  2661,  2615,  2443,  2444,  2445,  2446,
    2447,  2448,  2449,  2616,  2617,  2450,  2451,  2452,  2662,  2453,
    2618,  2454,  2619,  2455,  2456,  2457,  2458,  2459,  2460,  2461,
    2462,  2463,  2464,  2620,  2663,  2465,  2664,  2621,  2466,  2467,
    2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,  2476,  2622,
    2477,  2623,  2480,  2478,  2479,  2481,  2482,  2483,  2484,  2485,
    2486,  2487,  2488,  2489,  2490,  2624,  2491,  2492,  2493,  2494,
    2495,  2496,  2497,  2498,  2499,  2500,  2501,  2502,  2503,  2504,
    2505,  2506,  2507,  2508,  2509,  2665,  2510,  2511,  2512,  2513,
    2514,  2625,  2515,  2516,  2517,  2518,  2519,  2520,  2521,  2522,
    2523,  2524,  2525,  2526,  2527,  2528,  2529,  2530,  2626,  2531,
    2532,  2666,  2533,  2534,  2627,  2535,  2536,  2537,  2538,  2539,
    2540,  2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,  2628,
    2549,  2550,  2551,  2552,  2667,  2553,  2554,  2555,  2556,  2557,
    2558,  2629,  2630,  2559,  2560,  2631,  2561,  2632,  2562,  2563,
    2564,  2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,  2573,
    2574,  2575,  2576,  2577,  2578,  2579,  2633,  2634,  2580,  2668,
    2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2635,  2636,  2637,  2638,  2639,  2640,  2641,  2642,  2643,
    2644,  2645,  2592,  2593,  2594,   136,     0,     0,  2239,  2273,
    2274,  2277,  2272,   400,   399,  1609,  2236,  2273,  1518,     0,
    1498,   643,     0,  1435,   427,  1656,     0,     0,     0,     0,
       0,     0,   859,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   184,     0,     0,     0,     0,
     451,   450,     0,     0,  1054,   456,     0,     0,     0,     0,
       0,   633,  1558,  2478,  1556,  1610,   266,   269,   270,   267,
     268,  2255,     0,  1200,  1201,  1203,     0,     0,  1213,   899,
     900,     0,     0,     0,   913,     0,     0,     0,   897,     0,
       0,     0,   919,     0,   916,     0,     0,   920,   917,   894,
     918,   901,     0,   893,     0,     0,  1213,   921,     0,     0,
     895,     0,     0,     0,     0,  1435,  1555,   457,  1656,     0,
    1540,  1541,  1542,  1519,  1531,  1543,  1536,  1538,  1537,  1539,
    1535,  2254,  2290,   989,   989,   989,   989,   986,   987,   989,
     989,   989,  2498,     0,     0,   968,     0,   970,  2256,   989,
     994,   525,   525,   525,     0,   993,   998,   525,     0,  1403,
    1444,  2238,  1668,     0,   969,  1402,     0,     0,     0,  2559,
    1546,     0,     0,  1228,  1224,  1226,  1227,  1225,     0,  1057,
    1057,  2517,  1412,   248,  2528,  2629,  2559,   247,   241,   243,
     215,  2294,     0,     0,   993,     0,  1435,  1410,   965,  1675,
    1673,     0,  2223,  2317,  2333,  2426,   238,  2510,  2518,  2528,
    2629,  2559,  2591,   194,   204,   199,     0,   259,  2528,  2629,
    2559,   255,  1432,     0,  1636,  1783,  2232,     0,  1405,  1404,
    1520,     0,  1523,     0,  2493,  1640,  1643,  1525,  1641,  2275,
    1858,  1887,  1865,  1887,  1887,  1854,  1854,  2363,  1867,  1855,
    1856,  1892,     0,  1887,  1854,  1859,     0,  1857,  1895,  1895,
    1882,     3,  1839,  1840,  1841,  1842,  1868,  1869,  1843,  1874,
    1875,  1879,  1844,  1909,  1854,  2276,  1677,  1678,  2223,     4,
    2269,     5,  2218,  2268,     6,     7,  1632,     0,     0,     1,
    1656,     0,  1530,  1672,  1672,     0,  1672,     0,  1624,  1632,
    1627,  1631,     0,     0,     0,     0,     0,  1406,     0,     0,
       0,   924,     0,  1447,  1039,     0,     0,     0,     0,     0,
    1297,     0,  1097,  1096,  2278,  2261,  2262,  2263,     0,  2259,
    2260,  2279,  2280,  2281,     0,  2398,  1297,     0,     0,  2134,
    2145,  2146,  2147,  2321,  2380,  2142,  2143,  2144,  2136,  2137,
    2138,  2139,  2140,  2141,     0,     0,  1195,  2135,     0,  2398,
       0,  1297,     0,   163,     0,   140,  1297,     0,     0,  2398,
       0,     0,  2398,     0,     0,     0,     0,     0,  2398,     0,
       0,     0,     0,     0,   163,  2431,     0,   140,  2398,     0,
       0,  1426,     0,     0,     0,  1428,  1431,  1418,     0,  2215,
       0,  2216,  2240,     0,  1512,  1506,  1515,  1511,  1501,     0,
    2232,     0,     0,     0,     0,   907,     0,     0,   897,     0,
       0,     0,   908,     0,   909,   910,     0,     0,     0,     0,
     906,     0,  1416,  1408,     0,  1548,  1550,  1549,  1547,   525,
       0,     0,     0,  2398,     0,   140,  1485,     0,  2398,   140,
       0,     0,   455,   454,   140,  2259,   453,   452,  2321,  2380,
       0,  1087,     0,  1362,   140,  2398,     0,   186,  2398,   702,
    2398,  1525,     0,   646,     0,   814,  2431,   140,     0,     0,
       0,     0,     0,     0,  1057,     0,     0,     0,     0,     0,
       0,     0,   632,   643,  1559,  1557,     0,  1204,   240,   239,
    1202,   911,  2398,  1129,   361,     0,     0,  2398,  1466,  2398,
     361,   928,   912,     0,   898,  2398,   361,  1093,  2398,  2264,
     173,     0,   896,  2321,  2380,  2398,   361,  1197,     0,  2398,
     361,  2398,   169,  2398,   361,  2398,   361,  2398,   647,     0,
       0,  2398,   361,  2398,  2431,   171,   915,  2398,   361,   922,
    2398,   361,  2234,  2398,     0,  1419,     0,  1551,     0,  1533,
    2633,     0,  1656,   989,   988,     0,   989,     0,   989,     0,
     989,     0,   989,     0,     0,     0,   989,  2257,  2258,   971,
       0,   995,     0,     0,  1002,  1001,  1000,     0,     0,     0,
    1003,     0,  1787,  1586,     0,  1400,   242,   193,     0,   254,
     253,  1415,     0,     0,     0,  1057,     0,  1056,     0,     0,
    1411,   246,   244,     0,     0,     0,     0,     0,     0,  1417,
       0,  1409,     0,     0,     0,  2242,  2244,  2245,  2148,  2218,
       0,  2596,  2597,  2598,  2207,     0,  2599,  2600,  2601,  2648,
    2038,  2025,  2034,  2039,  2026,  2028,  2035,  2602,  2603,  1976,
    2604,  2605,  2252,  2606,  2607,  2608,  2610,  2611,  2612,  2613,
    2030,  2032,  2614,  2615,  2617,     0,  2253,  2618,  2619,  2460,
    2621,  2622,  2624,  2625,  2036,  2627,  2628,  2629,  2630,  2631,
    2632,  2251,     0,  2037,  2634,  2636,  2637,  2638,  2639,  2641,
    2642,  2643,  2644,     0,     0,     0,  2229,     0,  2005,     0,
    1847,  1848,  1870,  1871,  1849,  1876,  1877,  1850,     0,  2228,
    1912,  2093,  2004,  2021,     0,  2010,  2011,     0,  2003,  1999,
    1658,  2224,     0,  2000,  2241,  2243,  2208,  1658,  2222,   207,
     261,     0,   262,  2230,  2528,   195,   237,   209,   236,   210,
     208,     0,  2319,   196,     0,     0,   197,     0,     0,     0,
       0,   258,   256,     0,  1407,     0,  1785,  1784,  2233,   933,
       0,  1522,  1519,  2158,     0,  1642,     0,     0,     0,  1886,
    1873,  1881,  1880,     0,  1863,  1862,  1861,     0,  1860,  1887,
    1887,  1885,  1864,  1839,     0,     0,     0,  1891,     0,  1889,
    1835,  1831,     0,  1898,  1899,  1900,  1897,  1910,  1896,     0,
    1845,  1901,     0,  1854,  1851,  1743,     0,  1622,  1621,     8,
       0,  1527,  1529,  1504,  1525,  1670,  1671,     0,     0,     0,
       0,     0,     0,     0,     0,  1730,  1688,  1689,  1691,  1727,
    1731,  1739,     0,  1628,     0,     0,  1789,     0,     0,  1433,
       0,     0,     0,     0,     0,  1128,     0,     0,     0,     0,
     925,     0,     0,     0,  1453,     0,  1455,  1456,  1457,     0,
       0,     0,  1458,  1459,  1447,   250,  1465,  1463,  1446,  1448,
    1461,     0,     0,     0,     0,     0,     0,     0,  1477,     0,
     177,   178,     0,   659,   643,     0,  2398,     0,     0,     0,
       0,  1138,  1145,  1296,     0,     0,     0,     0,     0,     0,
       0,     0,  1139,  1137,     0,  1140,   252,  1150,  1177,  1180,
       0,     0,  1095,  1098,     0,     0,     0,     0,     0,  1287,
       0,     0,     0,  1287,     0,     0,     0,  1296,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   277,   279,   292,
     356,     0,   624,     0,     0,     0,   627,     0,  2398,  1297,
       0,     0,     0,  1199,     0,     0,     0,     0,     0,     0,
       0,     0,  1180,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   138,   139,   144,     0,     0,     0,     0,  1180,
       0,     0,     0,     0,     0,     0,     0,   610,   623,     0,
       0,     0,     0,     0,   620,     0,     0,   140,   282,   600,
     606,     0,     0,     0,   709,   708,     0,     0,     0,     0,
       0,     0,  1377,     0,  1376,     0,     0,     0,     0,  1475,
    1474,     0,     0,     0,     0,     0,  1287,     0,   271,   273,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   392,   393,     0,     0,     0,
     144,     0,     0,  1287,     0,   284,     0,     0,  1427,  1424,
    1425,     0,  1430,     0,     0,     0,     0,  2013,     0,  2162,
    1680,  2160,  1113,  2214,     0,  2282,  2669,  2670,  2671,  2672,
    2673,  2674,  2675,  2676,  2677,  2678,  2679,  2680,  2681,  2682,
    2683,  2684,  2685,  2686,  2687,  2688,  2689,  2690,  2691,  2692,
    2693,  2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,  2702,
    2703,  2704,  2705,  2706,  2707,  2708,  2709,  2710,  2711,  2712,
    2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,  2721,  2722,
    2723,  2724,  2725,  2726,  2727,  2728,  2729,  2730,  2731,  2732,
    2733,  2734,  2735,  2736,  2737,  2738,  2739,  2740,  2741,  2742,
    2743,  2744,  2745,  2211,  2210,  2237,  2283,  2284,  2285,  2286,
    2217,     0,     0,   226,   227,   225,  1513,   228,  1514,  1510,
       0,  1496,     0,     0,     0,     0,     0,     0,     0,     0,
    2321,  2380,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   822,  1447,
    1484,     0,     0,     0,   652,     0,  2398,     0,   142,   860,
       0,   812,   456,     0,     0,     0,  1170,  1361,   142,     0,
       0,   180,     0,     0,   706,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   813,     0,     0,   142,     0,
    2398,   603,  2398,     0,   525,   525,     0,     0,  1059,     0,
       0,     0,     0,     0,     0,     0,     0,  1614,  1613,  1616,
    1615,     0,  1612,     0,   359,   360,     0,  1187,  1212,     0,
       0,     0,     0,     0,   889,   914,     0,     0,  1181,     0,
       0,  2398,   361,  2398,     0,  2398,     0,     0,     0,  1189,
     361,     0,  1183,     0,     0,  1185,     0,  1378,     0,   905,
     903,   902,   904,     0,     0,   887,     0,     0,     0,     0,
       0,   882,     0,     0,   884,     0,     0,     0,     0,  1656,
    1532,     0,   979,     0,   983,     0,   974,     0,   980,     0,
     975,   972,   973,     0,   978,     0,     0,   526,   528,     0,
       0,  2345,  2362,     0,  2387,  2419,  2420,  2484,  2513,  2518,
    2524,     0,  2553,  2564,     0,  1004,  1034,   999,   718,     0,
       0,  1596,  1401,  2167,     0,  1656,     0,     0,     0,  1220,
    1221,   245,   216,     0,     0,     0,  1036,  2517,  1414,   964,
     643,     0,  2001,     0,  2008,  2009,  2206,     0,     0,     0,
       0,     0,     0,  2007,     0,     0,     0,     0,     0,     0,
       0,  1934,     0,     0,  2166,     0,     0,  2166,     0,     0,
    1969,     0,     0,     0,     0,     0,     0,     0,     0,  1935,
    1916,  1917,  2005,  2158,     0,  2006,  2248,     0,  1909,  2287,
    2148,     0,  2145,  2146,  2147,  2746,  2747,  2748,  2749,  2750,
    2751,  2752,  2753,  2754,  2755,  2756,  2757,  2758,  2759,  2760,
    2761,     0,  2762,  2763,  2764,  2765,  2766,  2768,  2767,  2769,
    2770,  2771,  2772,  2773,  2774,  2221,  2776,  2777,  2778,  2779,
    2780,  2781,  2782,  2783,  2784,  2785,  2786,  2787,  2788,  2789,
    2790,  2791,  2792,  2793,  2794,  2795,  2796,  2797,  2798,  2799,
    2800,  2801,  2802,  2803,  2804,  2805,  2806,  2807,  2808,  2809,
    2810,  2811,  2812,  2813,  2814,  2815,  2816,  2817,  2818,  2819,
    2820,  2821,  2822,  2823,  2824,  2825,  2826,  2827,  2828,  2829,
    2830,  2831,  2832,  2833,  2834,  2835,  2836,  2837,  2838,  2839,
    2840,  2841,  2842,  2843,  2844,  2845,  2846,  2847,  2848,  2849,
    2850,  2851,  2852,  2853,  2854,  2855,  2856,  2857,  2858,  2859,
    2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,  2868,  2869,
    2870,  2871,  2872,  2873,  2874,  2875,  2876,  2877,  2878,  2879,
    2880,  2881,  2882,  2883,  2884,  2885,  2886,  2887,  2888,  2889,
    2890,  2891,  2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,
    2900,  2901,  2902,  2903,  2904,  2905,  2906,  2907,  2908,  2909,
    2910,  2911,  2912,  2913,  2914,  2915,  2916,  2917,  2918,  2919,
    2920,  2921,  2922,  2923,  2924,  2925,  2926,  2927,  1949,  2928,
    2929,  2930,  2931,  2932,  2933,  2934,  2935,  2936,  2937,  2938,
    2939,  2940,  2941,  2942,  2943,  2944,  2945,  2946,  2947,  2948,
    2949,  2950,  2951,  2952,  2953,  2954,  2955,  2956,  2957,  2958,
    2959,  2960,  2961,  2962,  2963,  2964,  2965,  2966,  2967,  2968,
    2969,  2970,  2971,  2972,  2973,  2974,  2975,  2976,  1951,  2977,
    2978,  2979,  2980,  2981,  2982,  2983,  2984,  2985,  2986,  2987,
    2988,  2989,  2990,  2991,  2992,  2993,  2994,  2995,  2996,  2997,
    2998,  2999,  3000,  3001,  3002,  3003,  3004,  3005,  3006,  3007,
    3008,  3009,  3010,  3013,  3011,  3012,  3014,  3015,  3016,  3017,
    3018,  3019,  3020,  3021,  3022,  3023,  3024,  3025,  3026,  3027,
    3028,  3029,  3030,  3031,  3032,  3033,  3034,  3035,  3036,  3037,
    3038,  3039,  3040,  3041,  3042,  3043,  3044,  3045,  3046,  3047,
    3048,  3049,  3050,  3051,  3052,  3053,  3054,  3055,  3056,  3057,
    3058,  3059,  3060,  3061,  3062,  3063,  3064,  3065,  3066,  3067,
    3068,  3070,  3069,  3071,  3072,  3073,  3074,  3075,  3076,  3077,
    3078,  3079,  3080,  3081,  3082,  3083,  3084,  3085,  3086,  3087,
    3088,  3089,  3090,  3091,  3092,  3093,  3094,  3095,  3096,  3097,
    3098,  3099,  3100,  3101,  3102,  3103,  3104,  3105,  3106,  3107,
    3108,  3109,  3110,  3111,  3112,  3113,  3114,  3115,  3116,  3117,
    3118,  3119,  3120,  3121,  3122,  3123,  3124,  3125,  3126,  3127,
    3128,  3129,  3130,  3131,  3132,  3133,  3134,  3135,  3136,  3137,
    3138,  3139,  3140,  3141,  3142,  3143,  3144,  3145,  3146,  3147,
    3148,  3149,  3150,  3151,  3152,  3153,  3154,  3155,  3156,  3157,
    3158,  3159,  3160,  3161,  3162,  3163,     0,  2142,  2143,  2144,
    2136,  2137,  2138,  2139,  2140,  2141,  2152,     0,     0,  2227,
    2288,     0,  2095,     0,  1931,     0,     0,  1743,     0,  2246,
    2209,  1743,   263,   264,   260,     0,     0,   212,   211,     0,
     230,   234,   235,   206,   233,     0,   229,   214,  2082,  2081,
     213,   205,   202,   200,   217,   219,   220,   203,   201,   257,
       0,     0,     0,   361,  1530,  1517,     0,     0,  2221,     0,
    2156,     0,     0,  2154,     0,     0,     0,  1740,     0,  1644,
       0,  1648,     0,     0,     0,  1884,  1883,  1836,  1832,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   926,     0,  1852,     0,  1805,  2270,  2271,  2219,
    1676,  1530,     0,  1526,  1639,  1638,  1681,  1682,  1079,  1637,
    1710,  1711,     0,     0,     0,     0,  1736,  1734,  1701,  1692,
    1700,     0,     0,  1698,     0,  1702,  1912,  1729,  1626,  1686,
    1687,  1690,  1625,     0,  1732,     0,  1599,  1730,  1691,  1583,
       0,  1561,     0,  1790,     0,     0,  1434,     0,     0,     0,
    1108,  1110,     0,  1109,     0,  1112,     0,  1121,     0,     0,
    1107,  1126,     0,  1115,  1113,     0,  1473,     0,     0,     0,
       0,     0,  1454,     0,     0,  2553,   249,  1457,  1462,  1449,
    1460,     0,     0,     0,     0,     0,  1038,  1037,     0,     0,
    1061,     0,     0,     0,  1480,   514,     0,   358,     0,     0,
       0,     0,     0,     0,     0,     0,   808,   805,     0,     0,
     804,     0,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   682,     0,  1287,     0,   290,     0,
    1147,     0,  1146,     0,  1151,     0,     0,  1148,  1143,  1144,
    2518,  2528,  2559,   251,  1149,  1179,     0,  1178,  1174,     0,
    1090,     0,  1091,     0,     0,     0,     0,     0,  2372,  2398,
     298,   321,     0,  1286,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   343,
       0,     0,   346,   345,     0,     0,     0,     0,     0,   350,
     329,     0,   330,     0,   349,     0,     0,     0,   625,   626,
       0,     0,     0,  1287,     0,   286,     0,     0,     0,     0,
       0,     0,     0,     0,  1196,     0,   735,     0,     0,  2518,
    1175,     0,     0,     0,     0,     0,     0,  1365,     0,     0,
     166,     0,   161,   165,     0,     0,  2518,  1176,     0,     0,
       0,     0,     0,   608,   609,   622,     0,   613,   614,   611,
     615,   616,     0,     0,     0,     0,     0,     0,     0,   607,
       0,     0,   704,   703,   707,     0,     0,     0,     0,     0,
       0,  1371,     0,     0,  1170,     0,     0,  1370,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1230,  1229,
       0,     0,     0,     0,  1297,     0,   850,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   168,   722,     0,   721,
       0,   162,   167,     0,     0,     0,     0,     0,     0,     0,
       0,   224,  1423,  1429,  1680,  1680,  1680,  2019,     0,     0,
       0,     0,  1679,  2212,  2215,  1501,  1507,  1500,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   406,   403,   404,   406,
       0,     0,     0,     0,   824,     0,   827,   830,  1445,   479,
       0,     0,   649,   682,     0,     0,   459,   175,     0,     0,
       0,     0,   737,     0,     0,     0,  1360,   137,   184,   186,
     457,     0,   185,   187,   189,   190,   191,   188,   192,     0,
     701,   705,     0,     0,     0,     0,   645,     0,     0,     0,
       0,     0,     0,     0,  1810,     0,     0,   160,     0,     0,
     598,   602,     0,     0,     0,     0,   459,   564,   372,  2398,
       0,   525,     0,  2398,     0,  1058,     0,   811,     0,     0,
       0,  1132,  1132,     0,     0,   751,   750,     0,     0,     0,
       0,     0,     0,  1611,   361,  1130,     0,  1467,     0,   361,
     929,   361,  1094,   174,  2265,     0,   891,     0,     0,     0,
       0,   361,  1198,   879,   361,   170,   361,   361,   648,     0,
     361,   172,     0,     0,   361,   923,   361,  2235,     0,   361,
    1554,  2398,   525,  1534,   976,   985,   984,   982,   981,   977,
       0,   996,     0,   524,     0,     0,     0,     0,     0,  1012,
    1013,     0,     0,  1009,  1014,     0,  1010,  1011,  1016,  1006,
    1005,  1017,  1018,     0,     0,  1036,   716,     0,     0,     0,
       0,  1593,     0,  1591,     0,  1788,  1595,  1584,  1545,     0,
    1544,     0,   591,  1057,  1057,     0,     0,   993,     0,     0,
     361,  1413,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2171,     0,  2172,     0,     0,  2205,  2201,
       0,     0,     0,     0,     0,  2175,  2178,  2179,  2180,  2177,
    2181,  2176,     0,     0,  2182,     0,     0,     0,     0,     0,
       0,     0,     0,  2162,  2165,     0,     0,  2625,     0,     0,
       0,     0,  1977,     0,     0,  2129,     0,  2162,     0,     0,
       0,     0,     0,     0,     0,  2158,  2197,     0,     0,     0,
       0,  2080,     0,  2077,     0,     0,     0,     0,  2218,     0,
       0,  2249,  1913,  1927,  1928,  1929,  1932,  2226,     0,  2220,
       0,     0,  1914,  1940,     0,  2198,  1965,     0,  1970,  1955,
    2183,  2184,  2185,  2186,  1972,     0,  1948,  1953,  1957,     0,
    1936,     0,  1933,     0,  2221,  2157,     0,  2155,     0,  1924,
    1925,  1926,  1918,  1919,  1920,  1921,  1922,  1923,  1930,  2133,
    2131,  2132,     0,     0,     0,  2103,     0,     0,  1952,  2390,
    2426,     0,  1669,  1669,  1669,  1657,  1667,  2225,  1805,  1680,
    1805,  2231,     0,     0,  1909,     0,  1786,   931,   932,   930,
    1503,  1516,  1530,  2159,  1524,  1646,     0,     0,     0,  1853,
    1866,     0,  1894,  1893,  1895,  1895,     0,  1837,     0,  1878,
    1903,  1904,  1905,  1906,  1907,  1908,     0,  1902,  1846,   927,
       0,  2515,  2645,     0,  1767,  1742,  1744,  1754,  1767,  1774,
    1767,  2022,  1803,  2023,  2232,     0,  1713,  2267,  1505,  1528,
       0,  1077,  1078,     0,  1082,  2625,  2515,     0,     0,     0,
       0,  1703,  1737,     0,  1728,     0,  2242,  1704,  2241,  1705,
    1708,  1709,  1699,  1738,  1597,     0,  1733,  1630,  1629,     0,
    1808,     0,     0,     0,  1575,  1563,     0,  1791,     0,  1743,
    1601,     0,  2218,  1741,  1336,  1231,  1298,  1111,     0,  1854,
    1122,     0,  1106,     0,  1105,  1854,     0,  1123,     0,  1854,
    1337,  1232,  1299,  1338,  1233,  1300,  1339,  1234,  1464,  1452,
    1451,  1450,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   789,  2398,   361,  1478,
    1340,     0,  1235,   357,  1479,  1301,  1483,   807,   806,     0,
       0,  1302,     0,   658,   663,     0,   665,   666,  2321,  2380,
     667,   670,   671,     0,   673,   662,   661,     0,     0,     0,
       0,     0,   679,   684,     0,     0,     0,     0,     0,     0,
    1141,  1142,  1341,  1238,     0,  1303,     0,  1089,     0,  1239,
     176,     0,     0,   278,  2398,   300,     0,   477,   789,     0,
    1289,   297,   327,     0,   342,   337,   338,   336,  2398,   361,
    2398,   361,     0,     0,     0,     0,     0,   339,   334,   335,
     331,     0,     0,   344,  2293,  2364,  2529,     0,   690,   692,
       0,   697,   347,  1259,   368,   367,   366,     0,   351,     0,
     373,   376,   348,   328,   326,   323,   293,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1191,     0,
    1344,  1304,     0,  1326,     0,     0,     0,     0,   729,  1347,
    1245,  1307,     0,  1366,  1368,  1358,  1246,  1367,   164,  1276,
     153,     0,     0,   149,     0,     0,     0,     0,   143,  1348,
    1247,  1308,     0,     0,  1349,  1248,     0,     0,   283,   601,
     612,   617,  1253,   621,   618,  1316,   619,  1356,  1249,     0,
    1352,  1279,  1311,   584,  1170,  1170,  1359,  1372,  1250,  1170,
       0,  1287,     0,   272,   274,     0,  1057,     0,  1251,     0,
    1309,  1351,  1278,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1486,     0,     0,     0,     0,     0,     0,   361,
       0,     0,     0,  1289,  2398,   361,  1350,     0,  1284,     0,
    1324,     0,     0,   394,     0,  1277,  1287,     0,   285,  1255,
       0,  1318,     0,     0,   222,   221,   223,     0,     0,     0,
       0,  2163,  2164,     0,  2161,  2014,  2214,     0,  1497,   953,
     939,   952,     0,   935,  2362,     0,   938,   940,     0,     0,
       0,   941,   945,   946,     0,   937,   934,   936,     0,   405,
       0,     0,   746,   747,     0,     0,     0,     0,   826,     0,
       0,  1476,     0,   140,   656,     0,     0,     0,   651,   681,
     686,     0,     0,     0,     0,   458,   462,   466,   467,   468,
       0,     0,     0,     0,   154,   141,     0,   868,     0,   525,
       0,   739,  1364,  1363,  1169,     0,   186,   179,     0,     0,
     702,     0,  1525,     0,     0,   579,   582,   581,     0,   372,
     821,   819,   818,   820,   842,   817,     0,  1809,  1811,     0,
       0,     0,     0,     0,     0,   591,   461,     0,     0,   528,
       0,   567,     0,     0,     0,     0,   564,     0,     0,     0,
    2275,     0,   838,   810,     0,  1100,     0,  1118,  1101,     0,
       0,     0,     0,  1155,  1162,  1131,  1156,  1133,  1162,     0,
       0,   752,   756,   755,   759,   757,     0,   753,   630,  1617,
    1618,     0,  1188,     0,     0,  1472,     0,  1470,   890,  1182,
     361,     0,   361,     0,   361,  1190,  1184,  1186,  1379,     0,
     888,     0,     0,   881,   883,     0,   885,     0,   997,   527,
       0,     0,     0,     0,     0,     0,  1008,   628,  1015,     0,
    1029,  1024,  1026,     0,  1030,   715,     0,     0,  1594,  1587,
    1589,  1588,     0,     0,  1585,  2168,   880,     0,   597,     0,
       0,     0,     0,  1036,     0,  1031,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1674,  2169,  2170,     0,
       0,     0,  2202,     0,     0,  2055,     0,  2027,  2029,  2041,
       0,  2056,  2012,  2057,  2031,  2033,  2042,     0,     0,  2149,
       0,  2045,  2044,     0,  1979,  1980,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1994,  2046,  2128,     0,     0,     0,
    2048,  2047,     0,     0,  2196,     0,     0,     0,  2053,  2058,
       0,     0,     0,     0,  2064,     0,  2085,     0,     0,     0,
    2002,  2159,     0,     0,     0,     0,     0,     0,     0,     0,
    1971,  1956,  1974,  1950,  1954,  1958,     0,  1973,     0,     0,
    1944,     0,     0,  1942,  1966,  1938,     0,     0,  1967,     0,
       0,     0,  2020,     0,     0,  1669,  1669,  1669,  1669,  1666,
       0,     0,     0,  1713,     0,  1713,   198,     0,   231,   218,
    1502,  1647,  1656,  1872,     0,  1890,  1888,  1833,  1838,  1911,
    1767,  1774,  1767,     0,     0,  1632,     0,  1754,     0,  1766,
    1752,  1765,     0,     0,  1780,  1778,     0,  1780,     0,  1780,
       0,  1746,     0,  1770,  1748,  1765,  1750,     0,  1795,  2233,
    1804,     0,  1726,  1683,     0,  2150,  1082,     0,  1685,  1707,
    1706,     0,  1696,     0,  1735,  1693,  1598,  1582,     0,  1580,
    1567,  1569,  1568,     0,     0,  1570,  2218,     0,  1580,  1562,
    1606,     0,     0,  1808,     0,  1605,     0,  1854,  1103,  1104,
       0,  1127,     0,  1041,  1042,     0,  1040,     0,     0,     0,
     513,  1060,     0,     0,     0,   789,     0,     0,   517,     0,
    1481,     0,  1357,  1275,   660,     0,     0,     0,     0,   675,
     634,   676,   678,     0,     0,   677,   680,   683,  1287,     0,
     291,  1261,     0,  1322,  1135,     0,     0,  1092,     0,     0,
       0,     0,     0,     0,   476,   686,   322,     0,     0,     0,
       0,   381,     0,   302,   314,   379,   320,     0,   353,     0,
     325,     0,   318,   340,   332,   341,   333,   352,   354,     0,
     694,   695,   693,   689,     0,   696,   698,     0,   370,     0,
       0,     0,     0,  1343,     0,  1287,     0,   287,  1257,     0,
    1320,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1325,     0,     0,     0,     0,   734,     0,
     731,     0,     0,     0,   146,   145,     0,   152,     0,     0,
       0,     0,     0,     0,  1373,  1374,  1375,     0,     0,     0,
       0,     0,     0,   388,     0,   294,   296,   295,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   395,   363,     0,   845,     0,
       0,     0,   397,     0,     0,  1335,     0,     0,     0,     0,
       0,  1342,  1240,  2017,  2018,  2015,  1680,  2213,     0,     0,
       0,   950,     0,     0,     0,     0,   408,   409,   140,   407,
     430,     0,   789,     0,     0,   823,   828,   836,  2460,  2136,
    2137,   834,   829,   831,   833,   835,   832,     0,     0,     0,
       0,   495,     0,     0,     0,   485,     0,     0,  1170,   478,
     481,   482,     0,     0,   652,   655,   653,   654,     0,   674,
       0,   461,   502,   554,     0,   156,     0,     0,   157,   155,
       0,     0,   372,   736,     0,   733,     0,   182,     0,   706,
       0,     0,     0,     0,     0,  1170,   644,     0,   841,   843,
     815,     0,   686,     0,     0,   603,     0,   525,  1555,   586,
       0,   556,   461,   554,   563,     0,     0,   571,   371,     0,
       0,   591,   372,     0,     0,  1061,     0,   837,     0,     0,
    1099,     0,     0,     0,  1152,  1157,  1153,     0,  1132,  1114,
       0,  1154,     0,     0,  1160,  1085,  1134,  1086,  1395,  1396,
    1393,  1394,     0,     0,     0,     0,     0,     0,  1608,     0,
       0,  1468,     0,   892,     0,   875,     0,   877,   361,   723,
       0,   361,     0,     0,     0,     0,     0,     0,  1007,     0,
    1027,     0,     0,  1036,  1033,     0,     0,  1592,  1590,   589,
       0,  1222,  1223,  1036,     0,   361,  1035,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2173,     0,  2204,
    2200,     0,  2024,  2174,     0,     0,     0,  2129,     0,     0,
    1978,  1990,  1991,  1992,  2189,     0,  1997,     0,  1987,  1988,
    1989,  1981,  1982,  1983,  1984,  1985,  1986,  1993,  2193,  2192,
       0,     0,  2050,  2051,  2052,  2195,  2059,     0,  2311,  2086,
       0,  2063,  2079,  2078,     0,     0,     0,  2066,     0,     0,
    2075,     0,  2130,  2250,  1915,     0,     0,  1941,  2199,  1959,
       0,  1975,  1937,  2149,     0,     0,     0,     0,     0,  1946,
       0,     0,     0,  2106,  2101,  2102,  2126,     0,     0,     0,
       0,     0,     0,  1660,  1659,  1665,  1726,  2014,  1726,     0,
       0,  1834,  1753,  1749,  1751,     0,  2640,     0,  1756,  1763,
       0,  1745,     0,  1779,  1775,     0,  1776,     0,     0,  1777,
       0,     0,  1747,     0,  1763,     0,  1802,  1672,     0,  2097,
       0,  1684,  1080,  1081,  1694,     0,  1697,  2341,  1806,     0,
    1581,     0,     0,     0,  1572,  1578,  1560,     0,     0,  1602,
    1580,  1603,  1124,     0,     0,  1116,  1047,  1048,  1051,  1049,
    1046,  1050,     0,     0,     0,   789,     0,     0,   535,     0,
    1074,  1074,     0,     0,   519,   576,   530,   792,     0,     0,
       0,   790,   361,  1236,     0,     0,     0,     0,   635,  1355,
    1237,     0,     0,     0,     0,  1136,  1290,     0,     0,  1260,
       0,   299,   475,   474,   479,     0,     0,   305,   315,     0,
     310,     0,  1288,     0,     0,     0,     0,   309,   312,   383,
       0,   380,     0,   361,   361,   355,   691,   369,   374,   375,
     378,  1295,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   869,   852,     0,     0,   870,
     871,     0,     0,     0,  1193,  1194,  1192,  1327,  1328,  1333,
    1330,  1329,  1332,  1334,  1331,     0,  1243,     0,     0,   727,
    1291,   150,   147,   148,   151,  1292,  1273,  1254,  1317,   585,
       0,     0,     0,  1252,     0,  1310,     0,  1269,  1263,     0,
       0,     0,     0,     0,  1354,  1283,  1315,  1353,  1281,  1313,
    1280,  1312,  1282,  1314,  1274,     0,     0,  1813,   849,     0,
       0,     0,   361,   361,   848,   725,  1256,     0,  1319,  1265,
       0,     0,     0,   942,     0,     0,     0,   944,   413,   431,
     140,     0,   745,   809,     0,     0,   825,     0,   483,     0,
     489,   493,     0,     0,   497,   498,   496,   484,  1170,   525,
     575,   778,   779,     0,     0,   799,     0,   650,     0,     0,
     459,     0,   499,     0,     0,   463,   159,   158,     0,     0,
       0,   740,   744,   742,   741,   743,   738,     0,   729,   186,
    2398,     0,     0,     0,     0,   583,   577,   580,  1369,   816,
       0,  1812,   719,     0,   372,   599,     0,     0,     0,   459,
     591,     0,   464,   469,   470,   479,     0,   564,   555,     0,
     556,   565,   566,     0,   573,  1443,     0,   592,   573,     0,
       0,     0,   840,     0,   839,     0,  1102,  1119,  1120,     0,
       0,  1162,     0,     0,  1164,  1159,     0,     0,   758,   761,
     754,   637,   361,     0,  1471,   361,   361,  1219,     0,   886,
    1021,  1022,  1023,  1020,  1019,   629,     0,  1025,   990,   717,
       0,   590,   361,     0,   991,   967,   959,   966,   955,   958,
     960,     0,   962,   963,   957,   954,   956,  2203,  2040,  2043,
    2054,     0,  2128,  2159,     0,     0,  1998,     0,     0,     0,
    2049,  2635,     0,     0,  2090,  2091,     0,  2087,  2088,  2083,
    2084,  2065,     0,  2449,  2070,     0,     0,     0,  1963,  1961,
    1960,  1945,     0,     0,  1943,  1939,     0,  1968,  2092,     0,
    2108,  2105,  2125,  2159,  1664,  1663,  1662,  1661,  2097,  2247,
    2097,   232,  1651,  1798,     0,  1801,     0,     0,  1755,     0,
       0,  1757,     0,     0,  1759,  1761,     0,     0,     0,     0,
       0,     0,  2236,     0,  1725,     0,  1680,     0,  1695,     0,
    1579,  1564,     0,  1565,  1571,     0,     0,     0,     0,  1607,
    1600,  1117,  1125,     0,     0,     0,   515,     0,   530,     0,
       0,     0,  1067,  1076,  1066,     0,   530,     0,  1170,   794,
     793,   796,   791,   795,  1482,     0,   668,   669,   672,  1262,
       0,  1323,  1271,     0,  1596,   301,   471,   308,     0,     0,
       0,   303,   382,   384,   304,   307,   311,   363,   324,   317,
       0,     0,     0,  1258,     0,  1321,  1267,  1294,  1345,  1241,
    1305,     0,     0,   858,     0,     0,     0,     0,  1346,  1242,
    1306,     0,     0,     0,     0,  1596,     0,     0,     0,     0,
       0,     0,     0,     0,  1491,     0,     0,   362,   847,   846,
     363,   396,  1285,     0,  2016,     0,   943,   948,   949,   947,
       0,   402,   410,   413,     0,     0,  1210,  1210,     0,     0,
     480,   494,     0,   575,   534,     0,   486,     0,     0,     0,
       0,     0,   687,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   732,   731,   181,     0,   459,     0,   686,
       0,   844,     0,     0,     0,   591,   461,     0,     0,  1552,
     460,     0,     0,   472,     0,   567,   556,   564,     0,     0,
     588,     0,  1436,     0,   594,     0,     0,     0,   788,  1158,
       0,  1172,     0,  1113,  1083,  1167,     0,  1656,  1805,     0,
       0,     0,     0,   771,     0,   641,  1211,  1469,   876,   878,
     724,  1028,     0,  1032,  1036,   961,  2188,  2130,  1995,     0,
    2191,  2190,  2194,     0,  2060,     0,  2061,  2089,  2067,  2071,
       0,  2068,  2069,  1964,  1962,  1947,  2094,     0,  1680,  2127,
    1634,  1633,     0,  1654,  1803,     0,     0,  1797,     0,     0,
    1827,     0,     0,     0,  1764,  1782,     0,  1760,  1758,     0,
    1771,     0,  1773,  2340,  2608,  2512,     0,  1712,  1714,  1717,
    1719,  1718,  1720,  1716,  2096,  2098,     0,  1691,  2151,  1807,
       0,     0,     0,  1062,     0,  1604,  1029,     0,   361,  1074,
    1170,   536,  2460,   537,  1073,  1075,  1079,     0,  1170,     0,
     575,   664,     0,     0,   280,     0,   306,   316,   365,   377,
       0,  1596,     0,     0,   856,   865,   865,   853,     0,     0,
     872,  1244,   728,     0,     0,   275,  1270,  1264,     0,     0,
       0,  1493,  1494,     0,     0,     0,     0,     0,  1293,   361,
    1266,   951,     0,   433,   440,   414,   418,  1485,     0,  1485,
       0,   415,   419,  1485,  1485,   412,  1805,   429,  1210,     0,
    1207,  1206,   523,   605,     0,   487,     0,   545,     0,     0,
     800,     0,     0,   685,     0,   461,   554,     0,   512,   503,
     504,   505,   506,   508,   507,   509,   510,   511,   501,   500,
       0,   686,   862,   372,  1443,   726,     0,     0,   699,     0,
     686,     0,  1555,   587,   556,   461,   554,   465,   479,     0,
     571,   564,   567,     0,   568,     0,   572,     0,     0,     0,
     591,  1495,  1061,     0,     0,   789,  1171,  1132,     0,     0,
    1161,  1165,  1166,     0,     0,     0,     0,  1214,   765,   766,
     760,   762,     0,   773,   777,   636,     0,     0,   640,   631,
     686,   361,     0,  1996,     0,     0,  2073,  2072,     0,  2112,
       0,     0,     0,  1645,  1796,  1799,     0,  1830,     0,     0,
       0,     0,  1816,     0,  1762,     0,     0,  1772,     0,     0,
       0,  1721,     0,     0,     0,  1730,     0,  1577,  1805,     0,
    1574,     0,  1043,     0,  1044,  1068,   575,     0,  1079,  1082,
     525,   575,     0,   789,  1272,     0,   605,     0,   319,     0,
     288,  1268,     0,     0,   867,   867,     0,     0,     0,     0,
       0,     0,   390,     0,     0,  1487,     0,  1488,  1489,  1492,
     398,   411,     0,   438,     0,   436,   435,   437,     0,   426,
       0,     0,     0,     0,     0,     0,   401,  1205,  1209,  1208,
       0,   488,     0,   490,     0,   531,   532,   533,     0,   492,
     541,   542,     0,   797,     0,   802,     0,   688,     0,     0,
     686,   553,   710,     0,     0,     0,  1437,     0,     0,   578,
     720,  1443,   591,   564,     0,   556,   473,     0,   573,   567,
     571,   569,   570,     0,  1440,     0,   593,     0,  1070,   787,
       0,  1162,  1173,  1168,  1163,  1399,     0,     0,   763,   768,
     767,  1485,   772,     0,     0,     0,   639,   638,   714,   992,
    2187,  2076,  2062,  2074,  2107,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1828,  1829,  1814,     0,     0,  1818,
    1769,  1794,     0,     0,     0,  1715,  2099,  2100,  2266,  1566,
    1576,  1063,     0,     0,   540,     0,  1082,  1064,   534,   789,
     529,   516,  1596,   313,   364,     0,     0,     0,   863,   866,
     854,   855,   874,   873,   730,  1596,     0,   386,   385,     0,
     389,     0,   434,   443,     0,   441,   416,   421,     0,   425,
     423,   422,   417,   420,   522,     0,     0,     0,     0,     0,
     543,     0,   544,   574,     0,   801,     0,     0,     0,   712,
     861,     0,     0,   459,   686,  1438,  1553,   567,   556,   564,
       0,     0,   558,  1074,  1074,   446,   571,   573,  1441,  1442,
       0,     0,   372,     0,  1084,  1398,  1397,  1656,     0,     0,
       0,   774,   775,   770,     0,     0,  2595,  2341,  2567,     0,
    2124,  2113,  2124,  2124,  2104,     0,     0,     0,  1800,     0,
    1817,  1820,     0,     0,     0,  1826,  1819,  1821,     0,  1781,
       0,  1792,  1723,     0,  1722,  1805,   361,     0,   789,   538,
    1065,   545,   518,   281,  1596,   857,     0,   276,     0,   391,
    1490,   439,     0,   424,   604,   491,   550,     0,   549,     0,
     547,   546,   798,   803,     0,   686,   851,  1443,   700,   571,
     564,   567,     0,   557,     0,  1076,  1076,   573,   444,     0,
       0,   573,     0,  1381,  1656,  1380,  1382,  1390,  1387,  1389,
    1388,  1386,  1217,  1218,   764,   769,     0,     0,     0,  2117,
    2116,  2115,  2119,  2118,     0,  2111,  2109,  2110,     0,     0,
       0,     0,  1823,  1824,  1825,  1822,  1768,     0,  1724,  1573,
    1045,     0,   520,   789,   289,   864,     0,   442,   548,   552,
     551,   686,   711,  1439,   573,   567,   571,  1074,   559,  1075,
     561,   560,   448,  1070,  1071,     0,  1805,   777,     0,  1391,
    1385,  1632,  1619,     0,     0,   776,     0,     0,     0,  2121,
       0,  2122,     0,     0,     0,     0,     0,     0,     0,   521,
       0,   713,   447,   571,   573,  1076,   372,  1069,     0,  1052,
       0,  1383,  1656,     0,     0,   782,  2114,  2120,  2123,  1650,
    1649,     0,     0,  1653,     0,  1793,   539,   387,   573,   445,
     562,   573,  1072,     0,  1384,     0,     0,   784,     0,   780,
     783,   785,   786,     0,     0,  1815,   449,  1805,     0,     0,
       0,   748,     0,  1680,     0,  1053,     0,     0,     0,   781,
       0,     0,   782,  1215,  1216,     0,  1652,     0,   749
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5359, -5359, -5359,  3598,  -707, -5359, -5359,  -936, -1354,  2843,
   -2348, -5359, -5359, -5359,  1323, -5359, -5359, -5359, -5359,  3563,
   -5359,  1548, -2843, -5359, -5359,   126,   306, -1374,   166,  3147,
    1234, -5359,  -996, -5359, -5359,  -622,     1, -5359,   216,   459,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359,  -697,  1659,
   -5359,  1744,  1037,  -784, -3771, -5359, -5359, -1496, -3657, -5359,
     342, -5359,   368, -4631, -1166, -5359, -5359, -5359,  1650, -5359,
   -5359, -5359,  1597,   836,  -604, -5359, -5359, -5359, -5359, -5359,
   -5359, -1012, -5359, -5359, -1268,     6,  -638, -2865, -4176, -5359,
   -5359,   203,  -648, -1470, -5359,   383, -5359, -4495, -5359,  -261,
   -2713, -5359, -5359, -5359,  -618, -1435,  1131, -5359,  -727, -1137,
    1469, -2976, -1125, -5359,  -494, -5359, -1245, -1024, -1021, -1158,
   -4220, -4666, -5359, -5359, -1273, -3673, -4952, -5217, -4721, -4875,
    1140, -5359,  -290,   209, -5359,     7, -3576, -3647,    10,   175,
   -5359,    11,    13, -5359,   192,  -956,  -949, -1553, -5359,  -895,
   -5359, -5359, -5359, -3360, -5359, -5359, -5359,   141, -5359, -5359,
   -5359, -5359,   240, -5359, -5359, -5359, -5359, -5359, -5359, -3115,
    1619,  1624, -5359, -3996, -5359,  -912, -5359,   394, -3394,  1064,
   -5359, -5359,   832,  3589,   224, -5359, -5359, -5359, -5359, -5359,
   -5359, -1758, -5359, -5359, -5359, -5359,  -262,  -587, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359,    14, -5359,   795,   165, -5359,
   -5359,  -866, -5359, -5359, -5359, -5359, -5359, -5359, -1312, -4982,
   -1396, -1382, -5359, -3358, -5359, -5359, -5359,  -557, -5359, -5359,
   -5359, -5359, -5359,  -914, -5359,   893, -4022, -5359, -5359,   210,
   -5359, -5359, -5359, -5359, -5359, -1127,  -499,  2777, -5359,  -729,
    -926, -5359, -5359, -5359,  -497, -5359, -5359, -5359, -5359, -5359,
    -506, -1288,  4583,  3974, -1098,  7040,  -825,  -577, -5359, -5359,
   -5359, -2739, -5359, -5359, -4134, -5359,  4574,  2271,   396,    15,
   -5359,   -15,    90,  3405, -1150, -3019,   161,  -687, -5359, -5359,
   -5359, -3000, -5359, -5359, -5359, -5359, -3958,    17, -5359,  -710,
   -5359, -4233, -5005, -4438, -3970, -1283, -5359, -5326, -4182, -4943,
   -3949, -5359,  1651, -5359, -5359,  -561,  -187,  2750, -5359, -1448,
    1985, -1397, -5359, -2531,   233,  1230,  2756, -3205,  -131,  2748,
   -2927, -5359,  -723,   827, -5359,  -584, -3689, -5359, -5359, -5359,
   -2708,  -813, -5359, -5359,  1368,   489, -5359, -5359, -5359, -5359,
    -634,  2729,  -179, -5359, -5359,  3947, -5359, -4791, -5359,  3920,
   -5359, -5359, -5359, -5359,  2653,  2664, -5359, -5359, -1447,   999,
   -5359,  -832, -5359, -5359,  1759,   430, -5359, -5359, -5359, -5359,
   -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -5359, -1112,
   -1295, -5359, -5359, -4373, -5359, -5359, -5359, -5359, -5359,  2278,
    -943,  -738,  3809,  -247,    18, -5161, -5359, -5359, -1126, -5359,
    3161, -5359, -5359, -5359, -5359, -5359,   226,   218, -5359, -5359,
   -5359, -5359, -3675, -5359, -5359, -4755, -5359, -5359,  1738, -5359,
   -5359,   764,     3,  2882, -5359, -5359, -5359,   -26, -5359, -5359,
   -1003,  2073, -5359, -2336, -5359,  -593, -5359, -5359, -1871,    21,
   -4214, -5359,     4, -5359, -5359,  -378, -5359,    44, -5359, -5359,
   -3884,     8, -5359, -5359, -5359, -5359, -4859, -5359,     9, -1014,
     567, -3239, -5359,    25,    35, -5359, -5359,     5,   199,   -45,
     -60,   -43,     2,   114,  3281, -5359, -5359, -5359, -5359,  3332,
   -5359,    -5,  -855,  4609,  4614, -5359,  -871,  -147, -5359,  1326,
    -721, -2534,  3238,  3244, -5359,  1314,  2080, -2422, -2417, -5359,
   -1299,  -992,  -828, -5359, -5359, -5359, -5359, -1846,  -709, -2539,
   -5359,  3260, -5359, -5359, -5359, -2327, -3258, -3191,  1353, -3193,
   -3084, -5359,   646,   632, -1269,  -336,    60,  -765,  3246, -5359,
   -5359,  1362,  -582, -5359, -5359,  -580, -3168,   595, -5359, -4422,
   -2754,  1369, -1234,  -964, -5359, -1092, -5359,  -791,  6237,  3299,
    -812, -5359, -5359,  -785, 12444, -5359, -5359, -5359, 13219, 13588,
   -5359, -5359, 14863, 15326, -5359,  -635, 15840, 10800,  -782, -1908,
    -191, 17663, -1748,   890,    88, -5359, -2909, -2265, -5359, -5359,
   -5359,  -544,   740,   518, -5359, -4434, -4280, -5359, -5359, -2210,
   -5359,  -799, -5359,  -798, -5359, -5359, -5359, -3159, -5358, -3136,
    2214, -5359, -5359, -5359,  -183, -5359, 17838, -3167, -5359,  -298,
    -979, -1567,  2685, -3010, -1887, -5359, -5359, -5359, -3049, -5359,
   -5359, -5359,  -846,  1465, -5359, -5359,  1566, -5359, -5359, -5359,
    -948,  1799,  -754, -1164,  1472,  3821,  -766,  2224,  -777, 16073,
    -639, 11048, -1278, -5359,   263, -4063,  6656,  7403,    16,  -140,
    1636,  -652,  2137,  2586, -5359, -5359,  5076,  8012,  -567,  -984,
   -5359,    -6, 13706, 11341, -3583, -5359
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    58,    59,    60,    61,    62,    63,  1584,  2947,  2802,
    3724,  3725,    64,    65,  1580,    66,    67,    68,    69,  1494,
      70,  1076,  1831,  2962,    71,  2646,   824,   825,   826,  2513,
    2514,  2892,  2515,  2503,  1347,  1777,  1516,   798,   799,  1476,
    1517,    73,    74,  1341,  2494,    75,    76,    77,  1547,  1639,
    1548,  1549,  1488,  1877,  4767,  5518,  3518,  2764,  3773,  3519,
    3520,  4154,  4155,  4235,  5532,  5533,    78,  1655,  1656,    79,
      80,  2929,  3690,  4288,  5131,  5132,  5365,   636,  4790,  4791,
    5352,  5353,  5546,  5694,  5695,  2963,   667,  3768,  4371,  3715,
    4861,  3716,  4862,  3717,  4863,  4144,  4145,  3701,  4319,  4320,
    4803,  4321,  3718,  4822,  5398,  3719,  2665,  5561,  2997,  1949,
    1947,  5048,  5377,  4627,  4628,  5788,  5569,  5570,  5571,  5810,
    4824,  4867,  4868,  5731,  5732,  3771,  4377,  4874,  5190,  5146,
    3416,    82,  3744,  3745,    83,   730,  1853,  3868,   731,  3000,
     668,   732,  2964,    88,  2990,  5563,  2991,  1610,  2816,  4301,
    3848,    89,  1103,  4119,  5215,  5458,  5459,   721,    90,  1839,
      91,    92,  2942,  3708,    93,  2682,  3433,    94,    95,  3452,
    3453,  3454,    96,  4329,  5151,  1550,  3507,  3508,  3509,  3510,
    4175,    97,  1834,  2971,  2972,    98,    99,   100,  3098,  3099,
     101,  2878,   102,   103,   104,   105,  4210,  4729,  4838,  3548,
    3731,  4345,  4836,   106,  3694,  2965,  3018,  3806,  3807,  5213,
    5450,  5451,  5452,  5621,  5844,  5454,  5623,  5753,  5625,  4813,
    5958,  5959,  5435,  4108,  4641,   108,  4814,  4815,  5576,   109,
    2680,   110,   111,  1808,  2935,  2936,  4302,  3007,  3781,  3782,
    4357,  4358,   112,  3632,   113,  4705,  4706,   669,  5584,  5524,
    5680,   114,   115,  4709,  4710,   116,   117,   118,   119,   120,
     722,  1039,  1040,   724,  1158,  1159,  3389,  1120,   121,  2523,
     122,  3670,   123,  1233,  4926,   124,   755,  1174,  1175,  2966,
     126,   764,  3117,   766,  1964,  3850,  3851,  4443,   127,   128,
    3095,  3120,   129,  1481,  2656,  2657,  4622,  2967,   670,  1218,
    3004,  3411,  5292,  5042,  5293,  5742,  5895,  5043,  5306,  3334,
    4058,   131,   671,  1522,  2721,  1126,  1127,  3011,  3786,  2627,
    2628,  1678,  4398,  2630,  3788,  2631,  1455,  2632,  1113,  1114,
    3794,  3795,  3796,  3797,  4394,  4404,  4405,  5207,  5443,  4401,
    2956,  5201,  5202,   132,  1519,  2718,   133,   134,   135,  1563,
     964,  1136,  1137,   136,   683,   684,   137,  5370,   138,  1116,
     139,  5211,   140,   141,   789,   790,   142,   143,  2735,  4157,
     144,  1520,   145,   146,  3542,  3543,  4721,   147,   148,   149,
    1826,  1827,   150,   151,   152,   153,   154,  5835,  5898,  5899,
    5900,  4412,  5747,   155,  1205,   156,   157,   158,   159,   196,
    1005,  1006,  1007,   917,  2968,  5192,   161,   162,  1477,  1478,
    1479,  1480,  2651,   163,   164,   165,  3816,  3817,   166,   167,
     168,   169,  1811,   170,   171,  5343,   172,   173,  1781,   174,
     175,  1013,  1014,  1015,  1016,  1779,  3282,   630,   842,  1372,
    1378,  1421,  1422,  1423,   177,   734,   178,  1213,  1044,   735,
    1167,   180,   736,  2610,  3364,  4073,  4074,  4075,  4078,  5027,
    4600,   737,  3360,   183,  1971,  3104,  3107,  3356,   738,  3369,
    3370,  3371,  4081,   739,   757,  1106,  3022,   740,  1308,   188,
     189,   190,   898,   845,   846,  3287,  5253,  5473,   192,  2487,
    3265,   773,  1427,   886,   887,   888,   907,  2902,  2576,  2577,
    2601,  2602,  1436,  1437,  2589,  2593,  2594,  3347,  3340,  2582,
    4052,  5277,  5278,  5279,  5280,  5281,  5282,  4589,  2597,  2598,
    1439,  1440,  1441,  2606,   193,  2566,  3315,  3316,  3317,  4029,
    4030,  5779,  4044,  4040,  4574,  5004,  3318,  1203,  1447,  4582,
    5781,  3319,  4993,  4994,  5257,  4048,  3326,  4069,  3756,  3757,
    3758,  3320,  5481,  5482,  5776,  5777,  5259,  5260,  2633,  1401,
     872,  1309,   873,  1414,  1310,  1388,   875,  1311,  1312,  1313,
     878,  1314,  1315,  1316,   881,  1380,  1317,  1318,  1397,  1410,
    1411,  1373,  5261,  1320,  1321,  1322,  3322,  1323,  4520,  4966,
    4952,  3192,  3193,  2510,  4516,  3952,  4510,  2482,  3255,  5016,
    5284,  5285,  3992,  4544,  4980,  5248,  5638,  5760,  5761,  5855,
    1324,  1325,  1326,  3252,  2476,   967,  1327,  4304,  2478,  3186,
    3164,  1681,  3165,  1974,  1995,  3136,  3152,  3153,  3229,  3166,
    3174,  3179,  3187,  3216,  1328,  3138,  3139,  3893,  1997,  1329,
    1011,  1684,  1012,  1416,  3211,  1337,  1338,  1331,  1965,   835,
    5000,  1162,  1764,   770,  1332,  1333,  1334,  1335,  1556,   938,
    1129,  1130,   889,   891,   892,  2570,   626,   618,   940,  3511,
    2479,   627,   620,   621,  1769,  2480
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     619,    72,   191,   176,   181,   186,    81,    84,   182,   184,
      85,    86,   897,    87,   107,   125,  1070,   130,   160,   930,
    1776,   179,   803,   191,   733,   185,  1765,   971,   966,  1680,
     976,  1609,   965,  1892,  1194,  1195,  1196,  1342,   759,  1442,
    1200,   837,   908,   624,   759,  1330,   885,  2664,  2759,  1428,
     675,  1430,  1555,  1142,  1393,  1946,  2829,  2629,  2730,  1413,
    1107,  1660,  1017,  1672,  1770,  3746,   918,  1155,  3357,  1614,
    1384,  1385,  1369,  2722,  3358,  1992,   974,  1985,  1836,  1392,
    1219,  3714,  1368,  1356,  1161,  3798,  2742,  1399,  2985,  1168,
     996,  4125,  4356,  2731,   615,  3854,  1460,  3382,  3384,  3873,
    4003,  4067,  4005,  4382,  3110,   834,  3135,  4591,  2896,  4407,
    4170,  3629,  4172,   765,  1551,  1109,  3737,  4306,  4369,  1809,
    4146,  1778,  4026,  1814,  2629,  1038,  4043,   804,  1818,  4080,
    3201,   910,  4629,  4997,  2562,  1169,  3597,  2713,  1828,  1573,
    4624,  1152,  1140,   232,  1590,  1144,  2858,  2859,   911,  4664,
     902,  1848,  4881,  4870,  4860,  4821,  1821,  5194,  4689,  3052,
    3268,  5009,  1017,  5011,  3270,   848,  4056,  5381,   823,  5066,
    3349,  1845,  3673,  4086,  3676,  3677,  3976,  3352,  1523,  3681,
    3682,  3683,  1881,  3685,  3686,  3687,  1435,  4366,  3280,  2854,
    5155,   619,  5433,  5044,  4606,  1349,  4869,  2713,  1438,   187,
     619,   941,   797,  5598,  5187,  5314,  2693,  1518,   619,   831,
     941,   619,   741,  1844,  2713, -2383,  2885,   634,  1381,  1382,
     187,  1017,  5041, -2421,   941, -1887,  1552,  3917,  1391,  4957,
   -2307, -2444,   741,  5420,  4041,  3328,  4046,  2521,  5186,  1874,
    1874,   741, -2481,  5586, -1854, -2275,  5335,  1874,  1518,  1874,
    1109, -2386, -2240,  1518, -2275, -2275,   896,  2870,  1176, -1867,
    4392, -2276,   741,  2733, -1892, -1895,  1368,  3171,  5375,   616,
   -2276, -2276, -2651, -1882,  1017,   681,  1001,   681,  2865,  1180,
   -2239, -2651, -2651,  1608,   681,   989,  2733,   681,   681,  2953,
    2041,   783,  1638,  1806,  3209,  3100, -1895,  2852,   741,  2733,
    3323,  5523,  1665,  2500,  3209,  1552,   681,  2658,   840,  3654,
    1874,   741,  3119,  2567,  3802,  4322,   928,  1060,  1969,  2982,
    4121,  2527,  1801,   681,  4928,  4929,  4930,  1228,  4932,  4933,
    4934,  4935,  4936,   681,  1017,  -140,  1884,  3917,  4126,  3858,
    3081,  -140,  1888,  2927,  1482,  2672,  5371,  1490,  2648,   681,
     681,  2041,  1899,  2994,  2529,  4857,  1902,  5345,  5346,  3860,
    1905,  5209,  1907,  5509,  4882,   916,  4852,  1874,  1915,  5745,
    5183,   681,  1874,  5456,  1921,  3891,  1002,  1924,  2995,   784,
    4858,  2994,  2527,  5737,  1858,  2660,  1043,   747,  1449,  3523,
     909,  5025,  5427,  1096,  2846,   747,  1346, -1709,  5848,  1874,
    5428,  3803,   747,   747,  5466,  2661,  2995,  5825,  5826,  5850,
    2782,   748,   632,  1672,   747,  2529,  2950,  3704,  2501,   748,
    1770,  2573,  1490,   747,  3101,  1003,   748,   748,  1765,  5313,
    5725,  4707,  3096,  1823,  1217,  5513,  1198,  3111,   748,  2492,
    2041,  3331,  2796,  1564, -2134,   628,  3249,   748,  5677,  1109,
   -2442, -2134,  1592,  3250,  3568,  3623,   631,  5619,  1483,  2504,
     919,  1491,  5520,  2750,  2516,  2516,   768,   966,  2569,   931,
    5600,  2670,  1384,  1385,  2957,  2768,  2041,   931,  1165,   681,
     931,   741,  5052,  1004,  3871,   681,  1900,  2733,  2522,  3624,
    2733,  1593,  2733,  1392,  2987,   629,  2673,  2751,  4229,  3917,
    2983,  2733, -2153,  5620,  2529,  1977,  1399,  2527,  1064, -2153,
    2493,  4236,   194,  2733,  1074,   861,  1565,   966,  3097,  5827,
    5421,  5678,  1875,  1875,  1199,  1890,  1087,  3705,  2658,  2565,
    1875,  3332,  1875,  3568,  1403,  2951,  1491,  2502,  1807,   785,
    2529,  4294,  4353,  4708,  5409,  1374,  1966,  2659,  2783,  5936,
    5457,  5746,  3119,  2662,  2035,  5851,   195,  -432,  1890,  1231,
    1874,  5925,  1976,  5707,  3859,  5666,  5429,  3427,  1807, -1709,
   -1854,  5373,  2996,  2743,  4859,  1770,  1986,  5557,  4122,  1930,
     786,   787,  2490,  4402,  3861,  2928,  1450,  2674,  5271,   682,
     676,  2832,  1123,  1875,  4126,  2485,  3524,  4306,  2884,  3082,
    5167,  3669,  5884,  5210,  2700,  5026,  2660,   929,  1061,  1404,
    1989,  1381,  1382,  3804,  2707,  5467,  4323,  4214,  4925,  1807,
    1484,  2853,  4724,   941,  1970,  2871,  2661,  3805,  2564,  3102,
    4393,  5664,  1562,   841,  3456,  1890,  5669,   191,  1391,  1045,
    1048,  1009,   941,  1046,  1047,  1010,  1970,  5736,   941,  3103,
    1875,  3210, -1854,  3655,  2872,  1875,  5883,  1199,  1671,  1485,
     941,  3981,   635,  2954,  2797,  1109,  1379,  2663,  2824,  5924,
    1405,  2827,  2984,  1406,  1807,  2866,   941,   788,  5237,  1876,
    1883,   619,  1875,  2938,   897,  4830,   885,  1887,  3137,  1898,
     619,   941, -2442,  1486,  2894,  2895,  1492,   619,  3297,   941,
     619,  2814,  3131,  2834,  2817,  2818,  5948,  1172,  3932,  3323,
    1553,  1554,   885,   941,  2847,  3706, -2383, -1887,  1394,   753,
     754,  2607,  1101,   941, -2421,  4878,  5030,  2776,  2893,  2498,
     191, -2307, -2444,  2608,  4877,  5829,  1383, -2275,  2540,  1395,
     753,   754,  1009, -2481, -2240,  1230,  1010,  4634,  5593,  1394,
    1920,  1387, -2386, -2276,  2545,  2546, -1892,  1396,  1173,  1493,
    1178,  1487,  1182,  1443, -2651, -1882, -2442,  2037,  1186,  2488,
    1395,  2475, -2239,  5847,  2662,  5819,   753,   754, -2442,  3273,
    5963,  5691,   941,  2813,  1109,  1407,  2568,  1582,  1398,  1553,
    1554,  1189,  1109,  1109,  1009,  2671,  2717,  5225,  1010, -2134,
    2698,  3251,  5053,  4306,  3707,   619,   619,  1923,  3070,  2901,
    1583,   941,  1890,  5793,  1199,  3929,  3930,  3931,  3932,  -140,
    -140,  3054,  4230,  2937, -1854,  3531,  5797,  4267,  4043,  2472,
    2473,  2474,  2475,  1202,   187,   941,  4651,   619,   910,  4442,
    1788,  4571,  4831,  1875,  1793,  4575,  1794,   966,  4694,  2717,
    4088,  1792,  4089,  3692,  3080,   911,  4366, -2153,  4474,  4082,
     885,  5505,  2775,  4286,  4287,  3092,  2717,  1807,  1927,  5886,
    4789,   677,  4354,  4455,  4354,  4442,  5708,  5735,  3428,  4403,
    5374,  2486,   619,  1124,  2744,  4614,  4224,  4225,  2663,  4702,
    1783,  4226,  3386,  4347,  2915,   941,  1408,  1202,  2745,   905,
    2746,    72,   191,   176,   181,   186,    81,    84,   182,   184,
      85,    86,  5806,    87,   107,   125,  3349,   130,   160,  1409,
    4336,   179,  4061,  5596,  1475,   185,  1595,   187,   896,  5729,
     678,  4792,  2784,  5923,  4793,  5874,  4562,  4832,  4564,  4281,
   -1708,  1345,   797,  1208,  1210,  1353,  4010,  5717,  1596,  1358,
     919,  3514,  2470,  2471,  2472,  2473,  2474,  2475,  1375,   931,
    5108,  2747,  4857,  5728,   905,  1574,   931,  1669,   679,   931,
     680,  5968,  5500,  5558,  1446,  3927,  3928,  3929,  3930,  3931,
    3932,  5772,  5635,  3145,  5109,  3447,   681,  4858,  2692,  1497,
    2838,  2945,  1206,  4819,   912,  1403,  1191,  4750,  1464,  1597,
    5414,  4703,   619,   619,  1766,  3447,  3515,  2666,  1503,  2034,
     941,  2873, -2236,  1620,  5879,   619,  5828,  1095,  4408,  2839,
     885,   619, -1854,  2708,  4833,   619,  3015,   619,  2583,  1001,
   -1854,   885,  1383, -1854,  1412,  2667, -1854,  3256,  4722,  5148,
    3460,  5135,  4083,   949,  2569,  3323,   885,   903,  3323,  3016,
     950,   951,   952,  5908,  5642,  3693,  1238,  4901,  5319,  3917,
    5565,  4954,  5820, -2776, -2776, -2776,  3448,  4449,  4092,  4629,
    1404,  2584,  4307,  1383,  5136,  2563,  1464,  3207,  1621,  1575,
    1096,   913,  3627,  1207,  1465,  2543,  3448,  1770,  1598,   619,
    4337,   619,   619,  3146,  3323,  4846,  5773,   909,  4485,   187,
    4486,  3387,  4062,  3516,  3388,  4409,  5892,  4704,  3036,  -681,
    5896,  2900, -1708,   904,  1238,  5807,  3043,  3917,  2709,  4310,
    1622,  3918,  3919,  3920,  5489,  5636,  5559,  1623,  2998,  1002,
    1624,  1405,   941,  5909,  1406,  3461,  1599,  1466,  5501,  1600,
    1177,  1179,  1181,  4594,  1670,  1183,  1184,  1185,  2676,  2874,
    2615,   797,  1208,  3913,  2828,  1190,  5637,  5149,  2677,  1649,
     619,  1644,  1465,  5922,  1097,  1650,  5579,   783,  3147,  4303,
    5880,  4751,  4955,  5408,   191,  1192,  3657,  4312,  1003,  3257,
    4834,  5723,  2586,  3089,  3090,  2946,  2668,  4820,  1602,   905,
    5566,  1359,   941,  4630,  5185,  5808,  5595,  5173,  5592,  5607,
    2960,  1629,  5204,  5949,  1645,  1017,   885,   772,   941,  5578,
    1932,  3017,  1934,  5179,  1936,  1466,  1938,  5910,  1940,  1941,
    1942,  4450,   941,  5809,  1009,  1944,   941,  5966,  1010,  3148,
    5967,  3381,  3149,  1604,  4487,  1467,  1004,  3033,   619,  5594,
    1867,  1576,  2587,  3451,  1866,  5110,  1407,  5774,  2006,  3457,
    4835,  3045,  5775,  5423,  1868,   784,  1605,  3475,  3234,   809,
    4399,  4410,   897,  3451,  3051,  1360,  5567,  5036,  5424,   619,
    5139,  3517,  3074,  1651,  4063,  4315,  1607,  1224,  2035,  1238,
    1577,  2961,  3917,  3056,   919,  3309,  3918,  3919,  3920,  1625,
     931,  1355,  1630,  5334,   931,  2647,   931,   619,   619,   619,
    3921,   619,  5519,  4525,  4806,  3029,  5318,   914,  1359,   781,
    1869,  1098,  3079,  1467,  1578,  4595,  3084,  2678,  4316,  4054,
    3088,   619,  3922,  3091,  1626,  3031,  3532,  4195,  1627,   906,
    2652,  4411,  3923,  3664,  4317,  5861,  3063,  3050,  5388,  5503,
    3044,  2653,  2713,  3046,  3150,   941,  2525,  1001,  1099,  5349,
    3560,  3361,  2887,   941,   941,  2819,  2679,  1408,  1859,  2654,
    1861,  1862,  1628,  5911,   810,  1840,  4008,  2574,  2575,  5029,
    2579,   187,  3720,  1468,  5837,  4998,  1646,   619,  1431,  3162,
    1469,  5001,  1360,   966,   911,   911,  5005,   911,  5804,  5007,
    3923,  2888,  5389,  3083,  1224,  5390,  3086,  3087,  3235,  5470,
    1472,  5391,  1473,  3236,  1595,  5582,  1766,  1100,  1841,  1101,
    1870,  1425,  1470,  1102,  5590,   785,    36,   805,   782,  3075,
    3914,  3915,  1890,   619,  5152,  3934,  1596,   619,   619,  5392,
    4148,  1890,  4318,  1909,  2040,  1652,  3561,  2041,  2829,  1994,
    3237,  4196,   619,  4918,  5425,  3746,  1471,  1002,   885,  3300,
    3354,  1433,  3076,  4922,  3613,  3151,   786,   787,  4807,  2003,
    3614,  5837,  3964,  3965,  5628,  3077,  1871,  3447,  2527,  5471,
    4180,  4891,  3764,  5767,  1653, -2776,  1910,  1597,  1472,  5912,
    1473,  1647,  4181,  3887,  3130,  3303,  5393,  3922,  2538,  2760,
    3562,  2020,  2820,  1171,  5913,  2821,  1003,  4306,  1434,  5394,
    3078,  2529,  5344,  4811,  1446,  2580,  2032,  2583,  1654,  3269,
    3301,  5395,  2655,  4033,  5422,   885,  1426,   194,  5174,   955,
     956,   957,   958,   959,   960,   961,   962,   963,  5413,  5661,
    1474,  3362, -2776, -2776, -2776,  3927,  3928,  3929,  3930,  3931,
    3932,  4783,  1770,  3721,  4149, -1632,  4787,  4616,  3448,  3563,
    2584,  4071,  1216,  3546,  1004,  3923,   885,  3355, -1632,  5837,
    5667,   195,  3787,  1872, -1632,  1540,  1598,  3642,  3615,  1931,
    3966,  5156,  1933,  1650,  1935,  4637,  1937,  1611,  1939,  1765,
    1842,  1475,  1943,  3449,  5719,  3238,  1475,  4072,  4034,   885,
    3924,  3925,  3926,  3927,  3928,  3929,  3930,  3931,  3932,    41,
    1407,  2581,  3072,  4197,  1469,  1370,  2826,  4851,  3072,  2629,
    4810, -1632,  2585,  2629,  1599, -2776,  1612,  1600,  5341,  5157,
   -2776,  4035,  3450,  3072,  3862,  1407,   909,   909,  3547,   909,
    2040, -1632,  2828,  2041,  2760,    45,  4036,  2042,  2043,  2044,
      36,  5342,  4198,  5890,  5891,  2760,  4037,  4848,  1911,  4303,
    4812,  2761,   941,  3564,  2526,  3400,  4995, -2776,  1475,  4638,
      41,  2586,  1475,  1923,  2527,  1420,  1602,   619,   619,   619,
    2799,  2528,  4038,  2738,  4720,  2739,  4199,    49, -1632,  1579,
    2762,  1651,  5548,  1582,  5550,  1843,    41, -1632,  5554,  5555,
      50,  3492,  2849,  3132,  1540,  3134,    45,  2529,  3722,  5396,
    3032,  3141,  5397,   808,  3863,  2763,  1583,  3155,  3156,  3157,
    2534,  1604,  3402,    51,   966,   966,   832,  5790,  3176,  3042,
    4639,  2587,    45,  3188,  4640,  3451,  1613,  4617,  5818,  4592,
    3616,  3363,    41,  4618,  1605,  4138,  2740,  5551,    49,  3279,
    4619,  3619,  5552,  5950,  2758,  3025,  5585,  3723,  5599,  4150,
    4151,  2855,  3493,  1912,  1607,  3924,  3925,  3926,  3927,  3928,
    3929,  3930,  3931,  3932,    49,  4039,   941,  3323,    45,  3617,
    4804,  3323,  3494,  4034,  3521,  4620,  3565,    50,   885,  4152,
    3620,  3325,  3414,  5606,  3566,  4227,  2819,  3567,  4692,   885,
    -163,  4593,    57,  5553,  5049,  1451,  2761,  4621,  3403,  3544,
      51,  1766, -2776,  3618,   194,   885,  4035,  2761,  2667,  4139,
      49,  2530,  1393,  1431,  3621,  5267,  2531,  1771,    57,  5882,
    1772,  4577, -2259,    50,   941,  2762,  -163, -1632,  3353,  4082,
     966,  4037,   941,  3495,  1452,   843,  2762,  3323,  2532,  2228,
     941,  4805,  3415,   939,  2750,  4667,    51,  4233,   195,   628,
    2763,  5942,   975,  2533,  5455,  4303,  -163,  1088,   885,  4228,
    5894,  2763,  4693,  3579,    57,  5050,   997,   619,  1453,  1431,
     619,  5751,   899,   885,  4033,  1432,   885,   885,  2751,  4668,
     619,   619,  2508,   941,   941,  5921,  1433,   900,  1461,  2758,
    3544,   915,  2278,  1089,  1617,   619,  4234,   941,   619,   901,
    2758,  5974, -2776,  5752,  5224,  3410,  2534,   885,   885,  2535,
     941,   941,  4151,  2470,  2471,  2472,  2473,  2474,  2475,  3560,
    5727,  3580,  5744,  2820,   985,  2509,  2821,  1462,  1090,  3583,
   -1679,   191,  3586,  1618,  1846,  3746, -1679,  3820,   747,  1807,
    1582,  4680,  1433,  1394,  4801,  5726,  5750,  3622,   619,  4034,
    4039,   619,   619,  5068,   986,  5154,  3702,  1847,  5952,  4669,
    5073,  1463,   748,  1583,  1395, -1061,  3064,  1619,  3065,  3116,
    3066,  4802,  3067,   924,  3068,  2760,  1091,   191,  3069,  1045,
    1048,  2629,  4035,  1046,  1047,   619,  1088,   619,  2041,  1434,
    5577,  2629,   619,   619,  5178,   916,  5165,  4036,  2536,   619,
     619,   619,  4467, -1679,   619,  3561,   619,  4037,   619,   619,
     619,   619,   619,   619,  5296,   619,  5298,   619,   619,  2527,
    4137,   619,  1089,  3658,  3659,  3660,  2829,  3553,  3554,  3473,
    3105,  3557,  3628,  4038,  3960,   885,   619,   619,   619,  2800,
    5444,  3734,  3414,  5126,  2803,  5127,  5128,  5129,  4637,  3625,
   -1679,  2760,  2529,   619,  4192,  1766,  5821,  4348,  5341,  3562,
    5002,  2790,  5300,  5448,  3750,  3751,  3752,  3753,   948,  3755,
    5308,  2629,  3470,  3115,  4430,     3,     4,  5610,  2807,  3094,
    1062,  5342,  1063,  3626,  1109,  5831,  1456,  5449,  3323,  3323,
    3664,  3814,  2886,  4193,  3783,  5743,  4276,  5627,  2466,  3789,
    5143,  2955,  4104,  1923,   776,  1091,  2467,  2468,  2469,  2470,
    2471,  2472,  2473,  2474,  2475,  3578,  2876,  4630,  3563,  3906,
    2882,  1457,  3907,  1498,  1890,  1458,  4039,  4194,   187,  5914,
    4630,  1009,  4638,  2733,   777,  1010,   919,  2761,   778,   919,
     727,  4560,   647,  4441,  2734,  1929,  1923,  5885,  1772,   931,
     931,  5589,  3603,  5915,  4231,  5671,   647,  2769,  1499,  1459,
      15,   926,  2889,   741,   931,   947,  2762,   931,  3458,  1582,
    4481,  4482,  4483,  4484,   187,  2890,  4488,  4489,  4490,  4491,
    4492,  4493,  4494,  4495,  4496,  4497,  3648,   991,  4442,  3733,
    3847,  2763,  1583,  4639,  1000,    20,   619,  4640,  5556,  4268,
    1640,  3594,   649,  3595,  2891,  3950,   727,  3599,  4085,  4059,
    -140,  3957,  1008,  2761,  5003,   741,   649,   931,  1917,  1500,
     931,   931,  3564,  1351,  5461,  -596,    15,  1084,  3285,  4769,
    2758,  1050,  1394,  4535,  4536, -1631,   619,   903,  1394,  1641,
    3812,  1918,  2762,  1642,  3288,  3818,  2496,  3819, -1631,  1052,
   -1680,  3286,  4770,  1395, -1631,  1501, -1680,  3825,  4752,  1395,
    3826,    20,  3827,  3828,  2898,  2899,  3830,  2763,  2733,  5951,
    3833,  1396,  3834,  1643,  3776,  3836,  4378,  1398,  4107,  2741,
    3888,  4753,  5341,   233,  1065,  3889,  3790,   619,  4630,   633,
    1065,  1502,  1066,   756,  1067, -1632,  -457,   725,  1585,   756,
    3323, -1631,  1065,   904,  4415,  5342,  2758,  3323, -1632,  4416,
    1057,  5792,  3323,  5522, -1632,  3323,   806,  1657,  5526,  5527,
    1661, -1631,  3738, -1680,  2596,  -595,  1978,  4613,  4885,  1772,
    5660,  1504,  1383,  4416,  2563,  3943,  3875,  3945,  3946,  1572,
    5310,  4307,     3,     4,  1589,  3565,  4995,  4308,  1009,  1383,
   -2240,  1412,  1010,  3566,  2524,  1071,  3567,  1772,    41,  2040,
    4309, -1632,  2041,  1506,  2760,  3302,  3304,  3305, -1631,  1469,
   -1680,   660,  1092,   661,  5833,    29,  1093, -1631,    33,   905,
    2516, -1632,  1383,  1094,  2563,   660,  5351,   661,  4310,  2537,
    4311,  1111,  2538,  2527,    45,  1993,  1115,    57,  4004,  1822,
   -2776,  1389,  1390,  3869,  3870,    36,  3215,  1122,  2571,    41,
    3791,  1772,  1131,   665,  3060,  -457,  3020,  2538,  3021,  1509,
    3220,  3221,  3222,  3223,  3350,  3351,  2529,  1510, -1632,  3071,
    5872,  3995,  3072,  3996,  2760,  2716,    49, -1632,  3073,  2760,
    3997,  3072,  3998,  3846,    33,    45,  4312,  1512,  2760,    50,
    3108,  3284,  3289,  3109,  1923,  2538,  1513,  4375,  2760,  4376,
    1514,   619,   619,   619,   619,   619,   619,   619,   619,   619,
      41,   619,    51,  3373,  4313,    41,  2538,  5762,  5763,  3792,
     619,  3533,   619,  3467,  1138, -1088,  3468,    49,  1132,  3538,
      57,   728,  3539,  3698,  3838,  3978,  3699,  3072,  1149,  3437,
      50,  3441,  3442,  4794,   966,  4795,    45,  4945,  3440,  4946,
    5611,    45,  4015,  4016,  1515,  5919,  1166, -1631,  3793,   906,
     619,  1156,  3886,    51,   619,  2538,  2761,   619,  3281,   619,
    3895,   628,   619,  2538,  4006,  3901,   619,   741,  2538,  4314,
   -2776,   729,  4127,  3194,  4315, -2776,  3197,  3902,    49,  4303,
    2538,  4222,  3434,    49,  4087,  2762,  4232,  1766,  1193,   619,
    3903,    50,  4800,  2538,  3936,  4269,    50,  2538,  4156,  1201,
    4049,  3949,   647,  1197,  2538,  4653,   619, -1632,  1204,  3323,
    2763,  2760, -2776,  3469,    51,   619,   619,  4316,  1212,    51,
    4630,  3954,  5506,  1214,  3955, -1055,  2761,  3979,  1215,  4679,
    5511,  2761,  5834,  4317,  2564,  4853,  4013,    57,  1217,  2538,
    2761,   941,  5931,  4173,  5932,  3365,  4174,  5869,   885,  2758,
    2761,  1221,   885,   885,  4364,  2762,  5856,  5857,  4178,   941,
    2762,  4179,   649,   941,  4110,  2534,  1223,   941,  3404,  2762,
    3407,   894,   895,  1009,  5786,   941,  1417,  1010,  4203,  2762,
    2763,  4204,  1222,  3321,  4670,  2763,  4677,  4265,  1225,  4387,
    4204,  3559,  4388,   941,  2763,  4390,   619,  3401,  4391,  5436,
    4421,  1227,  4661,  4422,  2763,  1232,    29,   619,  1224,   885,
     619,  4652,   619,   619,   651,   885,  1226,  4506,  5733,  2758,
    4507,  1234,  4517,  2629,  2758,  4518,  4528,   941,  4696,  2538,
    1417,  4318, -1620,  2758,  4556,  4160,  4558,  4162,  1109,  1595,
    4988,  4602,  4990,  2758,  4603,  2937,  4607,   941,   941,  4608,
    4612,  4636,  4454,  3388,  3072,  1354,   885, -2776,  5929,  4854,
    3215,  1596,  3072,  4919,  4942,  1361,  1970,  2538,  4695,  4351,
    3645,  3323,  4982,  2761,  5032,  2538,  1357,  3388,  1766,   941,
    4093,  4094,  1766,  5495,  5038,  3455,  5045,  5039,  4130,  3072,
    5046,  3323,  5180,  3072,  3314,  5181,  4096,  4324,  4576,  1363,
    4579,    41,  2762,  5217,  3323,   941,  4422,  1766,  5250,  1362,
    5251,   941,  1597,  4295,  5234,  1367,  5236,  5235,   941,  2538,
    5254,  5264,  1371,  5255,  1923,   941,  1386,  2763,   941,  5975,
    1376,   660,  5270,   661,   941,  4361,  1377,    45,  5272,   187,
    4114,  4361,  5383,  5403, -1088,  5384,  3072,  5437,  5478,  5484,
    5438,  5479,  1923,  1383,   941,  1387,   664, -2776,   616,  1822,
     941,  4630,  2040,  4187,  1400,  2041,  2758,   941,  2470,  2471,
    2472,  2473,  2474,  2475,  5487,  4255,  1402,  4361,  4673,    49,
     941,  4262,  1202,  1202,  5498,  3593,  1202,  5499,  5178, -1703,
   -1703,  5541,    50,   941,  5542,  1109,  2527,  5581,  1766,  1379,
    2495,  1598,  3916, -2776,   941,  5608,  5022,  5631,  5499,  4871,
    3955, -1707, -1707,  5632,  3944,    51,  2538,  5646,  5650,  1417,
    5647,  1923,   619,   619,   619,  4208,  4237,  5651,   619,  2529,
    2538, -1706, -1706,    57, -1392,  3172, -1392,  5670,  5355,  1418,
    3072,  1429,  4604,  3190,  4217,  5733,  3967,  5676,  1444,  1599,
    3109,  4630,  1600,  1445,  5682,   619,   885,  3109,  5683,  1495,
    5686,  3109,  3323,  2538,  1766,  4864,  5687,  2828,  3879,  2538,
    3881,  3882,  5688,  3787,    41,  5689,   919,  5715,  1448,   931,
    5716,   931,   931,  1454,  5356,  5768,  5658,  5782,  4361,  3994,
    2538,  5784,  2040,  1412,  2538,  2041,  4632,  4633,   619,  4512,
    5801,  1602,  5823,  5802,  5868,  5824,  1521,  5492,  5893,  5357,
      45,  5499,  1524,  5927,  5947,  4461,  5928,  2538,  1526,  5965,
    3323,  3876,  5647, -2277,  2629,  1527,  2527,  5358,  3765,  1562,
     885,  5359,  4342, -2776,   885,  5971,  5988,  1567,  5972,  5972,
    1566,  1568,  2569, -2776,  1202,  1579,  1604,  1581, -2776,  4630,
    1591,  1594,    49,  5360,  1616,  1631,  5361,  1632,  1648,  2529,
    1658,  1659,  1662,  1667,  1668,    50,  4423,  1780,  4425,  1605,
    4427,  5362,  1782,  1789,  1784,  1795,  1800,  1803,   966,  1805,
    1810,  1813,  1815,  1807,  1824, -2776,  1825,  1829,    51,  1607,
    1832,  1830,  3321,  1672,  -183,  1833,  2040,  1837,  4335,  2041,
    4338,  1835,  1838,  1849,  1856,  1860,    57,  1864,  1873,   213,
    1878,  1879,  1880,  4325,  1882,  4327,  1885,   941,  1886,  1889,
    1890,  4445,  1897,  1901,  1903,  1904,  1906,  1908,  4534,  1913,
    2527,  1770,  1914,   885,  1916,   941,  1919, -2776,  2534,  4355,
    1922,  1925,   941,  1928,  1926,  1945,   619,  2040,   885,   619,
    2041,   619,   619,   885,  1975,   897,  1981,  4679,  1983,  5363,
    1984,   619,  1990,  2529,  1991, -1858,   619,  2569,  1109, -1865,
    1109,  2000,  1998, -2776,  3323,  1999,  2001,  2002, -2776,    57,
    4055,  2527,  2004,  2005, -1855,  2006, -1856,  2007, -2776,  2008,
    2009,  2010,   619,   619,   619,  2012,  2013,   619,  4396,   897,
   -1859,  2014,  2015,  2016, -1857,   619,   619,   619,   619,  2017,
    5364,  2018,  2019,  1766,  2529, -2776,  2481,  2021,   619,  1766,
    5065,   619,   187,   619,  2022,  3521,  5228,  4690,  2023,  2024,
   -2776,  2025,  4537,  2026,   619,   619,  4438,  2027,   619,  2483,
    2028,  2485,  2486,  2499,  2511,  4671,  3969,  2495,  3970,  4453,
    3544,  2519,  2541,  1109,  2542,  2547,  2549,   619,  2550,   619,
    2553,   619,  2556,  2554,  3323,  2557,  2559,   616,  2534,  2558,
    2560,  2565,  3971,  2572,  1432,  1434,  2603, -2776,  2605,  2614,
    2616,   619, -2776,  4538,  2617,  2618,  2619,  4000,  4001,  4002,
    2635,  2636,  2638,  2637,  2563,  2639,  2640,  2641,   897,   941,
    2642,  2643,  2644,   776,  2650,  2669,  2675,  4898,  2681,  3217,
    2695,  3218,  2699,  2702,  2701,  2706,  2703,  2705,  2719, -2776,
    2725,  2723,  2736,  2724,  2879,  4648,  2737,  2752, -2776,  2757,
   -2776,  2748,  2564, -2776,   619,  3219,  2754,   619,  2758,  2755,
    4719,  2470,  2471,  2472,  2473,  2474,  2475,  2756,   897,   619,
    2765,  2767,  2766,  2770,   619,  2772,  2771,  2791,  2777,  2778,
   -2776,  2781,  3323,  2798,  2787,  2788,  2792,  2794,  2795,   619,
   -2776,  2808,  2534,  2815,  3220,  3221,  3222,  3223,  2793,  2822,
    2825,  3972,  4788,   619,  4775,  1540,  2840,  3973, -2775,  2842,
    2848,  2801,  2804,  2844,  2805,  2850,  2851,  2867,  2810,  2032,
    2811,  2868,   885,  2823,  2830,   885,  2831,   885,  2904,  2836,
    2837,  2843,   885,  2875,  2845,   919,  2856,  2857,   931,  2869,
     931,   931,  2897,  2534,  2880,  2909,   941,   941,  3321,  2911,
    3209,  3321,   619,  2912,  2925,  4780,  2913,  3220,  3221,  3222,
    3223,  2914,  2918,  2032,  3224,  3225,  2919,  2920,  2922,  2926,
    3226,  2923,  2924,   941,  2930,  2932,   941,  2933,  2940,   885,
   -2776,  2931,  2941,   642, -2776,  3215,  2944,   885,  2955,  2949,
    2958,  2470,  2471,  2472,  2473,  2474,  2475,  3321,  2969,  2973,
    2974,  3988,  1613,  2977,  2993, -2775,  2986,  3002,  3013,  2989,
    2992,  3019,   885,  3023,  3035,  3037,  2959,  3038,  3040,  3006,
    3039,  3053,  3341,  3093,  2976,  3323,  3118,  3010,  3137,  3106,
    3028,  5463,  2879,  3085,  3142, -2776,  3189,  3195,  2041,  3199,
    3208,  3214,  3231,  5200,  3233,  3253,  3254,  3272,  1766,  1766,
    1766,  3275,  3277,  3276,  3974,  3278, -2775,  3290,  3292,  4020,
    5477,  3291,  4025,  1407,  3293,  3975,  3307,  4055,  3294, -2775,
    3295,  3299,   941,  3308,  3325, -2775,  3034,  3342,  3330,  3343,
   -2775,   885,  3344,   885, -2776,  3345, -2775,   904,  3359, -2775,
    3366,   941,  3377, -2775,  4915,  2470,  2471,  2472,  2473,  2474,
    2475,  3378,  3380,  2879,  3410,  3408,  3405,  3412,  3314,  3323,
     941,  3413,   896,  3419,  3435,  3323,  3424,  3227,  3429,  3430,
    3432,  3443, -2775,   616, -2775,  3459,   616,  3464,  3228,  1351,
    3483,  3466,  3496,  3501,  1355, -2776,  3527,  2040,  3476,  3528,
    2041,  3502, -2775,  3534,  3537,  3573,  2470,  2471,  2472,  2473,
    2474,  2475,  3529,  3631,  3545,  3656,  3552,  3589,  3572,  3644,
    3665,  3672,  3678,  3684,  3700,  4478,   905,  3679,  3680,  3711,
    3712,  2527,   616,  3652,   885,  3653,  3689,  3726, -2776,  3730,
    3732,  3741,  3728,  3748,  3754,  3759,  3760,  3761,  3762, -2775,
    3763,  3767, -2775,  3774,  4907,  3770,   941,  4909, -2775,  4505,
    3775,   619,  3778,  3779,  2529,  3784,  2569,   619,  3800,  3799,
    3801,  3809,  3811,  3323,  3810,  3772,   885,  3813,  3815,  3829,
    3831,  4924,  3832,  1923,  3835,  3837,  3840,  3841,  3842,  3845,
    3843,  3853,  3844,  3119,  4826,  4827,  1920,  3855,  3857,  3864,
    3856,  3872,  5161,  1766,   885,  4547,  3874,  3867,  3880,   941,
    3900,   941,  3951,  3963, -2126, -2775,  3968,  3977,  3986,  4967,
    3991,  3897,  1887,  3898,   941,  3913,   941,  3987,  1199,  3899,
    4023,  3904,  3905,  4976,  3909, -2554,  3657,  3911,  3912,  4090,
    3935,  4051,  5013,  4066,  4011,  3940,  1238,   619,  4068,  3917,
    3941,  3948,  3962,  3918,  3919,  3920,  4864,  2538,  3989,  3990,
    3993,  4012,  4017,  4019,  4018,  4047,  4024,  3210,  4084,  4057,
    4526,  4032,  4077,   885,  4064,  4102,  4097,  4103, -2776,  4106,
    4109,  4070,  4134, -2776,  4095,  4111,  5072,  4123,  4098,  4124,
    4381,  4135,  4136,  4141,   941,   885,  4140,  4142, -2775,  4143,
    4158,  4147,  4159,  4161,  4910,  4911,  4912,  4913,  4914,  4169,
    4167,  4168,  4177,  4182,  4191,  4207,  4209,   885,  4211,  5508,
   -2776,  4218, -2775,  4212, -2775, -2775,  4418,  4205,  4213,  4216,
    4219,  4223, -2554,  4220,  4221,  4238,   941,  4240,  4239,  4241,
    4242,  4245,  1970,  5020,  4254,  4257,  4243,  4244,  1238,  4385,
    4246,  3917,  4541,   941,  4247,  3918,  3919,  3920,  4261,  4248,
    2865,  4249,  4250,  4273,  5133,  4251,  4252, -2775,  5054, -2775,
   -2775,  4253,  4972,  2534,  4263,   941,  4264,  4270,   941,  4274,
    4259,  4280,  4275, -2554,  4277,  4285,  4291,  4293,  4328,  4333,
    4340,  4334,  4343,  4344,  4346,   619, -2554,  4350,   885,  4361,
    4363,  4360, -2554,  4370,   619,  4373,  4379, -2554,  4380,  5078,
    5079,  4384,   619, -2554,   619,  4400, -2554,   619,  4417,  4432,
   -2554,   885,   619,   619,   619,   619,  1202,  4386,   619,   619,
     619,   619,   619,   619,   619,   619,   619,   619,  4414,  4383,
    4433,   619,   619,   619,  4447,  4434,   885,  4424,  4420, -2554,
    4426,   619,   897,  4446,  3922,   619,  4439,  1766,  4435,   619,
    4444,  4436,  4448,  4437,  4457, -2776,  5017,   619,  4458, -2554,
     619,  4459,   619,  4470,  4460,  4462,  1993,  4463,  4464,  4465,
    4466,  3917,   619, -2125,   187,   619,   619,  4530,  4479,  4519,
     619,   619,  4531,  4572,  4573,  4542,  4580,   619,  5121,  5122,
    4549,  4550,  4551,  4552,  4586,  4561,  4587,  4055,  4581,  4588,
    4502,  4599,  4601,  4605,  4565,  5063, -2554,  4503,  4504, -2554,
     187,  4596,  3923,  4548,   191, -2554,  1045,  1048,   619,  4570,
    1046,  1047,  4055,  4511,  5862,  5863,   619,  4615,  4533,  4623,
     619,  4644,  4557,  4645,  4559,  4568,  4585,  4590,  4654,  4646,
    4647,  5200,  4655,  4657,  4660,  4666,  3922,  4658,  4665,  4682,
    4685,  4697,  4698,  4701,  4713, -2776,  4714,  4699,  3172,  3172,
    4700,  4715,   619,  3172,  4711,  4712,  2470,  2471,  2472,  2473,
    2474,  2475, -2554,  4725,  4740,  4716,  4727,  4728,   619,  4741,
    4746,  4749,  5144,  4765,   885,  4766,  4768,  4672,  5104,  4771,
    4782,  4784,  4785,  4786,  4837,  4781,   619,  4797,  4808,  4844,
    3172,  3172,  4818,  4823,  4829,  4843,  4849,  4850,  4856,  4872,
    5111,  5112,  4866,  5114,  3923,  4873,  4883,   941,  5216,  4894,
    3321,  5218,  5219,  4889,  3321,  4890,  4892,   772,  4908,  4896,
    4893,  4897,  4916,  4921,  4902,  4923,  4931,  4944,  5223,  4956,
    4938,  4959,  4960, -2127,  4939,  5287,  5354,  4950,  5006,  5019,
    5018,  5031,  2829,  5015,  4961, -2554,  5033,  5028,  5035,  4978,
    4965,  4992,  5040,  5041,  4996,  4999,  5010,  5047,  1766,  5051,
    5069,  5070,  5512,  1766,   885,  1766,  5071,  5074,  5081, -2554,
    5082, -2554, -2554,  5094,  5080,  5163,  2032,  5101,  5103,  5115,
    3321,  5097,  5106,  5107,  5116,  5123,  5125,  5124,  1766,   885,
    5134,  5137,  5141,  4055,  5130,  5142,  5145,  5150,  5153,  4953,
    5158,   187,  3924,  3925,  3926,  3927,  3928,  3929,  3930,  3931,
    3932, -2554,  5159,  5160, -2554, -2554, -2554,  5162,  4731,  5166,
    5168,  3314,  5177,  5172,  5182,  3314,  5184,   941,  5188,  4739,
     941,  5189,  5193,  5191,  5195,  5535,  5196,  5537,  5214,  5206,
    5212,  5197,  5229,  3374,  5239,  5221,  3072,  5222,  5233,  5247,
    5241,  5252,  5242,  5240,  5256,  5262,  5288,  5266,  5269,  5291,
    5294,  3390,  5297,  5307,  5312,  3393,  5315,  5316,  5309,  3396,
    1238,  5311,  5317,  3917,  5369,  5322,  5328,  3918,  3919,  3920,
    5329,  5333,  5338,  5339,  5340,   616,  5376,  5347,  4807,   616,
    5378,  5379,  5387,  5406,   619,  3420,  5386,  5480,  5382,  5407,
    5411,  5416,  5434,  5418,  3924,  3925,  3926,  3927,  3928,  3929,
    3930,  3931,  3932,  5439,  5447,  5445,  5446,  5453,  5472,  5468,
     941,   941,  5492,  5476,   885,  5641,  5488,  5490,  5494,  3462,
     941,  5507,  5493,  5516,  5496,  5517,  5562,   619,   619,  5515,
    5523,  5529,  5560,  5568,  5572,  5573,  5575,   941,  5545,  1065,
    5263,  5583,  5597,  5601,  5602,   616,  5588,  5603,  5605,  5614,
    5604,  5263,  5615,  5622,  5616,  5624,  5617,  5469,  5626,  5639,
     885,  5400,  5633,  5640,  4875,   885,   619,   619,  5643,  5663,
    5653,  3512,  4543,  5662,  5675,  5679,  5698,   619,  5704,  5709,
    5711,  5718,  5714,  5721,  5722,  5738,  5303,   966,  5739,  5740,
    5741,  1238,  5755,  5765,  3917,  5699,  5701,  3540,  3918,  3919,
    3920,  5754,  5748,  3549,  5749,  5764,  5766,  5778,  5771,  5320,
    3555,  5780,  5796,  5787,  5789,  4973,   941,  1065,  5805,  5707,
    3569,  3321,  3321,  5798,  1238,  5708,  3574,  3917,  5813,  5812,
    5830,  3918,  3919,  3920,  5832,  5814,  5854,  5849,  5325,  5547,
    5864,  5878,   619,  5897,  5867,  5907,  3587,  5871,  5916,  5876,
    5933,  5934,  3590,   619,  5903,  5904,  5938,  2040,  5953,  3596,
    2041,  5935,  5937,  5955,  2042,  2043,  2044,  5956,  3922,  5964,
    5969,  5970,  3611,  5977,  5978,  5981,  5645,  5982,  1419,  5985,
    5441,   619,  1525,  2881,   619,  3636,  3735,  2518,  3604,  4009,
    3526,  2527,   619,   619,  5504,   885,  1065,  4153,  2528,   619,
     619,  4688,  4681,  5799,   619,  3643,  3691,  4290,   619,  5366,
    5692,   619,   619,  5417,  5877,  4678,   619,  4825,  5140,  5399,
    4100,  3839,   619,  5791,  2529,  5301,  5873,  5712,  5693,  5710,
    5811,  5888,  3314,  4105,  5170,  4876,  3923,  4855,  5354,   619,
    5673,  5803,  3709,  4847,  4817,  5540,   619,  3710,  4686,  4171,
    1615,   619,  4349,  4842,   619,   619,  5164,  5405,   187,  4389,
    1238,  4900,   619,  3917,  5618,  5930,  5987,  3918,  3919,  3920,
    5979,  5380,  4296,   619,  5816,  5327,  2948,  5525,  4884,  5681,
    5330,   723,   774,  4917,  1967,  1041,  5021,  5023,  5034,  5502,
    5926,  3739,  3012,  5705,  3383,  3008,   616,   616,  4091,  3922,
     619,  3024,  4406,  5442,  4886,  5612,  3041,  5485,  5858,  5859,
    1110,  3113,  4260,  3641,  4717,  5836,  1150,  5954,   885,  2649,
    4904,  1364,  3114,  3668,  5290,  3329,  4903,  5024,  5785,  4609,
     811,   941,  3922,  3321,  2906,   812,  4053,  2539,  2530,  4065,
    3321,  5783,  3339,  2531,  5655,  3321,  4027,  4563,  3321,  2491,
    4578,  5268,  4021,  5475,  5474,  2600,   885,  5629,  4610,  4022,
    2599,  5067,  5944,  5770,  5865,  2532,  2228,  3923,  5644,  5464,
    2609,  5075,  2548,   941,  5656,  4513,  5657,  3258,   885,  2604,
    2533,  3984,  3178,  3667,  3892,   941,  3982,  3327,  5539,  1415,
    3267,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3923,   619,     0,     0,     0,     0,     0,     0,     0,  3852,
       0,     0,     0,     0,   941,     0,     0,     0,     0,  2278,
       0,     0,     0,     0,     0,     0,     0,  3866,     0,     0,
       0,     0,     0,  2534,  3852,     0,  3924,  3925,  3926,  3927,
    3928,  3929,  3930,  3931,  3932,   885,     0,     0,     0,     0,
       0,  3314,     0,  5534,     0,     0,  3314,     0,     0,  3314,
       0,     0,     0,  5668,     0,     0,     0,  1109, -2776,     0,
       0,   619,     0,     0,     0,     0,     0,     0,     0,     0,
     187,   187,     0,     0,  1498,     0,  5693,   619,  3172,  3172,
    3172,  3172,  1766,     0,  3172,  3172,  3172,  3172,  3172,  3172,
    3172,  3172,  3172,  3172,     0,     0,     0,     0,   616,     0,
       0,   941,     0,     0,     0,   616,     0,     0,   619,  1499,
     616,  4509,     0,   616,  5008,  2536,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3923,   966,     0,     0,
       0,  5175,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3172,  3172,  5665,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   885,     0,   885,  3924,  3925,  3926,
    3927,  3928,  3929,  3930,  3931,  3932,     0,  4055,     0,     0,
    1500,     0,     0,     0,  5324,     0,     0,     0,     0,   966,
       0,     0,     0,  5326,  4567,     0,     0,   941,     0,     0,
    3924,  3925,  3926,  3927,  3928,  3929,  3930,  3931,  3932,     0,
       0,     0,  3321,     0,     0,   619,  1501,  5465,   619,     0,
       0,   619,   619,   619,     0,  2466,     0,     0,  5368,     0,
       0,  5962,     0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,
    2474,  2475,     0,     0,     0,     0,   619,   619,     0,     0,
     619,  5486,  1502,     0,     0,     0,     0,  1109,  2034,     0,
       0,     0,     0,     0,  5973,     0,     0,     0,  5962,     0,
     619,     0,     0,     0,     0,     0,   619,     0,  5962,     0,
     619,     0,  5870,     0,     0,     0,   885,   619,     0,     0,
       0,     0,  1504,     0,     0,     0,     0,     0,     0,     0,
     619,     0,   619,     0,     0,     0,     0,   941,     0,   941,
       0,     0,     0,   619,     0,     0,     0,     0,     0,     0,
    5530,  5531,     0,     0,  1506,     0,     0,     0,     0,     0,
    1469,     0,     0,     0,  5289,   187,  3924,  3925,  3926,  3927,
    3928,  3929,  3930,  3931,  3932,  4112,     0,     0,     0,     0,
       0,     0,     0,     0,   885,   941,  5147,     0,     0,     0,
       0,     0,   617,     0,     0,   619,    36,     0,  2715,     0,
       0,  1508,     0,     0,  3321,     0,     0,     0,  1595,   767,
    1509,   769,  5980,     0,     0,   775,     0,   616,  1510,     0,
       0,   792,   800,   767,  3321,   807,  2716,     0,   800,   800,
    1596,   836,  5534,   839,  1766,     0,     0,  3321,  1512,   619,
     893,   893,   893,     0,     0,     0,     0,  1513,     0,     0,
       0,  1514,     0,     0,     0,     0,  4143,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4183,     0,     0,  5404, -2556,     0,
    5634,  1597,  4672,     0,     0,     0,     0,     0,     0,  2672,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5652,   619,  5654,     0,   885,  1515,     0,     0,  5430,     0,
    3172,     0,     0,     0,     0,  3314,     0,     0,    72,   191,
     176,   181,   186,    81,    84,   182,   184,    85,    86,     0,
      87,   107,   125,   619,   130,   160,     0,   619,   179,   619,
       0,   897,   185,     0,     0,  1109,     0,  4673,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   619,
       0,     0,   619,     0,     0,     0,  5432,     0,     0,     0,
    1598,     0,     0,   619,     0, -2556,     0,     0,     0,   616,
     619,     0,     0,   617,   921,   921,     0,     0,   921,     0,
       0,     0,   932,     0,   836,  3321,     0,   968,  4271,   616,
     932,     0,     0,   932,     0,     0,   836,     0,   921,     0,
    1528,   836,   616,     0,     0,   921,  1529,   836,  1599,     0,
       0,  1600,     0,     0,     0,     0, -2556,   885,     0,     0,
       0,  1530,   885,   885,   966,     0,  2828,   619,     0, -2556,
    4674,     0,   619,   619,   941, -2556,     0,     0,     0,     0,
   -2556,     0,     0,  3321,     0,     0, -2556,     0,   941, -2556,
       0,  1531,     0, -2556,   931,     0,     0,     0,     0,     0,
    1602,   187,     0,     0,     0,     0,     0,     0,   619,     0,
       0,     0,     0,     0,     0,   619,     0,     0,  1766,     0,
       0,     0, -2556,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   187,     0,     0,     0,     0,     0,   931,     0,
    4958,     0, -2556,   619,     0,  1604,   187,  1532,     0,     0,
       0,     0,     0,     0,  1533,     0,  5591,  1534,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1605,     0,
       0,     0,   885,   885,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1535,     0,     0,     0,  1607, -2556,
    4675,     0, -2556,  4676,     0,     0,   619,     0, -2556,     0,
     616,     0,   619,     0,     0,     0,     0,     0,  2879,     0,
       0,     0,     0,   619,  1766,  2032,     0,   885,  1536,     0,
       0,     0,   619,     0,   619,  4440,   619,     0,     0,  5795,
       0,     0,     0,   619,     0,     0,     0,  3321,     0,     0,
       0,  5659,     0,     0,     0,     0,     0,     0,     0,     0,
    4456,   619,     0,     0,     0, -2556,     0,     0,   616,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1766,     0,   941,     0,
       0,  1537,     0,     0,     0,  1538,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1539,     0,     0,     0,  2758,
       0,  5842,  5843,     0,  1540,     0,     0,     0,     0,     0,
     772,     0,     0,     0,     0,     0,  1541,     0,  5920,     0,
       0,     0,     0,     0,     0,     0,     0,  3321,     0,     0,
       0,   619,     0,     0,     0,     0,     0,     0, -2556,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3314,     0,
     187,     0,     0,     0,     0,  1542, -2572,     0,  1543,  1544,
       0,     0, -2556,     0, -2556, -2556,     0,     0,     0,   619,
     619,   619,     0,     0,     0,     0,     0,   619,     0,     0,
       0,     0,     0,     0,  5574,     0,     0,   619,     0,  1545,
       0,     0,     0,     0,     0,     0,     0,   941,     0,     0,
       0,     0,     0,     0, -2556,     0,     0, -2556, -2556, -2556,
     619,     0,   616,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   941,     0,  3321,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   187,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1020,     0,     0,     0,
       0,     0,   836, -2572,   921,     0,   921,  1546,     0,   921,
       0,     0,     0,     0,   619,     0,   968,  5817,     0,     0,
       0,  1077,     0,   921,   619,     0,     0,     0,     0,   921,
       0,     0,   619,   619,     0,     0,     0,     0,   619,   191,
     619,  5838,  5841,     0,     0,  5839,  5840,     0,     0,  4649,
       0,     0,   616,   617, -2572,     0,   619,   619,     0,     0,
       0,     0,   932,     0,     0,     0,   968, -2572,     0,   932,
       0,     0,   932, -2572,     0,     0,     0,     0, -2572,  5902,
    5983,  5984,     0,     0, -2572,     0,   941, -2572,   921,     0,
       0, -2572,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   619,     0,
       0,     0,     0,     0,   619,     0,     0,     0,  3321,     0,
   -2572,     0,     0,     0,  3172,     0,   191,     0,  5838,  5841,
       0,   619,  5839,  5840,     0,     0,     0,     0,     0,   836,
   -2572,     0,   800,   800,   800,     0,     0,     0,     0,     0,
     616,   619,     0,     0,     0,   619,     0,  1220,     0,     0,
     619,     0,     0,     0,     0,     0,     0,     0,     0,  4754,
       0,     0,  4757,     0,     0,     0,  3172,  1336,  1336,     0,
     836,   800,     0,     0,     0,   800,     0, -2572,     0,     0,
   -2572,   619,     0,     0,     0,     0, -2572,     0,   619,   836,
       0,     0,  3321,   836,     0,     0,     0,     0,  3321,  1336,
       0,   187,   619,     0,  1498,     0,     0,     0,     0,  1766,
       0,     0,     0,     0,   191,     0,  5838,  5841,     0,   931,
    5839,  5840,     0,     0,     0,     0,   187,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   619,   619,  1499,
       0,     0,   619, -2572,  1336,     0,  1766,     0,     0,     0,
       0,   619,   619,     0,     0,     0,  1766,     0,   836,     0,
       0,     0,  4839,     0,     0,     0,     0,     0,     0,     0,
     836,     0,     0,     0,  1528,     0,     0,     0,     0,  2879,
    1529,     0,     0,   616,     0,   836,     0,     0,     0,     0,
       0,   931,   931,     0,  2040,     0,  3321,  2041,   772,     0,
    1500,  2042,  2043,  2044,   836,     0,     0,     0,     0,   921,
     921,     0,     0,  5901,     0,     0,     0,     0,  2526,     0,
       0,     0,     0,     0,     0,  1531, -2572,     0,  2527,     0,
       0,     0,     0,     0,     0,  2528,  1501,     0,     0,     0,
       0,   800,   800,     0,     0,     0,     0,     0,     0,     0,
   -2572,     0, -2572, -2572,     0,     0,     0,     0,  3852,     0,
       0,  2529,     0,     0,  1336,  1336,     0,   616,     0,     0,
       0,     0,  1502,   616,     0,     0,     0,   617,     0,   921,
       0,  1532,     0,   932,     0,     0,   968,   932,  1533,   932,
    5906,  1534, -2572,     0,   921, -2572, -2572, -2572,     0,  3172,
       0,     0,     0,     0,     0,     0,     0,     0,  1503,     0,
       0,   187,  1504,     0,     0,     0,     0,   836,  1535,     0,
       0,     0,     0,     0,   921,   921,     0,     0,  3172,     0,
       0,  2040,     0,     0,  2041,     0,     0,     0,  2042,  2043,
    2044,     0,     0,  1505,  1506,   836,   836,   836,     0,   921,
    1469,   617,  1536,   617,   617,  2526,     0,  5941,     0,     0,
       0,     0,     0,     0,     0,  2527,     0,     0,     0,     0,
       0,   616,  2528,     0,     0,  2530,     0,     0,     0,     0,
    2531,     0,  1507,     0,     0,     0,    36,   921,     0,   921,
     921,  1508,     0,     0,     0,     0,     0,     0,  2529,     0,
    1509,     0,  2532,  2228,     0,     0,     0,  5941,  1510,     0,
       0,  5976,     0,     0,     0,  1635,  1511,  2533,     0,  1538,
     931,   931,  1336,     0,     0,     0,     0,     0,  1512,  1539,
       0,     0,     0,     0,     0,     0,     0,  1513,  1540,     0,
       0,  1514,     0,     0,     0,     0,     0,     0,  1948,  1948,
    1541,     0,     0,   836,     0,   767,  2278,  2040,     0,     0,
    2041,     0,     0,     0,  2042,  2043,  2044,     0,     0,   871,
    2534,     0,     0,  2535,   836,     0,     0,     0,     0,     0,
    1982,  2526,     0,   836,     0,     0,  1988,     0,     0,  1663,
       0,  2527,  1543,  1544,     0,  1515,     0,     0,  2528,     0,
    1336,  2040,     0,     0,  2041,     0,     0,     0,  2042,  2043,
    2044,     0,  2530,     0,     0,  5088,     0,  2531,     0,     0,
       0,     0,     0,  1664,  2529,  2526,     0,  5098,     0,     0,
       0,  1336,     0,     0,     0,  2527,     0,     0,     0,  2532,
    2228,     0,  2528,     0,     0,     0,     0,     0,     0,  3172,
       0,     0,     0,     0,  2533,     0,     0,     0,     0,  1336,
    1336,  1336,  2536,  1336,     0,     0,     0,     0,  2529,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1336,     0,     0,     0,     0,     0,     0,
       0,  1546,     0,  2278,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2534,     0,     0,
    2535,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   836,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2530,  1336,
       0,     0,     0,  2531,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2466,     0,     0,  2532,  2228,     0,     0,     0,
    2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,
    2533,     0,  2530,     0,     0,  1336,  3908,  2531,     0,  1336,
    1336,     0,     0,     0,     0,     0,     0,     0,     0,  2536,
     836,   836,  2613,     0,  1336,     0,     0,     0,     0,  2532,
    2228,     0,     0,  5769,     0,     0,     0,     0,     0,  2278,
       0,     0,     0,     0,  2533,     0,     0,   800,     0,     0,
       0,     0,     0,  2534,     0,     0,  2535,     0,     0,  3852,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2704,  2278,     0,     0,     0,   800,     0,     0,
     921,     0,     0,     0,     0,     0,     0,  2534,     0,     0,
    2535,     0,     0,   836,  2732,     0,     0,     0,     0,     0,
       0,     0,   836,     0,     0,   921,     0,     0,     0,  2466,
       0,     0,     0,     0,     0,     0,     0,  2467,  2468,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,     0,     0,     0,     0,
       0,     0,   968,  3958,   836,  2536,  2040,   800,     0,  2041,
       0,     0,     0,  2042,  2043,  2044,     0,     0,     0,     0,
       0,     0,  3172,  3172,   800,     0,     0,   836,     0,  3852,
     836,  3852,     0,     0,     0,     0,     0,     0,   758,     0,
    2527,     0,     0,     0,   758,     0,     0,  2528,     0,  2536,
       0,     0,   921,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   836,     0,
       0,     0,     0,  2529,     0,     0,     0,     0,     0,     0,
     921,   921,   921,   921,   836,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   836,     0,
       0,     0,     0,     0,     0,  2466,     0,     0,     0,  1336,
    1336,  1336,     0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,
    2474,  2475,     0,     0,     0,     0,  3198,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2466,
    1528,     0,     0,     0,     0,     0,  1529,  2467,  2468,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,     0,     0,     0,     0,
    4292,  1633,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2530,     0,     0,
       0,     0,  2531,     0,     0,     0,     0,     0,     0,     0,
       0,  1531,     0,     0,     0,     0,     0,   836,     0,     0,
       0,     0,     0,     0, -2776, -2776,     0,     0,   836,     0,
       0,     0,     0,     0,     0,     0,   921,   921,     0,  2533,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   921,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1634,     0,  1532,     0,     0,
     836,     0,     0,     0,  1533,     0,     0,  1534, -2776,     0,
       0,     0,     0,     0,     0,     0,   921,   921,   921,   921,
       0,     0,  2534,     0,     0,   836,     0,     0,     0,  1121,
       0,     0,   836,     0,  1535,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   617,
       0,     0,   617,     0,     0,  1121,     0,  2040,     0,     0,
    2041,     0,   932,   932,  2042,  2043,  2044,     0,  1536,     0,
       0,     0,     0,   968,   968,  2040,     0,   932,  2041,     0,
     932,  2526, -2776, -2776, -2776,     0,     0,     0,     0,     0,
       0,  2527,     0,     0,     0,   921,   921,     0,  2528,     0,
       0,     0,   921,     0,   836,     0,     0,     0,     0,  2527,
       0,     0,     0,     0,  2536,     0,  2528,     0,     0,     0,
       0,  1948,     0,     0,  2529,     0,     0,     0,   921,     0,
     932,  1635,     0,   932,   932,  1538,   836,   836,     0,   921,
       0,     0,  2529,     0,     0,  1539,   836,     0,     0,     0,
       0,     0,     0,   836,  1540,     0,     0,     0,     0,   767,
     767,     0,     0,  3121,     0,     0,  1541,  1336,     0,  1336,
       0,     0,     0,     0,  1336,  1336,     0,     0,     0,     0,
       0,  1336,  1336,  1336,     0,     0,  1336,     0,  1336,   968,
    1336,  1336,  1336,  1336,  1336,  1336,     0,  1336,     0,  1336,
    1336,     0,     0,  1336,     0,  1636,     0,     0,  1543,  1544,
       0,     0,     0,     0,  2466,     0,     0,     0,  1336,  1336,
    1336,     0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,
    2475,     0,     0,     0,     0,  1336,     0,     0,  2530,  1637,
       0,     0,     0,  2531,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -135,     0,     0,  2530,     0,     0,     0,
       0,  2531,     0,     0,     0,  2532,  2228,     0,     0,     0,
       0,     0,     0,     1,     0,   921,     0,     0,     0,     0,
    2533,     0,     0,     2,     0,     3,     4,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2533,     0,
       0,     0,     0,     5,     0,     0,     0,  1546,     0,     0,
       0,     0,     0,     6,     0,     0,     0,     0,     0,  2278,
       0,     0,     0,     0,     0,     7,     0,     8,     9,     0,
       0,     0,     0,  2534,    10,     0,    11,     0,   920,   922,
       0,     0,   925,     0,     0,     0,     0,     0,    12,  1528,
      13,  2534,     0,     0,     0,  1529,     0,     0,     0,     0,
       0,     0,   983,  1787,     0,     0,     0,    14,     0,   993,
      15,     0,     0,     0,  1796,     0,     0,     0,  1336,     0,
       0,     0,     0,     0,     0,    16,     0,    17,     0,  1804,
       0,    18,     0,     0,     0,     0,     0,    19,     0,  3852,
    1531,     0,     0,     0,     0,    20,     0,    21,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,  1336,     0,
       0,     0,     0,     0,     0,  2536,     0,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2536,     0,     0,     0,     0,    24,     0,
       0,     0,     0,     0,     0,     0,  1532,     0,     0,     0,
       0,     0,     0,  1533,     0,     0,  1534,     0,     0,  1336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,    26,
       0,     0,     0,  1535,    27,     0,     0,     0,   758,     0,
     758,     0,   758,     0,     0,     0,    28,   686,   758,  1187,
    1188,     0,   687,     0,     0,     0,     0,     0,     0,     0,
     685,     0,     0,     0,    29,  2466,     0,  1536,     0,   771,
       0,     0,     0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,
    2474,  2475,     0,  2466,     0,     0,     0,     0,     0,  1973,
     688, -2776, -2776, -2776,  2470,  2471,  2472,  2473,  2474,  2475,
      30,     0,     0,   689,     0,     0,     0,     0,    31,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   690,
       0,     0,    32,     0,     0,     0,     0,     0,    33,    34,
    1635,    35,     0,     0,  1538,     0,    36,   691,     0,     0,
       0,     0,    37,     0,  1539,    38,     0,     0,     0,     0,
       0,     0,    39,  1540,     0,     0,     0,     0,    40,    41,
       0,   692,     0,     0,     0,  1541,    42,     0,     0,     0,
      43,     0,   693,     0,     0,     0,     0,     0,     0,     0,
      44,   694,     0,  1336,  1336,  1336,  1336,  1336,  1336,  1336,
    1336,  1336,     0,  1336,   695,    45,     0,     0,     0,   696,
       0,   836,  1336,     0,  1336,     0,   697,  1543,  1544,     0,
       0,   836,     0,     0,     0,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   698,    47,     0,     0,     0,
       0,     0,    48,     0,     0,     0,     0,    49,  1545,     0,
     836,     0,  1336,   758,     0,   921,  1336,     0,     0,  1336,
      50,  1336,     0,     0,  1336,     0,     0,     0,  1336,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   699,     0,    51,    52,    53,    54,    55,    56,     0,
       0,  3324,     0,     0,     0,     0,     0,   836,   836,     0,
       0,    57,     0,     0,  -135,     0,     0,     0,  1336,     0,
       0,     0,     0,     0,     0,     0,  1546,  1336,  1336,     0,
       0,   700,   758,     0,     0,     0,     0,     0,  1051,     0,
    1054,   836,     0,  1056,   701,     0,     0,     0,  3367,     0,
    3372,     0,     0,  1528,     0,   702,     0,  1081,     0,  1529,
       0,     0,     0,  1085,     0,   213,   703,     0,  2040,   704,
       0,  2041,     0,     0,  1633,  2042,  2043,  2044,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   767,
       0,   767,  2526,     0,     0,     0,   705,     0,     0,   706,
       0,     0,  2527,   707,  1531,   708,     0,     0,  1336,  2528,
       0,     0,   709,     0,     0,   710,     0,     0,     0,   617,
       0,     0,   932,   968,   932,   932,     0,     0,   921,     0,
       0,   836,     0,     0,   711,  2529,     0,     0,     0,     0,
       0,   712,     0,     0,     0,     0,     0,   713,     0,     0,
     714,     0,   800,     0,   715,     0,     0,     0,  1634,  2780,
    1532,     0,   716,  2732,   717,     0,     0,  1533,     0,   718,
    1534,  3480,   836,     0,     0,     0,     0,     0,  3491,     0,
       0,     0,   719,     0,     0,     0,     0,   836,     0,     0,
       0,     0,     0,     0,     0,   720,     0,  1535,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   836,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   836,   836,
       0,  1536,   836,     0,     0,   800,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2530,
       0,     0,     0,     0,  2531,     0,     0,     0,   921,     0,
       0,   921,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2532,  2228,     0,     0,
       0,     0,     0,     0,     0,     0,   836,   836,     0,     0,
       0,  2533,     0,     0,  1635,     0,     0,     0,  1538,     0,
       0,  3630,     0,  3633,  3635,     0,     0,     0,  1539,     0,
       0,     0,     0,     0,     0,     0,     0,  1540,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1541,
    2278,     0,     0,     0,  1336,  1336,  1336,     0,     0,     0,
    1336,     0,     0,     0,  2534,     0,     0,  2535,   921,     0,
       0,     0,     0,  1560,  1561,     0,     0,     0,     0,     0,
       0,   921,     0,     0,     0,     0,     0,  1336,  3601,   921,
     758,  1543,  1544,     0,     0,   758,   758,     0,     0,     0,
       0,  2910,  2732,     0,     0,     0,     0,   836,     0,     0,
     836,     0,  2921,     0,  3736,  1042,     0,   767,     0,     0,
       0,     0,  3602,  2544,     0,     0,     0,     0,  2939,   921,
    3747,     0,  2551,     0,  2552,     0,     0,     0,  2555,     0,
    3630,     0,     0,  1785,   884,  2561,     0,     0,     0,     0,
     921,     0,  3769,     0,     0,     0,  2536,     0,  1797,     0,
    2040,     0,     0,  2041,     0,  1108,   685,  2042,  2043,  2044,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3014,     0,     0,  2526,     0,     0,     0,  1819,  1820,
    1546,   921,     0,   921,  2527,   921,  3026,     0,     0,  1121,
    3030,  2528,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1857,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2529,  1948,     0,
    3049,  1121,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   758,     0,     0,     0,     0,
       0,     0,     0,  1894,  1896,     0,  2466,     0,     0,     0,
       0,     0,  1211,     0,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2474,  2475,     0,     0,     0,     0,  4472,   617,   921,
       0,   932,     0,   932,   932,     0,   921,     0,  1229,  1187,
    1188,     0,     0,  1336,     0,     0,  1339,     0,  1336,  1348,
    1108,  1350,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1528,     0,     0,     0,     0,     0,  1529,     0,
       0,     0,     0,     0,  1336,  1336,  1336,     0,     0,  1336,
       0,     0,   758,     0,     0,   758,   758,  1336,  1336,  1336,
    1336,  2530,     0,     0,     0,     0,  2531,     0,     0,     0,
    1336,     0,     0,  1336,     0,  1336,     0,     0,  3202,     0,
       0,     0,     0,  1531,     0,     0,  1336,  1336,  2532,  2228,
    1336,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2533,     0,     0,     0,   968,     0,  1336,
       0,  1336,     0,  1336,  2040,     0,     0,  2041,     0,     0,
       0,  2042,  2043,  2044,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1336,     0,     0,     0,   836,  2526,  1532,
       0,     0,  2278,     0,     0,     0,  1533,     0,  2527,  1534,
       0,     0,     0,     0,     0,  2528,  2534,     0,   836,  2535,
       0,  1528,     0,     0,     0,     0,     0,  1529,     0,     0,
       0,     0,     0,     0,     0,     0,  1535,     0,     0,     0,
       0,  2529,     0,     0,     0,     0,   617,     0,     0,  3324,
    4031,     0,     0,     0,  4031,  4045,  4031,     0,     0,     0,
       0,  1336,     0,     0,     0,     0,  1336,     0,     0,     0,
    1536,     0,  1531,     0,     0,     0,     0,     0,     0,  1108,
       0,  1336,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3324,     0,     0,     0,  4076,
       0,     0,  4079,     0,  3372,   758,     0,     0,  2536,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2040,     0,
       0,  2041,     0,     0,     0,  2042,  2043,  2044,  1532,     0,
       0,     0,     0,  1635,     0,  1533,     0,  1538,  1534,     0,
       0,     0,  2526,     0,  1336,     0,     0,  1539,     0,     0,
       0,  1948,  2527,     0,     0,  2530,  1540,     0,     0,  2528,
    2531,     0,     0,     0,     0,  1535,     0,     0,  1541,     0,
       0,     0,     0,     0,   921,   921,     0,     0,     0,     0,
       0,     0,  2532,  2228,     0,  2529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2533,     0,  1536,
    1498,     0,     0,     0,     0,     0,     0,  2696,  2466,     0,
    1543,  1544,     0,     0,  2714,     0,  2467,  2468,  2469,  2470,
    2471,  2472,  2473,  2474,  2475,     0,     0,     0,     0,  4522,
       0,     0,     0,     0,     0,  1499,  2278,     0,     0,  2753,
       0,  2697,     0,     0,     0,     0,     0,     0,     0,     0,
    2534,     0,     0,  2535,     0,     0,     0,     0,     0,     0,
       0,     0,  1537,     0,     0,     0,  1538,  1972,     0,     0,
       0,     0,     0,     0,     0,     0,  1539,     0,     0,     0,
       0,   836,     0,     0,     0,  1540,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1108,  1500,  1541,     0,  2530,
       0,     0,     0,     0,  2531,     0,     0,     0,     0,  1546,
       0,     0,     0,     0,     0,     0,  2835,  3143,  3144,     0,
       0,     0,     0,     0,  3158,  3159,  2532,  2228,     0,     0,
       0,     0,  1501,     0,     0,     0,  2773,     0,     0,  1543,
    1544,  2533,  2536,     0,  2860,  2861,  2862,  2863,     0,     0,
       0,     0,     0,  3200,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,     0,  1502,     0,
    2774,     0,  2036,     0,     0,     0,     0,     0,     0,     0,
    2278,  2038,     0,     0,     0,     0,     0,     0,     0,     0,
     884,     0,     0,  1336,  2534,  2489,     0,  2535,     0,  1336,
       0,     0,     0,     0,  1503,     0,     0,     0,  1504,     0,
     921,     0,     0,     0,  1108,     0,     0,  2506,  2507,     0,
       0,     0,  1108,  1108,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1546,  1569,
    1506,     0,  2466,     0,     0,     0,  1469,   836,   836,   836,
    2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,
       0,     0,     0,  4625,   836,     0,     0,     0,     0,     0,
    1528,     0,     0,     0,     0,     0,  1529,     0,  1570,  1336,
       0,     0,    36,  1595,     0,     0,  2536,  1508,     0,     0,
    2916,  2917,     0,     0,     0,     0,  1509,  1948,   836,   836,
       0,     0,     0,   836,  1510,  1596,  2934,     0,     0,     0,
       0,     0,  1571,     0,     0,   836,     0,     0,     0,     0,
       0,  1531,     0,     0,  1512,     0,     0,     0,     0,     0,
       0,     0,     0,  1513,     0,     0,     0,  1514,   884,     0,
    2978,  2979,  2980,  2981,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1597,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   921,     0,     0,     0,     0,     0,  1532,     0,     0,
       0,     0,  3436,     0,  1533,     0,  2466,  1534,  3444,     0,
       0,  1515,   836,     0,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2474,  2475,     0,     0,   836,     0,  4845,   836,     0,
       0,     0,     0,     0,  1535,     0,     0,     0,     0,     0,
    3055,     0,     0,     0,     0,     0,  3059,  1336,     0,  3477,
       0,     0,     0,     0,     0,  3789,  1336,     0,     0,     0,
       0,     0,     0,     0,  1336,  1598,  1336,     0,  1536,  1336,
       0,     0,     0,     0,  1336,  1336,  1336,  1336,     0,  1498,
    1336,  1336,  1336,  1336,  1336,  1336,  1336,  1336,  1336,  1336,
       0,     0,     0,  1336,  1336,  1336,  2833,     0,     0,     0,
    1682,     0,     0,  1336,  2841,     0,     0,  1336,     0,     0,
       0,  1336,     0,  1599,  1499,     0,  1600,     0,   884,  1336,
       0,     0,  1336,     0,  1336,     0,     0,     0,     0,   884,
       0,  1601,     0,     0,  1336,  1538,     0,  1336,  1336,     0,
       0,     0,  1336,  1336,   884,  1539,     0,  4545,     0,  1336,
       0,     0,     0,     0,  1540,     0,   836,   836,   836,     0,
       0,  2040,     0,     0,  2041,  1602,  1541,     0,  2042,  2043,
    2044,     0,     0,     0,     0,  1500,  4031,  4045,  4031,     0,
    1336,  4031,     0,     0,  4569,  2526,     0,     0,  3324,     0,
       0,     0,  3324,     0,     0,  2527,     0,     0,  4584,     0,
       0,     0,  2528,     0,     0,  1603,     0,     0,  1543,  1544,
    1604,  1501,     0,     0,     0,     0,     0,     0,     0,  3212,
       0,     0,     0,     0,  1336,     0,     0,     0,  2529,     0,
       0,     0,     0,  1605,     0,     0,     0,     0,  3372,  1606,
    1336,     0,  3790,     0,     0,     0,     0,  1502,     0,  3696,
       0,     0,     0,  1607,     0,     0,     0,     0,  4631,  1948,
    1948,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,  3296,
    3298,     0,     0,     0,     0,  3306,     0,     0,  2732,  4663,
       0,     0,     0,     0,   884,     0,     0,  1546,     0,     0,
       0,     0,     0,     0,     0,  2040,  2970,  4684,  2041,  1506,
    2975,     0,  2042,  2043,  2044,  1469,     0,  3348,  3348,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2526,
       0,     0,  2530,     0,     0,     0,     0,  2531,     0,  2527,
       0,     0,     0,     0,     0,     0,  2528,     0,     0,     0,
       0,    36,     0,     0,     0,     0,  1508,     0,     0,  2532,
    2228,     0,     0,     0,     0,  1509,     0,     0,     0,     0,
       0,     0,  2529,  1510,  2533,     0,     0,   758,     0,     0,
       0,  2716,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1512,     0,     0,     0,     0,     0,     0,
       0,     0,  1513,     0,     0,     0,  1514,  4772,     0,     0,
       0,     0,     0,  2278,     0,     0,  3865,     0,     0,     0,
       0,     0,     0,     0,     0,  3792,     0,  2534,     0,     0,
    2535,  3878,     0,     0,     0,     0,  3883,     0,     0,     0,
     921,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   921,     0,  1336,     0,     0,     0,
    1515,  3479,     0,   836,  3793,     0,     0,     0,     0,  4816,
       0,     0,     0,     0,     0,     0,     0,  3154,     0,     0,
    2732,     0,     0,     0,     0,     0,  2530,     0,     0,     0,
       0,  2531,     0,     0,   836,     0,     0,     0,     0,  3324,
    3747,     0,     0,     0,     0,     0,     0,  3630,     0,     0,
       0,     0,     0,  2532,  2228,     0,  4865,     0,     0,  2536,
       0,     0,     0,     0,     0,     0,   836,   686,  2533,     0,
       0,     0,  2683,     0,     0,     0,  2634,     0,  1336,  1336,
       0,     0,   758,     0,     0,     0,     0,     0,     0,  1336,
     758,     0,     0,   758,     0,     0,     0,     0,     0,     0,
    1948,   836,     0,     0,     0,   758,     0,  2278,     0,     0,
    2684,     0,     0,     0,     0,     0,     0,     0,   836,     0,
       0,  2534,     0,   689,  2535,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   690,
       0,     0,     0,  2634,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1336,     0,     0,  1025,     0,  2466,
       0,     0,     0,     0,     0,  1336,     0,  2467,  2468,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,     0,     0,     0,  3212,
    4940,  2685,     0,     0,   884,     0,     0,     0,     0,     0,
       0,     0,   693,  1336,     0,     0,  1336,     0,     0,     0,
       0,   694,     0,     0,  1336,  1336,     0,     0,     0,     0,
       0,  1336,  1336,  2536,   695,     0,  1336,   884,     0,  2686,
    1336,     0,     0,  1336,  1336,     0,     0,     0,  1336,  4981,
       0,     0,     0,     0,  1336,   836,   836,   836,   836,     0,
       0,     0,     0,     0,     0,  1028,     0,     0,     0,     0,
       0,   617,     0,     0,  4031,     0,     0,     0,  3324,     0,
       0,     0,     0,  3324,     0,     0,  3324,   617,     0,  3630,
       0,  5012,     0,     0,  1336,     0,   968,     0,     0,     0,
       0,     0,  4115,     0,     0,  1336,     0,     0,     0,  4076,
    4118,   699,     0,     0,  3372,  1682,  1682,  1682,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   767,
       0,     0,  1336,  2466,     0,     0,     0,     0,     0,     0,
       0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,
       0,  2687,  1528,     0,  4977,     0,     0,     0,  1529,     0,
       0,     0,  3445,     0,     0,     0,  2732,     0,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5076,     0,     0,   213,  2688,     0,     0,   704,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1531,  4200,     0,  4202,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1032,     0,     0,  2689,
       0,     0,     0,     0,     0,   708,   884,     0,     0,     0,
       0,     0,   709,  1336,     0,   710,     0,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,   711,     0,     0,   921,     0,  1532,
       0,  1034,     0,     0,     0,     0,  1533,   713,     0,  1534,
    1035,     0,   921,     0,   715,     0,     0,     0,     0,     0,
       0,     0,  2690,     0,     0,     0,     0,     0,     0,  2691,
       0,     0,  3581,     0,     0,  3584,  1535,  4256,     0,     0,
       0,     0,     0,  1336,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,   720,     0,     0,     0,   617,
       0,   884,     0,     0,   884,   884,  2732,     0,     0,     0,
    1536,     0,     0,     0,     0,  1948,     0,     0,  3274,  4278,
       0,     0,     0,     0,  2040,     0,     0,  2041,     0,     0,
    3747,  2042,  2043,  2044,     0,   884,   884,     0,     0,  4007,
       0,   758,     0,   921,     0,  3769,     0,     0,  2526,     0,
       0,     0,     0,     0,     0,     0,     0,  4014,  2527,     0,
    1528,     0,  3675,     0,     0,  2528,  1529,     0,     0,     0,
       0,   836,     0,  1635,     0,  3688,     0,  1538,     0,     0,
       0,     0,   836,  3697,     0,     0,     0,  1539,     0,     0,
       0,  2529,     0,     0,     0,     0,  1540,     0,     0,     0,
       0,     0,     0,  4060,  4060,     0,     0,     0,  1541,     0,
       0,  1531,     0,     0,     0,     0,  3477,     0,     0,     0,
       0,     0,     0,  3742,     0,     0,     0,  1336,     0,     0,
    1336,     0,     0,  1336,  1336,  1336,  1682,     0,     0,  1682,
       0,     0,     0,     0,  3766,     0,     0,  3472,     0,     0,
    1543,  1544,     0,     0,     0,     0,     0,     0,  1336,  1336,
    4419,     0,  1336,   884,  1108,     0,     0,  1532,     0,     0,
       0,     0,     0,     0,  1533,     0,     0,  1534,     0,     0,
       0,  1545,  1336,     0,     0,     0,     0,  3821,  1336,  3823,
       0,     0,  3324,     0,     0,     0,  5012,     0,     0,  1336,
       0,  5286,     0,     0,  1535,  2530,     0,     0,     0,     0,
    2531,     0,  4631,     0,  1336,     0,     0,     0,     0,     0,
       0,     0,     0,  1350,     0,  4631,   968,   921,     0,   921,
       0,     0,  2532,  2228,     0,     0,     0,     0,  1536,     0,
       0,  4471,     0,     0,     0,     0,     0,  2533,     0,  1546,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4480,     0,     0,     0,     0,     0,
       0,     0,     0,  3877,     0,     0,     0,   932,   968,     0,
    3884,  1528,     0,     0,     0,     0,  2278,  1529,     0,  4501,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2534,  1635,  1350,  2535,     0,  1538,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1539,     0,     0,     0,  1350,
       0,   932,     0,     0,  1540,     0,     0,     0,     0,     0,
       0,     0,  1531,     0,  4816,     0,  1541,     0,     0,   836,
       0,     0,     0,     0,   836,     0,     0,     0,     0,     0,
       0,     0,     0,  2732,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   836,     0,     0,     0,  4865,     0,     0,
    5419,     0,     0,     0,     0,  3646,     0,     0,  1543,  1544,
       0,   921,   836,  4631,     0,  3639,     0,     0,  1532,     0,
       0,     0,  2536,     0,     0,  1533,     0,     0,  1534,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3647,
       0,     0,     0,     0,     0,  1336,     0,     0,     0,  1336,
       0,  1336,  3671,     0,  3671,  1535,  3671,  3671,     0,     0,
       0,  3671,  3671,  3671,     0,  3671,  3671,  3671,     0,     0,
       0,   617,     0,     0,  1336,     0,     0,  1528,  5483,     0,
       0,     0,     0,  1529,     0,  1336,     0,     0,     0,  1536,
    1595,     0,  1336,     0,     0,     0,   758,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1546,     0,     0,
       0,     0,  1596,     0,     0,     0,     0,     0,     0,  4339,
    3749,     0,  2466,   836,     0,  1948,     0,     0,  1531,     0,
    2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,
       0,     0,     0,  5227,     0,  3777,     0,     0,     0,  1336,
       0,     0,  1635,     0,  1336,  1336,  1538,     0,     0,   921,
     921,   921,   921,  1597,     0,     0,  1539,     0,     0,     0,
       0,     0,     0,     0,     0,  1540,     0,     0,     0,     0,
    1528,     0,     0,     0,  1532,     0,  1529,  1541,     0,     0,
    1336,  1533,     0,     0,  1534,     0,     0,   617,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4116,  4117,
       0,  1535,   836,     0,     0,  3324,  4128,     0,     0,  1543,
    1544,  1531,     0,     0,     0,     0,     0,     0,     0,     0,
    1682,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     836,     0,  1598,     0,     0,  1536,     0,     0,     0,     0,
    4129,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   758,     0,  1336,     0,
       0,     0,     0,     0,  1336,     0,     0,  1532,  1948,     0,
       0,     0,  3630,     0,  1533,  1336,     0,  1534,     0,     0,
    1599,     0,     0,  1600,  1336,     0,  1336,     0,  1336,  5286,
       0,     0,     0,     0,     0,  4631,     0,  4828,  1601,     0,
       0,     0,  1538,   968,  1535,     0,     0,     0,  1546,     0,
       0,     0,  1539,  1336,     0,     0,     0,     0,     0,     0,
       0,  1540,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1602,  1541,     0,     0,     0,     0,  1536,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1948,  1948,
       0,     0,     0,     0,     0,     0,  3379,     0,     0,     0,
    2634,  3385,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3576,     0,     0,  1543,  1544,  1604,     0,   921,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5734,     0,     0,     0,     0,  1108,     0,
    1605,  1635,  1498,     0,     0,  1538,  3577,     0,     0,     0,
       0,     0,     0,     0,     0,  1539,     0,   884,     0,     0,
    1607,     0,     0,   884,  1540,     0,     0,     0,     0,     0,
       0,  1336,  1336,  1336,  4279,     0,  1541,  1499,     0,  1336,
       0,     0,     0,  5483,     0,     0,     0,     0,     0,  1336,
       0,     0,     0,     0,     0,     0,     0,     0,  3372,     0,
       0,     0,     0,     0,   884,     0,     0,     0,     0,     0,
       0,     0,   932,     0,  1546,  4185,     0,     0,  1543,  1544,
       0,     0,     0,     0,     0,     0,     0,   921,     0,     0,
       0,     0,     0,     0,  1948,     0,     0,     0,  1500,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4186,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2732,
       0,     0,     0,     0,     0,     0,  1336,     0,     0,     0,
       0,     0,     0,     0,  1501,     0,  4631,     0,     0,     0,
       0,     0,     0,     0,   932,   932,  5845,     0,     0,     0,
    1336,     0,  1336,     0,     0,  1108,   758,     0,     0,     0,
       0,  1948,  1948,  5860,     0,     0,     0,     0,  1336,  1336,
    1502,     0,   883,     0,  5866,     0,     0,  1546,     0,     0,
       0,   758,     0,     0,     0,     0,     0,     0,   758,     0,
       0,     0,   921,     0,     0,  4431,     0,     0,     0,   758,
       0,  5055,     0,     0,     0,     0,  1503,     0,     0,     0,
    1504,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5734,   921,   921,     0,     0,     0,  4631,     0,     0,     0,
       0,     0,  1682,  4176,     0,     0,     0,     0,     0,  5077,
       0,  1586,  1506,   617,     0,     0,     0,     0,  1469,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5093,     0,  1336,   884,     0,     0,  1336,     0,     0,
       0,     0,  1336,     0,     0,  1187,  1188,     0,     0,     0,
    1587,     0,     0,     0,    36,     0,     0,  4215,     0,  1508,
       0,     0,     0,     0,     0,     0,     0,     0,  1509,     0,
       0,     0,     0,  1336,     0,     0,  1510,     0,  5939,  5940,
     617,  5943,  5483,     0,  1588,     0,     0,     0,     0,     0,
       0,   921,     0,     0,  4631,     0,  1512,     0,  5120,     0,
       0,     0,     0,     0,     0,  1513,     0,     0,  2634,  1514,
       0,     0,  2634,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4258,     0,     0,     0,  1336,
     617,     0,   758,     0,   617,     0,     0,     0,     0,     0,
       0,     0,     0,   932,   932,     0,   625,  5986,     0,     0,
       0,     0,   674,   625,     0,     0,     0,     0,   726,     0,
     625,     0,     0,  1515,     0,     0,   625,     0,     0,   780,
       0,  3671,     0,     0,  -135,     0,     0,     0,     0,     0,
       0,     0,     0,  4289,  4289,   758,     0,     0,   847,   847,
       0,     0,     0,  4305,     1,     0,     0,     0,  1108,     0,
    1108,     0,     0,     0,     2,     0,     3,     4,     0,     0,
       0,   884,     0,     0,     0,     0,     0,     0,     0,  5205,
       0,     0,     0,     0,     5,     0,   884,     0,     0,     0,
       0,   884,     0,     0,     6,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     7,  4359,     8,     9,
       0,     0,     0,     0,     0,    10,     0,    11,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    12,
       0,    13,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4395,  1108,     0,     0,     0,     0,    14,     0,
       0,    15,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,     0,    17,     0,
       0,     0,    18,     0,     0,     0,     0,     0,    19,     0,
       0,     0,     0,     0,     0,     0,    20,     0,    21,     0,
       0,     0,     0,     0,     0,    22,     0,     0,   923,  4256,
       0,     0,   927,     0,     0,     0,     0,     0,     0,     0,
     970,     0,    23,   972,     0,     0,   977,   978,     0,   981,
       0,   984,     0,     0,   990,     0,   992,     0,     0,    24,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    25,
      26,   758,     0,     0,     0,    27,     0,   758,     0,     0,
       0,   758,     0,     0,  4796,     0,     0,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4798,     0,
       0,     0,     0,     0,     0,    29,     0,     0,  5091,  5092,
       0,     0,     0,  5095,  5096,  4523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2634,    30,     0,  3385,     0,  3385,     0,     0,     0,    31,
    2634,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    32,     0,     0,     0,     0,     0,    33,
      34,     0,    35,     0,     0,   686,     0,    36,     0,     0,
    3122,     0,  2040,    37,     0,  2041,    38,     0,     0,  2042,
    2043,  2044,     0,    39,     0,     0,     0,   884,     0,    40,
      41,     0,     0,     0,     0,   884,  2526,    42,     0,     0,
       0,    43,     0,     0,     0,     0,  2527,     0,     0,     0,
       0,    44,     0,  2528,     0,     0,     0,     0,     0,     0,
    2634,   689,  3123,     0,     0,     0,    45,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,   690,     0,  2529,
       0,     0,     0,     0,     0,     0,    46,     0,     0,     0,
       0,     0,     0,     0,     0,  1025,     0,    47,   883,     0,
       0,     0,     0,    48,     0,     0,     0,     0,    49,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3124,
       0,    50,     0,     0,     0,     0,     0,   933,   943,   884,
     693,   884,     0,     0,     0,   933,     0,   943,   933,   694,
    1973,     0,     0,     0,    51,  1973,  1973,     0,     0,     0,
       0,   943,   695,     0,     0,     0,     0,  3125,     0,     0,
       0,     0,    57,  4305,     0,  -135,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1028,     0,     0,     0,     0,  4723,     0,
       0,     0,     0,  2530,     0,     0,  4732,     0,  2531,  4733,
       0,  4734,     0,     0,     0,     0,     0,     0,  3126,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2532,  2228,   884,     0,     0,     0,     0,     0,     0,   699,
       0,     0,     0,     0,     0,  2533,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   883,  4774,     0,  1682,
       0,     0,     0,     0,     0,  1682,  5613,     0,  1019,     0,
       0,     0,     0,  3671,   884,     0,     0,     0,  3671,  1055,
       0,     0,     0,  1059,  2278,     0,     0,     0,     0,     0,
    1072,  1073,     0,     0,  1079,     0,  1082,  1083,  2534,     0,
       0,  2535,  3385,     0,     0,     0,     0,     0,     0,     0,
    5649,  1105,     0,   213,  3127,     0,     0,   704,     0,     0,
       0,     0,     0,     0,     0,     0,   758,     0,     0,  1118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1032,     0,     0,  3128,     0,     0,
    1146,     0,  1148,   708,     0,     0,     0,     0,     0,     0,
     709,     0,  1164,   710,     0,     0,     0,     0,     0,     0,
       0,   884,     0,     0,     0,     0,  4879,     0,     0,  4305,
       0,  5113,   711,     0,     0,     0,     0,     0,     0,  1034,
    2536,     0,     0,  3385,   625,   713,  5117,     0,  1035,     0,
       0,     0,   715,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   884,   883,  3129,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   883,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   883,   720,     0,     0,     0,     0,     0,     0,
    4927,  4927,  4927,  4927,     0,  4927,  4927,  4927,  4927,  4927,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   847,     0,     0,     0,     0,  5176,     0,     0,
    2466,     0,     0,     0,     0,     0,   884,     0,  2467,  2468,
    2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,     0,     0,
       0,  5238,     0,     0,     0,     0,     0,     0,     0,   884,
       0,     0,  2040,     0,     0,  2041,     0,     0,     0,  2042,
    2043,  2044,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   884,     0,  2526,     0,     0,     0,
    4989,     0,  4991,     0,     0,     0,  2527,     0,     0,     0,
     943,     0,     0,  2528,  1489,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,   943,     0,     0,     0,  2529,
       0,     0,     0,     0,     0,     0,     0,   943,     0,     0,
     758,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   933,   943,     0,
       0,     0,     0,     0,   933,     0,   943,   933,  1666,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,     0,  1786,     0,     0,     0,     0,     0,     0,     0,
       0,  5304,     0,  5305,     0,     0,     0,  1798,     0,  1799,
       0,     0,     0,     0,     0,     0,     0,     0,  1802,     0,
       0,     0,  2634,     0,     0,  1812,     0,     0,     0,     0,
       0,     0,     0,  2530,     0,     0,     0,     0,  2531,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2532,  2228,     0,     0,     0,     0,     0,  1863,     0,  1865,
       0,     0,     0,     0,  2505,  2533,     0,     0,   943,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5118,  5119,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,     0,  3671,     0,  3671,  3671,  3671,
    5690,     0,  3385,     0,  2278,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2534,     0,
       0,  2535,     0,     0,     0,     0,     0,  3385,     0,     0,
       0,     0,     0,   625,     0,   625,     0,   625,     0,   625,
       0,   625,   625,   625,     0,  5431,     0,     0,   625,     0,
       0,     0,   943,     0,     0,     0,     0,     0,     0,  1968,
       0,     0,     0,  5171,   883,     0,     0,     0,     0,     0,
       0,     0,  2040,     0,     0,  2041,     0,  1980,     0,  2042,
    2043,  2044,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2526,     0,     0,     0,
       0,     0,  5199,     0,     0,     0,  2527,     0,     0,     0,
    2536,     0,     0,  2528,     0,     0,     0,     0,     0,  2040,
       0,     0,  2041,     0,     0,     0,  2042,  2043,  2044,     0,
       0,   883,     0,     0,     0,     0,     0,     0,     0,  2529,
       0,     0,     0,  2526,  4927,     0,     0,     0,     0,     0,
       0,     0,     0,  2527,     0,     0,     0,     0,     0,     0,
    2528,  1768,   884,     0,     0,     0,     0,   943,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,   933,     0,
       0,     0,   933,     0,   933,     0,  2529,     0,     0,     0,
       0,     0,     0,     0,  5536,     0,  5538,     0,     0,     0,
       0,     0,     0,     0,     0,   883,     0,     0,  3385,     0,
    2466,     0,     0,  2634,     0,     0,     0,     0,  2467,  2468,
    2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,     0,     0,
       0,  5246,     0,     0,   847,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2530,     0,     0,     0,     0,  2531,     0,
       0,     0,     0,  2040,     0,     0,  2041,     0,     0,     0,
    2042,  2043,  2044,     0,     0,     0,     0,     0,     0,     0,
    2532,  2228,     0,     0,     0,     0,     0,  2526,     0,   943,
       0,     0,     0,  4305,     0,  2533,     0,  2527,     0,     0,
    2530,     0,     0,     0,  2528,  2531,   874,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2532,  2228,     0,
    2529,     0,     0,     0,  2278,     0,     0,     0,  3671,     0,
       0,     0,  2533,   884,     0,     0,     0,  5367,  2534,   943,
       0,  2535,     0,  2694,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   943,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
       0,  2278,     0,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   883,  2534,     0,     0,  2535,     0,
       0,  5960,     0,     0,     0,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   883,     0,     0,     0,  2785,     0,     0,     0,     0,
       0,     0,     0,  5720,     0,     0,     0,     0,  5960,     0,
    2536,     0,     0,     0,  2530,     0,     0,     0,  5960,  2531,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   884,     0,     0,     0,
       0,  2532,  2228,     0,   883,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2533,  2536,     0,   883,
       0,     0,   883,   883,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,   884,     0,     0,     0,     0,     0,
     943,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   883,   883,  2278,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2534,
    2466,  5800,  2535,     0,     0,     0,     0,     0,  2467,  2468,
    2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,     0,     0,
       0,  5249,     0,  1768,     0,     0,     0,  1108,     0,     0,
       0,  5549,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2466,     0,     0,
       0,     0,     0,   884,     0,  2467,  2468,  2469,  2470,  2471,
    2472,  2473,  2474,  2475,     0,     0,     0,     0,  5299,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2040,     0,
       0,  2041,     0,     0,     0,  2042,  2043,  2044,     0,     0,
       0,  2536,     0,     0,     0,     0,     0,     0,  2907,     0,
       0,     0,  2526,     0,     0,     0,  5875,     0,     0,     0,
       0,   883,  2527,     0,     0,     0,     0,     0,  2040,  2528,
       0,  2041,     0,     0,     0,  2042,  2043,  2044,     0,     0,
       0,     0,     0,  2943,     0,  5889,  5889,     0,     0,     0,
       0,     0,  2526,     0,     0,  2529,     0,     0,     0,     0,
       0,     0,  2527,     0,     0,     0,     0,     0,     0,  2528,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5203,     0,   884,     0,  3005,     0,  3009,     0,
       0,     0,     0,     0,     0,  2529,     0,     0,     0,     0,
       0,  2466,     0,     0,     0,     0,     0,     0,  3027,  2467,
    2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,     0,
       0,     0,  5332,     0,     0,     0,     0,  1108,     0,     0,
       0,  5696,     0,  5697,  3047,     0,  3048,  5702,  5703,     0,
       0,     0,     0,     0,     0,  5889,     0,     0,     0,     0,
       0,  3057,     0,  3058,     0,     0,     0,     0,     0,   625,
       0,   625,     0,   625,     0,   625,     0,   625,     0,  2530,
       0,   625,     0,     0,  2531,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2532,  2228,     0,     0,
       0,     0,     0,     0,   884,     0,     0,     0,     0,  2530,
       0,  2533,     0,     0,  2531,     0,     0,     0,  2040,     0,
       0,  2041,     0,     0,     0,  2042,  2043,  2044,     0,     0,
       0,     0,     0,     0,     0,     0,  2532,  2228,     0,     0,
       0,     0,  2526,     0,     0,     0,     0,     0,     0,     0,
    2278,  2533,  2527,     0,     0,     0,     0,     0,     0,  2528,
       0,     0,     0,     0,  2534,     0,     0,  2535,     0,     0,
       0,     0,  3385,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2529,     0,     0,     0,     0,
    2278,     0,     0,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2534,  2040,     0,  2535,  2041,     0,
       0,     0,  2042,  2043,  2044,     0,   874,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1768,  2526,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2527,
       0,     0,   874,     0,     0,     0,  2528,     0,     0,     0,
       0,   943,     0,     0,     0,     0,  2536,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,   943,     0,     0,
       0,     0,  2529,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1108,     0,     0,     0,     0,
       0,     0,  3385,     0,     0,     0,  2536,     0,     0,  2530,
       0,     0,     0,     0,  2531,     0,     0,   933,   933,     0,
     943,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   933,     0,   943,   933,  2532,  2228,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   943,   943,     0,
       0,  2533,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   876,     0,     0,     0,     0,  2466,     0,     0,     0,
       0,     0,     0,     0,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2474,  2475,     0,     0,   933,     0,  5372,   933,   933,
    2278,     0,     0,     0,     0,     0,  2530,     0,     0,     0,
     874,  2531,     0,     0,  2534,     0,  2466,  2535,     0,     0,
       0,     0,     0,     0,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2474,  2475,  2532,  2228,   884,     0,  5684,  5961,     0,
     884,   884,     0,     0,  2489,     0,     0,     0,  2533,     0,
       0,     0,     0,   637,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   638,     0,     0,     0,  5961,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5961,     0,  2278,  4989,     0,
       0,     0,     0,     0,     0,     0,   639,     0,     0,     0,
       0,  2534,  1768,     0,  2535,     0,  2536,     0,     0,   640,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   883,  -860,     0,     0,   883,   883,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   641,     0,     0,     0,     0,     0,   642,
    5203,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   643,     0,     0,
     874,     0,     0,     0,     0,     0,     0,     0,   644,     0,
       0,   874,     0,     0,     0,   883,     0,   645,     0,     0,
       0,   883,     0,  2536,     0,   884,   874,     0,     0,     0,
     646,     0,     0,     0,     0,     0,  2466,     0,   647,     0,
       0,     0,   648,     0,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2474,  2475,     0,     0,     0,     0,  5706,     0,     0,
       0, -1055,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   649,     0,
       0,     0,     0,     0,     0,     0,     0,  -596,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2466,     0,     0,     0,     0,     0,     0,
       0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,
       0,     0,     0,     0,  5887,     0,     0,   650,     0,     0,
     651,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     877,   652,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   653,   874,     0,     0,     0,
       0,     0,  -457,     0,     0,     0,  3375,  3376,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   654,     0,     0,  3391,  3392,     0,  3394,  3395,
       0,   655,  3397,  3398,     0,     0,     0,     0,  -457,     0,
       0,   656,     0,     0,     0,     0,     0,  3409,     0,     0,
       0,     0,     0,     0,  3418,     0,     0,     0,  3421,  3422,
     657,     0,  3425,  3426,     0,     0,     0,   658,     0,  3431,
       0,     0,   883,  -457,     0,     0,   659,   660,     0,   661,
     662,  3446,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3463,     0,   663,     0,     0,  3465,     0,
       0,     0,   664,     0,     0,   665,     0,     0,   666,     0,
       0,     0,     0,  3471,     0,     0,     0,     0,     0,     0,
       0,  -457,  3478,     0,     0,  3482,     0,  3484,  3487,  3489,
       0,     0,     0,     0,  3497,  3500,     0,     0,     0,     0,
       0,     0,     0,     0,  3513,     0,   883,     0,     0,  3522,
     883,     0,     0,  3525,  2040,     0,     0,  2041,     0,     0,
       0,  2042,  2043,  2044,     0,  3535,  3536,     0,     0,     0,
    3541,     0,     0,     0,     0,     0,  3550,  3551,  2526,     0,
       0,     0,     0,  3556,     0,     0,  3558,     0,  2527,     0,
       0,     0,     0,  3570,  3571,  2528,     0,     0,     0,  3575,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3582,     0,     0,  3585,     0,     0,     0,     0,  3588,
       0,  2529,     0,     0,     0,  3591,  3592,     0,     0,     0,
       0,     0,     0,  3598,     0,     0,  3600,     0,   874,     0,
    3607,  3608,  3609,  3610,  1768,  3612,     0,     0,     0,   883,
       0,   876,     0,   942,     0,     0,     0,     0,  3637,  3638,
       0,  3640,   942,     0,   883,     0,     0,     0,     0,   883,
       0,     0,  3649,  3650,  3651,     0,   942,   876,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,   874,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1682,   943,     0,     0,     0,
     943,     0,     0,     0,   943,     0,     0,     0,     0,  3703,
       0,     0,   943,     0,     0,  2530,     0,  3727,     0,     0,
    2531,     0,     0,     0,     0,     0,   874,     0,     0,     0,
     943,     0,     0,     0,     0,     0,     0,  3740,     0,     0,
       0,     0,  2532,  2228,     0,     0,     0,   933,     0,   933,
     933,     0,     0,     0,     0,     0,     0,  2533,     0,   874,
       0,     0,     0,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,   943,     0,  3808,     0,     0,
       0,     0,     0,     0,     0,     0,  2278,     0,     0,     0,
       0,     0,     0,     0,     0,   876,  3822,     0,  3824,     0,
    2534,     0,     0,  2535,     0,  1768,   943,     0,     0,  1768,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,  1768,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,   943,     0,     0,     0,     0,
       0,     0,   943,     0,     0,   943,     0,     0,     0,     0,
       0,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2040,     0,     0,  2041,
       0,   943,     0,  2042,  2043,  2044,     0,   943,   883,  3885,
       0,   883,  2536,   883,   943,     0,     0,     0,   883,     0,
    2526,     0,     0,     0,     0,     0,     0,   943,     0,     0,
    2527,     0,     0,     0,     0,     0,     0,  2528,     0,     0,
     943,     0,     0,     0,     0,  1768,     0,     0,     0,     0,
       0,   943,     0,     0,     0,     0,     0,     0,   874,     0,
       0,     0,     0,  2529,     0,   883,     0,     0,     0,   874,
       0,     0,     0,   883,     0,   876,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   874,   876,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,     0,
       0,   876,     0,     0,     0,     0,     0,     0,     0,     0,
     877,  1768,  2466,     0,     0,     0,     0,     0,     0,     0,
    2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,
       0,     0,     0,  5905,     0,     0,   877,     0,   874,     0,
    2040,     0,     0,  2041,     0,     0,     0,  2042,  2043,  2044,
       0,     0,     0,   874,     0,     0,   874,   874,     0,     0,
       0,     0,     0,     0,  2526,   942,     0,   883,     0,   883,
       0,     0,     0,     0,  2527,     0,     0,  2530,     0,     0,
       0,  2528,  2531,     0,   942,     0,     0,   874,   874,     0,
     942,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   942,     0,  2532,  2228,     0,  2529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   942,  2533,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   942,     0,     0,     0,     0,     0,     0,
       0,   942,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   942,     0,     0,  2278,     0,
     883,   876,     0,     0,   943,   942,     0,     0,     0,     0,
       0,     0,  2534,     0,     0,  2535,     0,     0,     0,     0,
       0,     0,   943,     0,   877,     0,     0,     0,  4101,   943,
       0,     0,     0,     0,     0,     0,   933,     0,   933,   933,
       0,     0,   883,     0,     0,     0,     0,     0,  4113,     0,
       0,     0,     0,     0,     0,   874,     0,     0,     0,     0,
       0,  2530,     0,     0,   942,  4120,  2531,     0,     0,  4120,
     883,     0,     0,     0,  4131,  4132,  4133,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2532,  2228,
       0,     0,     0,   942,     0,     0,     0,     0,     0,     0,
    1768,     0,     0,  2533,  2536,     0,  1768,     0,     0,     0,
    4163,  4164,  4165,  4166,     0,     0,     0,   942,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   883,
       0,     0,  2278,     0,     0,     0,     0,  4184,     0,  4188,
    4189,  4190,     0,     0,     0,     0,  2534,     0,     0,  2535,
       0,   883,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   942,     0,     0,
       0,     0,     0,   883,   877,     0,   943,     0,     0,     0,
       0,     0,     0,     0,     0,   877,     0,     0,     0,     0,
       0,     0,     0,     0,  2466,     0,     0,     0,     0,     0,
     877,     0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,
    2475,     0,     0,     0,     0,  5945,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   876,     0,     0,     0,     0,  2536,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4266,     0,   883,     0,     0,     0,     0,     0,
       0,  4272,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1767,   883,     0,     0,
       0,     0,   942,     0,     0,     0,     0,  4282,  4283,     0,
       0,     0,  4284,     0,     0,     0,     0,     0,     0,     0,
     876,     0,   883,   943,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4326,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,     0,     0,   943,     0,     0,     0,     0,  2466,     0,
       0,   876,     0,     0,     0,     0,  2467,  2468,  2469,  2470,
    2471,  2472,  2473,  2474,  2475,     0,     0,     0,     0,  5946,
     877,     0,     0,     0,     0,     0,     0,  4362,     0,     0,
       0,     0,  4368,     0,   876,     0,     0,     0,  4374,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   942,  1768,  1768,  1768,  4413,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,  4428,     0,  4429,
       0,     0,     0,     0,     0,     0,     0,     0,   943,     0,
     883,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   942,     0,     0,   943,     0,     0,
       0,     0,     0,     0,     0,   879,     0,     0,  4452,     0,
     942,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   942,     0,     0,     0,   942,     0,
    2040,     0,     0,  2041,     0,     0,     0,  2042,  2043,  2044,
       0,     0,     0,     0,     0,     0,     0,     0,  2040,     0,
       0,  2041,     0,     0,  2526,  2042,  2043,  2044,     0,     0,
       0,     0,     0,     0,  2527,     0,     0,     0,     0,     0,
     883,  2528,  2526,     0,     0,     0,  3331,     0,     0,     0,
       0,     0,  2527,   943,     0,     0,     0,     0,     0,  2528,
       0,     0,     0,   876,     0,   883,     0,  2529,     0,     0,
       0,     0,     0,     0,   876,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2529,     0,     0,     0,     0,
     876,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1768,     0,   877,     0,     0,     0,   943,     0,   943,     0,
       0,     0,     0,     0,     0,     0,     0,   942,     0,     0,
       0,   943,     0,   943,     0,   942,   942,     0,   874,     0,
       0,     0,   874,   874,     0,     0,  3332,     0,     0,     0,
       0,     0,     0,   876,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   876,     0,
       0,   876,   876,     0,     0,     0,     0,     0,     0,   877,
       0,     0,     0,     0,     0,     0,     0,     0,  1767,     0,
       0,  2530,     0,     0,     0,     0,  2531,     0,     0,   874,
       0,   943,   876,   876,     0,   874,     0,     0,     0,  2530,
     883,     0,     0,     0,  2531,     0,     0,     0,  2532,  2228,
     877,     0,     0,     0,  4635,     0,     0,  4642,     0,  4643,
       0,     0,     0,  2533,     0,     0,  2532,  2228,     0,     0,
       0,     0,  4650,   943,     0,     0,   874,     0,     0,     0,
       0,  2533,     0,   877,  4656,     0,   883,     0,  4659,     0,
     943,   883,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2278,     0,     0,     0,     0,  4683,     0,     0,
       0,     0,   943,     0,     0,   943,  2534,     0,     0,  2535,
    2278,     0,     0,     0,     0,  4687,     0,     0,     0,     0,
    4691,     0,     0,     0,  2534,     0,     0,  2535,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4726,     0,     0,     0,  4730,
     876,     0,     0,     0,     0,     0,     0,  4735,  4736,  4737,
    4738,     0,     0,     0,     0,     0,     0,  4742,  4743,  4744,
    4745,     0,     0,     0,     0,     0,  4747,  4748,     0,     0,
       0,     0,  4755,  4756,  1768,  4758,  4759,  4760,  4761,  4762,
    4763,  4764,     0,     0,     0,     0,     0,     0,  2536,     0,
       0,  4773,     0,     0,     0,  4776,  4777,  4778,  4779,     0,
       0,   883,     0,     0,     0,     0,  2536,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4120,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4799,     0,     0,
       0,     0,     0,     0,   942,     0,     0,     0,     0,     0,
       0,     0,   877,     0,     0,     0,   874,     0,   880,     0,
       0,     0,     0,   877,     0,     0,  3333,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   877,
       0,     0,     0,     0,     0,     0,     0,     0,  2466,     0,
       0,     0,     0,     0,     0,     0,  2467,  2468,  2469,  2470,
    2471,  2472,  2473,  2474,  2475,     0,  2466,  2903,     0,     0,
       0,     0,  4880,     0,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2474,  2475,     0,   883,     0,     0,     0,     0,     0,
     874,     0,   877,     0,   874,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,  4120,     0,   877,     0,     0,
     877,   877,  4905,     0,  4906,     0,     0,     0,   942,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4920,     0,     0,     0,     0,     0,
       0,   877,   877,     0,   883,     0,     0,     0,     0,     0,
       0,     0,     0,  1767,     0,  1768,     0,     0,     0,     0,
    1768,     0,  1768,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   942,     0,     0,     0,
       0,     0,     0,     0,   942,  1768,     0,     0,     0,     0,
       0,     0,   942,   874,     0,   879,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   874,     0,
       0,   883,     0,   874,     0,     0,     0,     0,     0,     0,
       0,   879,     0,     0,   943,     0,     0,   943,     0,     0,
       0,     0,     0,     0,     0,   942,   942,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   942,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   942,   942,     0,     0,     0,     0,     0,   877,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   943,   943,     0,
       0,     0,     0,     0,     0,     0,     0,   943,     0,     0,
       0,     0,   883,  5056,  5057,  5058,     0,     0,     0,  5059,
    5060,  5061,  5062,     0,   943,     0,  5064,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2040,     0,     0,
    2041,     0,     0,     0,  2042,  2043,  2044,     0,     0,   879,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2526,  5083,  5084,  5085,  5086,  5087,     0,  5089,  5090,
       0,  2527,     0,     0,     0,     0,     0,     0,  2528,     0,
    5099,  5100,     0,     0,     0,     0,  2040,  1767,     0,  2041,
       0,     0,     0,  2042,  2043,  2044,     0,     0,     0,     0,
       0,     0,     0,   943,  2529,     0,     0,     0,     0,  5105,
    2526,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2527,     0,     0,     0,     0,     0,     0,  2528,     0,     0,
       0,     0,   883,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   874,     0,     0,   874,     0,   874,     0,     0,
       0,     0,   874,  2529,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   876,     0,     0,     0,   876,   876,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   874,
     883,     0,     0,     0,     0,     0,     0,   874,     0,   879,
       0,  5169,   882,     0,     0,     0,     0,     0,  2530,     0,
     879,     0,     0,  2531,   876,     0,     0,     0,     0,     0,
     876,     0,   874,     0,     0,   879,     0,     0,     0,     0,
       0,     0,     0,  3937,     0,  2532,  2228,     0,  3938,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2533,     0,     0,     0,     0,     0,     0,  2530,     0,     0,
       0,   876,  2531,     0,     0,     0,  5220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2532,  2228,     0,     0,     0,  2278,
       0,   874,     0,   874,     0,     0,     0,     0,     0,  2533,
       0,     0,     0,  2534,     0,     0,  2535,     0,   943,     0,
     883,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   880,     0,
       0,  4514,     0,     0,     0,     0,     0,     0,  2278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,     0,  2534,     0,   880,  2535,     0,     0,     0,     0,
       0,     0,   943,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   625,     0,     0,
       0,     0,     0,     0,   874,   879,     0,     0,     0,     0,
       0,   943,     0,     0,     0,  2536,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4515,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   874,     0,     0,     0,
       0,     0,     0,   883,     0,     0,     0,     0,   883,   883,
    5321,     0,     0,     0,  3939,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   874,     0,     0,     0,     0,  5331,
       0,   876,     0,     0,  5336,  5337,     0,     0,     0,  1768,
       0,     0,     0,     0,  5348,     0,     0,     0,     0,     0,
       0,  5350,     0,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,  2466,     0,     0,     0,     0,
       0,     0,   880,  2467,  2468,  2469,  2470,  2471,  2472,  2473,
    2474,  2475,     0,     0,     0,     0,     0,  5401,  5402,     0,
       0,     0,   877,   874,     0,     0,   877,   877,     0,     0,
    5410,     0,  5412,     0,     0,   876,     0,     0,     0,   876,
       0,     0,     0,     0,  2466,   874,     0,  5426,     0,   883,
       0,     0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,
    2475,     0,     0,     0,     0,     0,     0,   874,     0,     0,
       0,     0,  4120,     0,   943,     0,     0,     0,     0,  1767,
    5460,     0,     0,   877,     0,     0,     0,     0,     0,   877,
       0,   946,     0,   883,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   980,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   999,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   879,     0,     0,
     877,     0,     0,   942,     0,     0,     0,     0,   876,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   874,  5497,
       0,   942,     0,   876,     0,   942,     0,     0,   876,   942,
       0,     0,   880,     0,     0,     0,     0,   942,     0,     0,
    5514,   874,     0,   880,     0,     0,     0,     0,     0,     0,
    5521,     0,     0,     0,   943,   942,   943,     0,   880,     0,
       0,     0,     0,     0,   879,     0,   874,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   942,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,     0,   879,     0,     0,     0,   942,
     942,     0,   933,     0,     0,  5580,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   879,     0,
    1767,   942,     0,     0,  1767,     0,     0,     0,     0,     0,
       0,  1768,     0,     0,     0,     0,   933,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   942,     0,  1767,
       0,     0,     0,   942,     0,     0,     0,     0,     0,     0,
     942,     0,     0,     0,     0,  4120,     0,   942,     0,     0,
     942,     0,     0,     0,     0,     0,   942,     0,     0,     0,
     877,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   882,     0,   874,     0,   942,     0,   880,     0,
       0,     0,   942,     0,     0,     0,     0,     0,     0,   942,
       0,     0,     0,     0,     0,     0,     0,     0,   882,     0,
       0,     0,   942,  5672,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   942,     0,  5685,     0,     0,
    1767,     0,     0,     0,     0,     0,   942,     0,     0,     0,
       0,     0,     0,     0,   877,     0,     0,   876,   877,     0,
     876,     0,   876,     0,     0,     0,     0,   876,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5713,     0,     0,     0,   874,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5724,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1767,   879,     0,   874,
       0,     0,     0,     0,   876,     0,     0,     0,   879,     0,
       0,     0,   876,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   879,     0,     0,     0,     0,     0,
       0,   943,     0,     0,     0,     0,     0,   876,     0,     0,
       0,     0,     0,     0,     0,   943,     0,   877,     0,     0,
       0,     0,     0,  1018,     0,     0,   882,     0,     0,  1049,
       0,     0,   877,     0,     0,     0,     0,   877,     0,     0,
       0,     0,     0,  5794,     0,  1768,     0,   879,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   879,     0,     0,   879,   879,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   876,     0,   876,     0,
       0,     0,     0,     0,     0,     0,  5815,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   879,   879,     0,     0,
     880,     0,     0,     0,   874,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   942,
       0,     0,     0,  2040,     0,     0,  2041,     0,     0,     0,
    2042,  2043,  2044,     0,     0,     0,     0,   942,     0,     0,
       0,  1768,     0,     0,   942,     0,     0,  2526,     0,     0,
     874,     0,     0,     0,     0,   874,     0,  2527,     0,     0,
       0,     0,     0,     0,  2528,     0,     0,   880,     0,   876,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5881,     0,     0,     0,   882,     0,     0,     0,
    2529,     0,     0,     0,     0,     0,     0,   882,     0,     0,
       0,     0,     0,  1768,     0,   943,     0,  1343,   880,     0,
       0,   876,   882,     0,     0,  1767,     0,     0,     0,     0,
       0,  1767,     0,     0,   879,     0,  1366,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   876,
       0,   880,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5852,
       0,     0,     0,     0,     0,   874,   877,     0,     0,   877,
       0,   877,     0,     0,     0,  1424,   877,     0,     0,     0,
       0,   942,     0,     0,  2530,     0,     0,     0,   876,  2531,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,     0,     0,     0,     0,     0,
     876,  2532,  2228,     0,     0,     0,     0,   933,     0,     0,
       0,  1559,     0,   877,     0,     0,  2533,     0,     0,     0,
     943,   877,   876,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   882,     0,     0,     0,   877,     0,     0,     0,
       0,     0,     0,     0,     0,  2278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2534,
       0,     0,  2535,     0,     0,     0,     0,     0,   874,   933,
     933,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5853,     0,     0,   942,   942,
     880,     0,     0,   876,     0,     0,     0,     0,     0,     0,
       0,   880,     0,     0,     0,   877,   874,   877,     0,     0,
       0,     0,     0,     0,  1817,   942,   876,   880,   942,     0,
       0,     0,     0,   943,     0,     0,     0,     0,   874,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   876,  1851,  1854,  1855,     0,     0,     0,     0,     0,
       0,  2536,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     880,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   880,     0,     0,   880,   880,
    1767,  1767,  1767,     0,     0,   874,     0,     0,   877,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   942,     0,     0,     0,     0,   880,
     880,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   942,     0,     0,     0,     0,     0,     0,
     877,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1343,  2466,   942,     0,     0,     0,  1768,     0,     0,  2467,
    2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,   877,     0,
       0,  1979,     0,     0,   882,     0,     0,     0,     0,     0,
    1343,     0,     0,  2040,     0,     0,  2041,     0,     0,   876,
    2042,  2043,  2044,  1768,     0,     0,     0,     0,   933,   933,
       0,     0,     0,  1768,     0,     0,     0,  2526,     0,     0,
    3894,     0,     0,     0,     0,     0,   874,  2527,     0,     0,
       0,     0,     0,     0,  2528,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   877,   942,     0,
       0,   882,     0,     0,     0,     0,     0,   880,     0,     0,
    2529,     0,     0,     0,     0,     0,     0,     0,     0,   877,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   876,
       0,   877,   882,     0,     0,  1767,     0,     0,     0,     0,
       0,   942,     0,   942,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   876,     0,   942,     0,   942,     0,
       0,     0,     0,     0,     0,   882,     0,  2040,  2520,     0,
    2041,     0,     0,     0,  2042,  2043,  2044,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   874,     0,     0,     0,
       0,  2526,     0,     0,  3942,     0,     0,     0,     0,     0,
       0,  2527,     0,     0,     0,     0,     0,     0,  2528,     0,
       0,     0,   877,     0,  2530,     0,     0,   879,     0,  2531,
       0,   879,   879,     0,     0,     0,   942,     0,     0,     0,
       0,     0,     0,     0,  2529,   877,     0,     0,     0,     0,
       0,  2532,  2228,     0,     0,     0,     0,     0,  2611,     0,
       0,     0,     0,     0,   874,     0,  2533,     0,     0,     0,
     877,     0,     0,     0,     0,     0,     0,     0,   942,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   879,     0,
       0,     0,     0,     0,   879,   942,     0,     0,     0,   876,
       0,     0,     0,     0,     0,  2278,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   942,     0,  2534,
     942,     0,  2535,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   879,     0,     0,     0,     0,
    2726,     0,     0,     0,     0,   876,     0,     0,     0,  2749,
     876,     0,     0,  2040,     0,     0,  2041,     0,  2530,     0,
    2042,  2043,  2044,  2531,   882,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   882,     0,  2526,     0,     0,
       0,  2786,     0,     0,   874,  2532,  2228,  2527,     0,     0,
       0,   882,     0,     0,  2528,     0,     0,     0,     0,  1767,
    2533,     0,     0,     0,  2809,     0,     0,  2812,     0,     0,
       0,  2536,     0,     0,     0,     0,     0,     0,   877,     0,
    2529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2278,
       0,     0,     0,     0,   882,     0,     0,     0,     0,     0,
       0,     0,     0,  2534,     0,     0,  2535,     0,     0,   882,
       0,  2864,   882,   882,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2883,     0,     0,     0,     0,
     876,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   882,   882,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   874,   877,     0,
       0,  2466,   874,   874,     0,     0,     0,     0,     0,  2467,
    2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,     0,
       0,     0,     0,   877,  2530,   879,     0,     0,     0,  2531,
       0,     0,     0,     0,     0,  2536,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2532,  2228,     0,     0,     0,     0,     0,     0,   942,
       0,     0,     0,     0,     0,     0,  2533,     0,     0,     0,
       0,     0,     0,     0,  2905,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2908,     0,     0,     0,     0,
       0,     0,     0,   876,     0,     0,     0,     0,     0,   879,
       0,     0,     0,   879,     0,  2278,     0,     0,     0,     0,
    1767,   882,     0,   874,     0,  1767,     0,  1767,     0,  2534,
       0,     0,  2535,     0,     0,     0,     0,  2952,     0,     0,
       0,   876,     0,     0,     0,  2466,     0,     0,     0,     0,
    1767,  3910,     0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,
    2474,  2475,  2988,   876,     0,     0,     0,   874,   877,  3001,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   942,
     880,     0,   942,     0,   880,   880,     0,     0,     0,     0,
       0,  2040,     0,     0,  2041,     0,     0,     0,  2042,  2043,
    2044,     0,   879,     0,   877,     0,     0,     0,     0,   877,
       0,  2536,     0,     0,     0,  2526,     0,   879,     0,     0,
     876,     0,   879,     0,     0,  2527,     0,     0,     0,     0,
       0,  3062,  2528,     0,     0,  2040,     0,     0,  2041,     0,
       0,   880,  2042,  2043,  2044,     0,     0,   880,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2529,  2526,
       0,     0,  3953,  1343,  1343,     0,     0,     0,     0,  2527,
       0,     0,   942,   942,     0,     0,  2528,     0,     0,     0,
    3112,     0,   942,     0,     0,     0,     0,     0,   880,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   942,
       0,     0,  2529,     0,     0,     0,     0,     0,     0,     0,
       0,  2466,     0,     0,     0,     0,     0,     0,     0,  2467,
    2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   877,
    2040,   876,     0,  2041,     0,     0,     0,  2042,  2043,  2044,
       0,     0,     0,  3947,     0,     0,     0,     0,     0,     0,
    2040,     0,     0,  2041,  2526,     0,     0,  2042,  2043,  2044,
       0,     0,  2530,     0,  2527,     0,     0,  2531,   942,     0,
       0,  2528,     0,     0,  2526,     0,     0,  4521,     0,     0,
       0,     0,     0,     0,  2527,     0,     0,     0,     0,  2532,
    2228,  2528,     0,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,     0,  2533,     0,  2530,     0,     0,     0,
       0,  2531,     0,     0,     0,     0,     0,  2529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2532,  2228,     0,     0,     0,     0,     0,
       0,     0,     0,  2278,     0,     0,     0,     0,  2533,     0,
       0,   876,   877,     0,     0,     0,     0,  2534,     0,     0,
    2535,   879,     0,     0,   879,     0,   879,     0,     0,     0,
       0,   879,     0,     0,     0,     0,     0,     0,   880,     0,
       0,     0,     0,     0,     0,     0,     0,  2278,     0,     0,
     877,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2534,     0,     0,  2535,     0,     0,     0,     0,     0,
       0,  2530,   877,     0,     0,     0,  2531,     0,   879,   876,
       0,     0,     0,     0,     0,     0,   879,     0,     0,     0,
       0,  2530,     0,     0,     0,     0,  2531,     0,  2532,  2228,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2536,
       0,   879,   880,  2533,     0,     0,   880,     0,  2532,  2228,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2533,     0,     0,     0,     0,     0,   877,
       0,     0,     0,   942,     0,     0,     0,     0,     0,     0,
       0,     0,  2278,  2536,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2534,     0,     0,  2535,
       0,     0,  2278,     0,     0,     0,     0,     0,     0,     0,
     879,     0,   879,     0,     0,   942,  2534,     0,     0,  2535,
       0,     0,     0,     0,     0,     0,     0,   942,     0,   876,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2466,
       0,     0,     0,     0,     0,   880,     0,  2467,  2468,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,   942,     0,     0,     0,
     880,     0,     0,     0,     0,   880,     0,     0,     0,     0,
       0,     0,     0,     0,   882,     0,     0,     0,   882,   882,
       0,     0,     0,  2466,  1319,  1319,     0,     0,  2536,     0,
     877,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,
       0,     0,     0,   879,     0,     0,     0,     0,  2536,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4468,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1767,   882,     0,     0,     0,     0,
       0,   882,     0,     0,     0,   879,     0,     0,     0,     0,
       0,     0,   876,   942,     0,     0,     0,   876,   876,     0,
       0,  1319,     0,     0,     0,     0,     0,     0,  3266,     0,
       0,     0,     0,   879,     0,     0,     0,     0,  3271,     0,
       0,     0,   882,     0,     0,     0,     0,     0,  2466,     0,
       0,     0,     0,     0,     0,     0,  2467,  2468,  2469,  2470,
    2471,  2472,  2473,  2474,  2475,     0,     0,  1424,  2466,     0,
     877,     0,     0,     0,     0,     0,  2467,  2468,  2469,  2470,
    2471,  2472,  2473,  2474,  2475,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   942,
       0,     0,   879,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1424,  1424,     0,     0,     0,     0,
       0,     0,     0,  2040,   879,     0,  2041,     0,   876,     0,
    2042,  2043,  2044,     0,     0,     0,     0,     0,   877,     0,
       0,  1679,  1683,     0,     0,     0,   879,  2526,  1343,     0,
       0,     0,     0,     0,     0,     0,     0,  2527,     0,     0,
       0,     0,     0,     0,  2528,     0,     0,     0,     0,     0,
       0,     0,   876,     0,   880,     0,     0,   880,     0,   880,
       0,     0,     0,     0,   880,     0,     0,     0,     0,     0,
    2529,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   942,
       0,   942,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   879,     0,     0,
       0,   880,     0,     0,     0,     0,     0,     0,     0,   880,
       0,     0,   882,     0,     0,     0,     0,     0,     0,     0,
     879,     0,     0,     0,     0,     0,     0,   942,   877,     0,
       0,     0,     0,     0,   880,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   879,     0,     0,     0,  3481,
       0,   686,     0,     0,     0,  4941,  1021,     0,     0,     0,
       0,     0,     0,     0,  3503,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2530,     0,  1767,     0,     0,  2531,
       0,     0,     0,     0,     0,  3530,   882,     0,     0,     0,
     882,     0,     0,     0,  1022,     0,     0,     0,     0,     0,
       0,  2532,  2228,   880,     0,   880,     0,   689,  1023,     0,
       0,     0,     0,     0,     0,     0,  2533,     0,     0,  1024,
       0,     0,     0,   690,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1025,     0,     0,     0,     0,     0,  1996,     0,     0,
       0,   877,     0,     0,     0,  2278,   877,   877,     0,     0,
       0,     0,     0,  3605,  3606,  1026,     0,     0,     0,  2534,
       0,     0,  2535,     0,     0,     0,   693,     0,  2011,     0,
       0,     0,     0,     0,     0,   694,     0,     0,     0,   882,
       0,     0,     0,   879,     0,     0,   880,     0,   695,     0,
       0,     0,     0,  1027,   882,     0,  2029,  2030,  2031,   882,
    2033,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2040,     0,     0,  2041,     0,  1028,
    2484,  2042,  2043,  2044,     0,     0,     0,     0,   880,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2526,     0,
       0,     0,     0,     0,  1029,     0,     0,     0,  2527,     0,
       0,  2536,     0,     0,  3729,  2528,   880,   877,     0,     0,
       0,     0,     0,     0,     0,   699,     0,     0,     0,     0,
       0,     0,     0,   879,     0,     0,   942,     0,     0,     0,
       0,  2529,     0,     0,     0,     0,     0,     0,     0,     0,
     942,     0,     0,     0,     0,     0,     0,     0,   879,     0,
       0,   877,     0,     0,     0,  1030,     0,     0,  2040,     0,
       0,  2041,     0,     0,     0,  2042,  2043,  2044,     0,     0,
    1767,     0,  2578,     0,     0,   880,  2590,  2595,     0,   702,
       0,     0,  2526,     0,     0,     0,     0,     0,     0,   213,
    1031,     0,  2527,   704,     0,     0,     0,   880,     0,  2528,
       0,  2466,     0,     0,     0,     0,     0,     0,     0,  2467,
    2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,     0,   880,
    1032,     0,     0,  1033,     0,  2529,  4947,   707,     0,   708,
       0,     0,     0,     0,     0,     0,   709,  2477,     0,   710,
       0,     0,     0,     0,     0,  2530,     0,     0,     0,     0,
    2531,     0,     0,     0,     0,     0,     0,     0,   711,     0,
       0,     0,     0,     0,     0,  1034,  1767,     0,     0,     0,
       0,   713,  2532,  2228,  1035,     0,     0,     0,   715,     0,
       0,     0,     0,   879,     0,     0,  1036,  2533,   717,     0,
       0,  2477,     0,  1037,     0,     0,     0,     0,   882,     0,
     880,   882,     0,   882,     0,     0,     0,     0,   882,     0,
       0,     0,     0,     0,     0,  4948,     0,     0,     0,   720,
       0,     0,     0,   880,     0,     0,  2278,     0,  1767,   879,
     942,     0,     0,     0,   879,     0,     0,     0,     0,  2530,
    2534,     0,     0,  2535,  2531,     0,     0,     0,   880,     0,
       0,     0,     0,     0,     0,   882,     0,     0,     0,     0,
       0,     0,     0,   882,     0,     0,  2532,  2228,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2533,     0,     0,     0,     0,     0,     0,   882,     0,
       0,     0,     0,     0,     0,  2040,     0,     0,  2041,     0,
       0,     0,  2042,  2043,  2044,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3999,     0,  1679,  1679,  1679,  2526,
    2278,     0,     0,     0,     0,     0,     0,     0,     0,  2527,
       0,     0,  2536,     0,  2534,  1424,  2528,  2535,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   942,
       0,     0,     0,     0,     0,     0,     0,   882,     0,   882,
       0,     0,  2529,     0,   879,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   942,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   880,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2040,     0,     0,  2041,     0,
       0,     0,  2042,  2043,  2044,     0,  2536,     0,     0,     0,
       0,  4949,  2466,     0,     0,     0,     0,     0,     0,  2526,
    2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,  2527,
     882,     0,     0,     0,     0,     0,  2528,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2530,     0,     0,     0,
       0,  2531,  2529,     0,     0,     0,   880,   879,   942,     0,
       0,     0,   882,     0,     0,     0,     0,  2477,     0,     0,
       0,  2477,     0,  2532,  2228,     0,     0,     0,     0,     0,
       0,   880,     0,     0,     0,     0,     0,     0,  2533,     0,
     882,     0,     0,     0,     0,   879,  2466,     0,     0,     0,
       0,     0,     0,     0,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2474,  2475,     0,     0,     0,     0,   879,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2278,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2534,  5462,     0,  2535,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   882,
       0,     0,     0,     0,     0,     0,  2530,     0,  4206,     0,
       0,  2531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   882,     0,     0,   879,     0,     0,     0,     0,     0,
       0,  1767,     0,  2532,  2228,     0,     0,     0,     0,     0,
       0,     0,     0,   882,     0,     0,     0,     0,  2533,     0,
       0,  3140,     0,     0,     0,     0,   880,     0,     0,     0,
       0,     0,     0,  3160,     0,  3161,     0,  3163,  1767,     0,
    3177,  3180,  3185,  2536,     0,     0,     0,  3191,  1767,     0,
    3196,     0,     0,     0,     0,     0,     0,  2278,     0,     0,
       0,     0,     0,     0,     0,  3203,  3204,  3205,     0,     0,
       0,  2534,   880,     0,  2535,     0,     0,   880,     0,     0,
       0,     0,  3206,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   882,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   879,     0,   882,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   882,  2466,  4330,  4331,  4332,     0,     0,     0,
       0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,
       0,  4341,     0,  2536,     0,  2040,     0,     0,  2041,     0,
       0,     0,  2042,  2043,  2044,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2526,
       0,     0,     0,     0,  2477,  4365,  4367,     0,     0,  2527,
    4372,     0,     0,     0,     0,     0,  2528,   880,     0,  2477,
       0,     0,     0,  3173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3213,     0,  2477,  2477,  2477,
       0,  2477,  2529,     0,     0,   879,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2466,     0,  3230,     0,     0,     0,     0,
       0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     882,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4451,   879,     0,  1343,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3232,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     880,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2530,     0,     0,     0,
       0,  2531,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   880,     0,
       0,     0,     0,  2532,  2228,     0,     0,     0,     0,     0,
     882,     0,     0,     0,     0,     0,     0,     0,  2533,     0,
     880,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   882,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   879,     0,     0,     0,  2278,     0,     0,
       0,     0,     0,  4553,  4554,  4555,     0,     0,     0,     0,
       0,  2534,     0,     0,  2535,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   880,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3239,  3240,  3241,  3242,  3243,  3244,  3245,  3246,  3247,     0,
    3248,     0,     0,     0,     0,     0,     0,     0,     0,  1319,
       0,  1679,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2536,     0,     0,     0,     0,     0,     0,
     882,     0,     0,     0,     0,     0,   879,     0,     0,  3206,
       0,   879,   879,  3213,     0,     0,  3230,     0,  3232,     0,
       0,  3283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   880,     0,
       0,     0,     0,     0,     0,     0,   882,     0,     0,     0,
       0,   882,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2030,  2031,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2466,     0,     0,     0,     0,     0,     0,
       0,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   879,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,
       0,     0,  2477,     0,     0,     0,     0,     0,     2,     0,
       3,     4,     0,     0,     0,  3423,     0,     0,   880,     0,
       0,     0,     0,     0,     0,     0,   879,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     6,     0,
       0,   882,     0,     0,     0,     0,     0,     0,     0,     0,
       7,     0,     8,     9,     0,     0,     0,     0,     0,    10,
       0,    11,     0,     0,     0,     0,     0,     0,     0,     0,
    4809,     0,     0,    12,     0,    13,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   880,     0,     0,     0,
       0,     0,    14,     0,     0,    15,  2477,     0,     0,     0,
       0,  4841,     0,     0,     0,     0,     0,     0,  2477,     0,
      16,     0,    17,  2477,     0,     0,    18,     0,     0,     0,
       0,     0,  5440,     0,     0,     0,     0,     0,     0,     0,
      20,     0,    21,  3001,     0,     0,     0,     0,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    23,     0,     0,     0,
       0,     0,     0,     0,   882,     0,     0,     0,  4899,     0,
       0,     0,     0,    24,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3062,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   882,     0,     0,     0,   880,     0,     0,     0,
       0,     0,     0,    25,    26,     0,     0,     0,     0,    27,
       0,     0,     0,     0,   882,     0,     0,     0,     0,     0,
       0,    28,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3661,  3662,  1679,     0,     0,     0,  3666,     0,    29,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3695,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    30,     0,     0,     0,     0,
       0,   882,     0,    31,     0,     0,     0,     0,     0,     0,
       0,     0,  4984,  4985,  4986,  4987,     0,    32,     0,     0,
       0,     0,     0,    33,    34,     0,    35,     0,     0,     0,
       0,    36,     0,     0,  4403,     0,     0,    37,     0,   880,
      38,     0,     0,     0,   880,   880,     0,    39,     0,     0,
       0,     0,     0,    40,    41,     0,     0,     0,     0,     0,
       0,    42,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    44,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      45,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      46,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    47,   882,     0,     0,     0,     0,    48,     0,     0,
       0,     0,    49,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    50,     0,     0,     0,     0,
       0,     0,     0,   197,     0,   880,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    57,     0,     0,  -135,
    3890,     0,     0,     0,     0,  3896,     0,     0,     0,   880,
       0,     0,     0,     0,   198,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     199,     0,     0,  2033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3185,     0,  3185,  3185,   200,     0,
       0,     0,   882,     0,   201,     0,     0,  3956,     0,     0,
    3959,     0,  3961,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   202,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   203,     0,     0,     0,     0,     0,     0,
       0,     0,   204,     0,     0,     0,  3980,     0,  3983,     0,
    3985,     0,     0,     0,     0,   205,     0,     0,     0,     0,
     206,     0,     0,     0,     0,     0,     0,   207,     0,     0,
     882,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   208,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5198,     0,
       0,   209,     0,     0,     0,     0,     0,     0,     0,  5208,
       0,     0,     0,     0,     0,     0,     0,     0,  2477,     0,
       0,     0,   210,     0,     0,     0,     0,     0,  4050,     0,
       0,     0,     0,  2578,     0,     0,     0,     0,  2477,  2477,
       0,  2477,     0,     0,     0,     0,  3173,  3173,  2595,  3933,
       0,  3173,     0,     0,     0,  2477,     0,     0,  2477,     0,
       0,     0,   211,  2477,     0,     0,     0,     0,     0,  2477,
       0,     0,     0,     0,  2477,     0,     0,     0,     0,     0,
     882,  2477,  2477,  2477,  2477,     0,   212,     0,  3173,  3173,
       0,  2477,     0,     0,     0,     0,   213,   214,     0,     0,
     215,     0,     0,     0,     0,     0,     0,     0,  2477,     0,
    2477,  4099,     0,     0,     0,     0,     0,  2477,  2477,  2477,
    2477,  2477,  2477,  2477,  2477,  2477,  2477,   216,     0,     0,
     217,     0,     0,     0,   218,     0,   219,     0,     0,     0,
       0,     0,     0,   220,     0,     0,   221,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2477,     0,     0,     0,   222,     0,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,   224,   225,     0,
       0,   226,     0,     0,     0,   227,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   228,     0,     0,     0,     0,
     229,     0,     0,   882,     0,     0,     0,     0,   882,   882,
       0,     0,     0,   230,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   231,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5385,     0,     0,     0,
       0,  1343,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5415,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2477,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   882,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1679,     0,     0,   882,     0,     0,  1679,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5510,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4352,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5587,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2477,
    2477,     0,     0,     0,  2477,     0,     0,  5609,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2477,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4469,     0,     0,     0,     0,     0,
       0,     0,     0,  4473,     0,     0,     0,     0,     0,     0,
       0,  4475,     0,  4476,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4498,  4499,  4500,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3191,     0,
       0,     0,     0,     0,     0,     0,  4524,     0,     0,  4527,
       0,  4529,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4532,     0,     0,     0,     0,     0,     0,     0,  4539,
    4540,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2477,     0,
       0,  4598,     0,     0,  2477,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4611,     0,     0,
       0,     0,  3933,  3933,     0,     0,  3173,  3173,  3173,  3173,
       0,     0,  3173,  3173,  3173,  3173,  3173,  3173,  3173,  3173,
    3173,  3173,  3933,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2477,     0,     0,  2477,     0,  2477,
       0,     0,  3933,  3933,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2477,  3173,
    3173,  2477,     0,  2477,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2477,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2477,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4887,  4888,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4895,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4937,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4943,     0,     0,     0,     0,     0,  3173,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4962,  4964,     0,     0,     0,     0,     0,  4968,  4969,
    2477,     0,     0,  4970,     0,     0,     0,  4971,     0,     0,
    4974,  4975,     0,     0,     0,  4979,     0,     0,     0,     0,
       0,  4983,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5014,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1319,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5037,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2477,     0,     0,
       0,  2477,     0,  2477,  2477,     0,     0,     0,     0,  3933,
    3933,  3933,  3933,     0,     0,     0,  3933,  3933,  3933,  3933,
    3933,  3933,  3933,  3933,  3933,  3933,  2477,  2477,  2477,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2477,     0,     0,  2477,     0,  2477,     0,     0,
    2477,     0,     0,  3933,  3933,     0,     0,  2477,  2477,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5102,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2477,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2477,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5138,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5226,     0,     0,     0,     0,     0,
    5230,  5231,  5232,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5243,  5244,     0,  3933,  5245,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5265,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5295,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2477,  2477,     0,     0,     0,
       0,     0,     0,  2477,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2477,     0,     0,     0,     0,
       0,  2477,  3173,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2477,     0,  2477,     0,     0,     0,  2477,  2477,  2477,  2477,
       0,     0,  2477,  2477,     0,     0,     0,  2477,     0,     0,
       0,  2477,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3173,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2477,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2477,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3191,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2033,
    2477,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2477,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5528,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5564,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2477,     0,  3933,  3173,  2477,  2477,
    2477,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2477,  2477,  2477,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3173,     0,     0,  3933,
       0,     0,     0,  2477,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2477,     0,     0,     0,  5630,     0,     0,     0,     0,
       0,     0,     0,  2477,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5283,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5674,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5759,  5759,
    5759,  3933,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3933,  5283,  3173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2477,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5822,     0,     0,     0,     0,     0,     0,
       0,     0,  2477,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5846,     0,  5759,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2477,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2477,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5917,     0,     0,     0,  5918,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5759,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2477,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3173,  3173,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1679,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2477,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2477,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3933,  3933,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   234,     0,  1235,   681,     0,  1236,  1237,  1238,   741,
    1239,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,  1673,   243,   244,   245,
       0,     0,     0,     0,  1240,  2477,  2477,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1241,   259,  1242,  1243,     0,   262,   263,   264,   265,   266,
     267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,     0,
     274,   275,   276,   277,  1248,     0,  1249,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,   303,
     304,   305,   306,  1257,  1258,   309,  1259,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,  1674,     0,   322,   323,   857,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1260,   338,   339,   340,   341,  1261,  1262,   343,     0,
     344,   345,   346,  1263,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,  1264,     0,
    1265,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1266,  1267,     0,  1268,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,  1269,   401,
     402,   403,     0,   404,   405,   406,  1270,  1271,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1272,   424,  1273,   426,   427,   428,
     429,   430,   431,   432,   433,  1274,   435,  1275,   436,   437,
     438,   439,  1276,  1277,   441,  1278,   443,   444,   445,     0,
     446,   447,     0,     0,  1279,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1280,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1281,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1282,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,  1283,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
    1284,   526,   527,   528,   529,   530,   531,   532,   533,  1285,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1286,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1287,  1288,     0,     0,   563,   564,  1289,   566,  1290,  1291,
     568,   569,   570,   571,   572,   573,   574,   575,     0,  1292,
     576,   577,   578,   579,   580,  1293,     0,   581,   582,   583,
     584,   585,   586,  1294,  1675,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,  1295,  1296,  1297,  1298,   606,  1299,  1300,
    1301,  1302,   611,   612,   613,   614,  1303,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1304,  1305,  1676,
       0,     0,     0,     0,     0,     0,  1307,  1677,   234,     0,
    1235,   681,     0,  1236,  1237,  1238,   741,  1239,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,  1240,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,  1241,   259,  1242,
    1243,     0,   262,   263,   264,   265,   266,   267,   268,  1244,
    1245,   269,   270,  1246,  1247,   273,     0,   274,   275,   276,
     277,  1248,     0,  1249,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,   301,   302,   303,   304,   305,   306,
    1257,  1258,   309,  1259,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   857,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,  1260,   338,
     339,   340,   341,  1261,  1262,   343,     0,   344,   345,   346,
    1263,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,  1264,     0,  1265,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,  1266,  1267,     0,
    1268,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,  1269,   401,   402,   403,     0,
     404,   405,   406,  1270,  1271,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,  1272,   424,  1273,   426,   427,   428,   429,   430,   431,
     432,   433,  1274,   435,  1275,   436,   437,   438,   439,  1276,
    1277,   441,  1278,   443,   444,   445,     0,   446,   447,     0,
       0,  1279,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,  1280,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,  1281,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,  1282,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,  1283,   512,   513,   514,   515,   516,   517,   518,   519,
     520,    41,   521,   522,   523,   524,   525,  1284,   526,   527,
     528,   529,   530,   531,   532,   533,  1285,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,  1286,   550,     0,   551,   552,    45,   553,   554,
     555,   556,   557,   558,   559,     0,   560,  1287,  1288,     0,
       0,   563,   564,  1289,   566,  1290,  1291,   568,   569,   570,
     571,   572,   573,   574,   575,     0,  1292,   576,   577,   578,
     579,   580,  1293,     0,   581,   582,   583,   584,   585,  1170,
    1294,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,    50,   595,   596,   597,   598,   599,   600,   601,
    1295,  1296,  1297,  1298,   606,  1299,  1300,  1301,  1302,   611,
     612,   613,   614,  1303,     0,    51,     0,     0,     0,     0,
       0,     0,     0,     0,  1304,  1305,     0,     0,     0,     0,
       0,     0,     0,  1307,  5491,   234,     0,  1235,   681,     0,
    1236,  1237,  1238,   741,  1239,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,  1240,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1241,   259,  1242,  1243,     0,   262,
     263,   264,   265,   266,   267,   268,  1244,  1245,   269,   270,
    1246,  1247,   273,     0,   274,   275,   276,   277,  1248,     0,
    1249,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,   301,   302,   303,   304,   305,   306,  1257,  1258,   309,
    1259,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   857,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,  1260,   338,   339,   340,   341,
    1261,  1262,   343,     0,   344,   345,   346,  1263,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,  1264,     0,  1265,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,  1266,  1267,     0,  1268,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,  1269,   401,   402,   403,     0,   404,   405,   406,
    1270,  1271,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1272,   424,
    1273,   426,   427,   428,   429,   430,   431,   432,   433,  1274,
     435,  1275,   436,   437,   438,   439,  1276,  1277,   441,  1278,
     443,   444,   445,     0,   446,   447,     0,     0,  1279,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,  1280,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,  1281,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1282,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,  1283,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,  1284,   526,   527,   528,   529,   530,
     531,   532,   533,  1285,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1286,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,  1287,  1288,     0,     0,   563,   564,
    1289,   566,  1290,  1291,   568,   569,   570,   571,   572,   573,
     574,   575,     0,  1292,   576,   577,   578,   579,   580,  1293,
       0,   581,   582,   583,   584,   585,   586,  1294,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,  1295,  1296,  1297,
    1298,   606,  1299,  1300,  1301,  1302,   611,   612,   613,   614,
    1303,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1304,  1305,     0,     0,     0,     0,     0,     0,     0,
    1307,  3175,   234,     0,  1235,   681,     0,  1236,  1237,  1238,
     741,  1239,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,  1240,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,  1241,   259,  1242,  1243,     0,   262,   263,   264,   265,
     266,   267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,
       0,   274,   275,   276,   277,  1248,     0,  1249,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,
     303,   304,   305,   306,  1257,  1258,   309,  1259,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   857,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,  1260,   338,   339,   340,   341,  1261,  1262,   343,
       0,   344,   345,   346,  1263,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,  1264,
       0,  1265,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,  1266,  1267,     0,  1268,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,  1269,
     401,   402,   403,     0,   404,   405,   406,  1270,  1271,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1272,   424,  1273,   426,   427,
     428,   429,   430,   431,   432,   433,  1274,   435,  1275,   436,
     437,   438,   439,  1276,  1277,   441,  1278,   443,   444,   445,
       0,   446,   447,     0,     0,  1279,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1280,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1281,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1282,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,  1283,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1284,   526,   527,   528,   529,   530,   531,   532,   533,
    1285,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1286,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,  1287,  1288,     0,     0,   563,   564,  1289,   566,  1290,
    1291,   568,   569,   570,   571,   572,   573,   574,   575,     0,
    1292,   576,   577,   578,   579,   580,  1293,     0,   581,   582,
     583,   584,   585,   586,  1294,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,  1299,
    1300,  1301,  1302,   611,   612,   613,   614,  1303,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1304,  1305,
       0,     0,     0,     0,     0,     0,     0,  1307,  4477,   234,
       0,  1235,   681,     0,  1236,  1237,  1238,   741,  1239,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,  1240,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,   257,  1241,   259,
    1242,  1243,     0,   262,   263,   264,   265,   266,   267,   268,
    1244,  1245,   269,   270,  1246,  1247,   273,     0,   274,   275,
     276,   277,  1248,     0,  1249,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,   301,   302,   303,   304,   305,
     306,  1257,  1258,   309,  1259,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   857,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,  1260,
     338,   339,   340,   341,  1261,  1262,   343,     0,   344,   345,
     346,  1263,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,  1264,     0,  1265,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,  1266,  1267,
       0,  1268,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,     0,     0,   399,  1269,   401,   402,   403,
       0,   404,   405,   406,  1270,  1271,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1272,   424,  1273,   426,   427,   428,   429,   430,
     431,   432,   433,  1274,   435,  1275,   436,   437,   438,   439,
    1276,  1277,   441,  1278,   443,   444,   445,     0,   446,   447,
       0,     0,  1279,   449,   450,     0,     0,   451,   452,   453,
     454,   455,   456,  1280,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,  1281,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,  1282,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,  1283,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,  1284,   526,
     527,   528,   529,   530,   531,   532,   533,  1285,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,  1286,   550,     0,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,     0,   560,  1287,  1288,
       0,     0,   563,   564,  1289,   566,  1290,  1291,   568,   569,
     570,   571,   572,   573,   574,   575,     0,  1292,   576,   577,
     578,   579,   580,  1293,     0,   581,   582,   583,   584,   585,
     586,  1294,     0,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,  1295,  1296,  1297,  1298,   606,  1299,  1300,  1301,  1302,
     611,   612,   613,   614,  1303,     0,     0,     0,     0,   622,
       0,     0,     0,     0,     0,  1304,  1305,     0,     0,     0,
       0,     0,     0,     0,  1307,  4546,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,  4028,     0,   246,   247,   248,     0,   249,
     250,   251,   252,     0,   254,   255,   256,   257,   258,     0,
     260,   261,     0,   262,   263,   264,   265,   266,   267,   268,
       0,     0,   269,   270,   271,   272,   273,     0,   274,   275,
     276,   277,   278,     0,     0,     0,   280,   281,   282,   283,
     284,   285,     0,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0, -1767,   297,   298,   299,     0,     0,
       0,     0,     0,     0,     0,   301,   302,   303,   304,   305,
     306,   307,   308,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   324,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,     0,   343,     0,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0, -1767,
     353,   354,   355,   356,     0,   357,   358,     0,   359,   360,
     361,     0,   362,   363,   364,   365,   366,     0,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379, -1767,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   389,     0,     0,   392, -1767,   394,   395,
     396,   397,   398,     0,     0,   399,   400, -1767,   402,     0,
       0,   404,   405,   406,     0,     0,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423, -1767,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   436,   437,     0,   439,
       0,   440,   441,   442,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,     0,     0,   451,   452,   453,
       0,   455,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504, -1767,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,     0,   526,
     527,   528,   529,   530,     0,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,     0,   553,
       0,   555,   556,   557,   558,   559,     0,   560,   561,   562,
       0,     0,   563,   564,   565,   566,   567,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,     0,     0,     0,     0,     0,   849,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1417,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,     0,   850,   259,
     851,   852,     0,   262,   263,   264,   265,   266,   267,   268,
       0,     0,   269,   270,   853,   854,   273,     0,   274,   275,
     276,   277,     0,     0,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
       0,   300,     0,     0,     0,   301,   302,   303,   304,   305,
     306,   855,   856,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   857,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     338,   339,   340,   341,     0,     0,   343,     0,   344,   345,
     346,   858,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,     0,     0,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,  2620,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,  2621,   382,   383,   384,   385,   859,   860,
       0,   861,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,     0,     0,   399,     0,   401,   402,   403,
       0,   404,   405,   406,     0,     0,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   862,   424,   863,   426,   427,   428,   429,   430,
     431,   432,     0,     0,   435,     0,   436,   437,   438,   439,
       0,     0,   441,   864,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,     0,     0,   451,   452,  2623,
     454,   455,   456,     0,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,     0,   470,     0,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   865,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,     0,   526,
     527,  2624,   529,   530,   531,   532,   533,   867,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   550,     0,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   868,   869,
       0,     0,   563,   564,     0,   566,     0,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,     0,   581,   582,   583,   584,   585,
       0,   870,  2625,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     849,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   612,   613,   614,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,     0,     0,  2720,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,     0,   850,
     259,   851,   852,     0,   262,   263,   264,   265,   266,   267,
     268,     0,     0,   269,   270,   853,   854,   273,     0,   274,
     275,   276,   277,     0,     0,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,     0,   300,     0,     0,     0,   301,   302,   303,   304,
     305,   306,   855,   856,   309,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   857,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   338,   339,   340,   341,     0,     0,   343,     0,   344,
     345,   346,   858,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,     0,     0,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,  2620,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,  2621,   382,   383,   384,   385,   859,
     860,     0,   861,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,     0,   401,   402,
     403,     0,   404,   405,   406,     0,     0,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   862,   424,   863,   426,   427,   428,   429,
     430,   431,   432,     0,     0,   435,     0,   436,   437,   438,
     439,     0,     0,   441,   864,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,     0,     0,   451,   452,
    2623,   454,   455,   456,     0,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,     0,   470,
       0,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   865,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,     0,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,     0,
     526,   527,  2624,   529,   530,   531,   532,   533,   867,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,     0,   550,     0,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,     0,   560,   868,
     869,     0,     0,   563,   564,     0,   566,     0,     0,   568,
     569,   570,   571,   572,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,     0,   581,   582,   583,   584,
     585,     0,   870,  2625,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   234,     0,  1235,   681,     0,  1236,  1237,  1238,   741,
    1239,     0,   612,   613,   614,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,  1240,     0,  3785,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1241,   259,  1242,  1243,     0,   262,   263,   264,   265,   266,
     267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,     0,
     274,   275,   276,   277,  1248,     0,  1249,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,   303,
     304,   305,   306,  1257,  1258,   309,  1259,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   857,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1260,   338,   339,   340,   341,  1261,  1262,   343,     0,
     344,   345,   346,  1263,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,  1264,     0,
    1265,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1266,  1267,     0,  1268,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,  1269,   401,
     402,   403,     0,   404,   405,   406,  1270,  1271,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1272,   424,  1273,   426,   427,   428,
     429,   430,   431,   432,   433,  1274,   435,  1275,   436,   437,
     438,   439,  1276,  1277,   441,  1278,   443,   444,   445,     0,
     446,   447,     0,     0,  1279,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1280,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1281,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1282,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,  1283,   512,   513,   514,   515,   516,
     517,   518,   519,   520,    41,   521,   522,   523,   524,   525,
    1284,   526,   527,   528,   529,   530,   531,   532,   533,  1285,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1286,   550,     0,   551,   552,
      45,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1287,  1288,     0,     0,   563,   564,  1289,   566,  1290,  1291,
     568,   569,   570,   571,   572,   573,   574,   575,     0,  1292,
     576,   577,   578,   579,   580,  1293,     0,   581,   582,   583,
     584,   585,  1170,  1294,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,    50,   595,   596,   597,   598,
     599,   600,   601,  1295,  1296,  1297,  1298,   606,  1299,  1300,
    1301,  1302,   611,   612,   613,   614,  1303,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,  1304,  1305,     0,
       0,     0,   234,     0,  1235,   681,  1307,  1236,  1237,  1238,
     741,  1239,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,  1240,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,  1241,   259,  1242,  1243,  3181,   262,   263,   264,   265,
     266,   267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,
       0,   274,   275,   276,   277,  1248,     0,  1249,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,
     303,   304,   305,   306,  1257,  1258,   309,  1259,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   857,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,  1260,   338,   339,   340,   341,  1261,  1262,   343,
       0,   344,   345,   346,  1263,   348,     0,   349,     0,   350,
     351,  3182,   352,   353,   354,   355,   356,     0,   357,  1264,
       0,  1265,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,  1266,  1267,     0,  1268,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,  3183,   399,  1269,
     401,   402,   403,     0,   404,   405,   406,  1270,  1271,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1272,   424,  1273,   426,   427,
     428,   429,   430,   431,   432,   433,  1274,   435,  1275,   436,
     437,   438,   439,  1276,  1277,   441,  1278,   443,   444,   445,
       0,   446,   447,     0,     0,  1279,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1280,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1281,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1282,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,  1283,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1284,   526,   527,   528,   529,   530,   531,   532,   533,
    1285,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1286,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,  1287,  1288,     0,  3184,   563,   564,  1289,   566,  1290,
    1291,   568,   569,   570,   571,   572,   573,   574,   575,     0,
    1292,   576,   577,   578,   579,   580,  1293,     0,   581,   582,
     583,   584,   585,   586,  1294,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,  1299,
    1300,  1301,  1302,   611,   612,   613,   614,  1303,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1304,  1305,
       0,     0,     0,   234,     0,  1235,   681,  1307,  1236,  1237,
    1238,   741,  1239,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242, -2156,   243,
     244,   245,     0,     0,     0, -2156,  1240,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1241,   259,  1242,  1243,     0,   262,   263,   264,
     265,   266,   267,   268,  1244,  1245,   269,   270,  1246,  1247,
     273,     0,   274,   275,   276,   277,  1248,     0,  1249,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,
     302,   303,   304,   305,   306,  1257,  1258,   309,  1259,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   857,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,  1260,   338,   339,   340,   341,  1261,  1262,
     343,     0,   344,   345,   346,  1263,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
    1264,     0,  1265,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,  1266,  1267,     0,  1268,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
    1269,   401,   402,   403,     0,   404,   405,   406,  1270,  1271,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1272,   424,  1273,   426,
     427,   428,   429,   430,   431,   432,   433,  1274,   435,  1275,
     436,   437,   438,   439,  1276,  1277,   441,  1278,   443,   444,
     445,     0,   446,   447,     0,     0,  1279,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,  1280,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,  1281,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1282,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,  1283,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,  1284,   526,   527,   528,   529,   530,   531,   532,
     533,  1285,   535, -2156,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,  1286,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,  1287,  1288,     0,     0,   563,   564,  1289,   566,
    1290,  1291,   568,   569,   570,   571,   572,   573,   574,   575,
       0,  1292,   576,   577,   578,   579,   580,  1293,     0,   581,
     582,   583,   584,   585,   586,  1294,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,
    1299,  1300,  1301,  1302,   611,   612,   613,   614,  1303,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1304,
    1305,     0,     0,     0,   234,     0,  1235,   681,  1307,  1236,
    1237,  1238,   741,  1239,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242, -2154,
     243,   244,   245,     0,     0,     0, -2154,  1240,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,  1241,   259,  1242,  1243,     0,   262,   263,
     264,   265,   266,   267,   268,  1244,  1245,   269,   270,  1246,
    1247,   273,     0,   274,   275,   276,   277,  1248,     0,  1249,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
     301,   302,   303,   304,   305,   306,  1257,  1258,   309,  1259,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   857,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,  1260,   338,   339,   340,   341,  1261,
    1262,   343,     0,   344,   345,   346,  1263,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,  1264,     0,  1265,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,  1266,  1267,     0,  1268,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,  1269,   401,   402,   403,     0,   404,   405,   406,  1270,
    1271,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,  1272,   424,  1273,
     426,   427,   428,   429,   430,   431,   432,   433,  1274,   435,
    1275,   436,   437,   438,   439,  1276,  1277,   441,  1278,   443,
     444,   445,     0,   446,   447,     0,     0,  1279,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,  1280,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,  1281,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1282,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,  1283,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,  1284,   526,   527,   528,   529,   530,   531,
     532,   533,  1285,   535, -2154,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,  1286,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,  1287,  1288,     0,     0,   563,   564,  1289,
     566,  1290,  1291,   568,   569,   570,   571,   572,   573,   574,
     575,     0,  1292,   576,   577,   578,   579,   580,  1293,     0,
     581,   582,   583,   584,   585,   586,  1294,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,  1295,  1296,  1297,  1298,
     606,  1299,  1300,  1301,  1302,   611,   612,   613,   614,  1303,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1304,  1305,     0,     0,     0,   234,     0,  1235,   681,  1307,
    1236,  1237,  1238,   741,  1239,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,  1240,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1241,   259,  1242,  1243,     0,   262,
     263,   264,   265,   266,   267,   268,  1244,  1245,   269,   270,
    1246,  1247,   273,     0,   274,   275,   276,   277,  1248,     0,
    1249,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,   301,   302,   303,   304,   305,   306,  1257,  1258,   309,
    1259,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   857,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,  1260,   338,   339,   340,   341,
    1261,  1262,   343,     0,   344,   345,   346,  1263,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,  1264,     0,  1265,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,  1266,  1267,     0,  1268,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,  1269,   401,   402,   403,     0,   404,   405,   406,
    1270,  1271,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1272,   424,
    1273,   426,   427,   428,   429,   430,   431,   432,   433,  1274,
     435,  1275,   436,   437,   438,   439,  1276,  1277,   441,  1278,
     443,   444,   445,     0,   446,   447,     0,     0,  1279,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,  1280,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,  1281,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1282,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,  1283,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,  1284,   526,   527,   528,   529,   530,
     531,   532,   533,  1285,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1286,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,  1287,  1288,     0,     0,   563,   564,
    1289,   566,  1290,  1291,   568,   569,   570,   571,   572,   573,
     574,   575,     0,  1292,   576,   577,   578,   579,   580,  1293,
       0,   581,   582,   583,   584,   585,   586,  1294,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,  1295,  1296,  1297,
    1298,   606,  1299,  1300,  1301,  1302,   611,   612,   613,   614,
    1303,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1304,  1305,     0,     0,     0,     0,     0,  1993,  3133,
    1307,   234,     0,  1235,   681,     0,  1236,  1237,  1238,   741,
    1239,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,  1240,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1241,   259,  1242,  1243,     0,   262,   263,   264,   265,   266,
     267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,     0,
     274,   275,   276,   277,  1248,     0,  1249,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,   303,
     304,   305,   306,  1257,  1258,   309,  1259,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   857,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1260,   338,   339,   340,   341,  1261,  1262,   343,     0,
     344,   345,   346,  1263,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,  1264,     0,
    1265,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1266,  1267,     0,  1268,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,  1269,   401,
     402,   403,     0,   404,   405,   406,  1270,  1271,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1272,   424,  1273,   426,   427,   428,
     429,   430,   431,   432,   433,  1274,   435,  1275,   436,   437,
     438,   439,  1276,  1277,   441,  1278,   443,   444,   445,     0,
     446,   447,     0,     0,  1279,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1280,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1281,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1282,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,  1283,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
    1284,   526,   527,   528,   529,   530,   531,   532,   533,  1285,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1286,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1287,  1288,     0,     0,   563,   564,  1289,   566,  1290,  1291,
     568,   569,   570,   571,   572,   573,   574,   575,     0,  1292,
     576,   577,   578,   579,   580,  1293,     0,   581,   582,   583,
     584,   585,   586,  1294,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,  1295,  1296,  1297,  1298,   606,  1299,  1300,
    1301,  1302,   611,   612,   613,   614,  1303,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1304,  1305,  1306,
       0,     0,   234,     0,  1235,   681,  1307,  1236,  1237,  1238,
     741,  1239,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,  2588,   243,   244,
     245,     0,     0,     0,     0,  1240,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,  1241,   259,  1242,  1243,     0,   262,   263,   264,   265,
     266,   267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,
       0,   274,   275,   276,   277,  1248,     0,  1249,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,
     303,   304,   305,   306,  1257,  1258,   309,  1259,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   857,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,  1260,   338,   339,   340,   341,  1261,  1262,   343,
       0,   344,   345,   346,  1263,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,  1264,
       0,  1265,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,  1266,  1267,     0,  1268,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,  1269,
     401,   402,   403,     0,   404,   405,   406,  1270,  1271,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1272,   424,  1273,   426,   427,
     428,   429,   430,   431,   432,   433,  1274,   435,  1275,   436,
     437,   438,   439,  1276,  1277,   441,  1278,   443,   444,   445,
       0,   446,   447,     0,     0,  1279,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1280,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1281,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1282,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,  1283,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1284,   526,   527,   528,   529,   530,   531,   532,   533,
    1285,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1286,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,  1287,  1288,     0,     0,   563,   564,  1289,   566,  1290,
    1291,   568,   569,   570,   571,   572,   573,   574,   575,     0,
    1292,   576,   577,   578,   579,   580,  1293,     0,   581,   582,
     583,   584,   585,   586,  1294,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,  1299,
    1300,  1301,  1302,   611,   612,   613,   614,  1303,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1304,  1305,
       0,     0,     0,   234,     0,  1235,   681,  1307,  1236,  1237,
    1238,   741,  1239,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,  1240,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1241,   259,  1242,  1243,     0,   262,   263,   264,
     265,   266,   267,   268,  1244,  1245,   269,   270,  1246,  1247,
     273,     0,   274,   275,   276,   277,  1248,     0,  1249,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,
     302,   303,   304,   305,   306,  1257,  1258,   309,  1259,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   857,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,  1260,   338,   339,   340,   341,  1261,  1262,
     343,     0,   344,   345,   346,  1263,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
    1264,     0,  1265,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,  1266,  1267,     0,  1268,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
    1269,   401,   402,   403,     0,   404,   405,   406,  1270,  1271,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1272,   424,  1273,   426,
     427,   428,   429,   430,   431,   432,   433,  1274,   435,  1275,
     436,   437,   438,   439,  1276,  1277,   441,  1278,   443,   444,
     445,     0,   446,   447,     0,     0,  1279,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,  1280,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,  1281,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1282,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,  1283,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,  1284,   526,   527,   528,   529,   530,   531,   532,
     533,  1285,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,  1286,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,  1287,  1288,     0,     0,   563,   564,  1289,   566,
    1290,  1291,   568,   569,   570,   571,   572,   573,   574,   575,
       0,  1292,   576,   577,   578,   579,   580,  1293,     0,   581,
     582,   583,   584,   585,   586,  1294,  3663,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,
    1299,  1300,  1301,  1302,   611,   612,   613,   614,  1303,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1304,
    1305,     0,     0,     0,   234,     0,  1235,   681,  1307,  1236,
    1237,  1238,   741,  1239,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,  1240,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,  1241,   259,  1242,  1243,     0,   262,   263,
     264,   265,   266,   267,   268,  1244,  1245,   269,   270,  1246,
    1247,   273,     0,   274,   275,   276,   277,  1248,     0,  1249,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
     301,   302,   303,   304,   305,   306,  1257,  1258,   309,  1259,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   857,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,  1260,   338,   339,   340,   341,  1261,
    1262,   343,     0,   344,   345,   346,  1263,   348,     0,   349,
       0,   350,   351,  3182,   352,   353,   354,   355,   356,     0,
     357,  1264,     0,  1265,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,  1266,  1267,     0,  1268,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,  1269,   401,   402,   403,     0,   404,   405,   406,  1270,
    1271,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,  1272,   424,  1273,
     426,   427,   428,   429,   430,   431,   432,   433,  1274,   435,
    1275,   436,   437,   438,   439,  1276,  1277,   441,  1278,   443,
     444,   445,     0,   446,   447,     0,     0,  1279,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,  1280,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,  1281,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1282,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,  1283,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,  1284,   526,   527,   528,   529,   530,   531,
     532,   533,  1285,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,  1286,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,  1287,  1288,     0,     0,   563,   564,  1289,
     566,  1290,  1291,   568,   569,   570,   571,   572,   573,   574,
     575,     0,  1292,   576,   577,   578,   579,   580,  1293,     0,
     581,   582,   583,   584,   585,   586,  1294,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,  1295,  1296,  1297,  1298,
     606,  1299,  1300,  1301,  1302,   611,   612,   613,   614,  1303,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1304,  1305,     0,     0,     0,   234,     0,  1235,   681,  1307,
    1236,  1237,  1238,   741,  1239,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,  1240,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1241,   259,  1242,  1243,     0,   262,
     263,   264,   265,   266,   267,   268,  1244,  1245,   269,   270,
    1246,  1247,   273,     0,   274,   275,   276,   277,  1248,     0,
    1249,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,   301,   302,   303,   304,   305,   306,  1257,  1258,   309,
    1259,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   857,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,  1260,   338,   339,   340,   341,
    1261,  1262,   343,     0,   344,   345,   346,  1263,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,  1264,     0,  1265,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,  1266,  1267,     0,  1268,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,  1269,   401,   402,   403,     0,   404,   405,   406,
    1270,  1271,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1272,   424,
    1273,   426,   427,   428,   429,   430,   431,   432,   433,  1274,
     435,  1275,   436,   437,   438,   439,  1276,  1277,   441,  1278,
     443,   444,   445,     0,   446,   447,     0,     0,  1279,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,  1280,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,  1281,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1282,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,  1283,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,  1284,   526,   527,   528,   529,   530,
     531,   532,   533,  1285,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1286,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,  1287,  1288,  3233,     0,   563,   564,
    1289,   566,  1290,  1291,   568,   569,   570,   571,   572,   573,
     574,   575,     0,  1292,   576,   577,   578,   579,   580,  1293,
       0,   581,   582,   583,   584,   585,   586,  1294,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,  1295,  1296,  1297,
    1298,   606,  1299,  1300,  1301,  1302,   611,   612,   613,   614,
    1303,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1304,  1305,     0,     0,     0,   234,     0,  1235,   681,
    1307,  1236,  1237,  1238,   741,  1239,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,  1240,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,   256,   257,  1241,   259,  1242,  1243,     0,
     262,   263,   264,   265,   266,   267,   268,  1244,  1245,   269,
     270,  1246,  1247,   273,     0,   274,   275,   276,   277,  1248,
       0,  1249,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,   301,   302,   303,   304,   305,   306,  1257,  1258,
     309,  1259,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     857,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,  1260,   338,   339,   340,
     341,  1261,  1262,   343,     0,   344,   345,   346,  1263,   348,
       0,   349,     0,   350,   351,     0,   352,   353,   354,   355,
     356,     0,   357,  1264,     0,  1265,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,   383,   384,   385,  1266,  1267,     0,  1268,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,     0,   399,  1269,   401,   402,   403,     0,   404,   405,
     406,  1270,  1271,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,  1272,
     424,  1273,   426,   427,   428,   429,   430,   431,   432,   433,
    1274,   435,  1275,   436,   437,   438,   439,  1276,  1277,   441,
    1278,   443,   444,   445,     0,   446,   447,     0,     0,  1279,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
    1280,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,  1281,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,  1282,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,  1283,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,  1284,   526,   527,   528,   529,
     530,   531,   532,   533,  1285,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
    1286,   550,     0,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,     0,   560,  1287,  1288,     0,     0,   563,
     564,  1289,   566,  1290,  1291,   568,   569,   570,   571,   572,
     573,   574,   575,     0,  1292,   576,   577,   578,   579,   580,
    1293,     0,   581,   582,   583,   584,   585,   586,  1294,     0,
     588,   589,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,  1295,  1296,
    1297,  1298,   606,  1299,  1300,  1301,  1302,   611,   612,   613,
     614,  1303,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1304,  1305,     0,     0,     0,   234,     0,  1235,
     681,  1307,  1236,  1237,  1238,   741,  1239,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
    1240,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,  1241,   259,  1242,  1243,
       0,   262,   263,   264,   265,   266,   267,   268,  1244,  1245,
     269,   270,  1246,  1247,   273,     0,   274,   275,   276,   277,
    1248,     0,  1249,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,   301,   302,   303,   304,   305,   306,  1257,
    1258,   309,  1259,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   857,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,  1260,   338,   339,
     340,   341,  1261,  1262,   343,     0,   344,   345,   346,  1263,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,  1264,     0,  1265,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,  1266,  1267,     0,  1268,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,  1269,   401,   402,   403,     0,   404,
     405,   406,  1270,  1271,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1272,   424,  1273,   426,   427,   428,   429,   430,   431,   432,
     433,  1274,   435,  1275,   436,   437,   438,   439,  1276,  1277,
     441,  1278,   443,   444,   445,     0,   446,   447,     0,     0,
    1279,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,  1280,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,  1281,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1282,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
    1283,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,  1284,   526,   527,   528,
     529,   530,   531,   532,   533,  1285,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,  1286,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,  1287,  1288,     0,     0,
     563,   564,  1289,   566,  1290,  1291,   568,   569,   570,   571,
     572,   573,   574,   575,     0,  1292,   576,   577,   578,   579,
     580,  1293,     0,   581,   582,   583,   584,   585,   586,  1294,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,  1295,
    1296,  1297,  1298,   606,  1299,  1300,  1301,  1302,   611,   612,
     613,   614,  1303,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2591,  2592,     0,     0,     0,   234,     0,
    3346,   681,  1307,  1236,  1237,  1238,   741,  1239,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,  1240,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,  1241,   259,  1242,
    1243,     0,   262,   263,   264,   265,   266,   267,   268,  1244,
    1245,   269,   270,  1246,  1247,   273,     0,   274,   275,   276,
     277,  1248,     0,  1249,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,   301,   302,   303,   304,   305,   306,
    1257,  1258,   309,  1259,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   857,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,  1260,   338,
     339,   340,   341,  1261,  1262,   343,     0,   344,   345,   346,
    1263,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,  1264,     0,  1265,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,  1266,  1267,     0,
    1268,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,  1269,   401,   402,   403,     0,
     404,   405,   406,  1270,  1271,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,  1272,   424,  1273,   426,   427,   428,   429,   430,   431,
     432,   433,  1274,   435,  1275,   436,   437,   438,   439,  1276,
    1277,   441,  1278,   443,   444,   445,     0,   446,   447,     0,
       0,  1279,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,  1280,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,  1281,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,  1282,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,  1283,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,  1284,   526,   527,
     528,   529,   530,   531,   532,   533,  1285,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,  1286,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,  1287,  1288,     0,
       0,   563,   564,  1289,   566,  1290,  1291,   568,   569,   570,
     571,   572,   573,   574,   575,     0,  1292,   576,   577,   578,
     579,   580,  1293,     0,   581,   582,   583,   584,   585,   586,
    1294,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
    1295,  1296,  1297,  1298,   606,  1299,  1300,  1301,  1302,   611,
     612,   613,   614,  1303,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1304,  1305,     0,     0,     0,   234,
       0,  1235,   681,  1307,  1236,  1237,  1238,   741,  1239,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,  1240,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,   257,  1241,   259,
    1242,  1243,     0,   262,   263,   264,   265,   266,   267,   268,
    1244,  1245,   269,   270,  1246,  1247,   273,     0,   274,   275,
     276,   277,  1248,     0,  1249,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,  4597,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,   301,   302,   303,   304,   305,
     306,  1257,  1258,   309,  1259,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   857,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,  1260,
     338,   339,   340,   341,  1261,  1262,   343,     0,   344,   345,
     346,  1263,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,  1264,     0,  1265,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,  1266,  1267,
       0,  1268,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,     0,     0,   399,  1269,   401,   402,   403,
       0,   404,   405,   406,  1270,  1271,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1272,   424,  1273,   426,   427,   428,   429,   430,
     431,   432,   433,  1274,   435,  1275,   436,   437,   438,   439,
    1276,  1277,   441,  1278,   443,   444,   445,     0,   446,   447,
       0,     0,  1279,   449,   450,     0,     0,   451,   452,   453,
     454,   455,   456,  1280,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,  1281,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,  1282,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,  1283,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,  1284,   526,
     527,   528,   529,   530,   531,   532,   533,  1285,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,  1286,   550,     0,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,     0,   560,  1287,  1288,
       0,     0,   563,   564,  1289,   566,  1290,  1291,   568,   569,
     570,   571,   572,   573,   574,   575,     0,  1292,   576,   577,
     578,   579,   580,  1293,     0,   581,   582,   583,   584,   585,
     586,  1294,     0,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,  1295,  1296,  1297,  1298,   606,  1299,  1300,  1301,  1302,
     611,   612,   613,   614,  1303,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1304,  1305,     0,     0,     0,
     234,     0,  1235,   681,  1307,  1236,  1237,  1238,   741,  1239,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,  1240,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,   257,  1241,
     259,  1242,  1243,     0,   262,   263,   264,   265,   266,   267,
     268,  1244,  1245,   269,   270,  1246,  1247,   273,     0,   274,
     275,   276,   277,  1248,     0,  1249,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,  1250,
    1251,  1252,  1253,  1254,  1255,  1256,   301,   302,   303,   304,
     305,   306,  1257,  1258,   309,  1259,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   857,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
    1260,   338,   339,   340,   341,  1261,  1262,   343,     0,   344,
     345,   346,  1263,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,  1264,     0,  1265,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,   383,   384,   385,  1266,
    1267,     0,  1268,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,  1269,   401,   402,
     403,     0,   404,   405,   406,  1270,  1271,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,  1272,   424,  1273,   426,   427,   428,   429,
     430,   431,   432,   433,  1274,   435,  1275,   436,   437,   438,
     439,  1276,  1277,   441,  1278,   443,   444,   445,     0,   446,
     447,     0,     0,  1279,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,  1280,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,  1281,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,  1282,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,  1283,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,  1284,
     526,   527,   528,   529,   530,   531,   532,   533,  1285,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,  1286,   550,     0,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,     0,   560,  1287,
    1288,     0,     0,   563,   564,  1289,   566,  1290,  1291,   568,
     569,   570,   571,   572,   573,   574,   575,     0,  1292,   576,
     577,   578,   579,   580,  1293,     0,   581,   582,   583,   584,
     585,   586,  1294,     0,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,  4951,  1295,  1296,  1297,  1298,   606,  1299,  1300,  1301,
    1302,   611,   612,   613,   614,  1303,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1304,  1305,     0,     0,
       0,   234,     0,  1235,   681,  1307,  1236,  1237,  1238,   741,
    1239,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,  1240,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1241,   259,  1242,  1243,     0,   262,   263,   264,   265,   266,
     267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,     0,
     274,   275,   276,   277,  1248,     0,  1249,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,   303,
     304,   305,   306,  1257,  1258,   309,  1259,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   857,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1260,   338,   339,   340,   341,  1261,  1262,   343,     0,
     344,   345,   346,  1263,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,  1264,     0,
    1265,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1266,  1267,     0,  1268,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,  1269,   401,
     402,   403,     0,   404,   405,   406,  1270,  1271,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1272,   424,  1273,   426,   427,   428,
     429,   430,   431,  4963,   433,  1274,   435,  1275,   436,   437,
     438,   439,  1276,  1277,   441,  1278,   443,   444,   445,     0,
     446,   447,     0,     0,  1279,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1280,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1281,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1282,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,  1283,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
    1284,   526,   527,   528,   529,   530,   531,   532,   533,  1285,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1286,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1287,  1288,     0,     0,   563,   564,  1289,   566,  1290,  1291,
     568,   569,   570,   571,   572,   573,   574,   575,     0,  1292,
     576,   577,   578,   579,   580,  1293,     0,   581,   582,   583,
     584,   585,   586,  1294,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,  1295,  1296,  1297,  1298,   606,  1299,  1300,
    1301,  1302,   611,   612,   613,   614,  1303,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1304,  1305,     0,
       0,     0,   234,     0,  1235,   681,  1307,  1236,  1237,  1238,
     741,  1239,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,  1240,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,  1241,   259,  1242,  1243,     0,   262,   263,   264,   265,
     266,   267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,
       0,   274,   275,   276,   277,  1248,     0,  1249,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,  5273,
     299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,
     303,   304,   305,   306,  1257,  1258,   309,  1259,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   857,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,  1260,   338,   339,   340,   341,  1261,  1262,   343,
       0,   344,   345,   346,  1263,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,  1264,
       0,  5274,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,  1266,  1267,     0,  1268,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,  1269,
     401,   402,   403,     0,   404,   405,   406,  1270,  1271,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1272,   424,  1273,   426,   427,
     428,   429,   430,   431,   432,   433,  1274,   435,  1275,   436,
     437,   438,   439,  1276,  1277,   441,  1278,   443,   444,   445,
       0,   446,   447,     0,     0,  1279,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1280,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1281,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1282,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,  5275,   509,   510,  1283,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1284,   526,   527,   528,   529,   530,   531,   532,   533,
    1285,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1286,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,  1287,  1288,     0,     0,   563,   564,  1289,   566,  1290,
    1291,   568,   569,   570,   571,   572,   573,   574,   575,     0,
    1292,   576,   577,   578,   579,   580,  1293,     0,   581,   582,
     583,   584,   585,   586,  1294,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,  1299,
    1300,  1301,  1302,   611,   612,   613,   614,  1303,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1304,  1305,
       0,     0,     0,   234,     0,  1235,   681,  5276,  1236,  1237,
    1238,   741,  1239,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,  1240,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,  5756,  1241,   259,  1242,  1243,     0,   262,   263,   264,
     265,   266,   267,   268,  1244,  1245,   269,   270,  1246,  1247,
     273,     0,   274,   275,   276,   277,  1248,     0,  1249,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,  5757,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,
     302,   303,   304,   305,   306,  1257,  1258,   309,  1259,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   857,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,  1260,   338,   339,   340,   341,  1261,  1262,
     343,     0,   344,   345,   346,  1263,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
    1264,     0,  1265,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,  1266,  1267,     0,  1268,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
    1269,   401,   402,   403,     0,   404,   405,   406,  1270,  1271,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1272,   424,  1273,   426,
     427,   428,   429,   430,   431,   432,   433,  1274,   435,  1275,
     436,   437,   438,   439,  1276,  1277,   441,  1278,   443,   444,
     445,     0,   446,   447,     0,     0,  1279,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,  1280,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,  1281,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1282,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,  1283,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,  1284,   526,   527,   528,   529,   530,   531,   532,
     533,  1285,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,  1286,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,  1287,  1288,     0,     0,   563,   564,  1289,   566,
    1290,  1291,   568,   569,   570,   571,   572,  5758,   574,   575,
       0,  1292,   576,   577,   578,   579,   580,  1293,     0,   581,
     582,   583,   584,   585,   586,  1294,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,
    1299,  1300,  1301,  1302,   611,   612,   613,   614,  1303,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1304,
    1305,     0,     0,     0,   234,     0,  1235,   681,  1307,  1236,
    1237,  1238,   741,  1239,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,  1240,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,  1241,   259,  1242,  1243,     0,   262,   263,
     264,   265,   266,   267,   268,  1244,  1245,   269,   270,  1246,
    1247,   273,     0,   274,   275,   276,   277,  1248,     0,  1249,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,  5757,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
     301,   302,   303,   304,   305,   306,  1257,  1258,   309,  1259,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   857,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,  1260,   338,   339,   340,   341,  1261,
    1262,   343,     0,   344,   345,   346,  1263,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,  1264,     0,  1265,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,  1266,  1267,     0,  1268,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,  1269,   401,   402,   403,     0,   404,   405,   406,  1270,
    1271,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,  1272,   424,  1273,
     426,   427,   428,   429,   430,   431,   432,   433,  1274,   435,
    1275,   436,   437,   438,   439,  1276,  1277,   441,  1278,   443,
     444,   445,     0,   446,   447,     0,     0,  1279,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,  1280,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,  1281,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1282,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,  1283,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,  1284,   526,   527,   528,   529,   530,   531,
     532,   533,  1285,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,  1286,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,  1287,  1288,     0,     0,   563,   564,  1289,
     566,  1290,  1291,   568,   569,   570,   571,   572,  5758,   574,
     575,     0,  1292,   576,   577,   578,   579,   580,  1293,     0,
     581,   582,   583,   584,   585,   586,  1294,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,  1295,  1296,  1297,  1298,
     606,  1299,  1300,  1301,  1302,   611,   612,   613,   614,  1303,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1304,  1305,     0,     0,     0,   234,     0,  1235,   681,  1307,
    1236,  1237,  1238,   741,  1239,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,  1240,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1241,   259,  1242,  1243,     0,   262,
     263,   264,   265,   266,   267,   268,  1244,  1245,   269,   270,
    1246,  1247,   273,     0,   274,   275,   276,   277,  1248,     0,
    1249,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,   301,   302,   303,   304,   305,   306,  1257,  1258,   309,
    5258,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   857,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,  1260,   338,   339,   340,   341,
    1261,  1262,   343,     0,   344,   345,   346,  1263,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,  1264,     0,  1265,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,  1266,  1267,     0,  1268,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,  1269,   401,   402,   403,     0,   404,   405,   406,
    1270,  1271,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1272,   424,
    1273,   426,   427,   428,   429,   430,   431,   432,   433,  1274,
     435,     0,   436,   437,   438,   439,  1276,  1277,   441,  1278,
     443,   444,   445,     0,   446,   447,     0,     0,  1279,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,  1280,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,  1281,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1282,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,  3167,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,  1284,   526,   527,   528,   529,   530,
     531,   532,   533,  1285,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1286,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,  1287,  1288,     0,     0,   563,   564,
    1289,   566,  1290,  1291,   568,   569,   570,   571,   572,   573,
     574,   575,     0,     0,   576,   577,   578,   579,   580,  1293,
       0,   581,   582,   583,   584,   585,   586,  1294,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,  1295,  1296,  1297,
    1298,   606,  1299,  1300,  1301,  1302,   611,   612,   613,   614,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3168,  3169,     0,     0,     0,   234,     0,  1235,   681,
    3170,  1236,  1237,  1238,   741,  1239,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,  1240,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,   256, -2776,  1241,   259,  1242,  1243,     0,
     262,   263,   264,   265,   266,   267,   268,  1244,  1245,   269,
     270,  1246,  1247,   273,     0,   274,   275,   276,   277,  1248,
       0,  1249,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,  5757,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,   301,   302,   303,   304,   305,   306,  1257,  1258,
     309,  1259,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     857,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,  1260,   338,   339,   340,
     341,  1261,  1262,   343,     0,   344,   345,   346,  1263,   348,
       0,   349,     0,   350,   351,     0,   352,   353,   354,   355,
     356,     0,   357,  1264,     0,  1265,   360,   361,     0,   362,
     363,   364,   365,   366, -2776,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,   383,   384,   385,  1266,  1267,     0,  1268,     0,
     389,     0,     0,   392,   393,   394,   395,   396,   397,   398,
       0,     0,   399,  1269,   401,   402, -2776,     0,   404,   405,
     406,  1270,  1271,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,  1272,
     424,  1273,   426,   427,   428,   429,   430,   431,   432,   433,
    1274,   435,  1275,   436,   437,     0,   439,  1276,  1277,   441,
    1278,   443,   444,   445,     0,   446,   447,     0,     0,  1279,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
    1280,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,  1281,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,  1282,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,  1283,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,  1284,   526,   527,   528,   529,
     530, -2776,   532,   533,  1285,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
    1286,   550,     0,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,     0,   560,  1287,  1288,     0,     0,   563,
     564,  1289,   566,  1290,  1291,   568,   569,   570,   571,   572,
    5758,   574,   575,     0,  1292,   576,   577,   578,   579,   580,
    1293,     0,   581,   582,   583,   584,   585,   586,  1294,     0,
     588,   589,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,  1295,  1296,
    1297,  1298,   606,  1299,  1300,  1301,  1302,   611,   612,   613,
     614, -2776,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1304,  1305,     0,     0,     0,   234,     0,  1235,
     681,  1307,  1236,  1237,  1238,   741,  1239,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
    1240,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,  1241,   259,  1242,  1243,
       0,   262,   263,   264,   265,   266,   267,   268,  1244,  1245,
     269,   270,  1246,  1247,   273,     0,   274,   275,   276,   277,
    1248,     0,  1249,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,   301,   302,   303,   304,   305,   306,  1257,
    1258,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   857,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,  1260,   338,   339,
     340,   341,  1261,  1262,   343,     0,   344,   345,   346,  1263,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,  1264,     0,  1265,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,  1266,  1267,     0,  1268,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,  1269,   401,   402,   403,     0,   404,
     405,   406,  1270,  1271,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1272,   424,  1273,   426,   427,   428,   429,   430,   431,   432,
     433,  1274,   435,     0,   436,   437,   438,   439,  1276,  1277,
     441,  1278,   443,   444,   445,     0,   446,   447,     0,     0,
    1279,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,  1280,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,  1281,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1282,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
    3167,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,  1284,   526,   527,   528,
     529,   530,   531,   532,   533,  1285,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,  1286,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,  1287,  1288,     0,     0,
     563,   564,  1289,   566,  1290,  1291,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,  1293,     0,   581,   582,   583,   584,   585,   586,  1294,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,  1295,
    1296,  1297,  1298,   606,  1299,  1300,  1301,  1302,   611,   612,
     613,   614,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3168,  3169,   234,     0,  1235,   681,     0,
    1236,  1237,  3170,   741,  1239,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,  1240,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1241,   259,  1242,  1243,     0,   262,
     263,   264,   265,   266,   267,   268,  1244,  1245,   269,   270,
    1246,  1247,   273,     0,   274,   275,   276,   277,  1248,     0,
    1249,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,   301,   302,   303,   304,   305,   306,  1257,  1258,   309,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   857,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,  1260,   338,   339,   340,   341,
    1261,  1262,   343,     0,   344,   345,   346,  1263,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,  1264,     0,  1265,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,  1266,  1267,     0,  1268,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,  1269,   401,   402,   403,     0,   404,   405,   406,
    1270,  1271,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1272,   424,
    1273,   426,   427,   428,   429,   430,   431,   432,   433,  1274,
     435,     0,   436,   437,   438,   439,  1276,  1277,   441,  1278,
     443,   444,   445,     0,   446,   447,     0,     0,   448,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,  1280,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,  1281,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1282,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,  3335,  3336,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,  1284,   526,   527,   528,   529,   530,
     531,   532,   533,  1285,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1286,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,  1287,  1288,     0,     0,   563,   564,
    1289,   566,  1290,  1291,   568,   569,   570,   571,   572,   573,
     574,   575,     0,     0,   576,   577,   578,   579,   580,  1293,
       0,   581,   582,   583,   584,   585,   586,  1294,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,  1295,  1296,  1297,
    1298,   606,  1299,  1300,  1301,  1302,   611,   612,   613,   614,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3337,  3338,   234,     0,  1235,   681,     0,  1236,  1237,
    3170,   741,  1239,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,  1240,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1241,   259,  1242,  1243,     0,   262,   263,   264,
     265,   266,   267,   268,  1244,  1245,   269,   270,  1246,  1247,
     273,     0,   274,   275,   276,   277,  1248,     0,  1249,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,
     302,   303,   304,   305,   306,  1257,  1258,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   857,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,  1260,   338,   339,   340,   341,  1261,  1262,
     343,     0,   344,   345,   346,  1263,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
    1264,     0,  1265,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,  1266,  1267,     0,  1268,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
    1269,   401,   402,   403,     0,   404,   405,   406,  1270,  1271,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1272,   424,  1273,   426,
     427,   428,   429,   430,   431,   432,   433,  1274,   435,     0,
     436,   437,   438,   439,  1276,  1277,   441,  1278,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,  1280,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,  1281,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1282,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,  3167,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,  1284,   526,   527,   528,   529,   530,   531,   532,
     533,  1285,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,  1286,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,  1287,  1288,     0,     0,   563,   564,  1289,   566,
    1290,  1291,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,  1293,     0,   581,
     582,   583,   584,   585,   586,  1294,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,
    1299,  1300,  1301,  1302,   611,   612,   613,   614,     0,     0,
       0,     0,   234,     0,  1235,   681,     0,  1236,  1237,     0,
     741,  1239,     0,     0,     0,     0,     0,     0,  3170,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,  1240,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,  1241,   259,  1242,  1243,     0,   262,  4508,   264,   265,
     266,   267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,
       0,   274,   275,   276,   277,  1248,     0,  1249,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,
     303,   304,   305,   306,  1257,  1258,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   857,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,  1260,   338,   339,   340,   341,  1261,  1262,   343,
       0,   344,   345,   346,  1263,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,  1264,
       0,  1265,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,  1266,  1267,     0,  1268,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,  1269,
     401,   402,   403,     0,   404,   405,   406,  1270,  1271,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1272,   424,  1273,   426,   427,
     428,   429,   430,   431,   432,   433,  1274,   435,     0,   436,
     437,   438,   439,  1276,  1277,   441,  1278,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1280,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1281,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1282,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,  3167,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1284,   526,   527,   528,   529,   530,   531,   532,   533,
    1285,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1286,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,  1287,  1288,     0,     0,   563,   564,  1289,   566,  1290,
    1291,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,  1293,     0,   581,   582,
     583,   584,   585,   586,  1294,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,  1299,
    1300,  1301,  1302,   611,   612,   613,   614,     0,     0,     0,
       0,   234,     0,  1235,   681,     0,  1236,  1237,     0,   741,
    1239,     0,     0,     0,     0,     0,     0,  3170,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,  1240,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1241,   259,  1242,  1243,     0,   262,   263,   264,   265,   266,
     267,   268,  1244,  1245,   269,   270,  1246,  1247,   273,     0,
     274,   275,   276,   277,  1248,     0,  1249,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,   302,   303,
     304,   305,   306,  1257,  1258,   309,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   857,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1260,   338,   339,   340,   341,  1261,  1262,   343,     0,
     344,   345,   346,  1263,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,  1264,     0,
    1265,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1266,  1267,     0,  1268,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,  1269,   401,
     402,   403,     0,   404,   405,   406,  1270,  1271,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1272,   424,  1273,   426,   427,   428,
     429,   430,   431,   432,   433,  1274,   435,     0,   436,   437,
     438,   439,  1276,  1277,   441,  1278,   443,   444,   445,     0,
     446,   447,     0,     0,   448,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1280,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1281,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1282,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,  3167,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
    1284,   526,   527,   528,   529,   530,   531,   532,   533,  1285,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1286,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1287,  1288,     0,     0,   563,   564,  1289,   566,  1290,  1291,
     568,   569,   570,   571,   572,   573,   574,   575,     0,     0,
     576,   577,   578,   579,   580,  1293,     0,   581,   582,   583,
     584,   585,   586,  1294,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,  1295,  1296,  1297,  1298,  4566,  1299,  1300,
    1301,  1302,   611,   612,   613,   614,     0,     0,     0,     0,
     234,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3170,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,     0,   262,   263,   264,   265,   266,   267,
     268,     0,  1245,   269,   270,   271,   272,   273,     0,   274,
     275,   276,   277,  1248,     0,  1249,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,  1250,
    1251,  1252,  1253,  1254,  1255,  1256,   301,   302,   303,   304,
     305,   306,   307,   308,   309,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   324,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
     337,   338,   339,   340,   341,  1261,     0,   343,     0,   344,
     345,   346,   347,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,  1264,     0,   359,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,   383,   384,   385,   386,
     387,     0,   388,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,  3310,     0,   399,  1269,   401,   402,
     403,     0,   404,   405,   406,  1270,  1271,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,  1274,   435,     0,   436,   437,   438,
     439,     0,  1277,   441,   442,   443,   444,   445,     0,   446,
     447,     0,   833,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,  1280,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,  1281,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,  3311,   513,   514,   515,   516,   517,
     518,   519,   520,    41,   521,   522,   523,   524,   525,  1284,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,  1286,   550,     0,   551,   552,    45,
     553,   554,   555,   556,   557,   558,   559,     0,   560,   561,
     562,     0,     0,   563,   564,  1289,   566,  1290,     0,   568,
     569,   570,   571,   572,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,  1293,     0,   581,   582,   583,   584,
     585,  1170,   587,     0,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,    50,   595,   596,   597,   598,   599,
     600,   601,  1295,  1296,  1297,  1298,   606,  1299,  1300,  1301,
    1302,  3312,   612,   613,   614,     0,     0,    51,     0,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3313,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,   263,   264,   265,   266,   267,   268,
       0,  1245,   269,   270,   271,   272,   273,     0,   274,   275,
     276,   277,  1248,     0,  1249,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,   301,   302,   303,   304,   305,
     306,   307,   308,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   324,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,   337,
     338,   339,   340,   341,  1261,     0,   343,     0,   344,   345,
     346,   347,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,  1264,     0,   359,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,  3310,     0,   399,  1269,   401,   402,   403,
       0,   404,   405,   406,  1270,  1271,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,  1274,   435,     0,   436,   437,   438,   439,
       0,  1277,   441,   442,   443,   444,   445,     0,   446,   447,
       0,   833,   448,   449,   450,     0,     0,   451,   452,   453,
     454,   455,   456,  1280,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,  1281,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,  3311,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,  1284,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,  1286,   550,     0,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,   562,
       0,     0,   563,   564,  1289,   566,  1290,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,  1293,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,  1295,  1296,  1297,  1298,   606,  1299,  1300,  1301,  1302,
    3312,   612,   613,   614,     0,     0,     0,     0,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3313,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
    1245,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,  1248,     0,  1249,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,  1261,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,  1264,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,  1269,   401,   402,   403,     0,
     404,   405,   406,  1270,  1271,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,  1274,   435,     0,   436,   437,   438,   439,     0,
    1277,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,  1280,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,  1281,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,  1284,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,  1286,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,  1289,   566,  1290,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,  1293,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
    1295,  1296,  1297,  1298,   606,  1299,  1300,  1301,  1302,   611,
     612,   613,   614,     0,     0,     0,     0,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3743,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,  1245,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
    1248,     0,  1249,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,  1261,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,  1264,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,  1269,   401,   402,   403,     0,   404,
     405,   406,  1270,  1271,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,  1274,   435,     0,   436,   437,   438,   439,     0,  1277,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,  1280,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,  1281,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,  3311,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,  1284,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,  1286,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,  1289,   566,  1290,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,  1293,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,  1295,
    1296,  1297,  1298,   606,  1299,  1300,  1301,  1302,  3312,   612,
     613,   614,     0,     0,     0,     0,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     262,   263,   264,   265,   266,   267,   268,     0,  1245,   269,
     270,   271,   272,   273,     0,   274,   275,   276,   277,  1248,
       0,  1249,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,   301,   302,   303,   304,   305,   306,   307,   308,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     324,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,   337,   338,   339,   340,
     341,  1261,     0,   343,     0,   344,   345,   346,   347,   348,
       0,   349,     0,   350,   351,     0,   352,   353,   354,   355,
     356,     0,   357,  1264,     0,   359,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,     0,   399,  1269,   401,   402,   403,     0,   404,   405,
     406,  1270,  1271,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
    1274,   435,     0,   436,   437,   438,   439,     0,  1277,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
    1280,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,  1281,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,  1284,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
    1286,   550,     0,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,     0,   560,   561,   562,     0,     0,   563,
     564,  1289,   566,  1290,     0,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
    1293,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,  1295,  1296,
    1297,  1298,   606,  1299,  1300,  1301,  1302,   611,   612,   613,
     614,     0,     0,     0,     0,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4626,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
     263,   264,   265,   266,   267,   268,     0,  1245,   269,   270,
     271,   272,   273,     0,   274,   275,   276,   277,  1248,     0,
    1249,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,   301,   302,   303,   304,   305,   306,   307,   308,   309,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   324,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,   337,   338,   339,   340,   341,
    1261,     0,   343,     0,   344,   345,   346,   347,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,  1264,     0,   359,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,   388,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,  1269,   401,   402,   403,     0,   404,   405,   406,
    1270,  1271,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,  1274,
     435,     0,   436,   437,   438,   439,     0,  1277,   441,   442,
     443,   444,   445,     0,   446,   447,     0,     0,   448,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,  1280,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,  1281,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,  1284,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1286,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,   561,   562,     0,     0,   563,   564,
    1289,   566,  1290,     0,   568,   569,   570,   571,   572,   573,
     574,   575,     0,     0,   576,   577,   578,   579,   580,  1293,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,  1295,  1296,  1297,
    1298,   606,  1299,  1300,  1301,  1302,   611,   612,   613,   614,
       0,     0,     0,     0,   934,     0,  1552,   681,     0,     0,
       0,     0,   741,     0,     0,     0,     0,     0,     0,     0,
    5730,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,   263,
     264,   265,   266,   267,   268,     0,     0,   269,   270,   271,
     272,   273,     0,   274,   275,   276,   277,   278,     0,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,     0,   300,     0,     0,     0,
     301,   302,   303,   304,   305,   306,   307,   308,   309,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   324,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
    1773,   343,     0,   344,   345,   346,   347,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,   358,     0,   359,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,   400,   401,   402,   403,     0,   404,   405,   406,     0,
       0,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,  1774,     0,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,   469,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,     0,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,   561,   562,     0,     0,   563,   564,   565,
     566,   567,  1775,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,     0,
       0,     0,     0,   934,     0,     0,     0,     0,     0,     0,
    1553,  1554,  5543,     0,     0,     0,     0,     0,     0,  5544,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     3,     4,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,    41,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,    45,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,  1170,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,    50,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,     0,     0,
      51,     0,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    57,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,     0,     0,     0,
       0,   622,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5323,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,     0,   254,   255,   256,   257,
     258,     0,   260,   261,     0,   262,   263,   264,   265,   266,
     267,   268,     0,     0,   269,   270,   271,   272,   273,     0,
     274,   275,   276,   277,   278,     0,     0,     0,   280,   281,
     282,   283,   284,   285,     0,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,     0,   297,   298,   299,
       0,     0,     0,     0,     0,     0,     0,   301,   302,   303,
     304,   305,   306,   307,   308,   309,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   324,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,     0,   343,     0,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,     0,   353,   354,   355,   356,     0,   357,   358,     0,
     359,   360,   361,     0,   362,   363,   364,   365,   366,     0,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   381,   382,   383,   384,   385,
     386,   387,     0,   388,     0,   389,     0,     0,   392,     0,
     394,   395,   396,   397,   398,     0,     0,   399,   400,     0,
     402,     0,     0,   404,   405,   406,     0,     0,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
       0,   439,     0,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,     0,   448,   449,   450,     0,     0,   451,
     452,   453,     0,   455,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,     0,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,    41,   521,   522,   523,   524,   525,
       0,   526,   527,   528,   529,   530,     0,   532,   533,   534,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
      45,   553,     0,   555,   556,   557,   558,   559,     0,   560,
     561,   562,     0,     0,   563,   564,   565,   566,   567,     0,
     568,   569,   570,   571,   572,   573,   574,   575,     0,     0,
     576,   577,   578,   579,   580,     0,     0,   581,   582,   583,
     584,   585,  1170,   587,     0,   588,     0,   590,   591,   592,
     593,     0,     0,   594,     0,    50,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,     0,     0,    51,     0,
     622,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    57,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,     0,   254,   255,   256,   257,   258,
       0,   260,   261,     0,   262,   263,   264,   265,   266,   267,
     268,     0,     0,   269,   270,   271,   272,   273,     0,   274,
     275,   276,   277,   278,     0,     0,     0,   280,   281,   282,
     283,   284,   285,     0,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,     0,   297,   298,   299,     0,
       0,     0,     0,     0,     0,     0,   301,   302,   303,   304,
     305,   306,   307,   308,   309,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   324,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,     0,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
     360,   361,     0,   362,   363,   364,   365,   366,     0,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,     0,   381,   382,   383,   384,   385,   386,
     387,     0,   388,     0,   389,     0,     0,   392,     0,   394,
     395,   396,   397,   398,     0,     0,   399,   400,     0,   402,
       0,     0,   404,   405,   406,     0,     0,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,     0,     0,   451,   452,
     453,     0,   455,     0,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,     0,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,     0,
     526,   527,   528,   529,   530,     0,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,     0,
     553,     0,   555,   556,   557,   558,   559,     0,   560,   561,
     562,     0,     0,   563,   564,   565,   566,   567,     0,   568,
     569,   570,   571,   572,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,     0,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,     0,     0,     0,     0,   622,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1365,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,     0,   254,   255,   256,   257,   258,     0,
     260,   261,     0,   262,   263,   264,   265,   266,   267,   268,
       0,     0,   269,   270,   271,   272,   273,     0,   274,   275,
     276,   277,   278,     0,     0,     0,   280,   281,   282,   283,
     284,   285,     0,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,     0,   297,   298,   299,     0,     0,
       0,     0,     0,     0,     0,   301,   302,   303,   304,   305,
     306,   307,   308,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   324,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,     0,   343,     0,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,     0,
     353,   354,   355,   356,     0,   357,   358,     0,   359,   360,
     361,     0,   362,   363,   364,   365,   366,     0,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   389,     0,     0,   392,     0,   394,   395,
     396,   397,   398,     0,     0,   399,   400,     0,   402,     0,
       0,   404,   405,   406,     0,     0,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   436,   437,     0,   439,
       0,   440,   441,   442,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,     0,     0,   451,   452,   453,
       0,   455,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,     0,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,     0,   526,
     527,   528,   529,   530,     0,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,     0,   553,
       0,   555,   556,   557,   558,   559,     0,   560,   561,   562,
       0,     0,   563,   564,   565,   566,   567,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,     0,     0,     0,     0,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3368,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,     0,     0,     0,     0,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4543,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,     0,     0,     0,     0,     0,     0,     0,   849,
       0,  1552,   681,     0,     0,     0,   949,   741,     0,     0,
       0,     0,  4583,   950,   951,   952,   235,   236,   237,   238,
     239,   240,   241,   242,  1686,   243,   244,   245,  1687,  1688,
    1689,  1690,  1691,  1692,  1693,   246,   247,   248,  1694,   249,
     250,   251,   252,   253,   254,   255,   256,     0,   850,   259,
     851,   852,  1695,   262,   263,   264,   265,   266,   267,   268,
    1696,  1697,   269,   270,   853,   854,   273,  1698,   274,   275,
     276,   277,     0,  1699,   279,  1700,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,  1701,   290,   291,   292,
     293,   294,   295,  1702,   296,   297,   298,   299,  1703,  1704,
    1705,   300,  1706,  1707,  1708,   301,   302,   303,   304,   305,
     306,   855,   856,   309,  1709,   310,  1710,   311,   312,   313,
     314,   315,   316,   317,  1711,   318,   319,   320,   321,  1712,
    1713,   322,   323,   857,   325,   326,  1714,   327,   328,   329,
    1715,   330,   331,   332,  1716,   333,   334,   335,   336,     0,
     338,   339,   340,   341,     0,  1717,   343,  1718,   344,   345,
     346,   858,   348,  1719,   349,  1720,   350,   351,  1721,   352,
     353,   354,   355,   356,  1722,   357,     0,  1723,     0,   360,
     361,  1724,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,  1725,   372,   373,   374,   375,   376,   377,   378,
    1726,   379,   380,     0,   382,   383,   384,   385,   859,   860,
    1727,   861,  1728,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,  1729,  1730,   399,     0,   401,   402,   403,
    1731,   404,   405,   406,  1732,  1733,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   862,   424,   863,   426,   427,   428,   429,   430,
     431,   432,  4297,     0,   435,  1734,   436,   437,   438,   439,
    1735,     0,   441,   864,   443,   444,   445,  1736,   446,   447,
    1737,  1738,  4298,   449,   450,  1739,  1740,   451,   452,     0,
     454,   455,   456,     0,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,  1741,   467,   468,     0,   470,     0,
     472,   473,   474,  1742,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   865,   486,   487,   488,   489,  1743,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,  1744,   503,   504,   505,   506,   507,   508,
     509,   510,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,  1745,   521,   522,   523,   524,   525,  1746,   526,
     527,  2624,   529,   530,   531,   532,   533,   867,   535,  1747,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   550,  1748,   551,   552,  1749,   553,
     554,   555,   556,   557,   558,   559,  1750,   560,   868,   869,
    1751,  1752,   563,   564,     0,   566,     0,  1753,   568,   569,
     570,   571,   572,   573,   574,   575,  1754,  1755,   576,   577,
     578,   579,   580,  1756,  1757,   581,   582,   583,   584,   585,
       0,   870,  1758,   588,   589,   590,   591,   592,   593,  1759,
    1760,   594,  1761,  1762,   595,   596,   597,   598,   599,   600,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   612,   613,   614,     0,     0,     0,     0,     0,     0,
       0,     0,   955,   956,   957,  4299,  4300,   960,   961,   962,
     963,   849,     0,  1552,   681,     0,     0,     0,   949,   741,
       0,     0,     0,     0,     0,   950,   951,   952,   235,   236,
     237,   238,   239,   240,   241,   242,  1686,   243,   244,   245,
    1687,  1688,  1689,  1690,  1691,  1692,  1693,   246,   247,   248,
    1694,   249,   250,   251,   252,   253,   254,   255,   256,     0,
     850,   259,   851,   852,  1695,   262,   263,   264,   265,   266,
     267,   268,  1696,  1697,   269,   270,   853,   854,   273,  1698,
     274,   275,   276,   277,     0,  1699,   279,  1700,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,  1701,   290,
     291,   292,   293,   294,   295,  1702,   296,   297,   298,   299,
    1703,  1704,  1705,   300,  1706,  1707,  1708,   301,   302,   303,
     304,   305,   306,   855,   856,   309,  1709,   310,  1710,   311,
     312,   313,   314,   315,   316,   317,  1711,   318,   319,   320,
     321,  1712,  1713,   322,   323,   857,   325,   326,  1714,   327,
     328,   329,  1715,   330,   331,   332,  1716,   333,   334,   335,
     336,     0,   338,   339,   340,   341,     0,  1717,   343,  1718,
     344,   345,   346,   858,   348,  1719,   349,  1720,   350,   351,
    1721,   352,   353,   354,   355,   356,  1722,   357,     0,  1723,
       0,   360,   361,  1724,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,  1725,   372,   373,   374,   375,   376,
     377,   378,  1726,   379,   380,     0,   382,   383,   384,   385,
     859,   860,  1727,   861,  1728,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,  1729,  1730,   399,     0,   401,
     402,   403,  1731,   404,   405,   406,  1732,  1733,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   862,   424,   863,   426,   427,   428,
     429,   430,   431,   432,  4718,     0,   435,  1734,   436,   437,
     438,   439,  1735,     0,   441,   864,   443,   444,   445,  1736,
     446,   447,  1737,  1738,  4298,   449,   450,  1739,  1740,   451,
     452,     0,   454,   455,   456,     0,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,  1741,   467,   468,     0,
     470,     0,   472,   473,   474,  1742,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   865,   486,   487,   488,
     489,  1743,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,  1744,   503,   504,   505,   506,
     507,   508,   509,   510,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,  1745,   521,   522,   523,   524,   525,
    1746,   526,   527,  2624,   529,   530,   531,   532,   533,   867,
     535,  1747,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,     0,   550,  1748,   551,   552,
    1749,   553,   554,   555,   556,   557,   558,   559,  1750,   560,
     868,   869,  1751,  1752,   563,   564,     0,   566,     0,  1753,
     568,   569,   570,   571,   572,   573,   574,   575,  1754,  1755,
     576,   577,   578,   579,   580,  1756,  1757,   581,   582,   583,
     584,   585,     0,   870,  1758,   588,   589,   590,   591,   592,
     593,  1759,  1760,   594,  1761,  1762,   595,   596,   597,   598,
     599,   600,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   612,   613,   614,     0,     0,     0,     0,
       0,     0,     0,     0,   955,   956,   957,  4299,  4300,   960,
     961,   962,   963,  2039,     0,     0,     0,     0,     0,     0,
    2040,     0,     0,  2041,     0,     0,     0,  2042,  2043,  2044,
    2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,
    2055,  2056,  2057,  2058,  2059,  2060,     0,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,     0,     0,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,     0,  2119,  2120,
    2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,
    2131,  2132,  2133,     0,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,  2149,
    2150,  2151,  2152,  2153,  2154,  2155,  2156,  2157,  2158,  2159,
    2160,  2161,  2162,  2163,  2164,  2165,  2166,  2167,     0,  2168,
    2169,  2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,
    2179,     0,     0,  2180,  2181,  2182,  2183,     0,  2184,  2185,
    2186,  2187,     0,  2188,  2189,  2190,  2191,  2192,     0,  2193,
    2194,     0,  2195,  2196,  2197,     0,  2198,  2199,     0,  2200,
    2201,  2202,  2203,  2204,  2205,  2206,  2207,  2208,  2209,  2210,
    2211,  2212,  2213,  2214,  2215,  2216,  2217,  2218,  2219,  2220,
    2221,  2222,  2223,  2224,     0,  2225,     0,  2226,  2227,  2228,
    2229,  2230,  2231,  2232,  2233,  2234,  2235,  2236,  2237,  2238,
    2239,  2240,  2241,  2242,     0,  2243,  2244,  2245,  2246,  2247,
    2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,     0,
    2257,  2258,     0,  2259,  2260,  2261,  2262,  2263,  2264,  2265,
    2266,  2267,  2268,  2269,  2270,  2271,  2272,  2273,  2274,  2275,
    2276,  2277,  2278,  2279,  2280,  2281,  2282,  2283,  2284,  2285,
    2286,     0,  2287,  2288,     0,  2289,  2290,  2291,  2292,  2293,
       0,  2294,  2295,  2296,  2297,     0,     0,  2298,  2299,  2300,
    2301,  2302,  2303,  2304,  2305,  2306,  2307,     0,  2308,  2309,
    2310,  2311,  2312,     0,  2313,  2314,  2315,  2316,  2317,  2318,
    2319,  2320,  2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,
    2329,  2330,  2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,
    2339,  2340,  2341,  2342,  2343,  2344,  2345,     0,  2346,  2347,
    2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,  2356,  2357,
    2358,  2359,  2360,  2361,     0,  2362,  2363,  2364,  2365,  2366,
    2367,  2368,  2369,  2370,  2371,  2372,  2373,  2374,  2375,  2376,
    2377,  2378,  2379,  2380,  2381,  2382,  2383,  2384,  2385,  2386,
    2387,  2388,  2389,  2390,  2391,  2392,  2393,  2394,  2395,  2396,
    2397,  2398,  2399,  2400,  2401,  2402,  2403,  2404,  2405,  2406,
    2407,  2408,  2409,  2410,     0,  2411,  2412,  2413,  2414,  2415,
    2416,  2417,  2418,  2419,  2420,  2421,  2422,  2423,  2424,  2425,
       0,  2426,  2427,  2428,  2429,  2430,  2431,  2432,  2433,  2434,
    2435,  2436,  2437,  2438,  2439,  2440,  2441,     0,  2442,  2443,
    2444,  2445,  2446,  2447,     0,  2448,     0,     0,     0,     0,
    2449,  2450,  2451,  2452,  2453,  2454,  2455,  2456,  2457,  2458,
    2459,  2460,  2461,  2462,  2463,     0,  2464,  2465,  2466,     0,
       0,     0,     0,     0,     0,     0,  2467,  2468,  2469,  2470,
    2471,  2472,  2473,  2474,  2475,   622,     0,     0,     0,     0,
       0,     0,   949,     0,     0,     0,     0,     0,     0,   950,
     951,   952,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,     0,
     254,   255,   256,   257,   258,     0,   260,   261,     0,   262,
     263,   264,   265,   266,   267,   268,     0,     0,   269,   270,
     271,   272,   273,     0,   274,   953,   276,   277,   278,     0,
       0,     0,   280,   281,   282,   283,   284,   285,     0,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
       0,   297,   298,   299,     0,     0,     0,     0,     0,     0,
       0,   301,   302,   303,   304,   305,   306,   307,   308,   309,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   324,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,     0,   954,     0,   344,   345,   346,   347,   348,     0,
     349,     0,   350,     0,     0,     0,   353,   354,   355,   356,
       0,   357,   358,     0,   359,   360,   361,     0,   362,   363,
     364,   365,   366,     0,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   381,
     382,   383,   384,   385,   386,   387,     0,   388,     0,   389,
       0,     0,   392,     0,   394,   395,   396,   397,   398,     0,
       0,   399,   400,     0,   402,     0,     0,   404,   405,   406,
       0,     0,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   436,   437,     0,   439,     0,   440,   441,   442,
     443,   444,   445,     0,   446,   447,     0,     0,   448,   449,
     450,     0,     0,   451,   452,   453,     0,   455,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,     0,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,     0,   526,   527,   528,   529,   530,
       0,   532,   533,   534,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,     0,   553,     0,   555,   556,   557,
     558,   559,     0,   560,   561,   562,     0,     0,   563,   564,
     565,   566,   567,     0,   568,   569,   570,   571,   572,   573,
     574,   575,     0,     0,   576,   577,   578,   579,   580,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
       0,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
       0,     0,     0,     0,     0,     0,     0,     0,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   622,     0,     0,
       0,     0,     0,     0,   949,     0,     0,     0,     0,     0,
       0,   950,   951,   952,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,  1068,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,  1069,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,     0,     0,     0,     0,     0,     0,     0,     0,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   622,
       0,     0,     0,     0,     0,     0,   949,     0,     0,     0,
       0,     0,     0,   950,   951,   952,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,     0,   254,   255,   256,   257,   258,     0,
     260,   261,     0,   262,   263,   264,   265,   266,   267,   268,
       0,     0,   269,   270,   271,   272,   273,     0,   274,  1133,
     276,   277,   278,     0,     0,     0,   280,   281,   282,   283,
     284,   285,     0,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,     0,   297,   298,   299,     0,     0,
       0,     0,     0,     0,     0,   301,   302,   303,   304,   305,
     306,   307,   308,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   324,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,     0,  1134,     0,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,     0,
     353,   354,   355,   356,     0,   357,   358,     0,   359,   360,
     361,     0,   362,   363,   364,   365,  1135,     0,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   389,     0,     0,   392,     0,   394,   395,
     396,   397,   398,     0,     0,   399,   400,     0,   402,     0,
       0,   404,   405,   406,     0,     0,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   436,   437,     0,   439,
       0,   440,   441,   442,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,     0,     0,   451,   452,   453,
       0,   455,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,     0,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,     0,   526,
     527,   528,   529,   530,     0,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,     0,   553,
       0,   555,   556,   557,   558,   559,     0,   560,   561,   562,
       0,     0,   563,   564,   565,   566,   567,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,     0,     0,     0,     0,     0,     0,
       0,     0,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   622,     0,     0,     0,     0,     0,     0,   949,     0,
       0,     0,     0,     0,     0,   950,   951,   952,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,     0,   254,   255,   256,   257,
     258,     0,   260,   261,     0,   262,   263,   264,   265,   266,
     267,   268,     0,     0,   269,   270,   271,   272,   273,     0,
     274,  1790,   276,   277,   278,     0,     0,     0,   280,   281,
     282,   283,   284,   285,     0,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,     0,   297,   298,   299,
       0,     0,     0,     0,     0,     0,     0,   301,   302,   303,
     304,   305,   306,   307,   308,   309,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   324,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,     0,  1791,     0,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,     0,   353,   354,   355,   356,     0,   357,   358,     0,
     359,   360,   361,     0,   362,   363,   364,   365,   366,     0,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   381,   382,   383,   384,   385,
     386,   387,     0,   388,     0,   389,     0,     0,   392,     0,
     394,   395,   396,   397,   398,     0,     0,   399,   400,     0,
     402,     0,     0,   404,   405,   406,     0,     0,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
       0,   439,     0,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,     0,   448,   449,   450,     0,     0,   451,
     452,   453,     0,   455,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,     0,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
       0,   526,   527,   528,   529,   530,     0,   532,   533,   534,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
       0,   553,     0,   555,   556,   557,   558,   559,     0,   560,
     561,   562,     0,     0,   563,   564,   565,   566,   567,     0,
     568,   569,   570,   571,   572,   573,   574,   575,     0,     0,
     576,   577,   578,   579,   580,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,     0,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,     0,     0,     0,     0,
       0,     0,     0,     0,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   622,     0,     0,     0,     0,     0,     0,
     949,     0,     0,     0,     0,     0,     0,   950,   951,   952,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,     0,     0,
       0,     0,     0,     0,     0,     0,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   622,     0,     0,     0,     0,
       0,     0,   949,     0,     0,     0,     0,     0,     0,   950,
     951,   952,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,     0,
     254,   255,   256,   257,   258,     0,   260,   261,     0,   262,
     263,   264,   265,   266,   267,   268,     0,     0,   269,   270,
     271,   272,   273,     0,   274,  3438,   276,   277,   278,     0,
       0,     0,   280,   281,   282,   283,   284,   285,     0,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
       0,   297,   298,   299,     0,     0,     0,     0,     0,     0,
       0,   301,   302,   303,   304,   305,   306,   307,   308,   309,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   324,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,     0,  3439,     0,   344,   345,   346,   347,   348,     0,
     349,     0,   350,     0,     0,     0,   353,   354,   355,   356,
       0,   357,   358,     0,   359,   360,   361,     0,   362,   363,
     364,   365,   366,     0,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,     0,   381,
     382,   383,   384,   385,   386,   387,     0,   388,     0,   389,
       0,     0,   392,     0,   394,   395,   396,   397,   398,     0,
       0,   399,   400,     0,   402,     0,     0,   404,   405,   406,
       0,     0,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,     0,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   436,   437,     0,   439,     0,   440,   441,   442,
     443,   444,   445,     0,   446,   447,     0,     0,   448,   449,
     450,     0,     0,   451,   452,   453,     0,   455,     0,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,   469,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,     0,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,     0,   526,   527,   528,   529,   530,
       0,   532,   533,   534,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,     0,   553,     0,   555,   556,   557,
     558,   559,     0,   560,   561,   562,     0,     0,   563,   564,
     565,   566,   567,     0,   568,   569,   570,   571,   572,   573,
     574,   575,     0,     0,   576,   577,   578,   579,   580,     0,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
       0,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
       0,     0,     0,     0,     0,     0,     0,     0,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   622,     0,     0,
       0,     0,     0,     0,   949,     0,     0,     0,     0,     0,
       0,   950,   951,   952,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
    5302,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,  1685,     0,     0,     0,     0,     0,     0,     0,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   235,
     236,   237,   238,   239,   240,   241,   242,  1686,   243,   244,
     245,  1687,  1688,  1689,  1690,  1691,  1692,  1693,   246,   247,
     248,  1694,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,  1695,   262,   263,   264,   265,
     266,   267,   268,  1696,  1697,   269,   270,   271,   272,   273,
    1698,   274,   275,   276,   277,   278,  1699,   279,  1700,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,  1701,
     290,   291,   292,   293,   294,   295,  1702,   296,   297,   298,
     299,  1703,  1704,  1705,   300,  1706,  1707,  1708,   301,   302,
     303,   304,   305,   306,   307,   308,   309,  1709,   310,  1710,
     311,   312,   313,   314,   315,   316,   317,  1711,   318,   319,
     320,   321,  1712,  1713,   322,   323,   324,   325,   326,  1714,
     327,   328,   329,  1715,   330,   331,   332,  1716,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,  1717,   343,
    1718,   344,   345,   346,   347,   348,  1719,   349,  1720,   350,
     351,  1721,   352,   353,   354,   355,   356,  1722,   357,   358,
    1723,   359,   360,   361,  1724,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,  1725,   372,   373,   374,   375,
     376,   377,   378,  1726,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1727,   388,  1728,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,  1729,  1730,   399,   400,
     401,   402,   403,  1731,   404,   405,   406,  1732,  1733,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1734,   436,
     437,   438,   439,  1735,   440,   441,   442,   443,   444,   445,
    1736,   446,   447,  1737,  1738,   448,   449,   450,  1739,  1740,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,  1741,   467,   468,
     469,   470,   471,   472,   473,   474,  1742,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,  1743,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,  1744,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,  1745,   521,   522,   523,   524,
     525,  1746,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,  1747,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,  1748,   551,
     552,  1749,   553,   554,   555,   556,   557,   558,   559,  1750,
     560,   561,   562,  1751,  1752,   563,   564,   565,   566,   567,
    1753,   568,   569,   570,   571,   572,   573,   574,   575,  1754,
    1755,   576,   577,   578,   579,   580,  1756,  1757,   581,   582,
     583,   584,   585,   586,   587,  1758,   588,   589,   590,   591,
     592,   593,  1759,  1760,   594,  1761,  1762,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1763,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   838,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   849,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5700,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,     0,   850,   259,   851,   852,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   853,   854,   273,     0,   274,   275,   276,   277,
       0,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   855,
     856,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   857,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   338,   339,
     340,   341,     0,     0,   343,     0,   344,   345,   346,   858,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,     0,     0,     0,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
    2620,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,  2621,   382,   383,   384,   385,   859,   860,     0,   861,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,     0,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     862,   424,   863,   426,   427,   428,   429,   430,   431,   432,
       0,     0,   435,     0,   436,   437,   438,   439,     0,     0,
     441,   864,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,  2622,   451,   452,  2623,   454,   455,
     456,     0,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,     0,   470,     0,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   865,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,  2624,
     529,   530,   531,   532,   533,   867,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,     0,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   868,   869,     0,     0,
     563,   564,     0,   566,     0,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,     0,   870,
    2625,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,     0,     0,
    3780,     0,     0,     0,     0,     0,     0,     0,     0,   612,
     613,   614,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,  2626,   243,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,     0,   850,
     259,   851,   852,     0,   262,   263,   264,   265,   266,   267,
     268,     0,     0,   269,   270,   853,   854,   273,     0,   274,
     275,   276,   277,     0,     0,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,     0,   300,     0,     0,     0,   301,   302,   303,   304,
     305,   306,   855,   856,   309,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   857,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   338,   339,   340,   341,     0,     0,   343,     0,   344,
     345,   346,   858,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,     0,     0,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,  2620,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,  2621,   382,   383,   384,   385,   859,
     860,     0,   861,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,     0,   401,   402,
     403,     0,   404,   405,   406,     0,     0,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   862,   424,   863,   426,   427,   428,   429,
     430,   431,   432,     0,     0,   435,     0,   436,   437,   438,
     439,     0,     0,   441,   864,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,     0,  2622,   451,   452,
    2623,   454,   455,   456,     0,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,     0,   470,
       0,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   865,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,     0,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,     0,
     526,   527,  2624,   529,   530,   531,   532,   533,   867,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,     0,   550,     0,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,     0,   560,   868,
     869,     0,     0,   563,   564,     0,   566,     0,     0,   568,
     569,   570,   571,   572,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,     0,   581,   582,   583,   584,
     585,     0,   870,  2625,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,     0,     0,   934,     0,  1552,   681,     0,     0,     0,
       0,   741,   612,   613,   614,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,  2626,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,  2512,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,  1773,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,  1774,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,  1775,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   934,     0,
    1552,   681,     0,     0,     0,     0,   741,     0,     0,  1553,
    1554,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,  2517,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,  1773,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,  1774,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,  1775,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   934,     0,  1552,   681,     0,     0,     0,
       0,   741,     0,     0,  1553,  1554,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,  1773,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,  1774,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,  1775,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   934,     0,
       0,   681,     0,     0,     0,     0,   741,     0,     0,  1553,
    1554,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,  3399,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,  1773,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,  1774,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,  1775,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,   741,     0,     0,   753,   754,     0,     0,     0,     0,
     235,   742,   237,   238,   239,   240,   241,   242,   743,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   744,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   745,   347,   348,     0,   349,     0,
     746,     0,   747,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,   748,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   749,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     750,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   751,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   752,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,  1685,     0,
    5957,   681,     0,     0,     0,     0,   741,     0,     0,   753,
     754,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,  1686,   243,   244,   245,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,   246,   247,   248,  1694,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,  1695,   262,   263,   264,   265,   266,   267,   268,  1696,
    1697,   269,   270,   271,   272,   273,  1698,   274,   275,   276,
     277,   278,  1699,   279,  1700,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,  1701,   290,   291,   292,   293,
     294,   295,  1702,   296,   297,   298,   299,  1703,  1704,  1705,
     300,  1706,  1707,  1708,   301,   302,   303,   304,   305,   306,
     307,   308,   309,  1709,   310,  1710,   311,   312,   313,   314,
     315,   316,   317,  1711,   318,   319,   320,   321,  1712,  1713,
     322,   323,   324,   325,   326,  1714,   327,   328,   329,  1715,
     330,   331,   332,  1716,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,  1717,   343,  1718,   344,   345,   346,
     347,   348,  1719,   349,  1720,   350,   351,  1721,   352,   353,
     354,   355,   356,  1722,   357,   358,  1723,   359,   360,   361,
    1724,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,  1725,   372,   373,   374,   375,   376,   377,   378,  1726,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1727,
     388,  1728,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,  1729,  1730,   399,   400,   401,   402,   403,  1731,
     404,   405,   406,  1732,  1733,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1734,   436,   437,   438,   439,  1735,
     440,   441,   442,   443,   444,   445,  1736,   446,   447,  1737,
    1738,   448,   449,   450,  1739,  1740,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,  1741,   467,   468,   469,   470,   471,   472,
     473,   474,  1742,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,  1743,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,  1744,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,  1745,   521,   522,   523,   524,   525,  1746,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,  1747,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,  1748,   551,   552,  1749,   553,   554,
     555,   556,   557,   558,   559,  1750,   560,   561,   562,  1751,
    1752,   563,   564,   565,   566,   567,  1753,   568,   569,   570,
     571,   572,   573,   574,   575,  1754,  1755,   576,   577,   578,
     579,   580,  1756,  1757,   581,   582,   583,   584,   585,   586,
     587,  1758,   588,   589,   590,   591,   592,   593,  1759,  1760,
     594,  1761,  1762,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,  1685,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,  1686,   243,
     244,   245,  1687,  1688,  1689,  1690,  1691,  1692,  1693,   246,
     247,   248,  1694,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,  1695,   262,   263,   264,
     265,   266,   267,   268,  1696,  1697,   269,   270,   271,   272,
     273,  1698,   274,   275,   276,   277,   278,  1699,   279,  1700,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
    1701,   290,   291,   292,   293,   294,   295,  1702,   296,   297,
     298,   299,  1703,  1704,  1705,   300,  1706,  1707,  1708,   301,
     302,   303,   304,   305,   306,   307,   308,   309,  1709,   310,
    1710,   311,   312,   313,   314,   315,   316,   317,  1711,   318,
     319,   320,   321,  1712,  1713,   322,   323,   324,   325,   326,
    1714,   327,   328,   329,  1715,   330,   331,   332,  1716,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,  1717,
     343,  1718,   344,   345,   346,   347,   348,  1719,   349,  1720,
     350,   351,  1721,   352,   353,   354,   355,   356,  1722,   357,
     358,  1723,   359,   360,   361,  1724,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,  1725,   372,   373,   374,
     375,   376,   377,   378,  1726,   379,   380,   381,   382,   383,
     384,   385,   386,   387,  1727,   388,  1728,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,  1729,  1730,   399,
     400,   401,   402,   403,  1731,   404,   405,   406,  1732,  1733,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,  1734,
     436,   437,   438,   439,  1735,   440,   441,   442,   443,   444,
     445,  1736,   446,   447,  1737,  1738,   448,   449,   450,  1739,
    1740,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,  1741,   467,
     468,   469,   470,   471,   472,   473,   474,  1742,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,  1743,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,  1744,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,  1745,   521,   522,   523,
     524,   525,  1746,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,  1747,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,  1748,
     551,   552,  1749,   553,   554,   555,   556,   557,   558,   559,
    1750,   560,   561,   562,  1751,  1752,   563,   564,   565,   566,
     567,  1753,   568,   569,   570,   571,   572,   573,   574,   575,
    1754,  1755,   576,   577,   578,   579,   580,  1756,  1757,   581,
     582,   583,   584,   585,   586,   587,  1758,   588,   589,   590,
     591,   592,   593,  1759,  1760,   594,  1761,  1762,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,  1685,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,  3504,
     240,   241,   242,  1686,   243,   244,   245,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,   246,   247,   248,  1694,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,  1695,   262,   263,   264,   265,   266,   267,   268,  1696,
    1697,   269,   270,   271,   272,   273,  1698,   274,   275,   276,
     277,   278,  1699,   279,  1700,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,  1701,   290,   291,   292,   293,
     294,   295,  1702,   296,   297,   298,   299,  1703,  1704,  1705,
     300,  1706,  1707,  1708,   301,   302,   303,   304,   305,   306,
     307,   308,   309,  1709,   310,  1710,   311,   312,   313,   314,
     315,   316,   317,  1711,   318,   319,   320,   321,  1712,  1713,
     322,   323,   324,  3505,   326,  1714,   327,   328,   329,  1715,
     330,   331,   332,  1716,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,  1717,   343,  1718,   344,   345,   346,
     347,   348,  1719,   349,  1720,   350,   351,  1721,   352,   353,
     354,   355,   356,  1722,   357,   358,  1723,   359,   360,   361,
    1724,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,  1725,   372,   373,   374,   375,   376,   377,   378,  1726,
     379,   380,   381,   382,   383,   384,   385,   386,   387,  1727,
     388,  1728,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,  1729,  1730,   399,   400,   401,   402,   403,  1731,
     404,   405,   406,  1732,  1733,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,  1734,   436,   437,   438,   439,  1735,
     440,   441,   442,   443,   444,   445,  1736,   446,   447,  1737,
    1738,   448,   449,   450,  1739,  1740,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,  1741,   467,   468,   469,   470,   471,   472,
     473,   474,  1742,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,  1743,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,  1744,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,  1745,   521,   522,   523,   524,   525,  1746,  3506,   527,
     528,   529,   530,   531,   532,   533,   534,   535,  1747,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,  1748,   551,   552,  1749,   553,   554,
     555,   556,   557,   558,   559,  1750,   560,   561,   562,  1751,
    1752,   563,   564,   565,   566,   567,  1753,   568,   569,   570,
     571,   572,   573,   574,   575,  1754,  1755,   576,   577,   578,
     579,   580,  1756,  1757,   581,   582,   583,   584,   585,   586,
     587,  1758,   588,   589,   590,   591,   592,   593,  1759,  1760,
     594,  1761,  1762,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,  1245,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,  1248,     0,  1249,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,  1250,  1251,  1252,  1253,  1254,  1255,  1256,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,  1261,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
    1264,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
    1269,   401,   402,   403,     0,   404,   405,   406,  1270,  1271,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,  1274,   435,     0,
     436,   437,   438,   439,     0,  1277,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,  1280,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,  1281,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,  1284,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,  1286,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,  1289,   566,
    1290,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,  1293,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,  1295,  1296,  1297,  1298,   606,
    1299,  1300,  1301,  1302,   611,   612,   613,   614,   234,     0,
    1235,   681,     0,  1236,  1237,     0,   741,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,  1241,   259,  1242,
    1243,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,  1246,  1247,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
    1257,  1258,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   857,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,  1262,   343,     0,   344,   345,   346,
    1263,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,  1266,  1267,     0,
    1268,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,  1272,   424,  1273,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,  1276,
     440,   441,  1278,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,  1282,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,  1285,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,  1287,  1288,     0,
       0,   563,   564,   565,   566,   567,  1291,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
    1294,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   934,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   973,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   935,   300,     0,     0,   936,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,   937,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   934,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   994,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   935,
     300,     0,     0,   936,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   995,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,   937,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   934,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   935,   300,     0,     0,   936,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,   937,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,  2877,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   934,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   935,
     300,     0,     0,   936,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,  3849,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,   937,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   934,     0,     0,   681,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,  1773,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,  1774,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,  1775,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   934,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   935,
     300,     0,     0,   936,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,   937,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   934,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   935,   300,     0,     0,   936,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,  1086,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,   937,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   934,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   935,
     300,     0,     0,   936,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1128,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,   937,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   934,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,   935,   300,     0,     0,   936,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1141,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,   937,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   934,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,   935,
     300,     0,     0,   936,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1153,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,  1154,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,   937,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   934,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     3,     4,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   934,     0,
       0,   681,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,  2497,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   934,     0,     0,   681,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1112,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1125,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1139,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1143,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,   400,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   934,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,  2658,   274,   275,   276,
     277,   278,     0,     0,  2727,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,  2659,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,  2728,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,  2661,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  2729,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,  2662,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,  2663,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,  2658,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
    2659,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,  2728,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,  2661,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,  3713,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,  2662,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,  2663,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     801,   241,   242,   760,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,   761,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,   802,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   762,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   763,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   760,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,   761,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,  3406,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   762,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   763,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,  2658,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,  2659,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,  2728,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,  2661,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,  2662,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,  2663,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   760,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,   761,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   762,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   763,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,  1950,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,  1951,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,  1952,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,  1953,   350,     0,     0,     0,  1954,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,  1955,
    1956,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,  1957,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,  1958,
     510,   511,   512,   513,   514,  1959,   516,   517,   518,   519,
     520,     0,  1960,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,  1961,   553,     0,
    1962,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,  1963,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,   761,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   762,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   763,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   987,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   988,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
     833,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,  3485,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,  3486,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,  3498,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,  3499,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   623,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   672,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     673,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   793,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   794,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   795,   562,     0,     0,   796,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,   827,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   828,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   829,   562,     0,
       0,   830,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,   833,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,   890,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   944,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     945,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,  1104,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,   793,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,  1209,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,  1340,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,  1351,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   813,   270,   271,   272,  1352,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     816,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   817,   507,   508,   509,
     510,   511,   512,   513,   514,   818,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,  1344,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   820,   562,     0,
       0,   821,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   822,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1496,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,   833,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,  1557,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1558,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,  3259,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,  3260,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,  3261,   553,     0,   555,  3262,   557,  3263,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,  3264,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,   681,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,   741,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,  4028,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,  4042,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,  4662,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   779,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   791,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   813,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   814,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   815,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     816,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   817,   507,   508,   509,
     510,   511,   512,   513,   514,   818,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   819,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   820,   562,     0,
       0,   821,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   822,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   844,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   969,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     979,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   982,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     998,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1053,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1058,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1075,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1078,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1080,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1117,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1145,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1147,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1157,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1160,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1163,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   813,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   816,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   817,   507,   508,   509,   510,   511,   512,   513,   514,
     818,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,  1344,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   820,   562,     0,     0,   821,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   822,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1816,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1850,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1852,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1891,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1893,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    1895,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,  1987,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,  2612,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,     0,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   813,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     816,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   817,   507,   508,   509,
     510,   511,   512,   513,   514,   818,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,  1344,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
    2645,   556,   557,   558,   559,     0,   560,   820,   562,     0,
       0,   821,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   822,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   813,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   816,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   817,   507,   508,   509,   510,   511,   512,   513,   514,
    2710,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,  2711,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   820,   562,     0,     0,  2712,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   822,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   813,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     816,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   817,   507,   508,   509,
     510,   511,   512,   513,   514,  2789,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,  2711,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   820,   562,     0,
       0,  2712,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   822,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   813,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   816,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   817,   507,   508,   509,   510,   511,   512,   513,   514,
    2806,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,  2711,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   820,   562,     0,     0,  2712,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   822,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  2999,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    3003,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  3061,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    3417,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   813,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     816,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   817,   507,   508,   509,
     510,   511,   512,   513,   514,   818,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,  2711,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   820,   562,     0,
       0,  2712,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   822,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    3474,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  3488,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
    3490,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  3634,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,  3674,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  4840,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   849,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,     0,   850,   259,   851,   852,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   853,   854,
     273,     0,   274,   275,   276,   277,     0,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   855,   856,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   857,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   338,   339,   340,   341,     0,     0,
     343,     0,   344,   345,   346,   858,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
       0,     0,     0,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,  2620,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,  2621,   382,   383,
     384,   385,   859,   860,     0,   861,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
       0,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   862,   424,   863,   426,
     427,   428,   429,   430,   431,   432,     0,     0,   435,     0,
     436,   437,   438,   439,     0,     0,   441,   864,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,  2623,   454,   455,   456,     0,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,     0,   470,     0,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   865,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,  2624,   529,   530,   531,   532,
     533,   867,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,     0,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   868,   869,     0,     0,   563,   564,     0,   566,
       0,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,     0,   870,  2625,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   622,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   612,   613,   614,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,     0,   254,
     255,   256,   257,   258,     0,   260,   261,     0,   262,   263,
     264,   265,   266,   267,   268,     0,     0,   269,   270,   271,
     272,   273,     0,   274,   275,   276,   277,   278,     0,     0,
       0,   280,   281,   282,   283,   284,   285,     0,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,     0,
     297,   298,   299,     0,     0,     0,     0,     0,     0,     0,
     301,   302,   303,   304,   305,   306,   307,   308,   309,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   324,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,     0,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,     0,   361,     0,   362,   363,   364,
     365,   366,     0,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,     0,   381,   382,
     383,   384,   385,   386,   387,     0,   388,     0,   389,     0,
       0,   392,     0,   394,   395,   396,   397,   398,     0,     0,
     399,   400,     0,   402,     0,     0,   404,   405,   406,     0,
       0,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
       0,     0,   451,   452,   453,     0,   455,     0,   457,   458,
     459,   460,   461,   462,   463,     0,   465,   466,     0,     0,
     467,   468,   469,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,     0,   484,   485,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,     0,   506,   507,   508,   509,   510,   511,     0,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,     0,   526,   527,   528,   529,   530,     0,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,     0,   553,     0,   555,   556,   557,   558,
     559,     0,   560,   561,   562,     0,     0,   563,   564,   565,
     566,   567,     0,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   849,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,     0,   850,   259,
     851,   852,     0,   262,   263,   264,   265,   266,   267,   268,
       0,     0,   269,   270,   853,   854,   273,     0,   274,   275,
     276,   277,     0,     0,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
       0,   300,     0,     0,     0,   301,   302,   303,   304,   305,
     306,   855,   856,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   857,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     338,   339,   340,   341,     0,     0,   343,     0,   344,   345,
     346,   858,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,     0,     0,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,     0,   382,   383,   384,   385,   859,   860,
       0,   861,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,     0,     0,   399,     0,   401,   402,   403,
       0,   404,   405,   406,     0,     0,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   862,   424,   863,   426,   427,   428,   429,   430,
     431,   432,     0,     0,   435,     0,   436,   437,   438,   439,
    2706,     0,   441,   864,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,     0,     0,   451,   452,     0,
     454,   455,   456,     0,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,     0,   470,     0,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   865,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,     0,   526,
     527,  2624,   529,   530,   531,   532,   533,   867,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   550,     0,   551,   552,  4397,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   868,   869,
       0,     0,   563,   564,     0,   566,     0,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,     0,   581,   582,   583,   584,   585,
       0,   870,     0,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     849,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   612,   613,   614,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,     0,   850,
     259,   851,   852,     0,   262,   263,   264,   265,   266,   267,
     268,     0,     0,   269,   270,   853,   854,   273,     0,   274,
     275,   276,   277,     0,     0,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,     0,   300,     0,     0,     0,   301,   302,   303,   304,
     305,   306,   855,   856,   309,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   857,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   338,   339,   340,   341,     0,     0,   343,     0,   344,
     345,   346,   858,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,     0,     0,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,     0,   382,   383,   384,   385,   859,
     860,     0,   861,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,     0,   401,   402,
     403,     0,   404,   405,   406,     0,     0,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   862,   424,   863,   426,   427,   428,   429,
     430,   431,   432,  2779,     0,   435,     0,   436,   437,   438,
     439,     0,     0,   441,   864,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,     0,     0,   451,   452,
       0,   454,   455,   456,     0,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,     0,   470,
       0,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   865,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,     0,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,     0,
     526,   527,   866,   529,   530,   531,   532,   533,   867,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,     0,   550,     0,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,     0,   560,   868,
     869,     0,     0,   563,   564,     0,   566,     0,     0,   568,
     569,   570,   571,   572,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,     0,   581,   582,   583,   584,
     585,     0,   870,     0,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   849,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   612,   613,   614,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,     0,
     850,   259,   851,   852,     0,   262,   263,   264,   265,   266,
     267,   268,     0,     0,   269,   270,   853,   854,   273,     0,
     274,   275,   276,   277,     0,     0,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,     0,   300,     0,     0,     0,   301,   302,   303,
     304,   305,   306,   855,   856,   309,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   857,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   338,   339,   340,   341,     0,     0,   343,     0,
     344,   345,   346,   858,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,     0,     0,
       0,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,     0,   382,   383,   384,   385,
     859,   860,     0,   861,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,     0,   401,
     402,   403,     0,   404,   405,   406,     0,     0,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   862,   424,   863,   426,   427,   428,
     429,   430,   431,   432,  4201,     0,   435,     0,   436,   437,
     438,   439,     0,     0,   441,   864,   443,   444,   445,     0,
     446,   447,     0,     0,   448,   449,   450,     0,     0,   451,
     452,     0,   454,   455,   456,     0,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,     0,
     470,     0,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   865,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
       0,   526,   527,   866,   529,   530,   531,   532,   533,   867,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,     0,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
     868,   869,     0,     0,   563,   564,     0,   566,     0,     0,
     568,   569,   570,   571,   572,   573,   574,   575,     0,     0,
     576,   577,   578,   579,   580,     0,     0,   581,   582,   583,
     584,   585,     0,   870,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   849,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   612,   613,   614,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
       0,   850,   259,   851,   852,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   853,   854,   273,
       0,   274,   275,   276,   277,     0,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   855,   856,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   857,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   338,   339,   340,   341,     0,     0,   343,
       0,   344,   345,   346,   858,   348,  5648,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,     0,
       0,     0,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,     0,   382,   383,   384,
     385,   859,   860,     0,   861,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,     0,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   862,   424,   863,   426,   427,
     428,   429,   430,   431,   432,     0,     0,   435,     0,   436,
     437,   438,   439,     0,     0,   441,   864,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,     0,   454,   455,   456,     0,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
       0,   470,     0,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   865,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,     0,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   866,   529,   530,   531,   532,   533,
     867,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,     0,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   868,   869,     0,     0,   563,   564,     0,   566,     0,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,     0,   870,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   849,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   612,   613,   614,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,     0,   850,   259,   851,   852,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   853,   854,
     273,     0,   274,   275,   276,   277,     0,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   855,   856,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   857,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   338,   339,   340,   341,     0,     0,
     343,     0,   344,   345,   346,   858,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
       0,     0,     0,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,     0,   382,   383,
     384,   385,   859,   860,     0,   861,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
       0,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   862,   424,   863,   426,
     427,   428,   429,   430,   431,   432,     0,     0,   435,     0,
     436,   437,   438,   439,     0,     0,   441,   864,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,     0,   454,   455,   456,     0,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,     0,   470,     0,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   865,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   866,   529,   530,   531,   532,
     533,   867,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,     0,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   868,   869,     0,     0,   563,   564,     0,   566,
       0,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,     0,   870,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   849,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   612,   613,   614,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,     0,   850,   259,   851,   852,     0,   262,   263,
     264,   265,   266,   267,   268,     0,     0,   269,   270,   853,
     854,   273,     0,   274,   275,   276,   277,     0,     0,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,     0,   300,     0,     0,     0,
     301,   302,   303,   304,   305,   306,   855,   856,   309,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   857,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   338,   339,   340,   341,     0,
       0,   343,     0,   344,   345,   346,   858,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,     0,     0,     0,   360,   361,     0,   362,   363,   364,
     365,  1119,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,     0,   382,
     383,   384,   385,   859,   860,     0,   861,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,     0,   401,   402,   403,     0,   404,   405,   406,     0,
       0,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   862,   424,   863,
     426,   427,   428,   429,   430,   431,   432,     0,     0,   435,
       0,   436,   437,   438,   439,     0,     0,   441,   864,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
       0,     0,   451,   452,     0,   454,   455,   456,     0,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,     0,   470,     0,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   865,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,     0,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,     0,   526,   527,   866,   529,   530,   531,
     532,   533,   867,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,     0,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,   868,   869,     0,     0,   563,   564,     0,
     566,     0,     0,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,     0,
     581,   582,   583,   584,   585,     0,   870,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   849,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   612,   613,   614,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,     0,   850,   259,   851,   852,     0,   262,
     263,   264,   265,   266,   267,   268,     0,     0,   269,   270,
     853,   854,   273,     0,   274,   275,   276,   277,     0,     0,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,     0,   300,     0,     0,
       0,   301,   302,   303,   304,   305,   306,   855,   856,   309,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   857,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   338,   339,   340,   341,
       0,     0,   343,     0,   344,   345,   346,   858,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,     0,     0,     0,   360,   361,     0,   362,   363,
     364,   365,  1151,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,     0,
     382,   383,   384,   385,   859,   860,     0,   861,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,     0,   401,   402,   403,     0,   404,   405,   406,
       0,     0,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   862,   424,
     863,   426,   427,   428,   429,   430,   431,   432,     0,     0,
     435,     0,   436,   437,   438,   439,     0,     0,   441,   864,
     443,   444,   445,     0,   446,   447,     0,     0,   448,   449,
     450,     0,     0,   451,   452,     0,   454,   455,   456,     0,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,     0,   470,     0,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     865,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,     0,   526,   527,   866,   529,   530,
     531,   532,   533,   867,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,     0,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,   868,   869,     0,     0,   563,   564,
       0,   566,     0,     0,   568,   569,   570,   571,   572,   573,
     574,   575,     0,     0,   576,   577,   578,   579,   580,     0,
       0,   581,   582,   583,   584,   585,     0,   870,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   849,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   612,   613,   614,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,   256,     0,   850,   259,   851,   852,     0,
     262,   263,   264,   265,   266,   267,   268,     0,     0,   269,
     270,   853,   854,   273,     0,   274,   275,   276,   277,     0,
       0,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,     0,   300,     0,
       0,     0,   301,   302,   303,   304,   305,   306,   855,   856,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     857,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   338,   339,   340,
     341,     0,     0,   343,     0,   344,   345,   346,   858,   348,
       0,   349,     0,   350,   351,     0,   352,   353,   354,   355,
     356,     0,   357,     0,     0,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
       0,   382,   383,   384,   385,   859,   860,     0,   861,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,     0,   399,     0,   401,   402,   403,     0,   404,   405,
     406,     0,     0,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   862,
     424,   863,   426,   427,   428,   429,   430,   431,   432,     0,
       0,   435,     0,   436,   437,   438,   439,     0,     0,   441,
     864,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,     0,     0,   451,   452,     0,   454,   455,   456,
       0,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,     0,   470,     0,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   865,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,     0,   526,   527,  2624,   529,
     530,   531,   532,   533,   867,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
       0,   550,     0,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,     0,   560,   868,   869,     0,     0,   563,
     564,     0,   566,     0,     0,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,     0,   581,   582,   583,   584,   585,     0,   870,     0,
     588,   589,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   849,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   612,   613,
     614,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,     0,   850,   259,   851,   852,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   853,   854,   273,     0,   274,   275,   276,   277,
       0,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   855,
     856,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   857,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   338,   339,
     340,   341,     0,     0,   343,     0,   344,   345,   346,   858,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,     0,     0,     0,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,     0,   382,   383,   384,   385,   859,   860,     0,   861,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,     0,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     862,   424,   863,   426,   427,   428,   429,   430,   431,   432,
       0,     0,   435,     0,   436,   437,   438,   439,     0,     0,
     441,   864,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,     0,   454,   455,
     456,     0,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,     0,   470,     0,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   865,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,     0,
     529,   530,   531,   532,   533,   867,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,     0,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   868,   869,     0,     0,
     563,   564,     0,   566,     0,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,     0,   870,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   849,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   612,
     613,   614,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,     0,     0,   259,     0,
       0,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,     0,     0,   273,     0,   274,   275,   276,
     277,     0,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
       0,     0,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   338,
     339,   340,   341,     0,     0,   343,     0,   344,   345,   346,
       0,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,     0,     0,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,     0,   382,   383,   384,   385,     0,     0,     0,
       0,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,     0,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,     0,   424,     0,   426,   427,   428,   429,   430,   431,
     432,     0,     0,   435,     0,   436,   437,   438,   439,     0,
       0,   441,     0,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,     0,   454,
     455,   456,     0,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,     0,   470,     0,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,     0,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
       0,   529,   530,   531,   532,   533,     0,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,     0,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,     0,     0,     0,
       0,   563,   564,     0,   566,     0,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,     0,
       0,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     612,   613,   614
};

static const yytype_int16 yycheck[] =
{
       6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,     0,     0,     0,   650,     0,     0,   206,
    1016,     0,    37,    21,    21,     0,  1010,   214,   211,  1008,
     217,   980,   211,  1131,   761,   762,   763,   814,    22,   910,
     767,    46,   189,     8,    28,   811,    52,  1482,  1544,   904,
      15,   906,   947,   705,   866,  1192,  1609,  1454,  1528,   884,
     682,   997,   629,  1006,  1012,  2974,   197,   719,  2607,   981,
     855,   856,   837,  1521,  2608,  1239,   216,  1227,  1081,   864,
     790,  2946,   836,   821,   723,  3012,  1533,   869,  1846,   727,
     230,  3451,  3749,  1528,     6,  3095,   921,  2628,  2629,  3118,
    3268,  3359,  3270,  3776,  1975,    45,  1993,  4056,  1675,  3798,
    3504,  2865,  3506,    23,   946,   682,  2959,  3700,  3765,  1055,
    3478,  1016,  3313,  1059,  1521,   631,  3319,    37,  1064,  3368,
    2038,   191,  4102,  4567,  1412,   728,  2844,  1511,  1074,   971,
    4098,   718,   703,     2,   976,   706,  1642,  1643,   191,  4145,
     176,  1087,  4385,  4373,  4368,  4331,  1070,  4878,  4180,  1917,
    2487,  4583,   729,  4585,  2491,    51,  3333,  5149,    42,  4664,
    2592,  1085,  2911,  3378,  2913,  2914,  3225,  2594,   932,  2918,
    2919,  2920,  1118,  2922,  2923,  2924,   907,  3763,  2524,  1636,
    4821,   197,  5197,  4631,  4078,   817,  4372,  1571,   907,     0,
     206,   207,    36,  5420,  4870,  5064,  1494,   930,   214,    43,
     216,   217,    11,    37,  1588,     0,  1663,    53,   853,   854,
      21,   788,    77,     0,   230,     6,     5,    13,   863,  4509,
       0,     0,    11,  5185,  3318,  2571,  3320,    93,  4869,    62,
      62,    11,     0,  5404,     6,     6,  5105,    62,   971,    62,
     817,     0,     6,   976,    15,    16,    57,    46,    28,     6,
     118,     6,    11,    79,     6,     6,  1020,  2015,  5143,     6,
      15,    16,     6,     6,   841,     6,   120,     6,    46,    28,
       6,    15,    16,   980,     6,   225,    79,     6,     6,    28,
      13,   112,   989,   172,    42,    22,     6,    90,    11,    79,
    2565,   167,   999,     3,    42,     5,     6,    71,   173,    84,
      62,    11,   179,    15,   123,   152,   111,   111,   196,   145,
     184,    44,  1049,     6,  4458,  4459,  4460,   172,  4462,  4463,
    4464,  4465,  4466,     6,   901,     5,  1120,    13,  3453,   151,
     111,    11,  1126,   172,    24,   118,  5137,    24,  1474,     6,
       6,    13,  1136,   279,    77,   279,  1140,  5112,  5113,   151,
    1144,   172,  1146,  5306,  4386,    34,  4362,    62,  1152,    29,
    4865,     6,    62,   265,  1158,   140,   220,  1161,   304,   200,
     304,   279,    44,  5600,  1094,   149,   633,   172,    67,    75,
     191,   284,    63,    90,   324,   172,   118,   285,  5756,    62,
      71,   210,   172,   172,   265,   169,   304,  5733,  5734,   166,
     360,   196,   316,  1356,   172,    77,   331,    62,   118,   196,
    1368,  1424,    24,   172,   151,   269,   196,   196,  1412,   373,
    5591,   174,   148,  1071,    86,  5310,   414,   414,   196,   121,
      13,    38,   402,   300,    28,   448,    28,   196,   290,  1016,
     172,    35,   300,    35,  2802,   339,   284,   356,   138,  1354,
     197,   138,  5321,   168,  1359,  1360,   169,   650,  1416,   206,
    5422,    90,  1257,  1258,  1828,     5,    13,   214,   725,     6,
     217,    11,   120,   327,   172,     6,  1138,    79,   344,   373,
      79,   339,    79,  1278,  1848,   498,   269,   202,    90,    13,
     326,    79,    28,   402,    77,  1215,  1288,    44,   648,    35,
     192,   163,   416,    79,   654,   215,   373,   700,   234,  5736,
    5186,   363,   345,   345,   502,   502,   666,   172,    71,   172,
     345,   128,   345,  2881,   113,   450,   138,   237,   498,   360,
      77,   172,   172,   286,   172,   843,  1198,    90,   498,  5907,
     442,   211,   179,   317,  1308,   312,   460,   125,   502,   806,
      62,  5887,  1214,   123,   376,  5508,   237,    31,   498,   457,
      36,   189,   498,    31,   498,  1523,  1228,  5368,   442,  1172,
     401,   402,  1336,    50,   376,   414,   265,   360,  5010,   224,
      28,   274,   111,   345,  3709,   216,   282,  4180,   414,   370,
     498,   274,  5819,   414,  1499,   498,   149,   402,   402,   188,
    1232,  1246,  1247,   422,  1509,   476,   453,   274,   274,   498,
     300,   414,  4205,   629,   502,   414,   169,   436,  1413,   356,
     488,  5506,   498,   498,   414,   502,  5511,   635,  1273,   635,
     635,   496,   648,   635,   635,   500,   502,  5599,   654,   376,
     345,   399,   118,   428,   443,   345,  5817,   502,   502,   339,
     666,   399,   498,   402,  1578,  1232,   447,   431,  1604,  5886,
     249,  1607,   498,   252,   498,   443,   682,   498,  4958,   502,
     502,   687,   345,  1809,   729,  4342,   692,   502,   453,   502,
     696,   697,   414,   373,  1673,  1674,   373,   703,   497,   705,
     706,  1596,  1990,  1615,  1599,  1600,  5923,   733,   494,  2974,
     489,   490,   718,   719,  1628,   360,   501,   498,   459,   489,
     490,  1442,   419,   729,   501,  4382,  4610,  1559,  1671,  1351,
     728,   501,   501,  1442,  4381,  5740,   498,   498,  1377,   480,
     489,   490,   496,   501,   498,   414,   500,  4105,  5414,   459,
     502,   498,   501,   498,  1389,  1390,   498,   498,   742,   436,
     744,   441,   746,   910,   498,   498,   488,   498,   752,   498,
     480,   494,   498,  5755,   317,  5727,   489,   490,   500,   498,
     498,  5536,   788,  1595,  1351,   364,   488,   457,   498,   489,
     490,   756,  1359,  1360,   496,   414,  1519,  4931,   500,   383,
    1497,   383,   440,  4386,   449,   811,   812,   502,  1945,  1680,
     480,   817,   502,  5672,   502,   491,   492,   493,   494,   489,
     490,  1919,   414,  1807,   290,   414,  5685,   414,  4021,   491,
     492,   493,   494,   773,   635,   841,   414,   843,   898,   502,
    1027,  4032,    28,   345,  1031,  4036,  1033,  1030,   414,  1572,
    3381,  1030,  3383,   200,  1952,   898,  4432,   383,  3907,   502,
     866,  5299,  1559,   390,   391,  1963,  1589,   498,  1166,  5821,
     438,   309,   502,  3873,   502,   502,   436,  5598,   342,   346,
     498,   502,   888,   402,   342,  4090,  3594,  3595,   431,   174,
    1021,  3599,   290,  3736,  1789,   901,   475,   837,   356,   290,
     358,   900,   900,   900,   900,   900,   900,   900,   900,   900,
     900,   900,    62,   900,   900,   900,  3338,   900,   900,   498,
     181,   900,  3339,  5418,   923,   900,    37,   728,   729,  5595,
     368,  4291,  1566,  5885,  4292,  5794,  4020,   123,  4022,  3678,
     285,   815,   776,   777,   778,   819,  3282,  5578,    59,   172,
     687,   118,   489,   490,   491,   492,   493,   494,   844,   696,
     172,   419,   279,  5594,   290,    24,   703,   285,   406,   706,
     408,  5953,   270,    41,   914,   489,   490,   491,   492,   493,
     494,     3,   183,     3,   196,   184,     6,   304,  1494,   929,
     360,   304,   776,   304,   123,   113,   319,   167,     3,   110,
    5176,   286,  1008,  1009,  1010,   184,   173,    90,   265,  1307,
    1016,   360,   284,    24,   118,  1021,  5737,    27,   123,   389,
    1026,  1027,   488,   122,   210,  1031,    26,  1033,   222,   120,
     496,  1037,   498,   499,   500,   118,   502,   356,  4205,    34,
     122,   174,  3369,    10,  1992,  3310,  1052,   148,  3313,    49,
      17,    18,    19,   101,  5476,   402,    10,  4417,  5080,    13,
     173,   332,  5728,    17,    18,    19,   265,   111,   493,  5039,
     188,   265,    71,   498,   207,   500,     3,  2061,    89,   138,
      90,   210,   339,   777,    89,  1383,   265,  2035,   199,  1095,
     351,  1097,  1098,   113,  3359,  4353,   118,   898,   133,   900,
     135,   499,   285,   270,   502,   210,  5827,   392,  1892,   288,
    5831,   502,   457,   214,    10,   265,  1900,    13,   217,   118,
     131,    17,    18,    19,   374,   326,   194,   138,  1855,   220,
     141,   249,  1138,   181,   252,   217,   247,   142,   436,   250,
     744,   745,   746,   285,   462,   749,   750,   751,   131,   498,
    1448,   985,   986,   498,   265,   759,   357,   152,   141,    24,
    1166,    87,    89,  5884,   174,    30,  5386,   112,   188,  3700,
     274,   341,   443,  5169,  1172,   498,   502,   176,   269,   498,
     366,   498,   376,  1960,  1961,   498,   269,   498,   299,   290,
     303,   414,  1198,  4102,  4867,   345,  5416,  4854,  5412,  5432,
      97,   985,  4891,  5924,   130,  1772,  1212,   402,  1214,  5385,
    1175,   211,  1177,  4860,  1179,   142,  1181,   265,  1183,  1184,
    1185,   265,  1228,   373,   496,  1190,  1232,  5948,   500,   249,
    5951,  2628,   252,   344,   269,   240,   327,  1889,  1244,  5415,
      39,   300,   436,   442,  1103,   457,   364,   269,   498,  2696,
     436,  1903,   274,   123,    53,   200,   367,  2727,    51,    28,
    3791,   366,  1307,   442,  1916,   488,   379,  4625,   138,  1275,
     269,   438,   175,   138,   457,   274,   387,   500,  2032,    10,
     339,   178,    13,  1922,  1021,  2563,    17,    18,    19,   300,
    1027,   382,   986,   373,  1031,   300,  1033,  1303,  1304,  1305,
     196,  1307,   373,    34,   120,  1882,  5077,   436,   414,   299,
     109,   321,  1951,   240,   373,   457,  1955,   300,   317,   286,
    1959,  1327,   218,  1962,   335,  1886,  2773,    24,   339,   430,
     167,   436,   286,  2900,   333,  5769,  1929,  1914,    28,  5297,
    1901,   178,  2716,  1904,   364,  1351,  1372,   120,   358,  5120,
       3,   118,   300,  1359,  1360,   110,   339,   475,  1095,   196,
    1097,  1098,   373,   411,   133,    87,  3274,  1427,  1428,  4608,
    1430,  1172,    25,   300,  5747,  4568,   302,  1383,   161,  2013,
     307,  4572,   488,  1566,  1427,  1428,  4577,  1430,   499,  4580,
     286,   339,    82,  1954,   500,    85,  1957,  1958,   191,    57,
     405,    91,   407,   196,    37,  5401,  1412,   417,   130,   419,
     209,    28,   339,   423,  5410,   360,   343,   316,   246,   322,
    3168,  3169,   502,  1429,  4818,  3173,    59,  1433,  1434,   119,
      24,   502,   431,    87,    10,   300,    89,    13,  2991,  1240,
     233,   138,  1448,  4443,   314,  4354,   373,   220,  1454,   188,
     273,   234,   355,  4453,    24,   475,   401,   402,   274,  1260,
      30,  5834,  3210,  3211,  5460,   368,   265,   184,    44,   127,
     488,  4398,   152,   373,   339,    51,   130,   110,   405,   373,
     407,   407,   500,   497,  1990,   249,   176,   218,   502,   243,
     143,  1292,   247,   729,   373,   250,   269,  5080,   281,   189,
     403,    77,   341,   174,  1444,   164,  1307,   222,   373,  2488,
     249,   201,   349,    98,  5187,  1521,   133,   416,   152,   486,
     487,   488,   489,   490,   491,   492,   493,   494,  5175,  5499,
     457,   298,   486,   487,   488,   489,   490,   491,   492,   493,
     494,  4280,  2490,   196,   138,   148,  4285,   175,   265,   202,
     265,   401,   788,   339,   327,   286,  1562,   380,   161,  5932,
    5509,   460,  3010,   362,   167,   288,   199,    24,   138,  1173,
     146,   150,  1176,    30,  1178,   120,  1180,   300,  1182,  2563,
     302,  1580,  1186,   300,  5580,   378,  1585,   437,   173,  1595,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   366,
     364,   260,   502,   300,   307,   841,   360,  4361,   502,  3006,
    4318,   214,   327,  3010,   247,   191,   339,   250,   457,   198,
     196,   206,   339,   502,   356,   364,  1427,  1428,   414,  1430,
      10,   234,   265,    13,   243,   402,   221,    17,    18,    19,
     343,   480,   339,  5825,  5826,   243,   231,  4355,   302,  4180,
     321,   405,  1658,   306,    34,  2651,  4565,   233,  1657,   204,
     366,   376,  1661,   502,    44,   901,   299,  1673,  1674,  1675,
     373,    51,   257,   356,  4205,   358,   373,   444,   281,   196,
     434,   138,  5357,   457,  5359,   407,   366,   290,  5363,  5364,
     457,   358,  1632,  1991,   288,  1993,   402,    77,   351,   389,
    1887,  1999,   392,   223,   436,   459,   480,  2005,  2006,  2007,
     286,   344,   351,   480,  1897,  1898,   416,  5666,  2016,  1898,
     265,   436,   402,  2021,   269,   442,   449,   355,  5724,   164,
     300,   498,   366,   361,   367,   299,   419,   269,   444,  2523,
     368,   300,   274,  5925,   498,  1876,  5403,   400,  5421,   343,
     344,   360,   419,   407,   387,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   444,   350,  1772,  4032,   402,   339,
     121,  4036,   358,   173,  2758,   403,   429,   457,  1784,   373,
     339,   454,   438,  5430,   437,   299,   110,   440,   299,  1795,
     307,   226,   498,   325,   121,   300,   405,   425,   437,  2783,
     480,  1807,   378,   373,   416,  1811,   206,   405,   118,   373,
     444,   191,  2624,   161,   373,  5006,   196,   499,   498,  5815,
     502,   221,   339,   457,  1830,   434,   343,   430,  2605,   502,
    2013,   231,  1838,   419,   339,   498,   434,  4102,   218,   219,
    1846,   192,   498,   207,   168,   155,   480,   118,   460,   448,
     459,  5914,   216,   233,  5214,  4386,   373,   331,  1864,   373,
    5830,   459,   373,  2812,   498,   192,   230,  1873,   373,   161,
    1876,   356,     0,  1879,    98,   167,  1882,  1883,   202,   189,
    1886,  1887,    92,  1889,  1890,  5881,   234,   501,   300,   498,
    2874,   502,   272,   367,   300,  1901,   167,  1903,  1904,   498,
     498,  5964,   478,   388,  4923,   438,   286,  1913,  1914,   289,
    1916,  1917,   344,   489,   490,   491,   492,   493,   494,     3,
    5593,  2816,  5611,   247,   343,   135,   250,   339,   402,  2824,
     161,  1929,  2827,   339,   167,  4844,   167,  3035,   172,   498,
     457,   373,   234,   459,    31,  5592,  5621,  2861,  1954,   173,
     350,  1957,  1958,  4666,   373,  4820,  2940,   190,  5928,   269,
    4673,   373,   196,   480,   480,   498,  1931,   373,  1933,  1984,
    1935,    58,  1937,   319,  1939,   243,   450,  1975,  1943,  1975,
    1975,  3378,   206,  1975,  1975,  1991,   331,  1993,    13,   281,
    5384,  3388,  1998,  1999,  4859,    34,  4839,   221,   378,  2005,
    2006,  2007,  3889,   234,  2010,    89,  2012,   231,  2014,  2015,
    2016,  2017,  2018,  2019,  5033,  2021,  5035,  2023,  2024,    44,
    3468,  2027,   367,  2894,  2895,  2896,  3579,  2792,  2793,  2726,
    1970,  2796,  2864,   257,  3198,  2041,  2042,  2043,  2044,  1580,
    5208,  2955,   438,  4782,  1585,  4784,  4785,  4786,   120,   339,
     281,   243,    77,  2059,   300,  2061,  5729,   402,   457,   143,
     284,  1572,  5038,   259,  2978,  2979,  2980,  2981,   450,  2983,
    5046,  3468,  2724,  1983,  3832,    32,    33,  5435,  1589,   457,
     406,   480,   408,   373,  2651,  5742,   300,   283,  4353,  4354,
    3657,  3027,   360,   339,  3008,   167,  3663,  5457,   478,    37,
    4808,   457,   498,   502,   343,   450,   486,   487,   488,   489,
     490,   491,   492,   493,   494,  2812,  1657,  5026,   202,   499,
    1661,   335,   502,    61,   502,   339,   350,   373,  1929,   414,
    5039,   496,   204,    79,   373,   500,  1873,   405,   377,  1876,
      97,  4012,   177,   457,    90,   499,   502,  5820,   502,  1886,
    1887,  5409,  2849,   438,  3601,  5513,   177,     5,    96,   373,
     117,   419,   327,    11,  1901,   278,   434,  1904,   360,   457,
    3918,  3919,  3920,  3921,  1975,   340,  3924,  3925,  3926,  3927,
    3928,  3929,  3930,  3931,  3932,  3933,  2883,   363,   502,  2954,
    3085,   459,   480,   265,   224,   152,  2202,   269,  5366,  3646,
     300,  2840,   237,  2842,   369,  3189,    97,  2846,  3372,     5,
     498,  3195,   498,   405,   438,    11,   237,  1954,   167,   157,
    1957,  1958,   306,    47,  5224,   246,   117,   363,   246,    26,
     498,   248,   459,  3981,  3982,   148,  2242,   148,   459,   339,
    3024,   190,   434,   343,  2542,  3029,    70,  3031,   161,   498,
     161,   269,    49,   480,   167,   193,   167,  3041,   167,   480,
    3044,   152,  3046,  3047,    15,    16,  3050,   459,    79,  5926,
    3054,   498,  3056,   373,  3001,  3059,  3772,   498,  3415,    90,
     497,   190,   457,     5,   648,   502,   224,  2293,  5197,    11,
     654,   229,   406,    22,   408,   148,   331,    19,   975,    28,
    4565,   214,   666,   214,   284,   480,   498,  4572,   161,   289,
     419,  5669,  4577,  5323,   167,  4580,    38,   994,  5328,  5329,
     997,   234,  2960,   234,  1434,   246,   499,   493,   284,   502,
    5498,   269,   498,   289,   500,  3181,  3120,  3183,  3184,   971,
    5048,    71,    32,    33,   976,   429,  5255,    77,   496,   498,
     498,   500,   500,   437,   499,   341,   440,   502,   366,    10,
      90,   214,    13,   301,   243,  2556,  2557,  2558,   281,   307,
     281,   406,   246,   408,   270,   271,    94,   290,   335,   290,
    3275,   234,   498,   200,   500,   406,  5125,   408,   118,   499,
     120,   248,   502,    44,   402,   496,   190,   498,  3269,   434,
      51,    68,    69,  3113,  3114,   343,  2207,   419,   499,   366,
     348,   502,    86,   434,   499,   450,   457,   502,   459,   357,
     261,   262,   263,   264,   356,   357,    77,   365,   281,   499,
    5788,   406,   502,   408,   243,   373,   444,   290,   499,   243,
     406,   502,   408,  3082,   335,   402,   176,   385,   243,   457,
     499,   499,   499,   502,   502,   502,   394,   457,   243,   459,
     398,  2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,
     366,  2477,   480,   499,   204,   366,   502,  5636,  5637,   417,
    2486,   360,  2488,   499,    58,    90,   502,   444,   450,   499,
     498,   448,   502,   499,   499,   146,   502,   502,   363,  2686,
     457,  2688,  2689,   457,  2687,   459,   402,   133,  2687,   135,
    5437,   402,  3294,  3295,   452,  5873,   498,   430,   456,   430,
    2526,   224,   499,   480,  2530,   502,   405,  2533,  2525,  2535,
     499,   448,  2538,   502,  3272,   499,  2542,    11,   502,   269,
     191,   498,  3454,  2025,   274,   196,  2028,   499,   444,  5080,
     502,   360,  2683,   444,  3379,   434,   360,  2563,   498,  2565,
     499,   457,  4310,   502,   499,   360,   457,   502,  3480,   360,
    3324,   499,   177,   284,   502,   360,  2582,   430,   502,  4844,
     459,   243,   233,  2723,   480,  2591,  2592,   317,   498,   480,
    5499,   499,  5300,    58,   502,   200,   405,  3231,   450,  4152,
    5308,   405,   498,   333,  3389,  4363,   499,   498,    86,   502,
     405,  2617,   499,   499,   501,  2610,   502,  5785,  2624,   498,
     405,    47,  2628,  2629,  3761,   434,  5762,  5763,   499,  2635,
     434,   502,   237,  2639,  3418,   286,   220,  2643,  2653,   434,
    2655,    55,    56,   496,  5663,  2651,   499,   500,   499,   434,
     459,   502,   477,  2565,  4150,   459,  4152,   499,   287,   499,
     502,  2801,   502,  2669,   459,   499,  2672,  2651,   502,  5200,
     499,   284,  4142,   502,   459,   167,   271,  2683,   500,  2685,
    2686,  4128,  2688,  2689,   289,  2691,   287,   499,  5597,   498,
     502,   284,   499,  4090,   498,   502,   499,  2703,   360,   502,
     499,   431,   501,   498,  4003,  3489,  4005,  3491,  3275,    37,
    4556,   499,  4558,   498,   502,  3699,   499,  2723,  2724,   502,
     499,   499,  3872,   502,   502,   477,  2732,   378,  5896,   499,
    2531,    59,   502,   499,   499,    47,   502,   502,  4185,  3742,
    2880,  5006,   499,   405,   499,   502,   287,   502,  2754,  2755,
    3402,  3403,  2758,  5287,   499,  2695,   499,   502,  3455,   502,
     499,  5026,   499,   502,  2565,   502,  3405,  3703,  4037,   220,
    4039,   366,   434,   499,  5039,  2781,   502,  2783,  4988,   477,
    4990,  2787,   110,  3697,   499,   491,   499,   502,  2794,   502,
     499,   499,   171,   502,   502,  2801,   313,   459,  2804,  5967,
     502,   406,   499,   408,  2810,   502,   498,   402,   499,  2610,
    3432,   502,   499,   499,   419,   502,   502,   499,   499,   499,
     502,   502,   502,   498,  2830,   498,   431,   478,  2565,   434,
    2836,  5740,    10,  3530,    36,    13,   498,  2843,   489,   490,
     491,   492,   493,   494,   499,  3629,   498,   502,   176,   444,
    2856,  3635,  2792,  2793,   499,  2839,  2796,   502,  5723,   356,
     357,   499,   457,  2869,   502,  3432,    44,   499,  2874,   447,
     502,   199,  3170,    51,  2880,   499,   298,   499,   502,  4375,
     502,   356,   357,   499,  3182,   480,   502,   499,   499,   499,
     502,   502,  2898,  2899,  2900,  3547,  3606,   499,  2904,    77,
     502,   356,   357,   498,   499,  2015,   501,   499,    53,   499,
     502,    58,  4076,  2023,  3566,  5824,  3214,   499,   172,   247,
     502,  5830,   250,   216,   499,  2931,  2932,   502,   499,   461,
     499,   502,  5197,   502,  2940,  4370,   499,   265,  3125,   502,
    3127,  3128,   499,  4391,   366,   502,  2683,   499,   498,  2686,
     502,  2688,  2689,   498,    99,   499,  5495,   499,   502,  3257,
     502,   499,    10,   500,   502,    13,  4103,  4104,  2974,  3953,
     499,   299,   499,   502,   499,   502,   498,   502,   499,   124,
     402,   502,   339,   499,   499,  3880,   502,   502,   196,   499,
    5255,  3122,   502,   498,  4391,   153,    44,   142,  2993,   498,
    3006,   146,  3729,    51,  3010,   499,   499,   153,   502,   502,
     500,   284,  3960,   191,  2954,   196,   344,   339,   196,  5928,
     284,   153,   444,   168,   153,   196,   171,   153,   284,    77,
     167,   339,   153,   232,   120,   457,  3820,   438,  3822,   367,
    3824,   186,   284,   278,   498,   167,   499,    71,  3231,   269,
      37,   269,   461,   498,   284,   233,   167,   269,   480,   387,
     269,    47,  2974,  4006,    47,   424,    10,    89,  3720,    13,
    3722,   269,   300,   450,   450,   419,   498,   167,   153,   320,
     153,   498,   153,  3705,   153,  3707,   461,  3093,   153,   153,
     502,  3856,   153,   153,   153,   153,   153,   153,   146,   167,
      44,  4049,   153,  3109,   153,  3111,   153,    51,   286,  3748,
     153,   153,  3118,   402,   284,   498,  3122,    10,  3124,  3125,
      13,  3127,  3128,  3129,    37,  3170,   232,  4680,   167,   274,
     167,  3137,   284,    77,   498,     6,  3142,  4085,  3705,     6,
    3707,   167,   498,   191,  5409,   498,   498,   498,   196,   498,
    3333,    44,   498,   498,     6,   498,     6,   498,    51,   498,
     498,   498,  3168,  3169,  3170,   498,   498,  3173,  3790,  3214,
       6,   498,   498,   498,     6,  3181,  3182,  3183,  3184,   498,
     325,   498,   498,  3189,    77,   233,   458,   498,  3194,  3195,
    4660,  3197,  2993,  3199,   498,  4179,  4944,  4181,   498,   498,
     378,   498,   146,   498,  3210,  3211,  3845,   498,  3214,   296,
     498,   216,   502,    37,   101,  4151,   133,   502,   135,  3871,
    4204,   232,    37,  3790,   498,    36,   412,  3233,   412,  3235,
     496,  3237,   414,   496,  5499,   414,   498,  2974,   286,   414,
     414,   172,   159,   502,   167,   281,   167,   191,   279,   373,
      67,  3257,   196,   146,   414,   414,   360,  3262,  3263,  3264,
     414,   449,   360,   414,   500,   414,   414,   360,  3313,  3275,
     234,   414,   414,   343,   488,   414,    90,  4414,   360,   133,
     153,   135,   284,   229,   365,   274,   414,   414,   126,   233,
     405,   414,   304,   437,  1658,  4120,   284,   279,   191,   189,
     478,   356,  4087,   196,  3310,   159,   498,  3313,   498,   414,
    4205,   489,   490,   491,   492,   493,   494,   414,  3363,  3325,
      90,   126,   502,   300,  3330,   153,   196,   126,   438,   438,
     378,   414,  5597,   112,   414,   414,   402,   414,   414,  3345,
     233,   126,   286,    58,   261,   262,   263,   264,   402,    58,
     254,   268,  4288,  3359,  4266,   288,   324,   274,     0,   324,
     405,   414,   414,   324,   414,   304,   304,    46,   414,  3170,
     414,    46,  3378,   414,   414,  3381,   414,  3383,   503,   414,
     414,   414,  3388,   502,   414,  3122,   414,   414,  3125,   414,
    3127,  3128,   499,   286,   414,   218,  3402,  3403,  3310,   218,
      42,  3313,  3408,   284,   284,  4276,   218,   261,   262,   263,
     264,   218,   218,  3214,   268,   269,   218,   218,   218,   414,
     274,   218,   218,  3429,   424,    37,  3432,   153,   284,  3435,
     478,   498,   153,   118,   378,  3236,   269,  3443,   457,   438,
     153,   489,   490,   491,   492,   493,   494,  3359,   153,   153,
     284,  3252,   449,   240,    37,    97,   269,   167,    37,   269,
     269,   224,  3468,   362,   153,   153,  1830,   438,   438,   498,
     153,   153,  2582,   414,  1838,  5740,   172,   498,   453,   273,
     498,  5229,  1846,   278,   498,   378,   254,   254,    13,   502,
     412,   498,   498,  4890,   414,   181,   162,   416,  3504,  3505,
    3506,   502,   189,   499,   421,   189,   148,   499,   477,  3310,
    5258,   496,  3313,   364,   477,   432,   252,  3700,   499,   161,
     499,   499,  3528,   499,   454,   167,  1890,   376,   502,   222,
     172,  3537,   285,  3539,   478,   502,   178,   214,   438,   181,
      37,  3547,   293,   185,  4439,   489,   490,   491,   492,   493,
     494,    58,   499,  1917,   438,   498,   360,   222,  3359,  5824,
    3566,   222,  3363,   274,   498,  5830,   274,   421,   414,   414,
     414,   167,   214,  3310,   216,   274,  3313,   284,   432,    47,
     232,   284,   232,   232,   382,   478,   284,    10,   269,   414,
      13,   356,   234,   126,   502,   339,   489,   490,   491,   492,
     493,   494,   405,   190,   284,   327,   284,   373,   284,   370,
     499,    37,   218,   224,   488,  3913,   290,   438,   438,   153,
     279,    44,  3359,   414,  3630,   414,   323,   167,    51,    37,
     403,   169,   450,   324,   498,   370,   153,   498,   153,   281,
     153,   279,   284,   269,  4428,   438,  3652,  4431,   290,  3947,
      37,  3657,   269,   284,    77,    26,  4604,  3663,   224,   284,
     279,   187,   167,  5928,   187,   457,  3672,    37,   168,   224,
     370,  4455,   167,   502,   284,   269,   196,   196,   196,   461,
     196,    25,   196,   179,  4336,  4337,   502,   414,   172,   251,
     498,   284,  4829,  3699,  3700,  3993,    58,   457,   278,  3705,
     172,  3707,   305,   477,   296,   347,   172,   268,   414,  4521,
     295,   499,   502,   499,  3720,   498,  3722,   498,   502,   499,
     172,   499,   499,   146,   499,     0,   502,   499,   499,    58,
     499,   181,  4587,   242,   246,   499,    10,  3743,   454,    13,
     499,   499,   499,    17,    18,    19,  5181,   502,   498,   498,
     498,   498,   497,   499,   497,   480,   498,   399,   488,   479,
      34,   502,   284,  3769,   436,   498,   287,   498,   191,   200,
     153,   444,   208,   196,   284,   414,  4671,   414,   284,   414,
    3775,   274,   156,   269,  3790,  3791,   414,   153,   430,    85,
     365,   373,   153,   153,  4433,  4434,  4435,  4436,  4437,   232,
     365,   365,   200,   156,   284,   414,   438,  3813,   156,  5305,
     233,   435,   454,   234,   456,   457,  3811,   488,   306,   306,
     156,   389,    97,   414,   414,   414,  3832,   244,   414,   244,
     244,   360,   502,  4599,   126,   269,   414,   414,    10,  3779,
     414,    13,  3989,  3849,   414,    17,    18,    19,   153,   360,
      46,   414,   360,   499,  4790,   414,   360,   499,  4642,   501,
     502,   414,    34,   286,   414,  3871,   414,   414,  3874,   499,
     373,   218,   499,   148,   497,   218,   184,   499,   288,   499,
     424,   502,     3,   167,    47,  3891,   161,   111,  3894,   502,
     167,   499,   167,   498,  3900,   499,    37,   172,   153,  4683,
    4684,   153,  3908,   178,  3910,   167,   181,  3913,   184,   153,
     185,  3917,  3918,  3919,  3920,  3921,  3856,   488,  3924,  3925,
    3926,  3927,  3928,  3929,  3930,  3931,  3932,  3933,   279,   414,
     360,  3937,  3938,  3939,   151,   360,  3942,   438,   498,   214,
     438,  3947,  3987,   370,   218,  3951,   502,  3953,   360,  3955,
     287,   360,   151,   360,   218,   378,  4590,  3963,   218,   234,
    3966,   218,  3968,   144,   218,   218,   496,   218,   218,   218,
     218,    13,  3978,   296,  3775,  3981,  3982,   172,   502,   449,
    3986,  3987,   268,   221,   294,   454,   221,  3993,  4772,  4773,
    3995,  3996,  3997,  3998,   291,   497,    58,  4180,   404,   185,
     499,   347,   443,    88,   498,  4657,   281,   499,   499,   284,
    3811,   411,   286,   502,  4012,   290,  4012,  4012,  4024,   498,
    4012,  4012,  4205,   499,  5772,  5773,  4032,   424,   499,   167,
    4036,    37,   499,   438,   499,   499,   498,   498,   414,   438,
     224,  5438,   208,    58,   153,   176,   218,   405,   389,   424,
     365,   414,   156,   360,   360,   478,   499,   414,  3168,  3169,
     414,   499,  4068,  3173,   414,   414,   489,   490,   491,   492,
     493,   494,   347,   339,    58,   499,   498,   457,  4084,   405,
     444,   167,  4809,   284,  4090,    77,   153,   111,  4740,   424,
     218,   218,   218,   218,   414,   499,  4102,   498,   222,   284,
    3210,  3211,   498,   203,   498,   461,   499,   502,    37,   282,
    4749,  4750,   304,  4752,   286,   284,     3,  4123,  4902,    43,
    4032,  4905,  4906,   502,  4036,   498,   424,   402,   370,   414,
     502,   498,   178,   111,   499,   172,   218,   172,  4922,    58,
     499,   455,   455,   296,   499,  5016,  5130,   499,   221,   279,
     411,   424,  5705,   456,   499,   430,   414,   488,   172,   499,
     502,   499,   457,    77,   498,   498,   498,   197,  4174,   202,
     190,   190,  5309,  4179,  4180,  4181,   274,   274,    58,   454,
     405,   456,   457,   502,   488,  4837,  3987,   414,    71,   153,
    4102,   502,   414,   414,   156,   414,   218,   499,  4204,  4205,
     125,   174,   118,  4386,   498,    37,   438,   196,   279,  4507,
     498,  4012,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   496,   370,   438,   499,   500,   501,    37,  4212,   269,
     169,  4032,   279,   370,   457,  4036,    58,  4243,    83,  4223,
    4246,   405,    37,   457,   172,  5343,   284,  5345,   205,   167,
     334,   498,   172,  2617,   443,   287,   502,   216,   498,   304,
     499,   363,   499,   386,    37,    80,   499,   498,   498,    90,
     134,  2635,   284,   333,   414,  2639,    37,   153,   498,  2643,
      10,   499,   153,    13,    37,   414,   498,    17,    18,    19,
     498,   498,   498,   498,   498,  4032,   245,   167,   274,  4036,
     200,   498,   370,   153,  4310,  2669,   499,    37,   498,   111,
      37,   499,   172,   288,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   424,   499,   384,   384,   167,   110,    58,
    4336,  4337,   502,   498,  4340,  5472,   498,   498,    37,  2703,
    4346,   498,   502,   189,   443,   438,   498,  4353,  4354,   405,
     167,   405,   265,   284,   405,   499,     6,  4363,  5354,  2723,
    4999,   160,   498,   357,   357,  4102,   461,    71,    71,   501,
     287,  5010,   134,   139,   457,   453,   457,  5248,   442,   164,
    4386,  5158,   443,   164,  4379,  4391,  4392,  4393,   502,   172,
     498,  2755,   498,   373,   405,   330,   274,  4403,   202,   284,
     284,   370,   498,    37,    37,   287,  5040,  4590,   287,   498,
     197,    10,   152,    58,    13,  5552,  5553,  2781,    17,    18,
      19,   498,   174,  2787,   174,   499,    58,    37,   291,  5081,
    2794,   340,    58,   454,   499,    34,  4442,  2801,   393,   123,
    2804,  4353,  4354,   414,    10,   436,  2810,    13,     6,   499,
     498,    17,    18,    19,   139,   370,   149,   356,  5092,  5354,
     274,    23,  4468,   356,   498,    34,  2830,   498,    80,   498,
     414,   172,  2836,  4479,   502,   502,   292,    10,   152,  2843,
      13,   498,   356,   384,    17,    18,    19,   384,   218,   118,
     457,   457,  2856,   174,   174,   438,  5480,   498,   900,   499,
    5207,  4507,   939,  1660,  4510,  2869,  2958,  1360,  2849,  3275,
    2766,    44,  4518,  4519,  5298,  4521,  2880,  3480,    51,  4525,
    4526,  4179,  4154,  5689,  4530,  2875,  2929,  3691,  4534,  5133,
    5542,  4537,  4538,  5181,  5802,  4152,  4542,  4334,  4799,  5157,
    3409,  3072,  4548,  5668,    77,  5039,  5791,  5571,  5544,  5570,
    5708,  5824,  4353,  3413,  4844,  4380,   286,  4365,  5542,  4565,
    5516,  5698,  2943,  4354,  4324,  5349,  4572,  2943,  4174,  3505,
     981,  4577,  3740,  4349,  4580,  4581,  4838,  5164,  4379,  3784,
      10,  4416,  4588,    13,  5450,  5897,  5982,    17,    18,    19,
    5972,  5148,  3699,  4599,  5721,  5094,  1819,  5326,  4388,  5525,
    5097,    18,    28,  4442,  1199,   631,  4601,  4602,  4623,  5296,
    5893,  2960,  1862,  5562,  2629,  1859,  4353,  4354,  3388,   218,
    4626,  1873,  3795,  5207,  4391,  5438,  1897,  5266,  5765,  5766,
     683,  1978,  3633,  2874,  4204,  5747,   716,  5932,  4644,  1478,
    4422,   832,  1978,  2905,  5022,  2572,  4420,  4603,  5662,  4082,
      41,  4657,   218,  4565,  1772,    41,  3330,  1376,   191,  3345,
    4572,  5653,  2582,   196,  5492,  4577,  3313,  4021,  4580,  1337,
    4038,  5007,  3310,  5255,  5254,  1437,  4682,  5461,  4083,  3310,
    1436,  4665,  5916,  5647,  5776,   218,   219,   286,  5479,  5233,
    1444,  4675,  1393,  4699,  5493,  3955,  5494,  2483,  4704,  1439,
     233,  3236,  2017,  2904,  3138,  4711,  3234,  2570,  5347,   888,
    2486,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,  4727,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3093,
      -1,    -1,    -1,    -1,  4740,    -1,    -1,    -1,    -1,   272,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3111,    -1,    -1,
      -1,    -1,    -1,   286,  3118,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,  4771,    -1,    -1,    -1,    -1,
      -1,  4572,    -1,  5340,    -1,    -1,  4577,    -1,    -1,  4580,
      -1,    -1,    -1,  5510,    -1,    -1,    -1,  5354,   218,    -1,
      -1,  4797,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4601,  4602,    -1,    -1,    61,    -1,  5802,  4813,  3918,  3919,
    3920,  3921,  4818,    -1,  3924,  3925,  3926,  3927,  3928,  3929,
    3930,  3931,  3932,  3933,    -1,    -1,    -1,    -1,  4565,    -1,
      -1,  4837,    -1,    -1,    -1,  4572,    -1,    -1,  4844,    96,
    4577,  3951,    -1,  4580,  4581,   378,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   286,  5040,    -1,    -1,
      -1,  4856,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3981,  3982,  5507,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4890,    -1,  4892,   486,   487,   488,
     489,   490,   491,   492,   493,   494,    -1,  5080,    -1,    -1,
     157,    -1,    -1,    -1,  5091,    -1,    -1,    -1,    -1,  5092,
      -1,    -1,    -1,  5092,  4024,    -1,    -1,  4923,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    -1,
      -1,    -1,  4844,    -1,    -1,  4941,   193,  5235,  4944,    -1,
      -1,  4947,  4948,  4949,    -1,   478,    -1,    -1,  5135,    -1,
      -1,  5935,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,    -1,    -1,    -1,  4972,  4973,    -1,    -1,
    4976,  5269,   229,    -1,    -1,    -1,    -1,  5544,  5276,    -1,
      -1,    -1,    -1,    -1,  5963,    -1,    -1,    -1,  5972,    -1,
    4996,    -1,    -1,    -1,    -1,    -1,  5002,    -1,  5982,    -1,
    5006,    -1,  5786,    -1,    -1,    -1,  5012,  5013,    -1,    -1,
      -1,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5026,    -1,  5028,    -1,    -1,    -1,    -1,  5033,    -1,  5035,
      -1,    -1,    -1,  5039,    -1,    -1,    -1,    -1,    -1,    -1,
    5338,  5339,    -1,    -1,   301,    -1,    -1,    -1,    -1,    -1,
     307,    -1,    -1,    -1,  5019,  4856,   486,   487,   488,   489,
     490,   491,   492,   493,   494,  3429,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5080,  5081,  4813,    -1,    -1,    -1,
      -1,    -1,     6,    -1,    -1,  5091,   343,    -1,   345,    -1,
      -1,   348,    -1,    -1,  5006,    -1,    -1,    -1,    37,    23,
     357,    25,  5973,    -1,    -1,    29,    -1,  4844,   365,    -1,
      -1,    35,    36,    37,  5026,    39,   373,    -1,    42,    43,
      59,    45,  5689,    47,  5130,    -1,    -1,  5039,   385,  5135,
      54,    55,    56,    -1,    -1,    -1,    -1,   394,    -1,    -1,
      -1,   398,    -1,    -1,    -1,    -1,    85,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3528,    -1,    -1,  5162,     0,    -1,
    5468,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,   118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5488,  5197,  5490,    -1,  5200,   452,    -1,    -1,  5193,    -1,
    4310,    -1,    -1,    -1,    -1,  5006,    -1,    -1,  5207,  5207,
    5207,  5207,  5207,  5207,  5207,  5207,  5207,  5207,  5207,    -1,
    5207,  5207,  5207,  5229,  5207,  5207,    -1,  5233,  5207,  5235,
      -1,  5276,  5207,    -1,    -1,  5802,    -1,   176,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5255,
      -1,    -1,  5258,    -1,    -1,    -1,  5196,    -1,    -1,    -1,
     199,    -1,    -1,  5269,    -1,    97,    -1,    -1,    -1,  5006,
    5276,    -1,    -1,   197,   198,   199,    -1,    -1,   202,    -1,
      -1,    -1,   206,    -1,   208,  5197,    -1,   211,  3652,  5026,
     214,    -1,    -1,   217,    -1,    -1,   220,    -1,   222,    -1,
      24,   225,  5039,    -1,    -1,   229,    30,   231,   247,    -1,
      -1,   250,    -1,    -1,    -1,    -1,   148,  5323,    -1,    -1,
      -1,    45,  5328,  5329,  5507,    -1,   265,  5333,    -1,   161,
     269,    -1,  5338,  5339,  5340,   167,    -1,    -1,    -1,    -1,
     172,    -1,    -1,  5255,    -1,    -1,   178,    -1,  5354,   181,
      -1,    75,    -1,   185,  5091,    -1,    -1,    -1,    -1,    -1,
     299,  5162,    -1,    -1,    -1,    -1,    -1,    -1,  5374,    -1,
      -1,    -1,    -1,    -1,    -1,  5381,    -1,    -1,  5384,    -1,
      -1,    -1,   214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5193,    -1,    -1,    -1,    -1,    -1,  5135,    -1,
    4510,    -1,   234,  5409,    -1,   344,  5207,   131,    -1,    -1,
      -1,    -1,    -1,    -1,   138,    -1,  5411,   141,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   367,    -1,
      -1,    -1,  5438,  5439,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,   387,   281,
     389,    -1,   284,   392,    -1,    -1,  5462,    -1,   290,    -1,
    5197,    -1,  5468,    -1,    -1,    -1,    -1,    -1,  3832,    -1,
      -1,    -1,    -1,  5479,  5480,  5276,    -1,  5483,   202,    -1,
      -1,    -1,  5488,    -1,  5490,  3849,  5492,    -1,    -1,  5676,
      -1,    -1,    -1,  5499,    -1,    -1,    -1,  5409,    -1,    -1,
      -1,  5496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3874,  5517,    -1,    -1,    -1,   347,    -1,    -1,  5255,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5542,    -1,  5544,    -1,
      -1,   265,    -1,    -1,    -1,   269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   279,    -1,    -1,    -1,   498,
      -1,  5748,  5749,    -1,   288,    -1,    -1,    -1,    -1,    -1,
     402,    -1,    -1,    -1,    -1,    -1,   300,    -1,  5876,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5499,    -1,    -1,
      -1,  5597,    -1,    -1,    -1,    -1,    -1,    -1,   430,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5409,    -1,
    5411,    -1,    -1,    -1,    -1,   339,     0,    -1,   342,   343,
      -1,    -1,   454,    -1,   456,   457,    -1,    -1,    -1,  5635,
    5636,  5637,    -1,    -1,    -1,    -1,    -1,  5643,    -1,    -1,
      -1,    -1,    -1,    -1,  5381,    -1,    -1,  5653,    -1,   373,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5663,    -1,    -1,
      -1,    -1,    -1,    -1,   496,    -1,    -1,   499,   500,   501,
    5676,    -1,  5409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5689,    -1,  5597,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5496,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   630,    -1,    -1,    -1,
      -1,    -1,   636,    97,   638,    -1,   640,   441,    -1,   643,
      -1,    -1,    -1,    -1,  5730,    -1,   650,  5722,    -1,    -1,
      -1,   655,    -1,   657,  5740,    -1,    -1,    -1,    -1,   663,
      -1,    -1,  5748,  5749,    -1,    -1,    -1,    -1,  5754,  5747,
    5756,  5747,  5747,    -1,    -1,  5747,  5747,    -1,    -1,  4123,
      -1,    -1,  5499,   687,   148,    -1,  5772,  5773,    -1,    -1,
      -1,    -1,   696,    -1,    -1,    -1,   700,   161,    -1,   703,
      -1,    -1,   706,   167,    -1,    -1,    -1,    -1,   172,  5834,
    5977,  5978,    -1,    -1,   178,    -1,  5802,   181,   722,    -1,
      -1,   185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5824,    -1,
      -1,    -1,    -1,    -1,  5830,    -1,    -1,    -1,  5740,    -1,
     214,    -1,    -1,    -1,  4944,    -1,  5834,    -1,  5834,  5834,
      -1,  5847,  5834,  5834,    -1,    -1,    -1,    -1,    -1,   773,
     234,    -1,   776,   777,   778,    -1,    -1,    -1,    -1,    -1,
    5597,  5867,    -1,    -1,    -1,  5871,    -1,   791,    -1,    -1,
    5876,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4243,
      -1,    -1,  4246,    -1,    -1,    -1,  4996,   811,   812,    -1,
     814,   815,    -1,    -1,    -1,   819,    -1,   281,    -1,    -1,
     284,  5907,    -1,    -1,    -1,    -1,   290,    -1,  5914,   833,
      -1,    -1,  5824,   837,    -1,    -1,    -1,    -1,  5830,   843,
      -1,  5722,  5928,    -1,    61,    -1,    -1,    -1,    -1,  5935,
      -1,    -1,    -1,    -1,  5932,    -1,  5932,  5932,    -1,  5676,
    5932,  5932,    -1,    -1,    -1,    -1,  5747,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5963,  5964,    96,
      -1,    -1,  5968,   347,   888,    -1,  5972,    -1,    -1,    -1,
      -1,  5977,  5978,    -1,    -1,    -1,  5982,    -1,   902,    -1,
      -1,    -1,  4346,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     914,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,  4363,
      30,    -1,    -1,  5740,    -1,   929,    -1,    -1,    -1,    -1,
      -1,  5748,  5749,    -1,    10,    -1,  5928,    13,   402,    -1,
     157,    17,    18,    19,   948,    -1,    -1,    -1,    -1,   953,
     954,    -1,    -1,  5834,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    75,   430,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    51,   193,    -1,    -1,    -1,
      -1,   985,   986,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     454,    -1,   456,   457,    -1,    -1,    -1,    -1,  4442,    -1,
      -1,    77,    -1,    -1,  1008,  1009,    -1,  5824,    -1,    -1,
      -1,    -1,   229,  5830,    -1,    -1,    -1,  1021,    -1,  1023,
      -1,   131,    -1,  1027,    -1,    -1,  1030,  1031,   138,  1033,
    5847,   141,   496,    -1,  1038,   499,   500,   501,    -1,  5229,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,  5932,   269,    -1,    -1,    -1,    -1,  1061,   168,    -1,
      -1,    -1,    -1,    -1,  1068,  1069,    -1,    -1,  5258,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,   300,   301,  1089,  1090,  1091,    -1,  1093,
     307,  1095,   202,  1097,  1098,    34,    -1,  5914,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,  5928,    51,    -1,    -1,   191,    -1,    -1,    -1,    -1,
     196,    -1,   339,    -1,    -1,    -1,   343,  1131,    -1,  1133,
    1134,   348,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,
     357,    -1,   218,   219,    -1,    -1,    -1,  5964,   365,    -1,
      -1,  5968,    -1,    -1,    -1,   265,   373,   233,    -1,   269,
    5977,  5978,  1166,    -1,    -1,    -1,    -1,    -1,   385,   279,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,   288,    -1,
      -1,   398,    -1,    -1,    -1,    -1,    -1,    -1,  1192,  1193,
     300,    -1,    -1,  1197,    -1,  1199,   272,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    52,
     286,    -1,    -1,   289,  1218,    -1,    -1,    -1,    -1,    -1,
    1224,    34,    -1,  1227,    -1,    -1,  1230,    -1,    -1,   339,
      -1,    44,   342,   343,    -1,   452,    -1,    -1,    51,    -1,
    1244,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,   191,    -1,    -1,  4699,    -1,   196,    -1,    -1,
      -1,    -1,    -1,   373,    77,    34,    -1,  4711,    -1,    -1,
      -1,  1275,    -1,    -1,    -1,    44,    -1,    -1,    -1,   218,
     219,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,  5479,
      -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,  1303,
    1304,  1305,   378,  1307,    -1,    -1,    -1,    -1,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1327,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   441,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,
     289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,  1383,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   478,    -1,    -1,   218,   219,    -1,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    -1,
     233,    -1,   191,    -1,    -1,  1429,   502,   196,    -1,  1433,
    1434,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   378,
    1444,  1445,  1446,    -1,  1448,    -1,    -1,    -1,    -1,   218,
     219,    -1,    -1,  5643,    -1,    -1,    -1,    -1,    -1,   272,
      -1,    -1,    -1,    -1,   233,    -1,    -1,  1471,    -1,    -1,
      -1,    -1,    -1,   286,    -1,    -1,   289,    -1,    -1,  4923,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1506,   272,    -1,    -1,    -1,  1511,    -1,    -1,
    1514,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,
     289,    -1,    -1,  1527,  1528,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1536,    -1,    -1,  1539,    -1,    -1,    -1,   478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,
      -1,    -1,  1566,   502,  1568,   378,    10,  1571,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,  5772,  5773,  1588,    -1,    -1,  1591,    -1,  5033,
    1594,  5035,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,
      44,    -1,    -1,    -1,    28,    -1,    -1,    51,    -1,   378,
      -1,    -1,  1616,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1632,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,
    1644,  1645,  1646,  1647,  1648,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1662,    -1,
      -1,    -1,    -1,    -1,    -1,   478,    -1,    -1,    -1,  1673,
    1674,  1675,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,    -1,    -1,    -1,   499,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,
      24,    -1,    -1,    -1,    -1,    -1,    30,   486,   487,   488,
     489,   490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,
     499,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,  1771,    -1,    -1,
      -1,    -1,    -1,    -1,   218,   219,    -1,    -1,  1782,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1790,  1791,    -1,   233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1806,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   129,    -1,   131,    -1,    -1,
    1824,    -1,    -1,    -1,   138,    -1,    -1,   141,   272,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1840,  1841,  1842,  1843,
      -1,    -1,   286,    -1,    -1,  1849,    -1,    -1,    -1,   692,
      -1,    -1,  1856,    -1,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1873,
      -1,    -1,  1876,    -1,    -1,   718,    -1,    10,    -1,    -1,
      13,    -1,  1886,  1887,    17,    18,    19,    -1,   202,    -1,
      -1,    -1,    -1,  1897,  1898,    10,    -1,  1901,    13,    -1,
    1904,    34,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    44,    -1,    -1,    -1,  1919,  1920,    -1,    51,    -1,
      -1,    -1,  1926,    -1,  1928,    -1,    -1,    -1,    -1,    44,
      -1,    -1,    -1,    -1,   378,    -1,    51,    -1,    -1,    -1,
      -1,  1945,    -1,    -1,    77,    -1,    -1,    -1,  1952,    -1,
    1954,   265,    -1,  1957,  1958,   269,  1960,  1961,    -1,  1963,
      -1,    -1,    77,    -1,    -1,   279,  1970,    -1,    -1,    -1,
      -1,    -1,    -1,  1977,   288,    -1,    -1,    -1,    -1,  1983,
    1984,    -1,    -1,  1987,    -1,    -1,   300,  1991,    -1,  1993,
      -1,    -1,    -1,    -1,  1998,  1999,    -1,    -1,    -1,    -1,
      -1,  2005,  2006,  2007,    -1,    -1,  2010,    -1,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,    -1,  2021,    -1,  2023,
    2024,    -1,    -1,  2027,    -1,   339,    -1,    -1,   342,   343,
      -1,    -1,    -1,    -1,   478,    -1,    -1,    -1,  2042,  2043,
    2044,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,    -1,    -1,    -1,    -1,  2059,    -1,    -1,   191,   373,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     0,    -1,    -1,   191,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,   218,   219,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    -1,  2099,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    30,    -1,    32,    33,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    -1,   441,    -1,    -1,
      -1,    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,   272,
      -1,    -1,    -1,    -1,    -1,    72,    -1,    74,    75,    -1,
      -1,    -1,    -1,   286,    81,    -1,    83,    -1,   198,   199,
      -1,    -1,   202,    -1,    -1,    -1,    -1,    -1,    95,    24,
      97,   286,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,
      -1,    -1,   222,  1026,    -1,    -1,    -1,   114,    -1,   229,
     117,    -1,    -1,    -1,  1037,    -1,    -1,    -1,  2202,    -1,
      -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,  1052,
      -1,   138,    -1,    -1,    -1,    -1,    -1,   144,    -1,  5663,
      75,    -1,    -1,    -1,    -1,   152,    -1,   154,    -1,    -1,
      -1,    -1,    -1,    -1,   161,    -1,    -1,    -1,  2242,    -1,
      -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,    -1,    -1,
      -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   378,    -1,    -1,    -1,    -1,   195,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,
      -1,    -1,    -1,   138,    -1,    -1,   141,    -1,    -1,  2293,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,   236,
      -1,    -1,    -1,   168,   241,    -1,    -1,    -1,   742,    -1,
     744,    -1,   746,    -1,    -1,    -1,   253,    22,   752,   753,
     754,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    -1,    -1,    -1,   271,   478,    -1,   202,    -1,    26,
      -1,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,   478,    -1,    -1,    -1,    -1,    -1,  1212,
      65,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     307,    -1,    -1,    78,    -1,    -1,    -1,    -1,   315,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      -1,    -1,   329,    -1,    -1,    -1,    -1,    -1,   335,   336,
     265,   338,    -1,    -1,   269,    -1,   343,   112,    -1,    -1,
      -1,    -1,   349,    -1,   279,   352,    -1,    -1,    -1,    -1,
      -1,    -1,   359,   288,    -1,    -1,    -1,    -1,   365,   366,
      -1,   136,    -1,    -1,    -1,   300,   373,    -1,    -1,    -1,
     377,    -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     387,   156,    -1,  2467,  2468,  2469,  2470,  2471,  2472,  2473,
    2474,  2475,    -1,  2477,   169,   402,    -1,    -1,    -1,   174,
      -1,  2485,  2486,    -1,  2488,    -1,   181,   342,   343,    -1,
      -1,  2495,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   200,   433,    -1,    -1,    -1,
      -1,    -1,   439,    -1,    -1,    -1,    -1,   444,   373,    -1,
    2524,    -1,  2526,   947,    -1,  2529,  2530,    -1,    -1,  2533,
     457,  2535,    -1,    -1,  2538,    -1,    -1,    -1,  2542,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   246,    -1,   480,   481,   482,   483,   484,   485,    -1,
      -1,  2565,    -1,    -1,    -1,    -1,    -1,  2571,  2572,    -1,
      -1,   498,    -1,    -1,   501,    -1,    -1,    -1,  2582,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   441,  2591,  2592,    -1,
      -1,   286,  1016,    -1,    -1,    -1,    -1,    -1,   638,    -1,
     640,  2605,    -1,   643,   299,    -1,    -1,    -1,  2612,    -1,
    2614,    -1,    -1,    24,    -1,   310,    -1,   657,    -1,    30,
      -1,    -1,    -1,   663,    -1,   320,   321,    -1,    10,   324,
      -1,    13,    -1,    -1,    45,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2653,
      -1,  2655,    34,    -1,    -1,    -1,   351,    -1,    -1,   354,
      -1,    -1,    44,   358,    75,   360,    -1,    -1,  2672,    51,
      -1,    -1,   367,    -1,    -1,   370,    -1,    -1,    -1,  2683,
      -1,    -1,  2686,  2687,  2688,  2689,    -1,    -1,  2692,    -1,
      -1,  2695,    -1,    -1,   389,    77,    -1,    -1,    -1,    -1,
      -1,   396,    -1,    -1,    -1,    -1,    -1,   402,    -1,    -1,
     405,    -1,  2716,    -1,   409,    -1,    -1,    -1,   129,  1562,
     131,    -1,   417,  2727,   419,    -1,    -1,   138,    -1,   424,
     141,  2735,  2736,    -1,    -1,    -1,    -1,    -1,  2742,    -1,
      -1,    -1,   437,    -1,    -1,    -1,    -1,  2751,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   450,    -1,   168,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2772,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2792,  2793,
      -1,   202,  2796,    -1,    -1,  2799,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,  2822,    -1,
      -1,  2825,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2850,  2851,    -1,    -1,
      -1,   233,    -1,    -1,   265,    -1,    -1,    -1,   269,    -1,
      -1,  2865,    -1,  2867,  2868,    -1,    -1,    -1,   279,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   300,
     272,    -1,    -1,    -1,  2898,  2899,  2900,    -1,    -1,    -1,
    2904,    -1,    -1,    -1,   286,    -1,    -1,   289,  2912,    -1,
      -1,    -1,    -1,   953,   954,    -1,    -1,    -1,    -1,    -1,
      -1,  2925,    -1,    -1,    -1,    -1,    -1,  2931,   339,  2933,
    1354,   342,   343,    -1,    -1,  1359,  1360,    -1,    -1,    -1,
      -1,  1784,  2946,    -1,    -1,    -1,    -1,  2951,    -1,    -1,
    2954,    -1,  1795,    -1,  2958,   632,    -1,  2961,    -1,    -1,
      -1,    -1,   373,  1387,    -1,    -1,    -1,    -1,  1811,  2973,
    2974,    -1,  1396,    -1,  1398,    -1,    -1,    -1,  1402,    -1,
    2984,    -1,    -1,  1023,    52,  1409,    -1,    -1,    -1,    -1,
    2994,    -1,  2996,    -1,    -1,    -1,   378,    -1,  1038,    -1,
      10,    -1,    -1,    13,    -1,   682,   683,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1864,    -1,    -1,    34,    -1,    -1,    -1,  1068,  1069,
     441,  3035,    -1,  3037,    44,  3039,  1879,    -1,    -1,  1882,
    1883,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1093,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,  3072,    -1,
    1913,  1914,    -1,    -1,    -1,  1499,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1509,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1133,  1134,    -1,   478,    -1,    -1,    -1,
      -1,    -1,   779,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,    -1,    -1,    -1,    -1,   499,  3122,  3123,
      -1,  3125,    -1,  3127,  3128,    -1,  3130,    -1,   805,  1553,
    1554,    -1,    -1,  3137,    -1,    -1,   813,    -1,  3142,   816,
     817,   818,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    -1,    -1,  3168,  3169,  3170,    -1,    -1,  3173,
      -1,    -1,  1596,    -1,    -1,  1599,  1600,  3181,  3182,  3183,
    3184,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
    3194,    -1,    -1,  3197,    -1,  3199,    -1,    -1,  2041,    -1,
      -1,    -1,    -1,    75,    -1,    -1,  3210,  3211,   218,   219,
    3214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,    -1,    -1,    -1,  3231,    -1,  3233,
      -1,  3235,    -1,  3237,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3257,    -1,    -1,    -1,  3261,    34,   131,
      -1,    -1,   272,    -1,    -1,    -1,   138,    -1,    44,   141,
      -1,    -1,    -1,    -1,    -1,    51,   286,    -1,  3282,   289,
      -1,    24,    -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    -1,  3310,    -1,    -1,  3313,
    3314,    -1,    -1,    -1,  3318,  3319,  3320,    -1,    -1,    -1,
      -1,  3325,    -1,    -1,    -1,    -1,  3330,    -1,    -1,    -1,
     202,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,  1016,
      -1,  3345,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3359,    -1,    -1,    -1,  3363,
      -1,    -1,  3366,    -1,  3368,  1789,    -1,    -1,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,   131,    -1,
      -1,    -1,    -1,   265,    -1,   138,    -1,   269,   141,    -1,
      -1,    -1,    34,    -1,  3408,    -1,    -1,   279,    -1,    -1,
      -1,  3415,    44,    -1,    -1,   191,   288,    -1,    -1,    51,
     196,    -1,    -1,    -1,    -1,   168,    -1,    -1,   300,    -1,
      -1,    -1,    -1,    -1,  3438,  3439,    -1,    -1,    -1,    -1,
      -1,    -1,   218,   219,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,   202,
      61,    -1,    -1,    -1,    -1,    -1,    -1,   339,   478,    -1,
     342,   343,    -1,    -1,  1514,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,   499,
      -1,    -1,    -1,    -1,    -1,    96,   272,    -1,    -1,  1539,
      -1,   373,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,    -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,   269,  1204,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,    -1,    -1,
      -1,  3545,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1232,   157,   300,    -1,   191,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   441,
      -1,    -1,    -1,    -1,    -1,    -1,  1616,  2001,  2002,    -1,
      -1,    -1,    -1,    -1,  2008,  2009,   218,   219,    -1,    -1,
      -1,    -1,   193,    -1,    -1,    -1,   339,    -1,    -1,   342,
     343,   233,   378,    -1,  1644,  1645,  1646,  1647,    -1,    -1,
      -1,    -1,    -1,  2037,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   692,    -1,    -1,    -1,   229,    -1,
     373,    -1,  1309,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     272,  1318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     718,    -1,    -1,  3657,   286,  1332,    -1,   289,    -1,  3663,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,   269,    -1,
    3674,    -1,    -1,    -1,  1351,    -1,    -1,  1354,  1355,    -1,
      -1,    -1,  1359,  1360,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   441,   300,
     301,    -1,   478,    -1,    -1,    -1,   307,  3711,  3712,  3713,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    -1,
      -1,    -1,    -1,   499,  3728,    -1,    -1,    -1,    -1,    -1,
      24,    -1,    -1,    -1,    -1,    -1,    30,    -1,   339,  3743,
      -1,    -1,   343,    37,    -1,    -1,   378,   348,    -1,    -1,
    1790,  1791,    -1,    -1,    -1,    -1,   357,  3761,  3762,  3763,
      -1,    -1,    -1,  3767,   365,    59,  1806,    -1,    -1,    -1,
      -1,    -1,   373,    -1,    -1,  3779,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   394,    -1,    -1,    -1,   398,   866,    -1,
    1840,  1841,  1842,  1843,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3835,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
      -1,    -1,  2685,    -1,   138,    -1,   478,   141,  2691,    -1,
      -1,   452,  3856,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,    -1,    -1,  3869,    -1,   499,  3872,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,
    1920,    -1,    -1,    -1,    -1,    -1,  1926,  3891,    -1,  2732,
      -1,    -1,    -1,    -1,    -1,    37,  3900,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3908,   199,  3910,    -1,   202,  3913,
      -1,    -1,    -1,    -1,  3918,  3919,  3920,  3921,    -1,    61,
    3924,  3925,  3926,  3927,  3928,  3929,  3930,  3931,  3932,  3933,
      -1,    -1,    -1,  3937,  3938,  3939,  1613,    -1,    -1,    -1,
    1008,    -1,    -1,  3947,  1621,    -1,    -1,  3951,    -1,    -1,
      -1,  3955,    -1,   247,    96,    -1,   250,    -1,  1026,  3963,
      -1,    -1,  3966,    -1,  3968,    -1,    -1,    -1,    -1,  1037,
      -1,   265,    -1,    -1,  3978,   269,    -1,  3981,  3982,    -1,
      -1,    -1,  3986,  3987,  1052,   279,    -1,  3991,    -1,  3993,
      -1,    -1,    -1,    -1,   288,    -1,  4000,  4001,  4002,    -1,
      -1,    10,    -1,    -1,    13,   299,   300,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,   157,  4020,  4021,  4022,    -1,
    4024,  4025,    -1,    -1,  4028,    34,    -1,    -1,  4032,    -1,
      -1,    -1,  4036,    -1,    -1,    44,    -1,    -1,  4042,    -1,
      -1,    -1,    51,    -1,    -1,   339,    -1,    -1,   342,   343,
     344,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2099,
      -1,    -1,    -1,    -1,  4068,    -1,    -1,    -1,    77,    -1,
      -1,    -1,    -1,   367,    -1,    -1,    -1,    -1,  4082,   373,
    4084,    -1,   224,    -1,    -1,    -1,    -1,   229,    -1,  2932,
      -1,    -1,    -1,   387,    -1,    -1,    -1,    -1,  4102,  4103,
    4104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   269,    -1,  2553,
    2554,    -1,    -1,    -1,    -1,  2559,    -1,    -1,  4142,  4143,
      -1,    -1,    -1,    -1,  1212,    -1,    -1,   441,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,  1833,  4161,    13,   301,
    1837,    -1,    17,    18,    19,   307,    -1,  2591,  2592,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,   343,    -1,    -1,    -1,    -1,   348,    -1,    -1,   218,
     219,    -1,    -1,    -1,    -1,   357,    -1,    -1,    -1,    -1,
      -1,    -1,    77,   365,   233,    -1,    -1,  2651,    -1,    -1,
      -1,   373,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   394,    -1,    -1,    -1,   398,  4261,    -1,    -1,
      -1,    -1,    -1,   272,    -1,    -1,  3109,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,    -1,   286,    -1,    -1,
     289,  3124,    -1,    -1,    -1,    -1,  3129,    -1,    -1,    -1,
    4294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4308,    -1,  4310,    -1,    -1,    -1,
     452,  2735,    -1,  4317,   456,    -1,    -1,    -1,    -1,  4323,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2004,    -1,    -1,
    4334,    -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,
      -1,   196,    -1,    -1,  4348,    -1,    -1,    -1,    -1,  4353,
    4354,    -1,    -1,    -1,    -1,    -1,    -1,  4361,    -1,    -1,
      -1,    -1,    -1,   218,   219,    -1,  4370,    -1,    -1,   378,
      -1,    -1,    -1,    -1,    -1,    -1,  4380,    22,   233,    -1,
      -1,    -1,    27,    -1,    -1,    -1,  1454,    -1,  4392,  4393,
      -1,    -1,  2816,    -1,    -1,    -1,    -1,    -1,    -1,  4403,
    2824,    -1,    -1,  2827,    -1,    -1,    -1,    -1,    -1,    -1,
    4414,  4415,    -1,    -1,    -1,  2839,    -1,   272,    -1,    -1,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4432,    -1,
      -1,   286,    -1,    78,   289,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      -1,    -1,    -1,  1521,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4468,    -1,    -1,   112,    -1,   478,
      -1,    -1,    -1,    -1,    -1,  4479,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,    -1,    -1,    -1,  2529,
     499,   136,    -1,    -1,  1562,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   147,  4507,    -1,    -1,  4510,    -1,    -1,    -1,
      -1,   156,    -1,    -1,  4518,  4519,    -1,    -1,    -1,    -1,
      -1,  4525,  4526,   378,   169,    -1,  4530,  1595,    -1,   174,
    4534,    -1,    -1,  4537,  4538,    -1,    -1,    -1,  4542,  4543,
      -1,    -1,    -1,    -1,  4548,  4549,  4550,  4551,  4552,    -1,
      -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,
      -1,  4565,    -1,    -1,  4568,    -1,    -1,    -1,  4572,    -1,
      -1,    -1,    -1,  4577,    -1,    -1,  4580,  4581,    -1,  4583,
      -1,  4585,    -1,    -1,  4588,    -1,  4590,    -1,    -1,    -1,
      -1,    -1,  3435,    -1,    -1,  4599,    -1,    -1,    -1,  4603,
    3443,   246,    -1,    -1,  4608,  1673,  1674,  1675,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4623,
      -1,    -1,  4626,   478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
      -1,   286,    24,    -1,   499,    -1,    -1,    -1,    30,    -1,
      -1,    -1,  2692,    -1,    -1,    -1,  4660,    -1,    -1,    -1,
      -1,  3085,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4676,    -1,    -1,   320,   321,    -1,    -1,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,  3537,    -1,  3539,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   351,    -1,    -1,   354,
      -1,    -1,    -1,    -1,    -1,   360,  1784,    -1,    -1,    -1,
      -1,    -1,   367,  4727,    -1,   370,    -1,  1795,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1811,   389,    -1,    -1,  4751,    -1,   131,
      -1,   396,    -1,    -1,    -1,    -1,   138,   402,    -1,   141,
     405,    -1,  4766,    -1,   409,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,    -1,    -1,    -1,    -1,    -1,    -1,   424,
      -1,    -1,  2822,    -1,    -1,  2825,   168,  3630,    -1,    -1,
      -1,    -1,    -1,  4797,    -1,    -1,  1864,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   450,    -1,    -1,    -1,  4813,
      -1,  1879,    -1,    -1,  1882,  1883,  4820,    -1,    -1,    -1,
     202,    -1,    -1,    -1,    -1,  4829,    -1,    -1,  2505,  3672,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
    4844,    17,    18,    19,    -1,  1913,  1914,    -1,    -1,  3273,
      -1,  3275,    -1,  4857,    -1,  4859,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3291,    44,    -1,
      24,    -1,  2912,    -1,    -1,    51,    30,    -1,    -1,    -1,
      -1,  4885,    -1,   265,    -1,  2925,    -1,   269,    -1,    -1,
      -1,    -1,  4896,  2933,    -1,    -1,    -1,   279,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,
      -1,    -1,    -1,  3337,  3338,    -1,    -1,    -1,   300,    -1,
      -1,    75,    -1,    -1,    -1,    -1,  3769,    -1,    -1,    -1,
      -1,    -1,    -1,  2973,    -1,    -1,    -1,  4941,    -1,    -1,
    4944,    -1,    -1,  4947,  4948,  4949,  2014,    -1,    -1,  2017,
      -1,    -1,    -1,    -1,  2994,    -1,    -1,   339,    -1,    -1,
     342,   343,    -1,    -1,    -1,    -1,    -1,    -1,  4972,  4973,
    3813,    -1,  4976,  2041,  2651,    -1,    -1,   131,    -1,    -1,
      -1,    -1,    -1,    -1,   138,    -1,    -1,   141,    -1,    -1,
      -1,   373,  4996,    -1,    -1,    -1,    -1,  3037,  5002,  3039,
      -1,    -1,  5006,    -1,    -1,    -1,  5010,    -1,    -1,  5013,
      -1,  5015,    -1,    -1,   168,   191,    -1,    -1,    -1,    -1,
     196,    -1,  5026,    -1,  5028,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2710,    -1,  5039,  5040,  5041,    -1,  5043,
      -1,    -1,   218,   219,    -1,    -1,    -1,    -1,   202,    -1,
      -1,  3894,    -1,    -1,    -1,    -1,    -1,   233,    -1,   441,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3917,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3123,    -1,    -1,    -1,  5091,  5092,    -1,
    3130,    24,    -1,    -1,    -1,    -1,   272,    30,    -1,  3942,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,   265,  2789,   289,    -1,   269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   279,    -1,    -1,    -1,  2806,
      -1,  5135,    -1,    -1,   288,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    75,    -1,  5148,    -1,   300,    -1,    -1,  5153,
      -1,    -1,    -1,    -1,  5158,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5177,    -1,    -1,    -1,  5181,    -1,    -1,
    5184,    -1,    -1,    -1,    -1,   339,    -1,    -1,   342,   343,
      -1,  5195,  5196,  5197,    -1,  2872,    -1,    -1,   131,    -1,
      -1,    -1,   378,    -1,    -1,   138,    -1,    -1,   141,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,    -1,    -1,    -1,    -1,  5229,    -1,    -1,    -1,  5233,
      -1,  5235,  2909,    -1,  2911,   168,  2913,  2914,    -1,    -1,
      -1,  2918,  2919,  2920,    -1,  2922,  2923,  2924,    -1,    -1,
      -1,  5255,    -1,    -1,  5258,    -1,    -1,    24,  5262,    -1,
      -1,    -1,    -1,    30,    -1,  5269,    -1,    -1,    -1,   202,
      37,    -1,  5276,    -1,    -1,    -1,  3700,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   441,    -1,    -1,
      -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,  3723,
    2977,    -1,   478,  5307,    -1,  5309,    -1,    -1,    75,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    -1,
      -1,    -1,    -1,   499,    -1,  3002,    -1,    -1,    -1,  5333,
      -1,    -1,   265,    -1,  5338,  5339,   269,    -1,    -1,  5343,
    5344,  5345,  5346,   110,    -1,    -1,   279,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,
      24,    -1,    -1,    -1,   131,    -1,    30,   300,    -1,    -1,
    5374,   138,    -1,    -1,   141,    -1,    -1,  5381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3438,  3439,
      -1,   168,  5406,    -1,    -1,  5409,   339,    -1,    -1,   342,
     343,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5434,    -1,   199,    -1,    -1,   202,    -1,    -1,    -1,    -1,
     373,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3880,    -1,  5462,    -1,
      -1,    -1,    -1,    -1,  5468,    -1,    -1,   131,  5472,    -1,
      -1,    -1,  5476,    -1,   138,  5479,    -1,   141,    -1,    -1,
     247,    -1,    -1,   250,  5488,    -1,  5490,    -1,  5492,  5493,
      -1,    -1,    -1,    -1,    -1,  5499,    -1,  4340,   265,    -1,
      -1,    -1,   269,  5507,   168,    -1,    -1,    -1,   441,    -1,
      -1,    -1,   279,  5517,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   299,   300,    -1,    -1,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5552,  5553,
      -1,    -1,    -1,    -1,    -1,    -1,  2624,    -1,    -1,    -1,
    2628,  2629,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,    -1,    -1,   342,   343,   344,    -1,  5583,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5597,    -1,    -1,    -1,    -1,  3275,    -1,
     367,   265,    61,    -1,    -1,   269,   373,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   279,    -1,  2685,    -1,    -1,
     387,    -1,    -1,  2691,   288,    -1,    -1,    -1,    -1,    -1,
      -1,  5635,  5636,  5637,  3674,    -1,   300,    96,    -1,  5643,
      -1,    -1,    -1,  5647,    -1,    -1,    -1,    -1,    -1,  5653,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5662,    -1,
      -1,    -1,    -1,    -1,  2732,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5676,    -1,   441,   339,    -1,    -1,   342,   343,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5691,    -1,    -1,
      -1,    -1,    -1,    -1,  5698,    -1,    -1,    -1,   157,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5723,
      -1,    -1,    -1,    -1,    -1,    -1,  5730,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   193,    -1,  5740,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5748,  5749,  5750,    -1,    -1,    -1,
    5754,    -1,  5756,    -1,    -1,  3432,  4180,    -1,    -1,    -1,
      -1,  5765,  5766,  5767,    -1,    -1,    -1,    -1,  5772,  5773,
     229,    -1,    52,    -1,  5778,    -1,    -1,   441,    -1,    -1,
      -1,  4205,    -1,    -1,    -1,    -1,    -1,    -1,  4212,    -1,
      -1,    -1,  5796,    -1,    -1,  3835,    -1,    -1,    -1,  4223,
      -1,  4644,    -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,
     269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5824,  5825,  5826,    -1,    -1,    -1,  5830,    -1,    -1,    -1,
      -1,    -1,  2900,  3510,    -1,    -1,    -1,    -1,    -1,  4682,
      -1,   300,   301,  5847,    -1,    -1,    -1,    -1,   307,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4704,    -1,  5867,  2932,    -1,    -1,  5871,    -1,    -1,
      -1,    -1,  5876,    -1,    -1,  4299,  4300,    -1,    -1,    -1,
     339,    -1,    -1,    -1,   343,    -1,    -1,  3564,    -1,   348,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   357,    -1,
      -1,    -1,    -1,  5907,    -1,    -1,   365,    -1,  5912,  5913,
    5914,  5915,  5916,    -1,   373,    -1,    -1,    -1,    -1,    -1,
      -1,  5925,    -1,    -1,  5928,    -1,   385,    -1,  4771,    -1,
      -1,    -1,    -1,    -1,    -1,   394,    -1,    -1,  3006,   398,
      -1,    -1,  3010,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3632,    -1,    -1,    -1,  5963,
    5964,    -1,  4386,    -1,  5968,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5977,  5978,    -1,     8,  5981,    -1,    -1,
      -1,    -1,    14,    15,    -1,    -1,    -1,    -1,    20,    -1,
      22,    -1,    -1,   452,    -1,    -1,    28,    -1,    -1,    31,
      -1,  3678,    -1,    -1,     0,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3690,  3691,  4439,    -1,    -1,    50,    51,
      -1,    -1,    -1,  3700,    20,    -1,    -1,    -1,  3705,    -1,
    3707,    -1,    -1,    -1,    30,    -1,    32,    33,    -1,    -1,
      -1,  3109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4892,
      -1,    -1,    -1,    -1,    50,    -1,  3124,    -1,    -1,    -1,
      -1,  3129,    -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    72,  3754,    74,    75,
      -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      -1,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3789,  3790,    -1,    -1,    -1,    -1,   114,    -1,
      -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,
      -1,    -1,   138,    -1,    -1,    -1,    -1,    -1,   144,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,   154,    -1,
      -1,    -1,    -1,    -1,    -1,   161,    -1,    -1,   200,  5012,
      -1,    -1,   204,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     212,    -1,   178,   215,    -1,    -1,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,    -1,    -1,   195,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,
     236,  4665,    -1,    -1,    -1,   241,    -1,  4671,    -1,    -1,
      -1,  4675,    -1,    -1,  4294,    -1,    -1,   253,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4308,    -1,
      -1,    -1,    -1,    -1,    -1,   271,    -1,    -1,  4702,  4703,
      -1,    -1,    -1,  4707,  4708,  3962,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3378,   307,    -1,  3381,    -1,  3383,    -1,    -1,    -1,   315,
    3388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   329,    -1,    -1,    -1,    -1,    -1,   335,
     336,    -1,   338,    -1,    -1,    22,    -1,   343,    -1,    -1,
      27,    -1,    10,   349,    -1,    13,   352,    -1,    -1,    17,
      18,    19,    -1,   359,    -1,    -1,    -1,  3435,    -1,   365,
     366,    -1,    -1,    -1,    -1,  3443,    34,   373,    -1,    -1,
      -1,   377,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,   387,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,
    3468,    78,    79,    -1,    -1,    -1,   402,    -1,    -1,    -1,
      -1,    -1,   692,    -1,    -1,    -1,    -1,    94,    -1,    77,
      -1,    -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   112,    -1,   433,   718,    -1,
      -1,    -1,    -1,   439,    -1,    -1,    -1,    -1,   444,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   136,
      -1,   457,    -1,    -1,    -1,    -1,    -1,   206,   207,  3537,
     147,  3539,    -1,    -1,    -1,   214,    -1,   216,   217,   156,
    5323,    -1,    -1,    -1,   480,  5328,  5329,    -1,    -1,    -1,
      -1,   230,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,   498,  4180,    -1,   501,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,  4205,    -1,
      -1,    -1,    -1,   191,    -1,    -1,  4213,    -1,   196,  4216,
      -1,  4218,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,   219,  3630,    -1,    -1,    -1,    -1,    -1,    -1,   246,
      -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   866,  4264,    -1,  3657,
      -1,    -1,    -1,    -1,    -1,  3663,  5439,    -1,   630,    -1,
      -1,    -1,    -1,  4280,  3672,    -1,    -1,    -1,  4285,   641,
      -1,    -1,    -1,   645,   272,    -1,    -1,    -1,    -1,    -1,
     652,   653,    -1,    -1,   656,    -1,   658,   659,   286,    -1,
      -1,   289,  3700,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5483,   673,    -1,   320,   321,    -1,    -1,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5080,    -1,    -1,   691,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   351,    -1,    -1,   354,    -1,    -1,
     712,    -1,   714,   360,    -1,    -1,    -1,    -1,    -1,    -1,
     367,    -1,   724,   370,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3769,    -1,    -1,    -1,    -1,  4383,    -1,    -1,  4386,
      -1,  4751,   389,    -1,    -1,    -1,    -1,    -1,    -1,   396,
     378,    -1,    -1,  3791,   756,   402,  4766,    -1,   405,    -1,
      -1,    -1,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3813,  1026,   424,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1037,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1052,   450,    -1,    -1,    -1,    -1,    -1,    -1,
    4457,  4458,  4459,  4460,    -1,  4462,  4463,  4464,  4465,  4466,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   844,    -1,    -1,    -1,    -1,  4857,    -1,    -1,
     478,    -1,    -1,    -1,    -1,    -1,  3894,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,    -1,    -1,    -1,
      -1,   499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3917,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3942,    -1,    34,    -1,    -1,    -1,
    4557,    -1,  4559,    -1,    -1,    -1,    44,    -1,    -1,    -1,
     629,    -1,    -1,    51,   926,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   648,
      -1,    -1,    -1,    -1,    -1,   654,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   666,    -1,    -1,
    5354,    -1,  1212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   682,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   696,   697,    -1,
      -1,    -1,    -1,    -1,   703,    -1,   705,   706,  1000,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     719,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     729,    -1,  1024,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5041,    -1,  5043,    -1,    -1,    -1,  1039,    -1,  1041,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1050,    -1,
      -1,    -1,  4090,    -1,    -1,  1057,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   788,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,   219,    -1,    -1,    -1,    -1,    -1,  1099,    -1,  1101,
      -1,    -1,    -1,    -1,  1354,   233,    -1,    -1,   817,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4769,  4770,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   841,    -1,    -1,  4782,    -1,  4784,  4785,  4786,
    5534,    -1,  4180,    -1,   272,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,
      -1,   289,    -1,    -1,    -1,    -1,    -1,  4205,    -1,    -1,
      -1,    -1,    -1,  1175,    -1,  1177,    -1,  1179,    -1,  1181,
      -1,  1183,  1184,  1185,    -1,  5195,    -1,    -1,  1190,    -1,
      -1,    -1,   901,    -1,    -1,    -1,    -1,    -1,    -1,  1201,
      -1,    -1,    -1,  4850,  1454,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,  1219,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    -1,  4889,    -1,    -1,    -1,    44,    -1,    -1,    -1,
     378,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,  1521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    34,  4931,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,  1010,  4340,    -1,    -1,    -1,    -1,  1016,    -1,    -1,
      -1,    -1,  1562,    -1,    -1,    -1,    -1,    -1,  1027,    -1,
      -1,    -1,  1031,    -1,  1033,    -1,    77,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5344,    -1,  5346,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1595,    -1,    -1,  4386,    -1,
     478,    -1,    -1,  4391,    -1,    -1,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,    -1,    -1,    -1,
      -1,   499,    -1,    -1,  1376,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,   219,    -1,    -1,    -1,    -1,    -1,    34,    -1,  1138,
      -1,    -1,    -1,  5080,    -1,   233,    -1,    44,    -1,    -1,
     191,    -1,    -1,    -1,    51,   196,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,
      77,    -1,    -1,    -1,   272,    -1,    -1,    -1,  5125,    -1,
      -1,    -1,   233,  4521,    -1,    -1,    -1,  5134,   286,  1198,
      -1,   289,    -1,  1495,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1214,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1228,
      -1,   272,    -1,  1232,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1784,   286,    -1,    -1,   289,    -1,
      -1,  5935,    -1,    -1,    -1,  1795,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1811,    -1,    -1,    -1,  1567,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5583,    -1,    -1,    -1,    -1,  5972,    -1,
     378,    -1,    -1,    -1,   191,    -1,    -1,    -1,  5982,   196,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4644,    -1,    -1,    -1,
      -1,   218,   219,    -1,  1864,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,   378,    -1,  1879,
      -1,    -1,  1882,  1883,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1351,    -1,  4682,    -1,    -1,    -1,    -1,    -1,
    1359,  1360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1913,  1914,   272,  4704,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,
     478,  5691,   289,    -1,    -1,    -1,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,    -1,    -1,    -1,
      -1,   499,    -1,  1412,    -1,    -1,    -1,  5354,    -1,    -1,
      -1,  5358,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,    -1,    -1,
      -1,    -1,    -1,  4771,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,    -1,    -1,    -1,    -1,   499,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,   378,    -1,    -1,    -1,    -1,    -1,    -1,  1780,    -1,
      -1,    -1,    34,    -1,    -1,    -1,  5796,    -1,    -1,    -1,
      -1,  2041,    44,    -1,    -1,    -1,    -1,    -1,    10,    51,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,  1815,    -1,  5825,  5826,    -1,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4890,    -1,  4892,    -1,  1858,    -1,  1860,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,  1880,   486,
     487,   488,   489,   490,   491,   492,   493,   494,    -1,    -1,
      -1,    -1,   499,    -1,    -1,    -1,    -1,  5544,    -1,    -1,
      -1,  5548,    -1,  5550,  1906,    -1,  1908,  5554,  5555,    -1,
      -1,    -1,    -1,    -1,    -1,  5925,    -1,    -1,    -1,    -1,
      -1,  1923,    -1,  1925,    -1,    -1,    -1,    -1,    -1,  1931,
      -1,  1933,    -1,  1935,    -1,  1937,    -1,  1939,    -1,   191,
      -1,  1943,    -1,    -1,   196,    -1,    -1,    -1,    -1,  1658,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,    -1,
      -1,    -1,    -1,    -1,  5012,    -1,    -1,    -1,    -1,   191,
      -1,   233,    -1,    -1,   196,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,    -1,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     272,   233,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,    -1,   286,    -1,    -1,   289,    -1,    -1,
      -1,    -1,  5080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
     272,    -1,    -1,  1772,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   286,    10,    -1,   289,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,   692,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1807,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      -1,    -1,   718,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,  1830,    -1,    -1,    -1,    -1,   378,    -1,    -1,  1838,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1846,    -1,    -1,
      -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5802,    -1,    -1,    -1,    -1,
      -1,    -1,  5200,    -1,    -1,    -1,   378,    -1,    -1,   191,
      -1,    -1,    -1,    -1,   196,    -1,    -1,  1886,  1887,    -1,
    1889,  1890,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1901,    -1,  1903,  1904,   218,   219,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1916,  1917,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,   478,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,    -1,    -1,  1954,    -1,   499,  1957,  1958,
     272,    -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,
     866,   196,    -1,    -1,   286,    -1,   478,   289,    -1,    -1,
      -1,    -1,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   218,   219,  5323,    -1,   499,  5935,    -1,
    5328,  5329,    -1,    -1,  5941,    -1,    -1,    -1,   233,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,  5972,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5982,    -1,   272,  5985,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      -1,   286,  2061,    -1,   289,    -1,   378,    -1,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2624,    94,    -1,    -1,  2628,  2629,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,   118,
    5438,  5439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   136,    -1,    -1,
    1026,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   147,    -1,
      -1,  1037,    -1,    -1,    -1,  2685,    -1,   156,    -1,    -1,
      -1,  2691,    -1,   378,    -1,  5483,  1052,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,    -1,   478,    -1,   177,    -1,
      -1,    -1,   181,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,    -1,    -1,    -1,    -1,   499,    -1,    -1,
      -1,   200,  2732,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
      -1,    -1,    -1,    -1,   499,    -1,    -1,   286,    -1,    -1,
     289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   324,  1212,    -1,    -1,    -1,
      -1,    -1,   331,    -1,    -1,    -1,  2618,  2619,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   351,    -1,    -1,  2637,  2638,    -1,  2640,  2641,
      -1,   360,  2644,  2645,    -1,    -1,    -1,    -1,   367,    -1,
      -1,   370,    -1,    -1,    -1,    -1,    -1,  2659,    -1,    -1,
      -1,    -1,    -1,    -1,  2666,    -1,    -1,    -1,  2670,  2671,
     389,    -1,  2674,  2675,    -1,    -1,    -1,   396,    -1,  2681,
      -1,    -1,  2932,   402,    -1,    -1,   405,   406,    -1,   408,
     409,  2693,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2705,    -1,   424,    -1,    -1,  2710,    -1,
      -1,    -1,   431,    -1,    -1,   434,    -1,    -1,   437,    -1,
      -1,    -1,    -1,  2725,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   450,  2734,    -1,    -1,  2737,    -1,  2739,  2740,  2741,
      -1,    -1,    -1,    -1,  2746,  2747,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2756,    -1,  3006,    -1,    -1,  2761,
    3010,    -1,    -1,  2765,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,  2777,  2778,    -1,    -1,    -1,
    2782,    -1,    -1,    -1,    -1,    -1,  2788,  2789,    34,    -1,
      -1,    -1,    -1,  2795,    -1,    -1,  2798,    -1,    44,    -1,
      -1,    -1,    -1,  2805,  2806,    51,    -1,    -1,    -1,  2811,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2823,    -1,    -1,  2826,    -1,    -1,    -1,    -1,  2831,
      -1,    77,    -1,    -1,    -1,  2837,  2838,    -1,    -1,    -1,
      -1,    -1,    -1,  2845,    -1,    -1,  2848,    -1,  1454,    -1,
    2852,  2853,  2854,  2855,  2563,  2857,    -1,    -1,    -1,  3109,
      -1,   692,    -1,   207,    -1,    -1,    -1,    -1,  2870,  2871,
      -1,  2873,   216,    -1,  3124,    -1,    -1,    -1,    -1,  3129,
      -1,    -1,  2884,  2885,  2886,    -1,   230,   718,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2617,    -1,
      -1,    -1,    -1,    -1,    -1,  1521,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5963,  2635,    -1,    -1,    -1,
    2639,    -1,    -1,    -1,  2643,    -1,    -1,    -1,    -1,  2941,
      -1,    -1,  2651,    -1,    -1,   191,    -1,  2949,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,  1562,    -1,    -1,    -1,
    2669,    -1,    -1,    -1,    -1,    -1,    -1,  2969,    -1,    -1,
      -1,    -1,   218,   219,    -1,    -1,    -1,  2686,    -1,  2688,
    2689,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,  1595,
      -1,    -1,    -1,    -1,  2703,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2723,  2724,    -1,  3019,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   866,  3038,    -1,  3040,    -1,
     286,    -1,    -1,   289,    -1,  2754,  2755,    -1,    -1,  2758,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2781,    -1,  2783,    -1,    -1,    -1,  2787,    -1,
      -1,    -1,    -1,    -1,    -1,  2794,    -1,    -1,    -1,    -1,
      -1,    -1,  2801,    -1,    -1,  2804,    -1,    -1,    -1,    -1,
      -1,  2810,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,  2830,    -1,    17,    18,    19,    -1,  2836,  3378,  3131,
      -1,  3381,   378,  3383,  2843,    -1,    -1,    -1,  3388,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,  2856,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
    2869,    -1,    -1,    -1,    -1,  2874,    -1,    -1,    -1,    -1,
      -1,  2880,    -1,    -1,    -1,    -1,    -1,    -1,  1784,    -1,
      -1,    -1,    -1,    77,    -1,  3435,    -1,    -1,    -1,  1795,
      -1,    -1,    -1,  3443,    -1,  1026,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1811,  1037,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3468,    -1,
      -1,  1052,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     692,  2940,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    -1,
      -1,    -1,    -1,   499,    -1,    -1,   718,    -1,  1864,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,  1879,    -1,    -1,  1882,  1883,    -1,    -1,
      -1,    -1,    -1,    -1,    34,   629,    -1,  3537,    -1,  3539,
      -1,    -1,    -1,    -1,    44,    -1,    -1,   191,    -1,    -1,
      -1,    51,   196,    -1,   648,    -1,    -1,  1913,  1914,    -1,
     654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   666,    -1,   218,   219,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   682,   233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   697,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   705,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   719,    -1,    -1,   272,    -1,
    3630,  1212,    -1,    -1,  3093,   729,    -1,    -1,    -1,    -1,
      -1,    -1,   286,    -1,    -1,   289,    -1,    -1,    -1,    -1,
      -1,    -1,  3111,    -1,   866,    -1,    -1,    -1,  3410,  3118,
      -1,    -1,    -1,    -1,    -1,    -1,  3125,    -1,  3127,  3128,
      -1,    -1,  3672,    -1,    -1,    -1,    -1,    -1,  3430,    -1,
      -1,    -1,    -1,    -1,    -1,  2041,    -1,    -1,    -1,    -1,
      -1,   191,    -1,    -1,   788,  3447,   196,    -1,    -1,  3451,
    3700,    -1,    -1,    -1,  3456,  3457,  3458,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,
      -1,    -1,    -1,   817,    -1,    -1,    -1,    -1,    -1,    -1,
    3189,    -1,    -1,   233,   378,    -1,  3195,    -1,    -1,    -1,
    3492,  3493,  3494,  3495,    -1,    -1,    -1,   841,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3769,
      -1,    -1,   272,    -1,    -1,    -1,    -1,  3529,    -1,  3531,
    3532,  3533,    -1,    -1,    -1,    -1,   286,    -1,    -1,   289,
      -1,  3791,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   901,    -1,    -1,
      -1,    -1,    -1,  3813,  1026,    -1,  3275,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1037,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,    -1,
    1052,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,    -1,    -1,    -1,    -1,   499,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1454,    -1,    -1,    -1,    -1,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3644,    -1,  3894,    -1,    -1,    -1,    -1,    -1,
      -1,  3653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1010,  3917,    -1,    -1,
      -1,    -1,  1016,    -1,    -1,    -1,    -1,  3679,  3680,    -1,
      -1,    -1,  3684,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1521,    -1,  3942,  3402,  3403,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3706,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3429,    -1,    -1,  3432,    -1,    -1,    -1,    -1,   478,    -1,
      -1,  1562,    -1,    -1,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,   499,
    1212,    -1,    -1,    -1,    -1,    -1,    -1,  3759,    -1,    -1,
      -1,    -1,  3764,    -1,  1595,    -1,    -1,    -1,  3770,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1138,  3504,  3505,  3506,  3800,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3528,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3829,    -1,  3831,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3547,    -1,
    4090,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1198,    -1,    -1,  3566,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,  3870,    -1,
    1214,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1228,    -1,    -1,    -1,  1232,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    34,    17,    18,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
    4180,    51,    34,    -1,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    44,  3652,    -1,    -1,    -1,    -1,    -1,    51,
      -1,    -1,    -1,  1784,    -1,  4205,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    -1,  1795,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,
    1811,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3699,    -1,  1454,    -1,    -1,    -1,  3705,    -1,  3707,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1351,    -1,    -1,
      -1,  3720,    -1,  3722,    -1,  1359,  1360,    -1,  2624,    -1,
      -1,    -1,  2628,  2629,    -1,    -1,   128,    -1,    -1,    -1,
      -1,    -1,    -1,  1864,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1879,    -1,
      -1,  1882,  1883,    -1,    -1,    -1,    -1,    -1,    -1,  1521,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1412,    -1,
      -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,  2685,
      -1,  3790,  1913,  1914,    -1,  2691,    -1,    -1,    -1,   191,
    4340,    -1,    -1,    -1,   196,    -1,    -1,    -1,   218,   219,
    1562,    -1,    -1,    -1,  4106,    -1,    -1,  4109,    -1,  4111,
      -1,    -1,    -1,   233,    -1,    -1,   218,   219,    -1,    -1,
      -1,    -1,  4124,  3832,    -1,    -1,  2732,    -1,    -1,    -1,
      -1,   233,    -1,  1595,  4136,    -1,  4386,    -1,  4140,    -1,
    3849,  4391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   272,    -1,    -1,    -1,    -1,  4159,    -1,    -1,
      -1,    -1,  3871,    -1,    -1,  3874,   286,    -1,    -1,   289,
     272,    -1,    -1,    -1,    -1,  4177,    -1,    -1,    -1,    -1,
    4182,    -1,    -1,    -1,   286,    -1,    -1,   289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4207,    -1,    -1,    -1,  4211,
    2041,    -1,    -1,    -1,    -1,    -1,    -1,  4219,  4220,  4221,
    4222,    -1,    -1,    -1,    -1,    -1,    -1,  4229,  4230,  4231,
    4232,    -1,    -1,    -1,    -1,    -1,  4238,  4239,    -1,    -1,
      -1,    -1,  4244,  4245,  3953,  4247,  4248,  4249,  4250,  4251,
    4252,  4253,    -1,    -1,    -1,    -1,    -1,    -1,   378,    -1,
      -1,  4263,    -1,    -1,    -1,  4267,  4268,  4269,  4270,    -1,
      -1,  4521,    -1,    -1,    -1,    -1,   378,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4291,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4309,    -1,    -1,
      -1,    -1,    -1,    -1,  1658,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1784,    -1,    -1,    -1,  2932,    -1,    52,    -1,
      -1,    -1,    -1,  1795,    -1,    -1,   438,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1811,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,   478,   497,    -1,    -1,
      -1,    -1,  4384,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,    -1,  4644,    -1,    -1,    -1,    -1,    -1,
    3006,    -1,  1864,    -1,  3010,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4123,  4417,    -1,  1879,    -1,    -1,
    1882,  1883,  4424,    -1,  4426,    -1,    -1,    -1,  1772,    -1,
      -1,    -1,  4682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4446,    -1,    -1,    -1,    -1,    -1,
      -1,  1913,  1914,    -1,  4704,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1807,    -1,  4174,    -1,    -1,    -1,    -1,
    4179,    -1,  4181,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1830,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1838,  4204,    -1,    -1,    -1,    -1,
      -1,    -1,  1846,  3109,    -1,   692,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3124,    -1,
      -1,  4771,    -1,  3129,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   718,    -1,    -1,  4243,    -1,    -1,  4246,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1889,  1890,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1903,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1916,  1917,    -1,    -1,    -1,    -1,    -1,  2041,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4336,  4337,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4346,    -1,    -1,
      -1,    -1,  4892,  4645,  4646,  4647,    -1,    -1,    -1,  4651,
    4652,  4653,  4654,    -1,  4363,    -1,  4658,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,   866,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    34,  4694,  4695,  4696,  4697,  4698,    -1,  4700,  4701,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
    4712,  4713,    -1,    -1,    -1,    -1,    10,  2061,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4442,    77,    -1,    -1,    -1,    -1,  4741,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,  5012,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3378,    -1,    -1,  3381,    -1,  3383,    -1,    -1,
      -1,    -1,  3388,    77,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2624,    -1,    -1,    -1,  2628,  2629,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3435,
    5080,    -1,    -1,    -1,    -1,    -1,    -1,  3443,    -1,  1026,
      -1,  4843,    52,    -1,    -1,    -1,    -1,    -1,   191,    -1,
    1037,    -1,    -1,   196,  2685,    -1,    -1,    -1,    -1,    -1,
    2691,    -1,  3468,    -1,    -1,  1052,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   167,    -1,   218,   219,    -1,   172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,
      -1,  2732,   196,    -1,    -1,    -1,  4908,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   218,   219,    -1,    -1,    -1,   272,
      -1,  3537,    -1,  3539,    -1,    -1,    -1,    -1,    -1,   233,
      -1,    -1,    -1,   286,    -1,    -1,   289,    -1,  4657,    -1,
    5200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   692,    -1,
      -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4699,    -1,   286,    -1,   718,   289,    -1,    -1,    -1,    -1,
      -1,    -1,  4711,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5019,    -1,    -1,
      -1,    -1,    -1,    -1,  3630,  1212,    -1,    -1,    -1,    -1,
      -1,  4740,    -1,    -1,    -1,   378,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   395,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3672,    -1,    -1,    -1,
      -1,    -1,    -1,  5323,    -1,    -1,    -1,    -1,  5328,  5329,
    5082,    -1,    -1,    -1,   378,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3700,    -1,    -1,    -1,    -1,  5101,
      -1,  2932,    -1,    -1,  5106,  5107,    -1,    -1,    -1,  4818,
      -1,    -1,    -1,    -1,  5116,    -1,    -1,    -1,    -1,    -1,
      -1,  5123,    -1,    -1,    -1,    -1,    -1,    -1,  4837,    -1,
      -1,    -1,    -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,
      -1,    -1,   866,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,    -1,    -1,    -1,    -1,  5159,  5160,    -1,
      -1,    -1,  2624,  3769,    -1,    -1,  2628,  2629,    -1,    -1,
    5172,    -1,  5174,    -1,    -1,  3006,    -1,    -1,    -1,  3010,
      -1,    -1,    -1,    -1,   478,  3791,    -1,  5189,    -1,  5439,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,  3813,    -1,    -1,
      -1,    -1,  5214,    -1,  4923,    -1,    -1,    -1,    -1,  2563,
    5222,    -1,    -1,  2685,    -1,    -1,    -1,    -1,    -1,  2691,
      -1,   208,    -1,  5483,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1454,    -1,    -1,
    2732,    -1,    -1,  2617,    -1,    -1,    -1,    -1,  3109,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3894,  5291,
      -1,  2635,    -1,  3124,    -1,  2639,    -1,    -1,  3129,  2643,
      -1,    -1,  1026,    -1,    -1,    -1,    -1,  2651,    -1,    -1,
    5312,  3917,    -1,  1037,    -1,    -1,    -1,    -1,    -1,    -1,
    5322,    -1,    -1,    -1,  5033,  2669,  5035,    -1,  1052,    -1,
      -1,    -1,    -1,    -1,  1521,    -1,  3942,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2703,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5081,    -1,    -1,  1562,    -1,    -1,    -1,  2723,
    2724,    -1,  5091,    -1,    -1,  5387,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1595,    -1,
    2754,  2755,    -1,    -1,  2758,    -1,    -1,    -1,    -1,    -1,
      -1,  5130,    -1,    -1,    -1,    -1,  5135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2781,    -1,  2783,
      -1,    -1,    -1,  2787,    -1,    -1,    -1,    -1,    -1,    -1,
    2794,    -1,    -1,    -1,    -1,  5457,    -1,  2801,    -1,    -1,
    2804,    -1,    -1,    -1,    -1,    -1,  2810,    -1,    -1,    -1,
    2932,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   692,    -1,  4090,    -1,  2830,    -1,  1212,    -1,
      -1,    -1,  2836,    -1,    -1,    -1,    -1,    -1,    -1,  2843,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   718,    -1,
      -1,    -1,  2856,  5515,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2869,    -1,  5529,    -1,    -1,
    2874,    -1,    -1,    -1,    -1,    -1,  2880,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3006,    -1,    -1,  3378,  3010,    -1,
    3381,    -1,  3383,    -1,    -1,    -1,    -1,  3388,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5572,    -1,    -1,    -1,  4180,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5588,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2940,  1784,    -1,  4205,
      -1,    -1,    -1,    -1,  3435,    -1,    -1,    -1,  1795,    -1,
      -1,    -1,  3443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1811,    -1,    -1,    -1,    -1,    -1,
      -1,  5340,    -1,    -1,    -1,    -1,    -1,  3468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5354,    -1,  3109,    -1,    -1,
      -1,    -1,    -1,   630,    -1,    -1,   866,    -1,    -1,   636,
      -1,    -1,  3124,    -1,    -1,    -1,    -1,  3129,    -1,    -1,
      -1,    -1,    -1,  5675,    -1,  5384,    -1,  1864,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1879,    -1,    -1,  1882,  1883,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3537,    -1,  3539,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5718,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1913,  1914,    -1,    -1,
    1454,    -1,    -1,    -1,  4340,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3093,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,  3111,    -1,    -1,
      -1,  5480,    -1,    -1,  3118,    -1,    -1,    34,    -1,    -1,
    4386,    -1,    -1,    -1,    -1,  4391,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,  1521,    -1,  3630,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5814,    -1,    -1,    -1,  1026,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    -1,    -1,    -1,  1037,    -1,    -1,
      -1,    -1,    -1,  5542,    -1,  5544,    -1,   814,  1562,    -1,
      -1,  3672,  1052,    -1,    -1,  3189,    -1,    -1,    -1,    -1,
      -1,  3195,    -1,    -1,  2041,    -1,   833,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3700,
      -1,  1595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,
      -1,    -1,    -1,    -1,    -1,  4521,  3378,    -1,    -1,  3381,
      -1,  3383,    -1,    -1,    -1,   902,  3388,    -1,    -1,    -1,
      -1,  3275,    -1,    -1,   191,    -1,    -1,    -1,  3769,   196,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5663,    -1,    -1,    -1,    -1,    -1,
    3791,   218,   219,    -1,    -1,    -1,    -1,  5676,    -1,    -1,
      -1,   948,    -1,  3435,    -1,    -1,   233,    -1,    -1,    -1,
    5689,  3443,  3813,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1212,    -1,    -1,    -1,  3468,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,
      -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,  4644,  5748,
    5749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   312,    -1,    -1,  3402,  3403,
    1784,    -1,    -1,  3894,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1795,    -1,    -1,    -1,  3537,  4682,  3539,    -1,    -1,
      -1,    -1,    -1,    -1,  1061,  3429,  3917,  1811,  3432,    -1,
      -1,    -1,    -1,  5802,    -1,    -1,    -1,    -1,  4704,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3942,  1089,  1090,  1091,    -1,    -1,    -1,    -1,    -1,
      -1,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1864,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1879,    -1,    -1,  1882,  1883,
    3504,  3505,  3506,    -1,    -1,  4771,    -1,    -1,  3630,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3528,    -1,    -1,    -1,    -1,  1913,
    1914,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3547,    -1,    -1,    -1,    -1,    -1,    -1,
    3672,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1197,   478,  3566,    -1,    -1,    -1,  5935,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,  3700,    -1,
      -1,  1218,    -1,    -1,  1454,    -1,    -1,    -1,    -1,    -1,
    1227,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,  4090,
      17,    18,    19,  5972,    -1,    -1,    -1,    -1,  5977,  5978,
      -1,    -1,    -1,  5982,    -1,    -1,    -1,    34,    -1,    -1,
      37,    -1,    -1,    -1,    -1,    -1,  4892,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3769,  3652,    -1,
      -1,  1521,    -1,    -1,    -1,    -1,    -1,  2041,    -1,    -1,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3791,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4180,
      -1,  3813,  1562,    -1,    -1,  3699,    -1,    -1,    -1,    -1,
      -1,  3705,    -1,  3707,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4205,    -1,  3720,    -1,  3722,    -1,
      -1,    -1,    -1,    -1,    -1,  1595,    -1,    10,  1365,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5012,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,  3894,    -1,   191,    -1,    -1,  2624,    -1,   196,
      -1,  2628,  2629,    -1,    -1,    -1,  3790,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    77,  3917,    -1,    -1,    -1,    -1,
      -1,   218,   219,    -1,    -1,    -1,    -1,    -1,  1445,    -1,
      -1,    -1,    -1,    -1,  5080,    -1,   233,    -1,    -1,    -1,
    3942,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3832,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2685,    -1,
      -1,    -1,    -1,    -1,  2691,  3849,    -1,    -1,    -1,  4340,
      -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3871,    -1,   286,
    3874,    -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2732,    -1,    -1,    -1,    -1,
    1527,    -1,    -1,    -1,    -1,  4386,    -1,    -1,    -1,  1536,
    4391,    -1,    -1,    10,    -1,    -1,    13,    -1,   191,    -1,
      17,    18,    19,   196,  1784,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1795,    -1,    34,    -1,    -1,
      -1,  1568,    -1,    -1,  5200,   218,   219,    44,    -1,    -1,
      -1,  1811,    -1,    -1,    51,    -1,    -1,    -1,    -1,  3953,
     233,    -1,    -1,    -1,  1591,    -1,    -1,  1594,    -1,    -1,
      -1,   378,    -1,    -1,    -1,    -1,    -1,    -1,  4090,    -1,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   272,
      -1,    -1,    -1,    -1,  1864,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,    -1,    -1,   289,    -1,    -1,  1879,
      -1,  1648,  1882,  1883,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1662,    -1,    -1,    -1,    -1,
    4521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1913,  1914,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5323,  4180,    -1,
      -1,   478,  5328,  5329,    -1,    -1,    -1,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,    -1,    -1,
      -1,    -1,    -1,  4205,   191,  2932,    -1,    -1,    -1,   196,
      -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,  4123,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1771,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1782,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4644,    -1,    -1,    -1,    -1,    -1,  3006,
      -1,    -1,    -1,  3010,    -1,   272,    -1,    -1,    -1,    -1,
    4174,  2041,    -1,  5439,    -1,  4179,    -1,  4181,    -1,   286,
      -1,    -1,   289,    -1,    -1,    -1,    -1,  1824,    -1,    -1,
      -1,  4682,    -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,
    4204,   308,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,  1849,  4704,    -1,    -1,    -1,  5483,  4340,  1856,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4243,
    2624,    -1,  4246,    -1,  2628,  2629,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,  3109,    -1,  4386,    -1,    -1,    -1,    -1,  4391,
      -1,   378,    -1,    -1,    -1,    34,    -1,  3124,    -1,    -1,
    4771,    -1,  3129,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,  1928,    51,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,  2685,    17,    18,    19,    -1,    -1,  2691,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    34,
      -1,    -1,    37,  1960,  1961,    -1,    -1,    -1,    -1,    44,
      -1,    -1,  4336,  4337,    -1,    -1,    51,    -1,    -1,    -1,
    1977,    -1,  4346,    -1,    -1,    -1,    -1,    -1,  2732,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4363,
      -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4521,
      10,  4892,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    34,    -1,    -1,    17,    18,    19,
      -1,    -1,   191,    -1,    44,    -1,    -1,   196,  4442,    -1,
      -1,    51,    -1,    -1,    34,    -1,    -1,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,   218,
     219,    51,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    -1,   233,    -1,   191,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,   233,    -1,
      -1,  5012,  4644,    -1,    -1,    -1,    -1,   286,    -1,    -1,
     289,  3378,    -1,    -1,  3381,    -1,  3383,    -1,    -1,    -1,
      -1,  3388,    -1,    -1,    -1,    -1,    -1,    -1,  2932,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,
    4682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,    -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,
      -1,   191,  4704,    -1,    -1,    -1,   196,    -1,  3435,  5080,
      -1,    -1,    -1,    -1,    -1,    -1,  3443,    -1,    -1,    -1,
      -1,   191,    -1,    -1,    -1,    -1,   196,    -1,   218,   219,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   378,
      -1,  3468,  3006,   233,    -1,    -1,  3010,    -1,   218,   219,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,  4771,
      -1,    -1,    -1,  4657,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   272,   378,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,   289,
      -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3537,    -1,  3539,    -1,    -1,  4699,   286,    -1,    -1,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4711,    -1,  5200,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,
      -1,    -1,    -1,    -1,    -1,  3109,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,  4740,    -1,    -1,    -1,
    3124,    -1,    -1,    -1,    -1,  3129,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2624,    -1,    -1,    -1,  2628,  2629,
      -1,    -1,    -1,   478,   811,   812,    -1,    -1,   378,    -1,
    4892,   486,   487,   488,   489,   490,   491,   492,   493,   494,
      -1,    -1,    -1,  3630,    -1,    -1,    -1,    -1,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     410,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4818,  2685,    -1,    -1,    -1,    -1,
      -1,  2691,    -1,    -1,    -1,  3672,    -1,    -1,    -1,    -1,
      -1,    -1,  5323,  4837,    -1,    -1,    -1,  5328,  5329,    -1,
      -1,   888,    -1,    -1,    -1,    -1,    -1,    -1,  2485,    -1,
      -1,    -1,    -1,  3700,    -1,    -1,    -1,    -1,  2495,    -1,
      -1,    -1,  2732,    -1,    -1,    -1,    -1,    -1,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,    -1,  2524,   478,    -1,
    5012,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4923,
      -1,    -1,  3769,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2571,  2572,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,  3791,    -1,    13,    -1,  5439,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,  5080,    -1,
      -1,  1008,  1009,    -1,    -1,    -1,  3813,    34,  2605,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5483,    -1,  3378,    -1,    -1,  3381,    -1,  3383,
      -1,    -1,    -1,    -1,  3388,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5033,
      -1,  5035,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3894,    -1,    -1,
      -1,  3435,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3443,
      -1,    -1,  2932,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3917,    -1,    -1,    -1,    -1,    -1,    -1,  5081,  5200,    -1,
      -1,    -1,    -1,    -1,  3468,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3942,    -1,    -1,    -1,  2736,
      -1,    22,    -1,    -1,    -1,   172,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2751,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,    -1,  5130,    -1,    -1,   196,
      -1,    -1,    -1,    -1,    -1,  2772,  3006,    -1,    -1,    -1,
    3010,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,  3537,    -1,  3539,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    90,
      -1,    -1,    -1,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   112,    -1,    -1,    -1,    -1,    -1,  1244,    -1,    -1,
      -1,  5323,    -1,    -1,    -1,   272,  5328,  5329,    -1,    -1,
      -1,    -1,    -1,  2850,  2851,   136,    -1,    -1,    -1,   286,
      -1,    -1,   289,    -1,    -1,    -1,   147,    -1,  1275,    -1,
      -1,    -1,    -1,    -1,    -1,   156,    -1,    -1,    -1,  3109,
      -1,    -1,    -1,  4090,    -1,    -1,  3630,    -1,   169,    -1,
      -1,    -1,    -1,   174,  3124,    -1,  1303,  1304,  1305,  3129,
    1307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,   200,
    1327,    17,    18,    19,    -1,    -1,    -1,    -1,  3672,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,    44,    -1,
      -1,   378,    -1,    -1,  2951,    51,  3700,  5439,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4180,    -1,    -1,  5340,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4205,    -1,
      -1,  5483,    -1,    -1,    -1,   286,    -1,    -1,    10,    -1,
      -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
    5384,    -1,  1429,    -1,    -1,  3769,  1433,  1434,    -1,   310,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,   320,
     321,    -1,    44,   324,    -1,    -1,    -1,  3791,    -1,    51,
      -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,    -1,  3813,
     351,    -1,    -1,   354,    -1,    77,   172,   358,    -1,   360,
      -1,    -1,    -1,    -1,    -1,    -1,   367,  1319,    -1,   370,
      -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   389,    -1,
      -1,    -1,    -1,    -1,    -1,   396,  5480,    -1,    -1,    -1,
      -1,   402,   218,   219,   405,    -1,    -1,    -1,   409,    -1,
      -1,    -1,    -1,  4340,    -1,    -1,   417,   233,   419,    -1,
      -1,  1373,    -1,   424,    -1,    -1,    -1,    -1,  3378,    -1,
    3894,  3381,    -1,  3383,    -1,    -1,    -1,    -1,  3388,    -1,
      -1,    -1,    -1,    -1,    -1,   167,    -1,    -1,    -1,   450,
      -1,    -1,    -1,  3917,    -1,    -1,   272,    -1,  5542,  4386,
    5544,    -1,    -1,    -1,  4391,    -1,    -1,    -1,    -1,   191,
     286,    -1,    -1,   289,   196,    -1,    -1,    -1,  3942,    -1,
      -1,    -1,    -1,    -1,    -1,  3435,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3443,    -1,    -1,   218,   219,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,  3468,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3261,    -1,  1673,  1674,  1675,    34,
     272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      -1,    -1,   378,    -1,   286,  3282,    51,   289,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5663,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3537,    -1,  3539,
      -1,    -1,    77,    -1,  4521,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5689,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4090,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,   378,    -1,    -1,    -1,
      -1,   146,   478,    -1,    -1,    -1,    -1,    -1,    -1,    34,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    44,
    3630,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,
      -1,   196,    77,    -1,    -1,    -1,  4180,  4644,  5802,    -1,
      -1,    -1,  3672,    -1,    -1,    -1,    -1,  1679,    -1,    -1,
      -1,  1683,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,
      -1,  4205,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
    3700,    -1,    -1,    -1,    -1,  4682,   478,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,    -1,    -1,    -1,    -1,  4704,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   286,   167,    -1,   289,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3769,
      -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,  3545,    -1,
      -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3791,    -1,    -1,  4771,    -1,    -1,    -1,    -1,    -1,
      -1,  5935,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3813,    -1,    -1,    -1,    -1,   233,    -1,
      -1,  1998,    -1,    -1,    -1,    -1,  4340,    -1,    -1,    -1,
      -1,    -1,    -1,  2010,    -1,  2012,    -1,  2014,  5972,    -1,
    2017,  2018,  2019,   378,    -1,    -1,    -1,  2024,  5982,    -1,
    2027,    -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2042,  2043,  2044,    -1,    -1,
      -1,   286,  4386,    -1,   289,    -1,    -1,  4391,    -1,    -1,
      -1,    -1,  2059,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3894,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4892,    -1,  3917,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3942,   478,  3711,  3712,  3713,    -1,    -1,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
      -1,  3728,    -1,   378,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    -1,    -1,  1996,  3762,  3763,    -1,    -1,    44,
    3767,    -1,    -1,    -1,    -1,    -1,    51,  4521,    -1,  2011,
      -1,    -1,    -1,  2015,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2202,    -1,  2029,  2030,  2031,
      -1,  2033,    77,    -1,    -1,  5012,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   478,    -1,  2242,    -1,    -1,    -1,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4090,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3869,  5080,    -1,  3872,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2293,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4682,    -1,
      -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,
    4180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,
    4704,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4205,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5200,    -1,    -1,    -1,   272,    -1,    -1,
      -1,    -1,    -1,  4000,  4001,  4002,    -1,    -1,    -1,    -1,
      -1,   286,    -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4771,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2467,  2468,  2469,  2470,  2471,  2472,  2473,  2474,  2475,    -1,
    2477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2486,
      -1,  2488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   378,    -1,    -1,    -1,    -1,    -1,    -1,
    4340,    -1,    -1,    -1,    -1,    -1,  5323,    -1,    -1,  2526,
      -1,  5328,  5329,  2530,    -1,    -1,  2533,    -1,  2535,    -1,
      -1,  2538,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4892,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4386,    -1,    -1,    -1,
      -1,  4391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2591,  2592,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    -1,  2484,    -1,    -1,    -1,    -1,    -1,    30,    -1,
      32,    33,    -1,    -1,    -1,  2672,    -1,    -1,  5012,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5483,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    -1,
      -1,  4521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    -1,    74,    75,    -1,    -1,    -1,    -1,    -1,    81,
      -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4317,    -1,    -1,    95,    -1,    97,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5080,    -1,    -1,    -1,
      -1,    -1,   114,    -1,    -1,   117,  2578,    -1,    -1,    -1,
      -1,  4348,    -1,    -1,    -1,    -1,    -1,    -1,  2590,    -1,
     132,    -1,   134,  2595,    -1,    -1,   138,    -1,    -1,    -1,
      -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     152,    -1,   154,  4380,    -1,    -1,    -1,    -1,    -1,   161,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4644,    -1,    -1,    -1,  4415,    -1,
      -1,    -1,    -1,   195,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4432,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4682,    -1,    -1,    -1,  5200,    -1,    -1,    -1,
      -1,    -1,    -1,   235,   236,    -1,    -1,    -1,    -1,   241,
      -1,    -1,    -1,    -1,  4704,    -1,    -1,    -1,    -1,    -1,
      -1,   253,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2898,  2899,  2900,    -1,    -1,    -1,  2904,    -1,   271,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2931,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   307,    -1,    -1,    -1,    -1,
      -1,  4771,    -1,   315,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4549,  4550,  4551,  4552,    -1,   329,    -1,    -1,
      -1,    -1,    -1,   335,   336,    -1,   338,    -1,    -1,    -1,
      -1,   343,    -1,    -1,   346,    -1,    -1,   349,    -1,  5323,
     352,    -1,    -1,    -1,  5328,  5329,    -1,   359,    -1,    -1,
      -1,    -1,    -1,   365,   366,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,    -1,    -1,   377,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   387,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     402,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   433,  4892,    -1,    -1,    -1,    -1,   439,    -1,    -1,
      -1,    -1,   444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   457,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    -1,  5439,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   480,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   498,    -1,    -1,   501,
    3137,    -1,    -1,    -1,    -1,  3142,    -1,    -1,    -1,  5483,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      94,    -1,    -1,  3170,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3181,    -1,  3183,  3184,   112,    -1,
      -1,    -1,  5012,    -1,   118,    -1,    -1,  3194,    -1,    -1,
    3197,    -1,  3199,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   156,    -1,    -1,    -1,  3233,    -1,  3235,    -1,
    3237,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,
    5080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4885,    -1,
      -1,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4896,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3140,    -1,
      -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,  3325,    -1,
      -1,    -1,    -1,  3330,    -1,    -1,    -1,    -1,  3160,  3161,
      -1,  3163,    -1,    -1,    -1,    -1,  3168,  3169,  3345,  3171,
      -1,  3173,    -1,    -1,    -1,  3177,    -1,    -1,  3180,    -1,
      -1,    -1,   286,  3185,    -1,    -1,    -1,    -1,    -1,  3191,
      -1,    -1,    -1,    -1,  3196,    -1,    -1,    -1,    -1,    -1,
    5200,  3203,  3204,  3205,  3206,    -1,   310,    -1,  3210,  3211,
      -1,  3213,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,
     324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3230,    -1,
    3232,  3408,    -1,    -1,    -1,    -1,    -1,  3239,  3240,  3241,
    3242,  3243,  3244,  3245,  3246,  3247,  3248,   351,    -1,    -1,
     354,    -1,    -1,    -1,   358,    -1,   360,    -1,    -1,    -1,
      -1,    -1,    -1,   367,    -1,    -1,   370,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3283,    -1,    -1,    -1,   389,    -1,    -1,    -1,    -1,
      -1,    -1,   396,    -1,    -1,    -1,    -1,   401,   402,    -1,
      -1,   405,    -1,    -1,    -1,   409,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   419,    -1,    -1,    -1,    -1,
     424,    -1,    -1,  5323,    -1,    -1,    -1,    -1,  5328,  5329,
      -1,    -1,    -1,   437,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   450,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5153,    -1,    -1,    -1,
      -1,  5158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5177,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3423,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3657,    -1,    -1,  5483,    -1,    -1,  3663,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3743,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5406,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3661,
    3662,    -1,    -1,    -1,  3666,    -1,    -1,  5434,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3695,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3891,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3900,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3908,    -1,  3910,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3937,  3938,  3939,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3955,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3963,    -1,    -1,  3966,
      -1,  3968,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3978,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3986,
    3987,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3890,    -1,
      -1,  4068,    -1,    -1,  3896,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4084,    -1,    -1,
      -1,    -1,  3914,  3915,    -1,    -1,  3918,  3919,  3920,  3921,
      -1,    -1,  3924,  3925,  3926,  3927,  3928,  3929,  3930,  3931,
    3932,  3933,  3934,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3956,    -1,    -1,  3959,    -1,  3961,
      -1,    -1,  3964,  3965,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3980,  3981,
    3982,  3983,    -1,  3985,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4050,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4099,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4392,  4393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4403,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4479,    -1,    -1,    -1,    -1,    -1,  4310,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4518,  4519,    -1,    -1,    -1,    -1,    -1,  4525,  4526,
    4352,    -1,    -1,  4530,    -1,    -1,    -1,  4534,    -1,    -1,
    4537,  4538,    -1,    -1,    -1,  4542,    -1,    -1,    -1,    -1,
      -1,  4548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4588,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4599,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4626,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4469,    -1,    -1,
      -1,  4473,    -1,  4475,  4476,    -1,    -1,    -1,    -1,  4481,
    4482,  4483,  4484,    -1,    -1,    -1,  4488,  4489,  4490,  4491,
    4492,  4493,  4494,  4495,  4496,  4497,  4498,  4499,  4500,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4524,    -1,    -1,  4527,    -1,  4529,    -1,    -1,
    4532,    -1,    -1,  4535,  4536,    -1,    -1,  4539,  4540,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4727,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4598,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4611,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4797,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4941,    -1,    -1,    -1,    -1,    -1,
    4947,  4948,  4949,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4972,  4973,    -1,  4800,  4976,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5002,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5013,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5028,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4887,  4888,    -1,    -1,    -1,
      -1,    -1,    -1,  4895,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4937,    -1,    -1,    -1,    -1,
      -1,  4943,  4944,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4962,    -1,  4964,    -1,    -1,    -1,  4968,  4969,  4970,  4971,
      -1,    -1,  4974,  4975,    -1,    -1,    -1,  4979,    -1,    -1,
      -1,  4983,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4996,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5014,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5037,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5276,
    5102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5138,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5333,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5374,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5226,    -1,  5228,  5229,  5230,  5231,
    5232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5243,  5244,  5245,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5258,    -1,    -1,  5261,
      -1,    -1,    -1,  5265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5283,    -1,    -1,    -1,  5462,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5492,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5635,  5636,
    5637,  5463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5477,  5653,  5479,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5528,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5730,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5564,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5754,    -1,  5756,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5630,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5674,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5867,    -1,    -1,    -1,  5871,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5907,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5759,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5772,  5773,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5963,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5822,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5846,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5862,  5863,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,  5917,  5918,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,   133,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
      -1,    -1,    -1,    -1,    -1,    -1,   498,   499,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    -1,   480,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   498,   499,     3,    -1,     5,     6,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     498,   499,     3,    -1,     5,     6,    -1,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,     3,
      -1,     5,     6,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,   489,   490,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   498,   499,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    37,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,    -1,   273,
      -1,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,   293,
      -1,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,    -1,   403,
      -1,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,    -1,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   499,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,    -1,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,    -1,   268,    -1,   270,   271,   272,   273,
      -1,    -1,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,    -1,   312,    -1,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,    -1,   419,    -1,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   475,   476,   477,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,   499,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    -1,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,    -1,   231,   232,
     233,    -1,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,    -1,   268,    -1,   270,   271,   272,
     273,    -1,    -1,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,    -1,   312,
      -1,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,    -1,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,    -1,   419,    -1,    -1,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,    -1,   475,   476,   477,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,   499,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,    -1,   480,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,
      -1,    -1,     3,    -1,     5,     6,   498,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,   228,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
      -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    35,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    -1,    -1,    35,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,    -1,    -1,    -1,    -1,    -1,   496,   497,
     498,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,
      -1,    -1,     3,    -1,     5,     6,   498,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
      -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,   172,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,    -1,    -1,    -1,     3,    -1,     5,     6,
     498,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,   232,   233,    -1,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   489,   490,    -1,    -1,    -1,     3,    -1,     5,
       6,   498,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   489,   490,    -1,    -1,    -1,     3,    -1,
       5,     6,   498,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,    -1,    -1,    -1,     3,
      -1,     5,     6,   498,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   489,   490,    -1,    -1,    -1,
       3,    -1,     5,     6,   498,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,    -1,
      -1,     3,    -1,     5,     6,   498,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,
      -1,    -1,     3,    -1,     5,     6,   498,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
      -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,    -1,    -1,    -1,     3,    -1,     5,     6,
     498,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,    -1,    -1,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,   232,   233,    -1,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,    -1,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   489,   490,    -1,    -1,    -1,     3,    -1,     5,
       6,   498,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   489,   490,     3,    -1,     5,     6,    -1,
       8,     9,   498,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,     3,    -1,     5,     6,    -1,     8,     9,
     498,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,    -1,
      -1,    -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,   498,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,    -1,    -1,    -1,
      -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,   498,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   498,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,    -1,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,    -1,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,   285,   286,   287,   288,    -1,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,    -1,    -1,   480,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   498,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,   285,   286,   287,   288,    -1,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   498,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   498,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   498,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,   232,   233,    -1,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   498,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,    -1,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     498,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,   284,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,   491,    -1,    -1,    -1,    -1,    -1,    -1,   498,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,    -1,
     480,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   498,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   498,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
      -1,   273,    -1,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,    -1,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
     402,   403,    -1,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,    -1,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,    -1,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,    -1,   449,   450,   451,
     452,    -1,    -1,   455,    -1,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,    -1,   480,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   498,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    -1,    -1,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    -1,    99,   100,   101,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,    -1,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,    -1,   232,
      -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,    -1,
     273,    -1,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,    -1,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,    -1,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,    -1,
     403,    -1,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,    -1,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   498,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,    -1,   273,
      -1,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,   293,
      -1,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,    -1,   403,
      -1,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,    -1,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   498,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   498,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,     5,     6,    -1,    -1,    -1,    10,    11,    -1,    -1,
      -1,    -1,   498,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,    -1,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,   268,   269,   270,   271,   272,   273,
     274,    -1,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,   308,   309,   310,    -1,   312,    -1,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,    -1,   419,    -1,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   475,   476,   477,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,     3,    -1,     5,     6,    -1,    -1,    -1,    10,    11,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,    -1,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,   269,   270,   271,
     272,   273,   274,    -1,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,    -1,
     312,    -1,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,    -1,   419,    -1,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,    -1,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   475,   476,   477,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    -1,    -1,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,    -1,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,    -1,   163,   164,   165,   166,    -1,   168,   169,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,    -1,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,   251,    -1,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,   285,   286,   287,   288,   289,
      -1,   291,   292,   293,   294,    -1,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,   312,    -1,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,    -1,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,    -1,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,    -1,   448,   449,
     450,   451,   452,   453,    -1,   455,    -1,    -1,    -1,    -1,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,    -1,   476,   477,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,    -1,   273,    -1,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,    -1,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,    -1,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,    -1,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
      -1,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,    -1,   273,
      -1,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,   293,
      -1,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,    -1,   403,
      -1,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,    -1,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
      -1,   273,    -1,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,    -1,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,    -1,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,    -1,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,    -1,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,    -1,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    -1,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    80,    81,    82,    83,    84,    85,    -1,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,    -1,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,    -1,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,    -1,   273,    -1,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,    -1,   295,    -1,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
      -1,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,    -1,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,    -1,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
      -1,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     491,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   491,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     491,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,    -1,   268,    -1,   270,   271,   272,   273,    -1,    -1,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,    -1,   312,    -1,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,    -1,   419,    -1,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,    -1,   445,
     446,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,
     476,   477,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,   491,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    -1,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,    -1,   231,   232,
     233,    -1,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,    -1,    -1,   268,    -1,   270,   271,   272,
     273,    -1,    -1,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,    -1,   312,
      -1,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,    -1,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,    -1,   419,    -1,    -1,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,    -1,    -1,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,   475,   476,   477,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,   491,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
       5,     6,    -1,    -1,    -1,    -1,    11,    -1,    -1,   489,
     490,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    -1,   489,   490,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    11,    -1,    -1,   489,
     490,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,   284,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    11,    -1,    -1,   489,   490,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,   172,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
       5,     6,    -1,    -1,    -1,    -1,    11,    -1,    -1,   489,
     490,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
       5,     6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,   104,
     105,    -1,    -1,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,   104,
     105,    -1,    -1,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,   181,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,   104,
     105,    -1,    -1,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,   104,
     105,    -1,    -1,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,   104,
     105,    -1,    -1,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    -1,    79,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,   169,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,   178,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,   178,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,   169,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,   402,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
     285,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,   285,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,   285,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,   402,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    37,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    37,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    37,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,    -1,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
      -1,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,    -1,   268,    -1,
     270,   271,   272,   273,    -1,    -1,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,    -1,   312,    -1,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,    -1,   419,
      -1,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,    -1,   445,   446,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   476,   477,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    -1,
      99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,    -1,   184,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,    -1,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,    -1,
      -1,   220,    -1,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,    -1,   273,    -1,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,    -1,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,    -1,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,    -1,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,    -1,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,    -1,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,    -1,   268,    -1,   270,   271,   272,   273,
     274,    -1,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,    -1,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,    -1,   312,    -1,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,    -1,   419,    -1,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,   441,   442,   443,
      -1,   445,    -1,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   475,   476,   477,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    -1,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,    -1,   231,   232,
     233,    -1,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,    -1,    -1,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
      -1,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,    -1,   312,
      -1,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,    -1,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,    -1,   419,    -1,    -1,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,   441,   442,
     443,    -1,   445,    -1,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   475,   476,   477,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,    -1,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,    -1,   268,    -1,   270,   271,
     272,   273,    -1,    -1,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,    -1,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,    -1,
     312,    -1,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,    -1,   419,    -1,    -1,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,    -1,    -1,   439,   440,   441,
     442,   443,    -1,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   475,   476,   477,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,    -1,    -1,   160,
      -1,   162,   163,   164,   165,   166,   167,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,    -1,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,    -1,    -1,   268,    -1,   270,
     271,   272,   273,    -1,    -1,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,    -1,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
      -1,   312,    -1,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,    -1,   419,    -1,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,    -1,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   475,   476,   477,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
      -1,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,    -1,   268,    -1,
     270,   271,   272,   273,    -1,    -1,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,    -1,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,    -1,   312,    -1,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,    -1,   419,
      -1,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,    -1,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   476,   477,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    -1,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,    -1,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,    -1,   231,   232,   233,    -1,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,    -1,    -1,   268,
      -1,   270,   271,   272,   273,    -1,    -1,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,    -1,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,    -1,   312,    -1,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,    -1,
     419,    -1,    -1,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,
     439,   440,   441,   442,   443,    -1,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   475,   476,   477,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,    -1,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,    -1,
     268,    -1,   270,   271,   272,   273,    -1,    -1,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,    -1,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,    -1,   312,    -1,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
      -1,   419,    -1,    -1,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,    -1,
      -1,   439,   440,   441,   442,   443,    -1,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,   476,   477,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    -1,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    -1,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,
      -1,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,    -1,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,   236,
     237,    -1,    -1,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,    -1,
      -1,   268,    -1,   270,   271,   272,   273,    -1,    -1,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,    -1,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,    -1,   312,    -1,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,    -1,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,    -1,   419,    -1,    -1,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
      -1,    -1,   439,   440,   441,   442,   443,    -1,   445,    -1,
     447,   448,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,   476,
     477,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,    -1,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
      -1,    -1,   268,    -1,   270,   271,   272,   273,    -1,    -1,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,    -1,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,    -1,   312,    -1,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,    -1,   419,    -1,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,    -1,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,
     476,   477,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    -1,    53,    -1,
      -1,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    -1,    -1,    70,    -1,    72,    73,    74,
      75,    -1,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
      -1,    -1,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,    -1,    -1,   160,    -1,   162,   163,   164,
      -1,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,    -1,    -1,    -1,
      -1,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,    -1,   257,    -1,   259,   260,   261,   262,   263,   264,
     265,    -1,    -1,   268,    -1,   270,   271,   272,   273,    -1,
      -1,   276,    -1,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,    -1,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,    -1,   312,    -1,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,    -1,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
      -1,   376,   377,   378,   379,   380,    -1,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,    -1,    -1,    -1,
      -1,   416,   417,    -1,   419,    -1,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,    -1,
      -1,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     475,   476,   477
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    30,    32,    33,    50,    60,    72,    74,    75,
      81,    83,    95,    97,   114,   117,   132,   134,   138,   144,
     152,   154,   161,   178,   195,   235,   236,   241,   253,   271,
     307,   315,   329,   335,   336,   338,   343,   349,   352,   359,
     365,   366,   373,   377,   387,   402,   422,   433,   439,   444,
     457,   480,   481,   482,   483,   484,   485,   498,   505,   506,
     507,   508,   509,   510,   516,   517,   519,   520,   521,   522,
     524,   528,   540,   545,   546,   549,   550,   551,   570,   573,
     574,   589,   635,   638,   639,   642,   645,   646,   647,   655,
     662,   664,   665,   668,   671,   672,   676,   685,   689,   690,
     691,   694,   696,   697,   698,   699,   707,   709,   729,   733,
     735,   736,   746,   748,   755,   756,   759,   760,   761,   762,
     763,   772,   774,   776,   779,   783,   784,   792,   793,   796,
     801,   815,   847,   850,   851,   852,   857,   860,   862,   864,
     866,   867,   870,   871,   874,   876,   877,   881,   882,   883,
     886,   887,   888,   889,   890,   897,   899,   900,   901,   902,
     908,   910,   911,   917,   918,   919,   922,   923,   924,   925,
     927,   928,   930,   931,   933,   934,   936,   948,   950,   953,
     955,   956,   965,   967,   972,   977,   981,   982,   983,   984,
     985,   986,   992,  1028,   416,   460,   903,    27,    78,    94,
     112,   118,   136,   147,   156,   169,   174,   181,   200,   225,
     246,   286,   310,   320,   321,   324,   351,   354,   358,   360,
     367,   370,   389,   396,   401,   402,   405,   409,   419,   424,
     437,   450,   661,   903,     3,    20,    21,    22,    23,    24,
      25,    26,    27,    29,    30,    31,    39,    40,    41,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    57,    58,    59,    60,    61,    62,    63,    66,
      67,    68,    69,    70,    72,    73,    74,    75,    76,    78,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      91,    92,    93,    94,    95,    96,    98,    99,   100,   101,
     105,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     119,   121,   122,   123,   124,   125,   126,   127,   129,   130,
     131,   132,   135,   136,   137,   138,   139,   141,   142,   143,
     145,   146,   147,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   160,   162,   163,   164,   165,   166,   168,
     170,   171,   173,   174,   175,   176,   177,   179,   180,   182,
     183,   184,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   197,   198,   199,   200,   201,   202,   203,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   215,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   229,
     230,   231,   232,   233,   235,   236,   237,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   270,   271,   272,   273,
     275,   276,   277,   278,   279,   280,   282,   283,   286,   287,
     288,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   309,   310,   311,
     312,   313,   314,   315,   316,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   367,   368,   369,   370,   371,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   400,   401,   403,   404,   405,   406,   407,   408,   409,
     411,   412,   413,   416,   417,   418,   419,   420,   422,   423,
     424,   425,   426,   427,   428,   429,   432,   433,   434,   435,
     436,   439,   440,   441,   442,   443,   444,   445,   447,   448,
     449,   450,   451,   452,   455,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,  1088,  1158,  1170,  1171,  1175,
    1176,  1177,     3,    28,   978,  1155,  1170,  1175,   448,   498,
     941,   284,   316,   903,    53,   498,   581,    22,    40,    65,
      78,   112,   118,   136,   147,   156,   169,   177,   181,   237,
     286,   289,   310,   324,   351,   360,   370,   389,   396,   405,
     406,   408,   409,   424,   431,   434,   437,   590,   644,   751,
     802,   816,    28,   315,  1155,   978,    28,   309,   368,   406,
     408,     6,   224,   858,   859,  1161,    22,    27,    65,    78,
      94,   112,   136,   147,   156,   169,   174,   181,   200,   246,
     286,   299,   310,   321,   324,   351,   354,   358,   360,   367,
     370,   389,   396,   402,   405,   409,   417,   419,   424,   437,
     450,   661,   764,   766,   767,   903,  1155,    97,   448,   498,
     639,   642,   645,   936,   949,   953,   956,   965,   972,   977,
     981,    11,    21,    28,    48,   164,   170,   172,   196,   226,
     260,   318,   337,   489,   490,   780,   781,   978,  1160,  1162,
      28,    97,   333,   366,   785,   786,   787,  1170,   169,  1170,
    1157,  1161,   402,   995,   780,  1170,   343,   373,   377,   416,
    1155,   299,   246,   112,   200,   360,   401,   402,   498,   868,
     869,   359,  1170,    28,   371,   412,   416,   532,   541,   542,
    1170,    25,   178,   785,   786,   316,   903,  1170,   223,    28,
     133,   997,   998,    66,    91,   237,   255,   351,   360,   371,
     412,   416,   463,   529,   530,   531,   532,    28,   371,   412,
     416,   532,   416,   285,  1040,  1153,  1170,   995,   491,  1170,
     173,   498,   942,   498,   331,   987,   988,  1155,   987,     3,
      52,    54,    55,    68,    69,   115,   116,   137,   165,   212,
     213,   215,   256,   258,   277,   328,   375,   381,   412,   413,
     445,  1062,  1064,  1066,  1068,  1070,  1072,  1073,  1074,  1076,
    1077,  1078,  1080,  1081,  1171,  1175,   997,   998,   999,  1166,
      12,  1167,  1168,  1170,  1167,  1167,   982,   983,   986,     0,
     501,   498,   941,   148,   214,   290,   430,  1000,  1001,   982,
     984,   985,   123,   210,   436,   502,    34,   907,   832,  1158,
     769,  1170,   769,  1155,   319,   769,   419,  1155,   111,   402,
     820,  1158,  1170,  1177,     3,   104,   108,   372,  1163,  1164,
    1172,  1175,  1176,  1177,    28,   190,  1153,   278,   450,    10,
      17,    18,    19,    73,   160,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   854,   856,  1118,  1119,  1170,   190,
    1155,   820,  1155,    28,  1163,  1164,   820,  1155,  1155,   190,
    1153,  1155,   190,   769,  1155,   343,   373,    28,   190,  1040,
    1155,   363,  1155,   769,    28,   244,  1163,  1164,   190,  1153,
     224,   120,   220,   269,   327,   904,   905,   906,   498,   496,
     500,  1144,  1146,   935,   936,   937,   938,  1172,  1153,  1155,
    1170,    27,    65,    79,    90,   112,   136,   174,   200,   225,
     286,   321,   351,   354,   396,   405,   417,   424,   764,   765,
     766,   767,  1161,   907,   952,   956,   965,   972,   981,  1153,
     248,   769,   498,   190,   769,  1155,   769,   419,   190,  1155,
     111,   402,   406,   408,  1163,  1164,   406,   408,    73,   160,
     854,   341,  1155,  1155,  1163,   190,   525,  1170,   190,  1155,
     190,   769,  1155,  1155,   363,   769,   244,  1163,   331,   367,
     402,   450,   246,    94,   200,    27,    90,   174,   321,   358,
     417,   419,   423,   656,    28,  1155,   979,   539,  1161,  1172,
     859,   248,   190,   832,   833,   190,   863,   190,  1155,   190,
     771,  1062,   419,   111,   402,   190,   819,   820,   190,  1164,
    1165,    86,   450,    73,   160,   190,   855,   856,    58,   190,
     819,   190,  1165,   190,   819,   190,  1155,   190,  1155,   363,
     863,   190,   771,   190,   244,  1165,   224,   190,   768,   769,
     190,  1154,  1155,   190,  1155,   907,   498,   954,   590,   949,
     444,   935,   941,  1162,   781,   782,    28,   782,  1162,   782,
      28,   782,  1162,   782,   782,   782,  1162,  1160,  1160,   978,
     782,   319,   498,   498,   612,   612,   612,   284,   414,   502,
     612,   360,  1040,  1041,   502,   898,   542,   530,   532,    28,
     532,  1161,   498,   951,    58,   450,   935,    86,   803,   803,
    1170,    47,   477,   220,   500,   287,   287,   284,   172,  1161,
     414,   907,   167,   777,   284,     5,     8,     9,    10,    12,
      36,    52,    54,    55,    64,    65,    68,    69,    76,    78,
     102,   103,   104,   105,   106,   107,   108,   115,   116,   118,
     153,   158,   159,   165,   180,   182,   212,   213,   215,   230,
     238,   239,   256,   258,   267,   269,   274,   275,   277,   286,
     297,   311,   328,   356,   372,   381,   397,   412,   413,   418,
     420,   421,   431,   437,   445,   465,   466,   467,   468,   470,
     471,   472,   473,   478,   489,   490,   491,   498,   982,  1065,
    1068,  1071,  1072,  1073,  1075,  1076,  1077,  1080,  1081,  1085,
    1087,  1088,  1089,  1091,  1114,  1115,  1116,  1120,  1138,  1143,
    1150,  1151,  1158,  1159,  1160,  1161,  1170,  1149,  1150,  1161,
      28,   547,  1152,  1153,   371,   529,   118,   538,  1161,   539,
    1161,    47,    70,   529,   477,   382,   905,   287,   172,   414,
     488,    47,   477,   220,   906,   498,  1153,   491,  1146,  1041,
     935,   171,   943,  1085,  1123,   987,   502,   498,   944,   447,
    1079,  1079,  1079,   498,  1067,  1067,   313,   498,  1069,    68,
      69,  1079,  1067,  1064,   459,   480,   498,  1082,   498,  1082,
      36,  1063,   498,   113,   188,   249,   252,   364,   475,   498,
    1083,  1084,   500,   770,  1067,  1149,  1147,   499,   499,   507,
     935,   945,   946,   947,  1153,    28,   133,   996,   996,    58,
     996,   161,   167,   234,   281,  1004,  1006,  1007,  1022,  1024,
    1025,  1026,  1000,  1001,   172,   216,  1040,  1042,   498,    67,
     265,   300,   339,   373,   498,   830,   300,   335,   339,   373,
     770,   300,   339,   373,     3,    89,   142,   240,   300,   307,
     339,   373,   405,   407,   457,   540,   543,   912,   913,   914,
     915,   797,    24,   138,   300,   339,   373,   441,   556,  1155,
      24,   138,   373,   436,   523,   461,   190,  1040,    61,    96,
     157,   193,   229,   265,   269,   300,   301,   339,   348,   357,
     365,   373,   385,   394,   398,   452,   540,   544,   836,   848,
     875,   498,   817,  1146,   339,   523,   196,   153,    24,    30,
      45,    75,   131,   138,   141,   168,   202,   265,   269,   279,
     288,   300,   339,   342,   343,   373,   441,   552,   554,   555,
     679,   875,     5,   489,   490,   653,  1162,    28,   190,  1153,
     769,   769,   498,   853,   300,   373,   500,   153,   284,   300,
     339,   373,   848,   875,    24,   138,   300,   339,   373,   196,
     518,   339,   457,   480,   511,   518,   300,   339,   373,   848,
     875,   284,   300,   339,   153,    37,    59,   110,   199,   247,
     250,   265,   299,   339,   344,   367,   373,   387,   552,   650,
     651,   300,   339,   449,   679,   687,   153,   300,   339,   373,
      24,    89,   131,   138,   141,   300,   335,   339,   373,   542,
     530,   196,   153,    45,   129,   265,   339,   373,   552,   553,
     300,   339,   343,   373,    87,   130,   302,   407,   284,    24,
      30,   138,   300,   339,   373,   571,   572,   518,   167,   339,
     511,   518,   153,   339,   373,   552,  1155,   232,   120,   285,
     462,   502,   904,    28,   133,   446,   491,   499,   825,  1085,
    1124,  1125,  1171,  1085,  1145,     3,    28,    32,    33,    34,
      35,    36,    37,    38,    42,    56,    64,    65,    71,    77,
      79,    90,    97,   102,   103,   104,   106,   107,   108,   118,
     120,   128,   133,   134,   140,   144,   148,   159,   161,   167,
     169,   172,   178,   181,   185,   196,   204,   214,   216,   227,
     228,   234,   238,   239,   269,   274,   281,   284,   285,   289,
     290,   308,   317,   333,   347,   366,   372,   383,   399,   402,
     410,   414,   415,   421,   430,   431,   437,   438,   446,   453,
     454,   456,   457,   491,  1156,  1173,  1175,  1176,  1177,  1178,
    1144,   499,   502,   159,   284,   421,   536,   539,   653,   939,
     438,   932,   284,   832,   498,   769,  1155,  1062,   820,   278,
      73,   160,   856,   820,   820,   167,  1062,   769,  1155,  1155,
     499,   612,  1155,    71,  1062,   269,   172,   498,   737,   511,
      37,   926,  1155,   269,   511,   461,   190,  1153,   511,   769,
     769,   737,   434,   590,   284,   167,   884,   885,   511,   269,
      47,   526,   269,   424,   686,   269,   944,    89,   300,   663,
      87,   130,   302,   407,    37,   737,   167,   190,   511,   450,
     190,  1153,   190,   640,  1153,  1153,   450,   769,   803,  1158,
     419,  1158,  1158,  1155,   167,  1155,   661,    39,    53,   109,
     209,   265,   362,   153,    62,   345,   502,   557,   153,   498,
     153,   511,   153,   502,   557,   461,   153,   502,   557,   153,
     502,   190,   768,   190,   769,   190,   769,   153,   502,   557,
    1165,   153,   557,   153,   153,   557,   153,   557,   153,    87,
     130,   302,   407,   167,   153,   557,   153,   167,   190,   153,
     502,   557,   153,   502,   557,   153,   284,  1123,   402,   499,
     949,   782,   978,   782,   978,   782,   978,   782,   978,   782,
     978,   978,   978,   782,   978,   498,   613,   614,  1170,   613,
      28,   112,   136,   169,   174,   224,   225,   321,   354,   360,
     367,   402,   405,   424,   788,  1152,  1165,   787,  1155,   196,
     502,   968,  1161,  1062,  1127,    37,  1165,   803,   499,  1153,
    1155,   232,  1170,   167,   167,   788,  1165,   359,  1170,   539,
     284,   498,  1147,   496,   982,  1128,  1085,  1142,   498,   498,
     167,   498,   498,   982,   498,   498,   498,   498,   498,   498,
     498,  1085,   498,   498,   498,   498,   498,   498,   498,   498,
     982,   498,   498,   498,   498,   498,   498,   498,   498,  1085,
    1085,  1085,   982,  1085,  1123,  1146,  1161,   498,  1161,     3,
      10,    13,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     163,   164,   165,   166,   168,   169,   170,   171,   173,   174,
     175,   176,   177,   179,   180,   182,   183,   184,   186,   187,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   215,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   250,   251,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   282,   283,   285,
     286,   287,   288,   289,   291,   292,   293,   294,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   308,   309,
     310,   311,   312,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   448,   449,   450,   451,   452,   453,   455,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   476,   477,   478,   486,   487,   488,
     489,   490,   491,   492,   493,   494,  1118,  1120,  1122,  1174,
    1179,   458,  1101,   296,  1085,   216,   502,   993,   498,  1161,
    1146,   993,   121,   192,   548,   502,    70,   118,   539,    37,
       3,   118,   237,   537,   653,  1081,  1161,  1161,    92,   135,
    1097,   101,   118,   533,   534,   536,   653,   118,   533,   232,
    1153,    93,   344,   773,   499,   941,    34,    44,    51,    77,
     191,   196,   218,   233,   286,   289,   378,   499,   502,   988,
    1154,    37,   498,  1123,  1160,  1079,  1079,    36,  1063,   412,
     412,  1160,  1160,   496,   496,  1160,   414,   414,   414,   498,
     414,  1160,  1156,   500,  1067,   172,  1029,    15,   488,  1144,
    1169,   499,   502,   944,   984,   984,  1002,  1003,  1085,   984,
     164,   260,  1013,   222,   265,   327,   376,   436,    28,  1008,
    1085,   489,   490,  1009,  1010,  1085,  1087,  1022,  1023,  1007,
    1006,  1004,  1005,   167,  1025,   279,  1027,  1004,  1022,  1042,
     957,  1153,    37,  1170,   373,  1123,    67,   414,   414,   360,
     196,   207,   290,   293,   375,   446,   491,   823,   824,   825,
     827,   829,   831,  1062,  1171,   414,   449,   414,   360,   414,
     414,   360,   234,   414,   414,   405,   529,   300,   912,   914,
     488,   916,   167,   178,   196,   349,   798,   799,    71,    90,
     149,   169,   317,   431,   609,   610,    90,   118,   269,   414,
      90,   414,   118,   269,   360,    90,   131,   141,   300,   339,
     734,   360,   669,    27,    65,   136,   174,   286,   321,   354,
     417,   424,   764,   765,  1155,   153,   339,   373,   552,   284,
     653,   365,   229,   414,  1170,   414,   274,   653,   122,   217,
     360,   371,   416,   531,   769,   345,   373,   836,   849,   126,
     499,   818,   823,   414,   437,   405,  1153,    79,   149,   190,
     597,   609,  1170,    79,    90,   872,   304,   284,   356,   358,
     419,    90,   872,    31,   342,   356,   358,   419,   356,  1153,
     168,   202,   279,   769,   498,   414,   414,   189,   498,   561,
     243,   405,   434,   459,   561,    90,   502,   126,     5,     5,
     300,   196,   153,   339,   373,   552,   875,   438,   438,   266,
    1062,   414,   360,   498,   854,  1155,  1153,   414,   414,   360,
     849,   126,   402,   402,   414,   414,   402,   737,   112,   373,
     543,   414,   513,   543,   414,   414,   360,   849,   126,  1153,
     414,   414,  1153,  1064,   653,    58,   652,   653,   653,   110,
     247,   250,    58,   414,   511,   254,   360,   511,   265,   651,
     414,   414,   274,  1161,   679,   769,   414,   414,   360,   389,
     324,  1161,   324,   414,   324,   414,   324,   737,   405,  1040,
     304,   304,    90,   414,   872,   360,   414,   414,   561,   561,
     769,   769,   769,   769,  1153,    46,   443,    46,    46,   414,
      46,   414,   443,   360,   498,   502,   543,   437,   695,  1164,
     414,   513,   543,  1153,   414,   872,   360,   300,   339,   327,
     340,   369,   535,   904,  1124,  1124,  1125,   499,    15,    16,
     502,  1000,  1001,   497,   503,  1153,   937,  1155,  1153,   218,
    1062,   218,   284,   218,   218,   653,   769,   769,   218,   218,
     218,  1062,   218,   218,   218,   284,   414,   172,   414,   575,
     424,   498,    37,   153,   769,   738,   739,  1173,   912,  1062,
     284,   153,   666,  1155,   269,   304,   498,   512,   751,   438,
     331,   450,  1153,    28,   402,   457,   844,   512,   153,  1164,
      97,   178,   527,   589,   646,   709,   783,   801,   908,   153,
    1161,   687,   688,   153,   284,  1161,  1164,   240,   769,   769,
     769,   769,   145,   326,   498,   695,   269,   512,  1153,   269,
     648,   650,   269,    37,   279,   304,   498,   612,   612,   190,
     643,  1153,   167,   190,   804,  1155,   498,   741,   830,  1155,
     498,   821,   821,    37,  1062,    26,    49,   211,   710,   224,
     457,   459,   980,   362,   833,   832,  1062,  1155,   498,   771,
    1062,   819,   820,  1165,  1164,   153,   557,   153,   438,   153,
     438,   855,   856,   557,   819,  1165,   819,  1155,  1155,  1062,
     771,  1165,   695,   153,   768,   769,  1154,  1155,  1155,   769,
     499,   190,  1153,   949,   978,   978,   978,   978,   978,   978,
     613,   499,   502,   499,   175,   322,   355,   368,   403,  1154,
     768,   111,   370,   819,  1154,   278,   819,   819,  1154,  1152,
    1152,  1154,   768,   414,   457,   794,   148,   234,   692,   693,
      22,   151,   356,   376,   969,  1040,   273,   970,   499,   502,
     952,   414,  1153,   868,   869,   786,   785,   786,   172,   179,
     795,  1170,    27,    79,   136,   174,   225,   321,   354,   424,
     764,   765,  1123,   497,  1123,  1128,  1129,   453,  1139,  1140,
    1085,  1123,   498,  1160,  1160,     3,   113,   188,   249,   252,
     364,   475,  1130,  1131,  1161,  1123,  1123,  1123,  1160,  1160,
    1085,  1085,   854,  1085,  1124,  1126,  1133,   356,   489,   490,
     498,  1086,  1087,  1120,  1134,   499,  1123,  1085,  1126,  1135,
    1085,    56,   172,   228,   415,  1085,  1123,  1136,  1123,   254,
    1087,  1085,  1095,  1096,  1097,   254,  1085,  1097,   499,   502,
    1160,  1083,  1062,  1085,  1085,  1085,  1085,  1173,   412,    42,
     399,  1148,   769,  1085,   498,   982,  1137,   133,   135,   159,
     261,   262,   263,   264,   268,   269,   274,   421,   432,  1132,
    1085,   498,  1085,   414,    51,   191,   196,   233,   378,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,    28,
      35,   383,  1117,   181,   162,  1102,   356,   498,  1114,   177,
     237,   402,   406,   408,   434,   994,  1153,  1151,  1029,  1124,
    1029,  1153,   416,   498,  1161,   502,   499,   189,   189,   557,
     947,   936,   940,  1085,   499,   246,   269,   989,  1123,   499,
     499,   496,   477,   477,   499,   499,  1160,   497,  1160,   499,
     188,   249,  1084,   249,  1084,  1084,  1160,   252,   499,  1156,
     227,   357,   474,   498,   982,  1030,  1031,  1032,  1040,  1045,
    1055,  1088,  1090,  1091,  1170,   454,  1050,  1166,   947,   945,
     502,    38,   128,   438,   813,   356,   357,   489,   490,  1010,
    1012,  1087,   376,   222,   285,   502,     5,  1011,  1160,  1011,
     356,   357,  1012,  1152,   273,   380,   971,  1023,  1005,   438,
     966,   118,   298,   498,   958,   981,    37,  1170,   498,   973,
     974,   975,  1170,   499,  1164,  1155,  1155,   293,    58,  1171,
     499,   825,   827,   824,   827,  1171,   290,   499,   502,   770,
    1164,  1155,  1155,  1164,  1155,  1155,  1164,  1155,  1155,   118,
     536,  1162,   351,   437,   785,   360,   178,   785,   498,  1155,
     438,   805,   222,   222,   438,   498,   634,   190,  1155,   274,
    1164,  1155,  1155,  1085,   274,  1155,  1155,    31,   342,   414,
     414,  1155,   414,   670,   832,   498,  1062,   820,    73,   160,
     856,   820,   820,   167,  1062,   769,  1155,   184,   265,   300,
     339,   442,   673,   674,   675,  1040,   414,   872,   360,   274,
     122,   217,  1164,  1155,   284,  1155,   284,   499,   502,  1163,
    1165,  1155,   339,   552,   190,   597,   269,  1062,  1155,  1160,
    1170,  1153,  1155,   232,  1155,    28,   437,  1155,   190,  1155,
     190,  1170,   358,   419,   358,   419,   232,  1155,    28,   437,
    1155,   232,   356,  1153,    24,   138,   373,   680,   681,   682,
     683,  1173,  1164,  1155,   118,   173,   270,   438,   560,   563,
     564,  1173,  1155,    75,   282,  1155,   555,   284,   414,   405,
    1153,   414,   872,   360,   126,  1155,  1155,   502,   499,   502,
    1164,  1155,   878,   879,  1173,   284,   339,   414,   703,  1164,
    1155,  1155,   284,  1041,  1041,  1164,  1155,  1041,  1155,  1163,
       3,    89,   143,   202,   306,   429,   437,   440,   514,  1164,
    1155,  1155,   284,   339,  1164,  1155,   339,   373,   552,   650,
     653,   769,  1155,   653,   769,  1155,   653,  1164,  1155,   373,
    1164,  1155,  1155,  1162,  1154,  1154,  1164,   844,  1155,  1154,
    1155,   339,   373,   552,   553,  1153,  1153,  1155,  1155,  1155,
    1155,  1164,  1155,    24,    30,   138,   300,   339,   373,   300,
     339,   373,   737,   339,   373,   339,   373,   339,   875,  1054,
    1170,   190,   747,  1170,   190,  1170,  1164,  1155,  1155,  1161,
    1155,   878,    24,   572,   370,  1163,   339,   373,   552,  1155,
    1155,  1155,   414,   414,    84,   428,   327,   502,  1000,  1000,
    1000,  1085,  1085,   446,  1125,   499,  1085,  1145,   932,   274,
     775,  1161,    37,   775,   136,   769,   775,   775,   218,   438,
     438,   775,   775,   775,   224,   775,   775,   775,   769,   323,
     576,   576,   200,   402,   708,  1085,  1062,   769,   499,   502,
     488,   601,  1173,  1155,    62,   172,   360,   449,   667,   674,
     675,   153,   279,   233,   591,   593,   595,   597,   606,   609,
      25,   196,   351,   400,   514,   515,   167,  1155,   450,  1153,
      37,   704,   403,  1041,   737,   525,  1170,   526,   590,   816,
    1155,   169,   769,   498,   636,   637,  1090,  1170,   324,  1161,
     737,   737,   737,   737,   498,   737,  1052,  1053,  1054,   370,
     153,   498,   153,   153,   152,   981,   769,   279,   591,  1170,
     438,   629,   457,   562,   269,    37,   612,  1161,   269,   284,
       3,   742,   743,   737,    26,   499,   822,   823,   828,    37,
     224,   348,   417,   456,   834,   835,   836,   837,   834,   284,
     224,   279,   123,   210,   422,   436,   711,   712,  1155,   187,
     187,   167,   557,    37,   511,   168,   920,   921,   557,   557,
     768,   769,  1155,   769,  1155,   557,   557,   557,   557,   224,
     557,   370,   167,   557,   557,   284,   557,   269,   499,   614,
     196,   196,   196,   196,   196,   461,  1154,   653,   654,   181,
     789,   790,  1164,    25,   795,   414,   498,   172,   151,   376,
     151,   376,   356,   436,   251,  1062,  1164,   457,   641,   803,
     803,   172,   284,   789,    58,   557,   832,   769,  1062,   820,
     278,   820,   820,  1062,   769,  1155,   499,   497,   497,   502,
    1085,   140,  1140,  1141,    37,   499,  1085,   499,   499,   499,
     172,   499,   499,   499,   499,   499,   499,   502,   502,   499,
     308,   499,   499,   498,  1086,  1086,  1123,    13,    17,    18,
      19,   196,   218,   286,   486,   487,   488,   489,   490,   491,
     492,   493,   494,  1120,  1086,   499,   499,   167,   172,   378,
     499,   499,    37,  1136,  1123,  1136,  1136,   172,   499,   499,
    1173,   305,  1099,    37,   499,   502,  1085,  1173,   502,  1085,
    1147,  1085,   499,   477,  1086,  1086,   146,  1123,   172,   133,
     135,   159,   268,   274,   421,   432,  1132,   268,   146,   854,
    1085,   399,  1148,  1085,  1137,  1085,   414,   498,   982,   498,
     498,   295,  1106,   498,  1123,   406,   408,   406,   408,  1153,
     995,   995,   995,  1050,  1000,  1050,   905,  1160,  1083,   534,
     947,   246,   498,   499,  1160,  1082,  1082,   497,   497,   499,
     982,  1045,  1055,   172,   498,   982,  1031,  1032,    37,  1033,
    1034,  1170,   502,    98,   173,   206,   221,   231,   257,   350,
    1037,  1034,    37,  1033,  1036,  1170,  1034,   480,  1049,  1146,
    1085,   181,  1014,  1003,   286,  1118,  1121,   479,   814,     5,
    1160,  1012,   285,   457,   436,  1009,   242,  1030,   454,  1051,
     444,   401,   437,   959,   960,   961,  1170,   284,   962,  1170,
     975,   976,   502,  1029,   488,  1147,   831,   770,   827,   827,
      58,   829,   493,  1165,  1165,   284,  1154,   287,   284,  1085,
     610,  1155,   498,   498,   498,   634,   200,   613,   727,   153,
     557,   414,  1164,  1155,   539,  1062,   769,   769,  1062,   657,
    1155,   184,   442,   414,   414,   657,   673,   679,   339,   373,
     552,  1155,  1155,  1155,   208,   274,   156,   823,   299,   373,
     414,   269,   153,    85,   599,   600,   727,   373,    24,   138,
     343,   344,   373,   556,   565,   566,   679,   873,   365,   153,
     557,   153,   557,  1155,  1155,  1155,  1155,   365,   365,   232,
     682,   683,   682,   499,   502,   684,  1161,   200,   499,   502,
     488,   500,   156,  1164,  1155,   339,   373,   552,  1155,  1155,
    1155,   284,   300,   339,   373,    24,   138,   300,   339,   373,
    1062,   266,  1062,   499,   502,   488,  1153,   414,  1165,   438,
     700,   156,   234,   306,   274,  1161,   306,  1165,   435,   156,
     414,   414,   360,   389,   844,   844,   844,   299,   373,    90,
     414,   872,   360,   118,   167,   567,   163,   803,   414,   414,
     244,   244,   244,   414,   414,   360,   414,   414,   360,   414,
     360,   414,   360,   414,   126,   557,  1062,   269,  1161,   373,
     873,   153,   557,   414,   414,   499,  1155,   414,   872,   360,
     414,  1164,  1155,   499,   499,   499,  1125,   497,  1062,   769,
     218,   775,  1155,  1155,  1155,   218,   390,   391,   577,  1161,
     577,   184,   499,   499,   172,   737,   739,   266,   286,   489,
     490,   653,   740,   827,  1121,  1161,  1178,    71,    77,    90,
     118,   120,   176,   204,   269,   274,   317,   333,   431,   602,
     603,   605,   152,   453,   511,   539,  1155,   539,   288,   677,
    1153,  1153,  1153,   499,   502,  1165,   181,   351,  1165,  1160,
     424,  1153,   612,     3,   167,   705,    47,   526,   402,   686,
     111,   944,  1085,   172,   502,  1154,   562,   744,   745,  1161,
     499,   502,  1155,   167,   613,  1153,   640,  1153,  1155,   641,
     498,   592,  1153,   499,  1155,   457,   459,   630,   561,    37,
     153,   981,   629,   414,   153,  1040,   488,   499,   502,   711,
     499,   502,   118,   488,   838,  1161,   539,   402,   826,   827,
     167,   843,    50,   346,   839,   840,   837,   840,   123,   210,
     366,   436,   895,  1155,   279,   284,   289,   184,   981,  1062,
     498,   499,   502,   557,   438,   557,   438,   557,  1155,  1155,
     695,   769,   153,   360,   360,   360,   360,   360,  1154,   502,
    1164,   457,   502,   791,   287,  1041,   370,   151,   151,   111,
     265,  1153,  1155,  1165,   788,   795,  1164,   218,   218,   218,
     218,   653,   218,   218,   218,   218,   218,  1128,   410,  1085,
     144,  1062,   499,  1085,  1132,  1085,  1085,   499,  1123,   502,
    1062,  1086,  1086,  1086,  1086,   133,   135,   269,  1086,  1086,
    1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1085,  1085,
    1085,  1062,   499,   499,   499,  1123,   499,   502,    58,  1087,
    1100,   499,  1173,  1096,   314,   395,  1098,   499,   502,   449,
    1092,    37,   499,  1161,  1085,    34,    34,  1085,   499,  1085,
     172,   268,  1085,   499,   146,  1086,  1086,   146,   146,  1085,
    1085,  1001,   454,   498,  1107,  1170,   499,  1123,   502,   995,
     995,   995,   995,  1153,  1153,  1153,  1014,   499,  1014,   499,
     952,   497,  1034,  1036,  1034,   498,   469,  1087,   499,  1170,
     498,  1031,   221,   294,  1038,  1031,  1038,   221,  1037,  1038,
     221,   404,  1043,   498,  1170,   498,   291,    58,   185,  1021,
     498,   814,   164,   226,   285,   457,   411,   101,  1085,   347,
     964,   443,   499,   502,  1147,    88,   964,   499,   502,   974,
    1051,  1085,   499,   493,   831,   424,   175,   355,   361,   368,
     403,   425,   800,   167,   800,   499,   498,   617,   618,   808,
    1090,  1170,   613,   613,   727,  1155,   499,   120,   204,   265,
     269,   728,  1155,  1155,    37,   438,   438,   224,   770,  1164,
    1155,   414,   872,   360,   414,   208,  1155,    58,   405,  1155,
     153,   597,   118,  1170,   677,   389,   176,   155,   189,   269,
     561,   511,   111,   176,   269,   389,   392,   561,   599,   651,
     373,   566,   424,  1155,  1170,   365,   681,  1155,   564,   740,
    1173,  1155,   299,   373,   414,   872,   360,   414,   156,   414,
     414,   360,   174,   286,   392,   749,   750,   174,   286,   757,
     758,   414,   414,   360,   499,   499,   499,   879,   266,   653,
     827,   880,  1121,  1161,  1178,   339,  1155,   498,   457,   701,
    1155,  1162,  1161,  1161,  1161,  1155,  1155,  1155,  1155,  1162,
      58,   405,  1155,  1155,  1155,  1155,   444,  1155,  1155,   167,
     167,   341,   167,   190,  1164,  1155,  1155,  1164,  1155,  1155,
    1155,  1155,  1155,  1155,  1155,   284,    77,   558,   153,    26,
      49,   424,  1170,  1155,  1161,   679,  1155,  1155,  1155,  1155,
    1000,   499,   218,   775,   218,   218,   218,   775,   511,   438,
     582,   583,   657,   727,   457,   459,   769,   498,   769,  1155,
    1086,    31,    58,   604,   121,   192,   120,   274,   222,  1153,
     844,   174,   321,   723,   730,   731,  1170,   666,   498,   304,
     498,   592,   607,   203,   624,   595,  1165,  1165,  1062,   498,
     562,    28,   123,   210,   366,   436,   706,   414,   702,  1164,
     190,  1153,   688,   461,   284,   499,  1030,   637,   844,   499,
     502,  1054,   677,   695,   499,   648,    37,   279,   304,   498,
     954,   594,   596,   598,   609,  1170,   304,   625,   626,   592,
     624,   561,   282,   284,   631,   981,   643,   641,   562,  1161,
    1155,   805,   740,     3,   743,   284,   828,  1085,  1085,   502,
     498,   834,   424,   502,    43,  1085,   414,   498,   613,  1153,
     712,   657,   499,   920,   921,  1155,  1155,   557,   370,   557,
    1154,  1154,  1154,  1154,  1154,   653,   178,   790,   795,   499,
    1155,   111,   795,   172,   557,   274,   778,  1161,   778,   778,
     778,   218,   778,   778,   778,   778,   778,  1085,   499,   499,
     499,   172,   499,  1085,   172,   133,   135,   172,   167,   146,
     499,   464,  1094,  1123,   332,   443,    58,  1100,  1087,   455,
     455,   499,  1085,   265,  1085,   502,  1093,  1064,  1085,  1085,
    1085,  1085,    34,    34,  1085,  1085,   146,   499,   499,  1085,
    1108,  1170,   499,  1085,  1153,  1153,  1153,  1153,  1021,  1161,
    1021,  1161,   499,  1046,  1047,  1090,   498,  1099,  1033,   498,
    1154,  1031,   284,   438,  1039,  1031,   221,  1031,  1158,  1053,
     498,  1053,  1170,   996,  1085,   456,  1103,   854,   411,   279,
    1150,   981,   298,   981,   961,   284,   498,   963,   488,   975,
     964,   424,   499,   414,   785,   172,   727,  1085,   499,   502,
     457,    77,   807,   811,   807,   499,   499,   197,   615,   121,
     192,   202,   120,   440,   557,  1062,  1155,  1155,  1155,  1155,
    1155,  1155,  1155,  1165,  1155,   597,   601,  1162,   604,   190,
     190,   274,   653,   604,   274,  1162,  1170,  1062,   557,   557,
     488,    58,   405,  1155,  1155,  1155,  1155,  1155,  1164,  1155,
    1155,  1160,  1160,  1062,   502,  1160,  1160,   502,  1164,  1155,
    1155,   414,  1085,    71,  1165,  1155,   414,   414,   172,   196,
     457,  1154,  1154,   769,  1154,   153,   156,   769,  1161,  1161,
    1062,   557,   557,   414,   499,   218,   775,   775,   775,   775,
     498,   578,   579,   511,   125,   174,   207,   174,  1085,   269,
     603,   118,    37,   844,   612,   438,   633,  1158,    34,   152,
     196,   678,   682,   279,   591,   567,   150,   198,   498,   370,
     438,   613,    37,  1165,   700,   526,   269,   498,   169,  1155,
     636,  1161,   370,   562,   152,   981,   769,   279,   591,   641,
     499,   502,   457,   601,    58,   629,   567,   625,    83,   405,
     632,   457,   909,    37,   632,   172,   284,   498,  1153,  1161,
     825,   845,   846,  1171,   840,  1062,   167,   841,  1153,   172,
     414,   865,   334,   713,   205,   658,   557,   499,   557,   557,
    1155,   287,   216,   557,   789,   778,  1085,   499,  1086,   172,
    1085,  1085,  1085,   498,   499,   502,   499,  1100,   499,   443,
     386,   499,   499,  1085,  1085,  1085,   499,   304,  1109,   499,
    1103,  1103,   363,   990,   499,   502,    37,  1048,   118,  1060,
    1061,  1086,    80,  1154,   499,  1085,   498,  1031,  1039,   498,
     499,  1053,   499,   100,   182,   353,   498,  1015,  1016,  1017,
    1018,  1019,  1020,  1085,  1104,  1105,  1170,  1000,   499,   978,
     959,    90,   806,   808,   134,  1085,   789,   284,   789,   499,
     615,   618,   286,   854,   769,   769,   812,   333,   615,   498,
     844,   499,   414,   373,   970,    37,   153,   153,   558,   740,
    1165,  1155,   414,   498,   820,   854,   856,   750,   498,   498,
     758,  1155,   499,   498,   373,   970,  1155,  1155,   498,   498,
     498,   457,   480,   929,   341,   929,   929,   167,  1155,   558,
    1155,   775,   584,   585,  1173,    53,    99,   124,   142,   146,
     168,   171,   186,   274,   325,   580,   578,  1161,   820,    37,
     861,   861,   499,   189,   498,   633,   245,   616,   200,   498,
     731,   723,   498,   499,   502,  1153,   499,   370,    28,    82,
      85,    91,   119,   176,   189,   201,   389,   392,   608,   608,
    1152,  1155,  1155,   499,   981,   701,   153,   111,   677,   172,
    1155,    37,  1155,   641,   592,  1153,   499,   596,   288,  1170,
     630,   625,   629,   123,   138,   314,  1155,    63,    71,   237,
     981,   769,  1040,   806,   172,   726,   827,   499,   502,   424,
     144,   508,   839,   842,  1050,   384,   384,   499,   259,   283,
     714,   715,   716,   167,   719,   657,   265,   442,   659,   660,
    1155,   795,   167,  1086,  1095,  1123,   265,   476,    58,  1000,
      57,   127,   110,   991,  1049,  1046,   498,  1086,   499,   502,
      37,  1056,  1057,  1170,   499,  1154,  1123,   499,   498,   374,
     498,   499,   502,   502,    37,  1005,   443,  1155,   499,   502,
     270,   436,   791,   800,   557,   807,   844,   498,   561,   813,
    1153,   844,   613,   633,  1155,   405,   189,   438,   559,   373,
     970,  1155,  1127,   167,   753,   753,  1127,  1127,  1085,   405,
    1123,  1123,   568,   569,  1172,   768,   769,   768,   769,  1154,
     557,   499,   502,   491,   498,   536,   586,   653,   926,  1161,
     926,   269,   274,   325,   926,   926,  1050,   861,    41,   194,
     265,   611,   498,   649,  1085,   173,   303,   379,   284,   620,
     621,   622,   405,   499,  1158,     6,   732,   682,   592,   624,
    1155,   499,   677,   160,   752,   562,   909,  1153,   461,  1030,
     677,   981,   954,   625,   592,   624,   601,   498,   631,   629,
     630,   357,   357,    71,   287,    71,   641,   805,   499,  1153,
     727,   834,   845,  1062,   501,   134,   457,   457,   715,   356,
     402,   717,   139,   720,   453,   722,   442,   657,   677,   557,
    1085,   499,   499,   443,  1123,   183,   326,   357,  1110,   164,
     164,   613,  1053,   502,  1061,  1173,   499,   502,   167,  1062,
     499,   499,  1123,   498,  1123,  1016,  1105,  1107,  1023,   981,
    1050,   808,   373,   172,   633,   854,   813,   814,   612,   633,
     499,   727,  1155,   649,  1085,   405,   499,   290,   363,   330,
     754,   754,   499,   499,   499,  1155,   499,   499,   499,   502,
    1160,   929,   585,   536,   587,   588,  1161,  1161,   274,   613,
     491,   613,  1161,  1161,   202,   650,   499,   123,   436,   284,
     622,   284,   621,  1155,   498,   499,   502,   567,   370,   677,
     769,    37,    37,   498,  1155,   909,   641,   629,   567,   625,
     498,   627,   628,  1090,  1170,   632,   630,   631,   287,   287,
     498,   197,   809,   167,   840,    29,   211,   896,   174,   174,
     926,   356,   388,   721,   498,   152,    51,   101,   427,  1085,
    1111,  1112,  1111,  1111,   499,    58,    58,   373,   499,  1087,
    1057,   291,     3,   118,   269,   274,  1058,  1059,    37,  1035,
     340,  1044,   499,  1015,   499,   973,   789,   454,   619,   499,
     814,   616,   727,   970,  1155,   820,    58,   970,   414,   568,
     769,   499,   502,   613,   499,   393,    62,   265,   345,   373,
     623,   623,   499,     6,   370,  1155,   749,   981,   677,   630,
     625,   629,  1085,   499,   502,   811,   811,   631,   632,   806,
     498,   562,   139,   270,   498,   891,   893,   897,   956,   965,
     972,   981,   820,   820,   718,  1170,  1085,   723,  1112,   356,
     166,   312,   166,   312,   149,  1113,  1113,  1113,   613,   613,
    1170,  1099,  1086,  1086,   274,  1059,  1170,   498,   499,  1050,
     557,   498,   727,   620,   970,   769,   498,   588,    23,   118,
     274,  1155,   677,   909,   631,   629,   630,   499,   628,   769,
     812,   812,   632,   499,   808,   810,   632,   356,   892,   893,
     894,   982,   983,   502,   502,   499,  1158,    34,   101,   181,
     265,   411,   373,   373,   414,   438,    80,  1085,  1085,   727,
    1123,   677,   632,   630,   631,   811,   809,   499,   502,  1050,
     722,   499,   501,   414,   172,   498,  1112,   356,   292,  1170,
    1170,  1158,  1159,  1170,  1056,   499,   499,   499,   631,   632,
     812,   562,   808,   152,   894,   384,   384,     5,   724,   725,
    1160,  1161,  1173,   498,   118,   499,   632,   632,   723,   457,
     457,   499,   502,  1124,  1159,  1050,  1158,   174,   174,   725,
    1000,   438,   498,   820,   820,   499,  1170,   724,   499
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   504,   505,   505,   505,   505,   505,   505,   506,   506,
     507,   507,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   509,   510,   511,   511,
     511,   512,   512,   513,   513,   514,   514,   514,   514,   514,
     514,   514,   514,   514,   515,   515,   515,   515,   515,   515,
     516,   517,   517,   518,   518,   519,   519,   519,   519,   520,
     520,   520,   520,   520,   520,   521,   522,   523,   523,   524,
     524,   524,   524,   525,   525,   526,   526,   527,   527,   527,
     527,   527,   527,   528,   528,   528,   528,   529,   529,   529,
     530,   530,   530,   530,   531,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   532,   532,   533,   533,   534,
     534,   535,   535,   535,   535,   536,   536,   536,   536,   537,
     537,   537,   537,   537,   537,   537,   538,   538,   538,   539,
     539,   540,   540,   541,   541,   541,   541,   542,   542,   543,
     543,   544,   544,   545,   545,   545,   545,   545,   545,   545,
     546,   547,   547,   548,   548,   549,   550,   550,   550,   550,
     550,   551,   551,   551,   551,   551,   551,   551,   551,   551,
     551,   551,   551,   551,   551,   551,   551,   551,   551,   551,
     551,   551,   552,   552,   553,   553,   553,   554,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   556,   556,   557,
     557,   557,   558,   558,   559,   559,   560,   560,   560,   560,
     561,   562,   562,   563,   563,   564,   564,   564,   564,   565,
     565,   566,   566,   566,   566,   567,   567,   567,   567,   568,
     569,   569,   570,   571,   571,   572,   572,   572,   572,   573,
     573,   574,   574,   575,   575,   576,   576,   577,   577,   577,
     578,   578,   579,   579,   580,   580,   580,   580,   580,   580,
     580,   580,   580,   580,   580,   580,   580,   581,   581,   582,
     582,   583,   583,   584,   584,   585,   586,   586,   586,   586,
     586,   587,   587,   588,   589,   589,   589,   589,   589,   589,
     590,   590,   590,   590,   590,   590,   590,   590,   591,   591,
     592,   592,   593,   593,   594,   594,   595,   595,   595,   596,
     596,   597,   598,   598,   599,   599,   600,   600,   601,   601,
     602,   602,   602,   602,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   604,   604,   605,   605,   605,   605,   606,
     607,   607,   607,   608,   608,   608,   608,   608,   608,   608,
     608,   608,   608,   609,   609,   610,   610,   610,   610,   610,
     610,   610,   611,   611,   612,   612,   613,   613,   614,   615,
     615,   616,   616,   616,   616,   617,   617,   618,   618,   619,
     619,   620,   620,   620,   620,   620,   621,   622,   623,   623,
     623,   623,   623,   624,   624,   625,   625,   626,   627,   627,
     628,   628,   628,   629,   629,   630,   630,   630,   631,   631,
     631,   631,   632,   632,   633,   633,   634,   635,   635,   636,
     636,   637,   637,   637,   638,   638,   639,   639,   640,   641,
     641,   641,   642,   642,   643,   644,   644,   645,   646,   646,
     647,   647,   648,   648,   649,   649,   650,   650,   651,   651,
     651,   651,   651,   651,   651,   651,   651,   651,   651,   651,
     651,   651,   652,   652,   653,   653,   653,   653,   654,   654,
     655,   655,   656,   656,   657,   657,   658,   658,   659,   659,
     660,   660,   661,   661,   662,   663,   663,   664,   664,   665,
     665,   666,   666,   667,   667,   667,   667,   668,   669,   669,
     670,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   671,   672,   673,   673,   673,   673,   674,
     674,   675,   675,   676,   676,   677,   677,   678,   678,   679,
     680,   680,   681,   681,   681,   681,   682,   683,   684,   685,
     685,   686,   686,   687,   687,   688,   688,   689,   689,   689,
     690,   690,   690,   690,   691,   692,   692,   693,   693,   694,
     694,   695,   695,   696,   696,   697,   698,   699,   700,   700,
     701,   701,   702,   702,   703,   703,   704,   704,   705,   705,
     706,   706,   706,   706,   706,   707,   708,   708,   709,   709,
     710,   710,   710,   711,   711,   712,   712,   712,   712,   712,
     713,   713,   714,   714,   715,   716,   716,   717,   717,   718,
     719,   719,   720,   720,   721,   721,   722,   722,   723,   723,
     724,   724,   724,   725,   725,   725,   725,   726,   726,   727,
     727,   728,   728,   728,   728,   728,   728,   729,   729,   730,
     730,   731,   732,   732,   733,   734,   734,   734,   734,   735,
     736,   736,   736,   736,   736,   736,   736,   736,   736,   736,
     736,   736,   736,   736,   736,   736,   737,   738,   738,   739,
     739,   740,   740,   740,   740,   740,   740,   741,   742,   742,
     743,   744,   744,   745,   745,   746,   746,   746,   746,   747,
     747,   748,   749,   749,   750,   750,   750,   750,   750,   751,
     751,   752,   752,   753,   753,   753,   754,   754,   755,   756,
     756,   757,   757,   758,   758,   759,   759,   760,   760,   761,
     762,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   765,   765,   765,   765,
     765,   766,   766,   766,   766,   766,   766,   766,   766,   767,
     767,   767,   768,   768,   769,   769,   770,   770,   771,   771,
     772,   773,   773,   773,   774,   774,   774,   774,   774,   774,
     774,   774,   774,   774,   774,   774,   774,   774,   774,   774,
     774,   774,   775,   775,   776,   776,   776,   776,   776,   776,
     776,   776,   776,   776,   777,   777,   778,   778,   779,   779,
     780,   780,   780,   780,   780,   780,   780,   780,   780,   780,
     780,   780,   780,   780,   780,   780,   781,   781,   782,   782,
     783,   784,   784,   785,   785,   785,   785,   785,   786,   786,
     787,   787,   787,   787,   788,   788,   788,   788,   788,   788,
     788,   788,   788,   788,   788,   788,   788,   788,   788,   788,
     788,   788,   788,   788,   789,   789,   790,   790,   791,   791,
     792,   793,   793,   794,   794,   795,   795,   796,   797,   797,
     798,   798,   798,   799,   799,   799,   800,   800,   800,   800,
     800,   800,   801,   801,   802,   802,   803,   803,   804,   804,
     805,   805,   806,   806,   807,   807,   808,   808,   808,   809,
     809,   810,   810,   811,   811,   812,   812,   813,   813,   813,
     814,   814,   814,   815,   815,   815,   815,   816,   816,   817,
     817,   818,   818,   819,   819,   820,   820,   820,   820,   821,
     821,   822,   822,   823,   823,   823,   823,   823,   824,   824,
     824,   824,   824,   825,   826,   827,   827,   827,   828,   828,
     828,   829,   830,   830,   830,   830,   831,   831,   832,   833,
     833,   834,   834,   835,   835,   836,   836,   836,   836,   836,
     836,   836,   836,   836,   836,   836,   836,   836,   836,   836,
     836,   836,   837,   837,   837,   837,   837,   838,   838,   839,
     840,   840,   840,   841,   841,   842,   842,   843,   843,   844,
     844,   845,   846,   846,   847,   847,   847,   848,   848,   849,
     849,   850,   850,   850,   850,   850,   850,   851,   851,   852,
     852,   853,   853,   853,   853,   854,   854,   855,   855,   856,
     857,   858,   858,   859,   859,   860,   860,   860,   861,   861,
     861,   862,   863,   863,   864,   865,   865,   865,   865,   866,
     867,   867,   867,   867,   868,   868,   869,   869,   869,   870,
     870,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   872,   872,   873,   873,
     874,   874,   874,   874,   874,   874,   875,   875,   876,   876,
     876,   876,   876,   876,   876,   876,   876,   876,   876,   876,
     876,   876,   876,   876,   876,   876,   876,   876,   876,   876,
     876,   876,   876,   876,   876,   877,   878,   878,   879,   879,
     880,   880,   880,   880,   880,   881,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     883,   884,   884,   885,   885,   886,   886,   886,   886,   887,
     888,   888,   888,   888,   888,   888,   888,   888,   889,   889,
     890,   891,   891,   891,   892,   892,   893,   893,   893,   893,
     893,   894,   894,   895,   895,   895,   895,   896,   896,   896,
     897,   898,   898,   899,   900,   900,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   902,   902,
     903,   903,   903,   904,   904,   904,   904,   904,   905,   905,
     905,   906,   906,   907,   907,   907,   908,   908,   908,   908,
     909,   909,   909,   909,   910,   911,   912,   912,   913,   913,
     914,   914,   914,   915,   915,   915,   915,   915,   915,   915,
     916,   916,   917,   917,   917,   918,   919,   919,   919,   919,
     920,   920,   921,   922,   923,   923,   924,   925,   925,   925,
     925,   925,   925,   925,   926,   926,   927,   928,   928,   928,
     928,   928,   928,   929,   929,   930,   931,   931,   931,   931,
     932,   932,   933,   933,   934,   934,   935,   935,   936,   936,
     937,   938,   938,   939,   939,   939,   940,   940,   941,   941,
     942,   942,   943,   943,   944,   944,   945,   946,   946,   947,
     947,   948,   948,   948,   948,   949,   949,   949,   949,   949,
     949,   949,   949,   949,   950,   951,   951,   952,   952,   952,
     952,   953,   953,   953,   954,   954,   955,   955,   955,   955,
     956,   957,   957,   958,   958,   958,   958,   958,   959,   959,
     960,   960,   961,   962,   962,   962,   963,   963,   963,   964,
     964,   965,   966,   966,   967,   968,   968,   969,   969,   969,
     969,   969,   969,   969,   969,   970,   970,   971,   971,   971,
     972,   973,   973,   974,   974,   975,   976,   976,   977,   978,
     979,   979,   979,   979,   979,   979,   980,   980,   980,   981,
     981,   982,   982,   983,   983,   983,   983,   983,   983,   983,
     983,   984,   984,   985,   985,   985,   985,   985,   985,   985,
     986,   986,   986,   987,   987,   988,   989,   989,   989,   990,
     990,   990,   991,   991,   991,   992,   992,   993,   993,   994,
     994,   994,   994,   994,   994,   994,   994,   994,   995,   995,
     996,   996,   996,   997,   997,   998,   998,   999,   999,  1000,
    1000,  1001,  1002,  1002,  1003,  1003,  1004,  1004,  1004,  1004,
    1005,  1005,  1006,  1006,  1006,  1006,  1006,  1006,  1007,  1007,
    1008,  1008,  1009,  1010,  1010,  1010,  1011,  1011,  1012,  1012,
    1013,  1013,  1014,  1014,  1015,  1015,  1016,  1016,  1016,  1016,
    1016,  1017,  1018,  1019,  1020,  1021,  1021,  1022,  1022,  1023,
    1023,  1024,  1024,  1025,  1026,  1026,  1026,  1026,  1027,  1027,
    1028,  1028,  1029,  1029,  1030,  1030,  1031,  1031,  1031,  1031,
    1031,  1031,  1031,  1031,  1031,  1031,  1032,  1032,  1032,  1032,
    1032,  1032,  1033,  1033,  1033,  1033,  1034,  1034,  1035,  1035,
    1036,  1036,  1036,  1036,  1036,  1037,  1037,  1037,  1037,  1038,
    1038,  1039,  1039,  1040,  1040,  1040,  1040,  1041,  1041,  1042,
    1042,  1042,  1043,  1044,  1044,  1045,  1045,  1046,  1047,  1047,
    1048,  1048,  1049,  1049,  1050,  1050,  1051,  1051,  1051,  1052,
    1052,  1053,  1053,  1054,  1055,  1055,  1056,  1056,  1057,  1057,
    1057,  1058,  1058,  1059,  1059,  1059,  1059,  1060,  1060,  1061,
    1061,  1062,  1062,  1062,  1062,  1062,  1062,  1063,  1063,  1063,
    1064,  1064,  1064,  1064,  1064,  1064,  1064,  1065,  1065,  1065,
    1065,  1066,  1066,  1067,  1067,  1068,  1068,  1068,  1068,  1068,
    1068,  1068,  1068,  1068,  1068,  1068,  1069,  1069,  1070,  1070,
    1071,  1071,  1072,  1073,  1074,  1074,  1075,  1075,  1076,  1077,
    1078,  1078,  1078,  1078,  1078,  1078,  1079,  1079,  1080,  1080,
    1080,  1080,  1081,  1082,  1082,  1082,  1083,  1083,  1083,  1083,
    1083,  1083,  1083,  1083,  1083,  1083,  1083,  1083,  1083,  1083,
    1084,  1084,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1086,  1086,  1086,
    1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,
    1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1086,  1087,
    1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,
    1087,  1087,  1087,  1088,  1088,  1088,  1088,  1088,  1088,  1088,
    1089,  1089,  1090,  1090,  1091,  1091,  1091,  1091,  1091,  1091,
    1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,
    1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,
    1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,
    1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,  1091,
    1092,  1092,  1093,  1093,  1093,  1093,  1094,  1095,  1095,  1096,
    1096,  1097,  1097,  1098,  1098,  1098,  1099,  1099,  1099,  1099,
    1100,  1100,  1101,  1101,  1102,  1102,  1103,  1103,  1104,  1104,
    1105,  1106,  1106,  1106,  1107,  1108,  1108,  1109,  1109,  1110,
    1110,  1110,  1110,  1111,  1111,  1112,  1112,  1112,  1112,  1112,
    1113,  1113,  1113,  1113,  1113,  1114,  1114,  1114,  1115,  1115,
    1116,  1117,  1117,  1117,  1118,  1118,  1119,  1119,  1119,  1119,
    1119,  1119,  1119,  1119,  1119,  1119,  1119,  1119,  1120,  1120,
    1121,  1121,  1122,  1122,  1122,  1122,  1122,  1122,  1123,  1123,
    1124,  1124,  1125,  1125,  1125,  1126,  1126,  1127,  1127,  1128,
    1128,  1128,  1129,  1129,  1130,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1132,  1132,  1132,  1132,  1133,  1133,  1134,
    1135,  1135,  1135,  1135,  1135,  1136,  1136,  1136,  1137,  1137,
    1138,  1139,  1139,  1140,  1141,  1141,  1142,  1142,  1143,  1143,
    1144,  1144,  1144,  1144,  1145,  1145,  1146,  1146,  1147,  1147,
    1148,  1148,  1149,  1149,  1150,  1150,  1151,  1151,  1151,  1151,
    1152,  1152,  1153,  1153,  1154,  1154,  1155,  1156,  1157,  1158,
    1158,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1160,  1161,  1162,  1162,  1162,  1163,
    1164,  1164,  1164,  1164,  1165,  1165,  1166,  1167,  1168,  1168,
    1169,  1169,  1170,  1170,  1170,  1171,  1171,  1171,  1172,  1172,
    1172,  1172,  1173,  1173,  1173,  1173,  1173,  1174,  1174,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     5,     1,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       3,     3,     2,     1,     1,     2,     2,     2,     3,     3,
       5,     5,     5,     0,     3,     5,     5,     5,     5,     3,
       5,     3,     5,     3,     5,     5,     6,     1,     1,     6,
       4,     9,     7,     1,     0,     2,     0,     1,     1,     1,
       1,     1,     1,     3,     2,     3,     3,     2,     5,     1,
       3,     3,     3,     3,     1,     3,     3,     2,     2,     2,
       2,     3,     3,     3,     3,     1,     3,     1,     3,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     3,     1,     2,     3,     2,     1,     1,     2,
       1,     2,     1,     3,     3,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     4,     6,     4,     6,    10,    13,     4,     6,     4,
      10,    13,     4,     6,     4,     6,     5,     7,    11,    14,
       5,     7,     1,     3,     4,     4,     4,     3,     2,     5,
       3,     6,     4,     6,     6,     5,     7,     6,     6,     5,
       5,     6,     5,     9,     4,     5,     7,     6,     4,     8,
       4,     2,     4,     3,     6,     4,     3,     3,     3,     2,
       2,     3,     4,     4,     3,     3,     3,     3,     3,     3,
       4,     4,     3,     2,     3,     2,     2,     3,     3,     2,
       2,     3,     4,     4,     4,     5,     1,     3,     2,     1,
       1,     0,     2,     0,     2,     0,     1,     1,     1,     3,
       3,     2,     0,     1,     3,     3,     1,     5,     3,     1,
       2,     1,     3,     2,     3,     6,     6,    10,     1,     2,
       1,     3,     4,     1,     3,     4,     6,     4,     8,     2,
       2,    11,     9,     1,     1,     1,     0,     1,     1,     1,
       1,     3,     2,     0,     1,     1,     3,     3,     1,     1,
       3,     3,     3,     3,     4,     3,     2,     1,     0,     3,
       0,     1,     0,     1,     3,     2,     1,     1,     1,     3,
       0,     1,     3,     1,    13,    16,    12,    15,    14,    17,
       1,     1,     2,     2,     2,     2,     1,     0,     1,     0,
       3,     0,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     5,     2,     4,     2,     2,     1,     0,     2,     0,
       3,     1,     1,     2,     2,     1,     3,     4,     5,     2,
       5,     7,     5,     1,     2,     1,     2,     2,     2,     3,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     5,     8,     3,     9,     4,
      10,    11,     2,     0,     3,     0,     1,     3,     1,     4,
       0,     2,     2,     2,     0,     1,     3,     3,     6,     4,
       0,     1,     1,     2,     2,     0,     3,     3,     2,     1,
       1,     2,     2,     4,     0,     1,     0,     6,     1,     3,
       3,     3,     5,     2,     0,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     3,     8,    11,     1,
       3,     1,     1,     3,     6,     8,     7,    10,     6,     2,
       3,     0,     8,    11,     5,     1,     0,     6,     5,     8,
       4,     6,     1,     0,     3,     0,     1,     2,     2,     2,
       1,     2,     3,     2,     2,     2,     2,     3,     3,     3,
       1,     3,     1,     0,     1,     2,     2,     1,     1,     3,
       6,    10,     1,     0,     1,     2,     2,     0,     2,     2,
       1,     0,     1,     0,     7,     2,     0,     3,     5,     5,
       8,     2,     0,     2,     2,     2,     1,     5,     2,     0,
       2,     6,     6,     6,    10,     6,     6,     6,     9,     9,
       6,     6,     9,     6,     7,     2,     2,     2,     2,     1,
       2,     1,     0,     7,     6,     4,     0,     1,     3,     4,
       1,     3,     1,     2,     2,     2,     2,     1,     1,    10,
      13,     2,     0,     2,     2,     1,     0,     5,     4,     4,
      11,    14,    12,    15,    11,     2,     1,     4,     0,     8,
      11,     1,     1,     7,     9,     8,    10,     8,     4,     0,
       5,     0,     2,     0,     2,     0,     2,     0,     2,     0,
       1,     1,     1,     1,     1,     8,     1,     1,    17,    21,
       1,     1,     2,     1,     3,     1,     1,     1,     3,     1,
       2,     0,     1,     2,     4,     1,     1,     1,     1,     1,
       3,     0,     1,     0,     1,     1,     4,     0,     1,     1,
       1,     3,     0,     1,     1,     1,     1,     2,     0,     0,
       2,     2,     1,     2,     2,     2,     2,    11,    13,     1,
       3,     5,     1,     3,     5,     1,     2,     2,     1,     8,
       6,     5,     4,     4,     3,     7,     8,     6,     6,     6,
       6,     6,     4,     7,     5,     8,     3,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       3,     1,     0,     1,     3,     7,     9,     9,     8,     3,
       0,    13,     1,     3,     5,     5,     3,     6,     2,     1,
       0,     2,     0,     2,     4,     0,     1,     0,     6,     8,
       8,     1,     3,     5,     5,     7,     9,     7,     9,     5,
       6,     6,     4,     6,     4,     6,     8,     4,     6,     4,
       6,     5,     7,     1,     1,     1,     2,     1,     2,     1,
       1,     1,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     2,     2,     1,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     2,     2,     3,     1,     3,
       5,     2,     2,     0,     6,     6,     6,     6,     6,     6,
       6,     6,     8,     9,     8,     6,     6,     9,     9,     9,
       7,    10,     1,     1,     8,     8,     8,     8,     8,     8,
       8,     9,     8,     8,     2,     0,     1,     1,     2,     2,
       1,     2,     3,     3,     3,     3,     4,     4,     3,     3,
       3,     4,     4,     3,     4,     4,     1,     1,     1,     0,
       8,     8,    11,     1,     1,     2,     4,     5,     1,     3,
       2,     2,     2,     2,     1,     2,     2,     4,     3,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     2,     5,
       5,     5,     5,     5,     1,     3,     1,     2,     3,     0,
       6,     6,     9,     3,     0,     3,     0,     5,     2,     0,
       3,     3,     3,     7,     7,    10,     1,     1,     1,     1,
       1,     1,    15,    18,     1,     0,     1,     0,     1,     0,
       2,     0,     1,     3,     4,     5,     2,     2,     4,     4,
       0,     1,     3,     2,     0,     1,     0,     1,     1,     0,
       2,     2,     0,     9,    12,     7,     7,     2,     0,     3,
       2,     1,     3,     1,     3,     2,     1,     1,     2,     3,
       2,     1,     3,     3,     3,     2,     2,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     4,     5,     1,     3,
       3,     1,     3,     3,     5,     6,     1,     3,     2,     1,
       3,     1,     0,     1,     2,     4,     5,     1,     1,     1,
       1,     3,     3,     2,     2,     1,     2,     2,     2,     2,
       1,     2,     2,     2,     2,     1,     1,     1,     3,     2,
       1,     4,     0,     3,     0,     1,     1,     3,     5,     2,
       0,     2,     1,     3,     5,     5,     5,     1,     2,     1,
       0,     4,     6,     4,     6,     4,     6,     4,     6,     4,
       6,     3,     5,     5,     5,     1,     3,     1,     3,     2,
       2,     1,     2,     1,     2,    11,    10,    10,     2,     2,
       0,     9,     2,     0,    10,    11,    11,     5,     5,     8,
       4,     4,     7,     7,     1,     1,     1,     1,     1,     5,
       5,     6,     6,     6,     6,     6,     8,     8,     6,     6,
       7,     9,     9,     8,    10,     6,     6,     6,     6,     6,
       6,     6,     8,     6,     8,     6,     8,     7,     9,     6,
       8,     7,     9,     8,    10,     8,    10,     9,    11,     8,
      10,     9,    11,     8,     8,     7,     6,     6,     6,     6,
       8,     8,     8,     8,     6,     9,     1,     0,     2,     0,
       8,     8,     8,    10,     9,     8,     1,     0,     6,     6,
       6,     6,     6,     6,     6,     9,     9,     6,     6,     6,
       8,     6,     8,     8,     8,     8,     6,     8,     6,     8,
       7,     9,     7,     9,     6,     7,     1,     3,     3,     3,
       1,     1,     1,     1,     1,     7,     6,     6,     6,     6,
       6,     6,     7,     7,     6,     9,     9,     6,     6,     6,
       6,     6,     6,     8,     8,     8,     6,     7,     6,     6,
       5,     1,     0,     3,     3,     5,     6,     6,     6,     8,
       5,     5,     6,     7,     7,     7,     4,     4,     4,     6,
      13,     1,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     0,
       3,     2,     0,     2,     2,     2,     3,     3,     3,     3,
       2,     3,     2,     5,     4,     3,     3,     3,     3,     3,
       1,     1,     0,     3,     2,     2,     1,     2,     1,     3,
       2,     1,     0,     2,     3,     0,     9,    11,    12,    14,
       3,     4,     4,     0,     2,     5,     1,     0,     1,     2,
       3,     3,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     0,     5,     4,     6,     4,     3,     5,     7,     9,
       1,     3,     1,     5,     4,     4,     6,     4,     6,     6,
       5,     7,     9,     6,     1,     0,     6,    11,    11,    11,
      13,     9,    11,     1,     1,    10,     4,     6,     2,     5,
       2,     0,     6,     5,     3,     5,     1,     3,     1,     1,
       2,     1,     1,     1,     1,     0,     1,     0,     1,     0,
       1,     0,     1,     0,     3,     0,     2,     1,     3,     1,
       0,     2,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     5,     3,     0,     1,     1,     1,
       1,     3,     9,    12,     3,     0,     2,     3,     2,     3,
       7,     1,     3,     1,     4,     4,     7,     2,     1,     1,
       1,     3,     2,     8,     5,     0,     4,     3,     0,     2,
       0,     7,     2,     0,     5,     3,     0,     2,     2,     2,
       3,     1,     3,     1,     2,     1,     0,     1,     2,     0,
       8,     1,     3,     3,     5,     2,     1,     3,     7,     1,
       0,     3,     2,     2,     2,     2,     0,     2,     2,     1,
       1,     3,     3,     1,     2,     4,     4,     2,     3,     5,
       5,     1,     1,     9,     9,     1,     2,     4,     4,     4,
       2,     2,     3,     1,     3,     9,     1,     2,     0,     7,
       7,     0,    10,     6,     0,     1,     0,     2,     0,     3,
       3,     4,     4,     4,     4,     3,     2,     1,     1,     0,
       1,     1,     0,     1,     5,     1,     0,     1,     1,     1,
       0,     3,     1,     3,     4,     3,     2,     2,     1,     1,
       1,     0,     2,     4,     5,     6,     4,     5,     2,     3,
       1,     1,     1,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     4,     0,     1,     3,     1,     1,     1,     1,
       1,     2,     4,     4,     5,     2,     0,     1,     3,     1,
       0,     1,     2,     3,     2,     4,     2,     3,     2,     0,
       4,     5,     2,     0,     1,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     1,     4,     3,     4,     5,     4,
       5,     4,     5,     2,     4,     1,     1,     0,     2,     0,
       1,     4,     5,     4,     0,     2,     2,     2,     1,     1,
       0,     5,     2,     1,     2,     2,     4,     1,     3,     1,
       2,     3,     6,     4,     0,     2,     6,     2,     1,     3,
       4,     0,     2,     0,     2,     0,     2,     4,     0,     1,
       0,     1,     3,     3,     7,    12,     1,     3,     2,     3,
       3,     1,     2,     2,     2,     2,     1,     1,     3,     3,
       2,     2,     3,     5,     6,     2,     3,     3,     4,     0,
       1,     1,     1,     1,     1,     2,     4,     1,     1,     1,
       1,     2,     3,     3,     0,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     1,     3,     0,     1,     1,
       1,     1,     5,     2,     1,     1,     1,     1,     4,     1,
       2,     2,     1,     3,     3,     2,     1,     0,     5,     2,
       5,     2,     1,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     0,
       1,     4,     1,     3,     3,     5,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     3,     2,     2,     3,     5,     4,     6,
       3,     5,     4,     6,     4,     6,     5,     7,     3,     2,
       4,     2,     3,     3,     4,     3,     4,     3,     4,     5,
       6,     6,     7,     6,     7,     3,     4,     4,     6,     2,
       3,     4,     3,     4,     4,     5,     1,     1,     3,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     5,     6,     3,     4,     1,
       1,     2,     4,     1,     1,     1,     2,     2,     2,     2,
       1,     1,     4,     3,     5,     6,     8,     6,     6,     4,
       4,     1,     1,     1,     5,     1,     1,     4,     1,     4,
       1,     4,     1,     4,     1,     1,     1,     1,     1,     1,
       6,     4,     4,     6,     4,     4,     4,     4,     4,     6,
       5,     5,     5,     4,     6,     4,     4,     4,     4,     5,
       7,     7,     9,     5,     4,     6,     5,     7,     7,     7,
       2,     3,     3,     3,     4,     0,     4,     1,     3,     3,
       1,     1,     1,     2,     2,     0,     2,     3,     3,     4,
       2,     2,     5,     0,     5,     0,     2,     0,     1,     3,
       3,     2,     2,     0,     6,     1,     0,     3,     0,     3,
       3,     3,     0,     1,     4,     2,     2,     2,     2,     2,
       3,     2,     2,     3,     0,     4,     3,     5,     4,     3,
       5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       1,     4,     1,     4,     1,     2,     1,     2,     1,     3,
       1,     3,     1,     3,     3,     1,     0,     1,     3,     3,
       3,     2,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     7,     5,     3,
       5,     5,     3,     3,     5,     3,     2,     1,     1,     3,
       5,     1,     2,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     5,     1,     0,     1,     2,     0,     2,
       1,     0,     1,     0,     1,     3,     3,     2,     1,     1,
       1,     3,     1,     2,     1,     3,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     6,     2,     3,
       5,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     3,    10,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 861 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 27670 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 865 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 27678 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 869 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 27687 "gram.c" /* yacc.c:1646  */
    break;

  case 5:
#line 874 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);
				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 27698 "gram.c" /* yacc.c:1646  */
    break;

  case 6:
#line 881 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);
				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 27709 "gram.c" /* yacc.c:1646  */
    break;

  case 7:
#line 888 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);
				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 27720 "gram.c" /* yacc.c:1646  */
    break;

  case 8:
#line 907 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 27736 "gram.c" /* yacc.c:1646  */
    break;

  case 9:
#line 919 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 27747 "gram.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1061 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 27753 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1071 "gram.y" /* yacc.c:1646  */
    {
					CallStmt *n = makeNode(CallStmt);
					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *)n;
				}
#line 27763 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1086 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27775 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1107 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27781 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1108 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27787 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1112 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27793 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1113 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27799 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1118 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 27808 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 27816 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1127 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 27830 "gram.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1137 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 27842 "gram.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1145 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 27850 "gram.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1149 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 27858 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1153 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 27866 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1158 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 27874 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1162 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 27923 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1209 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 27929 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1212 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 27937 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1216 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 27945 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1220 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 27953 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1224 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 27961 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1228 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 27969 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1242 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27981 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1260 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 27993 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1268 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 28005 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1278 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28011 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1279 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28017 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1284 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28029 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1292 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28041 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1300 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28053 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1308 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28065 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1329 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28076 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1336 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28087 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1343 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28098 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1350 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28109 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1357 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28120 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1364 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28131 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1381 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28143 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1399 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 28156 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1409 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 28162 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1410 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 28168 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1422 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 28182 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1432 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 28196 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1442 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 28215 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1457 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 28234 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1474 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28240 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1475 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28246 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1480 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 28256 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1486 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28262 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1514 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minimum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28273 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1521 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28283 "gram.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1527 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 28293 "gram.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1533 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28303 "gram.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1542 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28315 "gram.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1550 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28327 "gram.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1562 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28339 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1570 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28351 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1578 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28362 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1585 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28373 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1594 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 28379 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1596 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28390 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1604 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 28405 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1615 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 28417 "gram.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1623 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28429 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1631 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 28444 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1642 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28456 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1650 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28468 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1658 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 28479 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1665 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28491 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1674 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28503 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1683 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28509 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1685 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 28515 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1688 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 28521 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1689 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 28527 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1693 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 28533 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1695 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 28539 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1698 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 28545 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1699 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 28551 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1700 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 28557 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1701 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 28563 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1705 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 28569 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1706 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 28575 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1707 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 28581 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1713 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28587 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1726 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 28595 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1730 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 28603 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1734 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 28622 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1749 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 28633 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1755 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 28639 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1756 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28645 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1757 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28651 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1761 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28657 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1762 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28663 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1763 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28669 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1767 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28675 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1768 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28681 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1772 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 28687 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1774 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minimum */
					(yyval.node) = (Node *) n;
				}
#line 28697 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1782 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 28703 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1784 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 28714 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1791 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 28725 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1798 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 28736 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1808 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 28747 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1815 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 28757 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1824 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 28763 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1825 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 28769 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1830 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 28775 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1831 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 28781 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1838 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 28791 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1844 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
#line 28801 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1850 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 28811 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1856 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 28821 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1862 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 28831 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1868 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 28841 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1874 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 28851 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1884 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 28862 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1893 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28868 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1894 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28874 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1898 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 28880 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1899 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 28886 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1908 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 28895 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1923 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 28905 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1929 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 28915 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1935 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 28925 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1941 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 28935 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1947 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 28945 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1966 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28958 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1975 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28971 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1984 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28984 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1993 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28997 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2002 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29012 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2013 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29027 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2024 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29040 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2033 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29053 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2042 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29066 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2051 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29081 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2062 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29096 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2073 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29109 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2082 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29122 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2091 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29135 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2100 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29148 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2109 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29161 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2118 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29174 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2127 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29189 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2138 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29204 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2149 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29217 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2158 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29230 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2169 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29236 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2170 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29242 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2176 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29259 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2190 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29276 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2203 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 29292 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2219 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29309 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2236 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29321 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2245 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29333 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2254 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29345 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2263 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29357 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2272 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29369 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2281 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 29380 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2289 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 29391 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2297 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *)n;
				}
#line 29402 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2305 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29414 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2314 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 29426 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2323 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 29445 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2339 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29457 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2348 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29469 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2357 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 29481 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2366 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 29493 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2375 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *)n;
				}
#line 29513 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2392 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29525 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2401 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29537 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2410 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29549 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2419 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29562 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2429 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29575 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2442 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 29593 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2457 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29605 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2466 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29617 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2475 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 29635 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2490 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29646 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2498 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29659 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2508 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29672 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2518 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 29682 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2525 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29693 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2533 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 29704 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2541 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
#line 29714 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2548 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
#line 29724 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2555 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29735 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2563 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29746 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2571 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29757 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2579 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 29767 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2586 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 29777 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2593 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29788 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2601 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 29798 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2608 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 29808 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2615 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29819 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2623 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29830 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2631 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29841 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2639 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29852 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2647 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 29863 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2655 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 29874 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2663 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 29887 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2673 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 29897 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2680 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 29908 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2688 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29919 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2696 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29930 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2704 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29941 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2712 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29952 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2720 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 29962 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2727 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 29972 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2734 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 29982 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2741 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 29992 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2747 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 30003 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2756 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30009 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2757 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30015 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2761 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 30021 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2762 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 30027 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2763 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 30033 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2768 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 30045 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2775 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30051 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2779 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30057 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2780 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30063 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2785 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30074 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2792 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30085 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2799 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30096 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2806 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30107 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2815 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30113 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2818 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30119 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2819 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30125 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2823 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30131 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2824 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 30137 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2830 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 30145 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2834 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 30153 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2838 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 30162 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2843 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 30170 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2850 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30176 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2852 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30182 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2857 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 30190 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2861 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 30198 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2865 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 30213 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2876 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 30221 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2884 "gram.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 30276 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2937 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 30291 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2950 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 30307 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2964 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 30320 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2976 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 30328 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2983 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 30336 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2987 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 30344 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3001 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 30358 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3013 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30364 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3014 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30370 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3020 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 30382 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3029 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 30395 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3039 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 30408 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3049 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 30427 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3075 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30437 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3081 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 30447 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3116 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 30484 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3149 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *)n;
				}
#line 30507 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3170 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30513 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3171 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30519 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3175 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30525 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3176 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30531 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3185 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30537 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3186 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30543 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3187 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30549 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3190 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30555 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3191 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30561 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3196 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30567 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3197 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30573 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3202 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 30581 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3206 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 30589 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3210 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30597 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3214 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30605 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3218 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"), (yylsp[0]));
				}
#line 30613 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3222 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 30621 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3226 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30629 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3230 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30637 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3234 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 30645 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3238 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star), (yylsp[-2]));
				}
#line 30653 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3242 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list), (yylsp[-3]));
				}
#line 30661 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3246 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 30669 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3250 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30677 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3259 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 30685 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3262 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 30691 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3267 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30699 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3270 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 30705 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3281 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 30713 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3285 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 30721 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3292 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 30729 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3298 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 30735 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3299 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 30741 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3300 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 30747 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3301 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 30753 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3302 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30759 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3307 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 30767 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3311 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 30775 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3318 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 30781 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3332 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 30802 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3351 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 30823 "gram.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3370 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 30845 "gram.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3390 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 30867 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3410 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 30889 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3430 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 30911 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3460 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30917 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3461 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30923 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3462 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30929 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3463 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30935 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3465 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 30946 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3472 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 30957 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3478 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 30963 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3479 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 30969 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3483 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30975 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3484 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30981 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3488 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30987 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3489 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30993 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3494 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31001 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3498 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31009 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3505 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 31017 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3509 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 31025 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3515 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31031 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3516 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31037 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3517 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31043 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3521 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31049 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3522 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31055 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3526 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 31079 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3548 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31101 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3566 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 31123 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3586 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31129 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3587 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 31135 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3591 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31141 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3592 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31147 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3596 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 31153 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3597 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31159 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3602 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 31170 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3608 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31176 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3609 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31182 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3611 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31199 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3642 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31210 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3649 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31221 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3656 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31236 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3667 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31251 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3678 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 31267 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3690 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 31282 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3701 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 31295 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3710 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *)n;
				}
#line 31322 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3733 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 31341 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3750 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 31347 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3751 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 31353 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3771 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31364 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3778 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31375 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3785 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31386 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3792 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31397 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3803 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 31409 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3813 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 31415 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3814 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 31421 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3815 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 31427 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3819 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 31433 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3820 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 31439 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3821 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 31445 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3822 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 31451 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3823 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 31457 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3824 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 31463 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3825 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 31469 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3826 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 31475 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3827 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 31481 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3828 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 31487 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3838 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 31498 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3844 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31504 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3849 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 31521 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3863 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31540 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3878 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31559 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3894 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31578 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3909 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31597 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3926 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method	= (yyvsp[-8].str);
					n->exclusions		= (yyvsp[-6].list);
					n->including		= (yyvsp[-4].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31618 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3944 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 31640 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3963 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 31646 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3964 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 31652 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3968 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31658 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3969 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31664 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3973 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31670 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3974 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31676 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3978 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 31684 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3983 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31690 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3984 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31696 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3988 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 31704 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3992 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 31716 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 4000 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 31724 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 4004 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 31732 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 4010 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 31738 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 4012 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 31744 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 4016 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 31752 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 4021 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 31760 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 4027 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 31766 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 4028 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31772 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 4039 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 31778 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 4041 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 31784 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 4043 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 31790 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 4045 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 31796 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4047 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 31802 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4050 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 31808 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4053 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 31814 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4057 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 31820 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4058 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 31826 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4059 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 31832 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4060 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 31838 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4061 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 31844 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4064 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31850 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4065 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31856 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4069 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 31862 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4070 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 31868 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4074 "gram.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = (yyvsp[-3].str);
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 31882 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4085 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 31888 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4086 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 31894 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4090 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 31909 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4101 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 31924 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4112 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 31939 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4125 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31945 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4126 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31951 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4131 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31957 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4132 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31963 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4133 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31969 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4136 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 31975 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4137 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 31981 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4138 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 31987 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4139 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 31993 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4142 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31999 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4143 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32005 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4146 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32011 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4147 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32017 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4150 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32023 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4170 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 32038 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4182 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 32053 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4201 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 32059 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4202 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 32065 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4206 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 32075 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4212 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 32085 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4218 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 32095 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4235 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);
					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 32107 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4243 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);
					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 32119 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4264 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32136 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4277 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32153 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4294 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 32169 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4308 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32175 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4309 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32181 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4310 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32187 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4323 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32204 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4336 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32221 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 32237 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4365 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 32243 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4366 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 32249 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4379 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 32261 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4399 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 32275 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4409 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 32289 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4422 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32301 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4430 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32313 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4440 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32319 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4441 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32325 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4444 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32331 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4445 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32337 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4448 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32343 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4449 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32349 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4453 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].typnam), (yylsp[-1]));
				}
#line 32357 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4457 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 32365 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4461 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 32373 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4465 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 32381 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4469 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 32389 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4473 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 32397 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4477 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 32405 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 32413 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4485 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 32421 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4489 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 32429 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4493 "gram.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 32438 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4498 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 32446 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4502 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 32454 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4506 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 32462 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4516 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 32468 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4517 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 32474 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4519 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 32483 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4523 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 32489 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4526 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 32495 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4527 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 32501 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4540 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *)n;
			}
#line 32520 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4556 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 32535 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4569 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32541 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4570 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32547 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4578 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32553 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4579 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 32559 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4583 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32565 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4584 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32571 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4588 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32577 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4589 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32583 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4593 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32589 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4594 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32595 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4610 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32608 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4620 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 32614 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4621 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 32620 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4635 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32631 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4642 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32642 "gram.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4659 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32654 "gram.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4667 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32666 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4678 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32672 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4680 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32678 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4685 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32686 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4689 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32694 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4693 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 32705 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4700 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 32713 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4712 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32724 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4722 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32730 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4724 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32736 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4729 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32744 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4742 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 32757 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4751 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32770 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4760 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32783 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4769 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 32796 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4778 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 32809 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4787 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32822 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4796 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32835 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4805 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 32848 "gram.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4814 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 32861 "gram.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4823 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32874 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4832 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32887 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4841 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 32900 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4850 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 32913 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4868 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32925 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4878 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 32931 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4879 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 32937 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4880 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 32943 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4881 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 32949 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4885 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32955 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4886 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32961 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4890 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32967 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4891 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32973 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4902 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32985 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4910 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 32997 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4921 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33003 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4922 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33009 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4927 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 33017 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4931 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 33025 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4938 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33031 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4943 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 33039 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4947 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 33047 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4954 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 33055 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4958 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 33064 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4963 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 33073 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4968 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 33081 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4975 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 33089 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4981 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33095 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4986 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 33101 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 4998 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33116 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5010 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33131 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5023 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33137 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5024 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33143 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5029 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33149 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5030 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33155 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5034 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33161 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5035 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33167 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5046 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 33180 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5055 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 33192 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5063 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33203 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5082 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33225 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5102 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33247 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5122 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33270 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5143 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33293 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5175 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 33308 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5188 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 33314 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5189 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 33320 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5194 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 33331 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5201 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 33342 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5217 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33355 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5226 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33368 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5237 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 33374 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5238 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 33380 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5251 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33392 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5259 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33404 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5276 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33416 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5302 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 33432 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5318 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 33446 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5330 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 33452 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5331 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33458 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5335 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 33464 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5336 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33470 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5340 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33476 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5341 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 33482 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5345 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33488 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5346 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 33494 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5351 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
									 parser_errposition((yylsp[0]))));

				}
#line 33512 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5364 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33518 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5368 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33524 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5369 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 33530 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5373 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 33536 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5374 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 33542 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5375 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 33548 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5376 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 33554 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5377 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 33560 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5388 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);
					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 33572 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5398 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 33578 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5399 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 33584 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5413 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 33608 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5436 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 33637 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5463 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 33643 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5464 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 33649 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5465 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 33655 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5470 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33661 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5472 "gram.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 33684 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5494 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 33690 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5496 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 33696 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 33702 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5500 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 33708 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5502 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 33714 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5506 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33720 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5507 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33726 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5511 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33732 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5512 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 33738 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5517 "gram.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);
					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *)n;
				}
#line 33750 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5527 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33756 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5528 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33762 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5532 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33768 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5541 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33774 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5545 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33780 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5550 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 33788 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5554 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 33800 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5569 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33806 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5570 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33812 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5574 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 33818 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5575 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33824 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5584 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 33830 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5585 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 33836 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5586 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33842 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5591 "gram.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 33850 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5594 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 33856 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5595 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 33862 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5596 "gram.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 33868 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5600 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 33874 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5601 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 33880 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5606 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 33886 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5608 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 33914 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5634 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 33920 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5635 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 33926 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5636 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 33932 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5637 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 33938 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5638 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 33944 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5639 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 33950 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5654 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 33963 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5665 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 33976 "gram.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5677 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33982 "gram.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5679 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33988 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5684 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 33994 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5689 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34000 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5691 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 34006 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5696 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 34017 "gram.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5705 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 34023 "gram.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5706 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 34029 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5707 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 34035 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5708 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 34041 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5720 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 34053 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5739 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34068 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5750 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34084 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5762 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34098 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5772 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34112 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5782 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34127 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5793 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 34140 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5802 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 34151 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5809 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34162 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5816 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34175 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5825 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34188 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5834 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34201 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5843 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34214 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5852 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34227 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5861 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 34241 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5871 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 34254 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5880 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 34268 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5891 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34274 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5894 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34280 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5895 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 34286 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5899 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 34294 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5903 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 34302 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5909 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 34308 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5910 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 34314 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5911 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 34320 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5912 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 34326 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5913 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 34332 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5914 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 34338 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5917 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34344 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5920 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34350 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5921 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 34356 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5930 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node), (yylsp[-2]));
				}
#line 34364 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5936 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34370 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5937 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34376 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5941 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34382 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5943 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 34388 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5954 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 34403 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5965 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 34418 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5976 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 34433 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5987 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 34448 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 5999 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34454 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6000 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34460 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6018 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34475 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6031 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34481 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6032 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34487 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6037 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);
					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 34503 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6050 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 34516 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6059 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 34528 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6067 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 34541 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6076 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 34552 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6084 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34558 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6085 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34564 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6088 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34570 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6089 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34576 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6092 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34582 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6093 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34588 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6094 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34594 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6098 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 34612 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6111 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34618 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6117 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34629 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6127 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34642 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6136 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34655 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6147 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34661 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6148 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34667 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6153 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 34679 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6161 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 34691 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6173 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34705 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6183 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34719 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6196 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34733 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6206 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34747 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6228 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 34758 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6238 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 34769 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6256 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34783 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6266 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34797 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6276 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34811 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6286 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34825 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6296 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34839 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6306 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34853 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6316 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34867 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6326 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34881 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6336 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34895 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6346 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34909 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6356 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 34923 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6366 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 34937 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6379 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 34943 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6380 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 34949 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6381 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 34955 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6382 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 34961 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6383 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 34967 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6384 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 34973 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6385 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 34979 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6386 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 34985 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6387 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 34991 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6388 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 34997 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6389 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 35003 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6390 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 35009 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6391 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 35015 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6401 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = (yyvsp[0].objtype); }
#line 35021 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6402 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 35027 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6403 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 35033 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6404 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 35039 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6405 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 35045 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6409 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 35051 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6410 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 35057 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6411 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 35063 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6412 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 35069 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6413 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 35075 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6414 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 35081 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6415 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 35087 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6416 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 35093 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6421 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 35099 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6422 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 35105 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6423 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 35111 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6427 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 35117 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6428 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 35123 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6431 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35129 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6432 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 35135 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6436 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35141 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6438 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35147 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6442 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 35153 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6443 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 35159 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6455 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35171 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6465 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35177 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6466 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35183 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6467 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35189 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6478 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35201 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6486 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35213 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6494 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35225 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6502 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35237 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6510 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35249 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6518 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35261 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6526 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35273 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6534 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35285 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6542 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35297 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6550 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35314 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6563 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35326 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6571 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35338 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6579 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35350 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6587 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35362 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6595 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35374 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6603 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35386 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6611 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35398 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6619 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35410 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6629 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35416 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6630 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35422 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6646 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35435 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6656 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35448 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6666 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35461 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6676 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35474 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6686 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35487 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6696 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35500 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6706 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35513 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6716 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35526 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6726 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35539 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6736 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35552 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6746 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35558 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6747 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35564 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6750 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35570 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6751 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35576 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6762 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = false;
					(yyval.node) = (Node *)n;
				}
#line 35586 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6768 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = true;
					(yyval.node) = (Node *)n;
				}
#line 35596 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6776 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35608 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6784 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35620 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6792 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35632 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6800 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35644 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6808 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35656 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6816 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 35668 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6824 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35680 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6832 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35692 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6840 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35704 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6848 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 35716 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6856 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35728 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6864 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35740 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6872 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 35752 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6880 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35764 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6888 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35776 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6896 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 35788 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6922 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node*)n;
				}
#line 35805 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6939 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35823 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6954 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35841 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6980 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35847 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6982 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35853 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6984 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35859 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6986 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 35870 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6993 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 35881 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7001 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 35887 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 7002 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 35893 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 7006 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35904 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 7013 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35915 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 7020 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35926 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7027 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35937 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 7041 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35949 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 7049 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35961 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 7057 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35973 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 7065 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35985 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7073 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35997 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7081 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36009 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7089 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36021 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7097 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36033 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 7105 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36045 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 7113 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36057 "gram.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 7121 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36069 "gram.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 7129 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36081 "gram.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 7137 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36093 "gram.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 7145 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36105 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7153 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36117 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7161 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36129 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7169 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36141 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7177 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36153 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7185 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36165 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7193 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36177 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7204 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 36183 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7205 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 36189 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7209 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36195 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7210 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36201 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7215 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36207 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7216 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36213 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7227 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node*)n;
				}
#line 36227 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7240 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 36241 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7250 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 36255 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7261 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36261 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7262 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36267 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7265 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36273 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7266 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 36279 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7277 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 36290 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7286 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36296 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7287 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36302 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7292 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 36310 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7296 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 36318 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7300 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 36326 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7312 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 36342 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7325 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 36359 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7339 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 36376 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7354 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 36382 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7355 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 36388 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7356 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 36394 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7357 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 36400 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7358 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 36406 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7359 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 36412 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7374 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-13].boolean);
					n->concurrent = (yyvsp[-11].boolean);
					n->idxname = (yyvsp[-10].str);
					n->relation = (yyvsp[-8].range);
					n->accessMethod = (yyvsp[-7].str);
					n->indexParams = (yyvsp[-5].list);
					n->indexIncludingParams = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 36444 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7404 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-16].boolean);
					n->concurrent = (yyvsp[-14].boolean);
					n->idxname = (yyvsp[-10].str);
					n->relation = (yyvsp[-8].range);
					n->accessMethod = (yyvsp[-7].str);
					n->indexParams = (yyvsp[-5].list);
					n->indexIncludingParams = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 36476 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7434 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36482 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7435 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36488 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7439 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36494 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7440 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36500 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7444 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36506 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7445 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36512 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7449 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36518 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7450 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 36524 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7453 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 36530 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7454 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 36536 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7460 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 36552 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7472 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 36568 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7491 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 36577 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 36586 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7501 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 36595 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7507 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36601 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7508 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36607 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7511 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 36613 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7512 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 36619 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7515 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36625 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7516 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36631 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7519 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36637 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7520 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36643 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7523 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 36649 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7524 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 36655 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7525 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 36661 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7528 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 36667 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7529 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 36673 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7530 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 36679 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7548 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 36695 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7561 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 36712 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7575 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 36728 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7588 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 36744 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7602 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36750 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7603 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36756 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7606 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36762 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7607 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36768 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7611 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 36774 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7612 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 36780 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7616 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 36786 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7618 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 36792 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7623 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 36804 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7636 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 36815 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7643 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 36826 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7650 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 36838 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7664 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36844 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7665 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36850 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7669 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 36856 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7671 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 36862 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7686 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36875 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7695 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36888 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7704 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36901 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7713 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36914 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7722 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36927 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7733 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 36933 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7734 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 36939 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7735 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 36945 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7736 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 36951 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7737 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 36957 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7748 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 36969 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7762 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 36975 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7764 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 36985 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7770 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 36996 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7780 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 37004 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7784 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 37013 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7789 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 37022 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7797 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 37037 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7839 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 37045 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7843 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 37053 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7847 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 37061 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7851 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 37070 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7858 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 37076 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7859 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 37082 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7864 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 37094 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7874 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 37100 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7876 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 37106 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7881 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37112 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7886 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37118 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7887 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37124 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7895 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(false), (yylsp[-3]));
				}
#line 37132 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7899 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(true), (yylsp[-4]));
				}
#line 37140 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7903 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 37148 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7907 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"), (yylsp[0]));
				}
#line 37156 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7911 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"), (yylsp[0]));
				}
#line 37164 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7915 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"), (yylsp[0]));
				}
#line 37172 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7919 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(true), (yylsp[-2]));
				}
#line 37180 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7923 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(false), (yylsp[-2]));
				}
#line 37188 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7927 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(true), (yylsp[-1]));
				}
#line 37196 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7931 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 37204 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7935 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 37212 "gram.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7939 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 37220 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7943 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 37228 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7947 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 37236 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7951 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 37244 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7955 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 37253 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7960 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 37261 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7967 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 37269 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7971 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 37277 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7975 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 37285 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7979 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 37293 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7983 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 37301 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7988 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37307 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7990 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 37315 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7996 "gram.y" /* yacc.c:1646  */
    {
					ReturnStmt *r = makeNode(ReturnStmt);
					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 37325 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 8005 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 37333 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 8009 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 37347 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 8019 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = NULL;
				}
#line 37355 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 8026 "gram.y" /* yacc.c:1646  */
    {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 37367 "gram.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 8034 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 37375 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 8045 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 37381 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 8046 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 37387 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 8050 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37393 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 8051 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37399 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8055 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37412 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8067 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 37420 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8071 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 37428 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8086 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37440 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8094 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37452 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8102 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37464 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8113 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37470 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8114 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37476 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8138 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37490 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8148 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37504 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8158 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37518 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8168 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37532 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8178 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37546 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8188 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37560 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8201 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37574 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8211 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37588 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8224 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37602 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8234 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37616 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8247 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 37628 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8255 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 37634 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8257 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 37640 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8259 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 37646 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8264 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37652 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8266 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 37658 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8270 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 37664 "gram.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8272 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 37670 "gram.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8277 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 37681 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8295 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37691 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8303 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37697 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8304 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37703 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8309 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 37711 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8313 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 37719 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8326 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 37733 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8337 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 37747 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8348 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 37761 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8359 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 37767 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8360 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 37773 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8361 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 37779 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8366 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37793 "gram.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8377 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37799 "gram.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8378 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37805 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8389 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 37819 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8401 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 37827 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8405 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 37835 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8409 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 37843 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8413 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 37851 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8420 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37864 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8440 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
								makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37880 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8452 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
								makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37896 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8464 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
								makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37912 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8476 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
								makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37928 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8489 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 37934 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8490 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 37940 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8493 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 37946 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8494 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 37952 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8495 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 37958 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8506 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *)n;
				}
#line 37971 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8515 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *)n;
				}
#line 37984 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8532 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37997 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8541 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38010 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8550 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38023 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8559 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38036 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8568 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38049 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8577 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38062 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8586 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38075 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8595 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38088 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8604 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38101 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8613 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38114 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8622 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38127 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8631 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38140 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8640 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38154 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8650 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38168 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 8660 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38181 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 8669 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38194 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 8678 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38207 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8687 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38220 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8696 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38233 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8705 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38246 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8714 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38260 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8724 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38274 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8734 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38288 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8744 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38302 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8754 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38316 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8764 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38330 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8774 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38344 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8784 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38358 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8794 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38372 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8804 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38386 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8814 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38400 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8824 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38414 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8834 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38429 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8845 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38444 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8856 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38459 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8867 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38474 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8878 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38489 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8889 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38504 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8900 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38518 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8910 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38532 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8920 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38547 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8931 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38562 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8942 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38576 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8952 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38590 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8962 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38602 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8970 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38615 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8979 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38628 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8988 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38641 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8997 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38654 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 9006 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38667 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 9015 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38680 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 9024 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38693 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 9033 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38706 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 9042 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38719 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 9051 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38735 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 9068 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 38741 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 9069 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 38747 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 9080 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38760 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 9089 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38773 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 9098 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38786 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 9107 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38800 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 9117 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38813 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 9126 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38826 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 9136 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38832 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 9137 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 38838 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 9148 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38851 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 9157 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38864 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 9166 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38877 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 9175 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38890 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9184 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38903 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9193 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38916 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9202 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38929 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9211 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38942 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9220 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38955 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9229 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38968 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9238 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38981 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9247 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38994 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9256 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39007 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9265 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39020 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9274 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39033 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9283 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39046 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9292 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39059 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9301 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39072 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9310 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39085 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9319 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39098 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 9328 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39111 "gram.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 9337 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39124 "gram.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9346 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39137 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9355 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39150 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9364 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39163 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9373 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39176 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9382 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39189 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9400 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 39200 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9408 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39206 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9409 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 39212 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9413 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 39218 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9415 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 39224 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9420 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 39230 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9421 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 39236 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 9422 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 39242 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 9423 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 39248 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 9424 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 39254 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 9437 "gram.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);
					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 39265 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 9452 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39277 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9460 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39289 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9468 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39301 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9476 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39313 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9484 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39325 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9492 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39337 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9500 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39349 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9508 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].value);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39361 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9516 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39373 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9524 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39385 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9532 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39397 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9540 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39409 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9548 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39421 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9556 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39433 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9564 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39445 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9572 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39457 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9580 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39469 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9588 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39481 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9596 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39493 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9604 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39505 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9612 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39517 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9620 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39529 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9628 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39541 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9636 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39553 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9654 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					if ((yyvsp[-1].node) != NULL)
					{
						/* FOR TABLE */
						if (IsA((yyvsp[-1].node), List))
							n->tables = (List *)(yyvsp[-1].node);
						/* FOR ALL TABLES */
						else
							n->for_all_tables = true;
					}
					(yyval.node) = (Node *)n;
				}
#line 39573 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9672 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39579 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9673 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 39585 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9678 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].list);
				}
#line 39593 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9682 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeInteger(true);
				}
#line 39601 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9702 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39612 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9709 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_ADD;
					(yyval.node) = (Node *)n;
				}
#line 39624 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9717 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_SET;
					(yyval.node) = (Node *)n;
				}
#line 39636 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9725 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_DROP;
					(yyval.node) = (Node *)n;
				}
#line 39648 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9742 "gram.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39662 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9761 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39675 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9770 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39688 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9779 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39701 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9788 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39715 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9798 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39729 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9808 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39743 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9818 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(true), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 39757 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 9828 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(false), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 39771 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9846 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39783 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9854 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39795 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9872 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39811 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9886 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39817 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9887 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 39823 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9888 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39829 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9894 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 39839 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9900 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 39849 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9916 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39855 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9917 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 39861 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9920 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 39867 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9921 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 39873 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9922 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 39879 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9923 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 39885 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9927 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39891 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9928 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39897 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9929 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39903 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9942 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39914 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9951 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39920 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9952 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39926 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9956 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39936 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9965 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39946 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9971 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 39956 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9990 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39968 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 9998 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39979 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 10005 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39991 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 10013 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 40003 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 10021 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40014 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 10028 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40025 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 10035 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40036 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 10042 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40047 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 10049 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40058 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 10056 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40069 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 10063 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40080 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 10070 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40091 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 10080 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40102 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 10087 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 40114 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 10103 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 40121 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 10106 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 40128 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 10109 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 40135 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 10112 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 40142 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 10115 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 40149 "gram.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 10122 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40155 "gram.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 10124 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 40161 "gram.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 10126 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40167 "gram.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 10132 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40173 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10136 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40179 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10137 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40185 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10138 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40191 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10152 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 40207 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10165 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 40223 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10178 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 40244 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10196 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 40265 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10215 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 40271 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 10216 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 40277 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10217 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 40283 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10218 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 40289 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10229 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40299 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 10245 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40310 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 10254 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40316 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 10255 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40322 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 10259 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40328 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 10260 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40334 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 10265 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 40342 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 10269 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 40350 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 10273 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 40358 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 10290 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40364 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 10291 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 40370 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 10292 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40376 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 10293 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40382 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 10294 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40388 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 10295 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40394 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 10296 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40400 "gram.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 10316 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 40411 "gram.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 10323 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 40422 "gram.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 10330 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *)makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *)n;
				 }
#line 40434 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 10341 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 40445 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 10358 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *)n;
				}
#line 40457 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 10366 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *)n;
				}
#line 40469 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 10374 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 40481 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 10382 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 40493 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 10393 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 40501 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 10397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 40509 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 10408 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 40517 "gram.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 10420 "gram.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);
					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 40527 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 10437 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 40537 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 10443 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 40547 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 10459 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 40560 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 10472 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 40572 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 10481 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 40583 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 10489 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 40594 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 10497 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 40606 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 10506 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40620 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 10517 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 40634 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 10528 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40646 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 10550 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40657 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 10560 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 40672 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 10571 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 40687 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 10582 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 40702 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 10593 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 40717 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 10604 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 40730 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 10613 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 40743 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 10641 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 40757 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 10664 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node*)n;
				}
#line 40771 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 10675 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node*)n;
				}
#line 40783 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 10683 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node*)n;
				}
#line 40797 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 10694 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node*)n;
				}
#line 40811 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 10706 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40817 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 10707 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 40823 "gram.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10720 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *)n;
				}
#line 40847 "gram.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10740 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 40859 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10750 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *)n;
				}
#line 40874 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10761 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 40886 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10772 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 40894 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10776 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 40902 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10788 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 40910 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10794 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40916 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10795 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 40922 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10799 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 40928 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10800 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 40934 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10801 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40940 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10805 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40946 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10806 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40952 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10810 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40958 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10811 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40964 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10814 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40970 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10815 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40976 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10818 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40982 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10819 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40988 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10823 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40994 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10824 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41000 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10829 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 41008 "gram.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10836 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41014 "gram.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10838 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41020 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10842 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41026 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10843 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41032 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10857 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 41043 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10864 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41057 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10874 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41068 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10881 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 41079 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10909 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 41091 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10918 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41097 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10919 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41103 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10937 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41114 "gram.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10945 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 41134 "gram.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10962 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 41154 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10979 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41160 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10980 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41166 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10991 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 41176 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10997 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 41186 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 11003 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 41196 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 11009 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 41206 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 11026 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 41218 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 11043 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 41226 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 11047 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 41235 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 11055 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41245 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 11061 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41256 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 11068 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41266 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 11074 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41277 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 11081 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 41287 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 11089 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 41293 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 11090 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 41299 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 11095 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 41305 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 11097 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 41311 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 11102 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 41323 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 11113 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 41336 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 11123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 41349 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 11132 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 41357 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 11139 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 41369 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 11148 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 41381 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 11156 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 41389 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 11162 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41395 "gram.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 11163 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41401 "gram.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 11176 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 41415 "gram.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 11188 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41421 "gram.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 11189 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41427 "gram.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 11201 "gram.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 41440 "gram.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 11211 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 41446 "gram.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 11212 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 41452 "gram.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 11215 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 41458 "gram.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 11216 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 41464 "gram.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 11217 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 41470 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 11218 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 41476 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 11219 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 41482 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 11220 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 41488 "gram.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 11221 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 41494 "gram.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 11222 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 41500 "gram.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 11225 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41506 "gram.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 11226 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41512 "gram.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 11230 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 41518 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 11231 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 41524 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 11232 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 41530 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 11248 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 41545 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 11260 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41551 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 11261 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 41557 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 11266 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 41566 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 11271 "gram.y" /* yacc.c:1646  */
    {
					int ncolumns = list_length((yyvsp[-3].list));
					int i = 1;
					ListCell *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 41591 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 11295 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 41603 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 11305 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 41609 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 11306 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 41615 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 11317 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 41628 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 11327 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41634 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 11330 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41640 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 11331 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 41646 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 11332 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 41652 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 11333 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 41658 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 11334 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 41664 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 11335 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 41670 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 11338 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41676 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 11339 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 41682 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 11340 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41688 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 11393 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 41694 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 11394 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 41700 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 11409 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41706 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 11411 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 41717 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 11418 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41729 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 11426 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41741 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 11434 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 41753 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 11442 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 41765 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 11450 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41777 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 11458 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41789 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 11468 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41795 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 11469 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41801 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 11504 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41818 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 11519 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41836 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 11532 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41842 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 11534 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 41865 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 11553 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41873 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 11557 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41881 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 11561 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41889 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 11576 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 41900 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 11583 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 41911 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 11590 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 41922 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 11599 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41928 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 11600 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41934 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 11604 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 41950 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 11618 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 41956 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 11619 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 41962 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 11620 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 41968 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 11625 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);
				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 41981 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 11634 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);
				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 41994 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 11643 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 42002 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 11650 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);
				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 42017 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 11661 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);
				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 42032 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 11672 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 42040 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 11678 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 42046 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 11679 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 42052 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 11684 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 42067 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 11695 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 42073 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 11704 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42082 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 11709 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42091 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11714 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42100 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11719 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42109 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11724 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42121 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11732 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42133 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11740 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 42142 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11745 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 42151 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11750 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 42160 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 11761 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 42166 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 11762 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 42172 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11763 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 42178 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11770 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 42184 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11771 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42190 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 11780 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42196 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 11781 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42202 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11785 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42208 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11786 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42214 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11790 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42220 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11794 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 42226 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11795 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 42232 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11799 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 42245 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11808 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 42258 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11821 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 42267 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11826 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 42276 "gram.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11831 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 42284 "gram.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11835 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 42296 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11845 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 42302 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11846 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 42308 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11851 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 42320 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11859 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 42333 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11875 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 42345 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11883 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 42357 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11891 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 42369 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11899 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 42381 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11910 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42387 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11913 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 42393 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11917 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42399 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11919 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 42408 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11926 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42414 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11946 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42420 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11948 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 42426 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11950 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 42432 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11954 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 42438 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11955 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 42444 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11959 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42450 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11960 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42456 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11963 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42462 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11964 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42468 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11990 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));
					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 42479 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11997 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));
					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 42490 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 12006 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42496 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 12007 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 42502 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 12011 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42508 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 12012 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42514 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 12013 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42520 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 12014 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42526 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 12015 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42532 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 12020 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 42540 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 12033 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42548 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 12040 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42556 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 12047 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 42564 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 12053 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42570 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 12054 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42576 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 12058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42582 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 12059 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42588 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 12063 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42594 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 12064 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42600 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 12068 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42606 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 12069 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 42612 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 12074 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 42624 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 12084 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 42630 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 12085 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 42636 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 12086 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 42642 "gram.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 12087 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 42648 "gram.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 12091 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42654 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 12092 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42660 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 12103 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 42670 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 12109 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 42680 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 12126 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42686 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 12127 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42692 "gram.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 12131 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42698 "gram.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 12132 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 42704 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 12139 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 42713 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 12144 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);
					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 42725 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 12152 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 42736 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 12159 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 42748 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 12167 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 42758 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 12173 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 42769 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 12180 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 42808 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 12215 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 42837 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 12240 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 42845 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 12244 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 42854 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 12270 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 42862 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 12274 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 42879 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 12287 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 42903 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 12307 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 42928 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 12328 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 42944 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 12340 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 42961 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 12356 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42971 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 12362 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42980 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 12367 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42990 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 12373 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42999 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 12379 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 43005 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 12380 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 43011 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 12391 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 43021 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 12396 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 43027 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 12405 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 43035 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 12409 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 43043 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 12413 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 43053 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 12419 "gram.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 43063 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 12425 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 43071 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 12430 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 43077 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 12431 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 43083 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 12432 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 43089 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 12433 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 43095 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 12454 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 43103 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 12458 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 43111 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 12466 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 43122 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 12473 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 43133 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 12480 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 43144 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 12487 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 43155 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 12497 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 43161 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 12498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 43167 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 12512 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 43175 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 12516 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 43186 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 12523 "gram.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 43197 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 12536 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 43211 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 12548 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 43217 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 12549 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43223 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 12565 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 43237 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 12575 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 43251 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 12587 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 43257 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 12591 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 43263 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 12592 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 43269 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 12595 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43275 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 12596 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43281 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 12599 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43287 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 12600 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43293 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 12605 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43299 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 12606 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43305 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 12611 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43311 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 12613 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 43323 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12620 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43329 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12625 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43335 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12626 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43341 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 12631 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 43349 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 12635 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 43357 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12641 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 43379 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12665 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 43393 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12676 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *)n;
				}
#line 43407 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12687 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43413 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12688 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 43419 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12693 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 43437 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12707 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);
					ListCell		   *option;
					bool				nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = intVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 43498 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12764 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 43513 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12778 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 43519 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12780 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 43525 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12785 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 43531 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12787 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 43537 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12789 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(true), (yylsp[-1])); }
#line 43543 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12791 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(false), (yylsp[0])); }
#line 43549 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12796 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43555 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12798 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 43561 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12803 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 43573 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12811 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 43585 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12831 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 43594 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12836 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 43604 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12843 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 43613 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12848 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 43623 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12854 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 43632 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12859 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 43642 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12868 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 43648 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12870 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 43654 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12872 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 43660 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12876 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43666 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12877 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43672 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12878 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43678 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12879 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43684 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12880 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43690 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12882 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 43699 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12887 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 43709 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12906 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43715 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12907 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43721 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12908 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43727 "gram.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12909 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43733 "gram.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12921 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43743 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12927 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 43753 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12934 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43759 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12935 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43765 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12942 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43774 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12947 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43783 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12952 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43792 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12957 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43801 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12962 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43810 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12967 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43819 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12972 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43828 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12977 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43838 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 12983 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43848 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 12989 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43858 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 12995 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43867 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 13002 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 43892 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 13023 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 43900 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 13033 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43908 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 13037 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43916 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 13045 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43924 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 13049 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 43933 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 13057 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43946 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 13069 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43964 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 13090 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43972 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 13094 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43980 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 13100 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43988 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 13104 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 44003 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 13117 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 44013 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 13125 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 44025 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 13135 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44031 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 13137 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44037 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 13139 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 44043 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 13141 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44049 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 13143 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44055 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 13145 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44061 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 13149 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44067 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 13150 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44073 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 13158 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 44086 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 13167 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 44098 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 13175 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 44111 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 13184 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 44123 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 13195 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 44132 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 13202 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44138 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 13203 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44144 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 13204 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44150 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 13209 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 44156 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 13211 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 44162 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 13213 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 44168 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 13215 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 44174 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 13217 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 44180 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 13219 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44186 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 13221 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 44195 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 13226 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 44204 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 13231 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 44214 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 13237 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 44226 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 13245 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 44235 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 13250 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 44246 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 13257 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 44256 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 13263 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44262 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 13268 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 44270 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 13272 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 44279 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 13307 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44285 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 13309 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 44291 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 13311 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 44303 "gram.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 13319 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 44314 "gram.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 13335 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44320 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 13337 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44326 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 13339 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44332 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 13341 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44338 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 13343 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44344 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 13345 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44350 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 13347 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44356 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 13349 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44362 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 13351 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44368 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 13353 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44374 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 13355 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44380 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 13357 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44386 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 13359 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44392 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 13361 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44398 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 13364 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44404 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 13366 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44410 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 13369 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44416 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 13371 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44422 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 13373 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 44428 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 13375 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 44434 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 13378 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 44443 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 13383 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 44456 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 13392 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 44465 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 13397 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 44478 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 13406 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 44487 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 13411 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 44500 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 13420 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 44509 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 13425 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 44522 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 13435 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make1((yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 44535 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 13444 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 44548 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 13453 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make1((yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 44561 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 13462 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 44574 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 13481 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44586 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 13489 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44598 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 13497 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 44610 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 13505 "gram.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44622 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 13513 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 44643 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 13530 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 44655 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 13538 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 44667 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 13546 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 44679 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 13554 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 44691 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 13562 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 44703 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 13570 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 44715 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 13578 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 44723 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 13582 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 44731 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 13586 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 44743 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 13594 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 44755 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 13602 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 44767 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 13610 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 44779 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 13618 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 44803 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 13638 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 44829 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 13660 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 44844 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 13671 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 44855 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 13678 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 44875 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 13694 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 44884 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 13699 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 44894 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 13705 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 44905 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 13712 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 44916 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 13719 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 44928 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 13727 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 44940 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 13735 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);
					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44958 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 13760 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44964 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 13762 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 44970 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 13764 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44976 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 13766 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44982 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 13768 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44988 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 13770 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44994 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 13772 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45000 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 13774 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45006 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 13776 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45012 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 13778 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45018 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 13780 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45024 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 13782 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45030 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 13784 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45036 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 13786 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45042 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 13788 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45048 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 13790 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45054 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 13792 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45060 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 13794 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 45066 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 13796 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 45074 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 13800 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 45082 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 13804 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 45091 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 13809 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 45101 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 13824 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45107 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 13825 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45113 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 13827 "gram.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 45132 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 13842 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 45148 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 13854 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45154 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 13856 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45160 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 13858 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 45175 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 13869 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 45203 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 13893 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 45218 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 13904 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 45233 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 13915 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 45244 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 13922 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 45258 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 13932 "gram.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 45272 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 13942 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *)g;
			  }
#line 45283 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 13951 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 45293 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 13957 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 45305 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 13965 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 45318 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 13974 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-7]));
					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 45331 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 13983 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 45347 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 13995 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *)n;
				}
#line 45360 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 14004 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
					n->agg_star = true;
					(yyval.node) = (Node *)n;
				}
#line 45382 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 14034 "gram.y" /* yacc.c:1646  */
    {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 45421 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 14069 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45427 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 14079 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45433 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 14080 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45439 "gram.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 14088 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45450 "gram.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 14095 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 45458 "gram.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 14099 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 45466 "gram.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 14103 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 45474 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 14107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 45482 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 14111 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 45490 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 14115 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 45498 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 14119 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 45506 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 14123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 45514 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 14127 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 45522 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 14131 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 45530 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 14135 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 45538 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 14139 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 45546 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 14143 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 45554 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 14147 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 45562 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 14151 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 45570 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 14155 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 45576 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 14157 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45587 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 14164 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45598 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 14171 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 45609 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 14178 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45620 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 14185 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 45635 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 14196 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45653 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 14210 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45667 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 14220 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 45682 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 14231 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 45702 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 14247 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45716 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 14257 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45727 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 14264 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45738 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 14271 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45749 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 14278 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 45757 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 14282 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 45768 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 14289 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 45780 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 14297 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 45792 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 14305 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45800 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 14309 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 45808 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 14313 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 45816 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 14317 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 45824 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 14321 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 45832 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 14325 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45845 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 14334 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 45853 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 14338 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 45866 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 14347 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 45874 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 14351 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 45882 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 14355 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 45891 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 14360 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 45904 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 14374 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45910 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 14376 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 45916 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 14380 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 45922 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 14382 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 45928 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 14384 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 45934 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 14386 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 45940 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 14389 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45946 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 14392 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45952 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 14393 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45958 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 14397 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 45970 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 14405 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 45982 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 14414 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 45988 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 14415 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 45994 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 14418 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 46000 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 14419 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46006 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 14420 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46012 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 14426 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 46020 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 14430 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46028 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 14434 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 46036 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 14438 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46044 "gram.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 14453 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46050 "gram.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 14454 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46056 "gram.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 14458 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 46062 "gram.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 14459 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46068 "gram.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 14467 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46074 "gram.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 14468 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46080 "gram.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 14472 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 46086 "gram.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 14474 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 46092 "gram.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 14479 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 46102 "gram.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 14487 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 46108 "gram.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 14489 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 46125 "gram.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 14502 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 46131 "gram.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 14507 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 46149 "gram.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 14532 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46155 "gram.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 14533 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 46161 "gram.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 14536 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46167 "gram.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 14537 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46173 "gram.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 14546 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 46184 "gram.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 14553 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 46195 "gram.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 14560 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 46206 "gram.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 14567 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46218 "gram.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 14577 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 46239 "gram.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 14594 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 46280 "gram.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 14639 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46292 "gram.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 14647 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46304 "gram.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 14655 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46316 "gram.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 14663 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46328 "gram.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 14671 "gram.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46340 "gram.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 14681 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 46346 "gram.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 14682 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 46352 "gram.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 14683 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 46358 "gram.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 14684 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46364 "gram.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 14685 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46370 "gram.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 14699 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46376 "gram.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 14700 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46382 "gram.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 14701 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 46388 "gram.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 14704 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46394 "gram.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 14705 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46400 "gram.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 14708 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 46406 "gram.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 14711 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 46412 "gram.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 14712 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 46418 "gram.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 14713 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 46424 "gram.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 14716 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46430 "gram.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 14717 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46436 "gram.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 14720 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 46442 "gram.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 14721 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 46448 "gram.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 14722 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 46454 "gram.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 14723 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 46460 "gram.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 14724 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 46466 "gram.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 14725 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 46472 "gram.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 14726 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 46478 "gram.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 14727 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 46484 "gram.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 14728 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 46490 "gram.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 14729 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 46496 "gram.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 14730 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 46502 "gram.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 14731 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 46508 "gram.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 14735 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46514 "gram.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 14737 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46520 "gram.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 14742 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46526 "gram.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 14744 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46532 "gram.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 14749 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46538 "gram.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 14751 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46544 "gram.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 14753 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 46550 "gram.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 14755 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 46556 "gram.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 14757 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 46562 "gram.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 14759 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 46568 "gram.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 14771 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 46576 "gram.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 14775 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 46584 "gram.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 14782 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 46592 "gram.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 14786 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 46600 "gram.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 14792 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 46608 "gram.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 14796 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 46621 "gram.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 14805 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 46634 "gram.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 14815 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46640 "gram.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 14816 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46646 "gram.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 14819 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 46652 "gram.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 14820 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 46658 "gram.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 14824 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 46666 "gram.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 14828 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 46674 "gram.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 14832 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 46682 "gram.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 14837 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46688 "gram.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 14838 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46694 "gram.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 14844 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 46702 "gram.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 14853 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46708 "gram.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 14854 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 46714 "gram.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 14855 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 46720 "gram.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 14856 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 46726 "gram.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 14857 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 46732 "gram.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 14858 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 46738 "gram.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 14859 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 46744 "gram.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 14860 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46750 "gram.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 14864 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFC"; }
#line 46756 "gram.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 14865 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFD"; }
#line 46762 "gram.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 14866 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKC"; }
#line 46768 "gram.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 14867 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKD"; }
#line 46774 "gram.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 14873 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46783 "gram.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 14878 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46792 "gram.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 14886 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 46798 "gram.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 14908 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46806 "gram.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 14912 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 46815 "gram.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 14917 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46830 "gram.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 14928 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 46851 "gram.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 14945 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46859 "gram.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 14950 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 46865 "gram.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 14951 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46871 "gram.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 14952 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46877 "gram.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 14956 "gram.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 46888 "gram.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 14962 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 46894 "gram.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 14973 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 46908 "gram.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 14986 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46914 "gram.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 14987 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46920 "gram.c" /* yacc.c:1646  */
    break;

  case 2203:
#line 14992 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 46932 "gram.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 15002 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46938 "gram.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 15003 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46944 "gram.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 15006 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46950 "gram.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 15007 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46956 "gram.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 15011 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 46964 "gram.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 15015 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 46972 "gram.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 15022 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 46980 "gram.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 15026 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 46988 "gram.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 15030 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 47000 "gram.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 15038 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 47012 "gram.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 15048 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47018 "gram.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 15049 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47024 "gram.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 15053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47030 "gram.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 15054 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 47036 "gram.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 15058 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47042 "gram.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 15059 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 47048 "gram.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 15073 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47054 "gram.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 15074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47060 "gram.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 15078 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 47066 "gram.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 15079 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 47072 "gram.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 15083 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 47084 "gram.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 15091 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 47096 "gram.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 15099 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 47108 "gram.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 15107 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 47124 "gram.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 15128 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 47130 "gram.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 15129 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 47136 "gram.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 15141 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 47144 "gram.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 15145 "gram.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 47173 "gram.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 15172 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 47179 "gram.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 15174 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 47185 "gram.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 15178 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47191 "gram.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 15180 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47197 "gram.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 15182 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47203 "gram.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 15193 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 47209 "gram.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 15195 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 47218 "gram.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 15206 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 47226 "gram.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 15210 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 47234 "gram.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 15214 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 47242 "gram.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 15218 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 47250 "gram.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 15222 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 47263 "gram.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 15231 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 47274 "gram.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 15238 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 47310 "gram.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 15270 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 47318 "gram.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 15274 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 47328 "gram.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 15280 "gram.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 47339 "gram.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 15287 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 47347 "gram.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 15291 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 47355 "gram.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 15295 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 47363 "gram.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 15300 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 47369 "gram.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 15301 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47375 "gram.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 15303 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 47381 "gram.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 15304 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 47387 "gram.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 15305 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 47393 "gram.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 15310 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec *spc = (RoleSpec *) (yyvsp[0].rolespec);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 47435 "gram.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 15350 "gram.y" /* yacc.c:1646  */
    {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[0].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[0].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[0]))));
						}
						else
						{
							n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
							n->rolename = pstrdup((yyvsp[0].str));
						}
						(yyval.rolespec) = n;
					}
#line 47466 "gram.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 15377 "gram.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
					}
#line 47474 "gram.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 15381 "gram.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
					}
#line 47482 "gram.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 15385 "gram.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
					}
#line 47490 "gram.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 15391 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 47496 "gram.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 15393 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 47502 "gram.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 15410 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 47533 "gram.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 15443 "gram.y" /* yacc.c:1646  */
    {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 47548 "gram.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 15455 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47554 "gram.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 15456 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 47560 "gram.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 15477 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47566 "gram.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 15478 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47572 "gram.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 15479 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47578 "gram.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 15484 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47584 "gram.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 15485 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47590 "gram.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 15486 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47596 "gram.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 15491 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47602 "gram.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 15492 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47608 "gram.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 15493 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47614 "gram.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 15494 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47620 "gram.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 15500 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47626 "gram.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 15501 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47632 "gram.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 15502 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47638 "gram.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 15503 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47644 "gram.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 15504 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47650 "gram.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 15510 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47656 "gram.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 15511 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47662 "gram.c" /* yacc.c:1646  */
    break;


#line 47666 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 16455 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Value	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause && limitClause->limitOption != LIMIT_OPTION_DEFAULT)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}
/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

