/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         minimal_base_yyparse
#define yylex           minimal_base_yylex
#define yyerror         minimal_base_yyerror
#define yydebug         minimal_base_yydebug
#define yynerrs         minimal_base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram_minimal.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2021, PgPool Global Development Group
 * Portions Copyright (c) 1996-2021, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "pool_string.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_attribute.h
 */
#define		  ATTRIBUTE_IDENTITY_ALWAYS	'a'
#define		  ATTRIBUTE_IDENTITY_BY_DEFAULT 'd'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node *limitOffset;
	Node *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool	distinct;
	List   *list;
} GroupClause;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void minimal_base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeStringConst(char *str, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 311 "gram_minimal.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_MINIMAL_BASE_YY_Y_TAB_H_INCLUDED
# define YY_MINIMAL_BASE_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int minimal_base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSOLUTE_P = 276,
    ACCESS = 277,
    ACTION = 278,
    ADD_P = 279,
    ADMIN = 280,
    AFTER = 281,
    AGGREGATE = 282,
    ALL = 283,
    ALSO = 284,
    ALTER = 285,
    ALWAYS = 286,
    ANALYSE = 287,
    ANALYZE = 288,
    AND = 289,
    ANY = 290,
    ARRAY = 291,
    AS = 292,
    ASC = 293,
    ASENSITIVE = 294,
    ASSERTION = 295,
    ASSIGNMENT = 296,
    ASYMMETRIC = 297,
    ATOMIC = 298,
    AT = 299,
    ATTACH = 300,
    ATTRIBUTE = 301,
    AUTHORIZATION = 302,
    BACKWARD = 303,
    BEFORE = 304,
    BEGIN_P = 305,
    BETWEEN = 306,
    BIGINT = 307,
    BINARY = 308,
    BIT = 309,
    BOOLEAN_P = 310,
    BOTH = 311,
    BREADTH = 312,
    BY = 313,
    CACHE = 314,
    CALL = 315,
    CALLED = 316,
    CASCADE = 317,
    CASCADED = 318,
    CASE = 319,
    CAST = 320,
    CATALOG_P = 321,
    CHAIN = 322,
    CHAR_P = 323,
    CHARACTER = 324,
    CHARACTERISTICS = 325,
    CHECK = 326,
    CHECKPOINT = 327,
    CLASS = 328,
    CLOSE = 329,
    CLUSTER = 330,
    COALESCE = 331,
    COLLATE = 332,
    COLLATION = 333,
    COLUMN = 334,
    COLUMNS = 335,
    COMMENT = 336,
    COMMENTS = 337,
    COMMIT = 338,
    COMMITTED = 339,
    COMPRESSION = 340,
    CONCURRENTLY = 341,
    CONFIGURATION = 342,
    CONFLICT = 343,
    CONNECTION = 344,
    CONSTRAINT = 345,
    CONSTRAINTS = 346,
    CONTENT_P = 347,
    CONTINUE_P = 348,
    CONVERSION_P = 349,
    COPY = 350,
    COST = 351,
    CREATE = 352,
    CROSS = 353,
    CSV = 354,
    CUBE = 355,
    CURRENT_P = 356,
    CURRENT_CATALOG = 357,
    CURRENT_DATE = 358,
    CURRENT_ROLE = 359,
    CURRENT_SCHEMA = 360,
    CURRENT_TIME = 361,
    CURRENT_TIMESTAMP = 362,
    CURRENT_USER = 363,
    CURSOR = 364,
    CYCLE = 365,
    DATA_P = 366,
    DATABASE = 367,
    DAY_P = 368,
    DEALLOCATE = 369,
    DEC = 370,
    DECIMAL_P = 371,
    DECLARE = 372,
    DEFAULT = 373,
    DEFAULTS = 374,
    DEFERRABLE = 375,
    DEFERRED = 376,
    DEFINER = 377,
    DELETE_P = 378,
    DELIMITER = 379,
    DELIMITERS = 380,
    DEPENDS = 381,
    DEPTH = 382,
    DESC = 383,
    DETACH = 384,
    DICTIONARY = 385,
    DISABLE_P = 386,
    DISCARD = 387,
    DISTINCT = 388,
    DO = 389,
    DOCUMENT_P = 390,
    DOMAIN_P = 391,
    DOUBLE_P = 392,
    DROP = 393,
    EACH = 394,
    ELSE = 395,
    ENABLE_P = 396,
    ENCODING = 397,
    ENCRYPTED = 398,
    END_P = 399,
    ENUM_P = 400,
    ESCAPE = 401,
    EVENT = 402,
    EXCEPT = 403,
    EXCLUDE = 404,
    EXCLUDING = 405,
    EXCLUSIVE = 406,
    EXECUTE = 407,
    EXISTS = 408,
    EXPLAIN = 409,
    EXPRESSION = 410,
    EXTENSION = 411,
    EXTERNAL = 412,
    EXTRACT = 413,
    FALSE_P = 414,
    FAMILY = 415,
    FETCH = 416,
    FILTER = 417,
    FINALIZE = 418,
    FIRST_P = 419,
    FLOAT_P = 420,
    FOLLOWING = 421,
    FOR = 422,
    FORCE = 423,
    FOREIGN = 424,
    FORWARD = 425,
    FREEZE = 426,
    FROM = 427,
    FULL = 428,
    FUNCTION = 429,
    FUNCTIONS = 430,
    GENERATED = 431,
    GLOBAL = 432,
    GRANT = 433,
    GRANTED = 434,
    GREATEST = 435,
    GROUP_P = 436,
    GROUPING = 437,
    GROUPS = 438,
    HANDLER = 439,
    HAVING = 440,
    HEADER_P = 441,
    HOLD = 442,
    HOUR_P = 443,
    IDENTITY_P = 444,
    IF_P = 445,
    ILIKE = 446,
    IMMEDIATE = 447,
    IMMUTABLE = 448,
    IMPLICIT_P = 449,
    IMPORT_P = 450,
    IN_P = 451,
    INCLUDE = 452,
    INCLUDING = 453,
    INCREMENT = 454,
    INDEX = 455,
    INDEXES = 456,
    INHERIT = 457,
    INHERITS = 458,
    INITIALLY = 459,
    INLINE_P = 460,
    INNER_P = 461,
    INOUT = 462,
    INPUT_P = 463,
    INSENSITIVE = 464,
    INSERT = 465,
    INSTEAD = 466,
    INT_P = 467,
    INTEGER = 468,
    INTERSECT = 469,
    INTERVAL = 470,
    INTO = 471,
    INVOKER = 472,
    IS = 473,
    ISNULL = 474,
    ISOLATION = 475,
    JOIN = 476,
    KEY = 477,
    LABEL = 478,
    LANGUAGE = 479,
    LARGE_P = 480,
    LAST_P = 481,
    LATERAL_P = 482,
    LEADING = 483,
    LEAKPROOF = 484,
    LEAST = 485,
    LEFT = 486,
    LEVEL = 487,
    LIKE = 488,
    LIMIT = 489,
    LISTEN = 490,
    LOAD = 491,
    LOCAL = 492,
    LOCALTIME = 493,
    LOCALTIMESTAMP = 494,
    LOCATION = 495,
    LOCK_P = 496,
    LOCKED = 497,
    LOGGED = 498,
    MAPPING = 499,
    MATCH = 500,
    MATERIALIZED = 501,
    MAXVALUE = 502,
    METHOD = 503,
    MINUTE_P = 504,
    MINVALUE = 505,
    MODE = 506,
    MONTH_P = 507,
    MOVE = 508,
    NAME_P = 509,
    NAMES = 510,
    NATIONAL = 511,
    NATURAL = 512,
    NCHAR = 513,
    NEW = 514,
    NEXT = 515,
    NFC = 516,
    NFD = 517,
    NFKC = 518,
    NFKD = 519,
    NO = 520,
    NONE = 521,
    NORMALIZE = 522,
    NORMALIZED = 523,
    NOT = 524,
    NOTHING = 525,
    NOTIFY = 526,
    NOTNULL = 527,
    NOWAIT = 528,
    NULL_P = 529,
    NULLIF = 530,
    NULLS_P = 531,
    NUMERIC = 532,
    OBJECT_P = 533,
    OF = 534,
    OFF = 535,
    OFFSET = 536,
    OIDS = 537,
    OLD = 538,
    ON = 539,
    ONLY = 540,
    OPERATOR = 541,
    OPTION = 542,
    OPTIONS = 543,
    OR = 544,
    ORDER = 545,
    ORDINALITY = 546,
    OTHERS = 547,
    OUT_P = 548,
    OUTER_P = 549,
    OVER = 550,
    OVERLAPS = 551,
    OVERLAY = 552,
    OVERRIDING = 553,
    OWNED = 554,
    OWNER = 555,
    PARALLEL = 556,
    PARSER = 557,
    PARTIAL = 558,
    PARTITION = 559,
    PASSING = 560,
    PASSWORD = 561,
    PGPOOL = 562,
    PLACING = 563,
    PLANS = 564,
    POLICY = 565,
    POSITION = 566,
    PRECEDING = 567,
    PRECISION = 568,
    PRESERVE = 569,
    PREPARE = 570,
    PREPARED = 571,
    PRIMARY = 572,
    PRIOR = 573,
    PRIVILEGES = 574,
    PROCEDURAL = 575,
    PROCEDURE = 576,
    PROCEDURES = 577,
    PROGRAM = 578,
    PUBLICATION = 579,
    QUOTE = 580,
    RANGE = 581,
    READ = 582,
    REAL = 583,
    REASSIGN = 584,
    RECHECK = 585,
    RECURSIVE = 586,
    REF = 587,
    REFERENCES = 588,
    REFERENCING = 589,
    REFRESH = 590,
    REINDEX = 591,
    RELATIVE_P = 592,
    RELEASE = 593,
    RENAME = 594,
    REPEATABLE = 595,
    REPLACE = 596,
    REPLICA = 597,
    RESET = 598,
    RESTART = 599,
    RESTRICT = 600,
    RETURN = 601,
    RETURNING = 602,
    RETURNS = 603,
    REVOKE = 604,
    RIGHT = 605,
    ROLE = 606,
    ROLLBACK = 607,
    ROLLUP = 608,
    ROUTINE = 609,
    ROUTINES = 610,
    ROW = 611,
    ROWS = 612,
    RULE = 613,
    SAVEPOINT = 614,
    SCHEMA = 615,
    SCHEMAS = 616,
    SCROLL = 617,
    SEARCH = 618,
    SECOND_P = 619,
    SECURITY = 620,
    SELECT = 621,
    SEQUENCE = 622,
    SEQUENCES = 623,
    SERIALIZABLE = 624,
    SERVER = 625,
    SESSION = 626,
    SESSION_USER = 627,
    SET = 628,
    SETS = 629,
    SETOF = 630,
    SHARE = 631,
    SHOW = 632,
    SIMILAR = 633,
    SIMPLE = 634,
    SKIP = 635,
    SMALLINT = 636,
    SNAPSHOT = 637,
    SOME = 638,
    SQL_P = 639,
    STABLE = 640,
    STANDALONE_P = 641,
    START = 642,
    STATEMENT = 643,
    STATISTICS = 644,
    STDIN = 645,
    STDOUT = 646,
    STORAGE = 647,
    STORED = 648,
    STRICT_P = 649,
    STRIP_P = 650,
    SUBSCRIPTION = 651,
    SUBSTRING = 652,
    SUPPORT = 653,
    SYMMETRIC = 654,
    SYSID = 655,
    SYSTEM_P = 656,
    TABLE = 657,
    TABLES = 658,
    TABLESAMPLE = 659,
    TABLESPACE = 660,
    TEMP = 661,
    TEMPLATE = 662,
    TEMPORARY = 663,
    TEXT_P = 664,
    THEN = 665,
    TIES = 666,
    TIME = 667,
    TIMESTAMP = 668,
    TO = 669,
    TRAILING = 670,
    TRANSACTION = 671,
    TRANSFORM = 672,
    TREAT = 673,
    TRIGGER = 674,
    TRIM = 675,
    TRUE_P = 676,
    TRUNCATE = 677,
    TRUSTED = 678,
    TYPE_P = 679,
    TYPES_P = 680,
    UESCAPE = 681,
    UNBOUNDED = 682,
    UNCOMMITTED = 683,
    UNENCRYPTED = 684,
    UNION = 685,
    UNIQUE = 686,
    UNKNOWN = 687,
    UNLISTEN = 688,
    UNLOGGED = 689,
    UNTIL = 690,
    UPDATE = 691,
    USER = 692,
    USING = 693,
    VACUUM = 694,
    VALID = 695,
    VALIDATE = 696,
    VALIDATOR = 697,
    VALUE_P = 698,
    VALUES = 699,
    VARCHAR = 700,
    VARIADIC = 701,
    VARYING = 702,
    VERBOSE = 703,
    VERSION_P = 704,
    VIEW = 705,
    VIEWS = 706,
    VOLATILE = 707,
    WHEN = 708,
    WHERE = 709,
    WHITESPACE_P = 710,
    WINDOW = 711,
    WITH = 712,
    WITHIN = 713,
    WITHOUT = 714,
    WORK = 715,
    WRAPPER = 716,
    WRITE = 717,
    XML_P = 718,
    XMLATTRIBUTES = 719,
    XMLCONCAT = 720,
    XMLELEMENT = 721,
    XMLEXISTS = 722,
    XMLFOREST = 723,
    XMLNAMESPACES = 724,
    XMLPARSE = 725,
    XMLPI = 726,
    XMLROOT = 727,
    XMLSERIALIZE = 728,
    XMLTABLE = 729,
    YEAR_P = 730,
    YES_P = 731,
    ZONE = 732,
    NOT_LA = 733,
    NULLS_LA = 734,
    WITH_LA = 735,
    MODE_TYPE_NAME = 736,
    MODE_PLPGSQL_EXPR = 737,
    MODE_PLPGSQL_ASSIGN1 = 738,
    MODE_PLPGSQL_ASSIGN2 = 739,
    MODE_PLPGSQL_ASSIGN3 = 740,
    UMINUS = 741
  };
#endif
/* Tokens.  */
#define IDENT 258
#define UIDENT 259
#define FCONST 260
#define SCONST 261
#define USCONST 262
#define BCONST 263
#define XCONST 264
#define Op 265
#define ICONST 266
#define PARAM 267
#define TYPECAST 268
#define DOT_DOT 269
#define COLON_EQUALS 270
#define EQUALS_GREATER 271
#define LESS_EQUALS 272
#define GREATER_EQUALS 273
#define NOT_EQUALS 274
#define ABORT_P 275
#define ABSOLUTE_P 276
#define ACCESS 277
#define ACTION 278
#define ADD_P 279
#define ADMIN 280
#define AFTER 281
#define AGGREGATE 282
#define ALL 283
#define ALSO 284
#define ALTER 285
#define ALWAYS 286
#define ANALYSE 287
#define ANALYZE 288
#define AND 289
#define ANY 290
#define ARRAY 291
#define AS 292
#define ASC 293
#define ASENSITIVE 294
#define ASSERTION 295
#define ASSIGNMENT 296
#define ASYMMETRIC 297
#define ATOMIC 298
#define AT 299
#define ATTACH 300
#define ATTRIBUTE 301
#define AUTHORIZATION 302
#define BACKWARD 303
#define BEFORE 304
#define BEGIN_P 305
#define BETWEEN 306
#define BIGINT 307
#define BINARY 308
#define BIT 309
#define BOOLEAN_P 310
#define BOTH 311
#define BREADTH 312
#define BY 313
#define CACHE 314
#define CALL 315
#define CALLED 316
#define CASCADE 317
#define CASCADED 318
#define CASE 319
#define CAST 320
#define CATALOG_P 321
#define CHAIN 322
#define CHAR_P 323
#define CHARACTER 324
#define CHARACTERISTICS 325
#define CHECK 326
#define CHECKPOINT 327
#define CLASS 328
#define CLOSE 329
#define CLUSTER 330
#define COALESCE 331
#define COLLATE 332
#define COLLATION 333
#define COLUMN 334
#define COLUMNS 335
#define COMMENT 336
#define COMMENTS 337
#define COMMIT 338
#define COMMITTED 339
#define COMPRESSION 340
#define CONCURRENTLY 341
#define CONFIGURATION 342
#define CONFLICT 343
#define CONNECTION 344
#define CONSTRAINT 345
#define CONSTRAINTS 346
#define CONTENT_P 347
#define CONTINUE_P 348
#define CONVERSION_P 349
#define COPY 350
#define COST 351
#define CREATE 352
#define CROSS 353
#define CSV 354
#define CUBE 355
#define CURRENT_P 356
#define CURRENT_CATALOG 357
#define CURRENT_DATE 358
#define CURRENT_ROLE 359
#define CURRENT_SCHEMA 360
#define CURRENT_TIME 361
#define CURRENT_TIMESTAMP 362
#define CURRENT_USER 363
#define CURSOR 364
#define CYCLE 365
#define DATA_P 366
#define DATABASE 367
#define DAY_P 368
#define DEALLOCATE 369
#define DEC 370
#define DECIMAL_P 371
#define DECLARE 372
#define DEFAULT 373
#define DEFAULTS 374
#define DEFERRABLE 375
#define DEFERRED 376
#define DEFINER 377
#define DELETE_P 378
#define DELIMITER 379
#define DELIMITERS 380
#define DEPENDS 381
#define DEPTH 382
#define DESC 383
#define DETACH 384
#define DICTIONARY 385
#define DISABLE_P 386
#define DISCARD 387
#define DISTINCT 388
#define DO 389
#define DOCUMENT_P 390
#define DOMAIN_P 391
#define DOUBLE_P 392
#define DROP 393
#define EACH 394
#define ELSE 395
#define ENABLE_P 396
#define ENCODING 397
#define ENCRYPTED 398
#define END_P 399
#define ENUM_P 400
#define ESCAPE 401
#define EVENT 402
#define EXCEPT 403
#define EXCLUDE 404
#define EXCLUDING 405
#define EXCLUSIVE 406
#define EXECUTE 407
#define EXISTS 408
#define EXPLAIN 409
#define EXPRESSION 410
#define EXTENSION 411
#define EXTERNAL 412
#define EXTRACT 413
#define FALSE_P 414
#define FAMILY 415
#define FETCH 416
#define FILTER 417
#define FINALIZE 418
#define FIRST_P 419
#define FLOAT_P 420
#define FOLLOWING 421
#define FOR 422
#define FORCE 423
#define FOREIGN 424
#define FORWARD 425
#define FREEZE 426
#define FROM 427
#define FULL 428
#define FUNCTION 429
#define FUNCTIONS 430
#define GENERATED 431
#define GLOBAL 432
#define GRANT 433
#define GRANTED 434
#define GREATEST 435
#define GROUP_P 436
#define GROUPING 437
#define GROUPS 438
#define HANDLER 439
#define HAVING 440
#define HEADER_P 441
#define HOLD 442
#define HOUR_P 443
#define IDENTITY_P 444
#define IF_P 445
#define ILIKE 446
#define IMMEDIATE 447
#define IMMUTABLE 448
#define IMPLICIT_P 449
#define IMPORT_P 450
#define IN_P 451
#define INCLUDE 452
#define INCLUDING 453
#define INCREMENT 454
#define INDEX 455
#define INDEXES 456
#define INHERIT 457
#define INHERITS 458
#define INITIALLY 459
#define INLINE_P 460
#define INNER_P 461
#define INOUT 462
#define INPUT_P 463
#define INSENSITIVE 464
#define INSERT 465
#define INSTEAD 466
#define INT_P 467
#define INTEGER 468
#define INTERSECT 469
#define INTERVAL 470
#define INTO 471
#define INVOKER 472
#define IS 473
#define ISNULL 474
#define ISOLATION 475
#define JOIN 476
#define KEY 477
#define LABEL 478
#define LANGUAGE 479
#define LARGE_P 480
#define LAST_P 481
#define LATERAL_P 482
#define LEADING 483
#define LEAKPROOF 484
#define LEAST 485
#define LEFT 486
#define LEVEL 487
#define LIKE 488
#define LIMIT 489
#define LISTEN 490
#define LOAD 491
#define LOCAL 492
#define LOCALTIME 493
#define LOCALTIMESTAMP 494
#define LOCATION 495
#define LOCK_P 496
#define LOCKED 497
#define LOGGED 498
#define MAPPING 499
#define MATCH 500
#define MATERIALIZED 501
#define MAXVALUE 502
#define METHOD 503
#define MINUTE_P 504
#define MINVALUE 505
#define MODE 506
#define MONTH_P 507
#define MOVE 508
#define NAME_P 509
#define NAMES 510
#define NATIONAL 511
#define NATURAL 512
#define NCHAR 513
#define NEW 514
#define NEXT 515
#define NFC 516
#define NFD 517
#define NFKC 518
#define NFKD 519
#define NO 520
#define NONE 521
#define NORMALIZE 522
#define NORMALIZED 523
#define NOT 524
#define NOTHING 525
#define NOTIFY 526
#define NOTNULL 527
#define NOWAIT 528
#define NULL_P 529
#define NULLIF 530
#define NULLS_P 531
#define NUMERIC 532
#define OBJECT_P 533
#define OF 534
#define OFF 535
#define OFFSET 536
#define OIDS 537
#define OLD 538
#define ON 539
#define ONLY 540
#define OPERATOR 541
#define OPTION 542
#define OPTIONS 543
#define OR 544
#define ORDER 545
#define ORDINALITY 546
#define OTHERS 547
#define OUT_P 548
#define OUTER_P 549
#define OVER 550
#define OVERLAPS 551
#define OVERLAY 552
#define OVERRIDING 553
#define OWNED 554
#define OWNER 555
#define PARALLEL 556
#define PARSER 557
#define PARTIAL 558
#define PARTITION 559
#define PASSING 560
#define PASSWORD 561
#define PGPOOL 562
#define PLACING 563
#define PLANS 564
#define POLICY 565
#define POSITION 566
#define PRECEDING 567
#define PRECISION 568
#define PRESERVE 569
#define PREPARE 570
#define PREPARED 571
#define PRIMARY 572
#define PRIOR 573
#define PRIVILEGES 574
#define PROCEDURAL 575
#define PROCEDURE 576
#define PROCEDURES 577
#define PROGRAM 578
#define PUBLICATION 579
#define QUOTE 580
#define RANGE 581
#define READ 582
#define REAL 583
#define REASSIGN 584
#define RECHECK 585
#define RECURSIVE 586
#define REF 587
#define REFERENCES 588
#define REFERENCING 589
#define REFRESH 590
#define REINDEX 591
#define RELATIVE_P 592
#define RELEASE 593
#define RENAME 594
#define REPEATABLE 595
#define REPLACE 596
#define REPLICA 597
#define RESET 598
#define RESTART 599
#define RESTRICT 600
#define RETURN 601
#define RETURNING 602
#define RETURNS 603
#define REVOKE 604
#define RIGHT 605
#define ROLE 606
#define ROLLBACK 607
#define ROLLUP 608
#define ROUTINE 609
#define ROUTINES 610
#define ROW 611
#define ROWS 612
#define RULE 613
#define SAVEPOINT 614
#define SCHEMA 615
#define SCHEMAS 616
#define SCROLL 617
#define SEARCH 618
#define SECOND_P 619
#define SECURITY 620
#define SELECT 621
#define SEQUENCE 622
#define SEQUENCES 623
#define SERIALIZABLE 624
#define SERVER 625
#define SESSION 626
#define SESSION_USER 627
#define SET 628
#define SETS 629
#define SETOF 630
#define SHARE 631
#define SHOW 632
#define SIMILAR 633
#define SIMPLE 634
#define SKIP 635
#define SMALLINT 636
#define SNAPSHOT 637
#define SOME 638
#define SQL_P 639
#define STABLE 640
#define STANDALONE_P 641
#define START 642
#define STATEMENT 643
#define STATISTICS 644
#define STDIN 645
#define STDOUT 646
#define STORAGE 647
#define STORED 648
#define STRICT_P 649
#define STRIP_P 650
#define SUBSCRIPTION 651
#define SUBSTRING 652
#define SUPPORT 653
#define SYMMETRIC 654
#define SYSID 655
#define SYSTEM_P 656
#define TABLE 657
#define TABLES 658
#define TABLESAMPLE 659
#define TABLESPACE 660
#define TEMP 661
#define TEMPLATE 662
#define TEMPORARY 663
#define TEXT_P 664
#define THEN 665
#define TIES 666
#define TIME 667
#define TIMESTAMP 668
#define TO 669
#define TRAILING 670
#define TRANSACTION 671
#define TRANSFORM 672
#define TREAT 673
#define TRIGGER 674
#define TRIM 675
#define TRUE_P 676
#define TRUNCATE 677
#define TRUSTED 678
#define TYPE_P 679
#define TYPES_P 680
#define UESCAPE 681
#define UNBOUNDED 682
#define UNCOMMITTED 683
#define UNENCRYPTED 684
#define UNION 685
#define UNIQUE 686
#define UNKNOWN 687
#define UNLISTEN 688
#define UNLOGGED 689
#define UNTIL 690
#define UPDATE 691
#define USER 692
#define USING 693
#define VACUUM 694
#define VALID 695
#define VALIDATE 696
#define VALIDATOR 697
#define VALUE_P 698
#define VALUES 699
#define VARCHAR 700
#define VARIADIC 701
#define VARYING 702
#define VERBOSE 703
#define VERSION_P 704
#define VIEW 705
#define VIEWS 706
#define VOLATILE 707
#define WHEN 708
#define WHERE 709
#define WHITESPACE_P 710
#define WINDOW 711
#define WITH 712
#define WITHIN 713
#define WITHOUT 714
#define WORK 715
#define WRAPPER 716
#define WRITE 717
#define XML_P 718
#define XMLATTRIBUTES 719
#define XMLCONCAT 720
#define XMLELEMENT 721
#define XMLEXISTS 722
#define XMLFOREST 723
#define XMLNAMESPACES 724
#define XMLPARSE 725
#define XMLPI 726
#define XMLROOT 727
#define XMLSERIALIZE 728
#define XMLTABLE 729
#define YEAR_P 730
#define YES_P 731
#define ZONE 732
#define NOT_LA 733
#define NULLS_LA 734
#define WITH_LA 735
#define MODE_TYPE_NAME 736
#define MODE_PLPGSQL_EXPR 737
#define MODE_PLPGSQL_ASSIGN1 738
#define MODE_PLPGSQL_ASSIGN2 739
#define MODE_PLPGSQL_ASSIGN3 740
#define UMINUS 741

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 249 "gram_minimal.y" /* yacc.c:355  */

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs		*objwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	StatsElem			*selem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	InferClause			*infer;
	OnConflictClause	*onconflict;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	struct ImportQual	*importqual;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;
	PartitionElem		*partelem;
	PartitionSpec		*partspec;
	PartitionBoundSpec	*partboundspec;
	RoleSpec			*rolespec;
	struct SelectLimit	*selectlimit;
	SetQuantifier	 setquantifier;
	struct GroupClause  *groupclause;

#line 1371 "gram_minimal.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int minimal_base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_MINIMAL_BASE_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1401 "gram_minimal.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  900
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   109011

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  504
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  678
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3165
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  5995

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   741

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   493,     2,     2,
     498,   499,   491,   489,   502,   490,   500,   492,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   503,   501,
     486,   488,   487,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   496,     2,   497,   494,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   495
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   862,   862,   866,   870,   875,   882,   889,   908,   920,
     934,   935,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1063,  1072,  1087,  1098,  1099,
    1100,  1109,  1110,  1114,  1115,  1119,  1124,  1128,  1138,  1146,
    1150,  1154,  1159,  1163,  1211,  1213,  1217,  1221,  1225,  1229,
    1243,  1261,  1269,  1280,  1281,  1285,  1293,  1301,  1309,  1330,
    1337,  1344,  1351,  1358,  1365,  1382,  1400,  1411,  1412,  1423,
    1433,  1443,  1458,  1476,  1477,  1481,  1488,  1496,  1497,  1498,
    1499,  1500,  1501,  1515,  1522,  1528,  1534,  1543,  1551,  1559,
    1563,  1571,  1579,  1586,  1596,  1597,  1605,  1616,  1624,  1632,
    1643,  1651,  1659,  1666,  1675,  1685,  1686,  1690,  1691,  1694,
    1696,  1700,  1701,  1702,  1703,  1707,  1708,  1709,  1715,  1727,
    1731,  1735,  1750,  1757,  1758,  1759,  1763,  1764,  1765,  1769,
    1770,  1774,  1775,  1784,  1785,  1792,  1799,  1809,  1816,  1826,
    1827,  1832,  1833,  1839,  1845,  1851,  1857,  1863,  1869,  1875,
    1885,  1895,  1896,  1900,  1901,  1909,  1924,  1930,  1936,  1942,
    1948,  1967,  1976,  1985,  1994,  2003,  2014,  2025,  2034,  2043,
    2052,  2063,  2074,  2083,  2092,  2101,  2110,  2119,  2128,  2139,
    2150,  2159,  2171,  2172,  2177,  2191,  2204,  2220,  2237,  2246,
    2255,  2264,  2273,  2282,  2290,  2298,  2306,  2315,  2324,  2340,
    2349,  2358,  2367,  2376,  2393,  2402,  2411,  2420,  2430,  2443,
    2458,  2467,  2476,  2491,  2499,  2509,  2519,  2526,  2534,  2542,
    2549,  2556,  2564,  2572,  2580,  2587,  2594,  2602,  2609,  2616,
    2624,  2632,  2640,  2648,  2656,  2664,  2674,  2681,  2689,  2697,
    2705,  2713,  2721,  2728,  2735,  2742,  2748,  2758,  2759,  2763,
    2764,  2765,  2769,  2777,  2781,  2782,  2786,  2793,  2800,  2807,
    2817,  2820,  2821,  2825,  2826,  2831,  2835,  2839,  2844,  2851,
    2853,  2858,  2862,  2866,  2877,  2885,  2938,  2951,  2965,  2977,
    2984,  2988,  3002,  3015,  3016,  3021,  3030,  3040,  3050,  3076,
    3082,  3115,  3150,  3172,  3173,  3177,  3178,  3187,  3188,  3189,
    3192,  3193,  3198,  3199,  3203,  3207,  3211,  3215,  3219,  3223,
    3227,  3231,  3235,  3239,  3243,  3247,  3251,  3260,  3264,  3268,
    3272,  3276,  3277,  3282,  3286,  3293,  3300,  3301,  3302,  3303,
    3304,  3308,  3312,  3320,  3331,  3350,  3369,  3389,  3409,  3429,
    3462,  3463,  3464,  3465,  3466,  3473,  3480,  3481,  3485,  3486,
    3490,  3491,  3495,  3499,  3506,  3510,  3517,  3518,  3519,  3523,
    3524,  3527,  3549,  3567,  3588,  3589,  3593,  3594,  3598,  3599,
    3603,  3610,  3611,  3612,  3643,  3650,  3657,  3668,  3679,  3691,
    3702,  3711,  3734,  3752,  3753,  3772,  3779,  3786,  3793,  3804,
    3815,  3816,  3817,  3821,  3822,  3823,  3824,  3825,  3826,  3827,
    3828,  3829,  3830,  3839,  3846,  3850,  3863,  3879,  3894,  3910,
    3925,  3944,  3965,  3966,  3970,  3971,  3975,  3976,  3979,  3985,
    3986,  3989,  3993,  4001,  4006,  4012,  4013,  4017,  4022,  4029,
    4030,  4040,  4042,  4044,  4046,  4049,  4052,  4055,  4059,  4060,
    4061,  4062,  4063,  4066,  4067,  4071,  4072,  4075,  4087,  4088,
    4091,  4102,  4113,  4127,  4128,  4133,  4134,  4135,  4138,  4139,
    4140,  4141,  4144,  4145,  4148,  4149,  4152,  4170,  4182,  4203,
    4204,  4207,  4213,  4219,  4236,  4244,  4265,  4278,  4294,  4310,
    4311,  4312,  4324,  4337,  4353,  4367,  4368,  4380,  4400,  4410,
    4423,  4431,  4442,  4443,  4446,  4447,  4450,  4451,  4454,  4458,
    4462,  4466,  4470,  4474,  4478,  4482,  4486,  4490,  4494,  4499,
    4503,  4507,  4513,  4514,  4518,  4519,  4520,  4525,  4528,  4529,
    4541,  4556,  4571,  4572,  4580,  4581,  4585,  4586,  4590,  4591,
    4595,  4596,  4600,  4601,  4611,  4622,  4623,  4636,  4643,  4660,
    4668,  4679,  4682,  4686,  4690,  4694,  4701,  4713,  4723,  4726,
    4730,  4743,  4752,  4761,  4770,  4779,  4788,  4797,  4806,  4815,
    4824,  4833,  4842,  4851,  4869,  4880,  4881,  4882,  4883,  4887,
    4888,  4892,  4893,  4903,  4911,  4923,  4924,  4928,  4932,  4940,
    4944,  4948,  4955,  4959,  4964,  4969,  4976,  4983,  4988,  4998,
    5010,  5025,  5026,  5031,  5032,  5036,  5037,  5047,  5056,  5064,
    5081,  5101,  5121,  5142,  5175,  5190,  5191,  5195,  5203,  5218,
    5227,  5239,  5240,  5252,  5260,  5277,  5301,  5318,  5332,  5333,
    5337,  5338,  5342,  5343,  5347,  5348,  5352,  5366,  5370,  5371,
    5375,  5376,  5377,  5378,  5379,  5389,  5400,  5401,  5412,  5434,
    5465,  5466,  5467,  5471,  5473,  5495,  5497,  5499,  5501,  5503,
    5508,  5509,  5513,  5514,  5518,  5529,  5530,  5534,  5543,  5547,
    5551,  5556,  5566,  5567,  5571,  5572,  5576,  5577,  5581,  5582,
    5586,  5587,  5588,  5592,  5596,  5597,  5598,  5602,  5603,  5608,
    5609,  5636,  5637,  5638,  5639,  5640,  5641,  5654,  5664,  5678,
    5680,  5685,  5690,  5692,  5697,  5707,  5708,  5709,  5710,  5721,
    5740,  5751,  5763,  5773,  5783,  5794,  5803,  5810,  5817,  5826,
    5835,  5844,  5853,  5862,  5872,  5881,  5893,  5896,  5897,  5900,
    5904,  5911,  5912,  5913,  5914,  5915,  5916,  5919,  5922,  5923,
    5931,  5938,  5939,  5942,  5944,  5955,  5966,  5977,  5988,  6001,
    6002,  6018,  6033,  6034,  6038,  6050,  6060,  6068,  6077,  6086,
    6087,  6090,  6091,  6094,  6095,  6096,  6099,  6113,  6118,  6128,
    6137,  6149,  6150,  6154,  6162,  6174,  6184,  6197,  6207,  6229,
    6239,  6257,  6267,  6277,  6287,  6297,  6307,  6317,  6327,  6337,
    6347,  6357,  6367,  6381,  6382,  6383,  6384,  6385,  6386,  6387,
    6388,  6389,  6390,  6391,  6392,  6393,  6403,  6404,  6405,  6406,
    6407,  6411,  6412,  6413,  6414,  6415,  6416,  6417,  6418,  6423,
    6424,  6425,  6429,  6430,  6433,  6434,  6437,  6439,  6444,  6445,
    6456,  6467,  6468,  6469,  6479,  6487,  6495,  6503,  6511,  6519,
    6527,  6535,  6543,  6551,  6564,  6572,  6580,  6588,  6596,  6604,
    6612,  6620,  6631,  6632,  6646,  6656,  6666,  6676,  6686,  6696,
    6706,  6716,  6726,  6736,  6748,  6749,  6752,  6753,  6763,  6769,
    6777,  6785,  6793,  6801,  6809,  6817,  6825,  6833,  6841,  6849,
    6857,  6865,  6873,  6881,  6889,  6897,  6907,  6908,  6911,  6912,
    6922,  6939,  6954,  6981,  6983,  6985,  6987,  6994,  7003,  7004,
    7007,  7014,  7021,  7028,  7042,  7050,  7058,  7066,  7074,  7082,
    7090,  7098,  7106,  7114,  7122,  7130,  7138,  7146,  7154,  7162,
    7170,  7178,  7186,  7194,  7206,  7207,  7211,  7212,  7217,  7218,
    7228,  7241,  7251,  7263,  7264,  7267,  7268,  7278,  7288,  7289,
    7293,  7297,  7301,  7312,  7325,  7339,  7356,  7357,  7358,  7359,
    7360,  7361,  7373,  7403,  7436,  7437,  7441,  7442,  7446,  7447,
    7451,  7452,  7455,  7456,  7461,  7473,  7492,  7497,  7502,  7509,
    7510,  7513,  7514,  7517,  7518,  7521,  7522,  7525,  7526,  7527,
    7530,  7531,  7532,  7548,  7561,  7575,  7588,  7604,  7605,  7608,
    7609,  7613,  7614,  7618,  7619,  7624,  7637,  7644,  7651,  7666,
    7667,  7671,  7672,  7687,  7696,  7705,  7714,  7723,  7735,  7736,
    7737,  7738,  7739,  7745,  7749,  7764,  7765,  7771,  7781,  7785,
    7790,  7798,  7840,  7844,  7848,  7852,  7860,  7861,  7865,  7876,
    7877,  7882,  7883,  7888,  7889,  7896,  7900,  7904,  7908,  7912,
    7916,  7920,  7924,  7928,  7932,  7936,  7940,  7944,  7948,  7952,
    7956,  7961,  7968,  7972,  7976,  7980,  7984,  7990,  7991,  7997,
    8006,  8010,  8021,  8027,  8036,  8042,  8043,  8047,  8048,  8052,
    8053,  8056,  8068,  8072,  8087,  8095,  8103,  8115,  8116,  8121,
    8122,  8139,  8149,  8159,  8169,  8179,  8189,  8202,  8212,  8225,
    8235,  8248,  8256,  8258,  8260,  8265,  8267,  8272,  8273,  8278,
    8296,  8305,  8306,  8310,  8314,  8326,  8337,  8348,  8361,  8362,
    8363,  8367,  8379,  8380,  8390,  8402,  8406,  8410,  8414,  8421,
    8441,  8453,  8465,  8477,  8491,  8492,  8495,  8496,  8497,  8507,
    8516,  8533,  8542,  8551,  8560,  8569,  8578,  8587,  8596,  8605,
    8614,  8623,  8632,  8641,  8651,  8661,  8670,  8679,  8688,  8697,
    8706,  8715,  8725,  8735,  8745,  8755,  8765,  8775,  8785,  8795,
    8805,  8815,  8825,  8835,  8846,  8857,  8868,  8879,  8890,  8901,
    8911,  8921,  8932,  8943,  8953,  8963,  8971,  8980,  8989,  8998,
    9007,  9016,  9025,  9034,  9043,  9052,  9066,  9067,  9070,  9071,
    9081,  9090,  9099,  9108,  9118,  9127,  9138,  9139,  9149,  9158,
    9167,  9176,  9185,  9194,  9203,  9212,  9221,  9230,  9239,  9248,
    9257,  9266,  9275,  9284,  9293,  9302,  9311,  9320,  9329,  9338,
    9347,  9356,  9365,  9374,  9383,  9401,  9410,  9411,  9414,  9416,
    9422,  9423,  9424,  9425,  9426,  9438,  9453,  9461,  9469,  9477,
    9485,  9493,  9501,  9509,  9517,  9525,  9533,  9541,  9549,  9557,
    9565,  9573,  9581,  9589,  9597,  9605,  9613,  9621,  9629,  9637,
    9655,  9674,  9675,  9679,  9683,  9703,  9710,  9718,  9726,  9743,
    9762,  9771,  9780,  9789,  9799,  9809,  9819,  9829,  9847,  9855,
    9871,  9888,  9889,  9890,  9895,  9901,  9910,  9911,  9912,  9913,
    9914,  9918,  9919,  9922,  9923,  9924,  9925,  9929,  9930,  9931,
    9943,  9953,  9954,  9957,  9966,  9972,  9991,  9999, 10006, 10014,
   10022, 10029, 10036, 10043, 10050, 10057, 10064, 10071, 10081, 10088,
   10098, 10099, 10100, 10104, 10107, 10110, 10113, 10116, 10123, 10125,
   10127, 10132, 10134, 10138, 10139, 10140, 10152, 10165, 10178, 10196,
   10217, 10218, 10219, 10220, 10230, 10246, 10256, 10257, 10261, 10262,
   10266, 10270, 10274, 10292, 10293, 10294, 10295, 10296, 10297, 10298,
   10305, 10306, 10317, 10324, 10331, 10342, 10359, 10367, 10375, 10383,
   10394, 10398, 10409, 10421, 10438, 10444, 10460, 10473, 10482, 10490,
   10498, 10507, 10518, 10529, 10539, 10540, 10551, 10561, 10572, 10583,
   10594, 10605, 10614, 10626, 10627, 10641, 10665, 10676, 10684, 10695,
   10708, 10709, 10721, 10741, 10751, 10762, 10773, 10777, 10784, 10785,
   10789, 10796, 10797, 10801, 10802, 10803, 10807, 10808, 10812, 10813,
   10816, 10817, 10820, 10821, 10825, 10826, 10830, 10837, 10839, 10844,
   10845, 10858, 10865, 10875, 10882, 10892, 10893, 10894, 10895, 10896,
   10897, 10898, 10899, 10900, 10910, 10920, 10921, 10925, 10926, 10927,
   10928, 10938, 10945, 10962, 10981, 10982, 10992, 10998, 11004, 11010,
   11026, 11037, 11058, 11062, 11070, 11076, 11083, 11089, 11096, 11105,
   11106, 11110, 11112, 11117, 11128, 11138, 11148, 11154, 11163, 11172,
   11178, 11179, 11190, 11204, 11205, 11216, 11227, 11228, 11231, 11232,
   11233, 11234, 11235, 11236, 11237, 11238, 11241, 11242, 11246, 11247,
   11248, 11259, 11275, 11290, 11291, 11295, 11300, 11324, 11335, 11336,
   11346, 11357, 11360, 11361, 11362, 11363, 11364, 11365, 11368, 11369,
   11370, 11418, 11419, 11423, 11424, 11439, 11440, 11447, 11455, 11463,
   11471, 11479, 11487, 11498, 11499, 11531, 11546, 11562, 11563, 11582,
   11586, 11590, 11605, 11612, 11619, 11629, 11630, 11633, 11648, 11649,
   11650, 11654, 11663, 11673, 11679, 11690, 11702, 11708, 11709, 11713,
   11725, 11733, 11738, 11743, 11748, 11753, 11761, 11769, 11774, 11779,
   11786, 11787, 11791, 11792, 11793, 11800, 11801, 11805, 11806, 11810,
   11811, 11815, 11816, 11820, 11824, 11825, 11828, 11837, 11850, 11855,
   11860, 11864, 11875, 11876, 11880, 11888, 11904, 11912, 11920, 11928,
   11939, 11942, 11947, 11948, 11956, 11976, 11977, 11979, 11984, 11985,
   11989, 11990, 11993, 11994, 12019, 12027, 12036, 12037, 12041, 12042,
   12043, 12044, 12045, 12049, 12062, 12069, 12076, 12083, 12084, 12088,
   12089, 12093, 12094, 12098, 12099, 12103, 12114, 12115, 12116, 12117,
   12121, 12122, 12132, 12138, 12156, 12157, 12161, 12162, 12168, 12173,
   12181, 12188, 12196, 12202, 12209, 12244, 12269, 12273, 12299, 12303,
   12316, 12336, 12357, 12369, 12385, 12391, 12396, 12402, 12409, 12410,
   12420, 12426, 12434, 12438, 12442, 12448, 12455, 12460, 12461, 12462,
   12463, 12467, 12468, 12483, 12487, 12495, 12502, 12509, 12516, 12527,
   12528, 12541, 12545, 12552, 12565, 12578, 12579, 12594, 12604, 12616,
   12621, 12622, 12625, 12626, 12629, 12630, 12635, 12636, 12641, 12642,
   12650, 12655, 12656, 12660, 12664, 12670, 12694, 12704, 12717, 12718,
   12722, 12736, 12793, 12807, 12809, 12814, 12816, 12818, 12820, 12825,
   12827, 12832, 12840, 12860, 12865, 12872, 12877, 12883, 12888, 12897,
   12899, 12902, 12906, 12907, 12908, 12909, 12910, 12911, 12916, 12936,
   12937, 12938, 12939, 12950, 12956, 12964, 12965, 12971, 12976, 12981,
   12986, 12991, 12996, 13001, 13006, 13012, 13018, 13024, 13031, 13053,
   13062, 13066, 13074, 13078, 13086, 13098, 13119, 13123, 13129, 13133,
   13146, 13154, 13164, 13166, 13168, 13170, 13172, 13174, 13179, 13180,
   13187, 13196, 13204, 13213, 13224, 13232, 13233, 13234, 13238, 13240,
   13242, 13244, 13246, 13248, 13250, 13255, 13260, 13266, 13274, 13279,
   13286, 13293, 13297, 13301, 13337, 13338, 13340, 13348, 13364, 13366,
   13368, 13370, 13372, 13374, 13376, 13378, 13380, 13382, 13384, 13386,
   13388, 13390, 13393, 13395, 13398, 13400, 13402, 13404, 13407, 13412,
   13421, 13426, 13435, 13440, 13449, 13454, 13464, 13473, 13482, 13491,
   13510, 13518, 13526, 13534, 13542, 13559, 13567, 13575, 13583, 13591,
   13599, 13607, 13611, 13615, 13623, 13631, 13639, 13647, 13667, 13689,
   13700, 13707, 13723, 13728, 13734, 13741, 13748, 13756, 13764, 13789,
   13791, 13793, 13795, 13797, 13799, 13801, 13803, 13805, 13807, 13809,
   13811, 13813, 13815, 13817, 13819, 13821, 13823, 13825, 13829, 13833,
   13838, 13854, 13855, 13856, 13871, 13883, 13885, 13887, 13898, 13922,
   13933, 13944, 13951, 13961, 13971, 13980, 13986, 13994, 14003, 14012,
   14024, 14033, 14063, 14098, 14109, 14110, 14117, 14124, 14128, 14132,
   14136, 14140, 14144, 14148, 14152, 14156, 14160, 14164, 14168, 14172,
   14176, 14180, 14184, 14186, 14193, 14200, 14207, 14214, 14225, 14239,
   14249, 14260, 14276, 14286, 14293, 14300, 14307, 14311, 14318, 14326,
   14334, 14338, 14342, 14346, 14350, 14354, 14363, 14367, 14376, 14380,
   14384, 14389, 14403, 14405, 14409, 14411, 14413, 14416, 14419, 14422,
   14423, 14426, 14434, 14444, 14445, 14448, 14449, 14450, 14455, 14459,
   14463, 14467, 14474, 14475, 14483, 14484, 14488, 14489, 14497, 14498,
   14502, 14503, 14508, 14516, 14518, 14532, 14535, 14562, 14563, 14566,
   14567, 14575, 14582, 14589, 14597, 14606, 14623, 14668, 14676, 14684,
   14692, 14700, 14711, 14712, 14713, 14714, 14715, 14729, 14730, 14731,
   14734, 14735, 14738, 14741, 14742, 14743, 14746, 14747, 14750, 14751,
   14752, 14753, 14754, 14755, 14756, 14757, 14758, 14759, 14760, 14761,
   14764, 14766, 14771, 14773, 14778, 14780, 14782, 14784, 14786, 14788,
   14800, 14804, 14811, 14815, 14821, 14825, 14834, 14845, 14846, 14849,
   14850, 14853, 14857, 14861, 14867, 14868, 14873, 14883, 14884, 14885,
   14886, 14887, 14888, 14889, 14890, 14894, 14895, 14896, 14897, 14902,
   14907, 14916, 14937, 14941, 14946, 14957, 14974, 14980, 14981, 14982,
   14985, 14992, 15002, 15016, 15017, 15021, 15032, 15033, 15036, 15037,
   15040, 15044, 15051, 15055, 15059, 15067, 15078, 15079, 15083, 15084,
   15088, 15089, 15092, 15093, 15103, 15104, 15108, 15109, 15112, 15120,
   15128, 15136, 15158, 15159, 15170, 15174, 15201, 15203, 15208, 15210,
   15212, 15222, 15224, 15235, 15239, 15243, 15247, 15251, 15260, 15267,
   15299, 15303, 15309, 15316, 15320, 15324, 15330, 15331, 15333, 15334,
   15335, 15339, 15379, 15406, 15410, 15414, 15420, 15422, 15436, 15472,
   15485, 15486, 15489, 15490, 15507, 15508, 15509, 15514, 15515, 15516,
   15521, 15522, 15523, 15524, 15530, 15531, 15532, 15533, 15534, 15540,
   15541, 15561, 15562, 15563, 15564, 15565, 15566, 15567, 15568, 15569,
   15570, 15571, 15572, 15573, 15574, 15575, 15576, 15577, 15578, 15579,
   15580, 15581, 15582, 15583, 15584, 15585, 15586, 15587, 15588, 15589,
   15590, 15591, 15592, 15593, 15594, 15595, 15596, 15597, 15598, 15599,
   15600, 15601, 15602, 15603, 15604, 15605, 15606, 15607, 15608, 15609,
   15610, 15611, 15612, 15613, 15614, 15615, 15616, 15617, 15618, 15619,
   15620, 15621, 15622, 15623, 15624, 15625, 15626, 15627, 15628, 15629,
   15630, 15631, 15632, 15633, 15634, 15635, 15636, 15637, 15638, 15639,
   15640, 15641, 15642, 15643, 15644, 15645, 15646, 15647, 15648, 15649,
   15650, 15651, 15652, 15653, 15654, 15655, 15656, 15657, 15658, 15659,
   15660, 15661, 15662, 15663, 15664, 15665, 15666, 15667, 15668, 15669,
   15670, 15671, 15672, 15673, 15674, 15675, 15676, 15677, 15678, 15679,
   15680, 15681, 15682, 15683, 15684, 15685, 15686, 15687, 15688, 15689,
   15690, 15691, 15692, 15693, 15694, 15695, 15696, 15697, 15698, 15699,
   15700, 15701, 15702, 15703, 15704, 15705, 15706, 15707, 15708, 15709,
   15710, 15711, 15712, 15713, 15714, 15715, 15716, 15717, 15718, 15719,
   15720, 15721, 15722, 15723, 15724, 15725, 15726, 15727, 15728, 15729,
   15730, 15731, 15732, 15733, 15734, 15735, 15736, 15737, 15738, 15739,
   15740, 15741, 15742, 15743, 15744, 15745, 15746, 15747, 15748, 15749,
   15750, 15751, 15752, 15753, 15754, 15755, 15756, 15757, 15758, 15759,
   15760, 15761, 15762, 15763, 15764, 15765, 15766, 15767, 15768, 15769,
   15770, 15771, 15772, 15773, 15774, 15775, 15776, 15777, 15778, 15779,
   15780, 15781, 15782, 15783, 15784, 15785, 15786, 15787, 15788, 15789,
   15790, 15791, 15792, 15793, 15794, 15795, 15796, 15797, 15798, 15799,
   15800, 15801, 15802, 15803, 15804, 15805, 15806, 15807, 15808, 15809,
   15810, 15811, 15812, 15813, 15814, 15815, 15816, 15817, 15818, 15819,
   15820, 15821, 15822, 15823, 15824, 15825, 15826, 15827, 15828, 15829,
   15830, 15831, 15832, 15833, 15834, 15835, 15836, 15837, 15838, 15839,
   15840, 15841, 15842, 15843, 15844, 15845, 15846, 15847, 15848, 15849,
   15850, 15851, 15852, 15853, 15854, 15855, 15856, 15857, 15858, 15859,
   15860, 15861, 15862, 15863, 15864, 15865, 15866, 15880, 15881, 15882,
   15883, 15884, 15885, 15886, 15887, 15888, 15889, 15890, 15891, 15892,
   15893, 15894, 15895, 15896, 15897, 15898, 15899, 15900, 15901, 15902,
   15903, 15904, 15905, 15906, 15907, 15908, 15909, 15910, 15911, 15912,
   15913, 15914, 15915, 15916, 15917, 15918, 15919, 15920, 15921, 15922,
   15923, 15924, 15925, 15926, 15927, 15928, 15929, 15930, 15944, 15945,
   15946, 15947, 15948, 15949, 15950, 15951, 15952, 15953, 15954, 15955,
   15956, 15957, 15958, 15959, 15960, 15961, 15962, 15963, 15964, 15965,
   15966, 15976, 15977, 15978, 15979, 15980, 15981, 15982, 15983, 15984,
   15985, 15986, 15987, 15988, 15989, 15990, 15991, 15992, 15993, 15994,
   15995, 15996, 15997, 15998, 15999, 16000, 16001, 16002, 16003, 16004,
   16005, 16006, 16007, 16008, 16009, 16010, 16011, 16012, 16013, 16014,
   16015, 16016, 16017, 16018, 16019, 16020, 16021, 16022, 16023, 16024,
   16025, 16026, 16027, 16028, 16029, 16030, 16031, 16032, 16033, 16034,
   16035, 16036, 16037, 16038, 16039, 16040, 16041, 16042, 16043, 16044,
   16045, 16046, 16047, 16048, 16049, 16050, 16051, 16052, 16065, 16066,
   16067, 16068, 16069, 16070, 16071, 16072, 16073, 16074, 16075, 16076,
   16077, 16078, 16079, 16080, 16081, 16082, 16083, 16084, 16085, 16086,
   16087, 16088, 16089, 16090, 16091, 16092, 16093, 16094, 16095, 16096,
   16097, 16098, 16099, 16100, 16101, 16102, 16103, 16104, 16105, 16106,
   16107, 16108, 16109, 16110, 16111, 16112, 16113, 16114, 16115, 16116,
   16117, 16118, 16119, 16120, 16121, 16122, 16123, 16124, 16125, 16126,
   16127, 16128, 16129, 16130, 16131, 16132, 16133, 16134, 16135, 16136,
   16137, 16138, 16139, 16140, 16141, 16142, 16143, 16144, 16145, 16146,
   16147, 16148, 16149, 16150, 16151, 16152, 16153, 16154, 16155, 16156,
   16157, 16158, 16159, 16160, 16161, 16162, 16163, 16164, 16165, 16166,
   16167, 16168, 16169, 16170, 16171, 16172, 16173, 16174, 16175, 16176,
   16177, 16178, 16179, 16180, 16181, 16182, 16183, 16184, 16185, 16186,
   16187, 16188, 16189, 16190, 16191, 16192, 16193, 16194, 16195, 16196,
   16197, 16198, 16199, 16200, 16201, 16202, 16203, 16204, 16205, 16206,
   16207, 16208, 16209, 16210, 16211, 16212, 16213, 16214, 16215, 16216,
   16217, 16218, 16219, 16220, 16221, 16222, 16223, 16224, 16225, 16226,
   16227, 16228, 16229, 16230, 16231, 16232, 16233, 16234, 16235, 16236,
   16237, 16238, 16239, 16240, 16241, 16242, 16243, 16244, 16245, 16246,
   16247, 16248, 16249, 16250, 16251, 16252, 16253, 16254, 16255, 16256,
   16257, 16258, 16259, 16260, 16261, 16262, 16263, 16264, 16265, 16266,
   16267, 16268, 16269, 16270, 16271, 16272, 16273, 16274, 16275, 16276,
   16277, 16278, 16279, 16280, 16281, 16282, 16283, 16284, 16285, 16286,
   16287, 16288, 16289, 16290, 16291, 16292, 16293, 16294, 16295, 16296,
   16297, 16298, 16299, 16300, 16301, 16302, 16303, 16304, 16305, 16306,
   16307, 16308, 16309, 16310, 16311, 16312, 16313, 16314, 16315, 16316,
   16317, 16318, 16319, 16320, 16321, 16322, 16323, 16324, 16325, 16326,
   16327, 16328, 16329, 16330, 16331, 16332, 16333, 16334, 16335, 16336,
   16337, 16338, 16339, 16340, 16341, 16342, 16343, 16344, 16345, 16346,
   16347, 16348, 16349, 16350, 16351, 16352, 16353, 16354, 16355, 16356,
   16357, 16358, 16359, 16360, 16361, 16362, 16363, 16364, 16365, 16366,
   16367, 16368, 16369, 16370, 16371, 16372, 16373, 16374, 16375, 16376,
   16377, 16378, 16379, 16380, 16381, 16382, 16383, 16384, 16385, 16386,
   16387, 16388, 16389, 16390, 16391, 16392, 16393, 16394, 16395, 16396,
   16397, 16398, 16399, 16400, 16401, 16402, 16403, 16404, 16405, 16406,
   16407, 16408, 16409, 16410, 16411, 16412, 16413, 16414, 16415, 16416,
   16417, 16418, 16419, 16420, 16421, 16422, 16423, 16424, 16425, 16426,
   16427, 16428, 16429, 16430, 16431, 16432, 16433, 16434, 16435, 16436,
   16437, 16438, 16439, 16440, 16441, 16442, 16443, 16444, 16445, 16446,
   16447, 16448, 16449, 16450, 16451, 16452, 16453, 16454, 16455, 16456,
   16457, 16458, 16459, 16460, 16461, 16462, 16463, 16464, 16465, 16466,
   16467, 16468, 16469, 16470, 16471, 16472, 16473, 16474, 16475, 16476,
   16477, 16478, 16479, 16480, 16481, 16482
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSOLUTE_P", "ACCESS",
  "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL", "ALSO", "ALTER",
  "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY", "AS", "ASC",
  "ASENSITIVE", "ASSERTION", "ASSIGNMENT", "ASYMMETRIC", "ATOMIC", "AT",
  "ATTACH", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P",
  "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BREADTH",
  "BY", "CACHE", "CALL", "CALLED", "CASCADE", "CASCADED", "CASE", "CAST",
  "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK",
  "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER", "COALESCE", "COLLATE",
  "COLLATION", "COLUMN", "COLUMNS", "COMMENT", "COMMENTS", "COMMIT",
  "COMMITTED", "COMPRESSION", "CONCURRENTLY", "CONFIGURATION", "CONFLICT",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CROSS", "CSV", "CUBE",
  "CURRENT_P", "CURRENT_CATALOG", "CURRENT_DATE", "CURRENT_ROLE",
  "CURRENT_SCHEMA", "CURRENT_TIME", "CURRENT_TIMESTAMP", "CURRENT_USER",
  "CURSOR", "CYCLE", "DATA_P", "DATABASE", "DAY_P", "DEALLOCATE", "DEC",
  "DECIMAL_P", "DECLARE", "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED",
  "DEFINER", "DELETE_P", "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH",
  "DESC", "DETACH", "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO",
  "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "ENABLE_P",
  "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE", "EVENT", "EXCEPT",
  "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS", "EXPLAIN",
  "EXPRESSION", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY",
  "FETCH", "FILTER", "FINALIZE", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR",
  "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT", "GRANTED", "GREATEST",
  "GROUP_P", "GROUPING", "GROUPS", "HANDLER", "HAVING", "HEADER_P", "HOLD",
  "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE", "IMMUTABLE",
  "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE", "INCLUDING", "INCREMENT",
  "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P",
  "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD",
  "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS",
  "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL", "LANGUAGE", "LARGE_P",
  "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATERIALIZED", "MAXVALUE", "METHOD", "MINUTE_P", "MINVALUE",
  "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES", "NATIONAL", "NATURAL",
  "NCHAR", "NEW", "NEXT", "NFC", "NFD", "NFKC", "NFKD", "NO", "NONE",
  "NORMALIZE", "NORMALIZED", "NOT", "NOTHING", "NOTIFY", "NOTNULL",
  "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF",
  "OFF", "OFFSET", "OIDS", "OLD", "ON", "ONLY", "OPERATOR", "OPTION",
  "OPTIONS", "OR", "ORDER", "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OVERRIDING", "OWNED", "OWNER",
  "PARALLEL", "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD",
  "PGPOOL", "PLACING", "PLANS", "POLICY", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROCEDURES", "PROGRAM",
  "PUBLICATION", "QUOTE", "RANGE", "READ", "REAL", "REASSIGN", "RECHECK",
  "RECURSIVE", "REF", "REFERENCES", "REFERENCING", "REFRESH", "REINDEX",
  "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE", "REPLICA",
  "RESET", "RESTART", "RESTRICT", "RETURN", "RETURNING", "RETURNS",
  "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE", "ROUTINES",
  "ROW", "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCHEMAS", "SCROLL",
  "SEARCH", "SECOND_P", "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES",
  "SERIALIZABLE", "SERVER", "SESSION", "SESSION_USER", "SET", "SETS",
  "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE", "SKIP", "SMALLINT",
  "SNAPSHOT", "SOME", "SQL_P", "STABLE", "STANDALONE_P", "START",
  "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STORED",
  "STRICT_P", "STRIP_P", "SUBSCRIPTION", "SUBSTRING", "SUPPORT",
  "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE", "TABLES", "TABLESAMPLE",
  "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIES",
  "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TRANSFORM",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "TYPES_P", "UESCAPE", "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION",
  "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER",
  "USING", "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "NOT_LA", "NULLS_LA", "WITH_LA",
  "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR", "MODE_PLPGSQL_ASSIGN1",
  "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3", "'<'", "'>'", "'='",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['", "']'", "'('",
  "')'", "'.'", "';'", "','", "':'", "$accept", "parse_toplevel",
  "stmtmulti", "toplevel_stmt", "stmt", "CallStmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "CreateSchemaStmt", "OptSchemaName",
  "OptSchemaEltList", "schema_stmt", "VariableSetStmt", "set_rest",
  "generic_set", "set_rest_more", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_drop_behavior", "opt_collate_clause", "alter_using",
  "replica_identity", "reloptions", "opt_reloptions", "reloption_list",
  "reloption_elem", "alter_identity_column_option_list",
  "alter_identity_column_option", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "column_compression",
  "opt_column_compression", "ColQualList", "ColConstraint",
  "ColConstraintElem", "generated_when", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "opt_c_include", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem", "OptWhereClause",
  "key_actions", "key_update", "key_delete", "key_action", "OptInherit",
  "OptPartitionSpec", "PartitionSpec", "part_params", "part_elem",
  "table_access_method_clause", "OptWith", "OnCommitOption",
  "OptTableSpace", "OptConsTableSpace", "ExistingIndex", "CreateStatsStmt",
  "stats_params", "stats_param", "AlterStatsStmt", "CreateAsStmt",
  "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "GrantRoleStmt", "RevokeRoleStmt", "opt_grant_admin_option",
  "opt_granted_by", "AlterDefaultPrivilegesStmt", "DefACLOptionList",
  "DefACLOption", "DefACLAction", "defacl_privilege_target", "IndexStmt",
  "opt_unique", "opt_concurrently", "opt_index_name",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_class", "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "opt_createfunc_opt_list", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "ReturnStmt", "opt_routine_body",
  "routine_body_stmt_list", "routine_body_stmt", "transform_type_list",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "operator_with_argtypes_list", "operator_with_argtypes",
  "DoStmt", "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_type", "reindex_target_multitable", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectDependsStmt",
  "opt_no", "AlterObjectSchemaStmt", "AlterOperatorStmt",
  "operator_def_list", "operator_def_elem", "operator_def_arg",
  "AlterTypeStmt", "AlterOwnerStmt", "CreatePublicationStmt",
  "opt_publication_for_tables", "publication_for_tables",
  "AlterPublicationStmt", "CreateSubscriptionStmt",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "TransactionStmtLegacy", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty",
  "opt_transaction_chain", "ViewStmt", "opt_check_option", "LoadStmt",
  "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "InsertStmtShort", "insert_target",
  "insert_rest", "override_kind", "insert_column_list",
  "insert_column_item", "opt_on_conflict", "opt_conf_expr",
  "returning_clause", "DeleteStmt", "using_clause", "LockStmt", "opt_lock",
  "lock_type", "opt_nowait", "opt_nowait_or_skip", "UpdateStmt",
  "UpdateStmtShort", "set_clause_list", "set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_materialized", "opt_search_clause",
  "opt_cycle_clause", "opt_with_clause", "into_clause", "OptTempTableName",
  "opt_table", "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "relation_expr_list", "relation_expr_opt_alias",
  "tablesample_clause", "opt_repeatable_clause", "func_table",
  "rowsfrom_item", "rowsfrom_list", "opt_col_def_list", "opt_ordinality",
  "where_clause", "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "xmltable",
  "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "a_expr", "b_expr", "c_expr", "func_application", "func_expr",
  "func_expr_windowless", "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "xml_passing_mech", "within_group_clause",
  "filter_clause", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "opt_window_exclusion_clause", "row",
  "explicit_row", "implicit_row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "func_arg_list_opt", "type_list", "array_expr",
  "array_expr_list", "extract_list", "extract_arg", "unicode_normal_form",
  "overlay_list", "position_list", "substr_list", "trim_list", "in_expr",
  "case_expr", "when_clause_list", "when_clause", "case_default",
  "case_arg", "columnref", "indirection_el", "opt_slice_bound",
  "indirection", "opt_indirection", "opt_asymmetric", "opt_target_list",
  "target_list", "target_el", "qualified_name_list", "qualified_name",
  "name_list", "name", "attr_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "SignedIconst", "RoleId", "RoleSpec", "role_list",
  "PLpgSQL_Expr", "PLAssignStmt", "plassign_target", "plassign_equals",
  "ColId", "type_function_name", "NonReservedWord", "ColLabel",
  "BareColLabel", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", "bare_label_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,    60,    62,    61,    43,
      45,    42,    47,    37,    94,   741,    91,    93,    40,    41,
      46,    59,    44,    58
};
# endif

#define YYPACT_NINF -5482

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5482)))

#define YYTABLE_NINF -2778

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2778)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   12071,    15, 18462, -5482, -5482,    15, 64974, -5482, 73049,  1449,
     173,  1406,   154, 18857, 73524, 82549,   225,   963, 12536,    15,
   82549,  1287, 55949, 70199,  1063, 82549,  1554,  1053, 55949, 82549,
      93, 83024,  1282,  1396,   146, 83499, 73999, 68774,  1431, 82549,
    1598,   368, 83974, 74474,  1275, 74949,  1053, 52173,   105,  1370,
   84449, 82549,106229,   368, 75424, 75424, 75424,  2826,  1903,  1414,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482,  1457, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482,  2156, -5482,  1238,
    2217,  1346,   771,  1429, -5482, -5482,  1991, 64974, 82549, 82549,
   82549,  1750, 82549,  1707, 82549,   851, 64974, 61174, 75899,  1890,
    1759, 48271, 84924, -5482, 64974, 82549, 58799, 64974, 82549, 82549,
   85399, 82549, 85874, 82549,  1773, 71624, 82549,  1837, 82549, 82549,
   59274, 86349,  2014,  1468,   253, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482,  1730,  1912, -5482,   275,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, 63549,
   82549, 10725,  1554,  1991, -5482,  2826, 82549,  2078, 82549,  1909,
   86824, 82549, -5482, 82549,  1925, 87299,   852,  1782, 61174,  1963,
   48763,  2112, 82549, 82549, 61174, 87774, 88249, 88724, 82549, 82549,
   -5482, -5482,  2096, 82549, -5482,  2219, 61649,  1515,  2243,  2432,
    2295,   718, -5482, 76374, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, 64499,   963, -5482, -5482,  2265, 65449,  2329, -5482,
   -5482, 89199,106690,  2134, -5482,   854, 65924, 62124,  2444,  2133,
   49255,  2530, -5482, 66399, -5482, 62599, 66874, -5482, -5482, -5482,
   -5482, -5482, 89674, -5482, 90149,  2241,  2329, -5482,107151, 63074,
   -5482,  2392, 90624, 91099, 91574,  1991,  2110,  1354,   910, 43439,
   -5482, -5482, -5482,  2164, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482,   844, -5482,   198,  1593,   251,   195,   254, -5482, -5482,
     197,   205,   206,   198,  2612,  2612, -5482, 82549, -5482, -5482,
    1593,    55,  2131,  2131,  2131,  2355,  1327, -5482,  2131,  2304,
   -5482, -5482, -5482, -5482, 74949, -5482,  2150, 76849, 82549, 77324,
    1554,  2182,  2600,  2223, -5482, -5482, -5482, -5482, -5482, 63549,
    2599,  2599, 82549, -5482, -5482,  2643,  2222,  2475,  2240, -5482,
   -5482, -5482,  2458,  2459,  2420,   354,  1554,   229, -5482,  2592,
   -5482,  2505, 29817, 29817,  1554, 77799, 92049,   280, 64499,  1554,
   78274,  2287,  1348,  2496, -5482, -5482, -5482,   674, -5482,  2758,
    2339,  2607,  2240,  1468, 44876, -5482,  2340,  1912, 74949, -5482,
   -5482, -5482, 63549,  2661, 32272, 82549,  2334, -5482,  2342,  2334,
   -5482, -5482,  2397, -5482,  2397,  2397,  2350,  2350,  2557,  2365,
   -5482, -5482, -5482,  1253,  2397,  2350, -5482,108073, -5482,  1836,
    1840, -5482, -5482,  2839, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482,  2383, -5482,  1000,  1947, -5482, -5482, -5482, 29817,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482,  2386,  2395,  1346,
   -5482,  6774, 63549, 82549,  1386,  1386,  2841,  1386,  1820,  1952,
   -5482,  2601, -5482,  2739,  2704, 74949,  2462,   911, -5482,  1630,
    2466,  1569,  2473,  1744,  1027, -5482,   641, 82549,   209,  2517,
   78749,  4999,  2493,  1912,  2531, -5482, -5482, -5482, -5482,  2645,
    1465, -5482, -5482, -5482, -5482,  2832,  2892,  6866,   325, 79224,
   -5482, -5482, -5482, -5482, 82549, 82549, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482,  2556,  1093, -5482, -5482,  2559,
    2913,  2783,  9512,   233,  2877,  2735,  1326, 10855,  2800,   144,
    2935, 14345,  1649,  2947,  1835,  2075, 76849, 82549,  2911,  2964,
    3075,  1824,   992,  2849,   936,  2877,  2967,  2796,  1326,  2983,
    6883, 82549, -5482,  2906,  3020,    87, -5482,   732, -5482, 23487,
   32272, 51698, -5482,  1912,  1769, -5482, -5482, 54999, -5482,  2705,
    2861,   689, 64974,  2648, 82549, 82549, -5482,106229, 64974, -5482,
    2869, 49747, 64974, -5482, 64974, -5482, -5482,  2981,106229, 82549,
   82549, -5482, 82549, -5482, -5482,  2650, -5482, -5482, -5482, -5482,
    2131, 82549,  3081,106229,  2884,   313,  1738,  3118, 82549,  2887,
    1738,  2696, 92524, -5482, -5482,  1738, -5482, -5482, -5482, 82549,
   82549,  2662,   155,  2875,  2994,  1738,  2894,  3117,  3119,  2896,
    2747,  2903,  2342,  3085,  2878,   996,   177,  2040,  1738,  2729,
   92999, 93474, 82549,  2730, 82549,  2599, 64974,  2767, 64974, 64974,
   82549,  3021, 82549, -5482,  2867, -5482, -5482,  1097, -5482, -5482,
   -5482, -5482, -5482,  3038, -5482,   153,  3040,  2698,  3045,  1802,
    3047,   176, -5482, -5482,  2740, -5482,  3049,   180, -5482,  3050,
   -5482,  2703, 93949, -5482, 94424, 94899,  3056,   259, -5482, 61174,
    3064,   180,  3065,  2703,  3066,   180,  3067,   246,  3068, -5482,
    1066,  3059,  3070,   176,  3074,  2158,  2703, -5482,  3076,   293,
   -5482,  3077,   326, -5482,  3078,  2948, -5482, 32272, -5482,  2834,
   -5482,  1370,  1785,   910,  3018, 74949,  1593, -5482, 82549,  1593,
   82549,  1593, 82549,  1593, 82549,  1593, 82549, 82549, 82549,  1593,
   -5482, -5482, -5482, 82549,  2741, 82549, 82549, -5482, -5482, -5482,
   70674, 61174, 71149, -5482, 82549, -5482,   541,  1554, -5482, -5482,
   -5482,    -9, -5482,  2240, -5482,106229,  3201, 61174,  2599,  1794,
   -5482, 82549, 82549, -5482, -5482, -5482,  3008, 82549,  3083,  3084,
   70674, 61174, -5482, 95374, -5482, 64499,  2957,  2744, -5482, -5482,
   -5482, -5482, -5482,  2019,  3239,   216,  3242, 32272,  2754,   216,
     216,  2757,  3089, -5482, -5482, -5482,   287,  2760,  2761, -5482,
     222,   222, -5482,  2763,  2764, -5482,   249,  2765,  2771,  3265,
    3266,   255,  2775,  2778,  2780,  1253,   216,  2781, 32272, -5482,
    2784,   222,  2786,  2787,  2788,  3275,  2789, -5482,  3282,  2791,
     291,   301,  2792,  2794, -5482,  2763, -5482,   258,  2795,  2797,
    2799,  2801,  2802,  2804,  2805,  2806, 32272, 32272, 32272, -5482,
   27357,  1912,  1554, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482,   265, 47779, -5482,  2847, -5482, -5482,  3012, -5482, -5482,
   32272, -5482, -5482,   100, -5482,   266, -5482, -5482, -5482,  1912,
    3093,  2812, -5482, -5482,  1680,  2813, -5482,  2289, -5482, -5482,
   -5482, -5482, -5482, -5482, 64024,  3279, -5482,   320,  1554,   732,
    1512,  3216, 54049, 54524, -5482, -5482,  3095, -5482, 82549, -5482,
   -5482,  1912,   148,  1833, -5482,  2164, 17160,  1883,  2334, 82549,
   82549,  3291, -5482,  2838, -5482, -5482, 32272, -5482, -5482, -5482,
    2612, -5482,  2397,  2397, -5482, -5482,  3296,  2925,  2926,  2612,
   -5482,  2612, -5482,  2843,  2846,  2612,  2929,  2932,  2934, -5482,
    2851,  2936,  2612, -5482, -5482, 56899,  2094, -5482,  3181,   302,
   -5482, -5482, -5482,  1981, -5482,  2854, -5482,  2342, -5482, -5482,
    1346,  1346, 32272,  1346,   240,  1307, 30308, 32763,  3190,  3079,
    1760,  1637,  3194, -5482,  3086,  1820,  1952, 74949, 82549, 95849,
   -5482, 32272, -5482,  3295,  2950,  2952,  3007, 53123, -5482,  2955,
    2921,  2958,  3014,  2876,  2963,  2965,  3022, -5482,  3153, -5482,
   -5482,  2974,  3051,  2982, 96324, -5482, -5482,  1030, -5482, -5482,
   -5482,  1030, -5482,  2914,  1271,  1033,   285,  2985,   215,   917,
    3311, -5482,  1200, -5482, -5482,  3044, -5482,  8897, 82549,  3252,
    7097,  3126,   325,  3048, -5482, -5482, -5482,  3183,  3001, 82549,
    3006,  3147,   325,   305, 96799, -5482, -5482, 82549, -5482, -5482,
   -5482, -5482,  9788,  3297, 26435, -5482,  1943,  3010,  2989,  3023,
   82549, 67824,   370,  3127,  3146,    77,  2048,   217,  3080, 82549,
     850,  3155, 82549,  2937,  3025,  3026,  3243,  2939,  1258,  3351,
    2940, -5482, -5482, -5482,  3318, -5482,   448,   451,  3145, -5482,
    3250,  3294,  7785,  3011,  3013,104846, -5482,  3036,    47, 50239,
   82549, 82549,  3039,  3041, 97274,  9788,  3326,  3052,  3054,  3046,
    3055,  1019,  3350,   712,  3057, -5482, -5482, -5482,   712,  3060,
    3061, 97749,  9788,  3337, 82549,  3062,  3063, 82549,108073,   325,
   -5482,  3408,   325,   325,  2441,  3410,  3069,   340,  3219,  1277,
    1738,  2940,  1508, -5482,  3071,  3072,   309, -5482,  3182, 82549,
    3087,  3090,  1743,  3156,  1554, -5482,  3157, -5482,  3092,  3158,
    3096,   675, -5482, -5482,  3088, 74949,  3175,  3180,   850,   425,
    1280,  2940, -5482,  3097,  3098,  2939,  2939, 82549, 82549, 82549,
   82549, 82549,   273,  3442,  3445,  3103,   348,   616,  2990, -5482,
     712, 59749,  3107, -5482,   712, 82549,   194,  1281,  2940,   734,
    1949, -5482, -5482, -5482,  1468, -5482, 32272, 32272, 32272,  2998,
   -5482,  1862, 17160,    72, -5482,   269,  6199,  2995, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, 82549, 63549, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, 82549, -5482, 82549,  3285,106229,  3289,  3230,
    3305,  3306,   325, 82549, 82549,  3312,  3314,  3315,106229,  3316,
    3317,  3320,  3255,  3122,   171,  3116,  3002,  3504,  3389, 82549,
   56899, -5482,  1030, -5482,106229,  3259,  3391, -5482, 82549,  3276,
      45, -5482,  3428,  3110, -5482, -5482,   671, 82549,   270,  3094,
   -5482, -5482,  3396, 61174,  1609,  3399,  1554,  3108,  3405,  3277,
    1554, 61174,  3319, 82549, 82549, 82549, 82549,   115, -5482, 59749,
    3298, -5482, 82549,  3299,  1508,  3301,  3523,    60,  2131, 98224,
    3397, 98699,  3073, 82549,  3082,  3082,  3526,106229,  1647,  3342,
   -5482, -5482,  2141, -5482,  3203, -5482, 64974, -5482, -5482, 64974,
   -5482, -5482,106229, 82549,  3099,106229,106229, -5482, -5482, 64974,
   64974, -5482, 61174, 61174,  3419,   293,  3420,  3136,  3423,  3139,
   50239, 50239, -5482,   372, 64974, -5482, 61174, 64974, -5482, 82549,
   -5482, 82549, -5482, -5482, -5482, -5482,106229,106229, -5482, 61174,
   59749,  3426, 82549, 82549, -5482, 82549, 82549, -5482, 82549, 82549,
    1998, 99174,   910, -5482, 82549,  3211, 82549, -5482, 82549, -5482,
   82549, -5482, 82549, -5482, 82549, -5482, -5482, -5482, 82549, -5482,
   82549,  2000, -5482, -5482,  2012,  1570, 82549, 82549,   226, 64974,
   82549,  3307, 64974, 64974, 82549, 82549, 82549, 82549, 82549,  3173,
    2813,  1645, -5482,  1323,   558, 74949,  3323, -5482, -5482,  2044,
    2826,  1328, 82549,  1223, -5482, -5482, -5482, -5482, 71149, 70199,
    3416,   361, 82549, -5482, -5482,  6119, 32272,  1912, 29321, -5482,
   -5482, 17160,  3148, 32272, 32272,  3101,  2612,  2612, -5482,   410,
   32272, 32272, 32272,  2612,  2612, 32272,  7397, 32272, 50239, 32272,
   37673, 24481, 32272, 32272, 27848, -5482, 32272,  3344, 38649, 32272,
    1512,  3348, 32272,  1512,  7397,  3590,  3590,  2056,  6103,  3105,
    1912, -5482,  2612,   880, -5482,   389,106229, 32272, 32272, 32272,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, 32272, -5482, 56899, -5482, -5482, -5482,
   -5482, -5482, -5482,  3193, -5482, -5482, -5482, -5482, -5482, -5482,
     247, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, 82549, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, 28339, -5482, -5482,
   -5482, -5482,  3111, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482,  2017, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, 28830, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482,  3112, -5482, -5482, 32272, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
    3197, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482,   742, 32272, 32272, 32272, 32272, 32272, 32272, 32272, 32272,
   32272, -5482, 32272,   436, -5482, -5482,  3431,  3452,    29,   465,
   79699, 29817,  3181, 23487, -5482,   238,  3181, -5482, -5482, -5482,
   82549,  3279, -5482, -5482,  3199, -5482, -5482, -5482, -5482, -5482,
     277, -5482, -5482, -5482, -5482, -5482, -5482, -5482,  3115, -5482,
   -5482, -5482, -5482,  3115, -5482,  3120,  3429,  3432,   246, 82549,
    2189, 32272,  3193,   208, 82549, 32272,  3111,  2017, 32272,  3112,
   32272,  3197, -5482, 32272, -5482,  2058,  2093, 32272,  2068,  3124,
   -5482, -5482,  3128,  2846,  3149,  3150,  3129,  3130,  2612,   188,
    3131,  1225,  1178,  3269,  2612,  3382,  3137, -5482, 56899, -5482,
   40565,  3184, -5482, -5482, -5482,   368, 82549, 82549, -5482,  3421,
   -5482,  3135, -5482, 13304,  3421, -5482, -5482, 38161,  3263,  3418,
    3356, -5482, -5482, -5482,  3143, 17160, 33254, 33254, -5482,  1996,
   17160,  2004, -5482, -5482, -5482, -5482, -5482, -5482,  1195, -5482,
   82549,   735,  3190,  1637,  3208, -5482,  3611, 82549, -5482,  2069,
   -5482, 61174, 82549, 82549,  3357, -5482,  3591, -5482,108073, -5482,
    3152, -5482,107612,103449, -5482, -5482,   945, -5482,  1006, 61174,
   -5482, 82549, 82549, 61174, 82549, 82549, -5482, 61174, 82549, 82549,
   -5482, -5482, -5482, -5482, -5482, 55474,  1219, 70199,  3292, 69249,
   -5482, -5482,  3159, 82549,  3217,  3434,  3436,   -26, -5482, -5482,
   99649, -5482,  3380, 61174, 82549, 82549, 32272,  3385, 82549, 82549,
   -5482,   587,  3246,  3247, -5482, 82549,  3249, 64974,  3168,106229,
   64974, 50731, 64974, 64974,  3500,106229, 82549, 82549,  1207, 74949,
     235,  1298,  2940,  3395, -5482,  1389, -5482, 61174, -5482, 82549,
    3386, -5482, -5482, -5482, 80174,  3624,  3293, -5482, -5482, -5482,
  100124, -5482, -5482,  3394, -5482,  2083, -5482, 61174, 61174, 82549,
    7805,100599,   572,  3411, -5482, -5482,106229, -5482, 82549, 80649,
   82549, 82549,  3447, 82549, 72099,101074,101549,  1344,  1687,  3449,
   82549, 72574,  3450, -5482,  3327, 82549, -5482, -5482, 57374, 61174,
   82549,   819, 56899, -5482, -5482, 82549, -5482,   966, -5482, 82549,
    2428,  3400, -5482, -5482,  3260,  3280, 82549,   304,  1689,  2940,
    3560, 82549, 82549,  3185,  2085, 61174, 82549, 56899, -5482,  3407,
    1339, 61174, 82549, 80174, -5482,  3409, 74949, 74949, 61174, 82549,
   74949, -5482, 82549, 92049, -5482, 61174,   982, -5482, 61174, 82549,
   80174, -5482,  3412,  3353, 61174, 82549, 15631, -5482, -5482, -5482,
     325, -5482, -5482, -5482, -5482, -5482, 82549, 82549,   325, 82549,
   82549,   325,  1308, -5482, 61174, 82549, -5482, -5482, -5482,  3321,
   61174, 82549, 82549,   198, 82549, -5482, 82549, 61174,  3094, 82549,
   82549, -5482, 82549,  3475, 82549, 82549, 82549, 82549, 82549, 82549,
   61174, 82549, -5482, -5482,  1254,  1256,  1673,  1682,   134, 82549,
    3508, 82549,102024, 61174, 82549, 82549,  1554, 82549, 56899,  1786,
   -5482, -5482,  3330, -5482, 61174,   982, -5482,  8146, 82549, 82549,
   82549,  3287,  3288,   193,  3376, -5482, -5482, -5482,   656,   656,
    3414, -5482, 32272, 32272, 30799,  3206, -5482, -5482, 32272,  2705,
   -5482, -5482, -5482,   312,  3671,   312,102499,   312,   312,  3495,
    3278,  3281,   312,   312,   312,  3493,   312,   312,   312, 82549,
    3398, -5482, -5482,  3398,   163, 32272,106229, 82549, -5482,  2100,
   -5482,  3232, -5482, -5482, 56899, 82549,   204,   853,  3565,  3443,
   68299,  2611,  3556, 82549,  3274, 82549,  3688,  3324, 74949,  2662,
   -5482,  2611, 82549, -5482,  2652, 70199, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, 82549, -5482, -5482,  3561, 82549, 41044,  3422,
   -5482,  1554,  2662,  2662,  2662,  2662,  3231,  2662, 82549,  3364,
    3585,  2611,  3244,  3592, -5482,  1508,  3594,   825, 82549,  3469,
   68299,  3331,  3300,  3480,  3713,  2131,  1554,  3483,  3471, -5482,
   53586, -5482,  2662,  3727, 26896,  4022,  5344,  3472,  3534, -5482,
   -5482,  3491,   838, 82549,  3575,  3586,  3605, -5482,   153, -5482,
    3737,  1802,  3608,   176, -5482,   180, -5482,  2703, -5482, 82549,
   -5482, 82549, 82549, 82549, 82549,   259, -5482, -5482,   180,  2703,
     180,   246, -5482,  3553,   176,  2703,  3413,  3612,   293, -5482,
     326, -5482,  3494,   246, -5482,  3513,  2131, -5482,  1046, 45355,
   -5482, -5482, -5482, -5482, -5482, -5482,  2111, -5482, 82549, -5482,
    3588,  3589,  3593,  3596,  3597,  3284,  3303,  3333, 82549,  3310,
    3284,   325,  3310,  3310,  3284,  2813,  2813,  3284,  3303, 60224,
    3762,  3617, -5482,  3388,  3302,  3627,   190, -5482,   236,  1428,
    3557, -5482, -5482, -5482, -5482,106229, -5482, 61174,  3358,  2599,
    2599,   379,  3532,  3325, 60224,  3749,   246, -5482, 64974, 82549,
  106229, 64974,  3541, 64974, 64974,106229, 82549, 82549,  2118, -5482,
    1763, -5482,  1875, 32272,   161, -5482, 13767,  2122, 32272,  3329,
    3332, -5482, -5482, -5482, -5482, -5482, -5482, -5482,  3334,  3648,
   -5482,  2136,  2160,  2170,  3335,  3339,  5606,  6969,  3340, 14271,
    3328,  3345,  3346,  3338, 37673, 37673, 27357,   609, -5482, 37673,
    3355,  3527,  2175, 10527,  3360,  3361, 14504, 31290, 32272, 31290,
   31290, 14583,  3354,  3362,  2176, 56899,  3520, 15076,  2204, -5482,
   32272, 56899,  7522, 32272, -5482, 32272,  3363, -5482, -5482,  2332,
    2332,  2332,  7397, -5482,  3352, -5482, 37673, 37673, -5482,  2465,
   27357, -5482, -5482,  3660, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482,  2828, -5482, -5482, -5482,  3579,  2829, 50239, 17179, 32272,
     210, 32272,  3111, 32272,  3441,  2332,  2332,  2332,   366,   366,
     199,   199,   199,  2159,   465, -5482, -5482, -5482,  3359,  3365,
    3366,  3555,  3367, 32272, -5482,  2307,  2317, 82549,  3341,  4002,
    5905, -5482, -5482, -5482,  3184,    72,  3184, -5482,  1468,  2612,
     880, 54999, -5482, -5482, -5482, -5482, -5482, -5482, 82549, 17160,
   -5482, -5482,  3620,  3369,  2209, -5482, -5482,  2612, -5482, -5482,
     -13,   -13,  3371, -5482,  3372, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482,  3373, -5482, -5482, -5482, 41523,  3698,  3375, 40086,
   81124,  3383,  1865, -5482, 81124, 81599, 81124, -5482,  3406, -5482,
    1912, 32272,  3694, -5482, -5482, -5482, 32272, -5482, -5482,  1910,
    3424,    81,   826,  1035,  1035,  1996,   842, -5482, -5482,  3451,
   -5482, 32272,  2035, -5482,  2149, -5482, -5482, -5482, -5482,  2813,
   -5482,  3647, -5482, -5482, -5482, 40565,  3438, 82549, -5482, -5482,
   -5482, -5482, -5482, -5482,103449,  1947, -5482,107612, -5482,107612,
   -5482,  1947,  3832, -5482,103449,  1962, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, 61174, 61174,
    3609, 82549,  3610,  3614, 32272,   938, 82549,  3401,  3403,  1418,
    3695, 82549, -5482,  3751,   246, -5482, -5482,  3492, -5482, 17160,
   -5482, -5482, -5482, -5482, -5482, 61174, 82549, -5482, 64499, -5482,
   -5482,106229, -5482, -5482, 82549, 82549, -5482, -5482, -5482,106229,
   -5482, -5482, -5482, 82549,   129,  3498,  3501, 82549, -5482,  1095,
    3182,  8836, 82549, 82549, 82549,  3697, -5482, -5482, -5482, -5482,
    3633, -5482,  3753, -5482,103449, -5482,  2703,  1481,  3509,  2940,
    3645, -5482,  3769,  3850, -5482,  3567,   974, -5482, -5482,  3578,
   -5482, -5482, -5482, -5482,  3792,   246,  3793,   246, 82549, 82549,
   82549, 82549,  3584, -5482, -5482, -5482, -5482,  3587,  3724, -5482,
   56899, 56899, 56899,  2210, -5482, -5482,  1554, -5482, -5482, -5482,
   -5482, -5482, -5482,  3750, -5482,  2218, -5482,   557, -5482, -5482,
   -5482, -5482, -5482,  3801, 61174, 82549,  9413, 82549, 82549, 82549,
    3674,  1859,  1170,106229, -5482,105307, -5482, -5482,  2235, -5482,
    3473, 82549,  3545, 61174,  3522, -5482, -5482, -5482,  3806,  3462,
    3462, -5482, -5482,  3462, -5482, -5482, -5482,  3731,  3661, -5482,
     925,  3663, 61174,  3535, -5482, -5482, -5482, -5482,  3815,  3558,
   -5482, -5482,  3559,  1869,  2940,  1508, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482,  3595, -5482, -5482, -5482, -5482,
    1708,  1708, -5482, -5482, -5482,  1708,  1501,   426,  1959,  2940,
   -5482,   902,  1564,  3562, -5482,  3563, -5482, -5482, -5482,  3730,
    3735,  3736,  3569,  3571,  3615,  3574,  3577,  3629, -5482,  3580,
    3635,  3599,  3646,  3600,  3879,   246,106229,  3747,  1554,  3644,
    3865,   246, -5482,  3606, -5482,  3607, -5482,  2259,  3973, -5482,
   82549, -5482,   307,  1983,  2940, -5482,  3613, -5482, 61174, 82549,
   -5482, -5482, -5482, 32272,  3524,  3529,  3530, 17160, 17160, 32272,
   -5482, -5482, 17160,  3528, -5482, -5482, -5482, -5482,106229, -5482,
   82549,  3812, -5482, -5482,   312, 82549, 82549, -5482, -5482, -5482,
   82549, -5482, -5482, -5482,  3813, -5482,   375,   375, -5482, -5482,
    3851,  7643,  3543,   367, -5482, 56899, 46795,  4143,   157,  1738,
   -5482, 64499, 82549, 64499, -5482,   853,  3746, 82549, 82549, 82549,
    3544,  3538, -5482, -5482, -5482, -5482, 61174,   882, 61174,  2612,
   -5482, -5482,  3621, -5482, 82549,  2131,  4041,  3881, -5482,  3462,
   -5482,  3999,  3119,  1609,  1764,   384,  2747,  3938,  2342, 32272,
     395, -5482, -5482,  1912, 82549,  3300, -5482, -5482, -5482, -5482,
    1554, -5482,  3551,  3549, -5482, 82549,  3885, 82549, 82549, 82549,
   82549,  3358,  3564, 82549,  3554,106229, 82549,  2270,  2939,  4017,
    3902,  2826,  3331,  3642,  3904, 74949,  3570,  2267, -5482, -5482,
     838, -5482,  2276,   178, -5482,  1554, 64499,104385,  3893, -5482,
     894,  5344, -5482, -5482,   894,   949, 82549, -5482, -5482, -5482,
   -5482,  3782,  1951, -5482,  3880, -5482, -5482,  2826, -5482,106229,
    3568, -5482,  2285, -5482, -5482, -5482,   293,  3625,   246,  3639,
     246, -5482, -5482, -5482, -5482, 82549, -5482, 82549, 59749, -5482,
   -5482, 82549, -5482,  3912,  3623,  1489, 44397,  3787, -5482, 82549,
     396, -5482,  3598, -5482, -5482, -5482,  3719,  3721,  3722,  3729,
    3732, 82549,  3284, -5482,  3576, 61174,  1732, -5482, -5482,  3786,
   -5482, -5482, 74949,  3714, -5482, -5482, -5482, -5482,  3939,  3940,
   -5482, -5482, -5482,  1060, -5482, 82549, 82549, 61174, 70674,   362,
   61174, -5482,  3875,  3876,  3877,  3882,   325,  3883,  3886,  3887,
    3889,  3892, -5482, -5482, -5482,  3602, 15241, 32272, -5482,  3969,
  106229, -5482,  7763, -5482, -5482, -5482, 32272, -5482, -5482, -5482,
   -5482, -5482, -5482,  2230, 32272, -5482, 32272, -5482, -5482, 24978,
    4103,  4103,  3618,106229, 37673, 37673, 37673, 37673,  1392,  2786,
   37673, 37673, 37673, 37673, 37673, 37673, 37673, 37673, 37673, 37673,
     497, -5482,  3821, 32272, 32272, 31781, -5482, -5482,106229,  3626,
    3354,  3631,  3632, 32272, -5482, -5482,  2292, 39128,  3636, 56899,
   -5482, 32272, 13443,  2296,  3670, 15670,  1912,  8191,  1554, 32272,
    1121,  1691, 32272,  2298, 32272,  3950, -5482, -5482, -5482, -5482,
   -5482, -5482,  3855, -5482, 32272,  3637,  3100, 37673, 37673,  3518,
   -5482,  3655, 32272, 27357, -5482,  3414,  3672, 45834, -5482, 25475,
    3630,  1053,  1053,  1053,  1053, -5482, 82549, 82549, 82549,  3694,
    3638,  3694,   732,  3640, -5482, -5482, -5482, -5482,  2826, -5482,
    3641, -5482, -5482, -5482, -5482, -5482, 81124, 81599, 81124,  3643,
   39607, 25955,  1865,  3652, 82549, -5482, -5482,  3656, 40565,  3907,
    3840, -5482, 40565,  3840,  1908,  3840,  3919,  3738, 46313, -5482,
   -5482,  3658, -5482,  3852, -5482,  1943, 17160,  4095,  3975, -5482,
    3673, -5482,  3424,  1846, -5482, -5482, -5482,  1026, -5482,  3757,
   -5482, -5482, -5482,  3383, 33745,  3811, -5482,  2310,  1984, -5482,
   -5482,103449, -5482,  3748,  2703,  2703,  1551,  3284,  3994,  1551,
    8532, -5482, -5482, 42002, 82549, 82549, -5482, 82549,  2312,  1412,
   82549, -5482, 82549, -5482, -5482, -5482,  4136,  3740,  3743,  3951,
   -5482,  2473, -5482, -5482, 61174, 82549, -5482, -5482, -5482,   403,
    2029,  2940, -5482,  3768, -5482, -5482,  3976, 82549, -5482,  4127,
    3781, 82549,  4038, 82549, 82074, -5482,  3746,  1412,  3803,  4018,
    1733,  2939,   340,  4376, -5482,  1893, -5482, -5482,  3771, -5482,
   82549, -5482, 82549, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
    3828, -5482, -5482, -5482, -5482, 57374, -5482, -5482, 82549, -5482,
   56899, 46795, 56899, 82549, -5482,  1526,   428,  2144,  2940, -5482,
    3783, -5482,  4042,  3788,  3789,  3841,   798,   879,  3799,  3804,
    3857,  3701,  3720,  3723, -5482, 56899, 47287,  3884, 82549,  2703,
    3728,  3764, 82549,   198,  1554, -5482, -5482,  1554,  2703,  1554,
   82549, 82549, 82549, 82549,   198, -5482, -5482, -5482,  4167,  3822,
   82549, 82549, 82549, 82549, -5482,  3785, -5482, -5482, -5482, 82549,
   82549,  4063,   985,  2173, 61174, 82549, 82549, 61174, 82549, 82549,
   82549, 82549, 82549, 82549, 82549,  3948, -5482,  4157,  4082,  2330,
    4129,  3814, 82549, -5482, 82549,  1554, -5482,  3182, 82549, 82549,
   82549, 82549, -5482, -5482, -5482, -5482, -5482,  3414, -5482,  3742,
    4024,   312, -5482,  4025,  4027,  4029,   312, -5482, -5482,  1738,
   -5482,   186, 82549, -5482,  2306, 82549, -5482, -5482, -5482,  3673,
     448,   451, -5482, -5482, -5482, -5482, -5482, -5482,  3752, 82549,
   82549, 37673, -5482,  2079,  1772,  1262, -5482,  4026, 82549,  3094,
   -5482, -5482, -5482,  1242, 82549, -5482, -5482, -5482, -5482,  3754,
   -5482,    46,  3564, -5482,  4050, 68299,  2703, 61174, 61174,  2703,
   -5482,106229,  3756,  3300, -5482,   292,  3842, 61174,  1609,102974,
    3108,  3797,  3978,  8587, 40565, 41044,  1708, -5482,  3760,  3763,
   -5482, -5482, 82549,  3746, 59749,  2354,  1508,  4227,  1150,  2110,
   -5482, 69724,  3962,  3564,  4050, -5482,  2939,  3985,  3984, -5482,
    2826, 82549,  3358,  3300,  1554, 82549,  3217, 46795, -5482,  4266,
    2097, -5482,103449, 32272, 32272, -5482,  3770, -5482,  3773,  5344,
   -5482,  3849,  3772,  4232, 32272, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482,  3862,  3779, 82549, 82549,   838, 82549, -5482,
    3780,  3608, -5482,  3608, -5482, 82549, -5482, 82549, -5482,   246,
   -5482,  3908,   246, 82549, -5482, -5482, -5482,  3837,  2356, -5482,
   -5482,  4193,  3811, -5482,  2358, 45355,  3438, 32272,  1912, 82549,
   82549, 82549, 82549, 82549,  3284,   325, -5482,  4104, 60224,  3617,
   -5482,  2360, 82549, -5482, -5482, -5482,  4173, -5482, -5482,   361,
    4116,   246, -5482,   965,   965,   965,   965,  4071,   965,   965,
     965,   965,   965, -5482, 32272, 17160, -5482,  3791, -5482, 17160,
    3794,  9104, 16186, -5482,  2362, 32272, -5482,  4498,  4498,  4498,
    3718,  4122, -5482,  2641,  4498,  4498,  4498,   376,   376,   185,
     185,   185,  4103,   497, 16417, 16540, 16781,  3798, -5482, -5482,
   -5482,  3354, -5482, 34236,   651,  4238, 38649, -5482, -5482, -5482,
    3844,  3845,  3802, -5482, 32272, 34727,  3808,108073,  4007, -5482,
    1736, 32272, 32272,   987, -5482,  8221, 32272, -5482,   987,   452,
   32272,  1821,  1933, 32272, 32272,  4111,  9440,  3805, 32272,103910,
   -5482, -5482, -5482,  2366, 32272, 82549, 82549, 82549, 82549, -5482,
   -5482, -5482,  3975,  1554,  3975,  1554,  3807, -5482, -5482, -5482,
   -5482, 57849,  3810,  3520, 81124,  3816, 82549,  1865, 40565, -5482,
   -5482,  1507, -5482, 40565,  4090, -5482, 40565, 64974, -5482, 82549,
    3817, 82549, -5482,  1386, 32272,  3856, 50239, -5482, -5482, -5482,
   -5482,  3905, -5482,  4034, 17160, 29817, -5482, -5482,  3894,  2377,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482,  3903, 70199,  4152,
   -5482, 32272,  2384, -5482,  3869,  4250,   345,  2388,  2401,  1412,
   -5482,  4131, -5482,  1872,  4130,   393, -5482,   246, -5482,106229,
   82549, 82549, 82549,  2876, -5482, -5482, 82549, 82549, 82549, 82549,
   -5482, -5482, 61174, 82549, -5482, 82549, -5482, -5482, -5482, -5482,
     198,  2079,  4144,  4145,  4059, -5482,   325, -5482,  2079,  4062,
     198, 82549, -5482, -5482, -5482,  1595, -5482,106229,   246,   246,
   -5482, -5482, -5482, -5482, -5482,  3858, -5482,  4279,  3935, 82549,
   82549, 82549, 82549, 82549, 61174, 82549, 82549,  2612,  2612,106229,
    3843, -5482,  2612,  2612,  3848, -5482, 61174, 82549, 82549, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
    3929, -5482, 32272,  4280, -5482, -5482, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, 61174, 82549,  3941, -5482,  3942,
   -5482,   840, -5482, -5482, 82549, 82549, 82549, 82549,  4199, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
    4197, 82549, -5482, -5482,  1554,  1554,106229,   246,   246, -5482,
   -5482, -5482,  3943, -5482, -5482,  3859,  4141,   312, -5482,   312,
     312,   312, -5482,  3863, -5482,  1738,  4229, -5482,  1412,  1486,
    4186, -5482, 32272, -5482,  1503,  3718, -5482,  4244,  4326, -5482,
   -5482, -5482, -5482,  3094,  2131,  3926, -5482, -5482, 64974,   356,
   -5482,  4170,   204, 56899,  4088, 68299,   902,   290,  3871,  4004,
   -5482,  2703,  2703,  3937, 82549,  4343, -5482, -5482, -5482, -5482,
   -5482, -5482, 61174,  3522, -5482,  4113,  1154,  4214, 82549, 41044,
   -5482,  3383, -5482, -5482, -5482,  1554, -5482, -5482,  4015,  3300,
   -5482,  1272, 82549,  4107, 68299,  3358,  2402, -5482, -5482, -5482,
    3933,  4333,  3331, -5482,   902,  3962, -5482, -5482,  4309,  3988,
    3944,  4359, -5482,  3988,  4226,  4115,  3916, -5482,  3570, -5482,
   82549, -5482, 17160, 17160,  1554,108534,   894,106229,  4235, -5482,
   17160, 82549,   857,  3901,  4072, -5482,  4200,   246,  2406, -5482,
     246,   246, -5482, 82549, -5482,  2826,  2628, 82549,  1912,    58,
   -5482,  3922, 82549, -5482,  3811, 17160,  3284,  3284,  3284,  3284,
    3284, -5482,  4132, -5482, -5482, -5482,  4202, -5482,   246, 60224,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482,   965, -5482, -5482,
   -5482, -5482, -5482, 17160, -5482, -5482, -5482, 32272, -5482,  9906,
   37673,  4251, -5482, 32272, 32272, 32272, -5482,  3927,  2410,  2411,
   -5482, -5482,   651, -5482,  4238, -5482, -5482, -5482,  9936,  3981,
   17160,  4040,  3928,  3930,   987,   987,  8221,   987, 32272, 32272,
     987,   987, 32272, -5482, -5482, 10032,  4124, -5482, -5482, 10455,
   -5482, -5482, -5482, -5482,  3856, -5482,  3856, -5482,  4067, -5482,
    2417,  4396, 36691,  4354, -5482, 82549,  2419, -5482, 32272,  3945,
   -5482, -5482, 40565,  1507,  3946,  2423, 82549,  2425,106229, 35218,
   17160, 82549,  3414,  3949, -5482, 82549,  2812, -5482, -5482, 60224,
    4153, 60224,  1412, 10955,  4131, 42002, 51223, 82549, -5482, 82549,
   -5482,  4105,  4131,  3947,  3094, -5482, -5482, -5482, -5482, -5482,
   -5482,  3952, -5482, -5482, -5482, -5482,  4033, -5482, -5482,    -8,
    3323, -5482,  4143, -5482,  4399,  4287,  4288, -5482, -5482, -5482,
   -5482, -5482, -5482,  4157, -5482, -5482, 46795, 61174, 82549, -5482,
    4035, -5482, -5482, -5482, -5482, -5482, -5482, 43918, 50239, -5482,
     798,  3954,  3955,   879, -5482, -5482, -5482, 82549, 10990,  3956,
     960,  3323, 82549, 82549,  3957,  3959,  3964,  1654,  1405,  1900,
    3284,  4283, 82549, -5482, -5482, -5482,  4157, -5482, -5482, 82549,
   -5482,   312, -5482, -5482, -5482, -5482, 56899, -5482,  2508,  3863,
    1554, 64974,  4426,  4426, 11092,  4190, -5482, -5482,   411,  3926,
    4220,  4267, -5482,  3968, 82549,  1242,  3971,  2429, -5482, 82549,
    3972,  4100,  2239,  2239, 82549, 82549, 82549,  2433,  2826,  2703,
    3764,  1609,  4319, 68299,  4362,  3746,   406, -5482, 82549,  4438,
   82549,  3358,  3564, 82549,  3982, -5482, -5482, 69724,  4189,  4143,
   82549,  2270,  3962,  3331,  1410, 82549, -5482,  1324, -5482,  2826,
   -5482, 82549, 74949, 42002,  4308, -5482,107612, -5482,  2434, -5482,
   -5482, -5482,  4058, 18162,  3184,  4099,  4101,  3989,  1871,  4317,
   82549,   686, -5482, -5482, -5482, -5482, -5482, -5482,  1489, -5482,
   -5482,  4400, 42002,  4357, 32272, -5482, -5482, -5482, 82549, -5482,
     362, -5482, 17110, -5482,  4544, 37673, 17160, 17160, 17160, 32272,
   -5482, 32272, -5482, -5482, -5482, -5482,   670, -5482, -5482,   987,
     987,   987, -5482,  4434,  3414, -5482, -5482, -5482,   363,  4383,
    3406, 57849,  3997, -5482, 37673,  2440, -5482,  3390, 82549,  2445,
   -5482, 17160, 82549, -5482, -5482, 32272, -5482,  2446, -5482,  3998,
      26,  4001, 23984,  3995, -5482, -5482, -5482, -5482, -5482, 17160,
    4003, -5482,  4463,  1637, -5482, -5482,  1732,  1551,   386,  4250,
    3094, -5482,  4006, -5482, -5482,  2939,   371, 82549,  3094, 82549,
    3926, -5482, 82549,  4108, -5482,  4323, -5482, -5482,  4068, -5482,
    1047,  3323, 82549,106229, -5482,   143,  4347, -5482,106229,106229,
   -5482, -5482, -5482, 32272,  4117, -5482, -5482, -5482, 32272, 32272,
   67349, -5482, -5482, 82549, 82549, 82549, 82549, 82549, -5482,   246,
   -5482, -5482,  2447, -5482, 42960, -5482, -5482,  3118,  1554,  3118,
    1540, -5482, -5482,  3118,  3118, -5482,  3184, -5482,  4426,  1113,
   -5482, -5482,  4258,  4030, 32272, -5482,   777,  4240,  4126,  4028,
   -5482, 64974,  4523, -5482, 56899,  3564,  4050, 82549, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,
    2451,  3746,  4373,  3300,  3944, -5482, 82549,  4074, -5482, 40565,
    3746,  2826,  2110, -5482,  3962,  3564,  4050, -5482, -5482,  4043,
    3984,  3331,  2270,  4179, -5482,  4182, -5482,  4469,  4256,  4473,
    3358, -5482,  3217,  2468, -5482, 82549, -5482, -5482,  5344,108534,
  106229, -5482, -5482, -5482,  4044,  4412,  4092,  4094, -5482, -5482,
   -5482,  1871, -5482,  1494,  4408,  4106, -5482,  4118, 82549, -5482,
   -5482,  4121, 82549,  2480,   745, 17160,  3746,   246, 32272,  4544,
    2486,  2487,  4123, -5482, 32272,  1333,  4394,  4403, 82549, -5482,
   -5482, -5482, 82549,  3718,  4066, 36691, 56899,  2494, -5482,105768,
   -5482,  2499,  2501, -5482, 32272,  4073, 32272, -5482, 35218, 82549,
    4075,  3190, -5482,  4397, -5482, -5482,  3926, 50239,   371,  3424,
    2131,  3926,  2503, -5482, -5482, 82549,  4030, 32272, -5482,  4165,
   -5482, -5482,  2507,  1745,  4246,  4246,  2511,  2515, 11620, 82549,
    2516,  2520, -5482,  2522,  2612,  3303,  1900,  3303, -5482,  3284,
   -5482, -5482, 56899, -5482, 60699, -5482, -5482, -5482,  1554, -5482,
    1554,  4304, 82549, 52648,  1554,  1554, -5482, -5482, -5482, -5482,
    4377, -5482,  1508, -5482, 11752, -5482, -5482, -5482,   446, -5482,
    4298,  4299, 82549, -5482,  4086, -5482,  2524, -5482,   902,  4215,
    3746, -5482, -5482, 82549,  4549,  4550, -5482,  1236, 82549,  3383,
   -5482,  3944,  3358,  3331,   902,  3962,  4143, 42481,  3988,  2270,
    3984, -5482, -5482,  4303, -5482,  4306, -5482,  4097,  4401, 42002,
   -5482,  1880,   894, -5482, -5482, -5482,   339,  4422,  4432, -5482,
   -5482, -5482,  3118, -5482,  1765,  4110,  4457, -5482, -5482,  2826,
   -5482,  3184, -5482,  4237, -5482, -5482, 17160, -5482, -5482, -5482,
    3354, 35709, 35709, 35709,  4114,  4554,  4558,  1193,  2534, 38649,
   -5482, -5482, -5482, 82549,  4327,  1172,  4580,  4281,  2535, 35218,
    2536, -5482, -5482, -5482, -5482, 60224,  4166,  4120,  3424, -5482,
    4220, -5482, -5482,  1412,  3323, -5482, 17160, 82549, 64974,  4564,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482,  3323,  4210, -5482,
   -5482, 67349, -5482, 82549, -5482, -5482,  2544, -5482, -5482, -5482,
   82549,  3901, -5482,  3901, -5482, -5482, -5482,  1300,  4236,  1141,
    1141,  4502, -5482,  4192, -5482, -5482,  4133, -5482,  4624,  4261,
   82549, -5482, -5482,   798,  2826, 68299,  3746, -5482, -5482,  2270,
    3962,  3331, 32272,  2545, -5482,  4250,   345, -5482,  3984,  3988,
   -5482, -5482, 42002,  4138,  3300, -5482,  4495, -5482, -5482, -5482,
    2710, 64974, 64974, 82549, -5482, -5482, -5482, 32272,  1242, -5482,
   -5482, 45355, 37182,  4282,   979, 13670,  4491, -5482,  4491,  4491,
   -5482, 82549, 82549, 82549, -5482,  3520, -5482, -5482, 37673, 37673,
    4369, -5482,  1172, -5482, 82549, -5482,  4146, -5482, -5482,  2550,
   -5482,   386,  4150, -5482, -5482, -5482,  4240,  1412, -5482,  3323,
   -5482, 82549, -5482,  4151, -5482, -5482, -5482, 60699,  3901, -5482,
   -5482, -5482,  4628, -5482,   262, -5482, -5482, -5482, -5482, 82549,
    3746,  3843,  3944, -5482,  3984,  3331,  2270, 12259, -5482, 42481,
   82549, 82549,  3988, -5482,  2566, 42002,  3988,  4296, -5482,  2394,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482,  4154,  4155, -5482,
   -5482, 12377, 64974,   856,  4619, -5482, -5482, -5482, -5482, -5482,
     905, -5482, -5482, -5482,  1284,  1291,  1917,  4574,  3718,  3718,
   -5482, -5482, -5482, 32272, -5482, -5482, 32272,  1412, -5482, -5482,
   -5482, 32272, -5482, -5482, -5482, -5482,  3746, -5482, -5482,  3988,
    2270,  3984,  4250, -5482, -5482, -5482, -5482, -5482,  4401, -5482,
    2576,  3184,  4106,  2467, -5482, -5482,  2554,  2395,  4241,  4486,
   -5482,  4161, -5482, 36200,  4305, -5482,  4368, -5482, 82549, 82549,
   58324, 82549, 82549, 12751, 12797,  1412,  2595, -5482, -5482,  3984,
    3988, 82549,  3300, -5482, 42002, -5482,  4510, -5482,  2394,  4284,
    4285, 56424, -5482, -5482, -5482, -5482, -5482,   278,  4545, -5482,
    2602, -5482, -5482, -5482,  3988, -5482, -5482,  3988, -5482,  1242,
   -5482,  4207,  4208, -5482,  2604, -5482, -5482, -5482, -5482, 32272,
   58324, -5482, -5482,  3184, 64974,  4492,  4493, -5482, 56424,   656,
    4239, -5482,  4172, 64974, 64974, -5482,  4174, 82549, 56424, -5482,
   -5482,  1554, -5482,  2617, -5482
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1658,  1422,   643,  1509,  1508,  1422,     0,   265,     0,  1519,
       0,  1422,   428,  1088,     0,     0,     0,     0,   643,  1422,
       0,  1658,     0,     0,     0,     0,     0,  1671,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1422,     0,
       0,  1678,     0,     0,     0,     0,  1671,     0,  1521,     0,
       0,     0,     0,  1678,     0,     0,     0,     0,     0,     2,
       9,    10,    45,    80,    81,    38,    37,    98,    63,    24,
      71,   132,   131,   133,    50,    46,    88,    33,    35,    47,
      51,    73,    75,    40,    53,    64,   110,    72,    31,    70,
      76,    96,    58,    19,    20,    59,    21,    60,    22,    61,
     106,    82,    99,    43,    69,    30,    52,    78,    79,    12,
      54,    86,    18,    65,    66,    68,    91,    92,    93,   115,
      94,   127,    49,   124,   103,   104,   121,   105,   122,    16,
     107,    62,    23,   118,   117,   119,    89,    55,    90,    77,
      97,   116,    34,   120,    25,    26,    28,    29,    27,    67,
      36,    74,    39,    95,   123,   113,   109,   128,   126,    11,
     134,   111,    83,    14,    15,   100,    13,    32,    57,    17,
      42,    41,    56,    48,   130,    44,  1519,   102,   114,   101,
      84,   108,    87,   112,   129,    85,   125,  1622,  1621,  1682,
    1625,  1657,     0,  1637,  1421,  1420,  1435,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   642,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1432,  2274,  2291,  2292,  2293,  2294,  2295,
    2296,  2297,  2298,  2299,  2300,  2301,  2302,  2303,  2304,  2306,
    2305,  2307,  2308,  2648,  2309,  2310,  2311,  2597,  2598,  2649,
    2599,  2600,  2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,
    2320,  2601,  2602,  2321,  2322,  2323,  2324,  2325,  2603,  2650,
    2326,  2327,  2328,  2329,  2330,  2331,  2651,  2332,  2333,  2334,
    2335,  2336,  2337,  2338,  2339,  2340,  2652,  2341,  2342,  2343,
    2653,  2344,  2345,  2346,  2347,  2348,  2349,  2604,  2605,  2350,
    2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,  2365,  2366,  2367,  2368,  2369,  2370,
    2371,  2372,  2373,  2374,  2375,  2376,  2377,  2606,  2378,  2379,
    2380,  2381,  2607,  2382,  2383,  2384,  2385,  2608,  2386,  2387,
    2388,  2654,  2655,  2389,  2390,  2391,  2392,  2393,  2609,  2610,
    2394,  2395,  2396,  2397,  2398,  2399,  2400,  2656,  2401,  2402,
    2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,
    2657,  2611,  2413,  2414,  2415,  2416,  2612,  2613,  2614,  2417,
    2658,  2659,  2418,  2660,  2419,  2420,  2421,  2422,  2423,  2424,
    2615,  2661,  2425,  2662,  2426,  2427,  2428,  2429,  2430,  2431,
    2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,  2440,  2441,
    2442,  2443,  2444,  2616,  2663,  2617,  2445,  2446,  2447,  2448,
    2449,  2450,  2451,  2618,  2619,  2452,  2453,  2454,  2664,  2455,
    2620,  2456,  2621,  2457,  2458,  2459,  2460,  2461,  2462,  2463,
    2464,  2465,  2466,  2622,  2665,  2467,  2666,  2623,  2468,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2624,
    2479,  2625,  2482,  2480,  2481,  2483,  2484,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2626,  2493,  2494,  2495,  2496,
    2497,  2498,  2499,  2500,  2501,  2502,  2503,  2504,  2505,  2506,
    2507,  2508,  2509,  2510,  2511,  2667,  2512,  2513,  2514,  2515,
    2516,  2627,  2517,  2518,  2519,  2520,  2521,  2522,  2523,  2524,
    2525,  2526,  2527,  2528,  2529,  2530,  2531,  2532,  2628,  2533,
    2534,  2668,  2535,  2536,  2629,  2537,  2538,  2539,  2540,  2541,
    2542,  2543,  2544,  2545,  2546,  2547,  2548,  2549,  2550,  2630,
    2551,  2552,  2553,  2554,  2669,  2555,  2556,  2557,  2558,  2559,
    2560,  2631,  2632,  2561,  2562,  2633,  2563,  2634,  2564,  2565,
    2566,  2567,  2568,  2569,  2570,  2571,  2572,  2573,  2574,  2575,
    2576,  2577,  2578,  2579,  2580,  2581,  2635,  2636,  2582,  2670,
    2583,  2584,  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2637,  2638,  2639,  2640,  2641,  2642,  2643,  2644,  2645,
    2646,  2647,  2594,  2595,  2596,   136,     0,     0,  2241,  2275,
    2276,  2279,  2274,   400,   399,  1611,  2238,  2275,  1518,     0,
    1498,   643,     0,  1435,   427,  1658,     0,     0,     0,     0,
       0,     0,   859,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   184,     0,     0,     0,     0,
     451,   450,     0,     0,  1054,   456,     0,     0,     0,     0,
       0,   633,  1558,  2480,  1556,  1612,   266,   269,   270,   267,
     268,  2257,     0,  1200,  1201,  1203,     0,     0,  1213,   899,
     900,     0,     0,     0,   913,     0,     0,     0,   897,     0,
       0,     0,   919,     0,   916,     0,     0,   920,   917,   894,
     918,   901,     0,   893,     0,     0,  1213,   921,     0,     0,
     895,     0,     0,     0,     0,  1435,  1555,   457,  1658,     0,
    1540,  1541,  1542,  1519,  1531,  1543,  1536,  1538,  1537,  1539,
    1535,     0,  2256,  2292,   989,   989,   989,   989,   986,   987,
     989,   989,   989,  2500,     0,     0,   968,     0,   970,  2258,
     989,   994,   525,   525,   525,     0,   993,   998,   525,     0,
    1403,  1444,  2240,  1670,     0,   969,  1402,     0,     0,     0,
    2561,  1546,     0,     0,  1228,  1224,  1226,  1227,  1225,     0,
    1057,  1057,  2519,  1412,   248,  2530,  2631,  2561,   247,   241,
     243,   215,  2296,     0,     0,   993,     0,  1435,  1410,   965,
    1677,  1675,     0,  2225,  2319,  2335,  2428,   238,  2512,  2520,
    2530,  2631,  2561,  2593,   194,   204,   199,     0,   259,  2530,
    2631,  2561,   255,  1432,     0,  1638,  1785,  2234,     0,  1405,
    1404,  1520,     0,  1523,     0,  2495,  1642,  1645,  1525,  1643,
    2277,  1860,  1889,  1867,  1889,  1889,  1856,  1856,  2365,  1869,
    1857,  1858,  1894,     0,  1889,  1856,  1861,     0,  1859,  1897,
    1897,  1884,     3,  1841,  1842,  1843,  1844,  1870,  1871,  1845,
    1876,  1877,  1881,  1846,  1911,  1856,  2278,  1679,  1680,  2225,
       4,  2271,     5,  2220,  2270,     6,     7,  1634,     0,     0,
       1,  1658,     0,  1530,  1674,  1674,     0,  1674,     0,  1626,
    1634,  1629,  1633,     0,     0,     0,     0,     0,  1406,     0,
       0,     0,   924,     0,  1447,  1039,     0,     0,     0,     0,
       0,  1297,     0,  1097,  1096,  2280,  2263,  2264,  2265,     0,
    2261,  2262,  2281,  2282,  2283,     0,  2400,  1297,     0,     0,
    2136,  2147,  2148,  2149,  2323,  2382,  2144,  2145,  2146,  2138,
    2139,  2140,  2141,  2142,  2143,     0,     0,  1195,  2137,     0,
    2400,     0,  1297,     0,   163,     0,   140,  1297,     0,     0,
    2400,     0,     0,  2400,     0,     0,     0,     0,     0,  2400,
       0,     0,     0,     0,     0,   163,  2433,     0,   140,  2400,
       0,     0,  1426,     0,     0,     0,  1428,  1431,  1418,     0,
    2217,     0,  2218,  2242,     0,  1512,  1506,  1515,  1511,  1501,
       0,  2234,     0,     0,     0,     0,   907,     0,     0,   897,
       0,     0,     0,   908,     0,   909,   910,     0,     0,     0,
       0,   906,     0,  1416,  1408,     0,  1548,  1550,  1549,  1547,
     525,     0,     0,     0,  2400,     0,   140,  1485,     0,  2400,
     140,     0,     0,   455,   454,   140,  2261,   453,   452,  2323,
    2382,     0,  1087,     0,  1362,   140,  2400,     0,   186,  2400,
     702,  2400,  1525,     0,   646,     0,   814,  2433,   140,     0,
       0,     0,     0,     0,     0,  1057,     0,     0,     0,     0,
       0,     0,     0,   632,   643,  1559,  1557,     0,  1204,   240,
     239,  1202,   911,  2400,  1129,   361,     0,     0,  2400,  1466,
    2400,   361,   928,   912,     0,   898,  2400,   361,  1093,  2400,
    2266,   173,     0,   896,  2323,  2382,  2400,   361,  1197,     0,
    2400,   361,  2400,   169,  2400,   361,  2400,   361,  2400,   647,
       0,     0,  2400,   361,  2400,  2433,   171,   915,  2400,   361,
     922,  2400,   361,  2236,  2400,     0,  1419,     0,  1551,     0,
    1533,  2635,     0,  1658,     0,     0,   989,   988,     0,   989,
       0,   989,     0,   989,     0,   989,     0,     0,     0,   989,
    2259,  2260,   971,     0,   995,     0,     0,  1002,  1001,  1000,
       0,     0,     0,  1003,     0,  1789,  1587,     0,  1400,   242,
     193,     0,   254,   253,  1415,     0,     0,     0,  1057,     0,
    1056,     0,     0,  1411,   246,   244,     0,     0,     0,     0,
       0,     0,  1417,     0,  1409,     0,     0,     0,  2244,  2246,
    2247,  2150,  2220,     0,  2598,  2599,  2600,  2209,     0,  2601,
    2602,  2603,  2650,  2040,  2027,  2036,  2041,  2028,  2030,  2037,
    2604,  2605,  1978,  2606,  2607,  2254,  2608,  2609,  2610,  2612,
    2613,  2614,  2615,  2032,  2034,  2616,  2617,  2619,     0,  2255,
    2620,  2621,  2462,  2623,  2624,  2626,  2627,  2038,  2629,  2630,
    2631,  2632,  2633,  2634,  2253,     0,  2039,  2636,  2638,  2639,
    2640,  2641,  2643,  2644,  2645,  2646,     0,     0,     0,  2231,
       0,  2007,     0,  1849,  1850,  1872,  1873,  1851,  1878,  1879,
    1852,     0,  2230,  1914,  2095,  2006,  2023,     0,  2012,  2013,
       0,  2005,  2001,  1660,  2226,     0,  2002,  2243,  2245,  2210,
    1660,  2224,   207,   261,     0,   262,  2232,  2530,   195,   237,
     209,   236,   210,   208,     0,  2321,   196,     0,     0,   197,
       0,     0,     0,     0,   258,   256,     0,  1407,     0,  1787,
    1786,  2235,   933,     0,  1522,  1519,  2160,     0,  1644,     0,
       0,     0,  1888,  1875,  1883,  1882,     0,  1865,  1864,  1863,
       0,  1862,  1889,  1889,  1887,  1866,  1841,     0,     0,     0,
    1893,     0,  1891,  1837,  1833,     0,  1900,  1901,  1902,  1899,
    1912,  1898,     0,  1847,  1903,     0,  1856,  1853,  1745,     0,
    1624,  1623,     8,     0,  1527,  1529,  1504,  1525,  1672,  1673,
       0,     0,     0,     0,     0,     0,     0,     0,  1732,  1690,
    1691,  1693,  1729,  1733,  1741,     0,  1630,     0,     0,  1791,
    1602,     0,  1433,     0,     0,     0,     0,     0,  1128,     0,
       0,     0,     0,   925,     0,     0,     0,  1453,     0,  1455,
    1456,  1457,     0,     0,     0,  1458,  1459,  1447,   250,  1465,
    1463,  1446,  1448,  1461,     0,     0,     0,     0,     0,     0,
       0,  1477,     0,   177,   178,     0,   659,   643,     0,  2400,
       0,     0,     0,     0,  1138,  1145,  1296,     0,     0,     0,
       0,     0,     0,     0,     0,  1139,  1137,     0,  1140,   252,
    1150,  1177,  1180,     0,     0,  1095,  1098,     0,     0,     0,
       0,     0,  1287,     0,     0,     0,  1287,     0,     0,     0,
    1296,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     277,   279,   292,   356,     0,   624,     0,     0,     0,   627,
       0,  2400,  1297,     0,     0,     0,  1199,     0,     0,     0,
       0,     0,     0,     0,     0,  1180,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   138,   139,   144,     0,     0,
       0,     0,  1180,     0,     0,     0,     0,     0,     0,     0,
     610,   623,     0,     0,     0,     0,     0,   620,     0,     0,
     140,   282,   600,   606,     0,     0,     0,   709,   708,     0,
       0,     0,     0,     0,     0,  1377,     0,  1376,     0,     0,
       0,     0,  1475,  1474,     0,     0,     0,     0,     0,  1287,
       0,   271,   273,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   392,   393,
       0,     0,     0,   144,     0,     0,  1287,     0,   284,     0,
       0,  1427,  1424,  1425,     0,  1430,     0,     0,     0,     0,
    2015,     0,  2164,  1682,  2162,  1113,  2216,     0,  2284,  2671,
    2672,  2673,  2674,  2675,  2676,  2677,  2678,  2679,  2680,  2681,
    2682,  2683,  2684,  2685,  2686,  2687,  2688,  2689,  2690,  2691,
    2692,  2693,  2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,
    2702,  2703,  2704,  2705,  2706,  2707,  2708,  2709,  2710,  2711,
    2712,  2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,  2721,
    2722,  2723,  2724,  2725,  2726,  2727,  2728,  2729,  2730,  2731,
    2732,  2733,  2734,  2735,  2736,  2737,  2738,  2739,  2740,  2741,
    2742,  2743,  2744,  2745,  2746,  2747,  2213,  2212,  2239,  2285,
    2286,  2287,  2288,  2219,     0,     0,   226,   227,   225,  1513,
     228,  1514,  1510,     0,  1496,     0,     0,     0,     0,     0,
       0,     0,     0,  2323,  2382,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   822,  1447,  1484,     0,     0,     0,   652,     0,  2400,
       0,   142,   860,     0,   812,   456,     0,     0,     0,  1170,
    1361,   142,     0,     0,   180,     0,     0,   706,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   813,     0,
       0,   142,     0,  2400,   603,  2400,     0,   525,   525,     0,
       0,  1059,     0,     0,     0,     0,     0,     0,     0,     0,
    1616,  1615,  1618,  1617,     0,  1614,     0,   359,   360,     0,
    1187,  1212,     0,     0,     0,     0,     0,   889,   914,     0,
       0,  1181,     0,     0,  2400,   361,  2400,     0,  2400,     0,
       0,     0,  1189,   361,     0,  1183,     0,     0,  1185,     0,
    1378,     0,   905,   903,   902,   904,     0,     0,   887,     0,
       0,     0,     0,     0,   882,     0,     0,   884,     0,     0,
       0,     0,  1658,  1532,     0,     0,     0,   979,     0,   983,
       0,   974,     0,   980,     0,   975,   972,   973,     0,   978,
       0,     0,   526,   528,     0,     0,  2347,  2364,     0,  2389,
    2421,  2422,  2486,  2515,  2520,  2526,     0,  2555,  2566,     0,
    1004,  1034,   999,   718,     0,     0,  1597,  1401,  2169,     0,
    1658,     0,     0,     0,  1220,  1221,   245,   216,     0,     0,
       0,  1036,  2519,  1414,   964,   643,     0,  2003,     0,  2010,
    2011,  2208,     0,     0,     0,     0,     0,     0,  2009,     0,
       0,     0,     0,     0,     0,     0,  1936,     0,     0,  2168,
       0,     0,  2168,     0,     0,  1971,     0,     0,     0,     0,
       0,     0,     0,     0,  1937,  1918,  1919,  2007,  2160,     0,
    2008,  2250,     0,  1911,  2289,  2150,     0,  2147,  2148,  2149,
    2748,  2749,  2750,  2751,  2752,  2753,  2754,  2755,  2756,  2757,
    2758,  2759,  2760,  2761,  2762,  2763,     0,  2764,  2765,  2766,
    2767,  2768,  2770,  2769,  2771,  2772,  2773,  2774,  2775,  2776,
    2223,  2778,  2779,  2780,  2781,  2782,  2783,  2784,  2785,  2786,
    2787,  2788,  2789,  2790,  2791,  2792,  2793,  2794,  2795,  2796,
    2797,  2798,  2799,  2800,  2801,  2802,  2803,  2804,  2805,  2806,
    2807,  2808,  2809,  2810,  2811,  2812,  2813,  2814,  2815,  2816,
    2817,  2818,  2819,  2820,  2821,  2822,  2823,  2824,  2825,  2826,
    2827,  2828,  2829,  2830,  2831,  2832,  2833,  2834,  2835,  2836,
    2837,  2838,  2839,  2840,  2841,  2842,  2843,  2844,  2845,  2846,
    2847,  2848,  2849,  2850,  2851,  2852,  2853,  2854,  2855,  2856,
    2857,  2858,  2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,
    2867,  2868,  2869,  2870,  2871,  2872,  2873,  2874,  2875,  2876,
    2877,  2878,  2879,  2880,  2881,  2882,  2883,  2884,  2885,  2886,
    2887,  2888,  2889,  2890,  2891,  2892,  2893,  2894,  2895,  2896,
    2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,  2906,
    2907,  2908,  2909,  2910,  2911,  2912,  2913,  2914,  2915,  2916,
    2917,  2918,  2919,  2920,  2921,  2922,  2923,  2924,  2925,  2926,
    2927,  2928,  2929,  1951,  2930,  2931,  2932,  2933,  2934,  2935,
    2936,  2937,  2938,  2939,  2940,  2941,  2942,  2943,  2944,  2945,
    2946,  2947,  2948,  2949,  2950,  2951,  2952,  2953,  2954,  2955,
    2956,  2957,  2958,  2959,  2960,  2961,  2962,  2963,  2964,  2965,
    2966,  2967,  2968,  2969,  2970,  2971,  2972,  2973,  2974,  2975,
    2976,  2977,  2978,  1953,  2979,  2980,  2981,  2982,  2983,  2984,
    2985,  2986,  2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,
    2995,  2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,
    3005,  3006,  3007,  3008,  3009,  3010,  3011,  3012,  3015,  3013,
    3014,  3016,  3017,  3018,  3019,  3020,  3021,  3022,  3023,  3024,
    3025,  3026,  3027,  3028,  3029,  3030,  3031,  3032,  3033,  3034,
    3035,  3036,  3037,  3038,  3039,  3040,  3041,  3042,  3043,  3044,
    3045,  3046,  3047,  3048,  3049,  3050,  3051,  3052,  3053,  3054,
    3055,  3056,  3057,  3058,  3059,  3060,  3061,  3062,  3063,  3064,
    3065,  3066,  3067,  3068,  3069,  3070,  3072,  3071,  3073,  3074,
    3075,  3076,  3077,  3078,  3079,  3080,  3081,  3082,  3083,  3084,
    3085,  3086,  3087,  3088,  3089,  3090,  3091,  3092,  3093,  3094,
    3095,  3096,  3097,  3098,  3099,  3100,  3101,  3102,  3103,  3104,
    3105,  3106,  3107,  3108,  3109,  3110,  3111,  3112,  3113,  3114,
    3115,  3116,  3117,  3118,  3119,  3120,  3121,  3122,  3123,  3124,
    3125,  3126,  3127,  3128,  3129,  3130,  3131,  3132,  3133,  3134,
    3135,  3136,  3137,  3138,  3139,  3140,  3141,  3142,  3143,  3144,
    3145,  3146,  3147,  3148,  3149,  3150,  3151,  3152,  3153,  3154,
    3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,  3163,  3164,
    3165,     0,  2144,  2145,  2146,  2138,  2139,  2140,  2141,  2142,
    2143,  2154,     0,     0,  2229,  2290,     0,  2097,     0,  1933,
       0,     0,  1745,     0,  2248,  2211,  1745,   263,   264,   260,
       0,     0,   212,   211,     0,   230,   234,   235,   206,   233,
       0,   229,   214,  2084,  2083,   213,   205,   202,   200,   217,
     219,   220,   203,   201,   257,     0,     0,     0,   361,  1530,
    1517,     0,     0,  2223,     0,  2158,     0,     0,  2156,     0,
       0,     0,  1742,     0,  1646,     0,  1650,     0,     0,     0,
    1886,  1885,  1838,  1834,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   926,     0,  1854,
       0,  1807,  2272,  2273,  2221,  1678,  1530,     0,  1526,  1641,
    1640,  1683,  1684,  1079,  1639,  1712,  1713,     0,     0,     0,
       0,  1738,  1736,  1703,  1694,  1702,     0,     0,  1700,     0,
    1704,  1914,  1731,  1628,  1688,  1689,  1692,  1627,     0,  1734,
       0,  1600,  1732,  1693,  1584,  1561,  1562,     0,  1792,     0,
    1434,     0,     0,     0,  1108,  1110,     0,  1109,     0,  1112,
       0,  1121,     0,     0,  1107,  1126,     0,  1115,  1113,     0,
    1473,     0,     0,     0,     0,     0,  1454,     0,     0,  2555,
     249,  1457,  1462,  1449,  1460,     0,     0,     0,     0,     0,
    1038,  1037,     0,     0,  1061,     0,     0,     0,  1480,   514,
       0,   358,     0,     0,     0,     0,     0,     0,     0,     0,
     808,   805,     0,     0,   804,     0,   657,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   682,     0,
    1287,     0,   290,     0,  1147,     0,  1146,     0,  1151,     0,
       0,  1148,  1143,  1144,  2520,  2530,  2561,   251,  1149,  1179,
       0,  1178,  1174,     0,  1090,     0,  1091,     0,     0,     0,
       0,     0,  2374,  2400,   298,   321,     0,  1286,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   343,     0,     0,   346,   345,     0,     0,
       0,     0,     0,   350,   329,     0,   330,     0,   349,     0,
       0,     0,   625,   626,     0,     0,     0,  1287,     0,   286,
       0,     0,     0,     0,     0,     0,     0,     0,  1196,     0,
     735,     0,     0,  2520,  1175,     0,     0,     0,     0,     0,
       0,  1365,     0,     0,   166,     0,   161,   165,     0,     0,
    2520,  1176,     0,     0,     0,     0,     0,   608,   609,   622,
       0,   613,   614,   611,   615,   616,     0,     0,     0,     0,
       0,     0,     0,   607,     0,     0,   704,   703,   707,     0,
       0,     0,     0,     0,     0,  1371,     0,     0,  1170,     0,
       0,  1370,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1230,  1229,     0,     0,     0,     0,  1297,     0,
     850,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     168,   722,     0,   721,     0,   162,   167,     0,     0,     0,
       0,     0,     0,     0,     0,   224,  1423,  1429,  1682,  1682,
    1682,  2021,     0,     0,     0,     0,  1681,  2214,  2217,  1501,
    1507,  1500,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     406,   403,   404,   406,     0,     0,     0,     0,   824,     0,
     827,   830,  1445,   479,     0,     0,   649,   682,     0,     0,
     459,   175,     0,     0,     0,     0,   737,     0,     0,     0,
    1360,   137,   184,   186,   457,     0,   185,   187,   189,   190,
     191,   188,   192,     0,   701,   705,     0,     0,     0,     0,
     645,     0,     0,     0,     0,     0,     0,     0,  1812,     0,
       0,   160,     0,     0,   598,   602,     0,     0,     0,     0,
     459,   564,   372,  2400,     0,   525,     0,  2400,     0,  1058,
       0,   811,     0,     0,     0,  1132,  1132,     0,     0,   751,
     750,     0,     0,     0,     0,     0,     0,  1613,   361,  1130,
       0,  1467,     0,   361,   929,   361,  1094,   174,  2267,     0,
     891,     0,     0,     0,     0,   361,  1198,   879,   361,   170,
     361,   361,   648,     0,   361,   172,     0,     0,   361,   923,
     361,  2237,     0,   361,  1554,  2400,   525,  1534,     0,     0,
     976,   985,   984,   982,   981,   977,     0,   996,     0,   524,
       0,     0,     0,     0,     0,  1012,  1013,     0,     0,  1009,
    1014,     0,  1010,  1011,  1016,  1006,  1005,  1017,  1018,     0,
       0,  1036,   716,     0,     0,     0,     0,  1594,     0,  1592,
       0,  1790,  1596,  1585,  1545,     0,  1544,     0,   591,  1057,
    1057,     0,     0,   993,     0,     0,   361,  1413,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2173,
       0,  2174,     0,     0,  2207,  2203,     0,     0,     0,     0,
       0,  2177,  2180,  2181,  2182,  2179,  2183,  2178,     0,     0,
    2184,     0,     0,     0,     0,     0,     0,     0,     0,  2164,
    2167,     0,     0,  2627,     0,     0,     0,     0,  1979,     0,
       0,  2131,     0,  2164,     0,     0,     0,     0,     0,     0,
       0,  2160,  2199,     0,     0,     0,     0,  2082,     0,  2079,
       0,     0,     0,     0,  2220,     0,     0,  2251,  1915,  1929,
    1930,  1931,  1934,  2228,     0,  2222,     0,     0,  1916,  1942,
       0,  2200,  1967,     0,  1972,  1957,  2185,  2186,  2187,  2188,
    1974,     0,  1950,  1955,  1959,     0,  1938,     0,  1935,     0,
    2223,  2159,     0,  2157,     0,  1926,  1927,  1928,  1920,  1921,
    1922,  1923,  1924,  1925,  1932,  2135,  2133,  2134,     0,     0,
       0,  2105,     0,     0,  1954,  2392,  2428,     0,  1671,  1671,
    1671,  1659,  1669,  2227,  1807,  1682,  1807,  2233,     0,     0,
    1911,     0,  1788,   931,   932,   930,  1503,  1516,  1530,  2161,
    1524,  1648,     0,     0,     0,  1855,  1868,     0,  1896,  1895,
    1897,  1897,     0,  1839,     0,  1880,  1905,  1906,  1907,  1908,
    1909,  1910,     0,  1904,  1848,   927,     0,  2517,  2647,     0,
    1769,  1744,  1746,  1756,  1769,  1776,  1769,  2024,  1805,  2025,
    2234,     0,  1715,  2269,  1505,  1528,     0,  1077,  1078,     0,
    1082,  2627,  2517,     0,     0,     0,     0,  1705,  1739,     0,
    1730,     0,  2244,  1706,  2243,  1707,  1710,  1711,  1701,  1740,
    1598,     0,  1735,  1632,  1631,     0,  1810,     0,  1793,  1743,
    1336,  1231,  1298,  1111,     0,  1856,  1122,     0,  1106,     0,
    1105,  1856,     0,  1123,     0,  1856,  1337,  1232,  1299,  1338,
    1233,  1300,  1339,  1234,  1464,  1452,  1451,  1450,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   789,  2400,   361,  1478,  1340,     0,  1235,   357,
    1479,  1301,  1483,   807,   806,     0,     0,  1302,     0,   658,
     663,     0,   665,   666,  2323,  2382,   667,   670,   671,     0,
     673,   662,   661,     0,     0,     0,     0,     0,   679,   684,
       0,     0,     0,     0,     0,     0,  1141,  1142,  1341,  1238,
       0,  1303,     0,  1089,     0,  1239,   176,     0,     0,   278,
    2400,   300,     0,   477,   789,     0,  1289,   297,   327,     0,
     342,   337,   338,   336,  2400,   361,  2400,   361,     0,     0,
       0,     0,     0,   339,   334,   335,   331,     0,     0,   344,
    2295,  2366,  2531,     0,   690,   692,     0,   697,   347,  1259,
     368,   367,   366,     0,   351,     0,   373,   376,   348,   328,
     326,   323,   293,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1191,     0,  1344,  1304,     0,  1326,
       0,     0,     0,     0,   729,  1347,  1245,  1307,     0,  1366,
    1368,  1358,  1246,  1367,   164,  1276,   153,     0,     0,   149,
       0,     0,     0,     0,   143,  1348,  1247,  1308,     0,     0,
    1349,  1248,     0,     0,   283,   601,   612,   617,  1253,   621,
     618,  1316,   619,  1356,  1249,     0,  1352,  1279,  1311,   584,
    1170,  1170,  1359,  1372,  1250,  1170,     0,  1287,     0,   272,
     274,     0,  1057,     0,  1251,     0,  1309,  1351,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1486,     0,
       0,     0,     0,     0,     0,   361,     0,     0,     0,  1289,
    2400,   361,  1350,     0,  1284,     0,  1324,     0,     0,   394,
       0,  1277,  1287,     0,   285,  1255,     0,  1318,     0,     0,
     222,   221,   223,     0,     0,     0,     0,  2165,  2166,     0,
    2163,  2016,  2216,     0,  1497,   953,   939,   952,     0,   935,
    2364,     0,   938,   940,     0,     0,     0,   941,   945,   946,
       0,   937,   934,   936,     0,   405,     0,     0,   746,   747,
       0,     0,     0,     0,   826,     0,     0,  1476,     0,   140,
     656,     0,     0,     0,   651,   681,   686,     0,     0,     0,
       0,   458,   462,   466,   467,   468,     0,     0,     0,     0,
     154,   141,     0,   868,     0,   525,     0,   739,  1364,  1363,
    1169,     0,   186,   179,     0,     0,   702,     0,  1525,     0,
       0,   579,   582,   581,     0,   372,   821,   819,   818,   820,
     842,   817,     0,  1811,  1813,     0,     0,     0,     0,     0,
       0,   591,   461,     0,     0,   528,     0,   567,     0,     0,
       0,     0,   564,     0,     0,     0,  2277,     0,   838,   810,
       0,  1100,     0,  1118,  1101,     0,     0,     0,     0,  1155,
    1162,  1131,  1156,  1133,  1162,     0,     0,   752,   756,   755,
     759,   757,     0,   753,   630,  1619,  1620,     0,  1188,     0,
       0,  1472,     0,  1470,   890,  1182,   361,     0,   361,     0,
     361,  1190,  1184,  1186,  1379,     0,   888,     0,     0,   881,
     883,     0,   885,     0,     0,     0,     0,  1576,  1564,     0,
    1745,  1603,     0,  2220,   997,   527,     0,     0,     0,     0,
       0,     0,  1008,   628,  1015,     0,  1029,  1024,  1026,     0,
    1030,   715,     0,     0,  1595,  1588,  1590,  1589,     0,     0,
    1586,  2170,   880,     0,   597,     0,     0,     0,     0,  1036,
       0,  1031,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1676,  2171,  2172,     0,     0,     0,  2204,     0,
       0,  2057,     0,  2029,  2031,  2043,     0,  2058,  2014,  2059,
    2033,  2035,  2044,     0,     0,  2151,     0,  2047,  2046,     0,
    1981,  1982,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1996,  2048,  2130,     0,     0,     0,  2050,  2049,     0,     0,
    2198,     0,     0,     0,  2055,  2060,     0,     0,     0,     0,
    2066,     0,  2087,     0,     0,     0,  2004,  2161,     0,     0,
       0,     0,     0,     0,     0,     0,  1973,  1958,  1976,  1952,
    1956,  1960,     0,  1975,     0,     0,  1946,     0,     0,  1944,
    1968,  1940,     0,     0,  1969,     0,     0,     0,  2022,     0,
       0,  1671,  1671,  1671,  1671,  1668,     0,     0,     0,  1715,
       0,  1715,   198,     0,   231,   218,  1502,  1649,  1658,  1874,
       0,  1892,  1890,  1835,  1840,  1913,  1769,  1776,  1769,     0,
       0,  1634,     0,  1756,     0,  1768,  1754,  1767,     0,     0,
    1782,  1780,     0,  1782,     0,  1782,     0,  1748,     0,  1772,
    1750,  1767,  1752,     0,  1797,  2235,  1806,     0,  1728,  1685,
       0,  2152,  1082,     0,  1687,  1709,  1708,     0,  1698,     0,
    1737,  1695,  1599,  1583,     0,  1581,  1563,     0,  1856,  1103,
    1104,     0,  1127,     0,  1041,  1042,     0,  1040,     0,     0,
       0,   513,  1060,     0,     0,     0,   789,     0,     0,   517,
       0,  1481,     0,  1357,  1275,   660,     0,     0,     0,     0,
     675,   634,   676,   678,     0,     0,   677,   680,   683,  1287,
       0,   291,  1261,     0,  1322,  1135,     0,     0,  1092,     0,
       0,     0,     0,     0,     0,   476,   686,   322,     0,     0,
       0,     0,   381,     0,   302,   314,   379,   320,     0,   353,
       0,   325,     0,   318,   340,   332,   341,   333,   352,   354,
       0,   694,   695,   693,   689,     0,   696,   698,     0,   370,
       0,     0,     0,     0,  1343,     0,  1287,     0,   287,  1257,
       0,  1320,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1325,     0,     0,     0,     0,   734,
       0,   731,     0,     0,     0,   146,   145,     0,   152,     0,
       0,     0,     0,     0,     0,  1373,  1374,  1375,     0,     0,
       0,     0,     0,     0,   388,     0,   294,   296,   295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   395,   363,     0,   845,
       0,     0,     0,   397,     0,     0,  1335,     0,     0,     0,
       0,     0,  1342,  1240,  2019,  2020,  2017,  1682,  2215,     0,
       0,     0,   950,     0,     0,     0,     0,   408,   409,   140,
     407,   430,     0,   789,     0,     0,   823,   828,   836,  2462,
    2138,  2139,   834,   829,   831,   833,   835,   832,     0,     0,
       0,     0,   495,     0,     0,     0,   485,     0,     0,  1170,
     478,   481,   482,     0,     0,   652,   655,   653,   654,     0,
     674,     0,   461,   502,   554,     0,   156,     0,     0,   157,
     155,     0,     0,   372,   736,     0,   733,     0,   182,     0,
     706,     0,     0,     0,     0,     0,  1170,   644,     0,   841,
     843,   815,     0,   686,     0,     0,   603,     0,   525,  1555,
     586,     0,   556,   461,   554,   563,     0,     0,   571,   371,
       0,     0,   591,   372,     0,     0,  1061,     0,   837,     0,
       0,  1099,     0,     0,     0,  1152,  1157,  1153,     0,  1132,
    1114,     0,  1154,     0,     0,  1160,  1085,  1134,  1086,  1395,
    1396,  1393,  1394,     0,     0,     0,     0,     0,     0,  1610,
       0,     0,  1468,     0,   892,     0,   875,     0,   877,   361,
     723,     0,   361,     0,  1568,  1570,  1569,     0,     0,  1571,
    2220,     0,  1581,  1608,     0,     0,  1810,     0,  1607,     0,
       0,     0,     0,     0,  1007,     0,  1027,     0,     0,  1036,
    1033,     0,     0,  1593,  1591,   589,     0,  1222,  1223,  1036,
       0,   361,  1035,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2175,     0,  2206,  2202,     0,  2026,  2176,
       0,     0,     0,  2131,     0,     0,  1980,  1992,  1993,  1994,
    2191,     0,  1999,     0,  1989,  1990,  1991,  1983,  1984,  1985,
    1986,  1987,  1988,  1995,  2195,  2194,     0,     0,  2052,  2053,
    2054,  2197,  2061,     0,  2313,  2088,     0,  2065,  2081,  2080,
       0,     0,     0,  2068,     0,     0,  2077,     0,  2132,  2252,
    1917,     0,     0,  1943,  2201,  1961,     0,  1977,  1939,  2151,
       0,     0,     0,     0,     0,  1948,     0,     0,     0,  2108,
    2103,  2104,  2128,     0,     0,     0,     0,     0,     0,  1662,
    1661,  1667,  1728,  2016,  1728,     0,     0,  1836,  1755,  1751,
    1753,     0,  2642,     0,  1758,  1765,     0,  1747,     0,  1781,
    1777,     0,  1778,     0,     0,  1779,     0,     0,  1749,     0,
    1765,     0,  1804,  1674,     0,  2099,     0,  1686,  1080,  1081,
    1696,     0,  1699,  2343,  1808,     0,  1582,  1124,     0,     0,
    1116,  1047,  1048,  1051,  1049,  1046,  1050,     0,     0,     0,
     789,     0,     0,   535,     0,  1074,  1074,     0,     0,   519,
     576,   530,   792,     0,     0,     0,   790,   361,  1236,     0,
       0,     0,     0,   635,  1355,  1237,     0,     0,     0,     0,
    1136,  1290,     0,     0,  1260,     0,   299,   475,   474,   479,
       0,     0,   305,   315,     0,   310,     0,  1288,     0,     0,
       0,     0,   309,   312,   383,     0,   380,     0,   361,   361,
     355,   691,   369,   374,   375,   378,  1295,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     869,   852,     0,     0,   870,   871,     0,     0,     0,  1193,
    1194,  1192,  1327,  1328,  1333,  1330,  1329,  1332,  1334,  1331,
       0,  1243,     0,     0,   727,  1291,   150,   147,   148,   151,
    1292,  1273,  1254,  1317,   585,     0,     0,     0,  1252,     0,
    1310,     0,  1269,  1263,     0,     0,     0,     0,     0,  1354,
    1283,  1315,  1353,  1281,  1313,  1280,  1312,  1282,  1314,  1274,
       0,     0,  1815,   849,     0,     0,     0,   361,   361,   848,
     725,  1256,     0,  1319,  1265,     0,     0,     0,   942,     0,
       0,     0,   944,   413,   431,   140,     0,   745,   809,     0,
       0,   825,     0,   483,     0,   489,   493,     0,     0,   497,
     498,   496,   484,  1170,   525,   575,   778,   779,     0,     0,
     799,     0,   650,     0,     0,   459,     0,   499,     0,     0,
     463,   159,   158,     0,     0,     0,   740,   744,   742,   741,
     743,   738,     0,   729,   186,  2400,     0,     0,     0,     0,
     583,   577,   580,  1369,   816,     0,  1814,   719,     0,   372,
     599,     0,     0,     0,   459,   591,     0,   464,   469,   470,
     479,     0,   564,   555,     0,   556,   565,   566,     0,   573,
    1443,     0,   592,   573,     0,     0,     0,   840,     0,   839,
       0,  1102,  1119,  1120,     0,     0,  1162,     0,     0,  1164,
    1159,     0,     0,   758,   761,   754,   637,   361,     0,  1471,
     361,   361,  1219,     0,   886,     0,     0,     0,  1573,  1579,
    1560,     0,     0,  1604,  1581,  1605,  1021,  1022,  1023,  1020,
    1019,   629,     0,  1025,   990,   717,     0,   590,   361,     0,
     991,   967,   959,   966,   955,   958,   960,     0,   962,   963,
     957,   954,   956,  2205,  2042,  2045,  2056,     0,  2130,  2161,
       0,     0,  2000,     0,     0,     0,  2051,  2637,     0,     0,
    2092,  2093,     0,  2089,  2090,  2085,  2086,  2067,     0,  2451,
    2072,     0,     0,     0,  1965,  1963,  1962,  1947,     0,     0,
    1945,  1941,     0,  1970,  2094,     0,  2110,  2107,  2127,  2161,
    1666,  1665,  1664,  1663,  2099,  2249,  2099,   232,  1653,  1800,
       0,  1803,     0,     0,  1757,     0,     0,  1759,     0,     0,
    1761,  1763,     0,     0,     0,     0,     0,     0,  2238,     0,
    1727,     0,  1682,     0,  1697,     0,  1580,  1117,  1125,     0,
       0,     0,   515,     0,   530,     0,     0,     0,  1067,  1076,
    1066,     0,   530,     0,  1170,   794,   793,   796,   791,   795,
    1482,     0,   668,   669,   672,  1262,     0,  1323,  1271,     0,
    1597,   301,   471,   308,     0,     0,     0,   303,   382,   384,
     304,   307,   311,   363,   324,   317,     0,     0,     0,  1258,
       0,  1321,  1267,  1294,  1345,  1241,  1305,     0,     0,   858,
       0,     0,     0,     0,  1346,  1242,  1306,     0,     0,     0,
       0,  1597,     0,     0,     0,     0,     0,     0,     0,     0,
    1491,     0,     0,   362,   847,   846,   363,   396,  1285,     0,
    2018,     0,   943,   948,   949,   947,     0,   402,   410,   413,
       0,     0,  1210,  1210,     0,     0,   480,   494,     0,   575,
     534,     0,   486,     0,     0,     0,     0,     0,   687,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   732,
     731,   181,     0,   459,     0,   686,     0,   844,     0,     0,
       0,   591,   461,     0,     0,  1552,   460,     0,     0,   472,
       0,   567,   556,   564,     0,     0,   588,     0,  1436,     0,
     594,     0,     0,     0,   788,  1158,     0,  1172,     0,  1113,
    1083,  1167,     0,  1658,  1807,     0,     0,     0,     0,   771,
       0,   641,  1211,  1469,   876,   878,   724,  1565,     0,  1566,
    1572,     0,     0,     0,     0,  1609,  1601,  1028,     0,  1032,
    1036,   961,  2190,  2132,  1997,     0,  2193,  2192,  2196,     0,
    2062,     0,  2063,  2091,  2069,  2073,     0,  2070,  2071,  1966,
    1964,  1949,  2096,     0,  1682,  2129,  1636,  1635,     0,  1656,
    1805,     0,     0,  1799,     0,     0,  1829,     0,     0,     0,
    1766,  1784,     0,  1762,  1760,     0,  1773,     0,  1775,  2342,
    2610,  2514,     0,  1714,  1716,  1719,  1721,  1720,  1722,  1718,
    2098,  2100,     0,  1693,  2153,  1809,  1029,     0,   361,  1074,
    1170,   536,  2462,   537,  1073,  1075,  1079,     0,  1170,     0,
     575,   664,     0,     0,   280,     0,   306,   316,   365,   377,
       0,  1597,     0,     0,   856,   865,   865,   853,     0,     0,
     872,  1244,   728,     0,     0,   275,  1270,  1264,     0,     0,
       0,  1493,  1494,     0,     0,     0,     0,     0,  1293,   361,
    1266,   951,     0,   433,   440,   414,   418,  1485,     0,  1485,
       0,   415,   419,  1485,  1485,   412,  1807,   429,  1210,     0,
    1207,  1206,   523,   605,     0,   487,     0,   545,     0,     0,
     800,     0,     0,   685,     0,   461,   554,     0,   512,   503,
     504,   505,   506,   508,   507,   509,   510,   511,   501,   500,
       0,   686,   862,   372,  1443,   726,     0,     0,   699,     0,
     686,     0,  1555,   587,   556,   461,   554,   465,   479,     0,
     571,   564,   567,     0,   568,     0,   572,     0,     0,     0,
     591,  1495,  1061,     0,  1062,     0,   789,  1171,  1132,     0,
       0,  1161,  1165,  1166,     0,     0,     0,     0,  1214,   765,
     766,   760,   762,     0,   773,   777,   636,     0,     0,   640,
     631,     0,     0,     0,     0,  1606,   686,   361,     0,  1998,
       0,     0,  2075,  2074,     0,  2114,     0,     0,     0,  1647,
    1798,  1801,     0,  1832,     0,     0,     0,     0,  1818,     0,
    1764,     0,     0,  1774,     0,     0,     0,  1723,     0,     0,
       0,  1732,  1043,     0,  1044,  1068,   575,     0,  1079,  1082,
     525,   575,     0,   789,  1272,     0,   605,     0,   319,     0,
     288,  1268,     0,     0,   867,   867,     0,     0,     0,     0,
       0,     0,   390,     0,     0,  1487,     0,  1488,  1489,  1492,
     398,   411,     0,   438,     0,   436,   435,   437,     0,   426,
       0,     0,     0,     0,     0,     0,   401,  1205,  1209,  1208,
       0,   488,     0,   490,     0,   531,   532,   533,     0,   492,
     541,   542,     0,   797,     0,   802,     0,   688,     0,     0,
     686,   553,   710,     0,     0,     0,  1437,     0,     0,   578,
     720,  1443,   591,   564,     0,   556,   473,     0,   573,   567,
     571,   569,   570,     0,  1440,     0,   593,     0,  1070,     0,
     787,     0,  1162,  1173,  1168,  1163,  1399,     0,     0,   763,
     768,   767,  1485,   772,     0,     0,     0,   639,   638,     0,
    1578,  1807,  1575,     0,   714,   992,  2189,  2078,  2064,  2076,
    2109,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1830,  1831,  1816,     0,     0,  1820,  1771,  1796,     0,     0,
       0,  1717,  2101,  2102,  2268,     0,   540,     0,  1082,  1064,
     534,   789,   529,   516,  1597,   313,   364,     0,     0,     0,
     863,   866,   854,   855,   874,   873,   730,  1597,     0,   386,
     385,     0,   389,     0,   434,   443,     0,   441,   416,   421,
       0,   425,   423,   422,   417,   420,   522,     0,     0,     0,
       0,     0,   543,     0,   544,   574,     0,   801,     0,     0,
       0,   712,   861,     0,     0,   459,   686,  1438,  1553,   567,
     556,   564,     0,     0,   558,  1074,  1074,   446,   571,   573,
    1441,  1442,     0,     0,   372,  1063,     0,  1084,  1398,  1397,
    1658,     0,     0,     0,   774,   775,   770,     0,     0,  1567,
    1577,     0,  2597,  2343,  2569,     0,  2126,  2115,  2126,  2126,
    2106,     0,     0,     0,  1802,     0,  1819,  1822,     0,     0,
       0,  1828,  1821,  1823,     0,  1783,     0,  1794,  1725,     0,
    1724,   361,     0,   789,   538,  1065,   545,   518,   281,  1597,
     857,     0,   276,     0,   391,  1490,   439,     0,   424,   604,
     491,   550,     0,   549,     0,   547,   546,   798,   803,     0,
     686,   851,  1443,   700,   571,   564,   567,     0,   557,     0,
    1076,  1076,   573,   444,     0,     0,   573,     0,  1381,  1658,
    1380,  1382,  1390,  1387,  1389,  1388,  1386,  1217,  1218,   764,
     769,     0,     0,  1807,     0,  2119,  2118,  2117,  2121,  2120,
       0,  2113,  2111,  2112,     0,     0,     0,     0,  1825,  1826,
    1827,  1824,  1770,     0,  1726,  1045,     0,   520,   789,   289,
     864,     0,   442,   548,   552,   551,   686,   711,  1439,   573,
     567,   571,  1074,   559,  1075,   561,   560,   448,  1070,  1071,
       0,  1807,   777,     0,  1391,  1385,  1634,  1621,     0,     0,
     776,     0,  1574,     0,     0,  2123,     0,  2124,     0,     0,
       0,     0,     0,     0,     0,   521,     0,   713,   447,   571,
     573,  1076,   372,  1069,     0,  1052,     0,  1383,  1658,     0,
       0,   782,  2116,  2122,  2125,  1652,  1651,     0,     0,  1655,
       0,  1795,   539,   387,   573,   445,   562,   573,  1072,     0,
    1384,     0,     0,   784,     0,   780,   783,   785,   786,     0,
       0,  1817,   449,  1807,     0,     0,     0,   748,     0,  1682,
       0,  1053,     0,     0,     0,   781,     0,     0,   782,  1215,
    1216,     0,  1654,     0,   749
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5482, -5482, -5482,  3775,  -529, -5482, -5482,  -927,  -807,  3015,
   -1255, -5482, -5482, -5482,  1055, -5482, -5482, -5482, -5482,  3739,
   -5482,  1718, -2854, -5482, -5482,   120,   272, -1371,   122,  3322,
    1400, -5482, -1012, -5482, -5482,  -624,     2, -5482,   470,   637,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,  -696,  1829,
   -5482,  1913,  1208,  4455, -3214, -5482, -5482, -1495, -3644, -5482,
     516, -5482,   542, -4646, -1002, -5482, -5482, -5482,  1811, -5482,
   -5482, -5482,  1758,  1005,  -434, -5482, -5482, -5482, -5482, -5482,
   -5482,  -846, -5482, -5482, -1110,     3,  -635, -2875, -4147, -5482,
   -5482,   373,  -478, -1470, -5482,   561, -5482, -4476, -5482,   -89,
   -2900, -5482, -5482, -5482,  -447, -1438,  1302, -5482,  -728, -1180,
    1631, -2901,  -962, -5482,  -325, -5482, -1084,  -858,  -856,  -995,
   -4186, -4679, -5482, -5482, -1111, -3670, -5004, -5227, -4726, -4685,
    1310, -5482,  -118,   377, -5482,     9, -3579, -3633,    11,   352,
   -5482,    14,    16, -5482,   369,  -792,  -968, -1580, -5482,  -845,
   -5482, -5482, -5482, -3343, -5482, -5482, -5482,   142, -5482, -5482,
   -5482, -5482,   412, -5482, -5482, -5482, -5482, -5482, -5482, -2504,
    1779,  1781, -5482, -4005, -5482,  -926, -5482,   565, -3388,  1230,
   -5482, -5482,   997,  3755,   392, -5482, -5482, -5482, -5482, -5482,
   -5482, -1749, -5482, -5482, -5482, -5482,   -99,  -425, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482,    17, -5482,   956,   332, -5482,
   -5482,  -711, -5482, -5482, -5482, -5482, -5482, -5482, -1160, -4989,
   -1244, -1233, -5482, -3377, -5482, -5482, -5482,  -398, -5482, -5482,
   -5482, -5482, -5482,  -907, -5482,  1052, -4016, -5482, -5482,   374,
   -5482, -5482, -5482, -5482, -5482,  -975,  -340,  2933, -5482,  -575,
    -771, -5482, -5482, -5482,  -337, -5482, -5482, -5482, -5482, -5482,
    -513, -1280,  4739,  4128, -1106,   418,  -831,  -572, -5482, -5482,
   -5482, -2692, -5482, -5482, -4112, -5482,  4730,  2034,   397,    18,
   -5482,    -4,    82,  3572, -1145, -3040,   316,  -535, -5482, -5482,
   -5482, -3006, -5482, -5482, -5482, -5482, -3965,    20, -5482,  -725,
   -5482, -4235, -5034, -4445, -3986, -1132, -5482, -4090, -5401, -4215,
   -3945, -5482,  1803, -5482, -5482,  -561,  -157,  2904, -5482, -1445,
    2137, -1413, -5482, -2545,   390,  1387,  2915, -3205,  -129,  2897,
   -2926, -5482,  -685,   984, -5482,  -427, -3671, -5482, -5482, -5482,
   -2711,  -660, -5482, -5482,  1434, -1124, -5482, -5482, -5482, -5482,
    -642,  2880,  -183, -5482, -5482,  4102, -5482, -4798, -5482,  4077,
   -5482, -5482, -5482, -5482,  2807,  2808, -5482, -5482, -1437,  1159,
   -5482,  -820, -5482, -5482,  1905,   594, -5482, -5482, -5482, -5482,
   -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482, -5482,  -956,
   -1142, -5482, -5482, -4672, -5482, -5482, -5482, -5482, -5482,  2264,
    -948,  -733,  3966,   969,    22, -5185, -5482, -5482, -1182, -5482,
    3336, -5482, -5482, -5482, -5482, -5482,   394,   387, -5482, -5482,
   -5482, -5482, -5030, -5482, -5482, -4809, -5482, -5482,  1888, -5482,
   -5482,  -347,    10,  3028, -5482, -5482, -5482,   -22, -5482, -5482,
   -1006,  2224, -5482, -2339, -5482,  -596, -5482, -5482, -1874,    23,
   -4191, -5482,  -629, -5482,  2870, -5482,  -412, -5482,   -98, -5482,
   -5482, -4219,    21, -5482, -5482, -5482, -5482, -4856, -5482,  -628,
   -5482,  -953,   378, -3686, -5482,    24,    30, -5482, -5482,    19,
     267,   -45,   -56,   -52,     4,   108,  3433, -5482, -5482, -5482,
      27,  3470, -5482,    -3,  -852,  4770,  4773, -5482,  -870,  -152,
   -5482,  1479,  -723, -2536,  3378,  3377, -5482,  1469,  2232, -2431,
   -2415, -5482, -1221,  -838,  -676, -5482, -5482, -5482, -5482, -1482,
    -712, -2550, -5482,  3381, -5482, -5482, -5482, -2371, -3267, -3189,
    1505, -3203, -3137, -5482,   800,   781,  -922,  -185,    49,  -764,
    -863, -5482, -5482,  1513,  -430, -5482, -5482,  -428, -3196,   398,
   -5482, -4415, -2756,  1519, -1086,  -815, -5482,  -943, -5482,  -645,
     276,  3446,  -816, -5482, -5482,  -784, 12682, -5482, -5482, -5482,
   13608, 14479, -5482, -5482, 14625, 14725, -5482,  -615, 15139, 10070,
    -762, -1917,    12, 17391, -1682,  2674,    64, -5482, -2895,  1433,
   -5482, -5482, -5482,  -396,   883,   431, -5482, -4437, -4294, -5482,
   -5482, -1864, -5482,  -658, -5482,  -654, -5482, -5482, -5482, -3095,
   -4326, -3124,  2359, -5482, -5482, -5482,  -181, -5482, 17601, -3179,
   -5482,  -193, -1008, -1562,  2827, -2955, -1888, -5482, -5482, -5482,
   -3058, -5482, -5482, -5482,  -757,  1606, -5482, -5482,  1710, -5482,
   -5482, -5482,  -974,  1944,  -751, -1177,  1611,  3967,  -770,  2367,
    -786, 16501,  -675, 10683, -1281, -5482,  1422, -5481,  6945,  7289,
      41,  -134,   -67,  -655,  2282,  2680, -5482, -5482,  4855,  7649,
    -562,  -705, -5482,    -6, 12390, 11306, -3581, -5482
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    58,    59,    60,    61,    62,    63,  1587,  2951,  2806,
    3720,  3721,    64,    65,  1583,    66,    67,    68,    69,  1497,
      70,  1077,  1834,  2966,    71,  2650,   825,   826,   827,  2518,
    2519,  2896,  2520,  2508,  1350,  1780,  1519,   799,   800,  1479,
    1520,    73,    74,  1344,  2499,    75,    76,    77,  1550,  1642,
    1551,  1552,  1491,  1880,  4762,  5518,  3514,  2768,  3769,  3515,
    3516,  4145,  4146,  4226,  5532,  5533,    78,  1658,  1659,    79,
      80,  2933,  3686,  4279,  5127,  5128,  5365,   636,  4785,  4786,
    5352,  5353,  5546,  5696,  5697,  2967,   667,  3764,  4362,  3711,
    4856,  3712,  4857,  3713,  4858,  4135,  4136,  3697,  4310,  4311,
    4798,  4312,  3714,  4817,  5398,  3715,  2669,  5561,  3001,  1954,
    1952,  5044,  5377,  4622,  4623,  5793,  5569,  5570,  5571,  5815,
    4819,  4862,  4863,  5733,  5734,  3767,  4368,  4869,  5186,  5142,
    3412,    82,  3740,  3741,    83,   730,  1856,  3874,   731,  3004,
     668,   732,  2968,    88,  2994,  5563,  2995,  1613,  2820,  4292,
    3854,    89,  1104,  4110,  5211,  5459,  5460,   721,    90,  1842,
      91,    92,  2946,  3704,    93,  2686,  3429,    94,    95,  3448,
    3449,  3450,    96,  4320,  5147,  1553,  3503,  3504,  3505,  3506,
    4166,    97,  1837,  2975,  2976,    98,    99,   100,  3104,  3105,
     101,  2882,   102,   103,   104,   105,  4201,  4724,  4833,  3544,
    3727,  4336,  4831,   106,  3690,  2969,  3022,  3802,  3803,  5209,
    5451,  5452,  5453,  5622,  5849,  5455,  5624,  5756,  5626,  4808,
    5964,  5965,  5436,  4099,  4636,   108,  4809,  4810,  5576,   109,
    2684,   110,   111,  1811,  2939,  2940,  4293,  3011,  3777,  3778,
    4348,  4349,   112,  3628,   113,  4700,  4701,   669,  5584,  5524,
    5682,   114,   115,  4704,  4705,   116,   117,   118,   119,   120,
     722,  1040,  1041,   724,  1159,  1160,  3385,  1121,   121,  2528,
     122,  3666,   123,  1236,  4932,   124,   756,  1177,  1178,  2970,
     126,   765,  3123,   767,  1969,  3856,  3857,  4449,   127,   128,
    3101,  3126,   129,  1484,  2660,  2661,  4617,  2971,   670,  1221,
    3008,  3407,  5433,  5038,  5434,  5744,  5900,  5039,  5306,  3340,
    4064,   131,   671,  1525,  2725,  1127,  1128,  3015,  3782,  2631,
    2632,  1681,  4389,  2634,  3784,  2635,  1458,  2636,  1114,  1115,
    3790,  3791,  3792,  3793,  4385,  4395,  4396,  5203,  5444,  4392,
    2960,  5197,  5198,   132,  1522,  2722,   133,   134,   135,  1566,
     965,  1137,  1138,   136,   683,   684,   137,  5370,   138,  1117,
     139,  5207,   140,   141,   790,   791,   142,   143,  2739,  4148,
     144,  1523,   145,   146,  3538,  3539,  4716,   147,   148,   149,
    1829,  1830,   150,   151,   152,   153,   154,  5840,  5903,  5904,
    5905,  4403,  5750,   155,  1208,   156,   157,   158,   159,   196,
    1006,  1007,  1008,   918,  2972,  5188,   161,   162,  1480,  1481,
    1482,  1483,  2655,   163,   164,   165,  3812,  3813,   166,   167,
     168,   169,  1814,   170,   171,  5343,   172,   173,  1784,   174,
     175,  1014,  1015,  1016,  1017,  1782,  3288,   630,   843,  1375,
    1381,  1424,  1425,  1426,   177,   734,   178,  1216,  1045,   735,
    1168,   180,   736,   181,  2615,  3837,  4427,  4428,  4429,  4432,
    5223,  4606,   737,  3366,   183,  1976,  3110,  3113,  3362,   738,
     184,  3840,  3841,  3842,  4434,   739,   758,  1107,  3026,   740,
    1311,   188,   189,   190,   899,   846,   847,  3293,  5259,  5479,
     741,  2492,  3271,   774,  1430,   887,   888,   889,   908,  2906,
    2581,  2582,  2606,  2607,  1439,  1440,  2594,  2598,  2599,  3353,
    3346,  2587,  4058,  5283,  5284,  5285,  5286,  5287,  5288,  4595,
    2602,  2603,  1442,  1443,  1444,  2611,   193,  2571,  3321,  3322,
    3323,  4035,  4036,  5785,  4050,  4046,  4580,  5010,  3324,  1206,
    1450,  4588,  5787,  3325,  4999,  5000,  5263,  4054,  3332,  4075,
    3752,  3753,  3754,  3326,  5487,  5488,  5782,  5783,  5265,  5266,
    2637,  1404,   873,  1312,   874,  1417,  1313,  1391,   876,  1314,
    1315,  1316,   879,  1317,  1318,  1319,   882,  1383,  1320,  1321,
    1400,  1413,  1414,  1376,  5267,  1323,  1324,  1325,  3328,  1326,
    4526,  4972,  4958,  3198,  3199,  2515,  4522,  3958,  4516,  2487,
    3261,  5022,  5290,  5291,  3998,  4550,  4986,  5254,  5644,  5766,
    5767,  5861,  1327,  1328,  1329,  3258,  2481,   968,  1330,  4295,
    2483,  3192,  3170,  1684,  3171,  1979,  2000,  3142,  3158,  3159,
    3235,  3172,  3180,  3185,  3193,  3222,  1331,  3144,  3145,  3899,
    2002,  1332,  1012,  1687,  1013,  1419,  3217,  1340,  1341,  1334,
    1970,   836,  5006,  1163,  1767,   771,  1335,  1336,  1337,  1338,
    1559,   939,  1130,  1131,   890,   892,   893,  2575,   626,   618,
     941,  3507,  2484,   627,   620,   621,  1772,  2485
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     619,  1683,    72,    81,   191,  1779,  1046,  1048,  1071,    84,
     176,    85,   898,  1612,    86,  1951,    87,   107,   125,   186,
     130,   182,   160,   179,   185,   191,  1895,   192,   966,  1345,
     967,   733,  2833,   804,  1197,  1198,  1199,   909,   624,  1773,
    1203,  1445,  1333,   838,  2633,   675,   886,  2668,  1162,   931,
    1143,  1396,  2763,  1431,  1416,  1433,  1617,   972,  1108,  1675,
     977,  2734,  3363,   760,  1156,  1997,  1222,  1018,   919,   760,
     615,  1663,  1387,  1388,  1372,  3710,  1839,  3364,  4009,  2726,
    4011,  1395,   975,  3742,  3879,  1990,  1371,  3378,  3380,  1359,
    3794,  1463,  1169,  2735,   835,  3860,   997,  4137,  4073,  2746,
    2989,  4347,  4373,  1558,  4116,   766,  3116,  4624,  1402,  3733,
    3141,  2633,  4161,  3625,  4163,  4297,  2900,  4597,  1039,   805,
    1110,  3274,  4049,  4398,  4619,  3276,  3207,  1554,  4360,  1812,
    4032,  4659,  1170,  1817,  2567,   911,  5003,  3593,  1821,   912,
     940,  4876,  1141,  2717,   232,  1145,  1153,  5190,  1831,   976,
    2862,  2863,  1576,  4433,   903,  4684,  5381,  1593,   798,   849,
    4062,  1851,   824,   998,  1824,   832,  3355,  1018,  4855,  4077,
    5151,  3056,  1781,  3982,  5015,  4816,  5017,  5420,  4865,  1848,
    4357,  5040,  1526,  5062,  3358,  1438,  5183,  4047,  5463,  4052,
    3286,   619,  1884,  5598,  1352, -2385,  1441, -2423,  3923,   742,
     619,   942,  2858,  2717,  5314, -2446, -2483,   634,   619,   742,
     942,   619,  2046,  4910,  1847,  1877,  4864,  2697,  5182,  5586,
    2717,  4963, -1889,  3669,   942,  3672,  3673,  1018, -1856,  2889,
    3677,  3678,  3679,  1493,  3681,  3682,  3683,  3334,  1877,  1384,
    1385,  2526,  1877,  2532, -2242,  5335,  1521, -2777,  2747,  1394,
    3215, -2309,  3215,   676, -2388, -1869,  1110,  1577,   784, -2277,
    2986, -1894,   742,   917, -1884,   742,  3700,   187, -2277, -2277,
    1371,   681,   681,  2737,   990, -2241,  2534,  3650,   841,  1179,
    1018, -2278,  1183,   681,   681,  1611,   681,  1521,   187,  3215,
   -2278, -2278,  1521, -2653,  1641,  2652,  4383, -1897,  2957,  5345,
    5346,  3897, -2653, -2653,  1668,  2674,  1768, -1897,  1877,  4313,
    5523,  -432,  1935,  4112,  2737,   681,  2490,  2572,   681,  2869,
    4826,  1877,  1804,  2505,   897,  1555,   681,  5548,   872,  5550,
    1555,   742,   647,  5554,  5555,  5371,   742,  3087,  3177,  2998,
    1018,  3864,  5221,  2931, -2777,  -140,   785,  1494,  4847,  2949,
    4814,  -140,  4934,  4935,  4936,  1877,  4938,  4939,  4940,  4941,
    4942,  4877,   906,  3688,  2999,  5313, -1710,   748,  5748,   748,
    1861,  1578,  1672,  5739,  1194,  2670,  3701,   748,   748,  2046,
    5884,   681,  1172,  2737,  5179,  3262,  2737,  3866,  1877,  3923,
    5144,   749,   649,   749,  2874, -2777,   810,  1773,  1349,  1506,
    5495,   749,   749,  2671,  2585,  1362,  5727,  2786, -2777,  3337,
    2532,  1675,  3410,  3151, -2777,  4827,   681, -2136,  5600, -2777,
    5476,  2578,  5037,   748, -2136, -2777,   748,  2712, -2777,  5895,
    5896,   194, -2777,  2742,  1877,  2743,   777,  1826,  2506,  5948,
    5152,  2987,  1219,  2534,  1595,  2574,  1397,   749,  1877,  2737,
     749,  2794, -2444,  2772,  5375,  1110,  2773,   631,   910,   742,
    2738, -2777,   742, -2777,  3255,  5520,   778,  1398,  2811,   967,
     779,  3256,  3411,  3623,  1097,   195,  1387,  1388,  2046,  1363,
   -2155, -2777,  2737,  1596,  1903,  1809,  -457, -2155,  5153,  5980,
    5477,  1227,  2527,  1982,  1893,  1373,  2744,  1395,  1878,  3338,
    2586,   811,  4828,  5421,  2737,  2737,   786,  2737,  5145,  2532,
    3923,  5832,  2509,  5048,  1065,  2856,  4220,  2521,  2521,   967,
    1075,  1878,  2713,  3152,  2011,  1878,  1231,  3263, -2777,  1402,
    5956, -2777,  1088,  1579,   677,   862,  5885, -2777, -1710,  4285,
    3125,  3125,  2534,  2950,  4815,  2787,  1971,   787,   788,  1673,
    5749,  3877,  1773,  1195,  2672,  1423,  5222,  2507,  3000,  2748,
    2040,   660,  1981,   661,  3702,  3689,  3865,  4344,  2570,  5709,
    5557,  4113,  1580,  2749,  2904,  2750,  1991,  1933,  5409,  3919,
    3106,  1066,  1495,  2836,  2614,  2932,  3665,  1066,  2495,  1825,
    4297,  1878,  5753,   678, -2777,  5738,  3088,  5889,  3153,  1066,
    5373,  5277,  2491,   842,  1878,  -457,  1581,  3216,  2888,  3987,
    4314,  1994,  3867,  2988,  3143,  4719,   921,   923,  3423,  1241,
     926,  3651,  3923,   942,  4784,  5513,  3924,  3925,  3926,  2675,
    2942,   679,  2569,   680,  1384,  1385,  2751,  5888,  1878,   191,
     984,  1565,   942,  1233,   789,  1496,  3216,   994,   942,  3452,
    1975,  1377,   635,  3703,  1049,  1879,  1047,  2704,  4829,  3154,
     942,  1394,  3155,  1382,  5930,  1485,  4384,  2711,  2898,  2899,
    5243,  1878,  2958,  1110,  2801,  1810,   942, -2777,  1886,  3938,
    2828,   619,  1890,  2831,   898,  3303,   886,   754,   755,  4825,
     619,   942,  2838,  2480, -2444,  5226, -2385,   619, -2423,   942,
     619, -2777,  5954, -2777, -2777,  2545, -2446, -2483,  5834,  3107,
    1768,  1173,   886,   942, -1889,  3137,  2870,  1878,  3527,  4629,
    1386,  4258,  2612,   942,  2851,  5824,  2897,  5693,  4830,  4873,
    2503,  1878,   191,  2613,  1010,  5593, -2242,  1974,  1011,  4872,
     754,   755,  2780,   754,   755,  1096, -2777,  1390, -2777, -2777,
    1397, -2277, -2309, -1894,  2818, -2388, -1884,  2821,  2822,  1446,
    1397,  1901,  2875,  2042,  2493,  4277,  4278, -2241, -2444,  5852,
    3076,  1398, -2136, -2278,  3156,  3279,  5969,  2550,  2551,  1486,
   -2444,  1398,  2817,   942,  1176, -2653,  1181,  1192,  1185,  1399,
    2573,  2876,  1110,  3240,  1189,  1923,  4297,  1585,  1010,  1401,
    1110,  1110,  1011,  1102,  2702,  3927,   619,   619,  1097,  1556,
    1557,  1810,   942,  2905,  1556,  1557,  3058,  4646,  5798,  3257,
    1586,  5666,  5891,  1205,  4049,  5231,  5671,  3928,  1926,  -140,
    -140,  5802,  4079,  5049,  4080, -2155,   942,  2721,   619,  2857,
    4221,  1010,  4689,   911,  4357,  1011,  1361,   912,  1795,  4577,
     967,  3086,  1002,  4581,  5505,  4480,  1202,  2477,  2478,  2479,
    2480,   886,  3098,  1893,  4448,  1810,  2779,  3935,  3936,  3937,
    3938,  1791,  5737,  4461,  1893,  1796,  4609,  1797,  4338,  4215,
    4216,  1202,  5710,   619,  4217,  3157,  5929,  1205,  4448,  4568,
    2721,  4570,  1098,  1786,   913,  3929,   942,  4345,  4435,   798,
    1211,  1213,   187,    72,    81,   191,  4788,  2721,  4345,  5374,
      84,   176,    85,  3355,  3108,    86,  5731,    87,   107,   125,
     186,   130,   182,   160,   179,   185,  1478,  2788,   192,  3424,
    4067,   681,  5719,  3241,  3109,  5472,  1348,  3510,  3242,  4787,
    1356,  1487,  5596,  5879,  4393,  4117,   906,  2919,  5730,  4016,
    5565,  5457,  1003,  1378,  2475,  2476,  2477,  2478,  2479,  2480,
    1652,  3798,   929,  1061,  1449,  1124,  1653,   913,  1122,   681,
    5974,   681,  4697, -2238,  1930,  3243,  2877,  3760,  1452,  1500,
    1488,   914,  4272,  4960,  2696,  3556,  3933,  3934,  3935,  3936,
    3937,  3938,  3511,  1406,  1122,   187,   897,  2045,  4139,  2850,
    2046,  1004,  2954,   619,   619,  1769,  5914,   727,  3360,  2662,
    3406,   942,  5104,  5833,  1489,  5632,   619,  4717,  2754,  1472,
    4224,   886,   619,  2574,  2961,  5414,   619,    15,   619,  5205,
    1467,  2532,   886,  1467,  2891,  2676,  5105,  3443, -2778,  1099,
    4065,  3519, -1856,  1975,  2991,  4171,   742,   886,  3799,  4624,
    1210,  5825,  2755,  4702,  1174,    36,  1052,  4172,  1055,  1005,
    5319,  1057,    20,  4327,  2534,  4896,  1773,  5648,  1407,  4225,
   -1061,  3557,  4399,  2892,  1654,  1082,  1100,  4841,  5842,  1647,
    5566,  1086,  1490,  1843,  4698,  2803,  5915,  2664,  1362,  3512,
     619,  5509,   619,   619,  4961,  3930,  3931,  3932,  3933,  3934,
    3935,  3936,  3937,  3938,  2662,  2941,  5897,  2665,   798,  1211,
    5901, -1711,  4140,  1406,  2878,  3361,  1468,  2039,  3444,  1468,
    3244,  2955,  1648,  2663, -1856,  3558,  1844,  4068,  5458,  1408,
    3002,  1241,  1409,   942,  3923,  1101,  1870,  1102,  3924,  3925,
    3926,  1103,  1180,  1182,  1184,  5856,  5473,  1186,  1187,  1188,
    1871,  4294,  4745,  1912,  5558,  4531,  5567,  1193,  3653,  4400,
    5408,   619,  1363,  5928,  3834,  4703,   910,  5842,   187,  1469,
    5916,  4455,  1469,  1810,  1227,  5778,  1453,   191, -2778,  3095,
    3096,  5633,  2664, -2778,  3559,  1010,  2677,   682,  1407,  1011,
    4699,    41,  5181,  2548,  4186,   942,  1913,  5607,  4625,  4205,
    5579,  4117,  2665,  5811,  5955,  5169,  1872,   915,  1937,   886,
    1939,   942,  1941,  1018,  1943,  5200,  1945,  1946,  1947,  3377,
   -2778,  5592,  5175,  1949,  1449,   942,  5225,    45,  5972,   942,
    5595,  5973,   769,  4328,  1674,  3382,  1655,  3037,  5578,  4931,
    4394,   619,  4390,  5032,  1410,    33,  1869,  1209,  3520,  1408,
    3060,  3049,  1409,   930,  1062,  2666,  1125,  3513,  2619,  1633,
    3800,  3471,  1543,  3453,  3055,   898,  5842,  1470,  5594,    49,
    1470,  5206,   619,  2539,  3801,  1656,    41,  2678,  3609,  3443,
    1175,  3085,    50, -1711,  3610,  3090,  2040,  3315,  3560,  3094,
    5779,  5857,  3097,  5668,  1649,  3447, -1856,  5106,  1845,  4069,
     619,   619,   619,  1790,   619,    51,  1873,  5559,  4187,  1657,
    3331,  4600,    45,  3033,  1799,  4401,  5917,  4141,  4142,     3,
       4,  1392,  1393,    57,   619,  4456,  4746,  1471,  3035,  1807,
    2651,  2680,  5503,  5334,  1472,   784,  3067,  1598,  5867,  3928,
    3528,  2681,  3660,  3048,  3835,  3054,  3050,  4143,   942,  2717,
    2666,  1046,  1048,  2530,    49,  1411,   942,   942,  4435,  1599,
    3444,  3213,  1874,  4014,  1410, -2778,  1473,    50,  1914,  2667,
      36,  5004,  1563,  1564,  2579,  2580,  3168,  2584,   912,   912,
     619,   912,  4801,  -681,   727,  4402,   904,  5427,   967,  5007,
      51,  3443,  3611,  1567,  5011,  5428,  5582,  5013,  3089,  1650,
    1474,  3092,  3093,  1846,    15,  5590,  5812,  3929,    57,  1769,
    1600,  3561,    41,  3306,  1428,  2833,  4806,  2588,  2823,  3562,
    5519,  2800,  3563,   785,  5170,  5148,   619,  3309,   616,  4852,
     619,   619,  1475,  2998,  1476,  1475,  5854,  1476,  2656,    20,
     187,  5780,  1788,  4924,  3383,   619,  5781,  3384,    45,  2657,
    3742,   886,   905,  4928,  4853,   773,  1632,  1800,  2999,  1875,
    2589,  5634,  1893,  4886,  2667, -2778,  1568,  2658,  1002,  4436,
    4188,  3102,  3444,  1915,  3307,  1411,  2475,  2476,  2477,  2478,
    2479,  2480,  3136,  4601,  1477,  3275,  5813,  1822,  1823,  1493,
      49,  1978,  3920,  3921, -1856,  4297,  1449,  3940,  1412,  1601,
    2682,  2764, -1856,    50,  1386, -1856,  1415,  3445, -1856,  4189,
    1999,  3456,  1860,  5422,  5814,  4852,  5641,  1810,   886,  1429,
    2764,  1773,  1582,  2764,  2764,  4491,    51,  4492,   906,  2588,
    2008,   647,  4632,  5423,  3970,  3971,  4802,  3447,  5413,  2683,
    4853,  2764,  1410,  4190,  3836,  1598,  3446,  1602,  5424,  1893,
    1603,  3564,  1897,  1899,  3612,  2824,  3615,  3103,  2825,   886,
     681,  5429,  2025,  4807,  5669,  2832,  5773,  1599,  1003,  3783,
    3398,  2591,  2589,  1936,  4298,  5721,  1938,  2037,  1940,  4778,
    1942,   782,  1944,   786,  4782,  1478,  1948,  5942,  1002,  1410,
    1478,   649,   886,  3613,  2883,  3616,  4846,  2633,  4805,  1605,
    -596,  2633,  1044,  1494,  2513,  4039,  3457,  3930,  3931,  3932,
    3933,  3934,  3935,  3936,  3937,  3938,  4633,  1004,  1600,   920,
    2659,  4301,    33,  5745,   787,   788,  4294,  3614,   932,  3617,
    3564,  2592,  1598,  -163,  2590,  4843,   932,  2830,    41,   932,
    2859,  2890,   783,  3396,  1607,  5830,  5831,  2514,  4854,  3447,
    1220,  4715,  5163,    41,  1599,   942,  3399,  5918,  3454,  5642,
    5131,  4493,  1478,  2765,  5919, -2261,  1478,  1608,   907,  -163,
     619,   619,   619,  3019,    45,  1005,  5001,  4634,  3542,  4303,
    4040,  4635,  2765,  2591,  2853,  2765,  2765,  1610,  1003,    45,
    5643,   833,  2766,  5132,  1166,  3078,  3020,   910,   910,  -163,
     910,  1241,  3488,  2765,  3923,  1600,  2964,  1601,  3924,  3925,
    3926,  2766,    41,  4041,  2766,  2766,    49,  2767,  3046,   967,
     967,  5823,   632,  5795,  5425,  4532,  4611,  4227,  4042,    50,
    1358,    49,  2766,  3036,  5725,   728,  2767,  1004,  4043,  2767,
    2767,  1201,  3117,  2592,    50,  3080,  5344,   806,    45,  2046,
    3029,  5599,    51,  3543,  1810,  1602,  2762,  2767,  1603,  5585,
     660,  5064,   661,  3489,  4044,   748,  2963,    51,  5069,   942,
      57,  4668,  5135,  2832,  2980,  2762,  1234,  4306,  2762,  2762,
    4129,   886,  2883,  1585,  3868,   729,  3078,  2965,   665,   749,
      49,  5008,   886,  3078,  1601,  1005,  2762,  5606,  1434,  5809,
    4218,  2497,  5931,  3138,  1769,  3140,  1586,  1605,   886,  5551,
    3638,  3147,  1396,  2534,  5552,  5887,  1653,  3161,  3162,  3163,
    4307,   809,   194,  5273,  3359,  4687,  3038,   942,  3182,  1202,
    1893,  1241,  4294,  3194,  3923,   942,  4308,   967,  3924,  3925,
    3926,  2784,  1602,   942,    57,  1603,  1089,   194,  3575,  5899,
    5620,  2671,  1607,  2883,  4130,  4978,  3410,  4045,  3021,  5318,
    2832,   886,  5341,  1768,  3869,  5553,   195,  5456,   844,  1459,
     619,  1436,  2498,   619,  4219,  1608,   886,  2902,  2903,   886,
     886,  5927,  1090,   619,   619,  5342,   942,   942,  4662,  5230,
    4425,   195,  3081,  4799,  1605,  1610,  5621,   628,   619,  4688,
     942,   619,  5349,   900,  1460,   628,  4612,  1926,  1461,  3928,
     886,   886,  4613,   942,   942,   901,  4095,  1091,  1437,  4614,
     950,  1434,  4663,  5729,  1654,  3082,  4426,   951,   952,   953,
    1454,   916,  2764,  3816,  4309,  2718,   191,  1543,  3083,  1607,
    5150,  5747,  1462,  1241,  3742,  5009,  3923,   629,  5958,  1614,
    3924,  3925,  3926,   619,  4615,   902,   619,   619,  3618,  5728,
    2757,  2633,  1608,  4039,  4800,  1092,  3070,  4979,  3071,  1455,
    3072,  2633,  3073,  3084,  3074,  3576,  4616,  3929,  3075,  5174,
    5161,  1434,  1610,  3579,   191,  3122,  3582,  1435,  1615,  5296,
     619,  5298,   619,  5045,  1436,  2833,  5577,   619,   619,  1049,
    4632,  1047,  4664,  1456,   619,   619,   619,  4473,  5445,   619,
    4598,   619,  3619,   619,   619,   619,   619,   619,   619,  4128,
     619,  3621,   619,   619,  3111,   917,   619,  3966,  3654,  3655,
    3656,  1588,  3549,  3550,  3469,  5679,  3553,  2839,  4040,  3928,
     886,   619,   619,   619,  1464,  3490,  3620,  5746,  3624,  3529,
    1660,  2633,  3730,  1664,  1436,  3622,   757,  3517,   619,  5611,
    1769,  5826,   757,  2914,  5046,  2864,  2865,  2866,  2867,   925,
    3121,  4041,  4599,  3466,  2925,  3746,  3747,  3748,  3749,  4421,
    3751,  4040,  3540,  1465,  4633,  5122,  4042,  5123,  5124,  5125,
    2943,  3660,  5139,  1110,  2765,  1089,  4043,  4267,  1616,  1623,
    5836,  1437,  3100,  2842,  3810,  3779,  3491,  3929,  5680,   920,
    4796,  5341,  2764, -1681,  4041,  5628,   986,  1466,   932, -1681,
    3574,  5754,  4044,  2766,  1643,   932,   927,  2737,   932,  4583,
    5449,  1090,  2843,  5300,  5342,  1620,  5673,  4797,  2745,  4043,
    4625,  5308,  5589,  3018,  4566,  4634,   987,  1893,  2767,  4635,
    3223,  3928,  3224,  5755,  5450,  5890,  1926,  3599,  3030,  4183,
    4222,  1122,  3034,  1644,  1624,  2959,  4339,  1645,   948,  3590,
    5556,  3591,  2046,  3540,  1621,  3595,  3225,  3930,  3931,  3932,
    3933,  3934,  3935,  3936,  3937,  3938, -1681,  2762,  1063,  4447,
    1064,  3644,  3053,  1122,  3729,  1585,  4060,  1646,  4184,   187,
     992,   619,  2764,  2532, -1634,  4259,  1625,  1849,  1622,   949,
    1926,  2920,  2921,  1626,  1092,  4045,  1627, -1634,  1586,  3929,
    2804,     3,     4, -1634,  5467,  2807,  2764,  2938,  1009,  4213,
    1850,  4098,  4185, -1681,  4448,  4406,  2534,  4142,  1001,  3698,
    4407,   619,  4487,  4488,  4489,  4490,  3853,   187,  4494,  4495,
    4496,  4497,  4498,  4499,  4500,  4501,  4502,  4503,  4045,  1585,
    3893,  2982,  2983,  2984,  2985,  2543,  4675,  5388,  1774,   233,
   -1634,  1775,  2764,  4369,  2765,   633,  2893,  3772,  3226,  3227,
    3228,  3229,  1586,   725,  1932,  3230,  3231,  1775,  5957,  2894,
   -1634,  3232,   619,  1983,  5797,  1397,  1775,  2880,  4625,  1397,
    -140,  2886,   807,  2766, -1634,  4541,  4542,  3930,  3931,  3932,
    3933,  3934,  3935,  3936,  3937,  3938,  1398, -1634,  2895,  4223,
    1398,  5389,  3208, -1634,  5390,  1920,  1051,  4625,  2767,  3734,
    5391,  5920,  2529,  5310,  1399,  1775,  1354, -1634,  1401,  3291,
    4747,  3059,  2045,  4260,  1058,  2046, -1634,  3063,  1921, -2778,
   -2778, -2778,  3356,  3357,  3294,  5921,  4764,  5341,  5392,  2501,
   -1705, -1705,  3292,  4748,  2765, -1633,  5001,  2762,  5522,  1067,
   -1634,  1068,  3894,  5526,  5527,  1628,  2532,  3895, -1633,  4765,
    5342,  4880,  2542,  2533, -1633,  2543,  4407,  2764,  2765,  4648,
   -1634, -1709, -1709,  2766,  3875,  3876,   956,   957,   958,   959,
     960,   961,   962,   963,   964,  4010,  1575,  1053,  1010,  2534,
    1629,  1592,  1011,  3852,  1630,  5393,  5877,  2766,  2767,  3930,
    3931,  3932,  3933,  3934,  3935,  3936,  3937,  3938,  5394,  5351,
    3949, -1633,  3951,  3952,  2765,  5760,  2521, -1634,  3233,  1010,
    5395, -2242,  2767,  1011,   920,  1386, -1634,  1415,  1631,  3234,
     932, -1633,  1531,  1072,   932,  4083,   932,  2762,  1532,  1085,
    1386,  3200,  2568,  2766,  3203,  -595,   619,   619,   619,   619,
     619,   619,   619,   619,   619,  2045,   619,  4608,  2046,  3221,
    2576,  2762,  1386,  1775,  2568,   619, -1634,   619,  2767,  1093,
    3956,  3226,  3227,  3228,  3229,  1095,  3963,  3064, -1633,  3077,
    2543,  5925,  3078,  1534,  4691, -1708, -1708, -1633,  3436,  2532,
     967,  3079,  5612,  1112,  3078,  1998, -2778,    57,  1862,  1116,
    1864,  1865,  3218,  2535,  4118,   619,  1094,  2762,  2536,   619,
    1132,  4294,   619,  3433,   619,  3437,  3438,   619,  4021,  4022,
    3287,   619,  2534,  3114,  4078,  4012,  3115,  5768,  5769,  2765,
    4147,  2823,  1010,  1123,  3370,  1420,  1011,  3290,  3430,  1535,
    1926,  5355,  1769,  4674,   619,  2538,  1536,  3295,  3369,  1537,
    2543,  2543,  3386,  3308,  3310,  3311,  3389,  4355,  2766,  4055,
    3392,   619,  3463,  1133,  3534,  3464, -1634,  3535,  1139,  5506,
     619,   619,  1386,  3465,  2568,  3985,  1538,  5511,  3024,  3694,
    3025,  2569,  3695,  2767,  1150,  4848,  3416,  5356,  1167,  2754,
    3844,  3972,   628,  3078,  3556,   942,  1157,  3892,  2539,  4795,
    2543,  3901,   886,   742,  2543,  5791,   886,   886,  5396,  1196,
    1539,  5397,  5357,   942,  3327,  3907,  3716,   942,  2543,  1200,
    3458,   942,  2762,  2755,  5862,  5863,  4665, -1633,  4672,   942,
    5358,  5437,  1207,  3400,  5359,  3403, -2778,  5912,  1217,  3908,
    1066, -2778,  2543,  4656,  1204,    29,  4438,   942,  2633,  3909,
     619,  3555,  2543,  1218,  3942,  3955,  5360,  2543,  2543,  5361,
    1215,   619,  4647,   886,   619,  1220,   619,   619,  2824,   886,
    1224,  2825,  3508,  1638,  5362,  1226,  3397,  1541, -2778,  1225,
    3557,   942,  5735,  3960,  1230,  5935,  3961,  1542,  4019,  4164,
    2541,  2543,  4165,  4001,  4625,  4002,  1543,  4169,  3536,  1110,
    4170,   942,   942,  4003,  3545,  4004,  4087,  4366,  1544,  4367,
     886,  3551,  4342,  4460,  4194,   895,   896,  4195,  1066,  4690,
    1227,  3565, -1088,  4084,  4085,  1228,  1229,  3570,  3451,   904,
    3641,  2539,  1769,   942,  3558,  4121,  1769,  5501,  4256,  1235,
      41,  4195, -1682,  4789,  1357,  4790,  4378,  3583, -1682,  4379,
    1546,  1547,  4315,  3586,  4951,  4381,  4952,  5981,  4382,   942,
    3592,  1769,  5363,  1360,  4412,   942,  4286,  4413,  4562,  1237,
    4564,  4512,   942,  3607,  4513,  4523,    45,  4534,  4524,   942,
    2543,  1548,   942,  3221,  4105,  1364,  3632,  3717,   942,  4607,
    2471,  4631,  3384,  3559,  3078,   905,  1365,  1066, -2778, -2778,
   -2778,  2475,  2476,  2477,  2478,  2479,  2480,  1366,   942,   647,
    4178,  1370,  1374,  5364,   942, -1682,  1379,  3320,    49,  2045,
    1380,   942,  2046, -2778,  1382,  1205,  1205,  4625,  1386,  1205,
    5174,    50, -1055,  4849,   942,  4906,  3078,  4911,  4907,  4925,
    4912,  4948,  1975,  1390,  2543,  4988,  1110,   942,  2543,  1549,
    1389,  4866,  1769,  2532,    51,  1403,  5028,  4228,   942,  3384,
   -2778,  1405, -1682,  5034,  3589,  1420,  5035,  5041,  4199,   649,
    3078,   906,    57, -1392,  1421, -1392,   619,   619,   619,  1432,
    5042,  5176,   619,  3078,  5177,  5213,  2534,  4208,  4413,  5240,
    5242,  1447,  5241,  2543,  4627,  4628,  5260,  3560,  5270,  5261,
    1448,  1926,  5276,  4859,  5278,  4352,  5218,  4352,  5383,   619,
     886,  5384,  5403,  5438,  5735,  3078,  5439,  3783,  1769,  5484,
    4625,   651,  5485, -2778,  5490,  5493,  5541,  1926,  4352,  5542,
    5581,  5664,  3218,  2500,  2475,  2476,  2477,  2478,  2479,  2480,
    1451,  3975,  3718,  3976,  1457,  3432,  5937,  5608,  5938,  2633,
    5609,  3440,   619,  1415,  3885,  3984,  3887,  3888,  1498,  5631,
    5838,    29,  5609,  3922,  1527,  5637,  5638,  3977,  3961,  2543,
    2941,  1524,  2574,  5652,    41,  3950,  5653,  4333,  5656,  3882,
    5657,  1926,  5672,  2543,   886,  3078,  5678,  1205,   886,  3115,
    5684,  3719,  3473,  3115,  5685,  5688,  3761,  3115,  2543,  5689,
   -2778,  5690,  2543,  5717,  5691, -2778,  5718,  3973,  1529, -2279,
      45,   907,  3858,  5774,  5788,  5790,  4352,  2543,  2543,  4625,
    3561,  4467,  3327,  5806,  5828,  1530,  5807,  5829,  3562,  5874,
    3872,  3563,  5498,  1420,  1565, -1622,   967,  3858,   660,  1569,
     661,  4326, -2778,  4329,  1675,  5898,  1570,  1571,  5609,  4346,
    4000, -1088,    49,  1582,  1584,  5933,    41,  4316,  5934,  4318,
    4994,  1773,  4996,   664,  1594,    50,  1825,  3838,  1597,  3226,
    3227,  3228,  3229,   942,  5953,  4674,  3978,  2543,  4451,  1531,
    1619,  5971,  3979,  5977,  5653,  1532,  5978,  1634,    51,   886,
    2045,   942,    45,  2046,  3441,  2539,  5994,  1635,   942,  5978,
    1636,  4582,   619,  4585,   886,   619,    57,   619,   619,   886,
    5256,   898,  5257,  1651,  1661,  1662,  1665,   619,  1670,  1110,
    1671,  1110,   619,  1783,  2532,  1785,  1787,  1792,  1798,  1803,
    1534, -2778,  1806,  1808,    49,  1813,  1816,  1818,  4061,  1827,
    1810,  1828,  4387,  1832,  1833,  1835,  -183,    50,   619,   619,
     619,  1836,  1838,   619,  1840,   898,  4444,  2534,  1841,  1852,
    1859,   619,   619,   619,   619,  5061,  1863,   213,  1867,  1769,
      51,  1876,    41,  1881,   619,  1769,  1882,   619,  1883,   619,
    1885,  1888,  1889,  1892,  1637,  1893,  1535, -2778,  5839,  1900,
     619,   619,  3692,  1536,   619,  4666,  1537,  1904,  1906,  1907,
    1909,  1911,  4459,  1917,  1110,  4893,  1916,  1919,    45,  1922,
    1925,  1928,  1929,   619,  1934,   619,  1931,   619,  1980,  1950,
    1986,  1995,  1996,  1538,  3577, -1860,  4540,  3580, -1867,  3980,
    1988,  1989,  2003,  4908,  4518,  2004,  2005,   619,  2006,  2007,
    3981,    57,  2009,  2010,   187,  4006,  4007,  4008,  5234,  2011,
      49, -1857, -1858,  2012,   898,   942,  2013,  1539,  2014,  2015,
    4643, -1861,  2017,    50,  2018,  2019,  2020,  2021, -1859,  2022,
    2023, -2778,  2024,  2026,  2569,  2027, -2778,  2028,   920,  2029,
    2030,   920,  2031,  2032,  2033,  2486,    51, -2778,  2488,  2490,
     619,   932,   932,   619,  2491,  2500,  2504,  2516,  2475,  2476,
    2477,  2478,  2479,  2480,    57,   619,   932,  2524,  2546,   932,
     619,  4770,  2552, -2778,  3671,   187,  2547,  2554,  2555,  2558,
    1638, -2556,  2559,  2561,  1541,   619,  2562,  3684,  2563,  2564,
    2565,  4714,  4783,  2570,  1542,  3693,  2577,  1435,  4103,   619,
    1437,  2608,  2620,  1543,  2621,  2610,  2622,  2623,   886,  2639,
    2640,   886,  2641,   886,  2642,  1544,  2568,  2643,   886,  2644,
    3327,   932,  2645,  3327,   932,   932,  2539,  2646,  2647,  1046,
    1048,  3871,   942,   942,   777,  3738,  2648,  4775,   619,  2673,
    1241,  2679,  2654,  3923,  2685,  2699,  3884,  3924,  3925,  3926,
    2703,  3889,  2706,  2705,  1639,  2707,  3762,  1546,  1547,   942,
    2709,  2710,   942,  2723,  2727,   886,  2728,  5486,  2729,  3327,
    2741,  2740,  2761,   886,  2756,  2758,  2752,  2762, -2556,  2759,
    2760,  2769,  2770,  2037,  2771,  2774,  2775,  2776,  1640,  2781,
    2785,  2782,  2795,  2791,  2796,  2792,  2797,  4174,   886,  3817,
    2798,  3819,  2802,  2812,  2574,  3517,  2819,  4685,  2826,  2799,
    1543,  2805,  5196,  2829,  2808,  2809,  2814,  2815, -2778,  2854,
    2844,  2846,  2848,  2827,  2855,  2834,  2835,  2037,  2871, -2556,
    3540,  2872,  2879,  2852,  1769,  1769,  1769,  2901,  2908,  1531,
    2935,  2840, -2556,  2913,  2841,  1532,  2847,  2915, -2556,  3221,
    2849,  2860,  2861, -2556,  2916,  4061,  1549,  2873,   942, -2556,
    1636,  2884, -2556,  2917,  2918,  3994, -2556,   886,  2045,   886,
    2922,  2046,  2923,  2924,  2926,  2927,  2930,   942,  2928,  2929,
    2934,  2936,  2937,  2944,  2945,  2948,   642,  3883,  2953,  2962,
    1534,  2959,  2973,  5469,  3890, -2556,   942,  1616,  2977,  2981,
    2997,  2978,  2532,  3017,  3006,  3027,  3023,  2990,  2993, -2778,
    2996,  3010,  3039,  3041,  3042, -2556,  3043,  3044, -2778,  3057,
    3014,  4262,  5483,  4026,  3069,  3091,  4031,  3099,  3124,  2475,
    2476,  2477,  2478,  2479,  2480,  2534,  3112,  3032,  3195,  3148,
    4921,  3143,  3201,  2046,  1637,  3214,  1535,  3205,  3928,  3220,
    3237,  3239,  3259,  1536,  3260,  3278,  1537,  3281,  3283,  3282,
     886,  3284, -2556,  3296,  3297, -2556,  3298,  3299,  3300,  3301,
    3305, -2556,  3320,  1410,  3313,   905,  3314,  3336,  3331,  3348,
    3349,  3350,   942,  1538,  5157,  3351,  3365,   619,  3367,  3374,
    3373,  3376,  3401,   619,  3415,  3406,  3408,  3404,  3409,  3420,
    3425,  3426,   886,  3428,  4543,  2045,  3431,  3439,  2046,  3455,
    3460,  1354,  4821,  4822,  3524,  1358,  3929,  1539,  3462,  3479,
    3472,  3492,  3497,  3498,  3523,  3525,  3530,  3533, -2556,  1769,
     886,  3541,  3569,  3548,  3585,   942,  3568,   942,  3627,  2532,
    3640,  3648,  3649,  3652,   906,  3661, -2778,  4106,  3668, -2778,
     942,  4973,   942,  3674, -2778,  4109,  3675,  3680,  3707,  3676,
    3696,  3685,  3708,  3722,  3724,  3726,  4484,  3728,  1241,  3750,
    3737,  3923,  2534,   619,  3755,  3924,  3925,  3926,  3756,  4859,
    1638,  5019,  3757,   773,  1541,  3758,  3744,  3759,  3763,  3770,
    3771, -2778,  3774,  3780,  1542,  3775,  3795,  3768,  3796,   886,
    4511,  2883,  3805,  1543,  4916,  4917,  4918,  4919,  4920,  3766,
    3797, -2556,  3807,  3806,  3809,  1544,  3811,  3825,  3831,  3828,
     942,   886,  3833,  3827,  3846,  3847,  1926,  3859,  4446,  3848,
    4372,   898,  3849,  3850,  3851, -2556,  3125, -2556, -2556,  3863,
    3862,  4544,  3861,   886,  2539,  1923,  4553,  3880,  3870,  4191,
    5508,  4193,  1890,  4462,  3597,  3873,  3878,  1546,  1547,  3886,
    3906,  5068,   942, -2128,  4376,  3957,  4409,  1202,  3903,  3969,
    3653,  3904,  3974,  3905,  3910,  5026,  3919, -2556,  3911,  3915,
   -2556, -2556, -2556,  4547,  3917,  3918, -2778,  3983,  3598,   942,
    3997, -2778,  4107,  4108,  3941,  3992,  2543,  3993,  5129,  3946,
    3947,  3954,  3968,  3995,  3996,  3999,  4017,  4018,  4023,  4024,
    4029,   942,  4025,  4030,   942,  4057,  3930,  3931,  3932,  3933,
    3934,  3935,  3936,  3937,  3938,  4038,  4053,  4070, -2778,  4072,
    4081,   619,  4074,  4086,   886,  4097, -2778,  4088,  4089,  4093,
     619,  4094,  4247,  4063,  4100,  4125,  4102,  4126,   619,  4127,
     619,  1205,  4114,   619,  4132,  4115,  1549,   886,   619,   619,
     619,   619,  4133,  4131,   619,   619,   619,   619,   619,   619,
     619,   619,   619,   619,  2574,  4134,  3928,   619,   619,   619,
    4138,  2539,   886,  4149,  4269,  4150,  4152,   619,   898,  4158,
    4168,   619,  4159,  1769,  5023,   619,  4160,  4173,  4182,  4198,
    4200,  4196,  4202,   619,  1975,  4203,   619,  4204,   619,  4207,
    4209,  4210,  4211,  4212,  4231,  4236,  4229,  4230,   619,  4232,
    4233,   619,   619,  4234,  4214,  4235,   619,   619,  4237,  4239,
    4061,  4238,   616,   619,  4240,  4241, -2778,  5059,  4555,  4556,
    4557,  4558, -2558,  3329,  3929,  4245,  4243,  2475,  2476,  2477,
    2478,  2479,  2480,  4242,  4244,  4061,  4248,  4250,  4252,  2869,
    4254,  4255,   191,  4264,   619,  4268,  5196,  4261,  4265,  4266,
    4271,  4276,   619, -2778,  4319,  4282,   619,  1049,   187,  1047,
    4325,  3473,  4284,  4324,  4334,  4331,  4337,  4644,  4335,  4341,
    4351,  4352,  4354,  4364,  4370,  4371,  4374,  4375,  4377,  3785,
    4391,  4405,  4361,  4415,  4408,  4423,  4411,  4424,   619,  5107,
    5108,  4431,  5110,  4450,   187,   886,  5140,  4417,  4445,  4439,
    5100,  4440,  4441,  1501,  4452,  4410,  4437,   619,  4270,  4442,
    4453,  4454,  4443,  4463,  4464,  4465,  5868,  5869,  1998, -2558,
    4466,  4468,  3327,   897,  4469,  4470,  3327,  4471,   942,   920,
    4472,  2601,   932,  4476,   932,   932,  3923, -2127,  1502,  4525,
    4485,  2045,  4536,  4537,  2046,  4508,  4548,  2833,  4578,  5512,
    4509,  4510,  4554, -2778,  4579,  4517,  4539,  4563,  4567,  4565,
    4586,  4571,  4587,  4592,  2475,  2476,  2477,  2478,  2479,  2480,
   -2558,  4574,  5293,  4593,  4576,  2532,  4591,  3327,  4605,  1769,
    4594,  4618, -2778, -2558,  1769,   886,  1769,  4749,  4602, -2558,
    4752,  4596,  4610,  4639, -2558,  4642,  4477,  5159,  4640,  1503,
   -2558,  4641,  4649, -2558,  4650,  4652,  4653, -2558,  2534,  1769,
     886,  4655,  4660,  4680,  4661,  4677,  4061,  4692,  4693,  4486,
    4709,  4696,  4694,  4695,  3930,  3931,  3932,  3933,  3934,  3935,
    3936,  3937,  3938,  4706,  4298,  1504, -2558,  4708,  4707,  4710,
    4299,  4723,  4711,  4720,  4507,  4735,  4722,  4736,   942,  4741,
    4744,   942,  4760,  4300,  4761,  4763, -2558,  5535,  4766,  5537,
    4667,  4776,  4777,  4779,  4726,  4780,  3786,  4781,  4803,  4422,
    4792,  1505,  4813,  4818,  4824,  4734,  4832,  4982,  4838,  4844,
    2037,  4301,  4839,  4302,  4851,  4845,  4861,  4867,  4868,  4878,
    4834,  4885,  4884,  4887,  4888,  4889,  4891,  4892,  4903,  4897,
    4905,  4909,  4922, -2558,  4927,   187, -2558,  2883,  4929,  4937,
    4944,  1507, -2558,  4945,  4950,   619,  4962,  4956,  5647,  4965,
    4966,  4967, -2778, -2129,  4984,  3320,  4998, -2778,  5002,  3320,
    4971,  5012,  5021,  5025,  5005,  5016,  5024,  5029,  5027,  4303,
    4959,   942,   942,  1509,  5031,   886,  5036,  5037,  5043,  1472,
    5269,   942,  5047,  5067,  5065,  5066,  5070,  5077,   619,   619,
    5078,  5269,  5545,  5097, -2778,  5090,  5076,  4304,   942, -2558,
    5093,  5099,  5111,  5112,  5130,  5102,  5103,  5119,  5120,  5121,
    5133,  5126,  5137,  5138,  5141,    36,  5146,  5149,  5400,  5154,
    3787,   886,  5701,  5703,  5155,  5156,   886,   619,   619,  1512,
    5158,  3858,  5162,  5164,  5475,  5168,  5173,  1513,   619,  4870,
    5178,  5180,  5184,  5185,  5303,  2720,  5189,  2539,  5191,  5192,
     616,  5187,  5202,  3078,   773,  5210,  5208,  1515,  3327,  3327,
    5224,  3329,  4305,  1598,  5193,   967,  1516,  4306,  5228,  5227,
    1517,  5354,  5320,  5235,  5245,  5239,  5246,  5247,  5253,  5248,
    5258,   619, -2558,  5262,  5268,  1599,  5315,  5297,  5307,  3788,
    5316,  5317,   942,  5272,  5275,  5309,  5325,  5312,  5294,  5322,
    5347,  5311,  5328,  5329,  5333,  5338, -2558,  5339, -2558, -2558,
    4307,  4134,  5340,  5369,  4802,  5376,  5379,  5378,   619,  5382,
    5387,  5386,  5406,  5407,  1518,  5411,  4308,  5418,  3789,   619,
    5435,  5416,  5440,  5446,  5454,  5447,  1600,  4667,  5448, -2778,
    5462,  5464,  5474,  5478,  2676,  5482,  5494,  5498, -2558,  5496,
    5500, -2558, -2558, -2558,  5507,  5499,  5517,   619,  1241,  5547,
     619,  3923,  5516,  5515,  5523, -2778, -2778, -2778,   619,   619,
    5808,   886,  5529,  5560,  5568,   619,   619,  5573,  5562,  5575,
     619,  5572,  5695,  5583,   619,  5588,  5601,   619,   619,  5602,
    5603,  5597,   619,  5604,  5605,  5615,  5616,  5623,   619,  5617,
     920,  5618,  4668,   932,  1241,   932,   932,  3923,  5645,  5625,
    5627,  3924,  3925,  3926,  5629,   619,  5639,  5646,  5649,  5665,
    5677,  5659,   619,  4549,  4309,  1601,  5681,   619,  5700,  5706,
     619,   619,  5711,  5713,  5716,  5720,  5723,  5724,   619, -2778,
    5740,  5864,  5865,  5741,  5707,  5742,  5751,  5491,  5743,   619,
    2475,  2476,  2477,  2478,  2479,  2480,  5752,  4823,  5757,  5758,
    5761,  3320,  5771,  5770,  5030,   619,  5772,  5784,  5777,  5794,
    5792,  5786,  5801,  1602,  5803,  5709,  1603,  5084,  5710,  5810,
    5818,  5819,  5817,   886,  5837,  3327,  5835,   187,  5855,  5094,
    5860,  2832,  3327,  5870,  5873,  4669,   942,  3327,  5876,  5881,
    3327,  5883,  5902,  5913,  5922,  5939,  5908,  5909,  5940,  5941,
    5944,  5943,  5959,  5970,  5975,  5976,  5983,  5984,  5961,  5962,
    5988,   886,  5539,  5991,  5442,  1605,  1422,  5987,  2885,  1528,
    3731,  4015,  3600,  3522,  4144,  2523,  4683,  4676,   942,  5804,
    3639,  3687,  4281,   886,  3178,  5366,  5694,  5882,  4820,  5417,
     942,  5063,  3196,  4791,  4673,  5136,  5399,  4091,  5796,  3845,
    5301,  5071,  5878,  5714,  5712,  5816,   619,  4793,  5893,  4096,
    1607,  5166,  4842,  4871,  5675,  4850,  3705,  4812,  3706,   942,
    4681,  4162,  4837,  4340,  5160,  5405,  4380,  1618,   616,  4895,
    5619,   616,  5936,  1608,  5993,  5985,  5380,  4287,  5821,  3329,
    5327,  5525,  3329,  4879,  5683,  2952,  5330,   723,   775,  1042,
     886,  5502, -2778,  1610,  4923,  4670,  5932,  3735,  4671,  3016,
    3379,  4082,  4881,  3028,  1972,  4397,  5443,  3012,  5534,  5613,
    3045,  5651,  5670,  3637,  3929,  1111,   619,   616,  4251,  4712,
    3119,  3120,  1110,  1151,  5841,  5695,  5960,  3664,  3329,  1367,
    4899,  3335,   619,  2910,  3068,  4898,  5461,  1769,  5853,  5220,
    2496,   812,  2544,  4913,   813,  4059,  2604,  2653,  2605,  3345,
    4071,  5789,  5661,  2609,  4033,  4584,   942,  4569,  5274,  4027,
    3929,  5481,  5480,   619,  4914,  4028,  5950,  5354,  5776,  5871,
    5650,  5662,  2553,  5470,  4519,  3320,  5663,  3264,  3990,  3184,
    3320,  3988,  3663,  3320,  3898,   967,  1418,  3333,  3273,     0,
       0,   617,  3858,     0,     0,  5667,     0,     0,     0,     0,
    5171,     0,     0,     0,  2762,     0,     0,     0,   768,   886,
     770,   886,     0,     0,   776,     0,     0,     0,     0,     0,
     793,   801,   768,     0,   808,  4061,     0,   801,   801,     0,
     837,     0,   840,  3327,     0,  5326,     0,   967,     0,   894,
     894,   894,     0,     0,     0,  5051,     0,     0,     0,     0,
       0,     0,     0,   942,  5217,  5219,     0,     0,     0,     0,
    5324,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   619,     0,     0,   619,     0,     0,   619,   619,   619,
       0,     0,     0,  5073,     0,     0,     0,     0,     0,     0,
       0,  5979,  3858,     0,  3858,     0,     0,     0,     0,     0,
       0,     0,   619,   619,  5368,  5089,   619,     0,     0,     0,
       0,     0,  1110,     0, -2778, -2778, -2778,  3933,  3934,  3935,
    3936,  3937,  3938,     0,     0,     0,   619,     0,     0,     0,
       0,     0,   619,     0,     0,     0,   619,     0,     0,     0,
       0,     0,   886,   619,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   942,     0,   942,     0,     0,     0,   619,
    3930,  3931,  3932,  3933,  3934,  3935,  3936,  3937,  3938,     0,
       0,     0,  5116,     0,     0,     0,     0,     0,  5471,     0,
       0,     0,   617,   922,   922,  5295,     0,   922,     0,     0,
    1501,   933,     0,   837,     0,     0,   969,     0,     0,   933,
     886,   942,   933,     0,     0,   837,  3327,   922,     0,     0,
     837,   619,  5492,     0,   922,     0,   837,     0,     0,  2039,
       0,     0,     0,     0,     0,  1502,     0,     0,     0,  3327,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5986,
       0,     0,     0,     0,     0,     0,     0,     0,   187,     0,
    1769,  5843,  5845,     0,     0,   619,     0,     0,     0,  5534,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5530,  5531,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1503,     0,     0,     0,
       0,     0,     0,  5201,  5109,     0,     0,     0,     0,     0,
       0,     0,   187,   187,     0,     0,     0,  5404,     0,  5113,
       0,     0,     0,     0,     0,     0,     0,   619,     0,     0,
     886,     0,  1504,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    72,    81,   191,  5430,     0,
    5843,  5845,    84,   176,    85,     0,   619,    86,   619,    87,
     107,   125,   186,   130,   182,   160,   179,   185,  1505,   619,
     192,     0,     0,   619,     0,   619,  5968,   898,     0,     0,
       0,  5432,     0,     0,     0,  1110,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   619,     0,  3327,   619,     0,
       0,  3347,     0,     0,  1506,     0,     0,     0,  1507,   619,
    5172,     0,     0,  5968,     0,     0,   619,     0,     0,  3320,
       0,  5640,     0,  5968,     0,     0,  3327,     0,     0,     0,
       0,     0,     0,     0,  4247,     0,     0,     0,     0,  1508,
    1509,  5658,     0,  5660,     0,     0,  1472,     0,     0,  5843,
    5845,     0,     0,     0,     0,     0,     0,   886,     0,     0,
       0,     0,   886,   886,     0,  3327,   967,   619,     0,     0,
       0,     0,   619,   619,   942,     0,     0,     0,  1510,     0,
       0,     0,    36,     0,     0,     0,     0,  1511,   942,     0,
       0,     0,     0,     0,     0,     0,  1512,     0,     0,     0,
       0,     0,     0,     0,  1513,     0,     0,     0,   619,     0,
       0,     0,  1514,     0,     0,   619,     0,     0,  1769,     0,
       0,  3785,     0,     0,  1515,     0,     0,     0,     0,     0,
       0,     0,     0,  1516,     0,     0,     0,  1517,     0,     0,
       0,     0,     0,   619,     0,  1501,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   187,     0,     0,     0,     0,
    5591,     0,     0,   886,   886,     0,     0,     0,     0,     0,
    1502,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1518,     0,     0,     0,  5304,   187,  5305,     0,     0,
     616,     0,   619,     0,   616,     0,     0,     0,   619,     0,
     187,  3329,     0,  3327,     0,  3329,     0,     0,     0,   619,
    1769,     0,     0,   886,     0,  1021,     0,     0,   619,     0,
     619,   837,   619,   922,     0,   922,     0,     0,   922,     0,
       0,  1503,     0,     0,     0,   969,     0,     0,     0,     0,
    1078,   619,   922,     0,     0,   616,     0,     0,   922,     0,
       0,  5800,     0,     0,     0,     0,  3329,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1769,  1504,   942,     0,
       0,     0,   617,     0,     0,     0,     0,     0,     0,  2037,
       0,   933,     0,     0,     0,   969,     0,     0,   933,     0,
       0,   933,     0,     0,     0,     0,     0,     0,  3786,     0,
       0,     0,     0,  1505,     0,     0,  1887,   922,     0,     0,
       0,     0,  1891,     0,     0,     0,     0,     0,     0,     0,
       0,   619,  1902,     0,  5847,  5848,  1905,     0,  3858,  1978,
    1908,     0,  1910,   619,  1978,  1978,     0,     0,  1918,  5431,
       0,     0,     0,  1507,  1924,     0,  2045,  1927,     0,  2046,
       0,     0,     0,  2047,  2048,  2049,     0,     0,     0,   837,
       0,     0,   801,   801,   801,   619,   619,   619,     0,     0,
    2531,     0,     0,   619,     0,  1509,     0,  1223,  5759,     0,
    2532,  1472,     0,   619,     0,     0,     0,  2533,     0,   942,
       0,  3327,     0,     0,     0,     0,     0,  1339,  1339,     0,
     837,   801,   619,  3327,     0,   801,  3320,     0,   187,     0,
       0,     0,     0,  2534,     0,   942,     0,    36,  5926,   837,
       0,     0,  1511,   837,     0,     0,     0,     0,     0,  1339,
       0,  1512,     0,     0,     0,     0,     0,     0,     0,  1513,
       0,     0,     0,     0,     0,     0,  5614,  2720,     0,     0,
       0,     0,     0,     0,     0,     0,   619,     0,     0,  1515,
       0,     0,     0,     0,     0,     0,   619,     0,  1516,     0,
       0,     0,  1517,  5822,  1339,   619,   619,     0,     0,     0,
       0,   619,     0,     0,   191,     0,   619,     0,   837,     0,
       0,  3788,  5536,     0,  5538,  5655,   616,   616,     0,  5846,
     837,  5844,   619,   619,     0,     0,     0,  3329,  3329,     0,
       0,     0,     0,     0,     0,   837,     0,     0,     0,     0,
       0,     0,     0,     0,  5907,     0,  1518,  2535,     0,     0,
    3789,   942,  2536,     0,   837,     0,  3327,     0,     0,   922,
     922,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   619,  2537,  2233,  5989,  5990,     0,   619,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2538,
       0,   801,   801,   191,     0,     0,   619,     0,  3178,  3178,
       0,     0,     0,  3178,     0,     0,     0,     0,  5846,     0,
    5844,     0,     0,     0,  1339,  1339,     0,   619,     0,     0,
     619,     0,     0,     0,     0,   619,     0,   617,  2283,   922,
       0,     0,     0,   933,     0,     0,   969,   933,     0,   933,
    3178,  3178,  2539,  3327,   922,  2540,   187,     0,     0,  3327,
       0,     0,     0,     0,     0, -2574,     0,   619,     0,     0,
       0,     0,     0,     0,   619,     0,     0,   837,     0,     0,
       0,     0,     0,     0,   922,   922,     0,     0,   619,     0,
       0,     0,     0,     0,     0,  1769,     0,     0,     0,     0,
       0,     0,   191,     0,     0,   837,   837,   837,     0,   922,
       0,   617,     0,   617,   617,     0,     0,  5846,     0,  5844,
       0,     0,     0,   619,   619,     0,     0,     0,   619,     0,
       0,     0,  1769,     0,     0,     0,     0,   619,   619,     0,
       0,     0,  1769,     0,  2541,     0,     0,   922,     0,   922,
     922,   187,     0,   616,     0,     0,     0,     0,  3327,     0,
     616,  5722, -2574,     0,  3329,   616,     0,     0,   616,  5014,
       0,  3329,     0,     0,     0,     0,  3329,   187,     0,  3329,
       0,     0,  1339,     0,     0,     0,     0,     0,     0,     0,
     837,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1953,  1953,     0, -2574,     0,   837,     0,   768,     0,     0,
       0,     0,     0,     0,     0,     0, -2574,     0,     0,     0,
       0,     0, -2574,     0,     0,     0,   837, -2574,     0,     0,
       0,     0,  1987, -2574,  2471,   837, -2574,     0,  1993,     0,
   -2574,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,     0,  1339,     0,     0,  3912,  5906,     0,  3913,     0,
       0,  5805,     0,  2045,     0,     0,  2046,     0,     0, -2574,
    2047,  2048,  2049,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1339,     0,     0,     0,  2531,     0, -2574,
       0,   686,     0,     0,     0,     0,  3128,  2532,     0,     0,
       0,     0,     0,     0,  2533,     0,     0,     0,     0,     0,
       0,  1339,  1339,  1339,     0,  1339,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2534,     0,     0,     0,     0,  1339, -2574,     0,     0, -2574,
       0,     0,     0,     0,     0, -2574,     0,   689,  3129,     0,
       0,     0,     0,     0,     0,   187,     0,     0,     0,  2045,
       0,     0,  2046,   690,     0,     0,  2047,  2048,  2049,  5880,
       0,     0,     0,   837,     0,     0,     0,     0,     0,     0,
    5143,  1026,     0,  2531,     0,     0,     0,     0,     0,     0,
       0,  1339,     0,  2532,     0,     0,     0,     0,  5894,  5894,
    2533,     0, -2574,     0,     0,  3130,     0,     0,     0,     0,
       0,   616,     0,     0,     0,     0,   693,     0,     0,     0,
       0,     0,  3329,     0,     0,   694,  2534,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1339,   695,     0,
       0,  1339,  1339,  3131,  2535,     0,     0,     0,     0,  2536,
       0,     0,   837,   837,  2618,     0,  1339,   773,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1029,
       0,  2537,  2233,     0,     0,     0,     0,     0,     0,   801,
       0,     0,     0,     0,     0, -2574,  2538,     0,     0,     0,
       0,     0,     0,     0,  3132,     0,     0,     0,     0,  5894,
    3040,     0,     0,     0,     0,     0,     0,     0,  3047, -2574,
       0, -2574, -2574,     0,  2708,   699,     0,     0,     0,   801,
       0,     0,   922,     0,     0,  2283,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   837,  2736,     0,     0,  2539,
    2535,     0,  2540,     0,   837,  2536,     0,   922,     0,     0,
       0, -2574,     0,     0, -2574, -2574, -2574,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2537,  2233,     0,
       0,     0,     0,     0,   969,     0,   837,     0,     0,   801,
       0,     0,  2538,     0,   616,     0,     0,     0,     0,   213,
    3133,     0,     0,   704,     0,  3329,   801,     0,     0,   837,
       0,     0,   837,     0,     0,     0,     0,   616,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3329,     0,
    1033,  2283,     0,  3134,   922,     0,     0,     0,     0,   708,
       0,  2541,     0,     0,     0,  2539,   709,     0,  2540,   710,
     837,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   922,   922,   922,   922,   837,     0,   711,   932,
       0,     0,     0,     0,     0,  1035,     0,     0,     0,     0,
     837,   713,     0,     0,  1036,     0,     0,     0,   715,     0,
       0,  1339,  1339,  1339,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3135,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   932,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   720,
       0,     0,     0,     0,     0,     0,     0,  2541,     0,     0,
       0,  2471,     0,     0,     0,     0,     0,     0,     0,  2472,
    2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,  3178,  3178,
    3178,  3178,  3204,     0,  3178,  3178,  3178,  3178,  3178,  3178,
    3178,  3178,  3178,  3178,     0,   616,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3329,     0,     0,   837,
       0,  4515,     0,     0,     0,     0,     0,     0,     0,     0,
     837,     0,     0,     0,   616,     0,     0,     0,   922,   922,
       0,     0,     0,     0,     0,  3329,     0,     0,     0,     0,
       0,  3178,  3178,     0,   922,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2471,     0,     0,
       0,     0,   837,   616,     0,  2472,  2473,  2474,  2475,  2476,
    2477,  2478,  2479,  2480,  3329,     0,  2907,     0,   922,   922,
     922,   922,     0,     0,  4573,     0,     0,   837,     0,     0,
       0,     0,     0,     0,   837,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   617,     0,     0,   617,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   933,   933,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   969,   969,     0,     0,   933,
       0,     0,   933,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -135,     0,     0,   922,   922,     0,
       0,     0,     0,     0,   922,     0,   837,     0,     0,   837,
       0,     0,     0,     0,     1,     0,     0,     0,     0,     0,
       0,     0,     0,  5574,     2,  1953,     3,     4,     0,     0,
       0,     0,   922,     0,   933,     0,     0,   933,   933,     0,
     837,   837,     0,   922,     5,     0,     0,     0,     0,     0,
     837,   616,     0,     0,     6,     0,     0,   837,     0,     0,
       0,     0,  3329,   768,   768,     0,     7,  3127,     8,     9,
       0,  1339,     0,  1339,     0,    10,     0,    11,  1339,  1339,
       0,     0,     0,     0,     0,  1339,  1339,  1339,     0,    12,
    1339,    13,  1339,   969,  1339,  1339,  1339,  1339,  1339,  1339,
       0,  1339,     0,  1339,  1339,     0,     0,  1339,    14,     0,
    1531,    15,     0,     0,     0,     0,  1532,     0,     0,     0,
       0,     0,  1339,  1339,  1339,     0,    16,  1531,    17,     0,
       0,  1533,    18,  1532,     0,     0,     0,     0,    19,  1339,
       0,     0,     0,     0,     0,     0,    20,     0,    21,     0,
       0,     0,     0,     0,     0,    22,     0,     0,     0,     0,
       0,  1534,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    23,     0,     0,     0,     0,     0,  1534,   922,
       0,     0,     0,     0,     0,     0,     0,   759,     0,    24,
       0,     0,     0,   759,     0,  3178,     0,     0,     0,  2045,
       0,     0,  2046,  3285,     0,     0,  2047,  2048,  2049,     0,
       0,     0,     0,     0,     0,     0,     0,  1535,     0,     0,
       0,     0,     0,  2531,  1536,     0,     0,  1537,     0,    25,
      26,     0,     0,  2532,  1535,    27,     0,     0,     0,   616,
    2533,  1536,     0,     0,  1537,     0,     0,    28,     0,     0,
    3329,   616,     0,     0,  1538,     0,     0,     0,     0,     0,
       0,     0,  3329,     0,     0,    29,  2534,     0,     0,     0,
       0,  1538,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1339,     0,     0,     0,     0,     0,  1539,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    30,     0,     0,     0,  1539,     0,     0,     0,    31,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     932,     0,  1339,    32,     0,     0,     0,     0,     0,    33,
      34,     0,    35,     0,     0,     0,     0,    36,     0,     0,
       0,  1531,     0,    37,     0,     0,    38,  1532,     0,     0,
       0,  1540,     0,    39,     0,  1541,     0,     0,     0,    40,
      41,     0,     0,     0,     0,  1542,     0,    42,  1638,     0,
       0,    43,  1541,  1339,  1543,     0,     0,     0,     0,     0,
    2535,    44,  1542,     0,   616,  2536,  1544,     0,     0,     0,
       0,  1543,  1534,   932,   932,  3329,    45,     0,     0,     0,
       0,     0,     0,  1544,     0,     0,     0,  2537,  2233,     0,
    4964,     0,     0,     0,     0,     0,    46,     0,     0,     0,
       0,     0,  2538,     0,     0,  1545,     0,    47,  1546,  1547,
       0,     0,     0,    48,     0,     0,     0,     0,    49,     0,
       0,     0,  1666,     0,     0,  1546,  1547,     0,  1535,     0,
       0,    50,     0,     0,     0,  1536,     0,     0,  1537,  1548,
       0,  2283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   616,     0,     0,    51,  2539,  1667,   616,  2540,     0,
       0,     0,  3329,     0,     0,  1538,     0,     0,  3329,     0,
       0,     0,    57,     0,  5911,  -135,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1539,
       0,     0,     0,     0,     0,     0,   685,  1549,     0,     0,
       0,     0,     0,     0,     0,   772,     0,     0,     0,     0,
       0,     0,     0,     0,  1549,     0,     0,  1339,  1339,  1339,
    1339,  1339,  1339,  1339,  1339,  1339,     0,  1339,     0,     0,
       0,     0,  5947,     0,     0,   837,  1339,  2541,  1339,     0,
       0,     0,     0,     0,     0,   837,   616,     0,     0,     0,
       0,     0,  1638,     0,     0,     0,  1541,  3329,     0,     0,
       0,     0,     0,     0,     0,     0,  1542,     0,     0,     0,
       0,     0,     0,     0,   837,  1543,  1339,     0,     0,   922,
    1339,     0,  5947,  1339,     0,  1339,  5982,  1544,  1339,     0,
       0,     0,  1339,     0,     0,   932,   932,  2045,     0,     0,
    2046,     0,     0,     0,  2047,  2048,  2049,     0,     0,     0,
       0,     0,     0,     0,     0,  3330,     0,     0,     0,     0,
       0,   837,   837,     0,     0,     0,  2700,     0,     0,  1546,
    1547,  2532,  1339,     0,     0,     0,     0,  2471,  2533,     0,
       0,  1339,  1339,     0,     0,  2472,  2473,  2474,  2475,  2476,
    2477,  2478,  2479,  2480,     0,   837,     0,     0,     0,     0,
    2701,  3914,  3368,     0,  2534,     0,     0,     0,     0,     0,
       0,     0,     0,  3808,     0,     0,     0,     0,  3814,     0,
    3815,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3821,     0,     0,  3822,     0,  3823,  3824,     0,     0,  3826,
       0,     0,   768,  3829,   768,  3830,     0,     0,  3832,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1339,  2045,     0,     0,  2046,     0,     0,  1549,  2047,
    2048,  2049,   617,     0,     0,   933,   969,   933,   933,     0,
       0,   922,     0,     0,   837,     0,  2531,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2532,     0,     0,     0,
       0,     0,     0,  2533,     0,   801,     0,     0,     0,     0,
       0,  3881,     0,     0,     0,     0,  2736,     0,  2535,     0,
       0,     0,     0,  2536,  3476,   837,     0,     0,     0,  2534,
       0,  3487,     0,     0,     0,     0,     0,     0,     0,     0,
     837,     0,     0,     0,     0,  2537,  2233,     0,     0,     0,
       0,     0,     0,     0,  3178,     0,     0,     0,     0,     0,
    2538,   837,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   837,   837,  2045,     0,   837,  2046,     0,   801,     0,
    2047,  2048,  2049,     0,     0,     0,     0,     0,     0,  2283,
       0,     0,     0,     0,     0,     0,  3178,  2531,     0,     0,
       0,   922,     0,  2539,   922,     0,     0,  2532,   759,     0,
     759,     0,   759,     0,  2533,     0,     0,     0,   759,  1190,
    1191,   885,     0,     0,     0,     0,     0,     0,     0,   837,
     837,     0,     0,  2535,     0,     0,     0,     0,  2536,     0,
    2534,     0,     0,     0,  3626,     0,  3629,  3631,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2537,  2233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2538,     0,  1339,  1339,  1339,
       0,     0,     0,  1339,     0,     0,     0,     0,     0,     0,
       0,   922,     0,  2045,     0,  2541,  2046,     0,     0,     0,
    2047,  2048,  2049,     0,   922,     0,     0,     0,     0,     0,
    1339,     0,   922,     0,  2283,     0,     0,  2531,     0,     0,
       0,     0,     0,     0,     0,  2736,     0,  2532,  2539,  1531,
     837,  2540,     0,   837,  2533,  1532,     0,  3732,     0,     0,
     768,     0,     0,     0,     0,     0,     0,     0,     0,  1531,
       0,     0,   922,  3743,  2535,  1532,     0,     0,     0,  2536,
    2534,     0,     0,  3626,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   922,     0,  3765,     0,     0,     0,     0,
    1534,  2537,  2233,     0,     0,     0,     0,     0,     0,  4101,
       0,     0,     0,     0,     0,  2471,  2538,     0,     0,     0,
    1534,     0,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,     0,   759,   922,     0,   922,     0,   922,     0,
    2541,     0,     0,     0,     0,     0,     0,     0,     0,  3178,
       0,     0,     0,     0,     0,  2283,  1535,     0,     0,     0,
       0,  1043,     0,  1536,  3843,     0,  1537,     0,     0,  2539,
       0,     0,  2540,  1953,     0,     0,  1535,     0,  3178,     0,
    4151,     0,  4153,  1536,     0,     0,  1537,     0,     0,     0,
       0,     0,     0,  1538,  2535,     0,     0,     0,     0,  2536,
       0,     0,   759,     0,     0,     0,     0,     0,     0,     0,
       0,  1109,   685,  1538,     0,     0,     0,     0,     0,     0,
       0,  2537,  2233,   617,   922,     0,   933,  1539,   933,   933,
       0,   922,     0,     0,     0,     0,  2538,     0,  1339,     0,
    2471,     0,     0,  1339,     0,     0,     0,  1539,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,     0,     0,
       0,  2541,     0,     0,  3964,     0,     0,     0,     0,  1339,
    1339,  1339,     0,     0,  1339,  2283,     0,     0,     0,     0,
       0,     0,  1339,  1339,  1339,  1339,     0,     0,     0,  2539,
    1540,     0,  2540,     0,  1541,  1339,     0,     0,  1339,     0,
    1339,     0,     0,     0,  1542,     0,     0,     0,     0,  1214,
    1638,  1339,  1339,  1543,  1541,  1339,     0,     0,     0,     0,
    4246,     0,     0,     0,  1542,  1544,  4253,     0,     0,     0,
       0,     0,   969,  1543,  1339,  1232,  1339,     0,  1339,     0,
       0,     0,     0,  1342,     0,  1544,  1351,  1109,  1353,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1339,     0,
       0,  2471,   837,     0,  2777,     0,     0,  1546,  1547,  2472,
    2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,     0,
       0,  2541,  4283,   837,  3468,     0,     0,  1546,  1547,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2778,  3178,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1531,   617,     0,     0,  3330,  4037,  1532,     0,  1548,  4037,
    4051,  4037,     0,     0,     0,     0,  1339,     0,     0,     0,
       0,  1339,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2045,     0,     0,  2046,     0,  1339,     0,  2047,  2048,
    2049,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3330,  1534,  4076,     0,     0,  2531,  1549,     0,     0,     0,
       0,  2045,     0,     0,  2046,  2532,     0,     0,  2047,  2048,
    2049,  2471,  2533,     0,     0,     0,  1549,     0,     0,  2472,
    2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,  1339,
       0,     0,  4478,     0,     0,  2532,  1953,     0,  2534,     0,
       0,  4414,  2533,  4416,     0,  4418,     0,  1535,     0,     0,
       0,     0,     0,     0,  1536,     0,     0,  1537,     0,   922,
     922,     0,     0,     0,     0,     0,     0,     0,  2534,     0,
       0,     0,   759,     0,     0,     0,  1109,   759,   759,     0,
       0,     0,     0,     0,  1538,     0,     0,     0,     0,     0,
       0,     0,     0,  5775,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2549,     0,     0,     0,     0,
       0,   885,     0,     0,  2556,     0,  2557,     0,  1539,     0,
    2560,     0,     0,     0,     0,     0,     0,  2566,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   885,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2535,     0,     0,     0,     0,  2536,     0,     0,
       0,     0,     0,     0,     0,     0,   837,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2537,
    2233,  1638,  2535,     0,     0,  1541,     0,  2536,     0,     0,
       0,     0,     0,     0,  2538,  1542,     0,     0,     0,     0,
       0,     0,     0,     0,  1543,     0,     0,     0,     0, -2778,
   -2778,     0,     0,     0,     0,     0,  1544,   759,     0,     0,
       0,     0,  3178,  3178,  2538,     0,     0,   759,     0,     0,
       0,     0,     0,  2283,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2539,     0,     0,
    2540,     0,     0,     0,     0,  3642,     0,     0,  1546,  1547,
       0,     0,     0, -2778,     0,     0,  1977,     0,     0,     0,
       0,  1190,  1191,     0,     0,     0,     0,  2539,  1339,     0,
       0,     0,     0,     0,  1339,     0,   885,     0,     0,  3643,
       0,     0,     0,     0,  1109,   922,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2045,     0,   759,  2046,     0,   759,   759,  2047,
    2048,  2049,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   837,   837,   837,     0,  2531,     0,     0,  2541,
       0,     0,     0,     0,     0,     0,  2532,     0,     0,   837,
       0,     0,     0,  2533,     0,     0,     0,  1549,     0,     0,
       0,     0,     0,     0,  1339,     0,     0,  2045,     0,  2541,
    2046,  2041,     0,     0,  2047,  2048,  2049,     0,     0,  2534,
    2043,     0,  1953,   837,   837,     0,     0,     0,   837,     0,
       0,  2531,     0,     0,  2494,     0,     0,     0,     0,     0,
     837,  2532,     0,     0,     0,     0,     0,     0,  2533,     0,
       0,     0,     0,  1109,     0,     0,  2511,  2512,     0,     0,
       0,  1109,  1109,     0,     0,     0,     0,     0,  1685,     0,
       0,     0,     0,     0,  2534,     0,     0,     0,     0,  2471,
       0,     0,     0,     0,     0,     0,   885,  2472,  2473,  2474,
    2475,  2476,  2477,  2478,  2479,  2480,   922,   885,     0,     0,
    4528,  4430,     0,     0,  3843,     0,     0,     0,     0,  2471,
       0,     0,   885,     0,     0,     0,     0,  2472,  2473,  2474,
    2475,  2476,  2477,  2478,  2479,  2480,     0,   837,     0,     0,
       0,     0,     0,  2535,     0,     0,     0,     0,  2536,     0,
     837,     0,     0,   837,     0,     0,     0,   759,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2537,  2233,  1339,     0,     0,     0,     0,     0,     0,     0,
       0,  1339,     0,     0,     0,  2538,     0,     0,     0,  1339,
       0,  1339,     0,     0,  1339,     0,     0,     0,  2535,  1339,
    1339,  1339,  1339,  2536,     0,  1339,  1339,  1339,  1339,  1339,
    1339,  1339,  1339,  1339,  1339,     0,     0,     0,  1339,  1339,
    1339,     0,     0,     0,  2283,  2537,  2233,     0,  1339,     0,
       0,     0,  1339,     0,     0,     0,  1339,     0,  2539,     0,
    2538,  2540,     0,     0,  1339,     0,     0,  1339,     0,  1339,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1339,
       0,     0,  1339,  1339,     0,     0,     0,  1339,  1339,     0,
       0,     0,  4551,     0,  1339,     0,     0,     0,     0,  2283,
    1531,   837,   837,   837,   885,     0,  1532,     0,     0,     0,
       0,     0,     0,  2539,  4902,     0,  2540,  4904,     0,     0,
       0,  4037,  4051,  4037,     0,  1339,  4037,     0,     0,  4575,
       0,     0,     0,  3330,     0,     0,     0,  3330,     0,     0,
       0,     0,     0,  4590,     0,  2837,     0,     0,     0,     0,
    2541,  1534,     0,  2845,     0,     0,  4930,     0,     0,   686,
       0,     0,     0,     0,  2687,     0,     0,     0,     0,  1339,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4626,  1953,
    1953,  3149,  3150,     0,     0,     0,     0,     0,  3164,  3165,
       0,     0,  2688,     0,     0,  2541,     0,  1535,     0,     0,
       0,     0,     0,     0,  1536,   689,     0,  1537,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3206,  2736,  4658,
       0,   690,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1538,     0,     0,  4679,     0,  1026,
    2471,     0,     0,     0,     0,     0,     0,     0,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,     0,     0,
       0,  4620,     0,  2689,     0,     0,     0,     0,  1539,     0,
       0,     0,     0,     0,   693,     0,     0,     0,     0,     0,
       0,     0,     0,   694,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2471,   695,     0,     0,     0,
       0,  2690,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,     0,     0,     0,     0,  4840,     0,     0,     0,
       0,     0,  5050,     0,     0,     0,     0,  1029,     0,     0,
       0,  1638,     0,     0,     0,  1541,  2638,  4767,     0,     0,
       0,     0,     0,     0,  2045,  1542,     0,  2046,     0,     0,
       0,  2047,  2048,  2049,  1543,  2974,     0,     0,     0,  2979,
       0,     0,     0,  5074,  5075,     0,  1544,     0,  2531,     0,
     922,     0,     0,   699,     0,     0,     0,     0,  2532,     0,
       0,     0,     0,     0,   922,  2533,  1339,     0,     0,     0,
       0,     0,     0,   837,     0,     0,     0,     0,     0,  4811,
       0,     0,     0,  2638,     0,  4119,     0,     0,  1546,  1547,
    2736,  2534,     0,  2691,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   837,     0,     0,     0,     0,  3330,
    3743,     0,     0,     0,     0,     0,     0,  3626,     0,  4120,
       0,     0,     0,     0,   885,     0,  4860,   213,  2692,     0,
       0,   704,  5117,  5118,     0,     0,   837,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1339,  1339,
       0,     0,     0,     0,     0,     0,     0,   885,  1033,  1339,
       0,  2693,     0,     0,     0,     0,     0,   708,     0,     0,
    1953,   837,     0,     0,   709,     0,     0,   710,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1549,   837,     0,
       0,     0,     0,     0,     0,     0,   711,     0,     0,     0,
    3843,     0,  1339,  1035,     0,  2535,     0,     0,  3160,   713,
    2536,     0,  1036,     0,     0,     0,   715,     0,     0,     0,
       0,     0,     0,     0,  2694,     0,     0,     0,     0,     0,
       0,  2695,  2537,  2233,     0,  1685,  1685,  1685,     0,  1339,
       0,     0,     0,     0,     0,     0,     0,  2538,     0,     0,
    1339,     0,     0,     0,     0,     0,     0,   720,     0,     0,
       0,     0,  5212,     0,     0,  5214,  5215,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1339,     0,
       0,  1339,     0,     0,     0,     0,  2283,     0,     0,  1339,
    1339,     0,     0,  5229,     0,     0,  1339,  1339,     0,     0,
    2539,  1339,     0,  2540,     0,  1339,     0,     0,  1339,  1339,
       0,     0,     0,  1339,  4987,     0,     0,     0,     0,  1339,
     837,   837,   837,   837,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   617,     0,     0,  4037,
       0,     0,     0,  3330,     0,     0,   885,  1531,  3330,     0,
       0,  3330,   617,  1532,  3626,     0,  5018,   885,     0,  1339,
    2045,   969,     0,  2046,     0,     0,     0,  2047,  2048,  2049,
    1339,     0,     0,   885,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   768,  2531,     0,  1339,     0,     0,     0,
       0,     0,  2541,     0,  2532,     0,     0,     0,  1534,     0,
       0,  2533,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3302,  3304,     0,     0,     0,     0,  3312,
    2736,     0,     0,     0,     0,     0,   885,  2534,     0,     0,
       0,     0,     0,     0,     0,     0,  5072,     0,     0,     0,
       0,   885,     0,     0,   885,   885,     0,     0,     0,     0,
       0,  3354,  3354,     0,  1535,     0,     0,     0,     0,     0,
       0,  1536,     0,     0,  1537,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   885,   885,     0,     0,     0,
       0,     0,     0,  1501,     0,     0,     0,  1339,     0,     0,
       0,  1538,  2471,     0,     0,     0,     0,     0,     0,     0,
    2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,
     759,   922,     0,  4946,     0,     0,     0,     0,  1502,     0,
       0,     0,     0,     0,     0,  1539,   922,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2535,     0,     0,     0,     0,  2536,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1339,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2537,  2233,
       0,     0,     0,   617,     0,     0,     0,     0,  1685,  1503,
    2736,  1685,     0,  2538,     0,     0,     0,     0,  1638,  1953,
       0,     0,  1541,     0,  3475,     0,     0,     0,     0,     0,
       0,     0,  1542,     0,  3743,   885,     0,     0,     0,     0,
       0,  1543,     0,     0,     0,  1504,     0,   922,     0,  3765,
       0,     0,  2283,  1544,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2539,     0,     0,  2540,
       0,     0,     0,     0,     0,   837,     0,     0,     0,     0,
       0,  1505,     0,     0,     0,     0,   837,     0,     0,     0,
       0,     0,  4176,  5504,     0,  1546,  1547,     0,     0,     0,
       0,     0,  4430,     0,     0,   759,     0,  3843,     0,     0,
       0,     0,     0,   759,     0,     0,   759,  1506,     0,     0,
       0,  1507,     0,     0,     0,     0,  4177,     0,   759,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3280,
       0,     0,  1339,     0,  5540,  1339,     0,     0,  1339,  1339,
    1339,     0,  1572,  1509,     0,     0,     0,     0,  2541,  1472,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1339,  1339,     0,     0,  1339,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1501,
       0,  1573,     0,     0,  1549,    36,     0,  1339,     0,     0,
    1511,     0,     0,  1339,     0,     0,     0,  3330,     0,  1512,
       0,  5018,     0,     0,  1339,     0,  5292,  1513,     0,     0,
       0,     0,     0,     0,  1502,  1574,     0,     0,     0,     0,
    4626,   969,   922,     0,   922,     0,     0,  1515,     0,     0,
       0,     0,     0,     0,     0,     0,  1516,     0,     0,     0,
    1517,     0,     0,     0,     0,     0,  2045,     0,  2471,  2046,
       0,     0,  5635,  2047,  2048,  2049,  2472,  2473,  2474,  2475,
    2476,  2477,  2478,  2479,  2480,     0,     0,     0,     0,  4983,
    2531,     0,   933,   969,  1109,  1503,  2045,     0,     0,  2046,
    2532,     0,     0,  2047,  2048,  2049,     0,  2533,     0,     0,
       0,     0,     0,     0,  1518,     0,     0,     0,     0,     0,
    2531,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2532,  1504,     0,  2534,     0,     0,   933,  2533,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4811,
       0,     0,     0,  1353,   837,     0,     0,     0,     0,   837,
       0,     0,     0,  2534,     0,     0,     0,  1505,  2736,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   837,     0,
       0,     0,  4860,     0,     0,  5419,   759,     0,     0,     0,
       0,     0,  2045,     0,     0,  2046,   922,   837,  4626,  2047,
    2048,  2049,     0,     0,     0,     0,     0,  1507,     0,     0,
       0,     0,     0,     0,     0,     0,  2531,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2532,  4626,     0,  1339,
       0,     0,  1353,  2533,     0,     0,     0,     0,     0,  1509,
    1339,     0,     0,     0,  1339,  1472,  1339,  2535,     0,  1353,
       0,     0,  2536,     0,     0,     0,     0,     0,     0,  2534,
       0,     0,     0,     0,     0,     0,   617,     0,     0,  1339,
       0,     0,   884,  5489,  2537,  2233,     0,  2535,     0,     0,
    1339,    36,  2536,  2719,     0,     0,  1511,  1339,     0,  2538,
       0,     0,  1685,     0,     0,  1512,     0,     0,     0,     0,
       0,     0,     0,  1513,  2537,  2233,     0,     0,     0,     0,
       0,  2720,   837,     0,  1953,  3635,     0,     0,     0,  2538,
       0,     0,     0,  1515,     0,     0,     0,     0,  2283,     0,
       0,     0,  1516,     0,     0,     0,  1517,     0,  1339,     0,
       0,     0,  2539,  1339,  1339,  2540,     0,     0,   922,   922,
     922,   922,  3667,     0,  3667,     0,  3667,  3667,  2283,     0,
       0,  3667,  3667,  3667,     0,  3667,  3667,  3667,     0,     0,
       0,     0,  2539,  2535,  4013,  2540,   759,     0,  2536,  1339,
       0,     0,     0,     0,     0,     0,   617,     0,     0,     0,
    1518,     0,  4020,     0,     0,     0,  5875,     0,     0,     0,
    2537,  2233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   837,     0,     0,  3330,  2538,     0,     0,     0,     0,
    3745,     0,     0,     0,     0,     0,     0,  3375,     0,     0,
       0,  2638,  3381,     0,  2541,     0,     0,     0,  4066,  4066,
     837,     0,     0,     0,     0,  3773,     0,     0,     0,     0,
       0,     0,     0,     0,  2283,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2541,     0,     0,     0,  2539,     0,
       0,  2540,     0,  1339,     0,     0,     0,     0,     0,  1339,
       0,     0,     0,  1953,     0,     0,     0,  3626,   885,     0,
    1339,     0,     0,     0,   885,     0,     0,     0,     0,  1339,
       0,  1339,     0,  1339,  5292,     0,     0,     0,     0,     0,
       0,     0,   969,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1339,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2471,   885,     0,     0,     0,     0,
       0,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,     0,     0,     0,     0,  5233,     0,  1953,  1953,     0,
    2541,     0,     0,     0,  2471,     0,     0,     0,     0,     0,
       0,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,     0,     0,     0,     0,  5244,     0,     0,   922,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5736,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4626,  2045,     0,     0,  2046,     0,
       0,     0,  2047,  2048,  2049,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2531,
       0,     0,     0,     0,     0,     0,  1339,  1339,  1339,  2532,
       0,     0,     0,     0,  1339,     0,  2533,     0,  5489,     0,
    2471,     0,     0,     0,  1339,     0,     0,     0,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,     0,     0,
       0,  5252,  2534,   933,     0,     0,     0,  2045,     0,     0,
    2046,     0,     0,     0,  2047,  2048,  2049,     0,   922,     0,
       0,     0,     0,  1685,     0,  1953,     0,     0,     0,     0,
       0,  2531,     0,     0,     0,     0,     0,     0,     0,     0,
    1109,  2532,     0,     0,     0,     0,     0,     0,  2533,     0,
    2736,     0,     0,     0,     0,   885,     0,  1339,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4626,     0,     0,
       0,     0,     0,     0,  2534,     0,   933,   933,  5850,     0,
       0,     0,  1339,     0,     0,     0,  3843,  1339,     0,     0,
       0,     0,     0,     0,     0,     0,  1953,  1953,  5866,     0,
       0,     0,     0,  1339,  1339,     0,     0,     0,     0,  5872,
       0,   759,     0,     0,     0,     0,  2535,     0,     0,     0,
       0,  2536,     0,     0,     0,     0,   922,     0,     0,  2638,
       0,     0,     0,  2638,  4330,     0,     0,     0,     0,     0,
       0,     0,     0,  2537,  2233,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5736,   922,   922,     0,  2538,     0,
    4626,   625,     0,     0,  3943,     0,     0,   674,   625,  3944,
       0,     0,     0,   726,     0,   625,     0,   617,     0,     0,
       0,   625,     0,     0,   781,     0,     0,  1109,  2535,     0,
       0,     0,     0,  2536,     0,     0,     0,  2283,  1339,     0,
       0,  1339,     0,   848,   848,     0,  1339,     0,     0,     0,
       0,  2539,     0,     0,  2540,  2537,  2233,   686,     0,     0,
       0,     0,  1022,     0,     0,     0,     0,     0,     0,     0,
    2538,     0,   884,     0,   885,     0,     0,     0,  1339,     0,
       0,     0,     0,  5945,  5946,   617,  5949,  5489,     0,   885,
       0,     0,     0,     0,   885,     0,   922,     0,   884,  4626,
    1023,     0,     0,     0,     0,  4167,     0,     0,     0,  2283,
       0,     0,     0,   689,  1024,     0,     0,     0,     0,     0,
       0,     0,     0,  2539,     0,  1025,  2540,     0,     0,   690,
       0,     0,     0,     0,  1339,   617,     0,     0,     0,   617,
       0,   759,     0,  2541,     0,     0,     0,  1026,   933,   933,
       0,     0,  5992,     0,     0,     0,     0,     0,     0,  4206,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1027,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   693,     0,     0,     0,     0,     0,     0,     0,
       0,   694,     0,   924,     0,     0,     0,   928,     0,     0,
       0,     0,     0,     0,   695,   971,     0,     0,   973,  1028,
       0,   978,   979,     0,   982,  3945,   985,     0,     0,   991,
       0,   993,     0,     0,     0,     0,  1501,  4249,     0,     0,
       0,     0,     0,     0,     0,  1029,     0,     0,     0,     0,
       0,     0,     0,  2471,     0,     0,     0,   884,     0,     0,
       0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,
    1030,  1502,     0,     0,  5255,     0,     0,     0,     0,     0,
       0,     0,     0,  3667,     0,  2045,     0,     0,  2046,     0,
       0,   699,  2047,  2048,  2049,  4280,  4280,     0,     0,     0,
       0,     0,     0,     0,     0,  4296,     0,     0,     0,  2531,
    1109,     0,  1109,     0,     0,     0,     0,     0,     0,  2532,
    2045,     0,     0,  2046,     0,  2471,  2533,  2047,  2048,  2049,
       0,  1031,  1503,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,     0,  2638,  2531,     0,  3381,     0,  3381,     0,
       0,     0,  2534,  2638,  2532,   702,     0,     0,     0,  4350,
       0,  2533,     0,     0,     0,   213,  1032,     0,  1504,   704,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2534,     0,     0,
       0,     0,     0,     0,  4386,  1109,  1033,     0,     0,  1034,
     885,     0,     0,   707,  1505,   708,     0,     0,   885,     0,
       0,     0,   709,     0,     0,   710,     0,   884,     0,     0,
       0,     0,  2045,     0,     0,  2046,     0,     0,   884,  2047,
    2048,  2049,     0,  2638,   711,     0,   759,     0,     0,     0,
    1506,  1035,     0,   884,  1507,     0,  2531,   713,     0,     0,
    1036,     0,     0,     0,   715,     0,  2532,     0,     0,     0,
       0,   759,  1037,  2533,   717,     0,  2535,     0,   759,  1038,
       0,  2536,     0,     0,     0,  1589,  1509,     0,     0,   759,
       0,     0,  1472,     0,     0,     0,     0,     0,     0,  2534,
       0,     0,     0,  2537,  2233,   720,     0,     0,     0,     0,
       0,  2535,   885,     0,   885,     0,  2536,     0,  2538,     0,
       0,     0,     0,     0,  1590,     0,     0,     0,    36,     0,
       0,     0,     0,  1511,     0,     0,     0,     0,  2537,  2233,
       0,     0,  1512,     0,     0,     0,     0,     0,     0,     0,
    1513,     0,     0,  2538,     0,     0,     0,  2283,  1591,     0,
       0,     0,     0,     0,     0,  1190,  1191,     0,     0,     0,
    1515,  2539,     0,     0,  2540,     0,     0,     0,     0,  1516,
       0,     0,     0,  1517,     0,     0,     0,  4529,     0,     0,
       0,     0,  2283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   885,  2539,     0,     0,  2540,
       0,     0,     0,  2535,     0,   884,     0,     0,  2536,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1685,     0,     0,     0,     0,  1518,  1685,     0,
    2537,  2233,     0,  1020,     0,     0,     0,   885,     0,     0,
       0,     0,   759,     0,  1056,  2538,     0,     0,  1060,     0,
       0,     0,     0,  2541,     0,  1073,  1074,     0,     0,  1080,
       0,  1083,  1084,     0,     0,  3381,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1106,     0,     0,     0,
       0,     0,     0,     0,  2283,     0,     0,     0,  2541,     0,
       0,     0,     0,     0,  1119,     0,     0,     0,  2539,     0,
       0,  2540,     0,     0,     0,     0,     0,     0,     0,     0,
     759,     0,     0,     0,     0,  1147,     0,  1149,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1165,     0,     0,
       0,     0,     0,     0,   885,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2510,     0,     0,
       0,     0,     0,  2471,     0,     0,  3381,     0,     0,     0,
     625,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,
       0,     0,     0,     0,  5299,     0,     0,     0,   885,     0,
    4296,     0,     0,     0,     0,     0,     0,     0,  2471,     0,
    2541,     0,     0,     0,     0,     0,  2472,  2473,  2474,  2475,
    2476,  2477,  2478,  2479,  2480,  4718,     0,     0,     0,  5332,
       0,     0,     0,  4727,     0,     0,  4728,     0,  4729,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   934,   944,     0,     0,     0,     0,     0,     0,
     934,     0,   944,   934,     0,     0,     0,   884,   848,     0,
       0,     0,     0,     0,     0,     0,   944,     0,     0,     0,
       0,     0,     0,     0,  4769,     0,     0,     0,     0,   885,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3667,     0,     0,     0,     0,  3667,     0,     0,     0,     0,
    2471,     0,   885,     0,     0,     0,     0,     0,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,     0,     0,
       0,  5372,     0,     0,   884,     0,     0,   885,     0,     0,
       0,     0,     0,     0,     0,   759,     0,     0,     0,     0,
    1492,   759,     0,     0,     0,   759,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2045,     0,     0,  2046,     0,   884,     0,  2047,  2048,  2049,
       0,     0,  5087,  5088,     0,     0,     0,  5091,  5092,     0,
       0,     0,     0,     0,  2531,     0,     0,     0,     0,     0,
       0,     0,     0,  4874,  2532,     0,  4296,     0,   884,     0,
       0,  2533,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1669,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2534,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1789,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1801,     0,  1802,     0,     0,     0,     0,
    2638,     0,     0,     0,  1805,     0,     0,     0,     0,     0,
       0,  1815,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4933,  4933,  4933,  4933,     0,  4933,  4933,  4933,
    4933,  4933,  2045,     0,     0,  2046,     0,     0,     0,  2047,
    2048,  2049,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1866,     0,  1868,  2531,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2532,     0,     0,     0,
       0,     0,     0,  2533,     0,     0,     0,     0,     0,     0,
       0,  2535,     0,     0,     0,     0,  2536,     0,     0,     0,
    3381,     0,     0,     0,     0,     0,     0,     0,     0,  2534,
       0,     0,     0,     0,     0,     0,     0,     0,  2537,  2233,
       0,     0,     0,     0,     0,  3381,     0,     0,     0,     0,
       0,     0,  4995,  2538,  4997,     0,     0,   884,     0,     0,
       0,   625,     0,   625,     0,   625,     0,   625,   884,   625,
     625,   625,     0,     0,     0,     0,   625,     0,     0,     0,
       0,     0,     0,     0,   884,     0,     0,  1973,     0,     0,
       0,     0,  2283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1985,  2539,     0,     0,  2540,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   944,     0,   884,     0,     0,
       0,     0,     0,  2535,     0,     0,     0,     0,  2536,     0,
       0,     0,   884,     0,   944,   884,   884,     0,     0,     0,
     944,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2537,  2233,   944,     0,     0,     0,     0,     0,     0,     0,
     885,     0,     0,     0,     0,  2538,   884,   884,   944,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2541,     0,
       0,     0,   934,   944,     0,     0,     0,     0,     0,   934,
       0,   944,   934,     0,     0,     0,     0,     0,     0,     0,
       0,   759,     0,     0,  2283,   944,  3381,     0,     0,     0,
       0,  2638,     0,     0,     0,   944,     0,     0,  2539,     0,
       0,  2540,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5114,  5115,     0,     0,     0,     0,     0,
       0,     0,   848,     0,     0,     0,  3667,     0,  3667,  3667,
    3667,  -135,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     0,     0,     0,   944,     0,     0,  2471,     0,
       0,     2,     0,     3,     4,     0,  2472,  2473,  2474,  2475,
    2476,  2477,  2478,  2479,  2480,     0,   884,     0,     0,  5686,
       0,     5,     0,     0,   944,     0,     0,     0,     0,     0,
    2541,     6,     0,     0,  5167,     0,     0,     0,     0,     0,
       0,     0,     0,     7,     0,     8,     9,     0,   944,     0,
       0,     0,    10,     0,    11,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    12,     0,    13,     0,
       0,     0,     0,  5195,     0,     0,   885,     0,     0,     0,
       0,  2698,     0,     0,     0,    14,     0,     0,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,    17,     0,     0,   944,    18,
       0,     0,     0,     0,     0,    19,     0,     0,     0,     0,
       0,     0,     0,    20,     0,    21,  4933,     0,     0,     0,
    2471,     0,    22,     0,     0,     0,     0,     0,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,     0,    23,
       0,  5708,     0,  2789,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    24,     0,     0,  2045,
       0,     0,  2046,     0,     0,     0,  2047,  2048,  2049,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   885,     0,
       0,     0,     0,  2531,     0,     0,     0,     0,     0,   759,
       0,     0,     0,  2532,     0,     0,    25,    26,     0,     0,
    2533,     0,    27,     0,     0,     0,     0,  1771,     0,     0,
       0,     0,     0,   944,    28,     0,   885,     0,     0,     0,
       0,     0,     0,     0,   934,     0,  2534,     0,   934,     0,
     934,     0,    29,     0,     0,     0,     0,     0,   885,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4296,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    30,     0,
       0,     0,     0,     0,     0,     0,    31,  2045,     0,     0,
    2046,     0,     0,     0,  2047,  2048,  2049,     0,     0,     0,
      32,     0,     0,     0,     0,     0,    33,    34,     0,    35,
    3667,  2531,     0,     0,    36,   885,     0,     0,     0,  5367,
      37,  2532,     0,    38,     0,     0,     0,     0,  2533,     0,
      39,     0,     0,     0,     0,     0,    40,    41,     0,     0,
       0,     0,     0,     0,    42,   944,     0,     0,    43,     0,
    2535,     0,     0,     0,  2534,  2536,     0,     0,    44,     0,
       0,     0,     0,     0,     0,     0,  2911,     0,     0,     0,
       0,     0,     0,    45,     0,     0,     0,  2537,  2233,  5692,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2538,    46,     0,     0,     0,     0,     0,     0,
       0,  2947,     0,     0,    47,     0,     0,   944,     0,     0,
      48,     0,     0,     0,     0,    49,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,     0,     0,    50,     0,
       0,  2283,     0,     0,  5199,     0,   885,   944,     0,     0,
       0,   944,     0,     0,  3009,  2539,  3013,     0,  2540,     0,
       0,    51,    52,    53,    54,    55,    56,     0,   686,     0,
       0,     0,     0,   687,     0,     0,  3031,     0,  2535,    57,
       0,     0,  -135,  2536,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3051,     0,  3052,  2537,  2233,   943,     0,     0,
       0,   688,     0,     0,     0,     0,   943,     0,     0,  3061,
    2538,  3062,     0,     0,   689,     0,     0,     0,     0,   625,
     943,   625,     0,   625,     0,   625,     0,   625,     0,     0,
     690,   625,     0,     0,     0,     0,     0,  2541,     0,     0,
       0,     0,     0,  1109,     0,     0,     0,  5549,   691,  2283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     944,     0,     0,  2539,     0,     0,  2540,   885,   944,   944,
       0,     0,   692,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   693,     0,     0,     0,     0,     0,     0,
       0,     0,   694,     0,     0,     0,     0,     0,   884,     0,
       0,     0,   884,   884,     0,   695,     0,     0,     0,     0,
     696,     0,     0,     0,     0,     0,     0,   697,     0,     0,
       0,  1771,     0,     0,     0,  3381,     0,     0,     0,     0,
       0,     0,     0,     0,   875,     0,   698,  2471,     0,     0,
       0,     0,     0,     0,     0,  2472,  2473,  2474,  2475,  2476,
    2477,  2478,  2479,  2480,     0,  2541,     0,     0,  5892,   884,
       0,  2045,     0,     0,  2046,   884,     0,     0,  2047,  2048,
    2049,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   699,     0,     0,  2531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2532,     0,     0,     0,     0,
       0,     0,  2533,     0,     0,     0,   884,  2045,     0,     0,
    2046,     0,     0,     0,  2047,  2048,  2049,     0,     0,     0,
       0,     0,   700,     0,     0,     0,     0,     0,  2534,     0,
       0,  2531,     0,  1109,     0,   701,     0,  5698,     0,  5699,
       0,  2532,     0,  5704,  5705,  3381,   702,     0,  2533,     0,
       0,     0,     0,     0,     0,  2471,   213,   703,     0,     0,
     704,     0,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,     0,     0,  2534,     0,  5910,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5966,   705,     0,     0,
     706,     0,     0,     0,   707,     0,   708,     0,     0,     0,
       0,     0,     0,   709,     0,     0,   710,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5966,     0,   711,     0,     0,     0,     0,
       0,     0,   712,  5966,     0,     0,     0,     0,   713,     0,
       0,   714,  2535,     0,     0,   715,     0,  2536,     0,     0,
       0,     0,     0,   716,     0,   717,     0,     0,     0,     0,
     718,     0,     0,     0,     0,     0,     0,   944,     0,  2537,
    2233,     0,   885,   719,     0,     0,     0,   885,   885,     0,
       0,     0,     0,     0,  2538,     0,   720,     0,  2535,     0,
       0,     0,     0,  2536,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,  2537,  2233,     0,     0,   943,
       0,     0,     0,  2283,     0,     0,     0,     0,     0,     0,
    2538,     0,     0,     0,     0,     0,     0,  2539,   943,     0,
    2540,     0,     0,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   943,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2283,
       0,     0,   943,     0,     0,     0,     0,     0,     0,     0,
     884,   944,     0,  2539,   884,     0,  2540,   943,  5199,   885,
       0,     0,     0,     0,     0,   943,  1109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
       0,     0,     0,     0,     0,     0,  1771,     0,     0,   943,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2541,
       0,     0,     0,     0,     0,     0,     0,     0,   885,   944,
       0,     0,     0,     0,     0,     0,     0,   944,     0,     0,
       0,     0,     0,     0,     0,   944,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2541,     0,     0,     0,   943,
       0,     0,     0,     0,     0,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   934,   934,     0,   944,   944,
     884,     0,     0,     0,     0,   884,     0,     0,   943,     0,
     934,     0,   944,   934,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   944,   944,     0,     0,  2471,
    5967,     0,   943,     0,     0,     0,  2494,  2472,  2473,  2474,
    2475,  2476,  2477,  2478,  2479,  2480,     0,     0,     0,     0,
    5951,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   934,     0,  5967,   934,   934,
       0,     0,     0,     0,     0,  2471,     0,  5967,     0,     0,
    4995,     0,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,   943,     0,     0,     0,  5952,     0,     0,     0,
       0,     0,     0,     0,     0,  3371,  3372,     0,     0,     0,
       0,     0,     0,     0,  2045,     0,     0,  2046,     0,     0,
       0,  2047,  2048,  2049,  3387,  3388,     0,  3390,  3391,     0,
       0,  3393,  3394,     0,     0,     0,     0,     0,  2531,     0,
       0,     0,  3337,     0,     0,     0,  3405,     0,  2532,     0,
       0,     0,     0,  3414,     0,  2533,     0,  3417,  3418,     0,
       0,  3421,  3422,     0,     0,     0,     0,     0,  3427,     0,
       0,     0,  1771,     0,   875,     0,     0,     0,     0,     0,
    3442,  2534,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3459,     0,     0,     0,     0,  3461,     0,     0,
     875,  1770,     0,     0,     0,     0,     0,   943,     0,     0,
       0,     0,  3467,     0,     0,     0,     0,     0,     0,     0,
       0,  3474,     0,     0,  3478,     0,  3480,  3483,  3485,     0,
       0,     0,  3338,  3493,  3496,     0,     0,     0,     0,     0,
       0,     0,     0,  3509,   884,     0,     0,   884,  3518,   884,
       0,     0,  3521,  2045,   884,     0,  2046,     0,     0,     0,
    2047,  2048,  2049,     0,  3531,  3532,     0,     0,     0,  3537,
       0,     0,     0,     0,     0,  3546,  3547,  2531,     0,     0,
       0,     0,  3552,     0,     0,  3554,     0,  2532,     0,     0,
       0,     0,  3566,  3567,  2533,  2535,     0,     0,  3571,     0,
    2536,   884,     0,     0,     0,     0,     0,     0,     0,   884,
    3578,     0,     0,  3581,     0,     0,     0,     0,  3584,     0,
    2534,     0,  2537,  2233,  3587,  3588,     0,     0,     0,   943,
       0,     0,  3594,     0,   884,  3596,     0,  2538,     0,  3603,
    3604,  3605,  3606,     0,  3608,     0,     0,     0,     0,   875,
       0,     0,     0,     0,     0,     0,     0,  3633,  3634,     0,
    3636,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3645,  3646,  3647,     0,     0,  2283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2539,   943,     0,  2540,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   884,     0,   884,     0,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1685,     0,
       0,   943,     0,     0,     0,   943,     0,     0,  3699,     0,
       0,     0,     0,     0,  2535,     0,  3723,     0,     0,  2536,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3736,     0,     0,     0,
     877,  2537,  2233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2538,     0,     0,     0,
    2045,     0,  2541,  2046,     0,     0,     0,  2047,  2048,  2049,
       0,     0,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,  2531,     0,  3804,     0,     0,   875,
       0,     0,     0,     0,  2532,  2283,     0,     0,     0,     0,
     875,  2533,     0,     0,     0,  3818,     0,  3820,     0,  2539,
       0,     0,  2540,     0,     0,   875,     0,     0,   884,     0,
       0,     0,  3339,     0,   943,     0,     0,  2534,     0,     0,
       0,     0,   943,   943,     0,     0,     0,  4520,     0,     0,
       0,     0,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2045,     0,     0,
    2046,     0,  2471,     0,  2047,  2048,  2049,     0,     0,     0,
    2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,
       0,  2531,     0,     0,  3900,  1770,     0,     0,     0,     0,
       0,  2532,     0,     0,     0,     0,     0,     0,  2533,     0,
    3891,  2541,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   884,  5858,     0,  4521,     0,
       0,     0,     0,     0,  2534,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,     0,     0,
       0,  2535,     0,     0,     0,     0,  2536,     0,     0,     0,
       0,     0,     0,     0,  1771,     0,     0,     0,     0,   884,
       0,     0,     0,     0,     0,     0,     0,     0,  2537,  2233,
       0,     0,     0,     0,     0,     0,     0,   875,     0,     0,
       0,     0,     0,  2538,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2471,     0,     0,     0,     0,     0,   944,     0,  2472,
    2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,     0,
       0,     0,  2283,     0,     0,   944,     0,     0,     0,   944,
       0,     0,     0,   944,     0,     0,  2539,     0,  2535,  2540,
       0,   944,     0,  2536,     0,     0,     0,     0,     0,     0,
     884,     0,     0,     0,     0,     0,     0,     0,     0,   944,
       0,     0,  5859,     0,     0,  2537,  2233,     0,     0,     0,
       0,     0,     0,   884,     0,     0,   934,     0,   934,   934,
    2538,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,     0,     0,   884,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,   944,     0,     0,     0,     0,  2283,
       0,     0,     0,     0,     0,     0,     0,     0,  2541,     0,
       0,   943,     0,  2539,     0,     0,  2540,     0,     0,     0,
       0,     0,     0,     0,  1771,   944,     0,     0,  1771,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4092,
       0,   944,     0,  1771,     0,     0,     0,   944,     0,     0,
       0,     0,     0,     0,   944,     0,     0,     0,     0,  4104,
       0,   944,     0,     0,   944,     0,     0,     0,     0,     0,
     944,     0,     0,     0,     0,     0,  4111,     0,     0,     0,
    4111,     0,     0,     0,     0,  4122,  4123,  4124,     0,   875,
     944,     0,     0,     0,     0,  2541,   944,     0,  2471,     0,
       0,   884,     0,   944,     0,     0,  2472,  2473,  2474,  2475,
    2476,  2477,  2478,  2479,  2480,   943,   944,     0,     0,     0,
       0,  4154,  4155,  4156,  4157,     0,     0,     0,     0,   944,
       0,     0,     0,     0,  1771,     0,     0,     0,     0,     0,
     944,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1770,     0,     0,     0,     0,     0,   875,     0,  4175,     0,
    4179,  4180,  4181,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   943,     0,     0,     0,     0,     0,     0,
       0,   943,     0,     0,     0,     0,     0,     0,     0,   943,
       0,   884,     0,     0,     0,  2471,     0,   875,     0,     0,
    1771,     0,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,     0,     0,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     875,  2045,   943,   943,  2046,     0,     0,     0,  2047,  2048,
    2049,     0,     0,     0,     0,     0,   943,     0,     0,     0,
     877,     0,     0,     0,     0,  2531,     0,     0,     0,   943,
     943,     0,     0,     0,     0,  2532,     0,     0,     0,     0,
       0,     0,  2533,  4257,     0,     0,   877,     0,     0,     0,
       0,     0,  4263,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2534,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4273,  4274,
       0,     0,     0,  4275,     0,     0,     0,     0,     0,  1531,
       0,     0,     0,     0,     0,  1532,     0,     0,     0,     0,
       0,     0,  1598,     0,     0,  4317,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   884,     0,     0,  1599,   944,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1534,     0,     0,   944,     0,     0,     0,     0,     0,     0,
     944,     0,     0,     0,     0,     0,     0,   934,  4353,   934,
     934,     0,     0,  4359,     0,     0,     0,   884,     0,  4365,
       0,     0,   884,     0,     0,  1600,  1770,     0,     0,     0,
       0,     0,  2535,     0,     0,     0,     0,  2536,     0,   875,
       0,     0,     0,     0,     0,   877,  1535,     0,     0,  4404,
     875,     0,     0,  1536,     0,     0,  1537,     0,     0,  2537,
    2233,     0,     0,     0,     0,     0,   875,     0,     0,     0,
       0,  1771,     0,     0,  2538,     0,     0,  1771,  4419,     0,
    4420,     0,     0,  1538,  2045,     0,     0,  2046,     0,     0,
       0,  2047,  2048,  2049,     0,     0,     0,     0,     0,     0,
       0,   878,     0,     0,     0,     0,     0,     0,  2531,     0,
       0,  3948,     0,  2283,  1601,     0,     0,  1539,  2532,   875,
       0,     0,     0,     0,     0,  2533,     0,  2539,     0,  4458,
    2540,     0,     0,     0,   875,     0,     0,   875,   875,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3916,
       0,  2534,     0,     0,     0,     0,     0,   944,     0,     0,
       0,     0,  1602,  2045,     0,  1603,  2046,   884,   875,   875,
    2047,  2048,  2049,     0,     0,     0,     0,     0,     0,     0,
    1604,     0,     0,     0,  1541,     0,     0,  2531,     0,     0,
       0,     0,     0,     0,  1542,     0,     0,  2532,     0,     0,
       0,     0,     0,  1543,  2533,   877,     0,     0,     0,     0,
       0,     0,     0,     0,  1605,  1544,   877,     0,     0,  2541,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2534,   877,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   880,     0,     0,
       0,     0,     0,     0,  1606,     0,     0,  1546,  1547,  1607,
       0,     0,     0,     0,     0,  2535,     0,     0,     0,     0,
    2536,     0,     0,     0,   944,   944,     0,     0,     0,   884,
       0,     0,  1608,     0,     0,     0,     0,     0,  1609,     0,
       0,     0,  2537,  2233,     0,     0,     0,     0,   875,     0,
       0,   944,  1610,     0,   944,     0,     0,  2538,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   884,     0,  2471,
       0,     0,     0,     0,     0,  3953,     0,  2472,  2473,  2474,
    2475,  2476,  2477,  2478,  2479,  2480,     0,     0,     0,   884,
       0,     0,     0,     0,  2535,     0,  2283,   881,     0,  2536,
    4630,     0,     0,  4637,     0,  4638,  1549,     0,     0,     0,
    2539,     0,     0,  2540,     0,     0,     0,     0,  4645,     0,
       0,  2537,  2233,     0,     0,     0,  1771,  1771,  1771,     0,
    4651,     0,     0,     0,  4654,     0,  2538,     0,     0,     0,
       0,     0,     0,   877,     0,     0,     0,     0,     0,     0,
     944,     0,     0,  4678,     0,     0,   884,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   944,
       0,  4682,     0,     0,     0,  2283,  4686,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   944,  2539,
       0,     0,  2540,     0,     0,     0,     0,     0,     0,     0,
       0,  4721,  2541,     0,     0,  4725,     0,     0,     0,     0,
       0,     0,     0,  4730,  4731,  4732,  4733,     0,     0,     0,
       0,     0,     0,  4737,  4738,  4739,  4740,     0,     0,     0,
       0,     0,  4742,  4743,     0,     0,     0,     0,  4750,  4751,
       0,  4753,  4754,  4755,  4756,  4757,  4758,  4759,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4768,     0,     0,
       0,  4771,  4772,  4773,  4774,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   944,     0,     0,   884,  1770,     0,
       0,  2541,     0,     0,     0,  4111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2471,  4794,     0,     0,     0,     0,     0,     0,
    2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,
       0,  1771,     0,     0,     0,     0,     0,   944,     0,   944,
       0,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   944,     0,   944,     0,     0,     0,     0,   943,
       0,     0,     0,   943,     0,     0,     0,   943,     0,     0,
       0,     0,     0,     0,     0,   943,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4875,     0,
       0,  2471,     0,   943,     0,   877,     0,     0,     0,  2472,
    2473,  2474,  2475,  2476,  2477,  2478,  2479,  2480,     0,     0,
       0,     0,     0,     0,     0,     0,  2045,     0,   884,  2046,
       0,  4111,   944,  2047,  2048,  2049,     0,   943,  4900,     0,
    4901,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2531,     0,     0,  3959,     0,     0,     0,   943,   943,     0,
    2532,     0,     0,     0,     0,     0,     0,  2533,     0,     0,
       0,     0,   877,     0,   944,  4926,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   884,     0,  1770,   943,
       0,     0,  1770,  2534,     0,     0,     0,     0,     0,     0,
       0,   944,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   878,     0,   877,     0,   943,     0,  1770,     0,     0,
       0,   943,     0,   944,     0,     0,   944,     0,   943,     0,
       0,   883,     0,     0,     0,   943,     0,   878,   943,     0,
       0,     0,     0,     0,   943,     0,   877,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,     0,     0,     0,     0,     0,
     943,     0,     0,     0,     0,     0,     0,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     943,  2045,     0,     0,  2046,     0,     0,     0,  2047,  2048,
    2049,     0,     0,   943,     0,  1771,   884,  2535,  1770,     0,
       0,     0,  2536,     0,   943,  2531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2532,     0,     0,     0,     0,
       0,     0,  2533,     0,  2537,  2233,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2538,
     875,     0,     0,     0,   875,   875,     0,   880,  2534,     0,
       0,     0,     0,  5052,  5053,  5054,     0,     0,     0,  5055,
    5056,  5057,  5058,     0,  1770,     0,  5060,     0,     0,     0,
       0,     0,     0,   880,     0,     0,   878,     0,  2283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2539,     0,     0,  2540,     0,     0,     0,     0,
       0,   875,  5079,  5080,  5081,  5082,  5083,   875,  5085,  5086,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5095,  5096,     0,   884,     0,   877,     0,     0,   884,   884,
       0,     0,     0,     0,     0,     0,   877,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   881,   875,  5101,
     944,     0,   877,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2535,     0,     0,     0,     0,  2536,     0,     0,
       0,     0,     0,   881,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2541,     0,     0,     0,     0,  2537,
    2233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1771,     0,     0,  2538,   877,  1771,     0,  1771,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   943,
     877,     0,   880,   877,   877,     0,     0,     0,     0,     0,
       0,  1771,     0,     0,     0,     0,   878,   943,     0,     0,
     884,     0,     0,  2283,   943,     0,     0,   878,     0,     0,
       0,  5165,     0,     0,   877,   877,     0,  2539,     0,     0,
    2540,     0,   878,     0,     0,     0,     0,     0,     0,     0,
     944,     0,     0,   944,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2471,     0,     0,     0,     0,   884,
       0,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1770,  5216,     0,     0,     0,
       0,  1770,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   875,  2541,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   944,   944,     0,     0,     0,     0,     0,
       0,     0,     0,   944,     0,     0,     0,     0,     0,     0,
       0,  4474,   880,     0,   877,  1531,     0,     0,     0,     0,
     944,  1532,     0,   880,     0,     0,     0,     0,  1598,     0,
       0,   943,     0,     0,     0,     0,     0,     0,   880,     0,
    2045,     0,     0,  2046,     0,     0,     0,  2047,  2048,  2049,
    1599,     0,   875,     0,   878,     0,   875,     0,     0,     0,
       0,     0,     0,     0,  2531,     0,  1534,  4527,   625,     0,
       0,     0,     0,     0,  2532,     0,     0,     0,     0,  2471,
       0,  2533,     0,     0,     0,     0,     0,  2472,  2473,  2474,
    2475,  2476,  2477,  2478,  2479,  2480,     0,     0,     0,     0,
       0,  1600,     0,     0,     0,     0,     0,  2534,     0,     0,
       0,     0,   881,     0,   944,     0,     0,     0,     0,     0,
       0,  5321,  1535,   881,     0,     0,     0,     0,     0,  1536,
       0,     0,  1537,     0,     0,     0,     0,     0,   881,     0,
    5331,     0,     0,     0,     0,  5336,  5337,     0,   943,   943,
       0,     0,     0,     0,     0,  5348,     0,   875,     0,  1538,
       0,     0,  5350,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   875,     0,     0,   943,     0,   875,   943,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1601,   883,     0,  1539,     0,     0,     0,     0,  5401,  5402,
     880,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5410,     0,  5412,     0,     0,     0,   883,     0,     0,
       0,  2535,     0,     0,     0,     0,  2536,     0,  5426,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1602,     0,
       0,  1603,     0,     0,     0,     0,     0,     0,  2537,  2233,
    1770,  1770,  1770,  4111,     0,     0,  1604,     0,     0,     0,
    1541,     0,     0,  2538,     0,     0,     0,     0,     0,     0,
    1542,  5466,     0,     0,   943,     0,     0,     0,     0,  1543,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1605,  1544,     0,   943,     0,     0,   878,     0,     0,     0,
     881,     0,  2283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   943,     0,     0,     0,  2539,     0,   944,  2540,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3572,     0,     0,  1546,  1547,  1607,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5514,     0,     0,  1608,     0,
     944,     0,     0,   878,  3573,  5521,   883,     0,     0,     0,
       0,     0,   944,     0,     0,     0,     0,     0,  1610,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   943,     0,
       0,   944,     0,     0,   878,     0,     0,     0,  2541,     0,
       0,     0,     0,     0,     0,     0,   875,     0,     0,   875,
       0,   875,     0,     0,     0,     0,   875,     0,     0,     0,
    5580,     0,  1549,     0,     0,     0,     0,   878,     0,     0,
       0,     0,   880,     0,     0,  1770,     0,     0,     0,     0,
       0,   943,     0,   943,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   943,     0,   943,     0,
       0,     0,     0,   875,     0,     0,     0,     0,     0,  1771,
       0,   875,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   944,     0,
       0,  4111,     0,     0,     0,  5630,   875,     0,  2471,   880,
       0,     0,     0,     0,     0,     0,  2472,  2473,  2474,  2475,
    2476,  2477,  2478,  2479,  2480,     0,   883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   943,   883,     0,     0,
       0,     0,   881,     0,     0,     0,     0,     0,     0,     0,
     880,     0,   883,     0,     0,     0,  2045,     0,  5674,  2046,
       0,     0,     0,  2047,  2048,  2049,     0,     0,     0,     0,
       0,     0,  5687,     0,     0,   875,     0,   875,   943,     0,
    2531,     0,     0,   880,     0,     0,     0,     0,     0,     0,
    2532,     0,     0,     0,     0,   944,   877,  2533,     0,     0,
     877,   877,     0,     0,     0,   943,     0,     0,     0,   881,
       0,     0,     0,     0,     0,  5715,     0,     0,     0,     0,
       0,     0,     0,  2534,     0,     0,   878,   943,     0,     0,
     943,  5726,     0,     0,     0,     0,     0,   878,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     881,     0,     0,   878,     0,     0,     0,   877,     0,     0,
       0,     0,     0,   877,     0,     0,     0,     0,   875,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   881,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   944,     0,   944,     0,     0,
       0,     0,     0,     0,   877,     0,   878,     0,     0,  1770,
     875,     0,     0,     0,   883,     0,     0,     0,  4947,     0,
    5799,   878,     0,     0,   878,   878,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2535,   875,     0,
       0,     0,  2536,   944,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   934,     0,   878,   878,     0,     0,     0,
       0,     0,     0,  5820,  2537,  2233,     0,     0,     0,     0,
       0,     0,   880,     0,     0,     0,     0,     0,     0,  2538,
       0,     0,     0,   880,     0,     0,     0,  2045,     0,     0,
    2046,     0,  1771,     0,  2047,  2048,  2049,   934,     0,   880,
       0,     0,     0,     0,     0,     0,     0,   875,     0,     0,
       0,  2531,     0,     0,     0,     0,     0,     0,  2283,     0,
       0,  2532,     0,     0,     0,     0,     0,     0,  2533,   875,
       0,     0,  2539,     0,     0,  2540,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   875,   880,     0,  2534,     0,     0,     0,     0,     0,
       0,     0,  5886,     0,   943,     0,     0,   880,     0,     0,
     880,   880,   881,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   881,     0,   878,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   881,
       0,   880,   880,     0,   877,     0,     0,     0,     0,     0,
    2045,     0,     0,  2046,     0,  1770,     0,  2047,  2048,  2049,
    1770,     0,  1770,     0,  2541,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2531,     0,     0,     0,     0,     0,
       0,     0,   875,     0,  2532,  1770,     0,     0,     0,  4953,
       0,  2533,   881,     0,     0,     0,   883,     0,     0,     0,
       0,     0,     0,     0,     0,   875,     0,   881,  2535,     0,
     881,   881,     0,  2536,     0,     0,     0,  2534,   877,     0,
       0,     0,   877,     0,   943,     0,     0,   943,     0,     0,
     875,     0,     0,     0,     0,  2537,  2233,     0,     0,     0,
       0,   881,   881,     0,     0,     0,   944,     0,     0,     0,
    2538,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     944,     0,     0,   883,  2471,     0,     0,     0,     0,     0,
       0,   880,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,     0,     0,     0,     0,     0,     0,     0,     0,  2283,
    1771,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2539,   883,     0,  2540,  4954,     0,   947,
       0,     0,     0,     0,     0,     0,     0,   943,   943,     0,
       0,   981,     0,   877,     0,     0,     0,   943,     0,     0,
       0,  2535,  1000,     0,     0,     0,  2536,   883,   877,     0,
       0,     0,     0,   877,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2537,  2233,
       0,     0,     0,   875,     0,     0,     0,     0,     0,     0,
       0,   881,     0,  2538,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2045,  1771,     0,  2046,  2541,     0,     0,  2047,  2048,
    2049,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2283,     0,     0,  2531,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2532,  2539,     0,     0,  2540,
       0,     0,  2533,     0,     0,     0,     0,     0,   943,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1771,     0,
     944,     0,     0,   875,     0,     0,     0,     0,  2534,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   875,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2471,     0,     0,     0,     0,
       0,     0,     0,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,     0,     0,     0,     0,     0,     0,  2541,     0,
       0,     0,     0,     0,     0,     0,   883,  4955,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   883,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   883,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   944,  2535,     0,     0,     0,     0,  2536,     0,     0,
       0,     0,   877,     0,   934,   877,     0,   877,     0,     0,
       0,     0,   877,     0,     0,     0,     0,   944,     0,  2537,
    2233,     0,     0,     0,     0,     0,   883,     0,     0,     0,
       0,     0,     0,   875,  2538,     0,     0,     0,  2471,     0,
       0,   883,     0,     0,   883,   883,  2472,  2473,  2474,  2475,
    2476,  2477,  2478,  2479,  2480,     0,     0,     0,     0,   877,
       0,     0,   943,     0,     0,     0,     0,   877,     0,     0,
       0,     0,     0,  2283,     0,   883,   883,   934,   934,   875,
       0,     0,     0,     0,   875,     0,     0,  2539,     0,     0,
    2540,     0,   877,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   943,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   878,     0,     0,
       0,   878,   878,   944,     0,     0,     0,     0,     0,     0,
    2045,     0,     0,  2046,     0,   943,     0,  2047,  2048,  2049,
       0,  1019,     0,     0,     0,     0,     0,  1050,     0,     0,
       0,   877,     0,   877,  2531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2532,     0,     0,     0,     0,  2541,
       0,  2533,     0,     0,     0,     0,     0,     0,   878,     0,
    2045,     0,     0,  2046,   878,     0,     0,  2047,  2048,  2049,
       0,     0,     0,     0,     0,   883,     0,  2534,     0,  2045,
       0,     0,  2046,     0,  2531,     0,  2047,  2048,  2049,     0,
       0,     0,     0,  1770,  2532,     0,     0,     0,     0,   875,
       0,  2533,     0,  2531,     0,   878,     0,     0,     0,     0,
       0,     0,   943,  2532,     0,     0,     0,     0,     0,     0,
    2533,     0,     0,     0,   877,     0,     0,  2534,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1771,     0,     0,
       0,     0,     0,   880,     0,     0,  2534,   880,   880,  2471,
       0,     0,     0,     0,     0,     0,     0,  2472,  2473,  2474,
    2475,  2476,  2477,  2478,  2479,  2480,   877,  5468,     0,     0,
       0,     0,     0,     0,  1771,     0,     0,     0,     0,   934,
     934,     0,     0,     0,  1771,     0,     0,     0,     0,     0,
       0,  2535,     0,     0,   877,     0,  2536,     0,     0,     0,
       0,     0,     0,     0,   880,     0,  1346,     0,     0,   943,
     880,   875,     0,     0,     0,     0,     0,     0,  2537,  2233,
       0,     0,     0,     0,     0,  1369,     0,     0,     0,     0,
       0,     0,     0,  2538,     0,     0,     0,     0,     0,     0,
       0,  2535,     0,   881,     0,     0,  2536,   881,   881,   875,
       0,   880,     0,     0,     0,     0,     0,     0,     0,     0,
    2535,     0,     0,   877,     0,  2536,     0,     0,  2537,  2233,
       0,   875,  2283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2538,     0,   877,  2539,  2537,  2233,  2540,
       0,     0,     0,     0,  1427,     0,     0,     0,     0,     0,
       0,     0,  2538,     0,   881,   878,     0,   877,     0,   943,
     881,   943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2539,     0,   875,  2540,
    1562,  2283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   881,     0,     0,     0,  2539,     0,   943,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2541,   878,
       0,     0,     0,   878,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   877,     0,
       0,     0,     0,     0,     0,     0,  1770,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   877,     0,     0,     0,     0,     0,     0,  2541,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   877,  2541,     0,     0,
       0,   880,     0,  1820,     0,     0,     0,     0,     0,   875,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2471,     0,
       0,  1854,  1857,  1858,   878,     0,  2472,  2473,  2474,  2475,
    2476,  2477,  2478,  2479,  2480,     0,     0,     0,     0,   878,
       0,     0,     0,     0,   878,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   880,     0,     0,  2471,   880,
       0,     0,     0,     0,     0,     0,  2472,  2473,  2474,  2475,
    2476,  2477,  2478,  2479,  2480,     0,     0,  2471,     0,     0,
       0,   881,     0,     0,     0,  2472,  2473,  2474,  2475,  2476,
    2477,  2478,  2479,  2480,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   877,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     875,  1346,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1984,     0,     0,     0,     0,     0,     0,     0,
     943,  1346,     0,     0,     0,   881,     0,     0,     0,   881,
     880,     0,     0,     0,   943,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   880,     0,     0,   875,     0,
     880,     0,     0,     0,     0,     0,     0,   883,     0,     0,
       0,   883,   883,     0,  1770,     0,     0,     0,     0,   877,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   877,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,     0,
       0,     0,     0,     0,   883,     0,     0,     0,     0,     0,
     881,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   878,     0,   881,   878,     0,   878,     0,
     881,     0,     0,   878,     0,     0,     0,     0,     0,  2525,
       0,     0,     0,     0,     0,   883,  1770,     0,   875,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     878,     0,     0,     0,     0,     0,     0,     0,   878,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1770,     0,   943,     0,     0,     0,     0,   877,
       0,     0,     0,   878,     0,     0,     0,     0,     0,  2616,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   877,     0,     0,     0,     0,
     877,     0,     0,     0,     0,     0,     0,     0,     0,   880,
       0,     0,   880,     0,   880,   875,     0,     0,     0,   880,
     875,   875,   878,     0,   878,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2730,     0,     0,     0,     0,     0,     0,     0,     0,
    2753,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   943,   880,     0,     0,     0,
       0,     0,     0,     0,   880,     0,     0,     0,     0,     0,
       0,     0,  2790,     0,     0,   883,     0,     0,     0,     0,
       0,   943,     0,     0,     0,     0,     0,     0,     0,   880,
       0,     0,     0,     0,     0,  2813,     0,     0,  2816,   881,
       0,     0,   881,     0,   881,   878,     0,     0,     0,   881,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   875,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   877,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   878,     0,   883,
       0,     0,  2868,   883,     0,     0,   881,     0,   880,     0,
     880,     0,     0,     0,   881,     0,  2887,     0,     0,     0,
       0,   875,     0,     0,     0,   878,     0,     0,     0,     0,
       0,     0,     1,     0,     0,     0,     0,     0,     0,   881,
       0,     0,     2,     0,     3,     4,     0,   943,     0,     0,
       0,     0,     0,  1322,  1322,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     6,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     7,     0,     8,     9,     0,     0,
       0,     0,     0,    10,   878,    11,     0,   877,     0,     0,
       0,   880,     0,     0,   883,     0,     0,    12,   881,    13,
     881,     0,     0,     0,     0,     0,   878,     0,     0,   883,
       0,     0,     0,     0,   883,  2909,    14,     0,     0,    15,
    1322,     0,     0,     0,     0,   877,  2912,     0,   878,     0,
       0,     0,     0,   880,    16,     0,    17,     0,     0,     0,
      18,     0,     0,     0,     0,     0,  5441,   877,     0,     0,
       0,     0,     0,     0,    20,     0,    21,     0,     0,     0,
       0,   880,     0,    22,     0,     0,     0,     0,  2956,     0,
       0,  1770,     0,     0,     0,     0,     0,     0,     0,     0,
      23,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   881,     0,  2992,     0,     0,     0,    24,     0,     0,
    3005,     0,     0,     0,     0,     0,     0,     0,  1770,     0,
       0,     0,     0,     0,   877,     0,     0,     0,  1770,   878,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     880,     0,     0,   881,     0,     0,     0,    25,    26,     0,
    1682,  1686,   878,    27,     0,     0,     0,     0,     0,     0,
       0,     0,   880,     0,     0,    28,     0,     0,     0,     0,
       0,   881,     0,     0,     0,     0,     0,   878,     0,     0,
       0,     0,  3066,    29,   880,  2616,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1346,  1346,     0,    30,
       0,     0,     0,     0,     0,     0,     0,    31,     0,     0,
       0,     0,     0,  3118,     0,     0,     0,     0,     0,   197,
     881,    32,     0,     0,     0,   877,     0,    33,    34,     0,
      35,     0,     0,     0,     0,    36,     0,     0,  4394,     0,
       0,    37,   881,   883,    38,     0,   883,     0,   883,     0,
       0,    39,     0,   883,     0,   880,     0,    40,    41,     0,
       0,     0,     0,     0,   881,    42,     0,     0,     0,    43,
     198,     0,     0,     0,     0,     0,     0,     0,   880,    44,
       0,     0,     0,     0,     0,     0,   199,     0,     0,     0,
     878,     0,     0,     0,    45,     0,     0,     0,     0,     0,
     883,     0,     0,   880,   200,     0,     0,     0,   883,     0,
     201,     0,     0,     0,    46,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    47,     0,     0,   202,     0,
       0,    48,     0,   883,     0,     0,    49,     0,     0,   203,
       0,     0,     0,     0,     0,     0,     0,     0,   204,    50,
       0,     0,     0,     0,     0,   881,   877,     0,     0,     0,
       0,   205,     0,     0,     0,     0,   206,     0,  2001,     0,
       0,     0,    51,   207,     0,     0,     0,     0,   881,     0,
     878,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      57,     0,   208,  -135,     0,     0,     0,     0,     0,  2016,
       0,     0,   883,   881,   883,   878,     0,     0,     0,     0,
       0,     0,     0,     0,   877,     0,     0,   209,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2034,  2035,  2036,
       0,  2038,     0,     0,     0,     0,   880,     0,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2489,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   883,     0,     0,     0,     0,
       0,     0,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   213,   214,     0,     0,   215,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   880,     0,     0,     0,
       0,     0,     0,     0,   877,     0,   881,   883,     0,     0,
     878,     0,     0,   216,     0,     0,   217,     0,     0,     0,
     218,   880,   219,  2583,     0,     0,     0,  2595,  2600,   220,
       0,     0,   221,     0,     0,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   222,     0,     0,     0,     0,   878,     0,   223,     0,
       0,   878,     0,   224,   225,     0,     0,   226,     0,     0,
       0,   227,     0,     0,     0,     0,     0,     0,     0,   637,
       0,   228,     0,     0,     0,     0,   229,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   881,   638,     0,   230,
       0,     0,     0,     0,   883,     0,     0,     0,     0,     0,
       0,     0,   231,     0,     0,     0,     0,     0,     0,     0,
       0,   881,   639,  2482,     0,     0,   883,     0,     0,     0,
       0,   877,     0,     0,     0,   640,   877,   877,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,     0,
       0,  -860,     0,     0,     0,     0,   880,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   641,
       0,     0,     0,     0,     0,   642,     0,  2482,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3272,     0,   643,     0,     0,     0,     0,     0,     0,
       0,  3277,   880,     0,   644,     0,   878,   880,     0,     0,
       0,     0,     0,   645,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   646,     0,     0,     0,
    1427,     0,     0,     0,   647,     0,     0,     0,   648,   883,
       0,     0,     0,     0,     0,     0,     0,     0,   877,     0,
       0,     0,     0,     0,     0,     0,   881, -1055,     0,     0,
       0,     0,   883,     0,     0,     0,     0,  1682,  1682,  1682,
       0,     0,     0,     0,     0,     0,     0,  1427,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,   883,     0,     0,
       0,     0,     0,     0,   649,     0,     0,   877,     0,     0,
       0,     0,   881,  -596,     0,     0,     0,   881,     0,     0,
       0,  1346,     0,     0,     0,     0,     0,     0,   878,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   650,     0,     0,   651,     0,     0,     0,
       0,     0,   880,     0,     0,     0,   878,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   652,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   878,     0,
       0,   653,     0,     0,     0,     0,     0,     0,  -457,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   654,     0,
       0,     0,     0,     0,     0,     0,     0,   655,     0,     0,
     883,     0,     0,     0,  -457,     0,     0,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3477,     0,     0,     0,   878,   657,     0,     0,     0,
       0,     0,   881,   658,     0,     0,  3499,     0,     0,  -457,
       0,     0,   659,   660,   880,   661,   662,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3526,     0,     0,
       0,   663,     0,  2482,     0,     0,     0,  2482,   664,     0,
       0,   665,     0,     0,   666,     0,     0,     0,     0,     0,
       0,     0,   880,     0,     0,     0,     0,  -457,     0,     0,
     883,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   880,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3601,  3602,     0,     0,     0,
       0,     0,     0,     0,   881,     0,   878,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   880,     0,     0,  3146,     0,     0,     0,     0,     0,
       0,     0,   881,     0,     0,     0,  3166,     0,  3167,     0,
    3169,     0,     0,  3183,  3186,  3191,     0,     0,     0,     0,
    3197,     0,     0,  3202,   881,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3209,  3210,
    3211,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3212,  3725,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     883,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   881,     0,     0,     0,     0,     0,   878,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   880,     0,     0,     0,   883,     0,     0,     0,
       0,   883,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   878,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3219,     0,
       0,     0,  2482,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   881,     0,     0,     0,     0,  2482,     0,     0,
       0,  3179,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2482,  2482,  2482,  3236,  2482,
       0,     0,     0,   880,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   883,     0,     0,     0,
       0,     0,     0,     0,     0,   878,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3238,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   880,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   881,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4005,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   881,   878,     0,     0,     0,     0,   878,   878,     0,
       0,     0,     0,     0,     0,     0,   883,     0,     0,     0,
       0,   880,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3245,  3246,  3247,  3248,  3249,  3250,  3251,
    3252,  3253,     0,  3254,     0,     0,     0,     0,     0,     0,
       0,     0,  1322,     0,  1682,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   878,
       0,   881,  3212,     0,     0,     0,  3219,     0,     0,  3236,
       0,  3238,     0,     0,  3289,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   880,     0,
       0,     0,     0,   880,   880,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   878,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2035,  2036,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   883,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4197,     0,     0,     0,     0,     0,   881,     0,
       0,     0,     0,   881,   881,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   880,     0,  3419,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2482,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   880,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   883,     0,     0,
       0,     0,     0,     0,     0,   881,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2482,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2482,     0,     0,     0,
       0,  2482,     0,     0,     0,     0,     0,     0,  4321,  4322,
    4323,     0,     0,     0,   881,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4332,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4356,
    4358,     0,     0,     0,  4363,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3657,  3658,  1682,     0,     0,     0,  3662,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3691,     0,     0,     0,
       0,     0,     0,     0,     0,   883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4457,     0,     0,  1346,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   883,     0,     0,     0,     0,   883,   883,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4559,  4560,  4561,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3896,     0,     0,     0,     0,  3902,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2038,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3191,   883,
    3191,  3191,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3962,     0,     0,  3965,     0,  3967,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   883,     0,
    3986,     0,  3989,     0,  3991,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4056,     0,     0,     0,     0,  2583,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2600,     0,     0,     0,     0,  2482,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2482,  2482,     0,
    2482,     0,     0,     0,     0,  3179,  3179,     0,  3939,     0,
    3179,     0,     0,     0,  2482,     0,     0,  2482,     0,     0,
       0,     0,  2482,     0,     0,  4090,     0,     0,  2482,     0,
       0,     0,     0,  2482,     0,     0,     0,     0,     0,  4804,
    2482,  2482,  2482,  2482,     0,     0,     0,  3179,  3179,     0,
    2482,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2482,     0,  2482,
    4836,     0,     0,     0,     0,     0,  2482,  2482,  2482,  2482,
    2482,  2482,  2482,  2482,  2482,  2482,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3005,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2482,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3066,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2482,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1682,     0,     0,     0,     0,     0,
    1682,     0,     0,     0,     0,     0,  4990,  4991,  4992,  4993,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4343,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2482,  2482,
       0,     0,     0,  2482,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4475,     0,
       0,     0,  2482,     0,     0,     0,     0,  4479,     0,     0,
       0,     0,     0,     0,     0,  4481,     0,  4482,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4504,  4505,  4506,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3197,     0,     0,     0,     0,     0,     0,     0,
    4530,     0,     0,  4533,     0,  4535,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4538,     0,     0,     0,     0,
       0,  5194,     0,  4545,  4546,     0,     0,     0,     0,     0,
       0,     0,  5204,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4604,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2482,     0,     0,
       0,     0,     0,  2482,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3939,  3939,     0,     0,  3179,  3179,  3179,  3179,     0,
       0,  3179,  3179,  3179,  3179,  3179,  3179,  3179,  3179,  3179,
    3179,  3939,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2482,     0,     0,  2482,     0,  2482,     0,
       0,  3939,  3939,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2482,  3179,  3179,
    2482,     0,  2482,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5385,     0,     0,     0,     0,  1346,     0,  2482,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5415,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2482,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4882,  4883,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4890,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5510,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4915,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4943,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4949,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3179,     0,     0,     0,     0,  5587,     0,     0,
       0,     0,     0,     0,     0,  4968,  4970,     0,     0,     0,
       0,     0,  4974,  4975,     0,     0,     0,  4976,     0,     0,
       0,  4977,     0,     0,  4980,  4981,  5610,     0,     0,  4985,
       0,     0,     0,     0,  2482,  4989,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5020,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1322,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5033,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2482,     0,     0,     0,
    2482,     0,  2482,  2482,     0,     0,     0,     0,  3939,  3939,
    3939,  3939,     0,     0,     0,  3939,  3939,  3939,  3939,  3939,
    3939,  3939,  3939,  3939,  3939,  2482,  2482,  2482,     0,     0,
       0,     0,     0,  5098,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2482,     0,     0,  2482,     0,  2482,     0,     0,  2482,
       0,     0,  3939,  3939,     0,     0,  2482,  2482,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5134,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2482,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5232,     0,
       0,     0,     0,     0,  5236,  5237,  5238,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5249,
    5250,     0,     0,  5251,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3939,     0,     0,  5271,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5289,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2482,  2482,     0,     0,     0,     0,     0,
       0,  2482,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2482,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2482,     0,     0,     0,     0,     0,
    2482,  3179,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2482,
       0,  2482,     0,     0,     0,  2482,  2482,  2482,  2482,     0,
       0,  2482,  2482,     0,     0,     0,  2482,     0,     0,     0,
    2482,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3179,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5465,     0,     0,     0,     0,
       0,  2482,     0,     0,     0,     0,     0,     0,     0,     0,
    3197,     0,     0,     0,  2482,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2038,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2482,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5528,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2482,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5564,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2482,     0,  3939,  3179,  2482,  2482,  2482,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2482,  2482,  2482,     0,     0,     0,     0,     0,     0,  5636,
       0,     0,     0,     0,     0,  3179,     0,     0,  3939,     0,
       0,     0,  2482,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5289,
    2482,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5676,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5765,  5765,  5765,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5289,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2482,     0,     0,     0,
    3939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3939,     0,  3179,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5827,     0,     0,     0,     0,     0,  2482,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5851,     0,
       0,     0,     0,  5765,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2482,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2482,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5923,     0,     0,  5924,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2482,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5765,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1682,     0,     0,     0,     0,     0,  2482,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3179,
    3179,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2482,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2482,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3939,
    3939,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     234,     0,  1238,   681,     0,  1239,  1240,  1241,   742,  1242,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,  1676,   243,   244,   245,     0,
       0,     0,     0,  1243,  2482,  2482,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,   257,  1244,
     259,  1245,  1246,     0,   262,   263,   264,   265,   266,   267,
     268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,   274,
     275,   276,   277,  1251,     0,  1252,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,   304,
     305,   306,  1260,  1261,   309,  1262,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
    1677,     0,   322,   323,   858,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
    1263,   338,   339,   340,   341,  1264,  1265,   343,     0,   344,
     345,   346,  1266,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,  1267,     0,  1268,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,   383,   384,   385,  1269,
    1270,     0,  1271,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,  1272,   401,   402,
     403,     0,   404,   405,   406,  1273,  1274,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,  1275,   424,  1276,   426,   427,   428,   429,
     430,   431,   432,   433,  1277,   435,  1278,   436,   437,   438,
     439,  1279,  1280,   441,  1281,   443,   444,   445,     0,   446,
     447,     0,     0,  1282,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,  1283,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,  1284,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,  1285,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,  1286,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,  1287,
     526,   527,   528,   529,   530,   531,   532,   533,  1288,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,  1289,   550,     0,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,     0,   560,  1290,
    1291,     0,     0,   563,   564,  1292,   566,  1293,  1294,   568,
     569,   570,   571,   572,   573,   574,   575,     0,  1295,   576,
     577,   578,   579,   580,  1296,     0,   581,   582,   583,   584,
     585,   586,  1297,  1678,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,  1298,  1299,  1300,  1301,   606,  1302,  1303,  1304,
    1305,   611,   612,   613,   614,  1306,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1307,  1308,  1679,     0,
       0,     0,     0,     0,     0,  1310,  1680,   234,     0,  1238,
     681,     0,  1239,  1240,  1241,   742,  1242,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
    1243,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,  1244,   259,  1245,  1246,
       0,   262,   263,   264,   265,   266,   267,   268,  1247,  1248,
     269,   270,  1249,  1250,   273,     0,   274,   275,   276,   277,
    1251,     0,  1252,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,  1253,  1254,  1255,  1256,
    1257,  1258,  1259,   301,   302,   303,   304,   305,   306,  1260,
    1261,   309,  1262,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   858,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,  1263,   338,   339,
     340,   341,  1264,  1265,   343,     0,   344,   345,   346,  1266,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,  1267,     0,  1268,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,  1269,  1270,     0,  1271,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,  1272,   401,   402,   403,     0,   404,
     405,   406,  1273,  1274,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1275,   424,  1276,   426,   427,   428,   429,   430,   431,   432,
     433,  1277,   435,  1278,   436,   437,   438,   439,  1279,  1280,
     441,  1281,   443,   444,   445,     0,   446,   447,     0,     0,
    1282,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,  1283,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,  1284,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1285,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
    1286,   512,   513,   514,   515,   516,   517,   518,   519,   520,
      41,   521,   522,   523,   524,   525,  1287,   526,   527,   528,
     529,   530,   531,   532,   533,  1288,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,  1289,   550,     0,   551,   552,    45,   553,   554,   555,
     556,   557,   558,   559,     0,   560,  1290,  1291,     0,     0,
     563,   564,  1292,   566,  1293,  1294,   568,   569,   570,   571,
     572,   573,   574,   575,     0,  1295,   576,   577,   578,   579,
     580,  1296,     0,   581,   582,   583,   584,   585,  1171,  1297,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,    50,   595,   596,   597,   598,   599,   600,   601,  1298,
    1299,  1300,  1301,   606,  1302,  1303,  1304,  1305,   611,   612,
     613,   614,  1306,     0,    51,     0,     0,     0,     0,     0,
       0,     0,     0,  1307,  1308,     0,     0,     0,     0,     0,
       0,     0,  1310,  5497,   234,     0,  1238,   681,     0,  1239,
    1240,  1241,   742,  1242,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,  1243,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,  1244,   259,  1245,  1246,     0,   262,   263,
     264,   265,   266,   267,   268,  1247,  1248,   269,   270,  1249,
    1250,   273,     0,   274,   275,   276,   277,  1251,     0,  1252,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
     301,   302,   303,   304,   305,   306,  1260,  1261,   309,  1262,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   858,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,  1263,   338,   339,   340,   341,  1264,
    1265,   343,     0,   344,   345,   346,  1266,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,  1267,     0,  1268,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,  1269,  1270,     0,  1271,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,  1272,   401,   402,   403,     0,   404,   405,   406,  1273,
    1274,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,  1275,   424,  1276,
     426,   427,   428,   429,   430,   431,   432,   433,  1277,   435,
    1278,   436,   437,   438,   439,  1279,  1280,   441,  1281,   443,
     444,   445,     0,   446,   447,     0,     0,  1282,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,  1283,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,  1284,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1285,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,  1286,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,  1287,   526,   527,   528,   529,   530,   531,
     532,   533,  1288,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,  1289,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,  1290,  1291,     0,     0,   563,   564,  1292,
     566,  1293,  1294,   568,   569,   570,   571,   572,   573,   574,
     575,     0,  1295,   576,   577,   578,   579,   580,  1296,     0,
     581,   582,   583,   584,   585,   586,  1297,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,  1298,  1299,  1300,  1301,
     606,  1302,  1303,  1304,  1305,   611,   612,   613,   614,  1306,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1307,  1308,     0,     0,     0,     0,     0,     0,     0,  1310,
    3181,   234,     0,  1238,   681,     0,  1239,  1240,  1241,   742,
    1242,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,  1243,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1244,   259,  1245,  1246,     0,   262,   263,   264,   265,   266,
     267,   268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,
     274,   275,   276,   277,  1251,     0,  1252,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
    1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,
     304,   305,   306,  1260,  1261,   309,  1262,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   858,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1263,   338,   339,   340,   341,  1264,  1265,   343,     0,
     344,   345,   346,  1266,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,  1267,     0,
    1268,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1269,  1270,     0,  1271,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,  1272,   401,
     402,   403,     0,   404,   405,   406,  1273,  1274,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1275,   424,  1276,   426,   427,   428,
     429,   430,   431,   432,   433,  1277,   435,  1278,   436,   437,
     438,   439,  1279,  1280,   441,  1281,   443,   444,   445,     0,
     446,   447,     0,     0,  1282,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1283,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1284,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1285,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,  1286,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
    1287,   526,   527,   528,   529,   530,   531,   532,   533,  1288,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1289,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1290,  1291,     0,     0,   563,   564,  1292,   566,  1293,  1294,
     568,   569,   570,   571,   572,   573,   574,   575,     0,  1295,
     576,   577,   578,   579,   580,  1296,     0,   581,   582,   583,
     584,   585,   586,  1297,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,  1303,
    1304,  1305,   611,   612,   613,   614,  1306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1307,  1308,     0,
       0,     0,     0,     0,     0,     0,  1310,  4483,   234,     0,
    1238,   681,     0,  1239,  1240,  1241,   742,  1242,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,  1243,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,  1244,   259,  1245,
    1246,     0,   262,   263,   264,   265,   266,   267,   268,  1247,
    1248,   269,   270,  1249,  1250,   273,     0,   274,   275,   276,
     277,  1251,     0,  1252,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,  1253,  1254,  1255,
    1256,  1257,  1258,  1259,   301,   302,   303,   304,   305,   306,
    1260,  1261,   309,  1262,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   858,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,  1263,   338,
     339,   340,   341,  1264,  1265,   343,     0,   344,   345,   346,
    1266,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,  1267,     0,  1268,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,  1269,  1270,     0,
    1271,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,  1272,   401,   402,   403,     0,
     404,   405,   406,  1273,  1274,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,  1275,   424,  1276,   426,   427,   428,   429,   430,   431,
     432,   433,  1277,   435,  1278,   436,   437,   438,   439,  1279,
    1280,   441,  1281,   443,   444,   445,     0,   446,   447,     0,
       0,  1282,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,  1283,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,  1284,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,  1285,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,  1286,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,  1287,   526,   527,
     528,   529,   530,   531,   532,   533,  1288,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,  1289,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,  1290,  1291,     0,
       0,   563,   564,  1292,   566,  1293,  1294,   568,   569,   570,
     571,   572,   573,   574,   575,     0,  1295,   576,   577,   578,
     579,   580,  1296,     0,   581,   582,   583,   584,   585,   586,
    1297,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
    1298,  1299,  1300,  1301,   606,  1302,  1303,  1304,  1305,   611,
     612,   613,   614,  1306,     0,     0,     0,     0,   622,     0,
       0,     0,     0,     0,  1307,  1308,     0,     0,     0,     0,
       0,     0,     0,  1310,  4552,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,  4034,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0, -1769,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0, -1769,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379, -1769,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392, -1769,   394,   395,   396,
     397,   398,     0,     0,   399,   400, -1769,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423, -1769,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504, -1769,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,     0,     0,     0,     0,     0,   850,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1420,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,     0,   851,   259,   852,
     853,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   854,   855,   273,     0,   274,   275,   276,
     277,     0,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     856,   857,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   858,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   338,
     339,   340,   341,     0,     0,   343,     0,   344,   345,   346,
     859,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,     0,     0,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,  2624,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,  2625,   382,   383,   384,   385,   860,   861,     0,
     862,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,     0,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   863,   424,   864,   426,   427,   428,   429,   430,   431,
     432,     0,     0,   435,     0,   436,   437,   438,   439,     0,
       0,   441,   865,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,  2627,   454,
     455,   456,     0,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,     0,   470,     0,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   866,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
    2628,   529,   530,   531,   532,   533,   868,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,     0,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   869,   870,     0,
       0,   563,   564,     0,   566,     0,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,     0,
     871,  2629,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   850,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     612,   613,   614,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,     0,  2724,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,     0,   851,   259,
     852,   853,     0,   262,   263,   264,   265,   266,   267,   268,
       0,     0,   269,   270,   854,   855,   273,     0,   274,   275,
     276,   277,     0,     0,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
       0,   300,     0,     0,     0,   301,   302,   303,   304,   305,
     306,   856,   857,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   858,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     338,   339,   340,   341,     0,     0,   343,     0,   344,   345,
     346,   859,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,     0,     0,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,  2624,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,  2625,   382,   383,   384,   385,   860,   861,
       0,   862,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,     0,     0,   399,     0,   401,   402,   403,
       0,   404,   405,   406,     0,     0,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   863,   424,   864,   426,   427,   428,   429,   430,
     431,   432,     0,     0,   435,     0,   436,   437,   438,   439,
       0,     0,   441,   865,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,     0,     0,   451,   452,  2627,
     454,   455,   456,     0,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,     0,   470,     0,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   866,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,     0,   526,
     527,  2628,   529,   530,   531,   532,   533,   868,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   550,     0,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   869,   870,
       0,     0,   563,   564,     0,   566,     0,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,     0,   581,   582,   583,   584,   585,
       0,   871,  2629,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     234,     0,  1238,   681,     0,  1239,  1240,  1241,   742,  1242,
       0,   612,   613,   614,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,  1243,     0,  3781,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,   257,  1244,
     259,  1245,  1246,     0,   262,   263,   264,   265,   266,   267,
     268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,   274,
     275,   276,   277,  1251,     0,  1252,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,   304,
     305,   306,  1260,  1261,   309,  1262,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   858,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
    1263,   338,   339,   340,   341,  1264,  1265,   343,     0,   344,
     345,   346,  1266,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,  1267,     0,  1268,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,   383,   384,   385,  1269,
    1270,     0,  1271,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,  1272,   401,   402,
     403,     0,   404,   405,   406,  1273,  1274,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,  1275,   424,  1276,   426,   427,   428,   429,
     430,   431,   432,   433,  1277,   435,  1278,   436,   437,   438,
     439,  1279,  1280,   441,  1281,   443,   444,   445,     0,   446,
     447,     0,     0,  1282,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,  1283,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,  1284,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,  1285,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,  1286,   512,   513,   514,   515,   516,   517,
     518,   519,   520,    41,   521,   522,   523,   524,   525,  1287,
     526,   527,   528,   529,   530,   531,   532,   533,  1288,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,  1289,   550,     0,   551,   552,    45,
     553,   554,   555,   556,   557,   558,   559,     0,   560,  1290,
    1291,     0,     0,   563,   564,  1292,   566,  1293,  1294,   568,
     569,   570,   571,   572,   573,   574,   575,     0,  1295,   576,
     577,   578,   579,   580,  1296,     0,   581,   582,   583,   584,
     585,  1171,  1297,     0,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,    50,   595,   596,   597,   598,   599,
     600,   601,  1298,  1299,  1300,  1301,   606,  1302,  1303,  1304,
    1305,   611,   612,   613,   614,  1306,     0,    51,     0,     0,
       0,     0,     0,     0,     0,     0,  1307,  1308,     0,     0,
       0,   234,     0,  1238,   681,  1310,  1239,  1240,  1241,   742,
    1242,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,  1243,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1244,   259,  1245,  1246,  3187,   262,   263,   264,   265,   266,
     267,   268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,
     274,   275,   276,   277,  1251,     0,  1252,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
    1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,
     304,   305,   306,  1260,  1261,   309,  1262,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   858,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1263,   338,   339,   340,   341,  1264,  1265,   343,     0,
     344,   345,   346,  1266,   348,     0,   349,     0,   350,   351,
    3188,   352,   353,   354,   355,   356,     0,   357,  1267,     0,
    1268,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1269,  1270,     0,  1271,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,  3189,   399,  1272,   401,
     402,   403,     0,   404,   405,   406,  1273,  1274,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1275,   424,  1276,   426,   427,   428,
     429,   430,   431,   432,   433,  1277,   435,  1278,   436,   437,
     438,   439,  1279,  1280,   441,  1281,   443,   444,   445,     0,
     446,   447,     0,     0,  1282,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1283,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1284,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1285,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,  1286,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
    1287,   526,   527,   528,   529,   530,   531,   532,   533,  1288,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1289,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1290,  1291,     0,  3190,   563,   564,  1292,   566,  1293,  1294,
     568,   569,   570,   571,   572,   573,   574,   575,     0,  1295,
     576,   577,   578,   579,   580,  1296,     0,   581,   582,   583,
     584,   585,   586,  1297,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,  1303,
    1304,  1305,   611,   612,   613,   614,  1306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1307,  1308,     0,
       0,     0,   234,     0,  1238,   681,  1310,  1239,  1240,  1241,
     742,  1242,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242, -2158,   243,   244,
     245,     0,     0,     0, -2158,  1243,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,  1244,   259,  1245,  1246,     0,   262,   263,   264,   265,
     266,   267,   268,  1247,  1248,   269,   270,  1249,  1250,   273,
       0,   274,   275,   276,   277,  1251,     0,  1252,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,
     303,   304,   305,   306,  1260,  1261,   309,  1262,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   858,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,  1263,   338,   339,   340,   341,  1264,  1265,   343,
       0,   344,   345,   346,  1266,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,  1267,
       0,  1268,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,  1269,  1270,     0,  1271,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,  1272,
     401,   402,   403,     0,   404,   405,   406,  1273,  1274,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1275,   424,  1276,   426,   427,
     428,   429,   430,   431,   432,   433,  1277,   435,  1278,   436,
     437,   438,   439,  1279,  1280,   441,  1281,   443,   444,   445,
       0,   446,   447,     0,     0,  1282,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1283,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1284,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1285,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,  1286,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1287,   526,   527,   528,   529,   530,   531,   532,   533,
    1288,   535, -2158,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1289,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,  1290,  1291,     0,     0,   563,   564,  1292,   566,  1293,
    1294,   568,   569,   570,   571,   572,   573,   574,   575,     0,
    1295,   576,   577,   578,   579,   580,  1296,     0,   581,   582,
     583,   584,   585,   586,  1297,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,
    1303,  1304,  1305,   611,   612,   613,   614,  1306,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1307,  1308,
       0,     0,     0,   234,     0,  1238,   681,  1310,  1239,  1240,
    1241,   742,  1242,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242, -2156,   243,
     244,   245,     0,     0,     0, -2156,  1243,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1244,   259,  1245,  1246,     0,   262,   263,   264,
     265,   266,   267,   268,  1247,  1248,   269,   270,  1249,  1250,
     273,     0,   274,   275,   276,   277,  1251,     0,  1252,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,
     302,   303,   304,   305,   306,  1260,  1261,   309,  1262,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   858,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,  1263,   338,   339,   340,   341,  1264,  1265,
     343,     0,   344,   345,   346,  1266,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
    1267,     0,  1268,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,  1269,  1270,     0,  1271,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
    1272,   401,   402,   403,     0,   404,   405,   406,  1273,  1274,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1275,   424,  1276,   426,
     427,   428,   429,   430,   431,   432,   433,  1277,   435,  1278,
     436,   437,   438,   439,  1279,  1280,   441,  1281,   443,   444,
     445,     0,   446,   447,     0,     0,  1282,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,  1283,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,  1284,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1285,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,  1286,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,  1287,   526,   527,   528,   529,   530,   531,   532,
     533,  1288,   535, -2156,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,  1289,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,  1290,  1291,     0,     0,   563,   564,  1292,   566,
    1293,  1294,   568,   569,   570,   571,   572,   573,   574,   575,
       0,  1295,   576,   577,   578,   579,   580,  1296,     0,   581,
     582,   583,   584,   585,   586,  1297,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,  1298,  1299,  1300,  1301,   606,
    1302,  1303,  1304,  1305,   611,   612,   613,   614,  1306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1307,
    1308,     0,     0,     0,   234,     0,  1238,   681,  1310,  1239,
    1240,  1241,   742,  1242,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,  1243,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,  1244,   259,  1245,  1246,     0,   262,   263,
     264,   265,   266,   267,   268,  1247,  1248,   269,   270,  1249,
    1250,   273,     0,   274,   275,   276,   277,  1251,     0,  1252,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
     301,   302,   303,   304,   305,   306,  1260,  1261,   309,  1262,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   858,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,  1263,   338,   339,   340,   341,  1264,
    1265,   343,     0,   344,   345,   346,  1266,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,  1267,     0,  1268,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,  1269,  1270,     0,  1271,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,  1272,   401,   402,   403,     0,   404,   405,   406,  1273,
    1274,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,  1275,   424,  1276,
     426,   427,   428,   429,   430,   431,   432,   433,  1277,   435,
    1278,   436,   437,   438,   439,  1279,  1280,   441,  1281,   443,
     444,   445,     0,   446,   447,     0,     0,  1282,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,  1283,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,  1284,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1285,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,  1286,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,  1287,   526,   527,   528,   529,   530,   531,
     532,   533,  1288,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,  1289,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,  1290,  1291,     0,     0,   563,   564,  1292,
     566,  1293,  1294,   568,   569,   570,   571,   572,   573,   574,
     575,     0,  1295,   576,   577,   578,   579,   580,  1296,     0,
     581,   582,   583,   584,   585,   586,  1297,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,  1298,  1299,  1300,  1301,
     606,  1302,  1303,  1304,  1305,   611,   612,   613,   614,  1306,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1307,  1308,     0,     0,     0,     0,     0,  1998,  3139,  1310,
     234,     0,  1238,   681,     0,  1239,  1240,  1241,   742,  1242,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,  1243,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,   257,  1244,
     259,  1245,  1246,     0,   262,   263,   264,   265,   266,   267,
     268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,   274,
     275,   276,   277,  1251,     0,  1252,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,   304,
     305,   306,  1260,  1261,   309,  1262,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   858,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
    1263,   338,   339,   340,   341,  1264,  1265,   343,     0,   344,
     345,   346,  1266,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,  1267,     0,  1268,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,   383,   384,   385,  1269,
    1270,     0,  1271,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,  1272,   401,   402,
     403,     0,   404,   405,   406,  1273,  1274,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,  1275,   424,  1276,   426,   427,   428,   429,
     430,   431,   432,   433,  1277,   435,  1278,   436,   437,   438,
     439,  1279,  1280,   441,  1281,   443,   444,   445,     0,   446,
     447,     0,     0,  1282,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,  1283,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,  1284,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,  1285,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,  1286,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,  1287,
     526,   527,   528,   529,   530,   531,   532,   533,  1288,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,  1289,   550,     0,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,     0,   560,  1290,
    1291,     0,     0,   563,   564,  1292,   566,  1293,  1294,   568,
     569,   570,   571,   572,   573,   574,   575,     0,  1295,   576,
     577,   578,   579,   580,  1296,     0,   581,   582,   583,   584,
     585,   586,  1297,     0,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,  1298,  1299,  1300,  1301,   606,  1302,  1303,  1304,
    1305,   611,   612,   613,   614,  1306,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1307,  1308,  1309,     0,
       0,   234,     0,  1238,   681,  1310,  1239,  1240,  1241,   742,
    1242,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,  2593,   243,   244,   245,
       0,     0,     0,     0,  1243,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1244,   259,  1245,  1246,     0,   262,   263,   264,   265,   266,
     267,   268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,
     274,   275,   276,   277,  1251,     0,  1252,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
    1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,
     304,   305,   306,  1260,  1261,   309,  1262,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   858,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1263,   338,   339,   340,   341,  1264,  1265,   343,     0,
     344,   345,   346,  1266,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,  1267,     0,
    1268,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1269,  1270,     0,  1271,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,  1272,   401,
     402,   403,     0,   404,   405,   406,  1273,  1274,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1275,   424,  1276,   426,   427,   428,
     429,   430,   431,   432,   433,  1277,   435,  1278,   436,   437,
     438,   439,  1279,  1280,   441,  1281,   443,   444,   445,     0,
     446,   447,     0,     0,  1282,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1283,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1284,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1285,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,  1286,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
    1287,   526,   527,   528,   529,   530,   531,   532,   533,  1288,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1289,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1290,  1291,     0,     0,   563,   564,  1292,   566,  1293,  1294,
     568,   569,   570,   571,   572,   573,   574,   575,     0,  1295,
     576,   577,   578,   579,   580,  1296,     0,   581,   582,   583,
     584,   585,   586,  1297,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,  1303,
    1304,  1305,   611,   612,   613,   614,  1306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1307,  1308,     0,
       0,     0,   234,     0,  1238,   681,  1310,  1239,  1240,  1241,
     742,  1242,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,  1243,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,  1244,   259,  1245,  1246,     0,   262,   263,   264,   265,
     266,   267,   268,  1247,  1248,   269,   270,  1249,  1250,   273,
       0,   274,   275,   276,   277,  1251,     0,  1252,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,
     303,   304,   305,   306,  1260,  1261,   309,  1262,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   858,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,  1263,   338,   339,   340,   341,  1264,  1265,   343,
       0,   344,   345,   346,  1266,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,  1267,
       0,  1268,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,  1269,  1270,     0,  1271,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,  1272,
     401,   402,   403,     0,   404,   405,   406,  1273,  1274,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1275,   424,  1276,   426,   427,
     428,   429,   430,   431,   432,   433,  1277,   435,  1278,   436,
     437,   438,   439,  1279,  1280,   441,  1281,   443,   444,   445,
       0,   446,   447,     0,     0,  1282,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1283,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1284,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1285,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,  1286,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1287,   526,   527,   528,   529,   530,   531,   532,   533,
    1288,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1289,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,  1290,  1291,     0,     0,   563,   564,  1292,   566,  1293,
    1294,   568,   569,   570,   571,   572,   573,   574,   575,     0,
    1295,   576,   577,   578,   579,   580,  1296,     0,   581,   582,
     583,   584,   585,   586,  1297,  3659,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,
    1303,  1304,  1305,   611,   612,   613,   614,  1306,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1307,  1308,
       0,     0,     0,   234,     0,  1238,   681,  1310,  1239,  1240,
    1241,   742,  1242,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,  1243,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1244,   259,  1245,  1246,     0,   262,   263,   264,
     265,   266,   267,   268,  1247,  1248,   269,   270,  1249,  1250,
     273,     0,   274,   275,   276,   277,  1251,     0,  1252,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,
     302,   303,   304,   305,   306,  1260,  1261,   309,  1262,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   858,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,  1263,   338,   339,   340,   341,  1264,  1265,
     343,     0,   344,   345,   346,  1266,   348,     0,   349,     0,
     350,   351,  3188,   352,   353,   354,   355,   356,     0,   357,
    1267,     0,  1268,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,  1269,  1270,     0,  1271,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
    1272,   401,   402,   403,     0,   404,   405,   406,  1273,  1274,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1275,   424,  1276,   426,
     427,   428,   429,   430,   431,   432,   433,  1277,   435,  1278,
     436,   437,   438,   439,  1279,  1280,   441,  1281,   443,   444,
     445,     0,   446,   447,     0,     0,  1282,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,  1283,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,  1284,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1285,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,  1286,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,  1287,   526,   527,   528,   529,   530,   531,   532,
     533,  1288,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,  1289,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,  1290,  1291,     0,     0,   563,   564,  1292,   566,
    1293,  1294,   568,   569,   570,   571,   572,   573,   574,   575,
       0,  1295,   576,   577,   578,   579,   580,  1296,     0,   581,
     582,   583,   584,   585,   586,  1297,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,  1298,  1299,  1300,  1301,   606,
    1302,  1303,  1304,  1305,   611,   612,   613,   614,  1306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1307,
    1308,     0,     0,     0,   234,     0,  1238,   681,  1310,  1239,
    1240,  1241,   742,  1242,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,  1243,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,  1244,   259,  1245,  1246,     0,   262,   263,
     264,   265,   266,   267,   268,  1247,  1248,   269,   270,  1249,
    1250,   273,     0,   274,   275,   276,   277,  1251,     0,  1252,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
     301,   302,   303,   304,   305,   306,  1260,  1261,   309,  1262,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   858,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,  1263,   338,   339,   340,   341,  1264,
    1265,   343,     0,   344,   345,   346,  1266,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,  1267,     0,  1268,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,  1269,  1270,     0,  1271,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,  1272,   401,   402,   403,     0,   404,   405,   406,  1273,
    1274,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,  1275,   424,  1276,
     426,   427,   428,   429,   430,   431,   432,   433,  1277,   435,
    1278,   436,   437,   438,   439,  1279,  1280,   441,  1281,   443,
     444,   445,     0,   446,   447,     0,     0,  1282,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,  1283,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,  1284,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1285,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,  1286,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,  1287,   526,   527,   528,   529,   530,   531,
     532,   533,  1288,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,  1289,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,  1290,  1291,  3239,     0,   563,   564,  1292,
     566,  1293,  1294,   568,   569,   570,   571,   572,   573,   574,
     575,     0,  1295,   576,   577,   578,   579,   580,  1296,     0,
     581,   582,   583,   584,   585,   586,  1297,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,  1298,  1299,  1300,  1301,
     606,  1302,  1303,  1304,  1305,   611,   612,   613,   614,  1306,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1307,  1308,     0,     0,     0,   234,     0,  1238,   681,  1310,
    1239,  1240,  1241,   742,  1242,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,  1243,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,   257,  1244,   259,  1245,  1246,     0,   262,
     263,   264,   265,   266,   267,   268,  1247,  1248,   269,   270,
    1249,  1250,   273,     0,   274,   275,   276,   277,  1251,     0,
    1252,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,  1253,  1254,  1255,  1256,  1257,  1258,
    1259,   301,   302,   303,   304,   305,   306,  1260,  1261,   309,
    1262,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   858,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,  1263,   338,   339,   340,   341,
    1264,  1265,   343,     0,   344,   345,   346,  1266,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,  1267,     0,  1268,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,  1269,  1270,     0,  1271,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,  1272,   401,   402,   403,     0,   404,   405,   406,
    1273,  1274,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1275,   424,
    1276,   426,   427,   428,   429,   430,   431,   432,   433,  1277,
     435,  1278,   436,   437,   438,   439,  1279,  1280,   441,  1281,
     443,   444,   445,     0,   446,   447,     0,     0,  1282,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,  1283,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,  1284,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1285,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,  1286,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,  1287,   526,   527,   528,   529,   530,
     531,   532,   533,  1288,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1289,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,  1290,  1291,     0,     0,   563,   564,
    1292,   566,  1293,  1294,   568,   569,   570,   571,   572,   573,
     574,   575,     0,  1295,   576,   577,   578,   579,   580,  1296,
       0,   581,   582,   583,   584,   585,   586,  1297,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,  1298,  1299,  1300,
    1301,   606,  1302,  1303,  1304,  1305,   611,   612,   613,   614,
    1306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1307,  1308,     0,     0,     0,   234,     0,  1238,   681,
    1310,  1239,  1240,  1241,   742,  1242,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,  1243,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,   256,   257,  1244,   259,  1245,  1246,     0,
     262,   263,   264,   265,   266,   267,   268,  1247,  1248,   269,
     270,  1249,  1250,   273,     0,   274,   275,   276,   277,  1251,
       0,  1252,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,   301,   302,   303,   304,   305,   306,  1260,  1261,
     309,  1262,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     858,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,  1263,   338,   339,   340,
     341,  1264,  1265,   343,     0,   344,   345,   346,  1266,   348,
       0,   349,     0,   350,   351,     0,   352,   353,   354,   355,
     356,     0,   357,  1267,     0,  1268,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,   383,   384,   385,  1269,  1270,     0,  1271,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,     0,   399,  1272,   401,   402,   403,     0,   404,   405,
     406,  1273,  1274,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,  1275,
     424,  1276,   426,   427,   428,   429,   430,   431,   432,   433,
    1277,   435,  1278,   436,   437,   438,   439,  1279,  1280,   441,
    1281,   443,   444,   445,     0,   446,   447,     0,     0,  1282,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
    1283,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,  1284,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,  1285,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,  1286,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,  1287,   526,   527,   528,   529,
     530,   531,   532,   533,  1288,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
    1289,   550,     0,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,     0,   560,  1290,  1291,     0,     0,   563,
     564,  1292,   566,  1293,  1294,   568,   569,   570,   571,   572,
     573,   574,   575,     0,  1295,   576,   577,   578,   579,   580,
    1296,     0,   581,   582,   583,   584,   585,   586,  1297,     0,
     588,   589,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,  1298,  1299,
    1300,  1301,   606,  1302,  1303,  1304,  1305,   611,   612,   613,
     614,  1306,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2596,  2597,     0,     0,     0,   234,     0,  3352,
     681,  1310,  1239,  1240,  1241,   742,  1242,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
    1243,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,  1244,   259,  1245,  1246,
       0,   262,   263,   264,   265,   266,   267,   268,  1247,  1248,
     269,   270,  1249,  1250,   273,     0,   274,   275,   276,   277,
    1251,     0,  1252,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,  1253,  1254,  1255,  1256,
    1257,  1258,  1259,   301,   302,   303,   304,   305,   306,  1260,
    1261,   309,  1262,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   858,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,  1263,   338,   339,
     340,   341,  1264,  1265,   343,     0,   344,   345,   346,  1266,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,  1267,     0,  1268,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,  1269,  1270,     0,  1271,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,  1272,   401,   402,   403,     0,   404,
     405,   406,  1273,  1274,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1275,   424,  1276,   426,   427,   428,   429,   430,   431,   432,
     433,  1277,   435,  1278,   436,   437,   438,   439,  1279,  1280,
     441,  1281,   443,   444,   445,     0,   446,   447,     0,     0,
    1282,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,  1283,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,  1284,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1285,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
    1286,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,  1287,   526,   527,   528,
     529,   530,   531,   532,   533,  1288,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,  1289,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,  1290,  1291,     0,     0,
     563,   564,  1292,   566,  1293,  1294,   568,   569,   570,   571,
     572,   573,   574,   575,     0,  1295,   576,   577,   578,   579,
     580,  1296,     0,   581,   582,   583,   584,   585,   586,  1297,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,  1298,
    1299,  1300,  1301,   606,  1302,  1303,  1304,  1305,   611,   612,
     613,   614,  1306,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1307,  1308,     0,     0,     0,   234,     0,
    1238,   681,  1310,  1239,  1240,  1241,   742,  1242,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,  1243,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,  1244,   259,  1245,
    1246,     0,   262,   263,   264,   265,   266,   267,   268,  1247,
    1248,   269,   270,  1249,  1250,   273,     0,   274,   275,   276,
     277,  1251,     0,  1252,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,  4603,  1253,  1254,  1255,
    1256,  1257,  1258,  1259,   301,   302,   303,   304,   305,   306,
    1260,  1261,   309,  1262,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   858,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,  1263,   338,
     339,   340,   341,  1264,  1265,   343,     0,   344,   345,   346,
    1266,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,  1267,     0,  1268,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,  1269,  1270,     0,
    1271,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,  1272,   401,   402,   403,     0,
     404,   405,   406,  1273,  1274,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,  1275,   424,  1276,   426,   427,   428,   429,   430,   431,
     432,   433,  1277,   435,  1278,   436,   437,   438,   439,  1279,
    1280,   441,  1281,   443,   444,   445,     0,   446,   447,     0,
       0,  1282,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,  1283,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,  1284,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,  1285,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,  1286,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,  1287,   526,   527,
     528,   529,   530,   531,   532,   533,  1288,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,  1289,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,  1290,  1291,     0,
       0,   563,   564,  1292,   566,  1293,  1294,   568,   569,   570,
     571,   572,   573,   574,   575,     0,  1295,   576,   577,   578,
     579,   580,  1296,     0,   581,   582,   583,   584,   585,   586,
    1297,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
    1298,  1299,  1300,  1301,   606,  1302,  1303,  1304,  1305,   611,
     612,   613,   614,  1306,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1307,  1308,     0,     0,     0,   234,
       0,  1238,   681,  1310,  1239,  1240,  1241,   742,  1242,     0,
       0,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,  1243,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,   257,  1244,   259,
    1245,  1246,     0,   262,   263,   264,   265,   266,   267,   268,
    1247,  1248,   269,   270,  1249,  1250,   273,     0,   274,   275,
     276,   277,  1251,     0,  1252,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,  1253,  1254,
    1255,  1256,  1257,  1258,  1259,   301,   302,   303,   304,   305,
     306,  1260,  1261,   309,  1262,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   858,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,  1263,
     338,   339,   340,   341,  1264,  1265,   343,     0,   344,   345,
     346,  1266,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,  1267,     0,  1268,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,  1269,  1270,
       0,  1271,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,     0,     0,   399,  1272,   401,   402,   403,
       0,   404,   405,   406,  1273,  1274,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,  1275,   424,  1276,   426,   427,   428,   429,   430,
     431,   432,   433,  1277,   435,  1278,   436,   437,   438,   439,
    1279,  1280,   441,  1281,   443,   444,   445,     0,   446,   447,
       0,     0,  1282,   449,   450,     0,     0,   451,   452,   453,
     454,   455,   456,  1283,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,  1284,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,  1285,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,  1286,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,  1287,   526,
     527,   528,   529,   530,   531,   532,   533,  1288,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,  1289,   550,     0,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,     0,   560,  1290,  1291,
       0,     0,   563,   564,  1292,   566,  1293,  1294,   568,   569,
     570,   571,   572,   573,   574,   575,     0,  1295,   576,   577,
     578,   579,   580,  1296,     0,   581,   582,   583,   584,   585,
     586,  1297,     0,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
    4957,  1298,  1299,  1300,  1301,   606,  1302,  1303,  1304,  1305,
     611,   612,   613,   614,  1306,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1307,  1308,     0,     0,     0,
     234,     0,  1238,   681,  1310,  1239,  1240,  1241,   742,  1242,
       0,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,  1243,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,   257,  1244,
     259,  1245,  1246,     0,   262,   263,   264,   265,   266,   267,
     268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,   274,
     275,   276,   277,  1251,     0,  1252,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,   304,
     305,   306,  1260,  1261,   309,  1262,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   858,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
    1263,   338,   339,   340,   341,  1264,  1265,   343,     0,   344,
     345,   346,  1266,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,  1267,     0,  1268,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,   383,   384,   385,  1269,
    1270,     0,  1271,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,  1272,   401,   402,
     403,     0,   404,   405,   406,  1273,  1274,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,  1275,   424,  1276,   426,   427,   428,   429,
     430,   431,  4969,   433,  1277,   435,  1278,   436,   437,   438,
     439,  1279,  1280,   441,  1281,   443,   444,   445,     0,   446,
     447,     0,     0,  1282,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,  1283,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,  1284,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,  1285,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,  1286,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,  1287,
     526,   527,   528,   529,   530,   531,   532,   533,  1288,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,  1289,   550,     0,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,     0,   560,  1290,
    1291,     0,     0,   563,   564,  1292,   566,  1293,  1294,   568,
     569,   570,   571,   572,   573,   574,   575,     0,  1295,   576,
     577,   578,   579,   580,  1296,     0,   581,   582,   583,   584,
     585,   586,  1297,     0,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,  1298,  1299,  1300,  1301,   606,  1302,  1303,  1304,
    1305,   611,   612,   613,   614,  1306,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1307,  1308,     0,     0,
       0,   234,     0,  1238,   681,  1310,  1239,  1240,  1241,   742,
    1242,     0,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,  1243,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1244,   259,  1245,  1246,     0,   262,   263,   264,   265,   266,
     267,   268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,
     274,   275,   276,   277,  1251,     0,  1252,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,  5279,   299,
    1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,
     304,   305,   306,  1260,  1261,   309,  1262,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   858,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1263,   338,   339,   340,   341,  1264,  1265,   343,     0,
     344,   345,   346,  1266,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,  1267,     0,
    5280,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1269,  1270,     0,  1271,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,  1272,   401,
     402,   403,     0,   404,   405,   406,  1273,  1274,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1275,   424,  1276,   426,   427,   428,
     429,   430,   431,   432,   433,  1277,   435,  1278,   436,   437,
     438,   439,  1279,  1280,   441,  1281,   443,   444,   445,     0,
     446,   447,     0,     0,  1282,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1283,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1284,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1285,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,  5281,   509,   510,  1286,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
    1287,   526,   527,   528,   529,   530,   531,   532,   533,  1288,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1289,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1290,  1291,     0,     0,   563,   564,  1292,   566,  1293,  1294,
     568,   569,   570,   571,   572,   573,   574,   575,     0,  1295,
     576,   577,   578,   579,   580,  1296,     0,   581,   582,   583,
     584,   585,   586,  1297,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,  1303,
    1304,  1305,   611,   612,   613,   614,  1306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1307,  1308,     0,
       0,     0,   234,     0,  1238,   681,  5282,  1239,  1240,  1241,
     742,  1242,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,  1243,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
    5762,  1244,   259,  1245,  1246,     0,   262,   263,   264,   265,
     266,   267,   268,  1247,  1248,   269,   270,  1249,  1250,   273,
       0,   274,   275,   276,   277,  1251,     0,  1252,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
    5763,  1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,
     303,   304,   305,   306,  1260,  1261,   309,  1262,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   858,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,  1263,   338,   339,   340,   341,  1264,  1265,   343,
       0,   344,   345,   346,  1266,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,  1267,
       0,  1268,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,  1269,  1270,     0,  1271,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,  1272,
     401,   402,   403,     0,   404,   405,   406,  1273,  1274,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1275,   424,  1276,   426,   427,
     428,   429,   430,   431,   432,   433,  1277,   435,  1278,   436,
     437,   438,   439,  1279,  1280,   441,  1281,   443,   444,   445,
       0,   446,   447,     0,     0,  1282,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1283,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1284,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1285,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,  1286,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1287,   526,   527,   528,   529,   530,   531,   532,   533,
    1288,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1289,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,  1290,  1291,     0,     0,   563,   564,  1292,   566,  1293,
    1294,   568,   569,   570,   571,   572,  5764,   574,   575,     0,
    1295,   576,   577,   578,   579,   580,  1296,     0,   581,   582,
     583,   584,   585,   586,  1297,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,
    1303,  1304,  1305,   611,   612,   613,   614,  1306,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1307,  1308,
       0,     0,     0,   234,     0,  1238,   681,  1310,  1239,  1240,
    1241,   742,  1242,     0,     0,     0,     0,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,  1243,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,  1244,   259,  1245,  1246,     0,   262,   263,   264,
     265,   266,   267,   268,  1247,  1248,   269,   270,  1249,  1250,
     273,     0,   274,   275,   276,   277,  1251,     0,  1252,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,  5763,  1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,
     302,   303,   304,   305,   306,  1260,  1261,   309,  1262,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   858,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,  1263,   338,   339,   340,   341,  1264,  1265,
     343,     0,   344,   345,   346,  1266,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
    1267,     0,  1268,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,  1269,  1270,     0,  1271,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
    1272,   401,   402,   403,     0,   404,   405,   406,  1273,  1274,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,  1275,   424,  1276,   426,
     427,   428,   429,   430,   431,   432,   433,  1277,   435,  1278,
     436,   437,   438,   439,  1279,  1280,   441,  1281,   443,   444,
     445,     0,   446,   447,     0,     0,  1282,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,  1283,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,  1284,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,  1285,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,  1286,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,  1287,   526,   527,   528,   529,   530,   531,   532,
     533,  1288,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,  1289,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,  1290,  1291,     0,     0,   563,   564,  1292,   566,
    1293,  1294,   568,   569,   570,   571,   572,  5764,   574,   575,
       0,  1295,   576,   577,   578,   579,   580,  1296,     0,   581,
     582,   583,   584,   585,   586,  1297,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,  1298,  1299,  1300,  1301,   606,
    1302,  1303,  1304,  1305,   611,   612,   613,   614,  1306,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1307,
    1308,     0,     0,     0,   234,     0,  1238,   681,  1310,  1239,
    1240,  1241,   742,  1242,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,  1243,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,  1244,   259,  1245,  1246,     0,   262,   263,
     264,   265,   266,   267,   268,  1247,  1248,   269,   270,  1249,
    1250,   273,     0,   274,   275,   276,   277,  1251,     0,  1252,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
     301,   302,   303,   304,   305,   306,  1260,  1261,   309,  5264,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   858,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,  1263,   338,   339,   340,   341,  1264,
    1265,   343,     0,   344,   345,   346,  1266,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,  1267,     0,  1268,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,  1269,  1270,     0,  1271,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,  1272,   401,   402,   403,     0,   404,   405,   406,  1273,
    1274,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,  1275,   424,  1276,
     426,   427,   428,   429,   430,   431,   432,   433,  1277,   435,
       0,   436,   437,   438,   439,  1279,  1280,   441,  1281,   443,
     444,   445,     0,   446,   447,     0,     0,  1282,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,  1283,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,  1284,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1285,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,  3173,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,  1287,   526,   527,   528,   529,   530,   531,
     532,   533,  1288,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,  1289,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,  1290,  1291,     0,     0,   563,   564,  1292,
     566,  1293,  1294,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,  1296,     0,
     581,   582,   583,   584,   585,   586,  1297,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,  1298,  1299,  1300,  1301,
     606,  1302,  1303,  1304,  1305,   611,   612,   613,   614,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3174,  3175,     0,     0,     0,   234,     0,  1238,   681,  3176,
    1239,  1240,  1241,   742,  1242,     0,     0,     0,     0,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,  1243,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256, -2778,  1244,   259,  1245,  1246,     0,   262,
     263,   264,   265,   266,   267,   268,  1247,  1248,   269,   270,
    1249,  1250,   273,     0,   274,   275,   276,   277,  1251,     0,
    1252,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,  5763,  1253,  1254,  1255,  1256,  1257,  1258,
    1259,   301,   302,   303,   304,   305,   306,  1260,  1261,   309,
    1262,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   858,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,  1263,   338,   339,   340,   341,
    1264,  1265,   343,     0,   344,   345,   346,  1266,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,  1267,     0,  1268,   360,   361,     0,   362,   363,
     364,   365,   366, -2778,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,  1269,  1270,     0,  1271,     0,   389,
       0,     0,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,  1272,   401,   402, -2778,     0,   404,   405,   406,
    1273,  1274,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,  1275,   424,
    1276,   426,   427,   428,   429,   430,   431,   432,   433,  1277,
     435,  1278,   436,   437,     0,   439,  1279,  1280,   441,  1281,
     443,   444,   445,     0,   446,   447,     0,     0,  1282,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,  1283,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,  1284,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
    1285,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,  1286,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,  1287,   526,   527,   528,   529,   530,
   -2778,   532,   533,  1288,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1289,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,  1290,  1291,     0,     0,   563,   564,
    1292,   566,  1293,  1294,   568,   569,   570,   571,   572,  5764,
     574,   575,     0,  1295,   576,   577,   578,   579,   580,  1296,
       0,   581,   582,   583,   584,   585,   586,  1297,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,  1298,  1299,  1300,
    1301,   606,  1302,  1303,  1304,  1305,   611,   612,   613,   614,
   -2778,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1307,  1308,     0,     0,     0,   234,     0,  1238,   681,
    1310,  1239,  1240,  1241,   742,  1242,     0,     0,     0,     0,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,  1243,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,   256,   257,  1244,   259,  1245,  1246,     0,
     262,   263,   264,   265,   266,   267,   268,  1247,  1248,   269,
     270,  1249,  1250,   273,     0,   274,   275,   276,   277,  1251,
       0,  1252,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,   301,   302,   303,   304,   305,   306,  1260,  1261,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     858,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,  1263,   338,   339,   340,
     341,  1264,  1265,   343,     0,   344,   345,   346,  1266,   348,
       0,   349,     0,   350,   351,     0,   352,   353,   354,   355,
     356,     0,   357,  1267,     0,  1268,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,   383,   384,   385,  1269,  1270,     0,  1271,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,     0,   399,  1272,   401,   402,   403,     0,   404,   405,
     406,  1273,  1274,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,  1275,
     424,  1276,   426,   427,   428,   429,   430,   431,   432,   433,
    1277,   435,     0,   436,   437,   438,   439,  1279,  1280,   441,
    1281,   443,   444,   445,     0,   446,   447,     0,     0,  1282,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
    1283,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,  1284,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,  1285,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,  3173,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,  1287,   526,   527,   528,   529,
     530,   531,   532,   533,  1288,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
    1289,   550,     0,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,     0,   560,  1290,  1291,     0,     0,   563,
     564,  1292,   566,  1293,  1294,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
    1296,     0,   581,   582,   583,   584,   585,   586,  1297,     0,
     588,   589,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,  1298,  1299,
    1300,  1301,   606,  1302,  1303,  1304,  1305,   611,   612,   613,
     614,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3174,  3175,   234,     0,  1238,   681,     0,  1239,
    1240,  3176,   742,  1242,     0,     0,     0,     0,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,  1243,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,  1244,   259,  1245,  1246,     0,   262,   263,
     264,   265,   266,   267,   268,  1247,  1248,   269,   270,  1249,
    1250,   273,     0,   274,   275,   276,   277,  1251,     0,  1252,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
     301,   302,   303,   304,   305,   306,  1260,  1261,   309,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   858,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,  1263,   338,   339,   340,   341,  1264,
    1265,   343,     0,   344,   345,   346,  1266,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,  1267,     0,  1268,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,  1269,  1270,     0,  1271,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,  1272,   401,   402,   403,     0,   404,   405,   406,  1273,
    1274,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,  1275,   424,  1276,
     426,   427,   428,   429,   430,   431,   432,   433,  1277,   435,
       0,   436,   437,   438,   439,  1279,  1280,   441,  1281,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,  1283,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,  1284,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,  1285,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,  3341,  3342,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,  1287,   526,   527,   528,   529,   530,   531,
     532,   533,  1288,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,  1289,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,  1290,  1291,     0,     0,   563,   564,  1292,
     566,  1293,  1294,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,  1296,     0,
     581,   582,   583,   584,   585,   586,  1297,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,  1298,  1299,  1300,  1301,
     606,  1302,  1303,  1304,  1305,   611,   612,   613,   614,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3343,  3344,   234,     0,  1238,   681,     0,  1239,  1240,  3176,
     742,  1242,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,  1243,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,  1244,   259,  1245,  1246,     0,   262,   263,   264,   265,
     266,   267,   268,  1247,  1248,   269,   270,  1249,  1250,   273,
       0,   274,   275,   276,   277,  1251,     0,  1252,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,
     303,   304,   305,   306,  1260,  1261,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   858,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,  1263,   338,   339,   340,   341,  1264,  1265,   343,
       0,   344,   345,   346,  1266,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,  1267,
       0,  1268,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,  1269,  1270,     0,  1271,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,  1272,
     401,   402,   403,     0,   404,   405,   406,  1273,  1274,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,  1275,   424,  1276,   426,   427,
     428,   429,   430,   431,   432,   433,  1277,   435,     0,   436,
     437,   438,   439,  1279,  1280,   441,  1281,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1283,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1284,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,  1285,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,  3173,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1287,   526,   527,   528,   529,   530,   531,   532,   533,
    1288,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1289,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,  1290,  1291,     0,     0,   563,   564,  1292,   566,  1293,
    1294,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,  1296,     0,   581,   582,
     583,   584,   585,   586,  1297,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,
    1303,  1304,  1305,   611,   612,   613,   614,     0,     0,     0,
       0,   234,     0,  1238,   681,     0,  1239,  1240,     0,   742,
    1242,     0,     0,     0,     0,     0,     0,  3176,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,  1243,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
    1244,   259,  1245,  1246,     0,   262,  4514,   264,   265,   266,
     267,   268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,
     274,   275,   276,   277,  1251,     0,  1252,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
    1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,
     304,   305,   306,  1260,  1261,   309,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   858,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,  1263,   338,   339,   340,   341,  1264,  1265,   343,     0,
     344,   345,   346,  1266,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,  1267,     0,
    1268,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
    1269,  1270,     0,  1271,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,  1272,   401,
     402,   403,     0,   404,   405,   406,  1273,  1274,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,  1275,   424,  1276,   426,   427,   428,
     429,   430,   431,   432,   433,  1277,   435,     0,   436,   437,
     438,   439,  1279,  1280,   441,  1281,   443,   444,   445,     0,
     446,   447,     0,     0,   448,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,  1283,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,  1284,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,  1285,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,  3173,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
    1287,   526,   527,   528,   529,   530,   531,   532,   533,  1288,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,  1289,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
    1290,  1291,     0,     0,   563,   564,  1292,   566,  1293,  1294,
     568,   569,   570,   571,   572,   573,   574,   575,     0,     0,
     576,   577,   578,   579,   580,  1296,     0,   581,   582,   583,
     584,   585,   586,  1297,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,  1303,
    1304,  1305,   611,   612,   613,   614,     0,     0,     0,     0,
     234,     0,  1238,   681,     0,  1239,  1240,     0,   742,  1242,
       0,     0,     0,     0,     0,     0,  3176,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,  1243,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,   257,  1244,
     259,  1245,  1246,     0,   262,   263,   264,   265,   266,   267,
     268,  1247,  1248,   269,   270,  1249,  1250,   273,     0,   274,
     275,   276,   277,  1251,     0,  1252,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,   301,   302,   303,   304,
     305,   306,  1260,  1261,   309,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   858,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
    1263,   338,   339,   340,   341,  1264,  1265,   343,     0,   344,
     345,   346,  1266,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,  1267,     0,  1268,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,   381,   382,   383,   384,   385,  1269,
    1270,     0,  1271,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,  1272,   401,   402,
     403,     0,   404,   405,   406,  1273,  1274,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,  1275,   424,  1276,   426,   427,   428,   429,
     430,   431,   432,   433,  1277,   435,     0,   436,   437,   438,
     439,  1279,  1280,   441,  1281,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,     0,     0,   451,   452,
     453,   454,   455,   456,  1283,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,  1284,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,  1285,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,  3173,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,  1287,
     526,   527,   528,   529,   530,   531,   532,   533,  1288,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,  1289,   550,     0,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,     0,   560,  1290,
    1291,     0,     0,   563,   564,  1292,   566,  1293,  1294,   568,
     569,   570,   571,   572,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,  1296,     0,   581,   582,   583,   584,
     585,   586,  1297,     0,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,  1298,  1299,  1300,  1301,  4572,  1302,  1303,  1304,
    1305,   611,   612,   613,   614,     0,     0,     0,     0,   234,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3176,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,     0,   262,   263,   264,   265,   266,   267,   268,
       0,  1248,   269,   270,   271,   272,   273,     0,   274,   275,
     276,   277,  1251,     0,  1252,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,  1253,  1254,
    1255,  1256,  1257,  1258,  1259,   301,   302,   303,   304,   305,
     306,   307,   308,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   324,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,   337,
     338,   339,   340,   341,  1264,     0,   343,     0,   344,   345,
     346,   347,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,  1267,     0,   359,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,  3316,     0,   399,  1272,   401,   402,   403,
       0,   404,   405,   406,  1273,  1274,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,  1277,   435,     0,   436,   437,   438,   439,
       0,  1280,   441,   442,   443,   444,   445,     0,   446,   447,
       0,   834,   448,   449,   450,     0,     0,   451,   452,   453,
     454,   455,   456,  1283,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,  1284,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,  3317,   513,   514,   515,   516,   517,   518,
     519,   520,    41,   521,   522,   523,   524,   525,  1287,   526,
     527,   528,   529,   530,   531,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,  1289,   550,     0,   551,   552,    45,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   561,   562,
       0,     0,   563,   564,  1292,   566,  1293,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,  1296,     0,   581,   582,   583,   584,   585,
    1171,   587,     0,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,    50,   595,   596,   597,   598,   599,   600,
     601,  1298,  1299,  1300,  1301,   606,  1302,  1303,  1304,  1305,
    3318,   612,   613,   614,     0,     0,    51,     0,   234,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3319,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
    1248,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,  1251,     0,  1252,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,  1253,  1254,  1255,
    1256,  1257,  1258,  1259,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,  1264,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,  1267,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,  3316,     0,   399,  1272,   401,   402,   403,     0,
     404,   405,   406,  1273,  1274,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,  1277,   435,     0,   436,   437,   438,   439,     0,
    1280,   441,   442,   443,   444,   445,     0,   446,   447,     0,
     834,   448,   449,   450,     0,     0,   451,   452,   453,   454,
     455,   456,  1283,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,  1284,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,  3317,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,  1287,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,  1289,   550,     0,   551,   552,     0,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,  1292,   566,  1293,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,  1296,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
    1298,  1299,  1300,  1301,   606,  1302,  1303,  1304,  1305,  3318,
     612,   613,   614,     0,     0,     0,     0,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3319,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,  1248,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
    1251,     0,  1252,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,  1253,  1254,  1255,  1256,
    1257,  1258,  1259,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,  1264,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,  1267,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,  1272,   401,   402,   403,     0,   404,
     405,   406,  1273,  1274,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,  1277,   435,     0,   436,   437,   438,   439,     0,  1280,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,  1283,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,  1284,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,  1287,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,  1289,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,  1292,   566,  1293,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,  1296,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,  1298,
    1299,  1300,  1301,   606,  1302,  1303,  1304,  1305,   611,   612,
     613,   614,     0,     0,     0,     0,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3739,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,     0,
     262,   263,   264,   265,   266,   267,   268,     0,  1248,   269,
     270,   271,   272,   273,     0,   274,   275,   276,   277,  1251,
       0,  1252,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,   301,   302,   303,   304,   305,   306,   307,   308,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     324,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,   337,   338,   339,   340,
     341,  1264,     0,   343,     0,   344,   345,   346,   347,   348,
       0,   349,     0,   350,   351,     0,   352,   353,   354,   355,
     356,     0,   357,  1267,     0,   359,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
     381,   382,   383,   384,   385,   386,   387,     0,   388,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,     0,   399,  1272,   401,   402,   403,     0,   404,   405,
     406,  1273,  1274,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
    1277,   435,     0,   436,   437,   438,   439,     0,  1280,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,     0,     0,   451,   452,   453,   454,   455,   456,
    1283,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,  1284,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
    3317,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,  1287,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
    1289,   550,     0,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,     0,   560,   561,   562,     0,     0,   563,
     564,  1292,   566,  1293,     0,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
    1296,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,   589,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,  1298,  1299,
    1300,  1301,   606,  1302,  1303,  1304,  1305,  3318,   612,   613,
     614,     0,     0,     0,     0,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    57,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,     0,   262,
     263,   264,   265,   266,   267,   268,     0,  1248,   269,   270,
     271,   272,   273,     0,   274,   275,   276,   277,  1251,     0,
    1252,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,  1253,  1254,  1255,  1256,  1257,  1258,
    1259,   301,   302,   303,   304,   305,   306,   307,   308,   309,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   324,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,   337,   338,   339,   340,   341,
    1264,     0,   343,     0,   344,   345,   346,   347,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,  1267,     0,   359,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,   381,
     382,   383,   384,   385,   386,   387,     0,   388,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,  1272,   401,   402,   403,     0,   404,   405,   406,
    1273,  1274,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,  1277,
     435,     0,   436,   437,   438,   439,     0,  1280,   441,   442,
     443,   444,   445,     0,   446,   447,     0,     0,   448,   449,
     450,     0,     0,   451,   452,   453,   454,   455,   456,  1283,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,  1284,   470,   471,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,  1287,   526,   527,   528,   529,   530,
     531,   532,   533,   534,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,  1289,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,   561,   562,     0,     0,   563,   564,
    1292,   566,  1293,     0,   568,   569,   570,   571,   572,   573,
     574,   575,     0,     0,   576,   577,   578,   579,   580,  1296,
       0,   581,   582,   583,   584,   585,   586,   587,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   601,  1298,  1299,  1300,
    1301,   606,  1302,  1303,  1304,  1305,   611,   612,   613,   614,
       0,     0,     0,     0,   234,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4621,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,     0,   262,   263,
     264,   265,   266,   267,   268,     0,  1248,   269,   270,   271,
     272,   273,     0,   274,   275,   276,   277,  1251,     0,  1252,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,
     301,   302,   303,   304,   305,   306,   307,   308,   309,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   324,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,   337,   338,   339,   340,   341,  1264,
       0,   343,     0,   344,   345,   346,   347,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,  1267,     0,   359,   360,   361,     0,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,   381,   382,
     383,   384,   385,   386,   387,     0,   388,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,  1272,   401,   402,   403,     0,   404,   405,   406,  1273,
    1274,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,  1277,   435,
       0,   436,   437,   438,   439,     0,  1280,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
       0,     0,   451,   452,   453,   454,   455,   456,  1283,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,  1284,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,  1287,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,  1289,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,   561,   562,     0,     0,   563,   564,  1292,
     566,  1293,     0,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,  1296,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,  1298,  1299,  1300,  1301,
     606,  1302,  1303,  1304,  1305,   611,   612,   613,   614,     0,
       0,     0,     0,   935,     0,  1555,   681,     0,     0,     0,
       0,   742,     0,     0,     0,     0,     0,     0,     0,  5732,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,  1776,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
     358,     0,   359,   360,   361,     0,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
     400,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,  1777,     0,   448,   449,   450,     0,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,  1778,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,     0,     0,
       0,     0,   935,     0,     0,     0,     0,     0,     0,  1556,
    1557,  5543,     0,     0,     0,     0,     0,     0,  5544,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     3,     4,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,    41,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,    45,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,  1171,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,    50,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,     0,     0,    51,
       0,   234,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    57,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,     0,   262,   263,   264,   265,   266,
     267,   268,     0,     0,   269,   270,   271,   272,   273,     0,
     274,   275,   276,   277,   278,     0,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,     0,   300,     0,     0,     0,   301,   302,   303,
     304,   305,   306,   307,   308,   309,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   324,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,     0,   343,     0,
     344,   345,   346,   347,   348,     0,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,   358,     0,
     359,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,   381,   382,   383,   384,   385,
     386,   387,     0,   388,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,   400,   401,
     402,   403,     0,   404,   405,   406,     0,     0,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
     438,   439,     0,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,     0,   448,   449,   450,     0,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
       0,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
     561,   562,     0,     0,   563,   564,   565,   566,   567,     0,
     568,   569,   570,   571,   572,   573,   574,   575,     0,     0,
     576,   577,   578,   579,   580,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,     0,     0,     0,     0,
     622,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5323,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,     0,   254,   255,   256,   257,   258,
       0,   260,   261,     0,   262,   263,   264,   265,   266,   267,
     268,     0,     0,   269,   270,   271,   272,   273,     0,   274,
     275,   276,   277,   278,     0,     0,     0,   280,   281,   282,
     283,   284,   285,     0,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,     0,   297,   298,   299,     0,
       0,     0,     0,     0,     0,     0,   301,   302,   303,   304,
     305,   306,   307,   308,   309,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   324,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,     0,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
     360,   361,     0,   362,   363,   364,   365,   366,     0,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,     0,   381,   382,   383,   384,   385,   386,
     387,     0,   388,     0,   389,     0,     0,   392,     0,   394,
     395,   396,   397,   398,     0,     0,   399,   400,     0,   402,
       0,     0,   404,   405,   406,     0,     0,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,     0,     0,   451,   452,
     453,     0,   455,     0,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,     0,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,    41,   521,   522,   523,   524,   525,     0,
     526,   527,   528,   529,   530,     0,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,    45,
     553,     0,   555,   556,   557,   558,   559,     0,   560,   561,
     562,     0,     0,   563,   564,   565,   566,   567,     0,   568,
     569,   570,   571,   572,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,     0,   581,   582,   583,   584,
     585,  1171,   587,     0,   588,     0,   590,   591,   592,   593,
       0,     0,   594,     0,    50,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,     0,     0,    51,     0,   622,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    57,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,     0,   254,   255,   256,   257,   258,     0,
     260,   261,     0,   262,   263,   264,   265,   266,   267,   268,
       0,     0,   269,   270,   271,   272,   273,     0,   274,   275,
     276,   277,   278,     0,     0,     0,   280,   281,   282,   283,
     284,   285,     0,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,     0,   297,   298,   299,     0,     0,
       0,     0,     0,     0,     0,   301,   302,   303,   304,   305,
     306,   307,   308,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   324,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,     0,   343,     0,   344,   345,
     346,   347,   348,     0,   349,     0,   350,     0,     0,     0,
     353,   354,   355,   356,     0,   357,   358,     0,   359,   360,
     361,     0,   362,   363,   364,   365,   366,     0,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,     0,   381,   382,   383,   384,   385,   386,   387,
       0,   388,     0,   389,     0,     0,   392,     0,   394,   395,
     396,   397,   398,     0,     0,   399,   400,     0,   402,     0,
       0,   404,   405,   406,     0,     0,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,     0,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   436,   437,     0,   439,
       0,   440,   441,   442,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,     0,     0,   451,   452,   453,
       0,   455,     0,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,   469,   470,   471,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,     0,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,     0,   526,
     527,   528,   529,   530,     0,   532,   533,   534,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,     0,   553,
       0,   555,   556,   557,   558,   559,     0,   560,   561,   562,
       0,     0,   563,   564,   565,   566,   567,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,     0,   581,   582,   583,   584,   585,
     586,   587,     0,   588,     0,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,     0,     0,     0,     0,   622,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1368,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,   275,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,   366,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,     0,     0,     0,     0,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3839,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,     0,     0,     0,     0,   622,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4549,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
       0,   254,   255,   256,   257,   258,     0,   260,   261,     0,
     262,   263,   264,   265,   266,   267,   268,     0,     0,   269,
     270,   271,   272,   273,     0,   274,   275,   276,   277,   278,
       0,     0,     0,   280,   281,   282,   283,   284,   285,     0,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,     0,   297,   298,   299,     0,     0,     0,     0,     0,
       0,     0,   301,   302,   303,   304,   305,   306,   307,   308,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     324,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,     0,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,   360,   361,     0,   362,
     363,   364,   365,   366,     0,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     381,   382,   383,   384,   385,   386,   387,     0,   388,     0,
     389,     0,     0,   392,     0,   394,   395,   396,   397,   398,
       0,     0,   399,   400,     0,   402,     0,     0,   404,   405,
     406,     0,     0,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,     0,     0,   451,   452,   453,     0,   455,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,   469,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,     0,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,     0,   526,   527,   528,   529,
     530,     0,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,     0,   553,     0,   555,   556,
     557,   558,   559,     0,   560,   561,   562,     0,     0,   563,
     564,   565,   566,   567,     0,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,     0,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,     0,     0,     0,     0,     0,     0,     0,   850,     0,
    1555,   681,     0,     0,     0,   950,   742,     0,     0,     0,
       0,  4589,   951,   952,   953,   235,   236,   237,   238,   239,
     240,   241,   242,  1689,   243,   244,   245,  1690,  1691,  1692,
    1693,  1694,  1695,  1696,   246,   247,   248,  1697,   249,   250,
     251,   252,   253,   254,   255,   256,     0,   851,   259,   852,
     853,  1698,   262,   263,   264,   265,   266,   267,   268,  1699,
    1700,   269,   270,   854,   855,   273,  1701,   274,   275,   276,
     277,     0,  1702,   279,  1703,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,  1704,   290,   291,   292,   293,
     294,   295,  1705,   296,   297,   298,   299,  1706,  1707,  1708,
     300,  1709,  1710,  1711,   301,   302,   303,   304,   305,   306,
     856,   857,   309,  1712,   310,  1713,   311,   312,   313,   314,
     315,   316,   317,  1714,   318,   319,   320,   321,  1715,  1716,
     322,   323,   858,   325,   326,  1717,   327,   328,   329,  1718,
     330,   331,   332,  1719,   333,   334,   335,   336,     0,   338,
     339,   340,   341,     0,  1720,   343,  1721,   344,   345,   346,
     859,   348,  1722,   349,  1723,   350,   351,  1724,   352,   353,
     354,   355,   356,  1725,   357,     0,  1726,     0,   360,   361,
    1727,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,  1728,   372,   373,   374,   375,   376,   377,   378,  1729,
     379,   380,     0,   382,   383,   384,   385,   860,   861,  1730,
     862,  1731,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,  1732,  1733,   399,     0,   401,   402,   403,  1734,
     404,   405,   406,  1735,  1736,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   863,   424,   864,   426,   427,   428,   429,   430,   431,
     432,  4288,     0,   435,  1737,   436,   437,   438,   439,  1738,
       0,   441,   865,   443,   444,   445,  1739,   446,   447,  1740,
    1741,  4289,   449,   450,  1742,  1743,   451,   452,     0,   454,
     455,   456,     0,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,  1744,   467,   468,     0,   470,     0,   472,
     473,   474,  1745,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   866,   486,   487,   488,   489,  1746,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,  1747,   503,   504,   505,   506,   507,   508,   509,
     510,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,  1748,   521,   522,   523,   524,   525,  1749,   526,   527,
    2628,   529,   530,   531,   532,   533,   868,   535,  1750,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,     0,   550,  1751,   551,   552,  1752,   553,   554,
     555,   556,   557,   558,   559,  1753,   560,   869,   870,  1754,
    1755,   563,   564,     0,   566,     0,  1756,   568,   569,   570,
     571,   572,   573,   574,   575,  1757,  1758,   576,   577,   578,
     579,   580,  1759,  1760,   581,   582,   583,   584,   585,     0,
     871,  1761,   588,   589,   590,   591,   592,   593,  1762,  1763,
     594,  1764,  1765,   595,   596,   597,   598,   599,   600,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     612,   613,   614,     0,     0,     0,     0,     0,     0,     0,
       0,   956,   957,   958,  4290,  4291,   961,   962,   963,   964,
     850,     0,  1555,   681,     0,     0,     0,   950,   742,     0,
       0,     0,     0,     0,   951,   952,   953,   235,   236,   237,
     238,   239,   240,   241,   242,  1689,   243,   244,   245,  1690,
    1691,  1692,  1693,  1694,  1695,  1696,   246,   247,   248,  1697,
     249,   250,   251,   252,   253,   254,   255,   256,     0,   851,
     259,   852,   853,  1698,   262,   263,   264,   265,   266,   267,
     268,  1699,  1700,   269,   270,   854,   855,   273,  1701,   274,
     275,   276,   277,     0,  1702,   279,  1703,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,  1704,   290,   291,
     292,   293,   294,   295,  1705,   296,   297,   298,   299,  1706,
    1707,  1708,   300,  1709,  1710,  1711,   301,   302,   303,   304,
     305,   306,   856,   857,   309,  1712,   310,  1713,   311,   312,
     313,   314,   315,   316,   317,  1714,   318,   319,   320,   321,
    1715,  1716,   322,   323,   858,   325,   326,  1717,   327,   328,
     329,  1718,   330,   331,   332,  1719,   333,   334,   335,   336,
       0,   338,   339,   340,   341,     0,  1720,   343,  1721,   344,
     345,   346,   859,   348,  1722,   349,  1723,   350,   351,  1724,
     352,   353,   354,   355,   356,  1725,   357,     0,  1726,     0,
     360,   361,  1727,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,  1728,   372,   373,   374,   375,   376,   377,
     378,  1729,   379,   380,     0,   382,   383,   384,   385,   860,
     861,  1730,   862,  1731,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,  1732,  1733,   399,     0,   401,   402,
     403,  1734,   404,   405,   406,  1735,  1736,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   863,   424,   864,   426,   427,   428,   429,
     430,   431,   432,  4713,     0,   435,  1737,   436,   437,   438,
     439,  1738,     0,   441,   865,   443,   444,   445,  1739,   446,
     447,  1740,  1741,  4289,   449,   450,  1742,  1743,   451,   452,
       0,   454,   455,   456,     0,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,  1744,   467,   468,     0,   470,
       0,   472,   473,   474,  1745,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   866,   486,   487,   488,   489,
    1746,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,  1747,   503,   504,   505,   506,   507,
     508,   509,   510,     0,   512,   513,   514,   515,   516,   517,
     518,   519,   520,  1748,   521,   522,   523,   524,   525,  1749,
     526,   527,  2628,   529,   530,   531,   532,   533,   868,   535,
    1750,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,     0,   550,  1751,   551,   552,  1752,
     553,   554,   555,   556,   557,   558,   559,  1753,   560,   869,
     870,  1754,  1755,   563,   564,     0,   566,     0,  1756,   568,
     569,   570,   571,   572,   573,   574,   575,  1757,  1758,   576,
     577,   578,   579,   580,  1759,  1760,   581,   582,   583,   584,
     585,     0,   871,  1761,   588,   589,   590,   591,   592,   593,
    1762,  1763,   594,  1764,  1765,   595,   596,   597,   598,   599,
     600,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   612,   613,   614,     0,     0,     0,     0,     0,
       0,     0,     0,   956,   957,   958,  4290,  4291,   961,   962,
     963,   964,  2044,     0,     0,     0,     0,     0,     0,  2045,
       0,     0,  2046,     0,     0,     0,  2047,  2048,  2049,  2050,
    2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,
    2061,  2062,  2063,  2064,  2065,     0,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,     0,     0,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,     0,  2124,  2125,  2126,
    2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,
    2137,  2138,     0,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,  2149,  2150,  2151,  2152,  2153,  2154,  2155,
    2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,  2165,
    2166,  2167,  2168,  2169,  2170,  2171,  2172,     0,  2173,  2174,
    2175,  2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,
       0,     0,  2185,  2186,  2187,  2188,     0,  2189,  2190,  2191,
    2192,     0,  2193,  2194,  2195,  2196,  2197,     0,  2198,  2199,
       0,  2200,  2201,  2202,     0,  2203,  2204,     0,  2205,  2206,
    2207,  2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,  2216,
    2217,  2218,  2219,  2220,  2221,  2222,  2223,  2224,  2225,  2226,
    2227,  2228,  2229,     0,  2230,     0,  2231,  2232,  2233,  2234,
    2235,  2236,  2237,  2238,  2239,  2240,  2241,  2242,  2243,  2244,
    2245,  2246,  2247,     0,  2248,  2249,  2250,  2251,  2252,  2253,
    2254,  2255,  2256,  2257,  2258,  2259,  2260,  2261,     0,  2262,
    2263,     0,  2264,  2265,  2266,  2267,  2268,  2269,  2270,  2271,
    2272,  2273,  2274,  2275,  2276,  2277,  2278,  2279,  2280,  2281,
    2282,  2283,  2284,  2285,  2286,  2287,  2288,  2289,  2290,  2291,
       0,  2292,  2293,     0,  2294,  2295,  2296,  2297,  2298,     0,
    2299,  2300,  2301,  2302,     0,     0,  2303,  2304,  2305,  2306,
    2307,  2308,  2309,  2310,  2311,  2312,     0,  2313,  2314,  2315,
    2316,  2317,     0,  2318,  2319,  2320,  2321,  2322,  2323,  2324,
    2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,  2334,
    2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,  2343,  2344,
    2345,  2346,  2347,  2348,  2349,  2350,     0,  2351,  2352,  2353,
    2354,  2355,  2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,
    2364,  2365,  2366,     0,  2367,  2368,  2369,  2370,  2371,  2372,
    2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,  2381,  2382,
    2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,  2391,  2392,
    2393,  2394,  2395,  2396,  2397,  2398,  2399,  2400,  2401,  2402,
    2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,  2411,  2412,
    2413,  2414,  2415,     0,  2416,  2417,  2418,  2419,  2420,  2421,
    2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,     0,
    2431,  2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,  2440,
    2441,  2442,  2443,  2444,  2445,  2446,     0,  2447,  2448,  2449,
    2450,  2451,  2452,     0,  2453,     0,     0,     0,     0,  2454,
    2455,  2456,  2457,  2458,  2459,  2460,  2461,  2462,  2463,  2464,
    2465,  2466,  2467,  2468,     0,  2469,  2470,  2471,     0,     0,
       0,     0,     0,     0,     0,  2472,  2473,  2474,  2475,  2476,
    2477,  2478,  2479,  2480,   622,     0,     0,     0,     0,     0,
       0,   950,     0,     0,     0,     0,     0,     0,   951,   952,
     953,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,     0,   254,
     255,   256,   257,   258,     0,   260,   261,     0,   262,   263,
     264,   265,   266,   267,   268,     0,     0,   269,   270,   271,
     272,   273,     0,   274,   954,   276,   277,   278,     0,     0,
       0,   280,   281,   282,   283,   284,   285,     0,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,     0,
     297,   298,   299,     0,     0,     0,     0,     0,     0,     0,
     301,   302,   303,   304,   305,   306,   307,   308,   309,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   324,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   955,     0,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,   360,   361,     0,   362,   363,   364,
     365,   366,     0,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,     0,   381,   382,
     383,   384,   385,   386,   387,     0,   388,     0,   389,     0,
       0,   392,     0,   394,   395,   396,   397,   398,     0,     0,
     399,   400,     0,   402,     0,     0,   404,   405,   406,     0,
       0,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
       0,     0,   451,   452,   453,     0,   455,     0,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,   469,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,     0,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,     0,   526,   527,   528,   529,   530,     0,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,     0,   553,     0,   555,   556,   557,   558,
     559,     0,   560,   561,   562,     0,     0,   563,   564,   565,
     566,   567,     0,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,     0,
       0,     0,     0,     0,     0,     0,     0,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   622,     0,     0,     0,
       0,     0,     0,   950,     0,     0,     0,     0,     0,     0,
     951,   952,   953,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
       0,   254,   255,   256,   257,   258,     0,   260,   261,     0,
     262,   263,   264,   265,   266,   267,   268,     0,     0,   269,
     270,   271,   272,   273,     0,   274,  1069,   276,   277,   278,
       0,     0,     0,   280,   281,   282,   283,   284,   285,     0,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,     0,   297,   298,   299,     0,     0,     0,     0,     0,
       0,     0,   301,   302,   303,   304,   305,   306,   307,   308,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     324,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,  1070,     0,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,   360,   361,     0,   362,
     363,   364,   365,   366,     0,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     381,   382,   383,   384,   385,   386,   387,     0,   388,     0,
     389,     0,     0,   392,     0,   394,   395,   396,   397,   398,
       0,     0,   399,   400,     0,   402,     0,     0,   404,   405,
     406,     0,     0,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,     0,     0,   451,   452,   453,     0,   455,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,   469,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,     0,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,     0,   526,   527,   528,   529,
     530,     0,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,     0,   553,     0,   555,   556,
     557,   558,   559,     0,   560,   561,   562,     0,     0,   563,
     564,   565,   566,   567,     0,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,     0,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,     0,     0,     0,     0,     0,     0,     0,     0,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   622,     0,
       0,     0,     0,     0,     0,   950,     0,     0,     0,     0,
       0,     0,   951,   952,   953,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,     0,   254,   255,   256,   257,   258,     0,   260,
     261,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   271,   272,   273,     0,   274,  1134,   276,
     277,   278,     0,     0,     0,   280,   281,   282,   283,   284,
     285,     0,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,     0,   297,   298,   299,     0,     0,     0,
       0,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     307,   308,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   324,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,  1135,     0,   344,   345,   346,
     347,   348,     0,   349,     0,   350,     0,     0,     0,   353,
     354,   355,   356,     0,   357,   358,     0,   359,   360,   361,
       0,   362,   363,   364,   365,  1136,     0,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,     0,   381,   382,   383,   384,   385,   386,   387,     0,
     388,     0,   389,     0,     0,   392,     0,   394,   395,   396,
     397,   398,     0,     0,   399,   400,     0,   402,     0,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,     0,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   436,   437,     0,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,   453,     0,
     455,     0,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,   469,   470,   471,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,     0,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
     528,   529,   530,     0,   532,   533,   534,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,     0,   553,     0,
     555,   556,   557,   558,   559,     0,   560,   561,   562,     0,
       0,   563,   564,   565,   566,   567,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,   586,
     587,     0,   588,     0,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,     0,     0,     0,     0,     0,     0,     0,
       0,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     622,     0,     0,     0,     0,     0,     0,   950,     0,     0,
       0,     0,     0,     0,   951,   952,   953,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,     0,   254,   255,   256,   257,   258,
       0,   260,   261,     0,   262,   263,   264,   265,   266,   267,
     268,     0,     0,   269,   270,   271,   272,   273,     0,   274,
    1793,   276,   277,   278,     0,     0,     0,   280,   281,   282,
     283,   284,   285,     0,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,     0,   297,   298,   299,     0,
       0,     0,     0,     0,     0,     0,   301,   302,   303,   304,
     305,   306,   307,   308,   309,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   324,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,  1794,     0,   344,
     345,   346,   347,   348,     0,   349,     0,   350,     0,     0,
       0,   353,   354,   355,   356,     0,   357,   358,     0,   359,
     360,   361,     0,   362,   363,   364,   365,   366,     0,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,     0,   381,   382,   383,   384,   385,   386,
     387,     0,   388,     0,   389,     0,     0,   392,     0,   394,
     395,   396,   397,   398,     0,     0,   399,   400,     0,   402,
       0,     0,   404,   405,   406,     0,     0,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,     0,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   436,   437,     0,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,     0,     0,   451,   452,
     453,     0,   455,     0,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,   469,   470,
     471,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,     0,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,     0,
     526,   527,   528,   529,   530,     0,   532,   533,   534,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,     0,
     553,     0,   555,   556,   557,   558,   559,     0,   560,   561,
     562,     0,     0,   563,   564,   565,   566,   567,     0,   568,
     569,   570,   571,   572,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,     0,   581,   582,   583,   584,
     585,   586,   587,     0,   588,     0,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,     0,     0,     0,     0,     0,
       0,     0,     0,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   622,     0,     0,     0,     0,     0,     0,   950,
       0,     0,     0,     0,     0,     0,   951,   952,   953,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,     0,     0,     0,
       0,     0,     0,     0,     0,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   622,     0,     0,     0,     0,     0,
       0,   950,     0,     0,     0,     0,     0,     0,   951,   952,
     953,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,     0,   254,
     255,   256,   257,   258,     0,   260,   261,     0,   262,   263,
     264,   265,   266,   267,   268,     0,     0,   269,   270,   271,
     272,   273,     0,   274,  3434,   276,   277,   278,     0,     0,
       0,   280,   281,   282,   283,   284,   285,     0,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,     0,
     297,   298,   299,     0,     0,     0,     0,     0,     0,     0,
     301,   302,   303,   304,   305,   306,   307,   308,   309,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   324,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,  3435,     0,   344,   345,   346,   347,   348,     0,   349,
       0,   350,     0,     0,     0,   353,   354,   355,   356,     0,
     357,   358,     0,   359,   360,   361,     0,   362,   363,   364,
     365,   366,     0,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,     0,   381,   382,
     383,   384,   385,   386,   387,     0,   388,     0,   389,     0,
       0,   392,     0,   394,   395,   396,   397,   398,     0,     0,
     399,   400,     0,   402,     0,     0,   404,   405,   406,     0,
       0,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,     0,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   436,   437,     0,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
       0,     0,   451,   452,   453,     0,   455,     0,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,   469,   470,   471,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,     0,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,     0,   526,   527,   528,   529,   530,     0,
     532,   533,   534,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,     0,   553,     0,   555,   556,   557,   558,
     559,     0,   560,   561,   562,     0,     0,   563,   564,   565,
     566,   567,     0,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,     0,
     581,   582,   583,   584,   585,   586,   587,     0,   588,     0,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,     0,
       0,     0,     0,     0,     0,     0,     0,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   622,     0,     0,     0,
       0,     0,     0,   950,     0,     0,     0,     0,     0,     0,
     951,   952,   953,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
       0,   254,   255,   256,   257,   258,     0,   260,   261,     0,
     262,   263,   264,   265,   266,   267,   268,     0,     0,   269,
     270,   271,   272,   273,     0,   274,   275,   276,   277,   278,
       0,     0,     0,   280,   281,   282,   283,   284,   285,     0,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,     0,   297,   298,   299,     0,     0,     0,     0,     0,
       0,     0,   301,   302,   303,   304,   305,   306,   307,   308,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     324,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,     0,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,   360,   361,     0,   362,
     363,   364,   365,   366,     0,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     381,   382,   383,   384,   385,   386,   387,     0,   388,     0,
     389,     0,     0,   392,     0,   394,   395,   396,   397,   398,
       0,     0,   399,   400,     0,   402,     0,     0,   404,   405,
     406,     0,     0,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,  5302,
     449,   450,     0,     0,   451,   452,   453,     0,   455,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,   469,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,     0,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,     0,   526,   527,   528,   529,
     530,     0,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,     0,   553,     0,   555,   556,
     557,   558,   559,     0,   560,   561,   562,     0,     0,   563,
     564,   565,   566,   567,     0,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,     0,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,  1688,     0,     0,     0,     0,     0,     0,     0,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   235,   236,
     237,   238,   239,   240,   241,   242,  1689,   243,   244,   245,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,   246,   247,   248,
    1697,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,  1698,   262,   263,   264,   265,   266,
     267,   268,  1699,  1700,   269,   270,   271,   272,   273,  1701,
     274,   275,   276,   277,   278,  1702,   279,  1703,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,  1704,   290,
     291,   292,   293,   294,   295,  1705,   296,   297,   298,   299,
    1706,  1707,  1708,   300,  1709,  1710,  1711,   301,   302,   303,
     304,   305,   306,   307,   308,   309,  1712,   310,  1713,   311,
     312,   313,   314,   315,   316,   317,  1714,   318,   319,   320,
     321,  1715,  1716,   322,   323,   324,   325,   326,  1717,   327,
     328,   329,  1718,   330,   331,   332,  1719,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,  1720,   343,  1721,
     344,   345,   346,   347,   348,  1722,   349,  1723,   350,   351,
    1724,   352,   353,   354,   355,   356,  1725,   357,   358,  1726,
     359,   360,   361,  1727,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,  1728,   372,   373,   374,   375,   376,
     377,   378,  1729,   379,   380,   381,   382,   383,   384,   385,
     386,   387,  1730,   388,  1731,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,  1732,  1733,   399,   400,   401,
     402,   403,  1734,   404,   405,   406,  1735,  1736,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,  1737,   436,   437,
     438,   439,  1738,   440,   441,   442,   443,   444,   445,  1739,
     446,   447,  1740,  1741,   448,   449,   450,  1742,  1743,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,  1744,   467,   468,   469,
     470,   471,   472,   473,   474,  1745,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,  1746,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,  1747,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,  1748,   521,   522,   523,   524,   525,
    1749,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,  1750,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,  1751,   551,   552,
    1752,   553,   554,   555,   556,   557,   558,   559,  1753,   560,
     561,   562,  1754,  1755,   563,   564,   565,   566,   567,  1756,
     568,   569,   570,   571,   572,   573,   574,   575,  1757,  1758,
     576,   577,   578,   579,   580,  1759,  1760,   581,   582,   583,
     584,   585,   586,   587,  1761,   588,   589,   590,   591,   592,
     593,  1762,  1763,   594,  1764,  1765,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   622,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1766,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
       0,   254,   255,   256,   257,   258,     0,   260,   261,     0,
     262,   263,   264,   265,   266,   267,   268,     0,     0,   269,
     270,   271,   272,   273,     0,   274,   275,   276,   277,   278,
       0,     0,     0,   280,   281,   282,   283,   284,   285,     0,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,     0,   297,   298,   299,     0,     0,     0,     0,     0,
       0,     0,   301,   302,   303,   304,   305,   306,   307,   308,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     324,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,     0,   344,   345,   346,   347,   348,
       0,   349,     0,   350,     0,     0,     0,   353,   354,   355,
     356,     0,   357,   358,     0,   359,   360,   361,     0,   362,
     363,   364,   365,   366,     0,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,     0,
     381,   382,   383,   384,   385,   386,   387,     0,   388,     0,
     389,     0,     0,   392,     0,   394,   395,   396,   397,   398,
       0,     0,   399,   400,     0,   402,     0,     0,   404,   405,
     406,     0,     0,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
       0,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   436,   437,     0,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,     0,     0,   451,   452,   453,     0,   455,     0,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,   469,   470,   471,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,     0,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,     0,   526,   527,   528,   529,
     530,     0,   532,   533,   534,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,     0,   553,     0,   555,   556,
     557,   558,   559,     0,   560,   561,   562,     0,     0,   563,
     564,   565,   566,   567,     0,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,     0,   581,   582,   583,   584,   585,   586,   587,     0,
     588,     0,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   622,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   839,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,     0,   254,   255,   256,   257,
     258,     0,   260,   261,     0,   262,   263,   264,   265,   266,
     267,   268,     0,     0,   269,   270,   271,   272,   273,     0,
     274,   275,   276,   277,   278,     0,     0,     0,   280,   281,
     282,   283,   284,   285,     0,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,     0,   297,   298,   299,
       0,     0,     0,     0,     0,     0,     0,   301,   302,   303,
     304,   305,   306,   307,   308,   309,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   324,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,     0,   343,     0,
     344,   345,   346,   347,   348,     0,   349,     0,   350,     0,
       0,     0,   353,   354,   355,   356,     0,   357,   358,     0,
     359,   360,   361,     0,   362,   363,   364,   365,   366,     0,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,     0,   381,   382,   383,   384,   385,
     386,   387,     0,   388,     0,   389,     0,     0,   392,     0,
     394,   395,   396,   397,   398,     0,     0,   399,   400,     0,
     402,     0,     0,   404,   405,   406,     0,     0,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,     0,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   436,   437,
       0,   439,     0,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,     0,   448,   449,   450,     0,     0,   451,
     452,   453,     0,   455,     0,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,   469,
     470,   471,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,     0,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
       0,   526,   527,   528,   529,   530,     0,   532,   533,   534,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
       0,   553,     0,   555,   556,   557,   558,   559,     0,   560,
     561,   562,     0,     0,   563,   564,   565,   566,   567,     0,
     568,   569,   570,   571,   572,   573,   574,   575,     0,     0,
     576,   577,   578,   579,   580,     0,     0,   581,   582,   583,
     584,   585,   586,   587,     0,   588,     0,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   850,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5702,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,   256,     0,   851,   259,   852,   853,     0,
     262,   263,   264,   265,   266,   267,   268,     0,     0,   269,
     270,   854,   855,   273,     0,   274,   275,   276,   277,     0,
       0,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,     0,   300,     0,
       0,     0,   301,   302,   303,   304,   305,   306,   856,   857,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     858,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   338,   339,   340,
     341,     0,     0,   343,     0,   344,   345,   346,   859,   348,
       0,   349,     0,   350,   351,     0,   352,   353,   354,   355,
     356,     0,   357,     0,     0,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,  2624,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
    2625,   382,   383,   384,   385,   860,   861,     0,   862,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,     0,   399,     0,   401,   402,   403,     0,   404,   405,
     406,     0,     0,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   863,
     424,   864,   426,   427,   428,   429,   430,   431,   432,     0,
       0,   435,     0,   436,   437,   438,   439,     0,     0,   441,
     865,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,     0,  2626,   451,   452,  2627,   454,   455,   456,
       0,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,     0,   470,     0,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   866,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,     0,   526,   527,  2628,   529,
     530,   531,   532,   533,   868,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
       0,   550,     0,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,     0,   560,   869,   870,     0,     0,   563,
     564,     0,   566,     0,     0,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,     0,   581,   582,   583,   584,   585,     0,   871,  2629,
     588,   589,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,     0,     0,  3776,
       0,     0,     0,     0,     0,     0,     0,     0,   612,   613,
     614,     0,     0,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,  2630,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,     0,   851,   259,
     852,   853,     0,   262,   263,   264,   265,   266,   267,   268,
       0,     0,   269,   270,   854,   855,   273,     0,   274,   275,
     276,   277,     0,     0,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
       0,   300,     0,     0,     0,   301,   302,   303,   304,   305,
     306,   856,   857,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   858,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     338,   339,   340,   341,     0,     0,   343,     0,   344,   345,
     346,   859,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,     0,     0,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,  2624,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,  2625,   382,   383,   384,   385,   860,   861,
       0,   862,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,     0,     0,   399,     0,   401,   402,   403,
       0,   404,   405,   406,     0,     0,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   863,   424,   864,   426,   427,   428,   429,   430,
     431,   432,     0,     0,   435,     0,   436,   437,   438,   439,
       0,     0,   441,   865,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,     0,  2626,   451,   452,  2627,
     454,   455,   456,     0,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,     0,   470,     0,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   866,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,     0,   526,
     527,  2628,   529,   530,   531,   532,   533,   868,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   550,     0,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   869,   870,
       0,     0,   563,   564,     0,   566,     0,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,     0,   581,   582,   583,   584,   585,
       0,   871,  2629,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
       0,     0,   935,     0,  1555,   681,     0,     0,     0,     0,
     742,   612,   613,   614,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,  2630,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,  2517,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,  1776,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,  1777,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
    1778,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   935,     0,  1555,
     681,     0,     0,     0,     0,   742,     0,     0,  1556,  1557,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,  2522,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,  1776,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,  1777,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,  1778,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   935,     0,  1555,   681,     0,     0,     0,     0,
     742,     0,     0,  1556,  1557,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,  1776,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,  1777,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
    1778,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   935,     0,     0,
     681,     0,     0,     0,     0,   742,     0,     0,  1556,  1557,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,  3395,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,  1776,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,  1777,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,  1778,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
     742,     0,     0,   754,   755,     0,     0,     0,     0,   235,
     743,   237,   238,   239,   240,   241,   242,   744,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   745,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   746,   347,   348,     0,   349,     0,   747,
       0,   748,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,   749,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   750,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   751,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   752,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   753,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,  1688,     0,  5963,
     681,     0,     0,     0,     0,   742,     0,     0,   754,   755,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,  1689,   243,   244,   245,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,   246,   247,   248,  1697,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
    1698,   262,   263,   264,   265,   266,   267,   268,  1699,  1700,
     269,   270,   271,   272,   273,  1701,   274,   275,   276,   277,
     278,  1702,   279,  1703,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,  1704,   290,   291,   292,   293,   294,
     295,  1705,   296,   297,   298,   299,  1706,  1707,  1708,   300,
    1709,  1710,  1711,   301,   302,   303,   304,   305,   306,   307,
     308,   309,  1712,   310,  1713,   311,   312,   313,   314,   315,
     316,   317,  1714,   318,   319,   320,   321,  1715,  1716,   322,
     323,   324,   325,   326,  1717,   327,   328,   329,  1718,   330,
     331,   332,  1719,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,  1720,   343,  1721,   344,   345,   346,   347,
     348,  1722,   349,  1723,   350,   351,  1724,   352,   353,   354,
     355,   356,  1725,   357,   358,  1726,   359,   360,   361,  1727,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
    1728,   372,   373,   374,   375,   376,   377,   378,  1729,   379,
     380,   381,   382,   383,   384,   385,   386,   387,  1730,   388,
    1731,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,  1732,  1733,   399,   400,   401,   402,   403,  1734,   404,
     405,   406,  1735,  1736,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,  1737,   436,   437,   438,   439,  1738,   440,
     441,   442,   443,   444,   445,  1739,   446,   447,  1740,  1741,
     448,   449,   450,  1742,  1743,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,  1744,   467,   468,   469,   470,   471,   472,   473,
     474,  1745,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,  1746,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,  1747,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
    1748,   521,   522,   523,   524,   525,  1749,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,  1750,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,  1751,   551,   552,  1752,   553,   554,   555,
     556,   557,   558,   559,  1753,   560,   561,   562,  1754,  1755,
     563,   564,   565,   566,   567,  1756,   568,   569,   570,   571,
     572,   573,   574,   575,  1757,  1758,   576,   577,   578,   579,
     580,  1759,  1760,   581,   582,   583,   584,   585,   586,   587,
    1761,   588,   589,   590,   591,   592,   593,  1762,  1763,   594,
    1764,  1765,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,  1688,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,  1689,   243,   244,
     245,  1690,  1691,  1692,  1693,  1694,  1695,  1696,   246,   247,
     248,  1697,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,  1698,   262,   263,   264,   265,
     266,   267,   268,  1699,  1700,   269,   270,   271,   272,   273,
    1701,   274,   275,   276,   277,   278,  1702,   279,  1703,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,  1704,
     290,   291,   292,   293,   294,   295,  1705,   296,   297,   298,
     299,  1706,  1707,  1708,   300,  1709,  1710,  1711,   301,   302,
     303,   304,   305,   306,   307,   308,   309,  1712,   310,  1713,
     311,   312,   313,   314,   315,   316,   317,  1714,   318,   319,
     320,   321,  1715,  1716,   322,   323,   324,   325,   326,  1717,
     327,   328,   329,  1718,   330,   331,   332,  1719,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,  1720,   343,
    1721,   344,   345,   346,   347,   348,  1722,   349,  1723,   350,
     351,  1724,   352,   353,   354,   355,   356,  1725,   357,   358,
    1726,   359,   360,   361,  1727,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,  1728,   372,   373,   374,   375,
     376,   377,   378,  1729,   379,   380,   381,   382,   383,   384,
     385,   386,   387,  1730,   388,  1731,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,  1732,  1733,   399,   400,
     401,   402,   403,  1734,   404,   405,   406,  1735,  1736,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,  1737,   436,
     437,   438,   439,  1738,   440,   441,   442,   443,   444,   445,
    1739,   446,   447,  1740,  1741,   448,   449,   450,  1742,  1743,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,  1744,   467,   468,
     469,   470,   471,   472,   473,   474,  1745,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,  1746,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,  1747,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,  1748,   521,   522,   523,   524,
     525,  1749,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,  1750,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,  1751,   551,
     552,  1752,   553,   554,   555,   556,   557,   558,   559,  1753,
     560,   561,   562,  1754,  1755,   563,   564,   565,   566,   567,
    1756,   568,   569,   570,   571,   572,   573,   574,   575,  1757,
    1758,   576,   577,   578,   579,   580,  1759,  1760,   581,   582,
     583,   584,   585,   586,   587,  1761,   588,   589,   590,   591,
     592,   593,  1762,  1763,   594,  1764,  1765,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,  1688,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,  3500,   240,
     241,   242,  1689,   243,   244,   245,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,   246,   247,   248,  1697,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
    1698,   262,   263,   264,   265,   266,   267,   268,  1699,  1700,
     269,   270,   271,   272,   273,  1701,   274,   275,   276,   277,
     278,  1702,   279,  1703,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,  1704,   290,   291,   292,   293,   294,
     295,  1705,   296,   297,   298,   299,  1706,  1707,  1708,   300,
    1709,  1710,  1711,   301,   302,   303,   304,   305,   306,   307,
     308,   309,  1712,   310,  1713,   311,   312,   313,   314,   315,
     316,   317,  1714,   318,   319,   320,   321,  1715,  1716,   322,
     323,   324,  3501,   326,  1717,   327,   328,   329,  1718,   330,
     331,   332,  1719,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,  1720,   343,  1721,   344,   345,   346,   347,
     348,  1722,   349,  1723,   350,   351,  1724,   352,   353,   354,
     355,   356,  1725,   357,   358,  1726,   359,   360,   361,  1727,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
    1728,   372,   373,   374,   375,   376,   377,   378,  1729,   379,
     380,   381,   382,   383,   384,   385,   386,   387,  1730,   388,
    1731,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,  1732,  1733,   399,   400,   401,   402,   403,  1734,   404,
     405,   406,  1735,  1736,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,  1737,   436,   437,   438,   439,  1738,   440,
     441,   442,   443,   444,   445,  1739,   446,   447,  1740,  1741,
     448,   449,   450,  1742,  1743,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,  1744,   467,   468,   469,   470,   471,   472,   473,
     474,  1745,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,  1746,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,  1747,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
    1748,   521,   522,   523,   524,   525,  1749,  3502,   527,   528,
     529,   530,   531,   532,   533,   534,   535,  1750,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,  1751,   551,   552,  1752,   553,   554,   555,
     556,   557,   558,   559,  1753,   560,   561,   562,  1754,  1755,
     563,   564,   565,   566,   567,  1756,   568,   569,   570,   571,
     572,   573,   574,   575,  1757,  1758,   576,   577,   578,   579,
     580,  1759,  1760,   581,   582,   583,   584,   585,   586,   587,
    1761,   588,   589,   590,   591,   592,   593,  1762,  1763,   594,
    1764,  1765,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,  1248,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,  1251,     0,  1252,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,  1253,  1254,  1255,  1256,  1257,  1258,  1259,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,  1264,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,  1267,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,  1272,
     401,   402,   403,     0,   404,   405,   406,  1273,  1274,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,  1277,   435,     0,   436,
     437,   438,   439,     0,  1280,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,  1283,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
    1284,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,  1287,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,  1289,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,  1292,   566,  1293,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,  1296,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,  1298,  1299,  1300,  1301,   606,  1302,
    1303,  1304,  1305,   611,   612,   613,   614,   234,     0,  1238,
     681,     0,  1239,  1240,     0,   742,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,  1244,   259,  1245,  1246,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,  1249,  1250,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,  1260,
    1261,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   858,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,  1265,   343,     0,   344,   345,   346,  1266,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,  1269,  1270,     0,  1271,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
    1275,   424,  1276,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,  1279,   440,
     441,  1281,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,  1285,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,  1288,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,  1290,  1291,     0,     0,
     563,   564,   565,   566,   567,  1294,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,  1297,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   935,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   974,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   936,   300,     0,     0,   937,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,   938,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   935,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   995,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   936,   300,
       0,     0,   937,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   996,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,   938,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   935,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   936,   300,     0,     0,   937,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,   938,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,  2881,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   935,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   936,   300,
       0,     0,   937,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,  3855,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,   938,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   935,     0,     0,   681,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,  1776,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,  1777,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
    1778,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   935,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   936,   300,
       0,     0,   937,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,   938,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   935,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   936,   300,     0,     0,   937,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,  1087,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,   938,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   935,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   936,   300,
       0,     0,   937,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1129,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,   938,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   935,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,   936,   300,     0,     0,   937,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1142,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,   938,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   935,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,   936,   300,
       0,     0,   937,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1154,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,  1155,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,   938,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   935,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     3,     4,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   935,     0,     0,
     681,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,  2502,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   935,     0,     0,   681,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1113,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1126,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   234,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1140,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   234,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1144,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,   400,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   935,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,   400,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,  2662,   274,   275,   276,   277,
     278,     0,     0,  2731,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,  2663,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,  2732,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,  2665,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  2733,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,  2666,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,  2667,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
    2662,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,  2663,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,  2732,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,  2665,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,  3709,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,  2666,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
    2667,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   802,
     241,   242,   761,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,   762,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,   803,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   763,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
     764,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   761,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,   762,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,  3402,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   763,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   764,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,  2662,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,  2663,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,  2732,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,  2665,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,  2666,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,  2667,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   761,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,   762,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   763,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   764,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,  1955,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,  1956,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
    1957,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,  1958,   350,     0,     0,     0,  1959,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,  1960,  1961,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,  1962,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,  1963,   510,
     511,   512,   513,   514,  1964,   516,   517,   518,   519,   520,
       0,  1965,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,  1966,   553,     0,  1967,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,  1968,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,   762,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   763,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   764,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   988,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   989,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,   834,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,  3481,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,  3482,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,  3494,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,  3495,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   623,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   672,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   673,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   794,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     795,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   796,   562,     0,     0,   797,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,   828,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   829,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   830,   562,     0,     0,
     831,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,   834,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,   891,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   945,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   946,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,  1105,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,   794,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,  1212,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,  1343,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,  1354,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     814,   270,   271,   272,  1355,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   817,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   818,   507,   508,   509,   510,
     511,   512,   513,   514,   819,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,  1347,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   821,   562,     0,     0,
     822,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   823,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1499,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,   834,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,  1560,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1561,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,  3265,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,  3266,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,  3267,   553,     0,   555,  3268,   557,  3269,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,  3270,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
     681,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
     742,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,  4034,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,  4048,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,  4657,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     780,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   792,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     814,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   815,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   816,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   817,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   818,   507,   508,   509,   510,
     511,   512,   513,   514,   819,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   820,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   821,   562,     0,     0,
     822,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   823,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     845,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   970,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   980,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   983,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   999,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1054,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1059,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1076,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1079,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1081,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1118,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1146,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1148,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1158,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1161,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1164,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   814,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   817,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     818,   507,   508,   509,   510,   511,   512,   513,   514,   819,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
    1347,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   821,   562,     0,     0,   822,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   823,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1819,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1853,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1855,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1894,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  1896,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  1898,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,  1992,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,  2617,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,     0,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     814,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   817,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   818,   507,   508,   509,   510,
     511,   512,   513,   514,   819,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,  1347,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,  2649,
     556,   557,   558,   559,     0,   560,   821,   562,     0,     0,
     822,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   823,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   814,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   817,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     818,   507,   508,   509,   510,   511,   512,   513,   514,  2714,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
    2715,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   821,   562,     0,     0,  2716,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   823,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     814,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   817,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   818,   507,   508,   509,   510,
     511,   512,   513,   514,  2793,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,  2715,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   821,   562,     0,     0,
    2716,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   823,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   814,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   817,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     818,   507,   508,   509,   510,   511,   512,   513,   514,  2810,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
    2715,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   821,   562,     0,     0,  2716,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   823,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  3003,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  3007,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  3065,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  3413,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     814,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,   366,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   817,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   818,   507,   508,   509,   510,
     511,   512,   513,   514,   819,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,  2715,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   821,   562,     0,     0,
    2716,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   823,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  3470,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  3484,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,  3486,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  3630,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   622,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,     0,   254,   255,   256,
     257,   258,     0,   260,   261,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   271,   272,   273,
       0,   274,   275,   276,   277,   278,     0,     0,     0,   280,
     281,   282,   283,   284,   285,     0,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,     0,   297,   298,
     299,     0,     0,     0,     0,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   307,   308,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,  3670,   324,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
       0,   344,   345,   346,   347,   348,     0,   349,     0,   350,
       0,     0,     0,   353,   354,   355,   356,     0,   357,   358,
       0,   359,   360,   361,     0,   362,   363,   364,   365,   366,
       0,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,     0,   381,   382,   383,   384,
     385,   386,   387,     0,   388,     0,   389,     0,     0,   392,
       0,   394,   395,   396,   397,   398,     0,     0,   399,   400,
       0,   402,     0,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,     0,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,     0,   436,
     437,     0,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,   453,     0,   455,     0,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
     469,   470,   471,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,     0,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   528,   529,   530,     0,   532,   533,
     534,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,     0,   553,     0,   555,   556,   557,   558,   559,     0,
     560,   561,   562,     0,     0,   563,   564,   565,   566,   567,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,   586,   587,     0,   588,     0,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   622,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,     0,   254,   255,   256,   257,   258,     0,   260,   261,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,   271,   272,   273,     0,   274,   275,   276,   277,
     278,     0,     0,     0,   280,   281,   282,   283,   284,   285,
       0,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,     0,   297,   298,   299,     0,     0,     0,     0,
       0,     0,     0,   301,   302,   303,   304,   305,   306,   307,
     308,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,     0,   344,   345,   346,   347,
     348,     0,   349,     0,   350,     0,     0,     0,   353,   354,
     355,   356,     0,   357,   358,     0,   359,   360,   361,     0,
     362,   363,   364,   365,  4835,     0,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
       0,   381,   382,   383,   384,   385,   386,   387,     0,   388,
       0,   389,     0,     0,   392,     0,   394,   395,   396,   397,
     398,     0,     0,   399,   400,     0,   402,     0,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,     0,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,     0,   436,   437,     0,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,   453,     0,   455,
       0,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,   469,   470,   471,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,     0,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,   528,
     529,   530,     0,   532,   533,   534,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,     0,   553,     0,   555,
     556,   557,   558,   559,     0,   560,   561,   562,     0,     0,
     563,   564,   565,   566,   567,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,   586,   587,
       0,   588,     0,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   850,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
       0,   851,   259,   852,   853,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   854,   855,   273,
       0,   274,   275,   276,   277,     0,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   856,   857,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   858,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   338,   339,   340,   341,     0,     0,   343,
       0,   344,   345,   346,   859,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,     0,
       0,     0,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,  2624,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,  2625,   382,   383,   384,
     385,   860,   861,     0,   862,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,     0,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   863,   424,   864,   426,   427,
     428,   429,   430,   431,   432,     0,     0,   435,     0,   436,
     437,   438,   439,     0,     0,   441,   865,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,  2627,   454,   455,   456,     0,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
       0,   470,     0,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   866,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,     0,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,  2628,   529,   530,   531,   532,   533,
     868,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,     0,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   869,   870,     0,     0,   563,   564,     0,   566,     0,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,     0,   871,  2629,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   622,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   612,   613,   614,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,     0,   254,   255,
     256,   257,   258,     0,   260,   261,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   271,   272,
     273,     0,   274,   275,   276,   277,   278,     0,     0,     0,
     280,   281,   282,   283,   284,   285,     0,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,     0,   297,
     298,   299,     0,     0,     0,     0,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   307,   308,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   324,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,     0,
     343,     0,   344,   345,   346,   347,   348,     0,   349,     0,
     350,     0,     0,     0,   353,   354,   355,   356,     0,   357,
     358,     0,   359,     0,   361,     0,   362,   363,   364,   365,
     366,     0,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,     0,   381,   382,   383,
     384,   385,   386,   387,     0,   388,     0,   389,     0,     0,
     392,     0,   394,   395,   396,   397,   398,     0,     0,   399,
     400,     0,   402,     0,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,     0,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,     0,
     436,   437,     0,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,   453,     0,   455,     0,   457,   458,   459,
     460,   461,   462,   463,     0,   465,   466,     0,     0,   467,
     468,   469,   470,   471,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,     0,   484,   485,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
       0,   506,   507,   508,   509,   510,   511,     0,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   528,   529,   530,     0,   532,
     533,   534,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,     0,   553,     0,   555,   556,   557,   558,   559,
       0,   560,   561,   562,     0,     0,   563,   564,   565,   566,
     567,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,   586,   587,     0,   588,     0,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   850,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   235,   236,   237,   238,   239,
     240,   241,   242,     0,   243,   244,   245,     0,     0,     0,
       0,     0,     0,     0,   246,   247,   248,     0,   249,   250,
     251,   252,   253,   254,   255,   256,     0,   851,   259,   852,
     853,     0,   262,   263,   264,   265,   266,   267,   268,     0,
       0,   269,   270,   854,   855,   273,     0,   274,   275,   276,
     277,     0,     0,   279,     0,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,     0,   290,   291,   292,   293,
     294,   295,     0,   296,   297,   298,   299,     0,     0,     0,
     300,     0,     0,     0,   301,   302,   303,   304,   305,   306,
     856,   857,   309,     0,   310,     0,   311,   312,   313,   314,
     315,   316,   317,     0,   318,   319,   320,   321,     0,     0,
     322,   323,   858,   325,   326,     0,   327,   328,   329,     0,
     330,   331,   332,     0,   333,   334,   335,   336,     0,   338,
     339,   340,   341,     0,     0,   343,     0,   344,   345,   346,
     859,   348,     0,   349,     0,   350,   351,     0,   352,   353,
     354,   355,   356,     0,   357,     0,     0,     0,   360,   361,
       0,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,     0,   372,   373,   374,   375,   376,   377,   378,     0,
     379,   380,     0,   382,   383,   384,   385,   860,   861,     0,
     862,     0,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,     0,     0,   399,     0,   401,   402,   403,     0,
     404,   405,   406,     0,     0,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   863,   424,   864,   426,   427,   428,   429,   430,   431,
     432,     0,     0,   435,     0,   436,   437,   438,   439,  2710,
       0,   441,   865,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,     0,     0,   451,   452,     0,   454,
     455,   456,     0,   458,   459,   460,   461,   462,   463,   464,
     465,   466,     0,     0,   467,   468,     0,   470,     0,   472,
     473,   474,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   866,   486,   487,   488,   489,     0,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   521,   522,   523,   524,   525,     0,   526,   527,
    2628,   529,   530,   531,   532,   533,   868,   535,     0,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,     0,   550,     0,   551,   552,  4388,   553,   554,
     555,   556,   557,   558,   559,     0,   560,   869,   870,     0,
       0,   563,   564,     0,   566,     0,     0,   568,   569,   570,
     571,   572,   573,   574,   575,     0,     0,   576,   577,   578,
     579,   580,     0,     0,   581,   582,   583,   584,   585,     0,
     871,     0,   588,   589,   590,   591,   592,   593,     0,     0,
     594,     0,     0,   595,   596,   597,   598,   599,   600,   850,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     612,   613,   614,     0,     0,     0,   235,   236,   237,   238,
     239,   240,   241,   242,     0,   243,   244,   245,     0,     0,
       0,     0,     0,     0,     0,   246,   247,   248,     0,   249,
     250,   251,   252,   253,   254,   255,   256,     0,   851,   259,
     852,   853,     0,   262,   263,   264,   265,   266,   267,   268,
       0,     0,   269,   270,   854,   855,   273,     0,   274,   275,
     276,   277,     0,     0,   279,     0,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,     0,   290,   291,   292,
     293,   294,   295,     0,   296,   297,   298,   299,     0,     0,
       0,   300,     0,     0,     0,   301,   302,   303,   304,   305,
     306,   856,   857,   309,     0,   310,     0,   311,   312,   313,
     314,   315,   316,   317,     0,   318,   319,   320,   321,     0,
       0,   322,   323,   858,   325,   326,     0,   327,   328,   329,
       0,   330,   331,   332,     0,   333,   334,   335,   336,     0,
     338,   339,   340,   341,     0,     0,   343,     0,   344,   345,
     346,   859,   348,     0,   349,     0,   350,   351,     0,   352,
     353,   354,   355,   356,     0,   357,     0,     0,     0,   360,
     361,     0,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,     0,   372,   373,   374,   375,   376,   377,   378,
       0,   379,   380,     0,   382,   383,   384,   385,   860,   861,
       0,   862,     0,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,     0,     0,   399,     0,   401,   402,   403,
       0,   404,   405,   406,     0,     0,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   863,   424,   864,   426,   427,   428,   429,   430,
     431,   432,  2783,     0,   435,     0,   436,   437,   438,   439,
       0,     0,   441,   865,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,     0,     0,   451,   452,     0,
     454,   455,   456,     0,   458,   459,   460,   461,   462,   463,
     464,   465,   466,     0,     0,   467,   468,     0,   470,     0,
     472,   473,   474,     0,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   866,   486,   487,   488,   489,     0,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,     0,   512,   513,   514,   515,   516,   517,   518,
     519,   520,     0,   521,   522,   523,   524,   525,     0,   526,
     527,   867,   529,   530,   531,   532,   533,   868,   535,     0,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,     0,   550,     0,   551,   552,     0,   553,
     554,   555,   556,   557,   558,   559,     0,   560,   869,   870,
       0,     0,   563,   564,     0,   566,     0,     0,   568,   569,
     570,   571,   572,   573,   574,   575,     0,     0,   576,   577,
     578,   579,   580,     0,     0,   581,   582,   583,   584,   585,
       0,   871,     0,   588,   589,   590,   591,   592,   593,     0,
       0,   594,     0,     0,   595,   596,   597,   598,   599,   600,
     850,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   612,   613,   614,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,   242,     0,   243,   244,   245,     0,
       0,     0,     0,     0,     0,     0,   246,   247,   248,     0,
     249,   250,   251,   252,   253,   254,   255,   256,     0,   851,
     259,   852,   853,     0,   262,   263,   264,   265,   266,   267,
     268,     0,     0,   269,   270,   854,   855,   273,     0,   274,
     275,   276,   277,     0,     0,   279,     0,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,     0,   290,   291,
     292,   293,   294,   295,     0,   296,   297,   298,   299,     0,
       0,     0,   300,     0,     0,     0,   301,   302,   303,   304,
     305,   306,   856,   857,   309,     0,   310,     0,   311,   312,
     313,   314,   315,   316,   317,     0,   318,   319,   320,   321,
       0,     0,   322,   323,   858,   325,   326,     0,   327,   328,
     329,     0,   330,   331,   332,     0,   333,   334,   335,   336,
       0,   338,   339,   340,   341,     0,     0,   343,     0,   344,
     345,   346,   859,   348,     0,   349,     0,   350,   351,     0,
     352,   353,   354,   355,   356,     0,   357,     0,     0,     0,
     360,   361,     0,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,     0,   372,   373,   374,   375,   376,   377,
     378,     0,   379,   380,     0,   382,   383,   384,   385,   860,
     861,     0,   862,     0,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,     0,     0,   399,     0,   401,   402,
     403,     0,   404,   405,   406,     0,     0,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   863,   424,   864,   426,   427,   428,   429,
     430,   431,   432,  4192,     0,   435,     0,   436,   437,   438,
     439,     0,     0,   441,   865,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,     0,     0,   451,   452,
       0,   454,   455,   456,     0,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,   467,   468,     0,   470,
       0,   472,   473,   474,     0,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   866,   486,   487,   488,   489,
       0,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,     0,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,   521,   522,   523,   524,   525,     0,
     526,   527,   867,   529,   530,   531,   532,   533,   868,   535,
       0,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,     0,   550,     0,   551,   552,     0,
     553,   554,   555,   556,   557,   558,   559,     0,   560,   869,
     870,     0,     0,   563,   564,     0,   566,     0,     0,   568,
     569,   570,   571,   572,   573,   574,   575,     0,     0,   576,
     577,   578,   579,   580,     0,     0,   581,   582,   583,   584,
     585,     0,   871,     0,   588,   589,   590,   591,   592,   593,
       0,     0,   594,     0,     0,   595,   596,   597,   598,   599,
     600,   850,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   612,   613,   614,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,   242,     0,   243,   244,   245,
       0,     0,     0,     0,     0,     0,     0,   246,   247,   248,
       0,   249,   250,   251,   252,   253,   254,   255,   256,     0,
     851,   259,   852,   853,     0,   262,   263,   264,   265,   266,
     267,   268,     0,     0,   269,   270,   854,   855,   273,     0,
     274,   275,   276,   277,     0,     0,   279,     0,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,     0,   290,
     291,   292,   293,   294,   295,     0,   296,   297,   298,   299,
       0,     0,     0,   300,     0,     0,     0,   301,   302,   303,
     304,   305,   306,   856,   857,   309,     0,   310,     0,   311,
     312,   313,   314,   315,   316,   317,     0,   318,   319,   320,
     321,     0,     0,   322,   323,   858,   325,   326,     0,   327,
     328,   329,     0,   330,   331,   332,     0,   333,   334,   335,
     336,     0,   338,   339,   340,   341,     0,     0,   343,     0,
     344,   345,   346,   859,   348,  5654,   349,     0,   350,   351,
       0,   352,   353,   354,   355,   356,     0,   357,     0,     0,
       0,   360,   361,     0,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,     0,   372,   373,   374,   375,   376,
     377,   378,     0,   379,   380,     0,   382,   383,   384,   385,
     860,   861,     0,   862,     0,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,     0,     0,   399,     0,   401,
     402,   403,     0,   404,   405,   406,     0,     0,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   863,   424,   864,   426,   427,   428,
     429,   430,   431,   432,     0,     0,   435,     0,   436,   437,
     438,   439,     0,     0,   441,   865,   443,   444,   445,     0,
     446,   447,     0,     0,   448,   449,   450,     0,     0,   451,
     452,     0,   454,   455,   456,     0,   458,   459,   460,   461,
     462,   463,   464,   465,   466,     0,     0,   467,   468,     0,
     470,     0,   472,   473,   474,     0,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   866,   486,   487,   488,
     489,     0,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,     0,   512,   513,   514,   515,   516,
     517,   518,   519,   520,     0,   521,   522,   523,   524,   525,
       0,   526,   527,   867,   529,   530,   531,   532,   533,   868,
     535,     0,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,     0,   550,     0,   551,   552,
       0,   553,   554,   555,   556,   557,   558,   559,     0,   560,
     869,   870,     0,     0,   563,   564,     0,   566,     0,     0,
     568,   569,   570,   571,   572,   573,   574,   575,     0,     0,
     576,   577,   578,   579,   580,     0,     0,   581,   582,   583,
     584,   585,     0,   871,     0,   588,   589,   590,   591,   592,
     593,     0,     0,   594,     0,     0,   595,   596,   597,   598,
     599,   600,   850,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   612,   613,   614,     0,     0,     0,   235,
     236,   237,   238,   239,   240,   241,   242,     0,   243,   244,
     245,     0,     0,     0,     0,     0,     0,     0,   246,   247,
     248,     0,   249,   250,   251,   252,   253,   254,   255,   256,
       0,   851,   259,   852,   853,     0,   262,   263,   264,   265,
     266,   267,   268,     0,     0,   269,   270,   854,   855,   273,
       0,   274,   275,   276,   277,     0,     0,   279,     0,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,     0,
     290,   291,   292,   293,   294,   295,     0,   296,   297,   298,
     299,     0,     0,     0,   300,     0,     0,     0,   301,   302,
     303,   304,   305,   306,   856,   857,   309,     0,   310,     0,
     311,   312,   313,   314,   315,   316,   317,     0,   318,   319,
     320,   321,     0,     0,   322,   323,   858,   325,   326,     0,
     327,   328,   329,     0,   330,   331,   332,     0,   333,   334,
     335,   336,     0,   338,   339,   340,   341,     0,     0,   343,
       0,   344,   345,   346,   859,   348,     0,   349,     0,   350,
     351,     0,   352,   353,   354,   355,   356,     0,   357,     0,
       0,     0,   360,   361,     0,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,     0,   372,   373,   374,   375,
     376,   377,   378,     0,   379,   380,     0,   382,   383,   384,
     385,   860,   861,     0,   862,     0,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,     0,     0,   399,     0,
     401,   402,   403,     0,   404,   405,   406,     0,     0,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   863,   424,   864,   426,   427,
     428,   429,   430,   431,   432,     0,     0,   435,     0,   436,
     437,   438,   439,     0,     0,   441,   865,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,     0,     0,
     451,   452,     0,   454,   455,   456,     0,   458,   459,   460,
     461,   462,   463,   464,   465,   466,     0,     0,   467,   468,
       0,   470,     0,   472,   473,   474,     0,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   866,   486,   487,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,     0,   512,   513,   514,   515,
     516,   517,   518,   519,   520,     0,   521,   522,   523,   524,
     525,     0,   526,   527,   867,   529,   530,   531,   532,   533,
     868,   535,     0,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,     0,   550,     0,   551,
     552,     0,   553,   554,   555,   556,   557,   558,   559,     0,
     560,   869,   870,     0,     0,   563,   564,     0,   566,     0,
       0,   568,   569,   570,   571,   572,   573,   574,   575,     0,
       0,   576,   577,   578,   579,   580,     0,     0,   581,   582,
     583,   584,   585,     0,   871,     0,   588,   589,   590,   591,
     592,   593,     0,     0,   594,     0,     0,   595,   596,   597,
     598,   599,   600,   850,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   612,   613,   614,     0,     0,     0,
     235,   236,   237,   238,   239,   240,   241,   242,     0,   243,
     244,   245,     0,     0,     0,     0,     0,     0,     0,   246,
     247,   248,     0,   249,   250,   251,   252,   253,   254,   255,
     256,     0,   851,   259,   852,   853,     0,   262,   263,   264,
     265,   266,   267,   268,     0,     0,   269,   270,   854,   855,
     273,     0,   274,   275,   276,   277,     0,     0,   279,     0,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
       0,   290,   291,   292,   293,   294,   295,     0,   296,   297,
     298,   299,     0,     0,     0,   300,     0,     0,     0,   301,
     302,   303,   304,   305,   306,   856,   857,   309,     0,   310,
       0,   311,   312,   313,   314,   315,   316,   317,     0,   318,
     319,   320,   321,     0,     0,   322,   323,   858,   325,   326,
       0,   327,   328,   329,     0,   330,   331,   332,     0,   333,
     334,   335,   336,     0,   338,   339,   340,   341,     0,     0,
     343,     0,   344,   345,   346,   859,   348,     0,   349,     0,
     350,   351,     0,   352,   353,   354,   355,   356,     0,   357,
       0,     0,     0,   360,   361,     0,   362,   363,   364,   365,
    1120,   367,   368,   369,   370,   371,     0,   372,   373,   374,
     375,   376,   377,   378,     0,   379,   380,     0,   382,   383,
     384,   385,   860,   861,     0,   862,     0,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,     0,     0,   399,
       0,   401,   402,   403,     0,   404,   405,   406,     0,     0,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   863,   424,   864,   426,
     427,   428,   429,   430,   431,   432,     0,     0,   435,     0,
     436,   437,   438,   439,     0,     0,   441,   865,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,     0,
       0,   451,   452,     0,   454,   455,   456,     0,   458,   459,
     460,   461,   462,   463,   464,   465,   466,     0,     0,   467,
     468,     0,   470,     0,   472,   473,   474,     0,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   866,   486,
     487,   488,   489,     0,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,     0,   512,   513,   514,
     515,   516,   517,   518,   519,   520,     0,   521,   522,   523,
     524,   525,     0,   526,   527,   867,   529,   530,   531,   532,
     533,   868,   535,     0,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,     0,   550,     0,
     551,   552,     0,   553,   554,   555,   556,   557,   558,   559,
       0,   560,   869,   870,     0,     0,   563,   564,     0,   566,
       0,     0,   568,   569,   570,   571,   572,   573,   574,   575,
       0,     0,   576,   577,   578,   579,   580,     0,     0,   581,
     582,   583,   584,   585,     0,   871,     0,   588,   589,   590,
     591,   592,   593,     0,     0,   594,     0,     0,   595,   596,
     597,   598,   599,   600,   850,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   612,   613,   614,     0,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,     0,
     243,   244,   245,     0,     0,     0,     0,     0,     0,     0,
     246,   247,   248,     0,   249,   250,   251,   252,   253,   254,
     255,   256,     0,   851,   259,   852,   853,     0,   262,   263,
     264,   265,   266,   267,   268,     0,     0,   269,   270,   854,
     855,   273,     0,   274,   275,   276,   277,     0,     0,   279,
       0,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,     0,   290,   291,   292,   293,   294,   295,     0,   296,
     297,   298,   299,     0,     0,     0,   300,     0,     0,     0,
     301,   302,   303,   304,   305,   306,   856,   857,   309,     0,
     310,     0,   311,   312,   313,   314,   315,   316,   317,     0,
     318,   319,   320,   321,     0,     0,   322,   323,   858,   325,
     326,     0,   327,   328,   329,     0,   330,   331,   332,     0,
     333,   334,   335,   336,     0,   338,   339,   340,   341,     0,
       0,   343,     0,   344,   345,   346,   859,   348,     0,   349,
       0,   350,   351,     0,   352,   353,   354,   355,   356,     0,
     357,     0,     0,     0,   360,   361,     0,   362,   363,   364,
     365,  1152,   367,   368,   369,   370,   371,     0,   372,   373,
     374,   375,   376,   377,   378,     0,   379,   380,     0,   382,
     383,   384,   385,   860,   861,     0,   862,     0,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,     0,     0,
     399,     0,   401,   402,   403,     0,   404,   405,   406,     0,
       0,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   863,   424,   864,
     426,   427,   428,   429,   430,   431,   432,     0,     0,   435,
       0,   436,   437,   438,   439,     0,     0,   441,   865,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
       0,     0,   451,   452,     0,   454,   455,   456,     0,   458,
     459,   460,   461,   462,   463,   464,   465,   466,     0,     0,
     467,   468,     0,   470,     0,   472,   473,   474,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   866,
     486,   487,   488,   489,     0,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,     0,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,   521,   522,
     523,   524,   525,     0,   526,   527,   867,   529,   530,   531,
     532,   533,   868,   535,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,     0,   550,
       0,   551,   552,     0,   553,   554,   555,   556,   557,   558,
     559,     0,   560,   869,   870,     0,     0,   563,   564,     0,
     566,     0,     0,   568,   569,   570,   571,   572,   573,   574,
     575,     0,     0,   576,   577,   578,   579,   580,     0,     0,
     581,   582,   583,   584,   585,     0,   871,     0,   588,   589,
     590,   591,   592,   593,     0,     0,   594,     0,     0,   595,
     596,   597,   598,   599,   600,   850,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   612,   613,   614,     0,
       0,     0,   235,   236,   237,   238,   239,   240,   241,   242,
       0,   243,   244,   245,     0,     0,     0,     0,     0,     0,
       0,   246,   247,   248,     0,   249,   250,   251,   252,   253,
     254,   255,   256,     0,   851,   259,   852,   853,     0,   262,
     263,   264,   265,   266,   267,   268,     0,     0,   269,   270,
     854,   855,   273,     0,   274,   275,   276,   277,     0,     0,
     279,     0,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,     0,   290,   291,   292,   293,   294,   295,     0,
     296,   297,   298,   299,     0,     0,     0,   300,     0,     0,
       0,   301,   302,   303,   304,   305,   306,   856,   857,   309,
       0,   310,     0,   311,   312,   313,   314,   315,   316,   317,
       0,   318,   319,   320,   321,     0,     0,   322,   323,   858,
     325,   326,     0,   327,   328,   329,     0,   330,   331,   332,
       0,   333,   334,   335,   336,     0,   338,   339,   340,   341,
       0,     0,   343,     0,   344,   345,   346,   859,   348,     0,
     349,     0,   350,   351,     0,   352,   353,   354,   355,   356,
       0,   357,     0,     0,     0,   360,   361,     0,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,     0,   372,
     373,   374,   375,   376,   377,   378,     0,   379,   380,     0,
     382,   383,   384,   385,   860,   861,     0,   862,     0,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,     0,
       0,   399,     0,   401,   402,   403,     0,   404,   405,   406,
       0,     0,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   863,   424,
     864,   426,   427,   428,   429,   430,   431,   432,     0,     0,
     435,     0,   436,   437,   438,   439,     0,     0,   441,   865,
     443,   444,   445,     0,   446,   447,     0,     0,   448,   449,
     450,     0,     0,   451,   452,     0,   454,   455,   456,     0,
     458,   459,   460,   461,   462,   463,   464,   465,   466,     0,
       0,   467,   468,     0,   470,     0,   472,   473,   474,     0,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     866,   486,   487,   488,   489,     0,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,     0,   512,
     513,   514,   515,   516,   517,   518,   519,   520,     0,   521,
     522,   523,   524,   525,     0,   526,   527,  2628,   529,   530,
     531,   532,   533,   868,   535,     0,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,     0,
     550,     0,   551,   552,     0,   553,   554,   555,   556,   557,
     558,   559,     0,   560,   869,   870,     0,     0,   563,   564,
       0,   566,     0,     0,   568,   569,   570,   571,   572,   573,
     574,   575,     0,     0,   576,   577,   578,   579,   580,     0,
       0,   581,   582,   583,   584,   585,     0,   871,     0,   588,
     589,   590,   591,   592,   593,     0,     0,   594,     0,     0,
     595,   596,   597,   598,   599,   600,   850,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   612,   613,   614,
       0,     0,     0,   235,   236,   237,   238,   239,   240,   241,
     242,     0,   243,   244,   245,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,     0,   249,   250,   251,   252,
     253,   254,   255,   256,     0,   851,   259,   852,   853,     0,
     262,   263,   264,   265,   266,   267,   268,     0,     0,   269,
     270,   854,   855,   273,     0,   274,   275,   276,   277,     0,
       0,   279,     0,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,     0,   290,   291,   292,   293,   294,   295,
       0,   296,   297,   298,   299,     0,     0,     0,   300,     0,
       0,     0,   301,   302,   303,   304,   305,   306,   856,   857,
     309,     0,   310,     0,   311,   312,   313,   314,   315,   316,
     317,     0,   318,   319,   320,   321,     0,     0,   322,   323,
     858,   325,   326,     0,   327,   328,   329,     0,   330,   331,
     332,     0,   333,   334,   335,   336,     0,   338,   339,   340,
     341,     0,     0,   343,     0,   344,   345,   346,   859,   348,
       0,   349,     0,   350,   351,     0,   352,   353,   354,   355,
     356,     0,   357,     0,     0,     0,   360,   361,     0,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,     0,
     372,   373,   374,   375,   376,   377,   378,     0,   379,   380,
       0,   382,   383,   384,   385,   860,   861,     0,   862,     0,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
       0,     0,   399,     0,   401,   402,   403,     0,   404,   405,
     406,     0,     0,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   863,
     424,   864,   426,   427,   428,   429,   430,   431,   432,     0,
       0,   435,     0,   436,   437,   438,   439,     0,     0,   441,
     865,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,     0,     0,   451,   452,     0,   454,   455,   456,
       0,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,     0,   467,   468,     0,   470,     0,   472,   473,   474,
       0,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   866,   486,   487,   488,   489,     0,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,     0,
     512,   513,   514,   515,   516,   517,   518,   519,   520,     0,
     521,   522,   523,   524,   525,     0,   526,   527,     0,   529,
     530,   531,   532,   533,   868,   535,     0,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
       0,   550,     0,   551,   552,     0,   553,   554,   555,   556,
     557,   558,   559,     0,   560,   869,   870,     0,     0,   563,
     564,     0,   566,     0,     0,   568,   569,   570,   571,   572,
     573,   574,   575,     0,     0,   576,   577,   578,   579,   580,
       0,     0,   581,   582,   583,   584,   585,     0,   871,     0,
     588,   589,   590,   591,   592,   593,     0,     0,   594,     0,
       0,   595,   596,   597,   598,   599,   600,   850,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   612,   613,
     614,     0,     0,     0,   235,   236,   237,   238,   239,   240,
     241,   242,     0,   243,   244,   245,     0,     0,     0,     0,
       0,     0,     0,   246,   247,   248,     0,   249,   250,   251,
     252,   253,   254,   255,   256,     0,     0,   259,     0,     0,
       0,   262,   263,   264,   265,   266,   267,   268,     0,     0,
     269,   270,     0,     0,   273,     0,   274,   275,   276,   277,
       0,     0,   279,     0,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,     0,   290,   291,   292,   293,   294,
     295,     0,   296,   297,   298,   299,     0,     0,     0,   300,
       0,     0,     0,   301,   302,   303,   304,   305,   306,     0,
       0,   309,     0,   310,     0,   311,   312,   313,   314,   315,
     316,   317,     0,   318,   319,   320,   321,     0,     0,   322,
     323,   324,   325,   326,     0,   327,   328,   329,     0,   330,
     331,   332,     0,   333,   334,   335,   336,     0,   338,   339,
     340,   341,     0,     0,   343,     0,   344,   345,   346,     0,
     348,     0,   349,     0,   350,   351,     0,   352,   353,   354,
     355,   356,     0,   357,     0,     0,     0,   360,   361,     0,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
       0,   372,   373,   374,   375,   376,   377,   378,     0,   379,
     380,     0,   382,   383,   384,   385,     0,     0,     0,     0,
       0,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     0,     0,   399,     0,   401,   402,   403,     0,   404,
     405,   406,     0,     0,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
       0,   424,     0,   426,   427,   428,   429,   430,   431,   432,
       0,     0,   435,     0,   436,   437,   438,   439,     0,     0,
     441,     0,   443,   444,   445,     0,   446,   447,     0,     0,
     448,   449,   450,     0,     0,   451,   452,     0,   454,   455,
     456,     0,   458,   459,   460,   461,   462,   463,   464,   465,
     466,     0,     0,   467,   468,     0,   470,     0,   472,   473,
     474,     0,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,     0,   486,   487,   488,   489,     0,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
       0,   512,   513,   514,   515,   516,   517,   518,   519,   520,
       0,   521,   522,   523,   524,   525,     0,   526,   527,     0,
     529,   530,   531,   532,   533,     0,   535,     0,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,     0,   550,     0,   551,   552,     0,   553,   554,   555,
     556,   557,   558,   559,     0,   560,     0,     0,     0,     0,
     563,   564,     0,   566,     0,     0,   568,   569,   570,   571,
     572,   573,   574,   575,     0,     0,   576,   577,   578,   579,
     580,     0,     0,   581,   582,   583,   584,   585,     0,     0,
       0,   588,   589,   590,   591,   592,   593,     0,     0,   594,
       0,     0,   595,   596,   597,   598,   599,   600,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   612,
     613,   614
};

static const yytype_int16 yycheck[] =
{
       6,  1009,     0,     0,     0,  1017,   635,   635,   650,     0,
       0,     0,    57,   981,     0,  1195,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,  1132,     0,   211,   815,
     211,    21,  1612,    37,   762,   763,   764,   189,     8,  1013,
     768,   911,   812,    46,  1457,    15,    52,  1485,   723,   206,
     705,   867,  1547,   905,   885,   907,   982,   214,   682,  1007,
     217,  1531,  2612,    22,   719,  1242,   791,   629,   197,    28,
       6,   998,   856,   857,   838,  2950,  1082,  2613,  3274,  1524,
    3276,   865,   216,  2978,  3124,  1230,   837,  2632,  2633,   822,
    3016,   922,   727,  1531,    45,  3101,   230,  3474,  3365,  1536,
    1849,  3745,  3772,   948,  3447,    23,  1980,  4093,   870,  2963,
    1998,  1524,  3500,  2869,  3502,  3696,  1678,  4062,   631,    37,
     682,  2492,  3325,  3794,  4089,  2496,  2043,   947,  3761,  1056,
    3319,  4136,   728,  1060,  1415,   191,  4573,  2848,  1065,   191,
     207,  4376,   703,  1514,     2,   706,   718,  4873,  1075,   216,
    1645,  1646,   972,  3839,   176,  4171,  5145,   977,    36,    51,
    3339,  1088,    42,   230,  1071,    43,  2597,   729,  4359,  3374,
    4816,  1920,  1017,  3231,  4589,  4322,  4591,  5181,  4364,  1086,
    3759,  4626,   933,  4659,  2599,   908,  4865,  3324,  5222,  3326,
    2529,   197,  1119,  5420,   818,     0,   908,     0,    13,    11,
     206,   207,  1639,  1574,  5060,     0,     0,    53,   214,    11,
     216,   217,    13,  4432,    37,    62,  4363,  1497,  4864,  5404,
    1591,  4515,     6,  2915,   230,  2917,  2918,   789,     6,  1666,
    2922,  2923,  2924,    24,  2926,  2927,  2928,  2576,    62,   854,
     855,    93,    62,    44,     6,  5101,   931,     0,    31,   864,
      42,     0,    42,    28,     0,     6,   818,    24,   112,     6,
     145,     6,    11,    34,     6,    11,    62,     0,    15,    16,
    1021,     6,     6,    79,   225,     6,    77,    84,   173,    28,
     842,     6,    28,     6,     6,   981,     6,   972,    21,    42,
      15,    16,   977,     6,   990,  1477,   118,     6,    28,  5108,
    5109,   140,    15,    16,  1000,    90,  1011,     6,    62,   152,
     167,   125,  1175,   184,    79,     6,   216,    15,     6,    46,
      28,    62,  1050,     3,    57,     5,     6,  5357,    52,  5359,
       5,    11,   177,  5363,  5364,  5133,    11,   111,  2020,   279,
     902,   151,   284,   172,    97,     5,   200,   138,  4353,   304,
     304,    11,  4464,  4465,  4466,    62,  4468,  4469,  4470,  4471,
    4472,  4377,   290,   200,   304,   373,   285,   172,    29,   172,
    1095,   138,   285,  5600,   319,    90,   172,   172,   172,    13,
     118,     6,   729,    79,  4860,   356,    79,   151,    62,    13,
      34,   196,   237,   196,    46,   148,    28,  1371,   118,   265,
     374,   196,   196,   118,   164,   414,  5591,   360,   161,    38,
      44,  1359,   438,     3,   167,   123,     6,    28,  5422,   172,
      57,  1427,    77,   172,    35,   178,   172,   122,   181,  5830,
    5831,   416,   185,   356,    62,   358,   343,  1072,   118,  5920,
     150,   326,   789,    77,   300,  1419,   459,   196,    62,    79,
     196,  1575,   172,     5,  5139,  1017,     5,   284,   191,    11,
      90,   214,    11,   216,    28,  5321,   373,   480,  1592,   650,
     377,    35,   498,   339,    90,   460,  1260,  1261,    13,   488,
      28,   234,    79,   339,  1139,   172,   331,    35,   198,  5970,
     127,   500,   344,  1218,   502,   842,   419,  1281,   345,   128,
     260,   133,   210,  5182,    79,    79,   360,    79,   152,    44,
      13,  5738,  1357,   120,   648,    90,    90,  1362,  1363,   700,
     654,   345,   217,   113,   498,   345,   172,   498,   281,  1291,
    5931,   284,   666,   300,   309,   215,   274,   290,   457,   172,
     179,   179,    77,   498,   498,   498,  1201,   401,   402,   462,
     211,   172,  1526,   498,   269,   902,   498,   237,   498,   342,
    1311,   406,  1217,   408,   360,   402,   376,   172,   172,   123,
    5368,   442,   339,   356,   502,   358,  1231,  1173,   172,   498,
      22,   648,   373,   274,  1447,   414,   274,   654,  1339,   434,
    4171,   345,  5622,   368,   347,  5599,   370,  5824,   188,   666,
     189,  5016,   502,   498,   345,   450,   373,   399,   414,   399,
     453,  1235,   376,   498,   453,  4196,   198,   199,    31,    10,
     202,   428,    13,   629,   438,  5310,    17,    18,    19,   414,
    1812,   406,  1416,   408,  1249,  1250,   419,  5822,   345,   635,
     222,   498,   648,   414,   498,   436,   399,   229,   654,   414,
     502,   844,   498,   449,   635,   502,   635,  1502,   366,   249,
     666,  1276,   252,   447,  5891,    24,   488,  1512,  1676,  1677,
    4964,   345,   402,  1235,  1581,   498,   682,   430,   502,   494,
    1607,   687,   502,  1610,   729,   497,   692,   489,   490,  4333,
     696,   697,  1618,   494,   414,  4914,   501,   703,   501,   705,
     706,   454,  5929,   456,   457,  1380,   501,   501,  5742,   151,
    1415,   733,   718,   719,   498,  1995,   443,   345,   414,  4096,
     498,   414,  1445,   729,  1631,  5729,  1674,  5536,   436,  4373,
    1354,   345,   728,  1445,   496,  5414,   498,   196,   500,  4372,
     489,   490,  1562,   489,   490,    27,   499,   498,   501,   502,
     459,   498,   501,   498,  1599,   501,   498,  1602,  1603,   911,
     459,   502,   414,   498,   498,   390,   391,   498,   488,  5758,
    1950,   480,   383,   498,   364,   498,   498,  1392,  1393,   138,
     500,   480,  1598,   789,   743,   498,   745,   757,   747,   498,
     488,   443,  1354,    51,   753,   502,  4377,   457,   496,   498,
    1362,  1363,   500,   419,  1500,   196,   812,   813,    90,   489,
     490,   498,   818,  1683,   489,   490,  1922,   414,  5674,   383,
     480,  5506,  5826,   774,  4027,  4937,  5511,   218,   502,   489,
     490,  5687,  3377,   440,  3379,   383,   842,  1522,   844,   414,
     414,   496,   414,   899,  4423,   500,   172,   899,  1031,  4038,
    1031,  1957,   120,  4042,  5299,  3913,   502,   491,   492,   493,
     494,   867,  1968,   502,   502,   498,  1562,   491,   492,   493,
     494,  1028,  5598,  3879,   502,  1032,  4081,  1034,  3732,  3590,
    3591,   502,   436,   889,  3595,   475,  5890,   838,   502,  4026,
    1575,  4028,   174,  1022,   123,   286,   902,   502,   502,   777,
     778,   779,   635,   901,   901,   901,  4283,  1592,   502,   498,
     901,   901,   901,  3344,   356,   901,  5595,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   924,  1569,   901,   342,
    3345,     6,  5578,   191,   376,   265,   816,   118,   196,  4282,
     820,   300,  5418,  5799,    50,  3449,   290,  1792,  5594,  3288,
     173,   265,   220,   845,   489,   490,   491,   492,   493,   494,
      24,   123,   111,   111,   915,   111,    30,   123,   692,     6,
    5959,     6,   174,   284,  1167,   233,   360,   152,    67,   930,
     339,   210,  3674,   332,  1497,     3,   489,   490,   491,   492,
     493,   494,   173,   113,   718,   728,   729,    10,    24,   324,
      13,   269,   331,  1009,  1010,  1011,   101,    97,   273,    71,
     438,  1017,   172,  5739,   373,   270,  1022,  4196,   168,   307,
     118,  1027,  1028,  1997,  1831,  5172,  1032,   117,  1034,   172,
       3,    44,  1038,     3,   300,   118,   196,   184,    51,   321,
       5,    75,    36,   502,  1851,   488,    11,  1053,   210,  5035,
     778,  5730,   202,   174,   210,   343,   638,   500,   640,   327,
    5076,   643,   152,   181,    77,  4408,  2040,  5482,   188,   167,
     498,    89,   123,   339,   138,   657,   358,  4344,  5750,    87,
     303,   663,   441,    87,   286,   373,   181,   149,   414,   270,
    1096,  5306,  1098,  1099,   443,   486,   487,   488,   489,   490,
     491,   492,   493,   494,    71,  1810,  5832,   169,   986,   987,
    5836,   285,   138,   113,   498,   380,    89,  1310,   265,    89,
     378,   450,   130,    90,   118,   143,   130,   285,   442,   249,
    1858,    10,   252,  1139,    13,   417,    39,   419,    17,    18,
      19,   423,   745,   746,   747,   166,   476,   750,   751,   752,
      53,  3696,   167,    87,    41,    34,   379,   760,   502,   210,
    5165,  1167,   488,  5889,   118,   286,   899,  5839,   901,   142,
     265,   111,   142,   498,   500,     3,   265,  1173,   191,  1965,
    1966,   436,   149,   196,   202,   496,   269,   224,   188,   500,
     392,   366,  4862,  1386,    24,  1201,   130,  5432,  4093,   274,
    5386,  3705,   169,    62,  5930,  4849,   109,   436,  1178,  1215,
    1180,  1217,  1182,  1775,  1184,  4886,  1186,  1187,  1188,  2632,
     233,  5412,  4855,  1193,  1175,  1231,  4912,   402,  5954,  1235,
    5416,  5957,   169,   351,   502,   290,   300,  1892,  5385,   274,
     346,  1247,  3787,  4620,   364,   335,  1104,   777,   282,   249,
    1925,  1906,   252,   402,   402,   317,   402,   438,  1451,   987,
     422,  2731,   288,  2700,  1919,  1310,  5938,   240,  5415,   444,
     240,   414,  1278,   286,   436,   339,   366,   360,    24,   184,
     436,  1956,   457,   457,    30,  1960,  2037,  2568,   306,  1964,
     118,   312,  1967,  5508,   302,   442,   290,   457,   302,   457,
    1306,  1307,  1308,  1027,  1310,   480,   209,   194,   138,   373,
     454,   285,   402,  1885,  1038,   366,   411,   343,   344,    32,
      33,    68,    69,   498,  1330,   265,   341,   300,  1889,  1053,
     300,   131,  5297,   373,   307,   112,  1932,    37,  5775,   218,
    2777,   141,  2904,  1904,   298,  1917,  1907,   373,  1354,  2720,
     317,  1980,  1980,  1375,   444,   475,  1362,  1363,   502,    59,
     265,  2066,   265,  3280,   364,   378,   339,   457,   302,   431,
     343,  4574,   954,   955,  1430,  1431,  2018,  1433,  1430,  1431,
    1386,  1433,   120,   288,    97,   436,   148,    63,  1569,  4578,
     480,   184,   138,   300,  4583,    71,  5401,  4586,  1959,   407,
     373,  1962,  1963,   407,   117,  5410,   265,   286,   498,  1415,
     110,   429,   366,   188,    28,  2995,   174,   222,   110,   437,
     373,   402,   440,   200,   152,  4813,  1432,   249,     6,   279,
    1436,  1437,   405,   279,   407,   405,  5762,   407,   167,   152,
    1173,   269,  1024,  4449,   499,  1451,   274,   502,   402,   178,
    4345,  1457,   214,  4459,   304,   402,   986,  1039,   304,   362,
     265,  5466,   502,  4389,   431,   478,   373,   196,   120,  3840,
     300,   148,   265,   407,   249,   475,   489,   490,   491,   492,
     493,   494,  1995,   457,   457,  2493,   345,  1069,  1070,    24,
     444,  1215,  3174,  3175,   488,  5076,  1447,  3179,   498,   199,
     300,   243,   496,   457,   498,   499,   500,   300,   502,   339,
    1243,   122,  1094,  5183,   373,   279,   183,   498,  1524,   133,
     243,  2495,   196,   243,   243,   133,   480,   135,   290,   222,
    1263,   177,   120,   123,  3216,  3217,   274,   442,  5171,   339,
     304,   243,   364,   373,   498,    37,   339,   247,   138,   502,
     250,  2806,  1134,  1135,   300,   247,   300,   234,   250,  1565,
       6,   237,  1295,   321,  5509,   265,   373,    59,   220,  3014,
     351,   376,   265,  1176,    71,  5580,  1179,  1310,  1181,  4271,
    1183,   299,  1185,   360,  4276,  1583,  1189,  5913,   120,   364,
    1588,   237,  1598,   339,  1661,   339,  4352,  3010,  4309,   299,
     246,  3014,   633,   138,    92,    98,   217,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   204,   269,   110,   197,
     349,   118,   335,  5609,   401,   402,  4171,   373,   206,   373,
    2885,   436,    37,   307,   327,  4346,   214,   360,   366,   217,
     360,   360,   246,  2655,   344,  5735,  5736,   135,   498,   442,
      86,  4196,   498,   366,    59,  1661,   437,   373,   360,   326,
     174,   269,  1660,   405,   373,   339,  1664,   367,   430,   343,
    1676,  1677,  1678,    26,   402,   327,  4571,   265,   339,   176,
     173,   269,   405,   376,  1635,   405,   405,   387,   220,   402,
     357,   416,   434,   207,   725,   502,    49,  1430,  1431,   373,
    1433,    10,   358,   405,    13,   110,    97,   199,    17,    18,
      19,   434,   366,   206,   434,   434,   444,   459,  1901,  1900,
    1901,  5726,   316,  5668,   314,    34,   175,   163,   221,   457,
     382,   444,   434,  1890,   498,   448,   459,   269,   231,   459,
     459,   414,   414,   436,   457,   175,   341,   316,   402,    13,
    1879,  5421,   480,   414,   498,   247,   498,   459,   250,  5403,
     406,  4661,   408,   419,   257,   172,  1833,   480,  4668,  1775,
     498,   176,   269,   265,  1841,   498,   807,   274,   498,   498,
     299,  1787,  1849,   457,   356,   498,   502,   178,   434,   196,
     444,   284,  1798,   502,   199,   327,   498,  5430,   161,   499,
     299,   121,  5892,  1996,  1810,  1998,   480,   299,  1814,   269,
      24,  2004,  2628,    77,   274,  5820,    30,  2010,  2011,  2012,
     317,   223,   416,  5012,  2610,   299,  1893,  1833,  2021,   502,
     502,    10,  4377,  2026,    13,  1841,   333,  2018,    17,    18,
      19,  1565,   247,  1849,   498,   250,   331,   416,  2816,  5835,
     356,   118,   344,  1920,   373,    34,   438,   350,   211,  5073,
     265,  1867,   457,  2568,   436,   325,   460,  5210,   498,   300,
    1876,   234,   192,  1879,   373,   367,  1882,    15,    16,  1885,
    1886,  5886,   367,  1889,  1890,   480,  1892,  1893,   155,  4929,
     401,   460,   322,   121,   299,   387,   402,   448,  1904,   373,
    1906,  1907,  5116,     0,   335,   448,   355,   502,   339,   218,
    1916,  1917,   361,  1919,  1920,   501,   498,   402,   281,   368,
      10,   161,   189,  5593,   138,   355,   437,    17,    18,    19,
     300,   502,   243,  3039,   431,  1517,  1932,   288,   368,   344,
    4815,  5612,   373,    10,  4839,   438,    13,   498,  5934,   300,
      17,    18,    19,  1959,   403,   498,  1962,  1963,  2865,  5592,
    1542,  3374,   367,    98,   192,   450,  1936,    34,  1938,   339,
    1940,  3384,  1942,   403,  1944,  2820,   425,   286,  1948,  4854,
    4834,   161,   387,  2828,  1980,  1989,  2831,   167,   339,  5029,
    1996,  5031,  1998,   121,   234,  3575,  5384,  2003,  2004,  1980,
     120,  1980,   269,   373,  2010,  2011,  2012,  3895,  5204,  2015,
     164,  2017,   339,  2019,  2020,  2021,  2022,  2023,  2024,  3464,
    2026,   339,  2028,  2029,  1975,    34,  2032,  3204,  2898,  2899,
    2900,   976,  2796,  2797,  2730,   290,  2800,  1619,   173,   218,
    2046,  2047,  2048,  2049,   300,   358,   373,   167,  2868,   360,
     995,  3464,  2959,   998,   234,   373,    22,  2762,  2064,  5436,
    2066,  5731,    28,  1787,   192,  1647,  1648,  1649,  1650,   319,
    1988,   206,   226,  2728,  1798,  2982,  2983,  2984,  2985,  3828,
    2987,   173,  2787,   339,   204,  4777,   221,  4779,  4780,  4781,
    1814,  3653,  4803,  2655,   405,   331,   231,  3659,   449,    24,
    5744,   281,   457,   360,  3031,  3012,   419,   286,   363,   687,
      31,   457,   243,   161,   206,  5458,   343,   373,   696,   167,
    2816,   356,   257,   434,   300,   703,   419,    79,   706,   221,
     259,   367,   389,  5034,   480,   300,  5513,    58,    90,   231,
    5035,  5042,  5409,  1867,  4018,   265,   373,   502,   459,   269,
     133,   218,   135,   388,   283,  5825,   502,  2853,  1882,   300,
    3597,  1885,  1886,   339,    89,   457,   402,   343,   278,  2844,
    5366,  2846,    13,  2878,   339,  2850,   159,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   234,   498,   406,   457,
     408,  2887,  1916,  1917,  2958,   457,   286,   373,   339,  1932,
     363,  2207,   243,    44,   148,  3642,   131,   167,   373,   450,
     502,  1793,  1794,   138,   450,   350,   141,   161,   480,   286,
    1583,    32,    33,   167,  5230,  1588,   243,  1809,   498,   360,
     190,  3411,   373,   281,   502,   284,    77,   344,   224,  2944,
     289,  2247,  3924,  3925,  3926,  3927,  3091,  1980,  3930,  3931,
    3932,  3933,  3934,  3935,  3936,  3937,  3938,  3939,   350,   457,
     497,  1843,  1844,  1845,  1846,   502,   373,    28,   499,     5,
     214,   502,   243,  3768,   405,    11,   327,  3005,   261,   262,
     263,   264,   480,    19,   499,   268,   269,   502,  5932,   340,
     234,   274,  2298,   499,  5671,   459,   502,  1660,  5193,   459,
     498,  1664,    38,   434,   148,  3987,  3988,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   480,   161,   369,   360,
     480,    82,  2046,   167,    85,   167,   248,  5222,   459,  2964,
      91,   414,   499,  5044,   498,   502,    47,   281,   498,   246,
     167,  1923,    10,   360,   419,    13,   290,  1929,   190,    17,
      18,    19,   356,   357,  2547,   438,    26,   457,   119,    70,
     356,   357,   269,   190,   405,   148,  5261,   498,  5323,   406,
     214,   408,   497,  5328,  5329,   300,    44,   502,   161,    49,
     480,   284,   499,    51,   167,   502,   289,   243,   405,   360,
     234,   356,   357,   434,  3119,  3120,   486,   487,   488,   489,
     490,   491,   492,   493,   494,  3275,   972,   498,   496,    77,
     335,   977,   500,  3088,   339,   176,  5793,   434,   459,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   189,  5121,
    3187,   214,  3189,  3190,   405,  5631,  3281,   281,   421,   496,
     201,   498,   459,   500,  1022,   498,   290,   500,   373,   432,
    1028,   234,    24,   341,  1032,   493,  1034,   498,    30,   363,
     498,  2030,   500,   434,  2033,   246,  2472,  2473,  2474,  2475,
    2476,  2477,  2478,  2479,  2480,    10,  2482,   493,    13,  2212,
     499,   498,   498,   502,   500,  2491,   430,  2493,   459,   246,
    3195,   261,   262,   263,   264,   200,  3201,   499,   281,   499,
     502,  5878,   502,    75,   360,   356,   357,   290,  2691,    44,
    2691,   499,  5438,   248,   502,   496,    51,   498,  1096,   190,
    1098,  1099,  2104,   191,  3450,  2531,    94,   498,   196,  2535,
      86,  5076,  2538,  2690,  2540,  2692,  2693,  2543,  3300,  3301,
    2530,  2547,    77,   499,  3375,  3278,   502,  5642,  5643,   405,
    3476,   110,   496,   419,  2621,   499,   500,   499,  2687,   131,
     502,    53,  2568,  4143,  2570,   233,   138,   499,   499,   141,
     502,   502,  2639,  2561,  2562,  2563,  2643,  3757,   434,  3330,
    2647,  2587,   499,   450,   499,   502,   430,   502,    58,  5300,
    2596,  2597,   498,  2727,   500,  3237,   168,  5308,   457,   499,
     459,  3385,   502,   459,   363,  4354,  2673,    99,   498,   168,
     499,   146,   448,   502,     3,  2621,   224,   499,   286,  4301,
     502,   499,  2628,    11,   502,  5665,  2632,  2633,   389,   498,
     202,   392,   124,  2639,  2570,   499,    25,  2643,   502,   284,
    2707,  2647,   498,   202,  5768,  5769,  4141,   430,  4143,  2655,
     142,  5196,   502,  2657,   146,  2659,   191,  5853,    58,   499,
    2727,   196,   502,  4133,   360,   271,  3843,  2673,  4081,   499,
    2676,  2805,   502,   450,   499,   499,   168,   502,   502,   171,
     498,  2687,  4119,  2689,  2690,    86,  2692,  2693,   247,  2695,
      47,   250,  2759,   265,   186,   220,  2655,   269,   233,   477,
      89,  2707,  5597,   499,   284,  5901,   502,   279,   499,   499,
     378,   502,   502,   406,  5609,   408,   288,   499,  2785,  3281,
     502,  2727,  2728,   406,  2791,   408,  3401,   457,   300,   459,
    2736,  2798,  3738,  3878,   499,    55,    56,   502,  2805,  4176,
     500,  2808,    90,  3398,  3399,   287,   287,  2814,  2699,   148,
    2884,   286,  2758,  2759,   143,  3451,  2762,  5293,   499,   167,
     366,   502,   161,   457,   477,   459,   499,  2834,   167,   502,
     342,   343,  3699,  2840,   133,   499,   135,  5973,   502,  2785,
    2847,  2787,   274,   287,   499,  2791,  3693,   502,  4009,   284,
    4011,   499,  2798,  2860,   502,   499,   402,   499,   502,  2805,
     502,   373,  2808,  2536,  3428,    47,  2873,   196,  2814,   499,
     478,   499,   502,   202,   502,   214,   477,  2884,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   220,  2834,   177,
    3526,   491,   171,   325,  2840,   234,   502,  2570,   444,    10,
     498,  2847,    13,   378,   447,  2796,  2797,  5742,   498,  2800,
    5725,   457,   200,   499,  2860,   499,   502,   499,   502,   499,
     502,   499,   502,   498,   502,   499,  3428,  2873,   502,   441,
     313,  4366,  2878,    44,   480,    36,   499,  3602,  2884,   502,
      51,   498,   281,   499,  2843,   499,   502,   499,  3543,   237,
     502,   290,   498,   499,   499,   501,  2902,  2903,  2904,    58,
     499,   499,  2908,   502,   502,   499,    77,  3562,   502,   499,
     499,   172,   502,   502,  4094,  4095,   499,   306,   499,   502,
     216,   502,   499,  4361,   499,   502,   298,   502,   499,  2935,
    2936,   502,   499,   499,  5829,   502,   502,  4382,  2944,   499,
    5835,   289,   502,   478,   499,   499,   499,   502,   502,   502,
     499,  5501,  2534,   502,   489,   490,   491,   492,   493,   494,
     498,   133,   351,   135,   498,  2689,   499,   499,   501,  4382,
     502,  2695,  2978,   500,  3131,   146,  3133,  3134,   461,   499,
     270,   271,   502,  3176,   339,   499,   499,   159,   502,   502,
    3695,   498,  3966,   499,   366,  3188,   502,  3725,   499,  3128,
     499,   502,   499,   502,  3010,   502,   499,  2958,  3014,   502,
     499,   400,  2736,   502,   499,   499,  2997,   502,   502,   499,
     191,   499,   502,   499,   502,   196,   502,  3220,   196,   498,
     402,   430,  3099,   499,   499,   499,   502,   502,   502,  5934,
     429,  3886,  2978,   499,   499,   153,   502,   502,   437,   499,
    3117,   440,   502,   499,   498,   501,  3237,  3124,   406,   500,
     408,  3716,   233,  3718,  4012,   499,   153,   284,   502,  3744,
    3263,   419,   444,   196,   339,   499,   366,  3701,   502,  3703,
    4562,  4055,  4564,   431,   284,   457,   434,  3068,   153,   261,
     262,   263,   264,  3099,   499,  4675,   268,   502,  3862,    24,
     153,   499,   274,   499,   502,    30,   502,   196,   480,  3115,
      10,  3117,   402,    13,  2696,   286,   499,   153,  3124,   502,
      45,  4043,  3128,  4045,  3130,  3131,   498,  3133,  3134,  3135,
    4994,  3176,  4996,   284,   167,   339,   153,  3143,   232,  3701,
     120,  3703,  3148,   438,    44,   284,   498,   278,   167,   499,
      75,    51,    71,   269,   444,    37,   269,   461,  3339,   284,
     498,   167,  3786,   269,    47,   269,    47,   457,  3174,  3175,
    3176,   424,   269,  3179,    89,  3220,  3851,    77,   300,   450,
     450,  3187,  3188,  3189,  3190,  4655,   419,   320,   167,  3195,
     480,   153,   366,   153,  3200,  3201,   498,  3203,   153,  3205,
     153,   461,   153,   153,   129,   502,   131,   378,   498,   153,
    3216,  3217,  2936,   138,  3220,  4142,   141,   153,   153,   153,
     153,   153,  3877,   153,  3786,  4405,   167,   153,   402,   153,
     153,   153,   284,  3239,   216,  3241,   402,  3243,    37,   498,
     232,   284,   498,   168,  2826,     6,   146,  2829,     6,   421,
     167,   167,   498,  4430,  3959,   498,   167,  3263,   498,   498,
     432,   498,   498,   498,  2997,  3268,  3269,  3270,  4950,   498,
     444,     6,     6,   498,  3319,  3281,   498,   202,   498,   498,
    4111,     6,   498,   457,   498,   498,   498,   498,     6,   498,
     498,   191,   498,   498,  4078,   498,   196,   498,  1876,   498,
     498,  1879,   498,   498,   498,   458,   480,   478,   296,   216,
    3316,  1889,  1890,  3319,   502,   502,    37,   101,   489,   490,
     491,   492,   493,   494,   498,  3331,  1904,   232,    37,  1907,
    3336,  4257,    36,   233,  2916,  3068,   498,   412,   412,   496,
     265,     0,   496,   414,   269,  3351,   414,  2929,   414,   498,
     414,  4196,  4279,   172,   279,  2937,   502,   167,  3425,  3365,
     281,   167,    67,   288,   414,   279,   414,   360,  3374,   414,
     449,  3377,   414,  3379,   360,   300,   500,   414,  3384,   414,
    3316,  1959,   360,  3319,  1962,  1963,   286,   234,   414,  4018,
    4018,  3115,  3398,  3399,   343,  2977,   414,  4267,  3404,   414,
      10,    90,   488,    13,   360,   153,  3130,    17,    18,    19,
     284,  3135,   229,   365,   339,   414,  2998,   342,   343,  3425,
     414,   274,  3428,   126,   414,  3431,   437,    37,   405,  3365,
     284,   304,   189,  3439,   279,   498,   356,   498,    97,   414,
     414,    90,   502,  3176,   126,   300,   196,   153,   373,   438,
     414,   438,   126,   414,   402,   414,   402,  3524,  3464,  3041,
     414,  3043,   112,   126,  4438,  4170,    58,  4172,    58,   414,
     288,   414,  4885,   254,   414,   414,   414,   414,   378,   304,
     324,   324,   324,   414,   304,   414,   414,  3220,    46,   148,
    4195,    46,   502,   405,  3500,  3501,  3502,   499,   503,    24,
     498,   414,   161,   218,   414,    30,   414,   218,   167,  3242,
     414,   414,   414,   172,   284,  3696,   441,   414,  3524,   178,
      45,   414,   181,   218,   218,  3258,   185,  3533,    10,  3535,
     218,    13,   218,   218,   218,   218,   414,  3543,   218,   284,
     424,    37,   153,   284,   153,   269,   118,  3129,   438,   153,
      75,   457,   153,  5235,  3136,   214,  3562,   449,   153,   240,
      37,   284,    44,    37,   167,   362,   224,   269,   269,    51,
     269,   498,   153,   153,   438,   234,   153,   438,   478,   153,
     498,  3648,  5264,  3316,   373,   278,  3319,   414,   172,   489,
     490,   491,   492,   493,   494,    77,   273,   498,   254,   498,
    4445,   453,   254,    13,   129,   412,   131,   502,   218,   498,
     498,   414,   181,   138,   162,   416,   141,   502,   189,   499,
    3626,   189,   281,   499,   496,   284,   477,   477,   499,   499,
     499,   290,  3365,   364,   252,   214,   499,   502,   454,   376,
     222,   285,  3648,   168,  4824,   502,   438,  3653,    37,    58,
     293,   499,   360,  3659,   274,   438,   222,   498,   222,   274,
     414,   414,  3668,   414,   146,    10,   498,   167,    13,   274,
     284,    47,  4327,  4328,   414,   382,   286,   202,   284,   232,
     269,   232,   232,   356,   284,   405,   126,   502,   347,  3695,
    3696,   284,   339,   284,   373,  3701,   284,  3703,   190,    44,
     370,   414,   414,   327,   290,   499,    51,  3431,    37,   191,
    3716,  4527,  3718,   218,   196,  3439,   438,   224,   153,   438,
     488,   323,   279,   167,   450,    37,  3919,   403,    10,   498,
     169,    13,    77,  3739,   370,    17,    18,    19,   153,  5177,
     265,  4593,   498,   402,   269,   153,   324,   153,   279,   269,
      37,   233,   269,    26,   279,   284,   284,   457,   224,  3765,
    3953,  3828,   187,   288,  4439,  4440,  4441,  4442,  4443,   438,
     279,   430,   167,   187,    37,   300,   168,   224,   284,   167,
    3786,  3787,   269,   370,   196,   196,   502,    25,  3855,   196,
    3771,  3836,   196,   196,   461,   454,   179,   456,   457,   172,
     498,   146,   414,  3809,   286,   502,  3999,    58,   251,  3533,
    5305,  3535,   502,  3880,   339,   457,   284,   342,   343,   278,
     172,  4666,  3828,   296,  3775,   305,  3807,   502,   499,   477,
     502,   499,   172,   499,   499,  4605,   498,   496,   499,   499,
     499,   500,   501,  3995,   499,   499,   191,   268,   373,  3855,
     295,   196,  3434,  3435,   499,   414,   502,   498,  4785,   499,
     499,   499,   499,   498,   498,   498,   246,   498,   497,   497,
     172,  3877,   499,   498,  3880,   181,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   502,   480,   436,   233,   242,
      58,  3897,   454,   284,  3900,   200,   378,   287,   284,   498,
    3906,   498,  3626,   479,   153,   208,   414,   274,  3914,   156,
    3916,  3862,   414,  3919,   269,   414,   441,  3923,  3924,  3925,
    3926,  3927,   153,   414,  3930,  3931,  3932,  3933,  3934,  3935,
    3936,  3937,  3938,  3939,  4908,    85,   218,  3943,  3944,  3945,
     373,   286,  3948,   365,  3668,   153,   153,  3953,  3993,   365,
     200,  3957,   365,  3959,  4596,  3961,   232,   156,   284,   414,
     438,   488,   156,  3969,   502,   234,  3972,   306,  3974,   306,
     435,   156,   414,   414,   244,   360,   414,   414,  3984,   244,
     244,  3987,  3988,   414,   389,   414,  3992,  3993,   414,   360,
    4171,   414,  2570,  3999,   414,   360,   478,  4652,  4001,  4002,
    4003,  4004,     0,  2570,   286,   126,   360,   489,   490,   491,
     492,   493,   494,   414,   414,  4196,   269,   373,   153,    46,
     414,   414,  4018,   499,  4030,   497,  5439,   414,   499,   499,
     218,   218,  4038,   378,   288,   184,  4042,  4018,  3771,  4018,
     502,  3765,   499,   499,     3,   424,    47,  4114,   167,   111,
     499,   502,   167,   499,    37,   153,   414,   153,   488,    37,
     167,   279,   498,   438,   184,   153,   498,   444,  4074,  4744,
    4745,   284,  4747,   287,  3807,  4081,  4804,   438,   502,   360,
    4735,   360,   360,    61,   370,  3809,   488,  4093,  3670,   360,
     151,   151,   360,   218,   218,   218,  5778,  5779,   496,    97,
     218,   218,  4038,  3836,   218,   218,  4042,   218,  4114,  2687,
     218,  1437,  2690,   144,  2692,  2693,    13,   296,    96,   449,
     502,    10,   172,   268,    13,   499,   454,  5707,   221,  5309,
     499,   499,   502,   478,   294,   499,   499,   499,   497,   499,
     221,   498,   404,   291,   489,   490,   491,   492,   493,   494,
     148,   499,  5022,    58,   498,    44,   498,  4093,   347,  4165,
     185,   167,    51,   161,  4170,  4171,  4172,  4234,   411,   167,
    4237,   498,   424,    37,   172,   224,  3900,  4832,   438,   157,
     178,   438,   414,   181,   208,    58,   405,   185,    77,  4195,
    4196,   153,   389,   365,   176,   424,  4377,   414,   156,  3923,
     499,   360,   414,   414,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   414,    71,   193,   214,   360,   414,   499,
      77,   457,   499,   339,  3948,    58,   498,   405,  4234,   444,
     167,  4237,   284,    90,    77,   153,   234,  5343,   424,  5345,
     111,   499,   218,   218,  4203,   218,   224,   218,   222,  3831,
     498,   229,   498,   203,   498,  4214,   414,   146,   461,   499,
    3993,   118,   284,   120,    37,   502,   304,   282,   284,     3,
    4337,   498,   502,   424,   502,    43,   414,   498,   370,   499,
     443,    88,   178,   281,   111,  4018,   284,  4354,   172,   218,
     499,   269,   290,   499,   172,  4301,    58,   499,  5478,   455,
     455,   499,   191,   296,   499,  4038,   499,   196,   498,  4042,
     502,   221,   456,   279,   498,   498,   411,   414,   424,   176,
    4513,  4327,  4328,   301,   172,  4331,   457,    77,   197,   307,
    5005,  4337,   202,   274,   190,   190,   274,    58,  4344,  4345,
     405,  5016,  5354,   414,   233,   502,   488,   204,  4354,   347,
     502,    71,   153,   156,   125,   414,   414,   414,   499,   218,
     174,   498,   118,    37,   438,   343,   196,   279,  5154,   498,
     348,  4377,  5552,  5553,   370,   438,  4382,  4383,  4384,   357,
      37,  4448,   269,   169,  5254,   370,   279,   365,  4394,  4370,
     457,    58,    83,   405,  5036,   373,    37,   286,   172,   284,
    2978,   457,   167,   502,   402,   205,   334,   385,  4344,  4345,
     488,  2978,   269,    37,   498,  4596,   394,   274,   216,   287,
     398,  5126,  5077,   172,   443,   498,   386,   499,   304,   499,
     363,  4437,   430,    37,    80,    59,    37,   284,   333,   417,
     153,   153,  4448,   498,   498,   498,  5088,   414,   499,   414,
     167,   499,   498,   498,   498,   498,   454,   498,   456,   457,
     317,    85,   498,    37,   274,   245,   498,   200,  4474,   498,
     370,   499,   153,   111,   452,    37,   333,   288,   456,  4485,
     172,   499,   424,   384,   167,   384,   110,   111,   499,   378,
      90,   134,    58,   110,   118,   498,   498,   502,   496,   498,
      37,   499,   500,   501,   498,   502,   438,  4513,    10,  5354,
    4516,    13,   189,   405,   167,    17,    18,    19,  4524,  4525,
    5700,  4527,   405,   265,   284,  4531,  4532,   499,   498,     6,
    4536,   405,  5544,   160,  4540,   461,   357,  4543,  4544,   357,
      71,   498,  4548,   287,    71,   501,   134,   139,  4554,   457,
    3128,   457,   176,  3131,    10,  3133,  3134,    13,   164,   453,
     442,    17,    18,    19,   443,  4571,   443,   164,   502,   172,
     405,   498,  4578,   498,   431,   199,   330,  4583,   274,   202,
    4586,  4587,   284,   284,   498,   370,    37,    37,  4594,   478,
     287,  5771,  5772,   287,  5562,   498,   174,  5272,   197,  4605,
     489,   490,   491,   492,   493,   494,   174,  4331,   498,   152,
     373,  4344,    58,   499,  4618,  4621,    58,    37,   291,   499,
     454,   340,    58,   247,   414,   123,   250,  4694,   436,   393,
       6,   370,   499,  4639,   139,  4571,   498,  4370,   356,  4706,
     149,   265,  4578,   274,   498,   269,  4652,  4583,   498,   498,
    4586,    23,   356,    34,    80,   414,   502,   502,   172,   498,
     292,   356,   152,   118,   457,   457,   174,   174,   384,   384,
     498,  4677,  5347,   499,  5203,   299,   901,   438,  1663,   940,
    2962,  3281,  2853,  2770,  3476,  1363,  4170,  4145,  4694,  5691,
    2879,  2933,  3687,  4699,  2020,  5129,  5542,  5807,  4325,  5177,
    4706,  4660,  2028,  4285,  4143,  4794,  5153,  3405,  5670,  3078,
    5035,  4670,  5796,  5571,  5570,  5710,  4722,  4299,  5829,  3409,
     344,  4839,  4345,  4371,  5516,  4356,  2947,  4315,  2947,  4735,
    4165,  3501,  4340,  3736,  4833,  5160,  3780,   982,  3316,  4407,
    5451,  3319,  5902,   367,  5988,  5978,  5144,  3695,  5723,  3316,
    5090,  5326,  3319,  4379,  5525,  1822,  5093,    18,    28,   631,
    4766,  5296,   218,   387,  4448,   389,  5898,  2964,   392,  1865,
    2633,  3384,  4382,  1876,  1202,  3791,  5203,  1862,  5340,  5439,
    1900,  5486,  5510,  2878,   286,   683,  4792,  3365,  3629,  4195,
    1983,  1983,  5354,   716,  5750,  5807,  5938,  2909,  3365,   833,
    4413,  2577,  4808,  1775,  1934,  4411,  5218,  4813,  5761,  4907,
    1340,    41,  1379,  4435,    41,  3336,  1439,  1481,  1440,  2587,
    3351,  5659,  5498,  1442,  3319,  4044,  4832,  4027,  5013,  3316,
     286,  5261,  5260,  4839,  4436,  3316,  5922,  5542,  5653,  5782,
    5485,  5499,  1396,  5239,  3961,  4578,  5500,  2488,  3242,  2022,
    4583,  3240,  2908,  4586,  3144,  5036,   889,  2575,  2491,    -1,
      -1,     6,  4929,    -1,    -1,  5507,    -1,    -1,    -1,    -1,
    4851,    -1,    -1,    -1,   498,    -1,    -1,    -1,    23,  4885,
      25,  4887,    -1,    -1,    29,    -1,    -1,    -1,    -1,    -1,
      35,    36,    37,    -1,    39,  5076,    -1,    42,    43,    -1,
      45,    -1,    47,  4839,    -1,  5088,    -1,  5088,    -1,    54,
      55,    56,    -1,    -1,    -1,  4639,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4929,  4905,  4906,    -1,    -1,    -1,    -1,
    5087,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4947,    -1,    -1,  4950,    -1,    -1,  4953,  4954,  4955,
      -1,    -1,    -1,  4677,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5969,  5029,    -1,  5031,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4978,  4979,  5131,  4699,  4982,    -1,    -1,    -1,
      -1,    -1,  5544,    -1,   486,   487,   488,   489,   490,   491,
     492,   493,   494,    -1,    -1,    -1,  5002,    -1,    -1,    -1,
      -1,    -1,  5008,    -1,    -1,    -1,  5012,    -1,    -1,    -1,
      -1,    -1,  5018,  5019,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5029,    -1,  5031,    -1,    -1,    -1,  5035,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    -1,
      -1,    -1,  4766,    -1,    -1,    -1,    -1,    -1,  5241,    -1,
      -1,    -1,   197,   198,   199,  5025,    -1,   202,    -1,    -1,
      61,   206,    -1,   208,    -1,    -1,   211,    -1,    -1,   214,
    5076,  5077,   217,    -1,    -1,   220,  5012,   222,    -1,    -1,
     225,  5087,  5275,    -1,   229,    -1,   231,    -1,    -1,  5282,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,  5035,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5979,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4851,    -1,
    5126,  5750,  5750,    -1,    -1,  5131,    -1,    -1,    -1,  5691,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5338,  5339,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,
      -1,    -1,    -1,  4887,  4746,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4905,  4906,    -1,    -1,    -1,  5158,    -1,  4761,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5193,    -1,    -1,
    5196,    -1,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5203,  5203,  5203,  5189,    -1,
    5839,  5839,  5203,  5203,  5203,    -1,  5222,  5203,  5224,  5203,
    5203,  5203,  5203,  5203,  5203,  5203,  5203,  5203,   229,  5235,
    5203,    -1,    -1,  5239,    -1,  5241,  5941,  5282,    -1,    -1,
      -1,  5192,    -1,    -1,    -1,  5807,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5261,    -1,  5193,  5264,    -1,
      -1,  2587,    -1,    -1,   265,    -1,    -1,    -1,   269,  5275,
    4852,    -1,    -1,  5978,    -1,    -1,  5282,    -1,    -1,  5012,
      -1,  5474,    -1,  5988,    -1,    -1,  5222,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5018,    -1,    -1,    -1,    -1,   300,
     301,  5494,    -1,  5496,    -1,    -1,   307,    -1,    -1,  5938,
    5938,    -1,    -1,    -1,    -1,    -1,    -1,  5323,    -1,    -1,
      -1,    -1,  5328,  5329,    -1,  5261,  5507,  5333,    -1,    -1,
      -1,    -1,  5338,  5339,  5340,    -1,    -1,    -1,   339,    -1,
      -1,    -1,   343,    -1,    -1,    -1,    -1,   348,  5354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   357,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   365,    -1,    -1,    -1,  5374,    -1,
      -1,    -1,   373,    -1,    -1,  5381,    -1,    -1,  5384,    -1,
      -1,    37,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   394,    -1,    -1,    -1,   398,    -1,    -1,
      -1,    -1,    -1,  5409,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5158,    -1,    -1,    -1,    -1,
    5411,    -1,    -1,  5439,  5440,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   452,    -1,    -1,    -1,  5037,  5189,  5039,    -1,    -1,
    4038,    -1,  5468,    -1,  4042,    -1,    -1,    -1,  5474,    -1,
    5203,  4038,    -1,  5409,    -1,  4042,    -1,    -1,    -1,  5485,
    5486,    -1,    -1,  5489,    -1,   630,    -1,    -1,  5494,    -1,
    5496,   636,  5498,   638,    -1,   640,    -1,    -1,   643,    -1,
      -1,   157,    -1,    -1,    -1,   650,    -1,    -1,    -1,    -1,
     655,  5517,   657,    -1,    -1,  4093,    -1,    -1,   663,    -1,
      -1,  5678,    -1,    -1,    -1,    -1,  4093,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5542,   193,  5544,    -1,
      -1,    -1,   687,    -1,    -1,    -1,    -1,    -1,    -1,  5282,
      -1,   696,    -1,    -1,    -1,   700,    -1,    -1,   703,    -1,
      -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,
      -1,    -1,    -1,   229,    -1,    -1,  1121,   722,    -1,    -1,
      -1,    -1,  1127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5597,  1137,    -1,  5751,  5752,  1141,    -1,  5665,  5323,
    1145,    -1,  1147,  5609,  5328,  5329,    -1,    -1,  1153,  5191,
      -1,    -1,    -1,   269,  1159,    -1,    10,  1162,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,   774,
      -1,    -1,   777,   778,   779,  5641,  5642,  5643,    -1,    -1,
      34,    -1,    -1,  5649,    -1,   301,    -1,   792,  5629,    -1,
      44,   307,    -1,  5659,    -1,    -1,    -1,    51,    -1,  5665,
      -1,  5597,    -1,    -1,    -1,    -1,    -1,   812,   813,    -1,
     815,   816,  5678,  5609,    -1,   820,  5409,    -1,  5411,    -1,
      -1,    -1,    -1,    77,    -1,  5691,    -1,   343,  5881,   834,
      -1,    -1,   348,   838,    -1,    -1,    -1,    -1,    -1,   844,
      -1,   357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   365,
      -1,    -1,    -1,    -1,    -1,    -1,  5440,   373,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5732,    -1,    -1,   385,
      -1,    -1,    -1,    -1,    -1,    -1,  5742,    -1,   394,    -1,
      -1,    -1,   398,  5724,   889,  5751,  5752,    -1,    -1,    -1,
      -1,  5757,    -1,    -1,  5750,    -1,  5762,    -1,   903,    -1,
      -1,   417,  5344,    -1,  5346,  5489,  4344,  4345,    -1,  5750,
     915,  5750,  5778,  5779,    -1,    -1,    -1,  4344,  4345,    -1,
      -1,    -1,    -1,    -1,    -1,   930,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5839,    -1,   452,   191,    -1,    -1,
     456,  5807,   196,    -1,   949,    -1,  5742,    -1,    -1,   954,
     955,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5829,   218,   219,  5983,  5984,    -1,  5835,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,
      -1,   986,   987,  5839,    -1,    -1,  5852,    -1,  3174,  3175,
      -1,    -1,    -1,  3179,    -1,    -1,    -1,    -1,  5839,    -1,
    5839,    -1,    -1,    -1,  1009,  1010,    -1,  5873,    -1,    -1,
    5876,    -1,    -1,    -1,    -1,  5881,    -1,  1022,   272,  1024,
      -1,    -1,    -1,  1028,    -1,    -1,  1031,  1032,    -1,  1034,
    3216,  3217,   286,  5829,  1039,   289,  5629,    -1,    -1,  5835,
      -1,    -1,    -1,    -1,    -1,     0,    -1,  5913,    -1,    -1,
      -1,    -1,    -1,    -1,  5920,    -1,    -1,  1062,    -1,    -1,
      -1,    -1,    -1,    -1,  1069,  1070,    -1,    -1,  5934,    -1,
      -1,    -1,    -1,    -1,    -1,  5941,    -1,    -1,    -1,    -1,
      -1,    -1,  5938,    -1,    -1,  1090,  1091,  1092,    -1,  1094,
      -1,  1096,    -1,  1098,  1099,    -1,    -1,  5938,    -1,  5938,
      -1,    -1,    -1,  5969,  5970,    -1,    -1,    -1,  5974,    -1,
      -1,    -1,  5978,    -1,    -1,    -1,    -1,  5983,  5984,    -1,
      -1,    -1,  5988,    -1,   378,    -1,    -1,  1132,    -1,  1134,
    1135,  5724,    -1,  4571,    -1,    -1,    -1,    -1,  5934,    -1,
    4578,  5583,    97,    -1,  4571,  4583,    -1,    -1,  4586,  4587,
      -1,  4578,    -1,    -1,    -1,    -1,  4583,  5750,    -1,  4586,
      -1,    -1,  1167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1195,  1196,    -1,   148,    -1,  1200,    -1,  1202,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   161,    -1,    -1,    -1,
      -1,    -1,   167,    -1,    -1,    -1,  1221,   172,    -1,    -1,
      -1,    -1,  1227,   178,   478,  1230,   181,    -1,  1233,    -1,
     185,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,    -1,  1247,    -1,    -1,   499,  5839,    -1,   502,    -1,
      -1,  5693,    -1,    10,    -1,    -1,    13,    -1,    -1,   214,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1278,    -1,    -1,    -1,    34,    -1,   234,
      -1,    22,    -1,    -1,    -1,    -1,    27,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,  1306,  1307,  1308,    -1,  1310,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    -1,  1330,   281,    -1,    -1,   284,
      -1,    -1,    -1,    -1,    -1,   290,    -1,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,  5938,    -1,    -1,    -1,    10,
      -1,    -1,    13,    94,    -1,    -1,    17,    18,    19,  5801,
      -1,    -1,    -1,  1368,    -1,    -1,    -1,    -1,    -1,    -1,
    4808,   112,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1386,    -1,    44,    -1,    -1,    -1,    -1,  5830,  5831,
      51,    -1,   347,    -1,    -1,   136,    -1,    -1,    -1,    -1,
      -1,  4839,    -1,    -1,    -1,    -1,   147,    -1,    -1,    -1,
      -1,    -1,  4839,    -1,    -1,   156,    77,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1432,   169,    -1,
      -1,  1436,  1437,   174,   191,    -1,    -1,    -1,    -1,   196,
      -1,    -1,  1447,  1448,  1449,    -1,  1451,   402,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   200,
      -1,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,  1474,
      -1,    -1,    -1,    -1,    -1,   430,   233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,    -1,  5931,
    1895,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1903,   454,
      -1,   456,   457,    -1,  1509,   246,    -1,    -1,    -1,  1514,
      -1,    -1,  1517,    -1,    -1,   272,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1530,  1531,    -1,    -1,   286,
     191,    -1,   289,    -1,  1539,   196,    -1,  1542,    -1,    -1,
      -1,   496,    -1,    -1,   499,   500,   501,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,    -1,
      -1,    -1,    -1,    -1,  1569,    -1,  1571,    -1,    -1,  1574,
      -1,    -1,   233,    -1,  5012,    -1,    -1,    -1,    -1,   320,
     321,    -1,    -1,   324,    -1,  5012,  1591,    -1,    -1,  1594,
      -1,    -1,  1597,    -1,    -1,    -1,    -1,  5035,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5035,    -1,
     351,   272,    -1,   354,  1619,    -1,    -1,    -1,    -1,   360,
      -1,   378,    -1,    -1,    -1,   286,   367,    -1,   289,   370,
    1635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1647,  1648,  1649,  1650,  1651,    -1,   389,  5087,
      -1,    -1,    -1,    -1,    -1,   396,    -1,    -1,    -1,    -1,
    1665,   402,    -1,    -1,   405,    -1,    -1,    -1,   409,    -1,
      -1,  1676,  1677,  1678,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5131,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,
      -1,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,  3924,  3925,
    3926,  3927,   499,    -1,  3930,  3931,  3932,  3933,  3934,  3935,
    3936,  3937,  3938,  3939,    -1,  5193,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5193,    -1,    -1,  1774,
      -1,  3957,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1785,    -1,    -1,    -1,  5222,    -1,    -1,    -1,  1793,  1794,
      -1,    -1,    -1,    -1,    -1,  5222,    -1,    -1,    -1,    -1,
      -1,  3987,  3988,    -1,  1809,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,    -1,    -1,
      -1,    -1,  1827,  5261,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,  5261,    -1,   497,    -1,  1843,  1844,
    1845,  1846,    -1,    -1,  4030,    -1,    -1,  1852,    -1,    -1,
      -1,    -1,    -1,    -1,  1859,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1876,    -1,    -1,  1879,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1889,  1890,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1900,  1901,    -1,    -1,  1904,
      -1,    -1,  1907,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     0,    -1,    -1,  1922,  1923,    -1,
      -1,    -1,    -1,    -1,  1929,    -1,  1931,    -1,    -1,  1934,
      -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5381,    30,  1950,    32,    33,    -1,    -1,
      -1,    -1,  1957,    -1,  1959,    -1,    -1,  1962,  1963,    -1,
    1965,  1966,    -1,  1968,    50,    -1,    -1,    -1,    -1,    -1,
    1975,  5409,    -1,    -1,    60,    -1,    -1,  1982,    -1,    -1,
      -1,    -1,  5409,  1988,  1989,    -1,    72,  1992,    74,    75,
      -1,  1996,    -1,  1998,    -1,    81,    -1,    83,  2003,  2004,
      -1,    -1,    -1,    -1,    -1,  2010,  2011,  2012,    -1,    95,
    2015,    97,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,
      -1,  2026,    -1,  2028,  2029,    -1,    -1,  2032,   114,    -1,
      24,   117,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      -1,    -1,  2047,  2048,  2049,    -1,   132,    24,   134,    -1,
      -1,    45,   138,    30,    -1,    -1,    -1,    -1,   144,  2064,
      -1,    -1,    -1,    -1,    -1,    -1,   152,    -1,   154,    -1,
      -1,    -1,    -1,    -1,    -1,   161,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   178,    -1,    -1,    -1,    -1,    -1,    75,  2104,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,   195,
      -1,    -1,    -1,    28,    -1,  4301,    -1,    -1,    -1,    10,
      -1,    -1,    13,  2528,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
      -1,    -1,    -1,    34,   138,    -1,    -1,   141,    -1,   235,
     236,    -1,    -1,    44,   131,   241,    -1,    -1,    -1,  5597,
      51,   138,    -1,    -1,   141,    -1,    -1,   253,    -1,    -1,
    5597,  5609,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5609,    -1,    -1,   271,    77,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2207,    -1,    -1,    -1,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   307,    -1,    -1,    -1,   202,    -1,    -1,    -1,   315,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5678,    -1,  2247,   329,    -1,    -1,    -1,    -1,    -1,   335,
     336,    -1,   338,    -1,    -1,    -1,    -1,   343,    -1,    -1,
      -1,    24,    -1,   349,    -1,    -1,   352,    30,    -1,    -1,
      -1,   265,    -1,   359,    -1,   269,    -1,    -1,    -1,   365,
     366,    -1,    -1,    -1,    -1,   279,    -1,   373,   265,    -1,
      -1,   377,   269,  2298,   288,    -1,    -1,    -1,    -1,    -1,
     191,   387,   279,    -1,  5742,   196,   300,    -1,    -1,    -1,
      -1,   288,    75,  5751,  5752,  5742,   402,    -1,    -1,    -1,
      -1,    -1,    -1,   300,    -1,    -1,    -1,   218,   219,    -1,
    4516,    -1,    -1,    -1,    -1,    -1,   422,    -1,    -1,    -1,
      -1,    -1,   233,    -1,    -1,   339,    -1,   433,   342,   343,
      -1,    -1,    -1,   439,    -1,    -1,    -1,    -1,   444,    -1,
      -1,    -1,   339,    -1,    -1,   342,   343,    -1,   131,    -1,
      -1,   457,    -1,    -1,    -1,   138,    -1,    -1,   141,   373,
      -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5829,    -1,    -1,   480,   286,   373,  5835,   289,    -1,
      -1,    -1,  5829,    -1,    -1,   168,    -1,    -1,  5835,    -1,
      -1,    -1,   498,    -1,  5852,   501,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   202,
      -1,    -1,    -1,    -1,    -1,    -1,    17,   441,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   441,    -1,    -1,  2472,  2473,  2474,
    2475,  2476,  2477,  2478,  2479,  2480,    -1,  2482,    -1,    -1,
      -1,    -1,  5920,    -1,    -1,  2490,  2491,   378,  2493,    -1,
      -1,    -1,    -1,    -1,    -1,  2500,  5934,    -1,    -1,    -1,
      -1,    -1,   265,    -1,    -1,    -1,   269,  5934,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   279,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2529,   288,  2531,    -1,    -1,  2534,
    2535,    -1,  5970,  2538,    -1,  2540,  5974,   300,  2543,    -1,
      -1,    -1,  2547,    -1,    -1,  5983,  5984,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2570,    -1,    -1,    -1,    -1,
      -1,  2576,  2577,    -1,    -1,    -1,   339,    -1,    -1,   342,
     343,    44,  2587,    -1,    -1,    -1,    -1,   478,    51,    -1,
      -1,  2596,  2597,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,    -1,  2610,    -1,    -1,    -1,    -1,
     373,   502,  2617,    -1,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3028,    -1,    -1,    -1,    -1,  3033,    -1,
    3035,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3045,    -1,    -1,  3048,    -1,  3050,  3051,    -1,    -1,  3054,
      -1,    -1,  2657,  3058,  2659,  3060,    -1,    -1,  3063,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2676,    10,    -1,    -1,    13,    -1,    -1,   441,    17,
      18,    19,  2687,    -1,    -1,  2690,  2691,  2692,  2693,    -1,
      -1,  2696,    -1,    -1,  2699,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,  2720,    -1,    -1,    -1,    -1,
      -1,  3126,    -1,    -1,    -1,    -1,  2731,    -1,   191,    -1,
      -1,    -1,    -1,   196,  2739,  2740,    -1,    -1,    -1,    77,
      -1,  2746,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2755,    -1,    -1,    -1,    -1,   218,   219,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4950,    -1,    -1,    -1,    -1,    -1,
     233,  2776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2796,  2797,    10,    -1,  2800,    13,    -1,  2803,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,   272,
      -1,    -1,    -1,    -1,    -1,    -1,  5002,    34,    -1,    -1,
      -1,  2826,    -1,   286,  2829,    -1,    -1,    44,   743,    -1,
     745,    -1,   747,    -1,    51,    -1,    -1,    -1,   753,   754,
     755,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2854,
    2855,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,
      77,    -1,    -1,    -1,  2869,    -1,  2871,  2872,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,   219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   233,    -1,  2902,  2903,  2904,
      -1,    -1,    -1,  2908,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2916,    -1,    10,    -1,   378,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,  2929,    -1,    -1,    -1,    -1,    -1,
    2935,    -1,  2937,    -1,   272,    -1,    -1,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2950,    -1,    44,   286,    24,
    2955,   289,    -1,  2958,    51,    30,    -1,  2962,    -1,    -1,
    2965,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      -1,    -1,  2977,  2978,   191,    30,    -1,    -1,    -1,   196,
      77,    -1,    -1,  2988,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2998,    -1,  3000,    -1,    -1,    -1,    -1,
      75,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,  3414,
      -1,    -1,    -1,    -1,    -1,   478,   233,    -1,    -1,    -1,
      75,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,   948,  3039,    -1,  3041,    -1,  3043,    -1,
     378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5235,
      -1,    -1,    -1,    -1,    -1,   272,   131,    -1,    -1,    -1,
      -1,   632,    -1,   138,  3069,    -1,   141,    -1,    -1,   286,
      -1,    -1,   289,  3078,    -1,    -1,   131,    -1,  5264,    -1,
    3485,    -1,  3487,   138,    -1,    -1,   141,    -1,    -1,    -1,
      -1,    -1,    -1,   168,   191,    -1,    -1,    -1,    -1,   196,
      -1,    -1,  1017,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   682,   683,   168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   218,   219,  3128,  3129,    -1,  3131,   202,  3133,  3134,
      -1,  3136,    -1,    -1,    -1,    -1,   233,    -1,  3143,    -1,
     478,    -1,    -1,  3148,    -1,    -1,    -1,   202,   486,   487,
     488,   489,   490,   491,   492,   493,   494,    -1,    -1,    -1,
      -1,   378,    -1,    -1,   502,    -1,    -1,    -1,    -1,  3174,
    3175,  3176,    -1,    -1,  3179,   272,    -1,    -1,    -1,    -1,
      -1,    -1,  3187,  3188,  3189,  3190,    -1,    -1,    -1,   286,
     265,    -1,   289,    -1,   269,  3200,    -1,    -1,  3203,    -1,
    3205,    -1,    -1,    -1,   279,    -1,    -1,    -1,    -1,   780,
     265,  3216,  3217,   288,   269,  3220,    -1,    -1,    -1,    -1,
    3625,    -1,    -1,    -1,   279,   300,  3631,    -1,    -1,    -1,
      -1,    -1,  3237,   288,  3239,   806,  3241,    -1,  3243,    -1,
      -1,    -1,    -1,   814,    -1,   300,   817,   818,   819,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3263,    -1,
      -1,   478,  3267,    -1,   339,    -1,    -1,   342,   343,   486,
     487,   488,   489,   490,   491,   492,   493,   494,    -1,    -1,
      -1,   378,   499,  3288,   339,    -1,    -1,   342,   343,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,  5485,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      24,  3316,    -1,    -1,  3319,  3320,    30,    -1,   373,  3324,
    3325,  3326,    -1,    -1,    -1,    -1,  3331,    -1,    -1,    -1,
      -1,  3336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,  3351,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3365,    75,  3367,    -1,    -1,    34,   441,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    44,    -1,    -1,    17,    18,
      19,   478,    51,    -1,    -1,    -1,   441,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,    -1,  3404,
      -1,    -1,   499,    -1,    -1,    44,  3411,    -1,    77,    -1,
      -1,  3816,    51,  3818,    -1,  3820,    -1,   131,    -1,    -1,
      -1,    -1,    -1,    -1,   138,    -1,    -1,   141,    -1,  3434,
    3435,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,
      -1,    -1,  1357,    -1,    -1,    -1,  1017,  1362,  1363,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5649,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1390,    -1,    -1,    -1,    -1,
      -1,   692,    -1,    -1,  1399,    -1,  1401,    -1,   202,    -1,
    1405,    -1,    -1,    -1,    -1,    -1,    -1,  1412,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   718,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3541,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,
     219,   265,   191,    -1,    -1,   269,    -1,   196,    -1,    -1,
      -1,    -1,    -1,    -1,   233,   279,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   288,    -1,    -1,    -1,    -1,   218,
     219,    -1,    -1,    -1,    -1,    -1,   300,  1502,    -1,    -1,
      -1,    -1,  5778,  5779,   233,    -1,    -1,  1512,    -1,    -1,
      -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,
     289,    -1,    -1,    -1,    -1,   339,    -1,    -1,   342,   343,
      -1,    -1,    -1,   272,    -1,    -1,  1207,    -1,    -1,    -1,
      -1,  1556,  1557,    -1,    -1,    -1,    -1,   286,  3653,    -1,
      -1,    -1,    -1,    -1,  3659,    -1,   867,    -1,    -1,   373,
      -1,    -1,    -1,    -1,  1235,  3670,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    -1,  1599,    13,    -1,  1602,  1603,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3707,  3708,  3709,    -1,    34,    -1,    -1,   378,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,  3724,
      -1,    -1,    -1,    51,    -1,    -1,    -1,   441,    -1,    -1,
      -1,    -1,    -1,    -1,  3739,    -1,    -1,    10,    -1,   378,
      13,  1312,    -1,    -1,    17,    18,    19,    -1,    -1,    77,
    1321,    -1,  3757,  3758,  3759,    -1,    -1,    -1,  3763,    -1,
      -1,    34,    -1,    -1,  1335,    -1,    -1,    -1,    -1,    -1,
    3775,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    -1,    -1,  1354,    -1,    -1,  1357,  1358,    -1,    -1,
      -1,  1362,  1363,    -1,    -1,    -1,    -1,    -1,  1009,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,   478,
      -1,    -1,    -1,    -1,    -1,    -1,  1027,   486,   487,   488,
     489,   490,   491,   492,   493,   494,  3831,  1038,    -1,    -1,
     499,  3836,    -1,    -1,  3839,    -1,    -1,    -1,    -1,   478,
      -1,    -1,  1053,    -1,    -1,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,    -1,  3862,    -1,    -1,
      -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,
    3875,    -1,    -1,  3878,    -1,    -1,    -1,  1792,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,   219,  3897,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3906,    -1,    -1,    -1,   233,    -1,    -1,    -1,  3914,
      -1,  3916,    -1,    -1,  3919,    -1,    -1,    -1,   191,  3924,
    3925,  3926,  3927,   196,    -1,  3930,  3931,  3932,  3933,  3934,
    3935,  3936,  3937,  3938,  3939,    -1,    -1,    -1,  3943,  3944,
    3945,    -1,    -1,    -1,   272,   218,   219,    -1,  3953,    -1,
      -1,    -1,  3957,    -1,    -1,    -1,  3961,    -1,   286,    -1,
     233,   289,    -1,    -1,  3969,    -1,    -1,  3972,    -1,  3974,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3984,
      -1,    -1,  3987,  3988,    -1,    -1,    -1,  3992,  3993,    -1,
      -1,    -1,  3997,    -1,  3999,    -1,    -1,    -1,    -1,   272,
      24,  4006,  4007,  4008,  1215,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,   286,  4419,    -1,   289,  4422,    -1,    -1,
      -1,  4026,  4027,  4028,    -1,  4030,  4031,    -1,    -1,  4034,
      -1,    -1,    -1,  4038,    -1,    -1,    -1,  4042,    -1,    -1,
      -1,    -1,    -1,  4048,    -1,  1616,    -1,    -1,    -1,    -1,
     378,    75,    -1,  1624,    -1,    -1,  4461,    -1,    -1,    22,
      -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,    -1,  4074,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4093,  4094,
    4095,  2006,  2007,    -1,    -1,    -1,    -1,    -1,  2013,  2014,
      -1,    -1,    65,    -1,    -1,   378,    -1,   131,    -1,    -1,
      -1,    -1,    -1,    -1,   138,    78,    -1,   141,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2042,  4133,  4134,
      -1,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   168,    -1,    -1,  4152,    -1,   112,
     478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,    -1,    -1,    -1,
      -1,   499,    -1,   136,    -1,    -1,    -1,    -1,   202,    -1,
      -1,    -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   156,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   478,   169,    -1,    -1,    -1,
      -1,   174,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,    -1,    -1,    -1,   499,    -1,    -1,    -1,
      -1,    -1,  4637,    -1,    -1,    -1,    -1,   200,    -1,    -1,
      -1,   265,    -1,    -1,    -1,   269,  1457,  4252,    -1,    -1,
      -1,    -1,    -1,    -1,    10,   279,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,   288,  1836,    -1,    -1,    -1,  1840,
      -1,    -1,    -1,  4678,  4679,    -1,   300,    -1,    34,    -1,
    4285,    -1,    -1,   246,    -1,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,  4299,    51,  4301,    -1,    -1,    -1,
      -1,    -1,    -1,  4308,    -1,    -1,    -1,    -1,    -1,  4314,
      -1,    -1,    -1,  1524,    -1,   339,    -1,    -1,   342,   343,
    4325,    77,    -1,   286,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4339,    -1,    -1,    -1,    -1,  4344,
    4345,    -1,    -1,    -1,    -1,    -1,    -1,  4352,    -1,   373,
      -1,    -1,    -1,    -1,  1565,    -1,  4361,   320,   321,    -1,
      -1,   324,  4767,  4768,    -1,    -1,  4371,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4383,  4384,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1598,   351,  4394,
      -1,   354,    -1,    -1,    -1,    -1,    -1,   360,    -1,    -1,
    4405,  4406,    -1,    -1,   367,    -1,    -1,   370,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   441,  4423,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   389,    -1,    -1,    -1,
    4435,    -1,  4437,   396,    -1,   191,    -1,    -1,  2009,   402,
     196,    -1,   405,    -1,    -1,    -1,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,    -1,    -1,    -1,    -1,    -1,
      -1,   424,   218,   219,    -1,  1676,  1677,  1678,    -1,  4474,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,
    4485,    -1,    -1,    -1,    -1,    -1,    -1,   450,    -1,    -1,
      -1,    -1,  4897,    -1,    -1,  4900,  4901,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4513,    -1,
      -1,  4516,    -1,    -1,    -1,    -1,   272,    -1,    -1,  4524,
    4525,    -1,    -1,  4928,    -1,    -1,  4531,  4532,    -1,    -1,
     286,  4536,    -1,   289,    -1,  4540,    -1,    -1,  4543,  4544,
      -1,    -1,    -1,  4548,  4549,    -1,    -1,    -1,    -1,  4554,
    4555,  4556,  4557,  4558,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4571,    -1,    -1,  4574,
      -1,    -1,    -1,  4578,    -1,    -1,  1787,    24,  4583,    -1,
      -1,  4586,  4587,    30,  4589,    -1,  4591,  1798,    -1,  4594,
      10,  4596,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
    4605,    -1,    -1,  1814,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4618,    34,    -1,  4621,    -1,    -1,    -1,
      -1,    -1,   378,    -1,    44,    -1,    -1,    -1,    75,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2558,  2559,    -1,    -1,    -1,    -1,  2564,
    4655,    -1,    -1,    -1,    -1,    -1,  1867,    77,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4671,    -1,    -1,    -1,
      -1,  1882,    -1,    -1,  1885,  1886,    -1,    -1,    -1,    -1,
      -1,  2596,  2597,    -1,   131,    -1,    -1,    -1,    -1,    -1,
      -1,   138,    -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1916,  1917,    -1,    -1,    -1,
      -1,    -1,    -1,    61,    -1,    -1,    -1,  4722,    -1,    -1,
      -1,   168,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    -1,
    2655,  4746,    -1,   499,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,   202,  4761,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4792,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,
      -1,    -1,    -1,  4808,    -1,    -1,    -1,    -1,  2019,   157,
    4815,  2022,    -1,   233,    -1,    -1,    -1,    -1,   265,  4824,
      -1,    -1,   269,    -1,  2739,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   279,    -1,  4839,  2046,    -1,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,   193,    -1,  4852,    -1,  4854,
      -1,    -1,   272,   300,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,    -1,   289,
      -1,    -1,    -1,    -1,    -1,  4880,    -1,    -1,    -1,    -1,
      -1,   229,    -1,    -1,    -1,    -1,  4891,    -1,    -1,    -1,
      -1,    -1,   339,  5298,    -1,   342,   343,    -1,    -1,    -1,
      -1,    -1,  4907,    -1,    -1,  2820,    -1,  4912,    -1,    -1,
      -1,    -1,    -1,  2828,    -1,    -1,  2831,   265,    -1,    -1,
      -1,   269,    -1,    -1,    -1,    -1,   373,    -1,  2843,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2510,
      -1,    -1,  4947,    -1,  5349,  4950,    -1,    -1,  4953,  4954,
    4955,    -1,   300,   301,    -1,    -1,    -1,    -1,   378,   307,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4978,  4979,    -1,    -1,  4982,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,   339,    -1,    -1,   441,   343,    -1,  5002,    -1,    -1,
     348,    -1,    -1,  5008,    -1,    -1,    -1,  5012,    -1,   357,
      -1,  5016,    -1,    -1,  5019,    -1,  5021,   365,    -1,    -1,
      -1,    -1,    -1,    -1,    96,   373,    -1,    -1,    -1,    -1,
    5035,  5036,  5037,    -1,  5039,    -1,    -1,   385,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   394,    -1,    -1,    -1,
     398,    -1,    -1,    -1,    -1,    -1,    10,    -1,   478,    13,
      -1,    -1,  5467,    17,    18,    19,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,   499,
      34,    -1,  5087,  5088,  2655,   157,    10,    -1,    -1,    13,
      44,    -1,    -1,    17,    18,    19,    -1,    51,    -1,    -1,
      -1,    -1,    -1,    -1,   452,    -1,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,   193,    -1,    77,    -1,    -1,  5131,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5144,
      -1,    -1,    -1,  2714,  5149,    -1,    -1,    -1,    -1,  5154,
      -1,    -1,    -1,    77,    -1,    -1,    -1,   229,  5163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5173,    -1,
      -1,    -1,  5177,    -1,    -1,  5180,  3091,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,  5191,  5192,  5193,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,   269,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,  5222,    -1,  5224,
      -1,    -1,  2793,    51,    -1,    -1,    -1,    -1,    -1,   301,
    5235,    -1,    -1,    -1,  5239,   307,  5241,   191,    -1,  2810,
      -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    -1,    -1,    -1,  5261,    -1,    -1,  5264,
      -1,    -1,    52,  5268,   218,   219,    -1,   191,    -1,    -1,
    5275,   343,   196,   345,    -1,    -1,   348,  5282,    -1,   233,
      -1,    -1,  2493,    -1,    -1,   357,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   365,   218,   219,    -1,    -1,    -1,    -1,
      -1,   373,  5307,    -1,  5309,  2876,    -1,    -1,    -1,   233,
      -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,   272,    -1,
      -1,    -1,   394,    -1,    -1,    -1,   398,    -1,  5333,    -1,
      -1,    -1,   286,  5338,  5339,   289,    -1,    -1,  5343,  5344,
    5345,  5346,  2913,    -1,  2915,    -1,  2917,  2918,   272,    -1,
      -1,  2922,  2923,  2924,    -1,  2926,  2927,  2928,    -1,    -1,
      -1,    -1,   286,   191,  3279,   289,  3281,    -1,   196,  5374,
      -1,    -1,    -1,    -1,    -1,    -1,  5381,    -1,    -1,    -1,
     452,    -1,  3297,    -1,    -1,    -1,  5791,    -1,    -1,    -1,
     218,   219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5406,    -1,    -1,  5409,   233,    -1,    -1,    -1,    -1,
    2981,    -1,    -1,    -1,    -1,    -1,    -1,  2628,    -1,    -1,
      -1,  2632,  2633,    -1,   378,    -1,    -1,    -1,  3343,  3344,
    5435,    -1,    -1,    -1,    -1,  3006,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   378,    -1,    -1,    -1,   286,    -1,
      -1,   289,    -1,  5468,    -1,    -1,    -1,    -1,    -1,  5474,
      -1,    -1,    -1,  5478,    -1,    -1,    -1,  5482,  2689,    -1,
    5485,    -1,    -1,    -1,  2695,    -1,    -1,    -1,    -1,  5494,
      -1,  5496,    -1,  5498,  5499,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5507,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   478,  2736,    -1,    -1,    -1,    -1,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,    -1,    -1,    -1,    -1,   499,    -1,  5552,  5553,    -1,
     378,    -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,    -1,    -1,    -1,    -1,   499,    -1,    -1,  5583,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5597,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5609,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    34,
      -1,    -1,    -1,    -1,    -1,    -1,  5641,  5642,  5643,    44,
      -1,    -1,    -1,    -1,  5649,    -1,    51,    -1,  5653,    -1,
     478,    -1,    -1,    -1,  5659,    -1,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,    -1,    -1,    -1,
      -1,   499,    77,  5678,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,  5693,    -1,
      -1,    -1,    -1,  2904,    -1,  5700,    -1,    -1,    -1,    -1,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3281,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
    5725,    -1,    -1,    -1,    -1,  2936,    -1,  5732,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5742,    -1,    -1,
      -1,    -1,    -1,    -1,    77,    -1,  5751,  5752,  5753,    -1,
      -1,    -1,  5757,    -1,    -1,    -1,  5761,  5762,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5771,  5772,  5773,    -1,
      -1,    -1,    -1,  5778,  5779,    -1,    -1,    -1,    -1,  5784,
      -1,  3696,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,  5801,    -1,    -1,  3010,
      -1,    -1,    -1,  3014,  3719,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   218,   219,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5829,  5830,  5831,    -1,   233,    -1,
    5835,     8,    -1,    -1,   167,    -1,    -1,    14,    15,   172,
      -1,    -1,    -1,    20,    -1,    22,    -1,  5852,    -1,    -1,
      -1,    28,    -1,    -1,    31,    -1,    -1,  3428,   191,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,   272,  5873,    -1,
      -1,  5876,    -1,    50,    51,    -1,  5881,    -1,    -1,    -1,
      -1,   286,    -1,    -1,   289,   218,   219,    22,    -1,    -1,
      -1,    -1,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     233,    -1,   692,    -1,  3115,    -1,    -1,    -1,  5913,    -1,
      -1,    -1,    -1,  5918,  5919,  5920,  5921,  5922,    -1,  3130,
      -1,    -1,    -1,    -1,  3135,    -1,  5931,    -1,   718,  5934,
      65,    -1,    -1,    -1,    -1,  3506,    -1,    -1,    -1,   272,
      -1,    -1,    -1,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,    -1,    90,   289,    -1,    -1,    94,
      -1,    -1,    -1,    -1,  5969,  5970,    -1,    -1,    -1,  5974,
      -1,  3886,    -1,   378,    -1,    -1,    -1,   112,  5983,  5984,
      -1,    -1,  5987,    -1,    -1,    -1,    -1,    -1,    -1,  3560,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   156,    -1,   200,    -1,    -1,    -1,   204,    -1,    -1,
      -1,    -1,    -1,    -1,   169,   212,    -1,    -1,   215,   174,
      -1,   218,   219,    -1,   221,   378,   223,    -1,    -1,   226,
      -1,   228,    -1,    -1,    -1,    -1,    61,  3628,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   478,    -1,    -1,    -1,   867,    -1,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     225,    96,    -1,    -1,   499,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3674,    -1,    10,    -1,    -1,    13,    -1,
      -1,   246,    17,    18,    19,  3686,  3687,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3696,    -1,    -1,    -1,    34,
    3701,    -1,  3703,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      10,    -1,    -1,    13,    -1,   478,    51,    17,    18,    19,
      -1,   286,   157,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,  3374,    34,    -1,  3377,    -1,  3379,    -1,
      -1,    -1,    77,  3384,    44,   310,    -1,    -1,    -1,  3750,
      -1,    51,    -1,    -1,    -1,   320,   321,    -1,   193,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    -1,  3785,  3786,   351,    -1,    -1,   354,
    3431,    -1,    -1,   358,   229,   360,    -1,    -1,  3439,    -1,
      -1,    -1,   367,    -1,    -1,   370,    -1,  1027,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,  1038,    17,
      18,    19,    -1,  3464,   389,    -1,  4171,    -1,    -1,    -1,
     265,   396,    -1,  1053,   269,    -1,    34,   402,    -1,    -1,
     405,    -1,    -1,    -1,   409,    -1,    44,    -1,    -1,    -1,
      -1,  4196,   417,    51,   419,    -1,   191,    -1,  4203,   424,
      -1,   196,    -1,    -1,    -1,   300,   301,    -1,    -1,  4214,
      -1,    -1,   307,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,   218,   219,   450,    -1,    -1,    -1,    -1,
      -1,   191,  3533,    -1,  3535,    -1,   196,    -1,   233,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,
      -1,    -1,    -1,   348,    -1,    -1,    -1,    -1,   218,   219,
      -1,    -1,   357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     365,    -1,    -1,   233,    -1,    -1,    -1,   272,   373,    -1,
      -1,    -1,    -1,    -1,    -1,  4290,  4291,    -1,    -1,    -1,
     385,   286,    -1,    -1,   289,    -1,    -1,    -1,    -1,   394,
      -1,    -1,    -1,   398,    -1,    -1,    -1,  3968,    -1,    -1,
      -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3626,   286,    -1,    -1,   289,
      -1,    -1,    -1,   191,    -1,  1215,    -1,    -1,   196,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3653,    -1,    -1,    -1,    -1,   452,  3659,    -1,
     218,   219,    -1,   630,    -1,    -1,    -1,  3668,    -1,    -1,
      -1,    -1,  4377,    -1,   641,   233,    -1,    -1,   645,    -1,
      -1,    -1,    -1,   378,    -1,   652,   653,    -1,    -1,   656,
      -1,   658,   659,    -1,    -1,  3696,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   673,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   272,    -1,    -1,    -1,   378,    -1,
      -1,    -1,    -1,    -1,   691,    -1,    -1,    -1,   286,    -1,
      -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4445,    -1,    -1,    -1,    -1,   712,    -1,   714,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   724,    -1,    -1,
      -1,    -1,    -1,    -1,  3765,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1357,    -1,    -1,
      -1,    -1,    -1,   478,    -1,    -1,  3787,    -1,    -1,    -1,
     757,   486,   487,   488,   489,   490,   491,   492,   493,   494,
      -1,    -1,    -1,    -1,   499,    -1,    -1,    -1,  3809,    -1,
    4171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,    -1,
     378,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,  4196,    -1,    -1,    -1,   499,
      -1,    -1,    -1,  4204,    -1,    -1,  4207,    -1,  4209,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   206,   207,    -1,    -1,    -1,    -1,    -1,    -1,
     214,    -1,   216,   217,    -1,    -1,    -1,  1457,   845,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   230,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4255,    -1,    -1,    -1,    -1,  3900,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4271,    -1,    -1,    -1,    -1,  4276,    -1,    -1,    -1,    -1,
     478,    -1,  3923,    -1,    -1,    -1,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,    -1,    -1,    -1,
      -1,   499,    -1,    -1,  1524,    -1,    -1,  3948,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4660,    -1,    -1,    -1,    -1,
     927,  4666,    -1,    -1,    -1,  4670,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,  1565,    -1,    17,    18,    19,
      -1,    -1,  4697,  4698,    -1,    -1,    -1,  4702,  4703,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4374,    44,    -1,  4377,    -1,  1598,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1001,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1025,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1040,    -1,  1042,    -1,    -1,    -1,    -1,
    4081,    -1,    -1,    -1,  1051,    -1,    -1,    -1,    -1,    -1,
      -1,  1058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4463,  4464,  4465,  4466,    -1,  4468,  4469,  4470,
    4471,  4472,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1100,    -1,  1102,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
    4171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,
      -1,    -1,    -1,    -1,    -1,  4196,    -1,    -1,    -1,    -1,
      -1,    -1,  4563,   233,  4565,    -1,    -1,  1787,    -1,    -1,
      -1,  1178,    -1,  1180,    -1,  1182,    -1,  1184,  1798,  1186,
    1187,  1188,    -1,    -1,    -1,    -1,  1193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1814,    -1,    -1,  1204,    -1,    -1,
      -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1222,   286,    -1,    -1,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   629,    -1,  1867,    -1,    -1,
      -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,  1882,    -1,   648,  1885,  1886,    -1,    -1,    -1,
     654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     218,   219,   666,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4331,    -1,    -1,    -1,    -1,   233,  1916,  1917,   682,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   378,    -1,
      -1,    -1,   696,   697,    -1,    -1,    -1,    -1,    -1,   703,
      -1,   705,   706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5076,    -1,    -1,   272,   719,  4377,    -1,    -1,    -1,
      -1,  4382,    -1,    -1,    -1,   729,    -1,    -1,   286,    -1,
      -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4764,  4765,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1379,    -1,    -1,    -1,  4777,    -1,  4779,  4780,
    4781,     0,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    -1,    -1,    -1,   789,    -1,    -1,   478,    -1,
      -1,    30,    -1,    32,    33,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,  2046,    -1,    -1,   499,
      -1,    50,    -1,    -1,   818,    -1,    -1,    -1,    -1,    -1,
     378,    60,    -1,    -1,  4845,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    72,    -1,    74,    75,    -1,   842,    -1,
      -1,    -1,    81,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,    97,    -1,
      -1,    -1,    -1,  4884,    -1,    -1,  4527,    -1,    -1,    -1,
      -1,  1498,    -1,    -1,    -1,   114,    -1,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   132,    -1,   134,    -1,    -1,   902,   138,
      -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   152,    -1,   154,  4937,    -1,    -1,    -1,
     478,    -1,   161,    -1,    -1,    -1,    -1,    -1,   486,   487,
     488,   489,   490,   491,   492,   493,   494,    -1,    -1,   178,
      -1,   499,    -1,  1570,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   195,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4639,    -1,
      -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,  5354,
      -1,    -1,    -1,    44,    -1,    -1,   235,   236,    -1,    -1,
      51,    -1,   241,    -1,    -1,    -1,    -1,  1011,    -1,    -1,
      -1,    -1,    -1,  1017,   253,    -1,  4677,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1028,    -1,    77,    -1,  1032,    -1,
    1034,    -1,   271,    -1,    -1,    -1,    -1,    -1,  4699,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5076,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   307,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   315,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
     329,    -1,    -1,    -1,    -1,    -1,   335,   336,    -1,   338,
    5121,    34,    -1,    -1,   343,  4766,    -1,    -1,    -1,  5130,
     349,    44,    -1,   352,    -1,    -1,    -1,    -1,    51,    -1,
     359,    -1,    -1,    -1,    -1,    -1,   365,   366,    -1,    -1,
      -1,    -1,    -1,    -1,   373,  1139,    -1,    -1,   377,    -1,
     191,    -1,    -1,    -1,    77,   196,    -1,    -1,   387,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1783,    -1,    -1,    -1,
      -1,    -1,    -1,   402,    -1,    -1,    -1,   218,   219,  5534,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,   422,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1818,    -1,    -1,   433,    -1,    -1,  1201,    -1,    -1,
     439,    -1,    -1,    -1,    -1,   444,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1217,    -1,    -1,    -1,    -1,   457,    -1,
      -1,   272,    -1,    -1,  4885,    -1,  4887,  1231,    -1,    -1,
      -1,  1235,    -1,    -1,  1861,   286,  1863,    -1,   289,    -1,
      -1,   480,   481,   482,   483,   484,   485,    -1,    22,    -1,
      -1,    -1,    -1,    27,    -1,    -1,  1883,    -1,   191,   498,
      -1,    -1,   501,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1909,    -1,  1911,   218,   219,   207,    -1,    -1,
      -1,    65,    -1,    -1,    -1,    -1,   216,    -1,    -1,  1926,
     233,  1928,    -1,    -1,    78,    -1,    -1,    -1,    -1,  1936,
     230,  1938,    -1,  1940,    -1,  1942,    -1,  1944,    -1,    -1,
      94,  1948,    -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,
      -1,    -1,    -1,  5354,    -1,    -1,    -1,  5358,   112,   272,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1354,    -1,    -1,   286,    -1,    -1,   289,  5018,  1362,  1363,
      -1,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   147,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   156,    -1,    -1,    -1,    -1,    -1,  2628,    -1,
      -1,    -1,  2632,  2633,    -1,   169,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,   181,    -1,    -1,
      -1,  1415,    -1,    -1,    -1,  5076,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    52,    -1,   200,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,    -1,   378,    -1,    -1,   499,  2689,
      -1,    10,    -1,    -1,    13,  2695,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,    -1,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,  2736,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,   286,    -1,    -1,    -1,    -1,    -1,    77,    -1,
      -1,    34,    -1,  5544,    -1,   299,    -1,  5548,    -1,  5550,
      -1,    44,    -1,  5554,  5555,  5196,   310,    -1,    51,    -1,
      -1,    -1,    -1,    -1,    -1,   478,   320,   321,    -1,    -1,
     324,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,    -1,    77,    -1,   499,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5941,   351,    -1,    -1,
     354,    -1,    -1,    -1,   358,    -1,   360,    -1,    -1,    -1,
      -1,    -1,    -1,   367,    -1,    -1,   370,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5978,    -1,   389,    -1,    -1,    -1,    -1,
      -1,    -1,   396,  5988,    -1,    -1,    -1,    -1,   402,    -1,
      -1,   405,   191,    -1,    -1,   409,    -1,   196,    -1,    -1,
      -1,    -1,    -1,   417,    -1,   419,    -1,    -1,    -1,    -1,
     424,    -1,    -1,    -1,    -1,    -1,    -1,  1661,    -1,   218,
     219,    -1,  5323,   437,    -1,    -1,    -1,  5328,  5329,    -1,
      -1,    -1,    -1,    -1,   233,    -1,   450,    -1,   191,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2936,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   218,   219,    -1,    -1,   629,
      -1,    -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,
     233,    -1,    -1,    -1,    -1,    -1,    -1,   286,   648,    -1,
     289,    -1,    -1,    -1,   654,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   666,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   272,
      -1,    -1,   682,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3010,  1775,    -1,   286,  3014,    -1,   289,   697,  5439,  5440,
      -1,    -1,    -1,    -1,    -1,   705,  5807,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   719,
      -1,    -1,    -1,    -1,    -1,    -1,  1810,    -1,    -1,   729,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   378,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5489,  1833,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1841,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1849,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   378,    -1,    -1,    -1,   789,
      -1,    -1,    -1,    -1,    -1,  3115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1889,  1890,    -1,  1892,  1893,
    3130,    -1,    -1,    -1,    -1,  3135,    -1,    -1,   818,    -1,
    1904,    -1,  1906,  1907,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1919,  1920,    -1,    -1,   478,
    5941,    -1,   842,    -1,    -1,    -1,  5947,   486,   487,   488,
     489,   490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,
     499,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1959,    -1,  5978,  1962,  1963,
      -1,    -1,    -1,    -1,    -1,   478,    -1,  5988,    -1,    -1,
    5991,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   902,    -1,    -1,    -1,   499,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2622,  2623,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,  2641,  2642,    -1,  2644,  2645,    -1,
      -1,  2648,  2649,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    -1,    38,    -1,    -1,    -1,  2663,    -1,    44,    -1,
      -1,    -1,    -1,  2670,    -1,    51,    -1,  2674,  2675,    -1,
      -1,  2678,  2679,    -1,    -1,    -1,    -1,    -1,  2685,    -1,
      -1,    -1,  2066,    -1,   692,    -1,    -1,    -1,    -1,    -1,
    2697,    77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2709,    -1,    -1,    -1,    -1,  2714,    -1,    -1,
     718,  1011,    -1,    -1,    -1,    -1,    -1,  1017,    -1,    -1,
      -1,    -1,  2729,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2738,    -1,    -1,  2741,    -1,  2743,  2744,  2745,    -1,
      -1,    -1,   128,  2750,  2751,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2760,  3374,    -1,    -1,  3377,  2765,  3379,
      -1,    -1,  2769,    10,  3384,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,  2781,  2782,    -1,    -1,    -1,  2786,
      -1,    -1,    -1,    -1,    -1,  2792,  2793,    34,    -1,    -1,
      -1,    -1,  2799,    -1,    -1,  2802,    -1,    44,    -1,    -1,
      -1,    -1,  2809,  2810,    51,   191,    -1,    -1,  2815,    -1,
     196,  3431,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3439,
    2827,    -1,    -1,  2830,    -1,    -1,    -1,    -1,  2835,    -1,
      77,    -1,   218,   219,  2841,  2842,    -1,    -1,    -1,  1139,
      -1,    -1,  2849,    -1,  3464,  2852,    -1,   233,    -1,  2856,
    2857,  2858,  2859,    -1,  2861,    -1,    -1,    -1,    -1,   867,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2874,  2875,    -1,
    2877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2888,  2889,  2890,    -1,    -1,   272,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     286,  1201,    -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3533,    -1,  3535,    -1,  1217,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5969,    -1,
      -1,  1231,    -1,    -1,    -1,  1235,    -1,    -1,  2945,    -1,
      -1,    -1,    -1,    -1,   191,    -1,  2953,    -1,    -1,   196,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2973,    -1,    -1,    -1,
      52,   218,   219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
      10,    -1,   378,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,  3626,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,  3023,    -1,    -1,  1027,
      -1,    -1,    -1,    -1,    44,   272,    -1,    -1,    -1,    -1,
    1038,    51,    -1,    -1,    -1,  3042,    -1,  3044,    -1,   286,
      -1,    -1,   289,    -1,    -1,  1053,    -1,    -1,  3668,    -1,
      -1,    -1,   438,    -1,  1354,    -1,    -1,    77,    -1,    -1,
      -1,    -1,  1362,  1363,    -1,    -1,    -1,   314,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3696,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,   478,    -1,    17,    18,    19,    -1,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    -1,
      -1,    34,    -1,    -1,    37,  1415,    -1,    -1,    -1,    -1,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,
    3137,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3765,   166,    -1,   395,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3787,    -1,    -1,
      -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2568,    -1,    -1,    -1,    -1,  3809,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1215,    -1,    -1,
      -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   478,    -1,    -1,    -1,    -1,    -1,  2621,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,    -1,    -1,
      -1,    -1,   272,    -1,    -1,  2639,    -1,    -1,    -1,  2643,
      -1,    -1,    -1,  2647,    -1,    -1,   286,    -1,   191,   289,
      -1,  2655,    -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,
    3900,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2673,
      -1,    -1,   312,    -1,    -1,   218,   219,    -1,    -1,    -1,
      -1,    -1,    -1,  3923,    -1,    -1,  2690,    -1,  2692,  2693,
     233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2707,    -1,    -1,    -1,    -1,  3948,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2727,  2728,    -1,    -1,    -1,    -1,   272,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   378,    -1,
      -1,  1661,    -1,   286,    -1,    -1,   289,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2758,  2759,    -1,    -1,  2762,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3406,
      -1,  2785,    -1,  2787,    -1,    -1,    -1,  2791,    -1,    -1,
      -1,    -1,    -1,    -1,  2798,    -1,    -1,    -1,    -1,  3426,
      -1,  2805,    -1,    -1,  2808,    -1,    -1,    -1,    -1,    -1,
    2814,    -1,    -1,    -1,    -1,    -1,  3443,    -1,    -1,    -1,
    3447,    -1,    -1,    -1,    -1,  3452,  3453,  3454,    -1,  1457,
    2834,    -1,    -1,    -1,    -1,   378,  2840,    -1,   478,    -1,
      -1,  4081,    -1,  2847,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,  1775,  2860,    -1,    -1,    -1,
      -1,  3488,  3489,  3490,  3491,    -1,    -1,    -1,    -1,  2873,
      -1,    -1,    -1,    -1,  2878,    -1,    -1,    -1,    -1,    -1,
    2884,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1810,    -1,    -1,    -1,    -1,    -1,  1524,    -1,  3525,    -1,
    3527,  3528,  3529,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1833,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1849,
      -1,  4171,    -1,    -1,    -1,   478,    -1,  1565,    -1,    -1,
    2944,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,    -1,    -1,    -1,  4196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1598,    10,  1892,  1893,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,  1906,    -1,    -1,    -1,
     692,    -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,  1919,
    1920,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,  3640,    -1,    -1,   718,    -1,    -1,    -1,
      -1,    -1,  3649,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3675,  3676,
      -1,    -1,    -1,  3680,    -1,    -1,    -1,    -1,    -1,    24,
      -1,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    37,    -1,    -1,  3702,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4331,    -1,    -1,    59,  3099,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      75,    -1,    -1,  3117,    -1,    -1,    -1,    -1,    -1,    -1,
    3124,    -1,    -1,    -1,    -1,    -1,    -1,  3131,  3755,  3133,
    3134,    -1,    -1,  3760,    -1,    -1,    -1,  4377,    -1,  3766,
      -1,    -1,  4382,    -1,    -1,   110,  2066,    -1,    -1,    -1,
      -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,  1787,
      -1,    -1,    -1,    -1,    -1,   867,   131,    -1,    -1,  3796,
    1798,    -1,    -1,   138,    -1,    -1,   141,    -1,    -1,   218,
     219,    -1,    -1,    -1,    -1,    -1,  1814,    -1,    -1,    -1,
      -1,  3195,    -1,    -1,   233,    -1,    -1,  3201,  3825,    -1,
    3827,    -1,    -1,   168,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    34,    -1,
      -1,    37,    -1,   272,   199,    -1,    -1,   202,    44,  1867,
      -1,    -1,    -1,    -1,    -1,    51,    -1,   286,    -1,  3876,
     289,    -1,    -1,    -1,  1882,    -1,    -1,  1885,  1886,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    77,    -1,    -1,    -1,    -1,    -1,  3281,    -1,    -1,
      -1,    -1,   247,    10,    -1,   250,    13,  4527,  1916,  1917,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     265,    -1,    -1,    -1,   269,    -1,    -1,    34,    -1,    -1,
      -1,    -1,    -1,    -1,   279,    -1,    -1,    44,    -1,    -1,
      -1,    -1,    -1,   288,    51,  1027,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   299,   300,  1038,    -1,    -1,   378,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      77,  1053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,   342,   343,   344,
      -1,    -1,    -1,    -1,    -1,   191,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,  3398,  3399,    -1,    -1,    -1,  4639,
      -1,    -1,   367,    -1,    -1,    -1,    -1,    -1,   373,    -1,
      -1,    -1,   218,   219,    -1,    -1,    -1,    -1,  2046,    -1,
      -1,  3425,   387,    -1,  3428,    -1,    -1,   233,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4677,    -1,   478,
      -1,    -1,    -1,    -1,    -1,   172,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,    -1,    -1,    -1,  4699,
      -1,    -1,    -1,    -1,   191,    -1,   272,    52,    -1,   196,
    4097,    -1,    -1,  4100,    -1,  4102,   441,    -1,    -1,    -1,
     286,    -1,    -1,   289,    -1,    -1,    -1,    -1,  4115,    -1,
      -1,   218,   219,    -1,    -1,    -1,  3500,  3501,  3502,    -1,
    4127,    -1,    -1,    -1,  4131,    -1,   233,    -1,    -1,    -1,
      -1,    -1,    -1,  1215,    -1,    -1,    -1,    -1,    -1,    -1,
    3524,    -1,    -1,  4150,    -1,    -1,  4766,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3543,
      -1,  4168,    -1,    -1,    -1,   272,  4173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3562,   286,
      -1,    -1,   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4198,   378,    -1,    -1,  4202,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4210,  4211,  4212,  4213,    -1,    -1,    -1,
      -1,    -1,    -1,  4220,  4221,  4222,  4223,    -1,    -1,    -1,
      -1,    -1,  4229,  4230,    -1,    -1,    -1,    -1,  4235,  4236,
      -1,  4238,  4239,  4240,  4241,  4242,  4243,  4244,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4254,    -1,    -1,
      -1,  4258,  4259,  4260,  4261,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3648,    -1,    -1,  4887,  2568,    -1,
      -1,   378,    -1,    -1,    -1,  4282,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   478,  4300,    -1,    -1,    -1,    -1,    -1,    -1,
     486,   487,   488,   489,   490,   491,   492,   493,   494,    -1,
      -1,  3695,    -1,    -1,    -1,    -1,    -1,  3701,    -1,  3703,
      -1,  2621,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3716,    -1,  3718,    -1,    -1,    -1,    -1,  2639,
      -1,    -1,    -1,  2643,    -1,    -1,    -1,  2647,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2655,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4375,    -1,
      -1,   478,    -1,  2673,    -1,  1457,    -1,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,  5018,    13,
      -1,  4408,  3786,    17,    18,    19,    -1,  2707,  4415,    -1,
    4417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      34,    -1,    -1,    37,    -1,    -1,    -1,  2727,  2728,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    -1,
      -1,    -1,  1524,    -1,  3828,  4452,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5076,    -1,  2758,  2759,
      -1,    -1,  2762,    77,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3855,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   692,    -1,  1565,    -1,  2785,    -1,  2787,    -1,    -1,
      -1,  2791,    -1,  3877,    -1,    -1,  3880,    -1,  2798,    -1,
      -1,    52,    -1,    -1,    -1,  2805,    -1,   718,  2808,    -1,
      -1,    -1,    -1,    -1,  2814,    -1,  1598,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2834,    -1,    -1,    -1,    -1,    -1,
    2840,    -1,    -1,    -1,    -1,    -1,    -1,  2847,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2860,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,
      19,    -1,    -1,  2873,    -1,  3959,  5196,   191,  2878,    -1,
      -1,    -1,   196,    -1,  2884,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,   218,   219,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   233,
    2628,    -1,    -1,    -1,  2632,  2633,    -1,   692,    77,    -1,
      -1,    -1,    -1,  4640,  4641,  4642,    -1,    -1,    -1,  4646,
    4647,  4648,  4649,    -1,  2944,    -1,  4653,    -1,    -1,    -1,
      -1,    -1,    -1,   718,    -1,    -1,   867,    -1,   272,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   286,    -1,    -1,   289,    -1,    -1,    -1,    -1,
      -1,  2689,  4689,  4690,  4691,  4692,  4693,  2695,  4695,  4696,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4707,  4708,    -1,  5323,    -1,  1787,    -1,    -1,  5328,  5329,
      -1,    -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   692,  2736,  4736,
    4114,    -1,  1814,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,    -1,   718,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   378,    -1,    -1,    -1,    -1,   218,
     219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4165,    -1,    -1,   233,  1867,  4170,    -1,  4172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3099,
    1882,    -1,   867,  1885,  1886,    -1,    -1,    -1,    -1,    -1,
      -1,  4195,    -1,    -1,    -1,    -1,  1027,  3117,    -1,    -1,
    5440,    -1,    -1,   272,  3124,    -1,    -1,  1038,    -1,    -1,
      -1,  4838,    -1,    -1,  1916,  1917,    -1,   286,    -1,    -1,
     289,    -1,  1053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4234,    -1,    -1,  4237,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,  5489,
      -1,    -1,   486,   487,   488,   489,   490,   491,   492,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3195,  4903,    -1,    -1,    -1,
      -1,  3201,   867,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2936,   378,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4327,  4328,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4337,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   410,  1027,    -1,  2046,    24,    -1,    -1,    -1,    -1,
    4354,    30,    -1,  1038,    -1,    -1,    -1,    -1,    37,    -1,
      -1,  3281,    -1,    -1,    -1,    -1,    -1,    -1,  1053,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      59,    -1,  3010,    -1,  1215,    -1,  3014,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    75,    37,  5025,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,   478,
      -1,    51,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,
      -1,   110,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    -1,  1027,    -1,  4448,    -1,    -1,    -1,    -1,    -1,
      -1,  5078,   131,  1038,    -1,    -1,    -1,    -1,    -1,   138,
      -1,    -1,   141,    -1,    -1,    -1,    -1,    -1,  1053,    -1,
    5097,    -1,    -1,    -1,    -1,  5102,  5103,    -1,  3398,  3399,
      -1,    -1,    -1,    -1,    -1,  5112,    -1,  3115,    -1,   168,
      -1,    -1,  5119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3130,    -1,    -1,  3425,    -1,  3135,  3428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     199,   692,    -1,   202,    -1,    -1,    -1,    -1,  5155,  5156,
    1215,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5168,    -1,  5170,    -1,    -1,    -1,   718,    -1,    -1,
      -1,   191,    -1,    -1,    -1,    -1,   196,    -1,  5185,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,
      -1,   250,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,
    3500,  3501,  3502,  5210,    -1,    -1,   265,    -1,    -1,    -1,
     269,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,
     279,  5228,    -1,    -1,  3524,    -1,    -1,    -1,    -1,   288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     299,   300,    -1,  3543,    -1,    -1,  1457,    -1,    -1,    -1,
    1215,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3562,    -1,    -1,    -1,   286,    -1,  4652,   289,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,   342,   343,   344,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5312,    -1,    -1,   367,    -1,
    4694,    -1,    -1,  1524,   373,  5322,   867,    -1,    -1,    -1,
      -1,    -1,  4706,    -1,    -1,    -1,    -1,    -1,   387,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3648,    -1,
      -1,  4735,    -1,    -1,  1565,    -1,    -1,    -1,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3374,    -1,    -1,  3377,
      -1,  3379,    -1,    -1,    -1,    -1,  3384,    -1,    -1,    -1,
    5387,    -1,   441,    -1,    -1,    -1,    -1,  1598,    -1,    -1,
      -1,    -1,  1457,    -1,    -1,  3695,    -1,    -1,    -1,    -1,
      -1,  3701,    -1,  3703,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3716,    -1,  3718,    -1,
      -1,    -1,    -1,  3431,    -1,    -1,    -1,    -1,    -1,  4813,
      -1,  3439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4832,    -1,
      -1,  5458,    -1,    -1,    -1,  5462,  3464,    -1,   478,  1524,
      -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,  1027,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3786,  1038,    -1,    -1,
      -1,    -1,  1457,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1565,    -1,  1053,    -1,    -1,    -1,    10,    -1,  5515,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,    -1,  5529,    -1,    -1,  3533,    -1,  3535,  3828,    -1,
      34,    -1,    -1,  1598,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,  4929,  2628,    51,    -1,    -1,
    2632,  2633,    -1,    -1,    -1,  3855,    -1,    -1,    -1,  1524,
      -1,    -1,    -1,    -1,    -1,  5572,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,  1787,  3877,    -1,    -1,
    3880,  5588,    -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1565,    -1,    -1,  1814,    -1,    -1,    -1,  2689,    -1,    -1,
      -1,    -1,    -1,  2695,    -1,    -1,    -1,    -1,  3626,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1598,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5029,    -1,  5031,    -1,    -1,
      -1,    -1,    -1,    -1,  2736,    -1,  1867,    -1,    -1,  3959,
    3668,    -1,    -1,    -1,  1215,    -1,    -1,    -1,   172,    -1,
    5677,  1882,    -1,    -1,  1885,  1886,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,  3696,    -1,
      -1,    -1,   196,  5077,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5087,    -1,  1916,  1917,    -1,    -1,    -1,
      -1,    -1,    -1,  5720,   218,   219,    -1,    -1,    -1,    -1,
      -1,    -1,  1787,    -1,    -1,    -1,    -1,    -1,    -1,   233,
      -1,    -1,    -1,  1798,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,  5126,    -1,    17,    18,    19,  5131,    -1,  1814,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3765,    -1,    -1,
      -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,   272,    -1,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,  3787,
      -1,    -1,   286,    -1,    -1,   289,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3809,  1867,    -1,    77,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5819,    -1,  4114,    -1,    -1,  1882,    -1,    -1,
    1885,  1886,  1787,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1798,    -1,  2046,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1814,
      -1,  1916,  1917,    -1,  2936,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,  4165,    -1,    17,    18,    19,
    4170,    -1,  4172,    -1,   378,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3900,    -1,    44,  4195,    -1,    -1,    -1,   172,
      -1,    51,  1867,    -1,    -1,    -1,  1457,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3923,    -1,  1882,   191,    -1,
    1885,  1886,    -1,   196,    -1,    -1,    -1,    77,  3010,    -1,
      -1,    -1,  3014,    -1,  4234,    -1,    -1,  4237,    -1,    -1,
    3948,    -1,    -1,    -1,    -1,   218,   219,    -1,    -1,    -1,
      -1,  1916,  1917,    -1,    -1,    -1,  5340,    -1,    -1,    -1,
     233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5354,    -1,    -1,  1524,   478,    -1,    -1,    -1,    -1,    -1,
      -1,  2046,   486,   487,   488,   489,   490,   491,   492,   493,
     494,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   272,
    5384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,  1565,    -1,   289,   167,    -1,   208,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4327,  4328,    -1,
      -1,   220,    -1,  3115,    -1,    -1,    -1,  4337,    -1,    -1,
      -1,   191,   231,    -1,    -1,    -1,   196,  1598,  3130,    -1,
      -1,    -1,    -1,  3135,  4354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,
      -1,    -1,    -1,  4081,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2046,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,  5486,    -1,    13,   378,    -1,    -1,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   272,    -1,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44,   286,    -1,    -1,   289,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,  4448,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5542,    -1,
    5544,    -1,    -1,  4171,    -1,    -1,    -1,    -1,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4196,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,    -1,    -1,    -1,    -1,    -1,    -1,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1787,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1798,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1814,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5665,   191,    -1,    -1,    -1,    -1,   196,    -1,    -1,
      -1,    -1,  3374,    -1,  5678,  3377,    -1,  3379,    -1,    -1,
      -1,    -1,  3384,    -1,    -1,    -1,    -1,  5691,    -1,   218,
     219,    -1,    -1,    -1,    -1,    -1,  1867,    -1,    -1,    -1,
      -1,    -1,    -1,  4331,   233,    -1,    -1,    -1,   478,    -1,
      -1,  1882,    -1,    -1,  1885,  1886,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,  3431,
      -1,    -1,  4652,    -1,    -1,    -1,    -1,  3439,    -1,    -1,
      -1,    -1,    -1,   272,    -1,  1916,  1917,  5751,  5752,  4377,
      -1,    -1,    -1,    -1,  4382,    -1,    -1,   286,    -1,    -1,
     289,    -1,  3464,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4694,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4706,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2628,    -1,    -1,
      -1,  2632,  2633,  5807,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,  4735,    -1,    17,    18,    19,
      -1,   630,    -1,    -1,    -1,    -1,    -1,   636,    -1,    -1,
      -1,  3533,    -1,  3535,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,   378,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,  2689,    -1,
      10,    -1,    -1,    13,  2695,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,  2046,    -1,    77,    -1,    10,
      -1,    -1,    13,    -1,    34,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,  4813,    44,    -1,    -1,    -1,    -1,  4527,
      -1,    51,    -1,    34,    -1,  2736,    -1,    -1,    -1,    -1,
      -1,    -1,  4832,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    -1,    -1,  3626,    -1,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5941,    -1,    -1,
      -1,    -1,    -1,  2628,    -1,    -1,    77,  2632,  2633,   478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,  3668,   167,    -1,    -1,
      -1,    -1,    -1,    -1,  5978,    -1,    -1,    -1,    -1,  5983,
    5984,    -1,    -1,    -1,  5988,    -1,    -1,    -1,    -1,    -1,
      -1,   191,    -1,    -1,  3696,    -1,   196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2689,    -1,   815,    -1,    -1,  4929,
    2695,  4639,    -1,    -1,    -1,    -1,    -1,    -1,   218,   219,
      -1,    -1,    -1,    -1,    -1,   834,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,    -1,  2628,    -1,    -1,   196,  2632,  2633,  4677,
      -1,  2736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     191,    -1,    -1,  3765,    -1,   196,    -1,    -1,   218,   219,
      -1,  4699,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   233,    -1,  3787,   286,   218,   219,   289,
      -1,    -1,    -1,    -1,   903,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   233,    -1,  2689,  2936,    -1,  3809,    -1,  5029,
    2695,  5031,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,  4766,   289,
     949,   272,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2736,    -1,    -1,    -1,   286,    -1,  5077,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   378,  3010,
      -1,    -1,    -1,  3014,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3900,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3923,    -1,    -1,    -1,    -1,    -1,    -1,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3948,   378,    -1,    -1,
      -1,  2936,    -1,  1062,    -1,    -1,    -1,    -1,    -1,  4887,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   478,    -1,
      -1,  1090,  1091,  1092,  3115,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,    -1,    -1,    -1,  3130,
      -1,    -1,    -1,    -1,  3135,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3010,    -1,    -1,   478,  3014,
      -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,
     490,   491,   492,   493,   494,    -1,    -1,   478,    -1,    -1,
      -1,  2936,    -1,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4081,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5018,  1200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1221,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5340,  1230,    -1,    -1,    -1,  3010,    -1,    -1,    -1,  3014,
    3115,    -1,    -1,    -1,  5354,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3130,    -1,    -1,  5076,    -1,
    3135,    -1,    -1,    -1,    -1,    -1,    -1,  2628,    -1,    -1,
      -1,  2632,  2633,    -1,  5384,    -1,    -1,    -1,    -1,  4171,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4196,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2689,    -1,
      -1,    -1,    -1,    -1,  2695,    -1,    -1,    -1,    -1,    -1,
    3115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3374,    -1,  3130,  3377,    -1,  3379,    -1,
    3135,    -1,    -1,  3384,    -1,    -1,    -1,    -1,    -1,  1368,
      -1,    -1,    -1,    -1,    -1,  2736,  5486,    -1,  5196,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3431,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3439,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5542,    -1,  5544,    -1,    -1,    -1,    -1,  4331,
      -1,    -1,    -1,  3464,    -1,    -1,    -1,    -1,    -1,  1448,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4377,    -1,    -1,    -1,    -1,
    4382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3374,
      -1,    -1,  3377,    -1,  3379,  5323,    -1,    -1,    -1,  3384,
    5328,  5329,  3533,    -1,  3535,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1539,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5665,  3431,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3439,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1571,    -1,    -1,  2936,    -1,    -1,    -1,    -1,
      -1,  5691,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3464,
      -1,    -1,    -1,    -1,    -1,  1594,    -1,    -1,  1597,  3374,
      -1,    -1,  3377,    -1,  3379,  3626,    -1,    -1,    -1,  3384,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4527,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3668,    -1,  3010,
      -1,    -1,  1651,  3014,    -1,    -1,  3431,    -1,  3533,    -1,
    3535,    -1,    -1,    -1,  3439,    -1,  1665,    -1,    -1,    -1,
      -1,  5489,    -1,    -1,    -1,  3696,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,  3464,
      -1,    -1,    30,    -1,    32,    33,    -1,  5807,    -1,    -1,
      -1,    -1,    -1,   812,   813,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    72,    -1,    74,    75,    -1,    -1,
      -1,    -1,    -1,    81,  3765,    83,    -1,  4639,    -1,    -1,
      -1,  3626,    -1,    -1,  3115,    -1,    -1,    95,  3533,    97,
    3535,    -1,    -1,    -1,    -1,    -1,  3787,    -1,    -1,  3130,
      -1,    -1,    -1,    -1,  3135,  1774,   114,    -1,    -1,   117,
     889,    -1,    -1,    -1,    -1,  4677,  1785,    -1,  3809,    -1,
      -1,    -1,    -1,  3668,   132,    -1,   134,    -1,    -1,    -1,
     138,    -1,    -1,    -1,    -1,    -1,   144,  4699,    -1,    -1,
      -1,    -1,    -1,    -1,   152,    -1,   154,    -1,    -1,    -1,
      -1,  3696,    -1,   161,    -1,    -1,    -1,    -1,  1827,    -1,
      -1,  5941,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3626,    -1,  1852,    -1,    -1,    -1,   195,    -1,    -1,
    1859,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5978,    -1,
      -1,    -1,    -1,    -1,  4766,    -1,    -1,    -1,  5988,  3900,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3765,    -1,    -1,  3668,    -1,    -1,    -1,   235,   236,    -1,
    1009,  1010,  3923,   241,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3787,    -1,    -1,   253,    -1,    -1,    -1,    -1,
      -1,  3696,    -1,    -1,    -1,    -1,    -1,  3948,    -1,    -1,
      -1,    -1,  1931,   271,  3809,  1934,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1965,  1966,    -1,   307,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   315,    -1,    -1,
      -1,    -1,    -1,  1982,    -1,    -1,    -1,    -1,    -1,    27,
    3765,   329,    -1,    -1,    -1,  4887,    -1,   335,   336,    -1,
     338,    -1,    -1,    -1,    -1,   343,    -1,    -1,   346,    -1,
      -1,   349,  3787,  3374,   352,    -1,  3377,    -1,  3379,    -1,
      -1,   359,    -1,  3384,    -1,  3900,    -1,   365,   366,    -1,
      -1,    -1,    -1,    -1,  3809,   373,    -1,    -1,    -1,   377,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3923,   387,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    -1,    -1,
    4081,    -1,    -1,    -1,   402,    -1,    -1,    -1,    -1,    -1,
    3431,    -1,    -1,  3948,   112,    -1,    -1,    -1,  3439,    -1,
     118,    -1,    -1,    -1,   422,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   433,    -1,    -1,   136,    -1,
      -1,   439,    -1,  3464,    -1,    -1,   444,    -1,    -1,   147,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,   457,
      -1,    -1,    -1,    -1,    -1,  3900,  5018,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,    -1,   174,    -1,  1247,    -1,
      -1,    -1,   480,   181,    -1,    -1,    -1,    -1,  3923,    -1,
    4171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     498,    -1,   200,   501,    -1,    -1,    -1,    -1,    -1,  1278,
      -1,    -1,  3533,  3948,  3535,  4196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5076,    -1,    -1,   225,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1306,  1307,  1308,
      -1,  1310,    -1,    -1,    -1,    -1,  4081,    -1,   246,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   286,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3626,    -1,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   320,   321,    -1,    -1,   324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4171,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5196,    -1,  4081,  3668,    -1,    -1,
    4331,    -1,    -1,   351,    -1,    -1,   354,    -1,    -1,    -1,
     358,  4196,   360,  1432,    -1,    -1,    -1,  1436,  1437,   367,
      -1,    -1,   370,    -1,    -1,  3696,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   389,    -1,    -1,    -1,    -1,  4377,    -1,   396,    -1,
      -1,  4382,    -1,   401,   402,    -1,    -1,   405,    -1,    -1,
      -1,   409,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      -1,   419,    -1,    -1,    -1,    -1,   424,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4171,    40,    -1,   437,
      -1,    -1,    -1,    -1,  3765,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4196,    65,  1322,    -1,    -1,  3787,    -1,    -1,    -1,
      -1,  5323,    -1,    -1,    -1,    78,  5328,  5329,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3809,    -1,
      -1,    94,    -1,    -1,    -1,    -1,  4331,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,
      -1,    -1,    -1,    -1,    -1,   118,    -1,  1376,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2490,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2500,  4377,    -1,   147,    -1,  4527,  4382,    -1,    -1,
      -1,    -1,    -1,   156,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
    2529,    -1,    -1,    -1,   177,    -1,    -1,    -1,   181,  3900,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5440,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4331,   200,    -1,    -1,
      -1,    -1,  3923,    -1,    -1,    -1,    -1,  1676,  1677,  1678,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2576,  2577,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3948,    -1,    -1,
      -1,    -1,    -1,    -1,   237,    -1,    -1,  5489,    -1,    -1,
      -1,    -1,  4377,   246,    -1,    -1,    -1,  4382,    -1,    -1,
      -1,  2610,    -1,    -1,    -1,    -1,    -1,    -1,  4639,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,    -1,    -1,   289,    -1,    -1,    -1,
      -1,    -1,  4527,    -1,    -1,    -1,  4677,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4699,    -1,
      -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,   331,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   351,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   360,    -1,    -1,
    4081,    -1,    -1,    -1,   367,    -1,    -1,   370,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2740,    -1,    -1,    -1,  4766,   389,    -1,    -1,    -1,
      -1,    -1,  4527,   396,    -1,    -1,  2755,    -1,    -1,   402,
      -1,    -1,   405,   406,  4639,   408,   409,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2776,    -1,    -1,
      -1,   424,    -1,  1682,    -1,    -1,    -1,  1686,   431,    -1,
      -1,   434,    -1,    -1,   437,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4677,    -1,    -1,    -1,    -1,   450,    -1,    -1,
    4171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4699,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2854,  2855,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4639,    -1,  4887,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4766,    -1,    -1,  2003,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4677,    -1,    -1,    -1,  2015,    -1,  2017,    -1,
    2019,    -1,    -1,  2022,  2023,  2024,    -1,    -1,    -1,    -1,
    2029,    -1,    -1,  2032,  4699,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2047,  2048,
    2049,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2064,  2955,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4766,    -1,    -1,    -1,    -1,    -1,  5018,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4887,    -1,    -1,    -1,  4377,    -1,    -1,    -1,
      -1,  4382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5076,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2207,    -1,
      -1,    -1,  2001,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4887,    -1,    -1,    -1,    -1,  2016,    -1,    -1,
      -1,  2020,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2034,  2035,  2036,  2247,  2038,
      -1,    -1,    -1,  5018,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4527,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2298,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5076,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5018,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3267,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4639,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3288,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5076,  5323,    -1,    -1,    -1,    -1,  5328,  5329,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4677,    -1,    -1,    -1,
      -1,  5196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4699,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2472,  2473,  2474,  2475,  2476,  2477,  2478,
    2479,  2480,    -1,  2482,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2491,    -1,  2493,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4766,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5440,
      -1,  5196,  2531,    -1,    -1,    -1,  2535,    -1,    -1,  2538,
      -1,  2540,    -1,    -1,  2543,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5323,    -1,
      -1,    -1,    -1,  5328,  5329,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5489,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2596,  2597,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4887,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3541,    -1,    -1,    -1,    -1,    -1,  5323,    -1,
      -1,    -1,    -1,  5328,  5329,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5440,    -1,  2676,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2489,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5489,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5018,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5440,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2583,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2595,    -1,    -1,    -1,
      -1,  2600,    -1,    -1,    -1,    -1,    -1,    -1,  3707,  3708,
    3709,    -1,    -1,    -1,  5489,  5076,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3724,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3758,
    3759,    -1,    -1,    -1,  3763,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2902,  2903,  2904,    -1,    -1,    -1,  2908,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2935,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5196,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3875,    -1,    -1,  3878,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5323,    -1,    -1,    -1,    -1,  5328,  5329,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4006,  4007,  4008,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3143,    -1,    -1,    -1,    -1,  3148,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3176,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3187,  5440,
    3189,  3190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3200,    -1,    -1,  3203,    -1,  3205,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5489,    -1,
    3239,    -1,  3241,    -1,  3243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3331,    -1,    -1,    -1,    -1,  3336,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3351,    -1,    -1,    -1,    -1,  3146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3166,  3167,    -1,
    3169,    -1,    -1,    -1,    -1,  3174,  3175,    -1,  3177,    -1,
    3179,    -1,    -1,    -1,  3183,    -1,    -1,  3186,    -1,    -1,
      -1,    -1,  3191,    -1,    -1,  3404,    -1,    -1,  3197,    -1,
      -1,    -1,    -1,  3202,    -1,    -1,    -1,    -1,    -1,  4308,
    3209,  3210,  3211,  3212,    -1,    -1,    -1,  3216,  3217,    -1,
    3219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3236,    -1,  3238,
    4339,    -1,    -1,    -1,    -1,    -1,  3245,  3246,  3247,  3248,
    3249,  3250,  3251,  3252,  3253,  3254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4406,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4423,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3653,    -1,    -1,    -1,    -1,    -1,
    3659,    -1,    -1,    -1,    -1,    -1,  4555,  4556,  4557,  4558,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3739,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3657,  3658,
      -1,    -1,    -1,  3662,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3897,    -1,
      -1,    -1,  3691,    -1,    -1,    -1,    -1,  3906,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3914,    -1,  3916,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3943,  3944,  3945,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3961,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3969,    -1,    -1,  3972,    -1,  3974,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3984,    -1,    -1,    -1,    -1,
      -1,  4880,    -1,  3992,  3993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4891,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4074,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3896,    -1,    -1,
      -1,    -1,    -1,  3902,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3920,  3921,    -1,    -1,  3924,  3925,  3926,  3927,    -1,
      -1,  3930,  3931,  3932,  3933,  3934,  3935,  3936,  3937,  3938,
    3939,  3940,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3962,    -1,    -1,  3965,    -1,  3967,    -1,
      -1,  3970,  3971,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3986,  3987,  3988,
    3989,    -1,  3991,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5149,    -1,    -1,    -1,    -1,  5154,    -1,  4056,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5173,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4090,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4383,  4384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4394,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5307,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4437,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4474,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4485,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4301,    -1,    -1,    -1,    -1,  5406,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4524,  4525,    -1,    -1,    -1,
      -1,    -1,  4531,  4532,    -1,    -1,    -1,  4536,    -1,    -1,
      -1,  4540,    -1,    -1,  4543,  4544,  5435,    -1,    -1,  4548,
      -1,    -1,    -1,    -1,  4343,  4554,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4594,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4605,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4621,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4475,    -1,    -1,    -1,
    4479,    -1,  4481,  4482,    -1,    -1,    -1,    -1,  4487,  4488,
    4489,  4490,    -1,    -1,    -1,  4494,  4495,  4496,  4497,  4498,
    4499,  4500,  4501,  4502,  4503,  4504,  4505,  4506,    -1,    -1,
      -1,    -1,    -1,  4722,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4530,    -1,    -1,  4533,    -1,  4535,    -1,    -1,  4538,
      -1,    -1,  4541,  4542,    -1,    -1,  4545,  4546,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4792,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4604,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4947,    -1,
      -1,    -1,    -1,    -1,  4953,  4954,  4955,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4978,
    4979,    -1,    -1,  4982,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4795,    -1,    -1,  5008,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5019,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4882,  4883,    -1,    -1,    -1,    -1,    -1,
      -1,  4890,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4915,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4943,    -1,    -1,    -1,    -1,    -1,
    4949,  4950,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4968,
      -1,  4970,    -1,    -1,    -1,  4974,  4975,  4976,  4977,    -1,
      -1,  4980,  4981,    -1,    -1,    -1,  4985,    -1,    -1,    -1,
    4989,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5002,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5224,    -1,    -1,    -1,    -1,
      -1,  5020,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5239,    -1,    -1,    -1,  5033,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5282,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5098,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5333,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5134,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5374,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5232,    -1,  5234,  5235,  5236,  5237,  5238,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5249,  5250,  5251,    -1,    -1,    -1,    -1,    -1,    -1,  5468,
      -1,    -1,    -1,    -1,    -1,  5264,    -1,    -1,  5267,    -1,
      -1,    -1,  5271,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5498,
    5289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5517,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5641,  5642,  5643,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5465,    -1,    -1,    -1,
    5469,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5483,    -1,  5485,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5732,    -1,    -1,    -1,    -1,    -1,  5528,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5757,    -1,
      -1,    -1,    -1,  5762,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5564,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5636,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5873,    -1,    -1,  5876,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5676,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5913,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5969,    -1,    -1,    -1,    -1,    -1,  5765,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5778,
    5779,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5827,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5851,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5868,
    5869,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,  5923,  5924,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
     133,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,
      -1,    -1,    -1,    -1,    -1,   498,   499,     3,    -1,     5,
       6,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,    -1,   480,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   489,   490,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   498,   499,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   498,
     499,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   498,   499,     3,    -1,
       5,     6,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,   489,   490,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   498,   499,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    37,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   499,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    -1,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,    -1,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,    -1,    -1,   268,    -1,   270,   271,   272,   273,    -1,
      -1,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,    -1,   312,    -1,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,    -1,   419,    -1,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     475,   476,   477,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,   499,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,    -1,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,    -1,   268,    -1,   270,   271,   272,   273,
      -1,    -1,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,    -1,   312,    -1,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,    -1,   419,    -1,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
      -1,   475,   476,   477,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,   499,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,    -1,   480,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,    -1,
      -1,     3,    -1,     5,     6,   498,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
     172,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,   228,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,
      -1,    -1,     3,    -1,     5,     6,   498,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    35,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
      -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    35,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,    -1,    -1,    -1,   496,   497,   498,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,   491,    -1,
      -1,     3,    -1,     5,     6,   498,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,
      -1,    -1,     3,    -1,     5,     6,   498,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
      -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,   172,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,    -1,    -1,    -1,     3,    -1,     5,     6,
     498,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,   232,   233,    -1,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   489,   490,    -1,    -1,    -1,     3,    -1,     5,
       6,   498,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      36,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   489,   490,    -1,    -1,    -1,     3,    -1,
       5,     6,   498,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   489,   490,    -1,    -1,    -1,     3,
      -1,     5,     6,   498,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   489,   490,    -1,    -1,    -1,
       3,    -1,     5,     6,   498,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,    -1,
      -1,     3,    -1,     5,     6,   498,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,    -1,
      -1,    -1,     3,    -1,     5,     6,   498,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,   490,
      -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,   434,   435,   436,   437,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,    -1,    -1,    -1,     3,    -1,     5,     6,   498,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
      -1,    -1,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,    -1,   273,   274,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   489,   490,    -1,    -1,    -1,     3,    -1,     5,     6,
     498,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,   232,   233,    -1,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   489,   490,     3,    -1,     5,     6,    -1,     8,
       9,   498,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     489,   490,     3,    -1,     5,     6,    -1,     8,     9,   498,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,    -1,    -1,    -1,
      -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,   498,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,   437,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,    -1,    -1,    -1,
       3,    -1,     5,     6,    -1,     8,     9,    -1,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,   498,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    36,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,   231,   232,
     233,    -1,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,   437,    -1,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   498,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,    -1,   229,   230,   231,   232,   233,
      -1,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
      -1,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,   285,   286,   287,   288,    -1,    -1,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,   437,    -1,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,    -1,   480,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   498,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,    -1,   229,   230,   231,   232,   233,    -1,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
     285,   286,   287,   288,    -1,    -1,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,   437,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   498,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   498,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,   231,   232,   233,    -1,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,    -1,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
     437,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,   448,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   498,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,   180,    -1,   182,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,   207,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,   230,   231,   232,   233,    -1,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,    -1,   275,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
     418,   419,   420,    -1,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,   437,
      -1,   439,   440,   441,   442,   443,   444,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     498,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,   231,   232,   233,    -1,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,   272,   273,    -1,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,   437,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,    -1,
      -1,    -1,    -1,     3,    -1,     5,     6,    -1,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   498,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,   284,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,    -1,    -1,
      -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,   489,
     490,   491,    -1,    -1,    -1,    -1,    -1,    -1,   498,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,    -1,    -1,   480,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   498,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,    -1,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,    -1,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,    -1,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   498,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    -1,    -1,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    -1,    99,   100,   101,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,    -1,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,    -1,   232,
      -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,    -1,
     273,    -1,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,    -1,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,    -1,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,   402,
     403,    -1,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,    -1,   449,   450,   451,   452,
      -1,    -1,   455,    -1,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,    -1,    -1,   480,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   498,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    -1,    -1,    -1,    80,    81,    82,    83,
      84,    85,    -1,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,   179,   180,    -1,   182,   183,
     184,    -1,   186,   187,   188,   189,   190,    -1,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,
     224,   225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,    -1,   273,
      -1,   275,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,   293,
      -1,   295,    -1,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,    -1,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,    -1,   400,   401,    -1,   403,
      -1,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,   418,   419,   420,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,   441,   442,   443,
     444,   445,    -1,   447,    -1,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   498,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   498,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   498,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    -1,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    -1,    -1,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,    -1,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,
     237,    -1,    -1,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,    -1,   273,    -1,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,    -1,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,    -1,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
      -1,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,    -1,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
       5,     6,    -1,    -1,    -1,    10,    11,    -1,    -1,    -1,
      -1,   498,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,    -1,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,    -1,   268,   269,   270,   271,   272,   273,   274,
      -1,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,   308,   309,   310,    -1,   312,    -1,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,    -1,   419,    -1,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     475,   476,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       3,    -1,     5,     6,    -1,    -1,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,    -1,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,    -1,   268,   269,   270,   271,   272,
     273,   274,    -1,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,   308,   309,   310,    -1,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,    -1,   419,    -1,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   475,   476,   477,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    -1,    -1,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,    -1,   163,   164,   165,   166,    -1,   168,   169,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,    -1,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,    -1,   250,
     251,    -1,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,    -1,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,    -1,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,    -1,   448,   449,   450,
     451,   452,   453,    -1,   455,    -1,    -1,    -1,    -1,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,    -1,   476,   477,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    -1,
      99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,    -1,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,    -1,
      -1,   220,    -1,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,    -1,   273,    -1,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,    -1,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,    -1,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,    -1,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,    -1,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    -1,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    -1,    -1,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,    -1,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,
     237,    -1,    -1,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,    -1,   273,    -1,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,    -1,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,    -1,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
      -1,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,    -1,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    76,    -1,    -1,    -1,    80,    81,    82,    83,    84,
      85,    -1,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,   179,   180,    -1,   182,   183,   184,
      -1,   186,   187,   188,   189,   190,    -1,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,
     225,   226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,    -1,   273,    -1,
     275,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,   293,    -1,
     295,    -1,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,    -1,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,    -1,   400,   401,    -1,   403,    -1,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,   418,   419,   420,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,   444,
     445,    -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   486,   487,   488,   489,   490,   491,   492,   493,   494,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    76,    -1,    -1,    -1,    80,    81,    82,
      83,    84,    85,    -1,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    -1,    99,   100,   101,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,   179,   180,    -1,   182,
     183,   184,    -1,   186,   187,   188,   189,   190,    -1,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,    -1,   207,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,   222,
     223,   224,   225,   226,    -1,    -1,   229,   230,    -1,   232,
      -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,    -1,
     273,    -1,   275,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
     293,    -1,   295,    -1,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,    -1,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,    -1,   400,   401,    -1,
     403,    -1,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,   418,   419,   420,    -1,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,   441,   442,
     443,   444,   445,    -1,   447,    -1,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   486,   487,   488,   489,   490,   491,   492,
     493,   494,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   486,   487,   488,   489,   490,
     491,   492,   493,   494,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    -1,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    76,    -1,    -1,
      -1,    80,    81,    82,    83,    84,    85,    -1,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    -1,
      99,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
     179,   180,    -1,   182,   183,   184,    -1,   186,   187,   188,
     189,   190,    -1,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,    -1,   207,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,    -1,
      -1,   220,    -1,   222,   223,   224,   225,   226,    -1,    -1,
     229,   230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,    -1,   273,    -1,   275,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,   293,    -1,   295,    -1,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,    -1,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
      -1,   400,   401,    -1,   403,    -1,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,
     439,   440,   441,   442,   443,   444,   445,    -1,   447,    -1,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,   487,   488,
     489,   490,   491,   492,   493,   494,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    -1,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    -1,    -1,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,    -1,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,
     237,    -1,    -1,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,    -1,   273,    -1,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,    -1,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,    -1,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
      -1,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,    -1,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   486,
     487,   488,   489,   490,   491,   492,   493,   494,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   491,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    -1,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    -1,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      -1,    -1,    -1,    80,    81,    82,    83,    84,    85,    -1,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,   179,   180,    -1,   182,   183,   184,    -1,   186,
     187,   188,   189,   190,    -1,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,    -1,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,    -1,    -1,   220,    -1,   222,   223,   224,   225,   226,
      -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,   236,
     237,    -1,    -1,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,    -1,   273,    -1,   275,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,   293,    -1,   295,    -1,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,    -1,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,    -1,   400,   401,    -1,   403,    -1,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,   418,   419,   420,    -1,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
      -1,    -1,   439,   440,   441,   442,   443,   444,   445,    -1,
     447,    -1,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   491,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    76,    -1,    -1,    -1,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    -1,    99,   100,   101,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,    -1,   160,    -1,
     162,   163,   164,   165,   166,    -1,   168,    -1,   170,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,   179,   180,    -1,
     182,   183,   184,    -1,   186,   187,   188,   189,   190,    -1,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,    -1,
     222,   223,   224,   225,   226,    -1,    -1,   229,   230,    -1,
     232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
      -1,   273,    -1,   275,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,   293,    -1,   295,    -1,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,    -1,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,    -1,   400,   401,
      -1,   403,    -1,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,   418,   419,   420,    -1,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,    -1,    -1,   439,   440,   441,
     442,   443,   444,   445,    -1,   447,    -1,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   491,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    -1,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    -1,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,
      -1,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,    -1,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
     207,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,   236,
     237,    -1,    -1,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,    -1,
      -1,   268,    -1,   270,   271,   272,   273,    -1,    -1,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,    -1,   312,    -1,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,    -1,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,    -1,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,    -1,   419,    -1,    -1,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
      -1,    -1,   439,   440,   441,   442,   443,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,   476,
     477,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,   491,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,    -1,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,    -1,    -1,   268,    -1,   270,   271,   272,   273,
      -1,    -1,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,    -1,   312,    -1,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,    -1,   419,    -1,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,   441,   442,   443,
      -1,   445,   446,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
      -1,    -1,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,   475,   476,   477,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,   491,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,   489,   490,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,     5,     6,    -1,    -1,    -1,    -1,
      11,    -1,    -1,   489,   490,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,   489,   490,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,   284,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    -1,    -1,   489,   490,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,   172,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,   489,   490,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,     5,
       6,    -1,     8,     9,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,   104,   105,
      -1,    -1,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,   104,   105,
      -1,    -1,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,   181,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,   284,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,   104,   105,
      -1,    -1,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,   104,   105,
      -1,    -1,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,   104,   105,    -1,    -1,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,   104,   105,
      -1,    -1,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    32,    33,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
       6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    -1,    79,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,   169,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,   178,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,   178,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,   169,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,   402,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,   285,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,   437,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,   437,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,   285,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,   285,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,   402,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
       6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    37,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    37,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    37,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,    -1,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    -1,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    -1,    99,   100,
     101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,   180,
      -1,   182,   183,   184,    -1,   186,   187,   188,   189,   190,
      -1,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,   220,
      -1,   222,   223,   224,   225,   226,    -1,    -1,   229,   230,
      -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,    -1,   273,    -1,   275,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,    -1,   295,    -1,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,    -1,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,    -1,   400,
     401,    -1,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,   418,   419,   420,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,   444,   445,    -1,   447,    -1,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    68,    69,    70,    -1,    72,    73,    74,    75,
      76,    -1,    -1,    -1,    80,    81,    82,    83,    84,    85,
      -1,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    -1,    99,   100,   101,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
     166,    -1,   168,    -1,   170,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,   179,   180,    -1,   182,   183,   184,    -1,
     186,   187,   188,   189,   190,    -1,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,    -1,   215,
      -1,   217,    -1,    -1,   220,    -1,   222,   223,   224,   225,
     226,    -1,    -1,   229,   230,    -1,   232,    -1,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,    -1,   273,    -1,   275,
     276,   277,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,   293,    -1,   295,
      -1,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,   375,
     376,   377,    -1,   379,   380,   381,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,    -1,   400,   401,    -1,   403,    -1,   405,
     406,   407,   408,   409,    -1,   411,   412,   413,    -1,    -1,
     416,   417,   418,   419,   420,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,   444,   445,
      -1,   447,    -1,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,    -1,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,    -1,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,    -1,    -1,   268,    -1,   270,
     271,   272,   273,    -1,    -1,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
      -1,   312,    -1,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,    -1,   419,    -1,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   475,   476,   477,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      80,    81,    82,    83,    84,    85,    -1,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    -1,    99,
     100,   101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,    -1,    -1,    -1,   174,   175,   176,   177,    -1,   179,
     180,    -1,   182,    -1,   184,    -1,   186,   187,   188,   189,
     190,    -1,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,    -1,    -1,
     220,    -1,   222,   223,   224,   225,   226,    -1,    -1,   229,
     230,    -1,   232,    -1,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,    -1,   273,    -1,   275,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,   293,    -1,   295,    -1,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,    -1,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,    -1,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,    -1,
     400,   401,    -1,   403,    -1,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,   418,   419,
     420,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,   444,   445,    -1,   447,    -1,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      55,    -1,    57,    58,    59,    60,    61,    62,    63,    -1,
      -1,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
      75,    -1,    -1,    78,    -1,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    91,    92,    93,    94,
      95,    96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,
     105,    -1,    -1,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,    -1,   129,   130,   131,   132,    -1,    -1,
     135,   136,   137,   138,   139,    -1,   141,   142,   143,    -1,
     145,   146,   147,    -1,   149,   150,   151,   152,    -1,   154,
     155,   156,   157,    -1,    -1,   160,    -1,   162,   163,   164,
     165,   166,    -1,   168,    -1,   170,   171,    -1,   173,   174,
     175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,
      -1,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
     205,   206,    -1,   208,   209,   210,   211,   212,   213,    -1,
     215,    -1,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,
     235,   236,   237,    -1,    -1,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,    -1,    -1,   268,    -1,   270,   271,   272,   273,   274,
      -1,   276,   277,   278,   279,   280,    -1,   282,   283,    -1,
      -1,   286,   287,   288,    -1,    -1,   291,   292,    -1,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    -1,    -1,   309,   310,    -1,   312,    -1,   314,
     315,   316,    -1,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,   357,   358,   359,   360,   361,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,    -1,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,    -1,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,   398,    -1,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,    -1,   411,   412,   413,    -1,
      -1,   416,   417,    -1,   419,    -1,    -1,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,    -1,   432,   433,   434,
     435,   436,    -1,    -1,   439,   440,   441,   442,   443,    -1,
     445,    -1,   447,   448,   449,   450,   451,   452,    -1,    -1,
     455,    -1,    -1,   458,   459,   460,   461,   462,   463,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     475,   476,   477,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    -1,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,    43,
      44,    45,    46,    47,    48,    49,    50,    -1,    52,    53,
      54,    55,    -1,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    -1,    -1,    78,    -1,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    91,    92,    93,
      94,    95,    96,    -1,    98,    99,   100,   101,    -1,    -1,
      -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,    -1,   121,   122,   123,
     124,   125,   126,   127,    -1,   129,   130,   131,   132,    -1,
      -1,   135,   136,   137,   138,   139,    -1,   141,   142,   143,
      -1,   145,   146,   147,    -1,   149,   150,   151,   152,    -1,
     154,   155,   156,   157,    -1,    -1,   160,    -1,   162,   163,
     164,   165,   166,    -1,   168,    -1,   170,   171,    -1,   173,
     174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,   183,
     184,    -1,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,   205,   206,    -1,   208,   209,   210,   211,   212,   213,
      -1,   215,    -1,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,    -1,    -1,   229,    -1,   231,   232,   233,
      -1,   235,   236,   237,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
      -1,    -1,   276,   277,   278,   279,   280,    -1,   282,   283,
      -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,    -1,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
     304,   305,   306,    -1,    -1,   309,   310,    -1,   312,    -1,
     314,   315,   316,    -1,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,    -1,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,    -1,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,    -1,   398,    -1,   400,   401,    -1,   403,
     404,   405,   406,   407,   408,   409,    -1,   411,   412,   413,
      -1,    -1,   416,   417,    -1,   419,    -1,    -1,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,    -1,   432,   433,
     434,   435,   436,    -1,    -1,   439,   440,   441,   442,   443,
      -1,   445,    -1,   447,   448,   449,   450,   451,   452,    -1,
      -1,   455,    -1,    -1,   458,   459,   460,   461,   462,   463,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   475,   476,   477,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    -1,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    -1,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    55,    -1,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    66,    67,    68,    69,    70,    -1,    72,
      73,    74,    75,    -1,    -1,    78,    -1,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,    -1,
      -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,    -1,   129,   130,   131,   132,
      -1,    -1,   135,   136,   137,   138,   139,    -1,   141,   142,
     143,    -1,   145,   146,   147,    -1,   149,   150,   151,   152,
      -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,   162,
     163,   164,   165,   166,    -1,   168,    -1,   170,   171,    -1,
     173,   174,   175,   176,   177,    -1,   179,    -1,    -1,    -1,
     183,   184,    -1,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,   205,   206,    -1,   208,   209,   210,   211,   212,
     213,    -1,   215,    -1,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,    -1,    -1,   229,    -1,   231,   232,
     233,    -1,   235,   236,   237,    -1,    -1,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,    -1,   268,    -1,   270,   271,   272,
     273,    -1,    -1,   276,   277,   278,   279,   280,    -1,   282,
     283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,   292,
      -1,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,   304,   305,   306,    -1,    -1,   309,   310,    -1,   312,
      -1,   314,   315,   316,    -1,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,   357,   358,   359,   360,   361,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,    -1,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
      -1,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,    -1,   398,    -1,   400,   401,    -1,
     403,   404,   405,   406,   407,   408,   409,    -1,   411,   412,
     413,    -1,    -1,   416,   417,    -1,   419,    -1,    -1,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,    -1,   432,
     433,   434,   435,   436,    -1,    -1,   439,   440,   441,   442,
     443,    -1,   445,    -1,   447,   448,   449,   450,   451,   452,
      -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,   462,
     463,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   475,   476,   477,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    -1,    29,    30,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,
      -1,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    53,    54,    55,    -1,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    66,    67,    68,    69,    70,    -1,
      72,    73,    74,    75,    -1,    -1,    78,    -1,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,    -1,   129,   130,   131,
     132,    -1,    -1,   135,   136,   137,   138,   139,    -1,   141,
     142,   143,    -1,   145,   146,   147,    -1,   149,   150,   151,
     152,    -1,   154,   155,   156,   157,    -1,    -1,   160,    -1,
     162,   163,   164,   165,   166,   167,   168,    -1,   170,   171,
      -1,   173,   174,   175,   176,   177,    -1,   179,    -1,    -1,
      -1,   183,   184,    -1,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,   205,   206,    -1,   208,   209,   210,   211,
     212,   213,    -1,   215,    -1,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,    -1,    -1,   229,    -1,   231,
     232,   233,    -1,   235,   236,   237,    -1,    -1,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,    -1,    -1,   268,    -1,   270,   271,
     272,   273,    -1,    -1,   276,   277,   278,   279,   280,    -1,
     282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,   291,
     292,    -1,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,   304,   305,   306,    -1,    -1,   309,   310,    -1,
     312,    -1,   314,   315,   316,    -1,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,   350,   351,
     352,   353,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
      -1,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,    -1,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,    -1,   398,    -1,   400,   401,
      -1,   403,   404,   405,   406,   407,   408,   409,    -1,   411,
     412,   413,    -1,    -1,   416,   417,    -1,   419,    -1,    -1,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,    -1,
     432,   433,   434,   435,   436,    -1,    -1,   439,   440,   441,
     442,   443,    -1,   445,    -1,   447,   448,   449,   450,   451,
     452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,   461,
     462,   463,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   475,   476,   477,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    -1,    29,    30,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    -1,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    55,    -1,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    66,    67,    68,    69,    70,
      -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,    -1,
     121,   122,   123,   124,   125,   126,   127,    -1,   129,   130,
     131,   132,    -1,    -1,   135,   136,   137,   138,   139,    -1,
     141,   142,   143,    -1,   145,   146,   147,    -1,   149,   150,
     151,   152,    -1,   154,   155,   156,   157,    -1,    -1,   160,
      -1,   162,   163,   164,   165,   166,    -1,   168,    -1,   170,
     171,    -1,   173,   174,   175,   176,   177,    -1,   179,    -1,
      -1,    -1,   183,   184,    -1,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,   205,   206,    -1,   208,   209,   210,
     211,   212,   213,    -1,   215,    -1,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,    -1,    -1,   229,    -1,
     231,   232,   233,    -1,   235,   236,   237,    -1,    -1,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,    -1,    -1,   268,    -1,   270,
     271,   272,   273,    -1,    -1,   276,   277,   278,   279,   280,
      -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,    -1,
     291,   292,    -1,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,   304,   305,   306,    -1,    -1,   309,   310,
      -1,   312,    -1,   314,   315,   316,    -1,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,    -1,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,    -1,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,   398,    -1,   400,
     401,    -1,   403,   404,   405,   406,   407,   408,   409,    -1,
     411,   412,   413,    -1,    -1,   416,   417,    -1,   419,    -1,
      -1,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
      -1,   432,   433,   434,   435,   436,    -1,    -1,   439,   440,
     441,   442,   443,    -1,   445,    -1,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,   460,
     461,   462,   463,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   475,   476,   477,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    -1,    29,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,
      40,    41,    -1,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    52,    53,    54,    55,    -1,    57,    58,    59,
      60,    61,    62,    63,    -1,    -1,    66,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    -1,    78,    -1,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    -1,    98,    99,
     100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,    -1,   129,
     130,   131,   132,    -1,    -1,   135,   136,   137,   138,   139,
      -1,   141,   142,   143,    -1,   145,   146,   147,    -1,   149,
     150,   151,   152,    -1,   154,   155,   156,   157,    -1,    -1,
     160,    -1,   162,   163,   164,   165,   166,    -1,   168,    -1,
     170,   171,    -1,   173,   174,   175,   176,   177,    -1,   179,
      -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,   205,   206,    -1,   208,   209,
     210,   211,   212,   213,    -1,   215,    -1,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,    -1,    -1,   229,
      -1,   231,   232,   233,    -1,   235,   236,   237,    -1,    -1,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,    -1,    -1,   268,    -1,
     270,   271,   272,   273,    -1,    -1,   276,   277,   278,   279,
     280,    -1,   282,   283,    -1,    -1,   286,   287,   288,    -1,
      -1,   291,   292,    -1,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,    -1,    -1,   309,
     310,    -1,   312,    -1,   314,   315,   316,    -1,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,    -1,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    -1,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,   398,    -1,
     400,   401,    -1,   403,   404,   405,   406,   407,   408,   409,
      -1,   411,   412,   413,    -1,    -1,   416,   417,    -1,   419,
      -1,    -1,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,   439,
     440,   441,   442,   443,    -1,   445,    -1,   447,   448,   449,
     450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,   459,
     460,   461,   462,   463,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   476,   477,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    -1,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    -1,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    55,    -1,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    66,    67,    68,
      69,    70,    -1,    72,    73,    74,    75,    -1,    -1,    78,
      -1,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    91,    92,    93,    94,    95,    96,    -1,    98,
      99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,    -1,
     129,   130,   131,   132,    -1,    -1,   135,   136,   137,   138,
     139,    -1,   141,   142,   143,    -1,   145,   146,   147,    -1,
     149,   150,   151,   152,    -1,   154,   155,   156,   157,    -1,
      -1,   160,    -1,   162,   163,   164,   165,   166,    -1,   168,
      -1,   170,   171,    -1,   173,   174,   175,   176,   177,    -1,
     179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,   205,   206,    -1,   208,
     209,   210,   211,   212,   213,    -1,   215,    -1,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,    -1,    -1,
     229,    -1,   231,   232,   233,    -1,   235,   236,   237,    -1,
      -1,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,    -1,    -1,   268,
      -1,   270,   271,   272,   273,    -1,    -1,   276,   277,   278,
     279,   280,    -1,   282,   283,    -1,    -1,   286,   287,   288,
      -1,    -1,   291,   292,    -1,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,   304,   305,   306,    -1,    -1,
     309,   310,    -1,   312,    -1,   314,   315,   316,    -1,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,    -1,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,    -1,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,    -1,   398,
      -1,   400,   401,    -1,   403,   404,   405,   406,   407,   408,
     409,    -1,   411,   412,   413,    -1,    -1,   416,   417,    -1,
     419,    -1,    -1,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,    -1,   432,   433,   434,   435,   436,    -1,    -1,
     439,   440,   441,   442,   443,    -1,   445,    -1,   447,   448,
     449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,   458,
     459,   460,   461,   462,   463,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   475,   476,   477,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    39,    40,    41,    -1,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    52,    53,    54,    55,    -1,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    -1,    -1,
      78,    -1,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    91,    92,    93,    94,    95,    96,    -1,
      98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,    -1,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,    -1,   121,   122,   123,   124,   125,   126,   127,
      -1,   129,   130,   131,   132,    -1,    -1,   135,   136,   137,
     138,   139,    -1,   141,   142,   143,    -1,   145,   146,   147,
      -1,   149,   150,   151,   152,    -1,   154,   155,   156,   157,
      -1,    -1,   160,    -1,   162,   163,   164,   165,   166,    -1,
     168,    -1,   170,   171,    -1,   173,   174,   175,   176,   177,
      -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,   205,   206,    -1,
     208,   209,   210,   211,   212,   213,    -1,   215,    -1,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,    -1,
      -1,   229,    -1,   231,   232,   233,    -1,   235,   236,   237,
      -1,    -1,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,    -1,    -1,
     268,    -1,   270,   271,   272,   273,    -1,    -1,   276,   277,
     278,   279,   280,    -1,   282,   283,    -1,    -1,   286,   287,
     288,    -1,    -1,   291,   292,    -1,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,   304,   305,   306,    -1,
      -1,   309,   310,    -1,   312,    -1,   314,   315,   316,    -1,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,    -1,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,    -1,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,    -1,
     398,    -1,   400,   401,    -1,   403,   404,   405,   406,   407,
     408,   409,    -1,   411,   412,   413,    -1,    -1,   416,   417,
      -1,   419,    -1,    -1,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,    -1,   432,   433,   434,   435,   436,    -1,
      -1,   439,   440,   441,   442,   443,    -1,   445,    -1,   447,
     448,   449,   450,   451,   452,    -1,    -1,   455,    -1,    -1,
     458,   459,   460,   461,   462,   463,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,   476,   477,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    41,    -1,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    55,    -1,
      57,    58,    59,    60,    61,    62,    63,    -1,    -1,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    -1,
      -1,    78,    -1,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    91,    92,    93,    94,    95,    96,
      -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,    -1,
      -1,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,    -1,   121,   122,   123,   124,   125,   126,
     127,    -1,   129,   130,   131,   132,    -1,    -1,   135,   136,
     137,   138,   139,    -1,   141,   142,   143,    -1,   145,   146,
     147,    -1,   149,   150,   151,   152,    -1,   154,   155,   156,
     157,    -1,    -1,   160,    -1,   162,   163,   164,   165,   166,
      -1,   168,    -1,   170,   171,    -1,   173,   174,   175,   176,
     177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,   205,   206,
      -1,   208,   209,   210,   211,   212,   213,    -1,   215,    -1,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
      -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,   236,
     237,    -1,    -1,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,    -1,
      -1,   268,    -1,   270,   271,   272,   273,    -1,    -1,   276,
     277,   278,   279,   280,    -1,   282,   283,    -1,    -1,   286,
     287,   288,    -1,    -1,   291,   292,    -1,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,   304,   305,   306,
      -1,    -1,   309,   310,    -1,   312,    -1,   314,   315,   316,
      -1,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,   350,   351,   352,   353,   354,   355,    -1,
     357,   358,   359,   360,   361,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,    -1,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,    -1,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,   398,    -1,   400,   401,    -1,   403,   404,   405,   406,
     407,   408,   409,    -1,   411,   412,   413,    -1,    -1,   416,
     417,    -1,   419,    -1,    -1,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,    -1,   432,   433,   434,   435,   436,
      -1,    -1,   439,   440,   441,   442,   443,    -1,   445,    -1,
     447,   448,   449,   450,   451,   452,    -1,    -1,   455,    -1,
      -1,   458,   459,   460,   461,   462,   463,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,   476,
     477,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    -1,    29,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    -1,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    -1,    53,    -1,    -1,
      -1,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      66,    67,    -1,    -1,    70,    -1,    72,    73,    74,    75,
      -1,    -1,    78,    -1,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    91,    92,    93,    94,    95,
      96,    -1,    98,    99,   100,   101,    -1,    -1,    -1,   105,
      -1,    -1,    -1,   109,   110,   111,   112,   113,   114,    -1,
      -1,   117,    -1,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,    -1,   129,   130,   131,   132,    -1,    -1,   135,
     136,   137,   138,   139,    -1,   141,   142,   143,    -1,   145,
     146,   147,    -1,   149,   150,   151,   152,    -1,   154,   155,
     156,   157,    -1,    -1,   160,    -1,   162,   163,   164,    -1,
     166,    -1,   168,    -1,   170,   171,    -1,   173,   174,   175,
     176,   177,    -1,   179,    -1,    -1,    -1,   183,   184,    -1,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,   205,
     206,    -1,   208,   209,   210,   211,    -1,    -1,    -1,    -1,
      -1,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,    -1,    -1,   229,    -1,   231,   232,   233,    -1,   235,
     236,   237,    -1,    -1,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
      -1,   257,    -1,   259,   260,   261,   262,   263,   264,   265,
      -1,    -1,   268,    -1,   270,   271,   272,   273,    -1,    -1,
     276,    -1,   278,   279,   280,    -1,   282,   283,    -1,    -1,
     286,   287,   288,    -1,    -1,   291,   292,    -1,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,   304,   305,
     306,    -1,    -1,   309,   310,    -1,   312,    -1,   314,   315,
     316,    -1,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,    -1,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,    -1,   373,   374,    -1,
     376,   377,   378,   379,   380,    -1,   382,    -1,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,   398,    -1,   400,   401,    -1,   403,   404,   405,
     406,   407,   408,   409,    -1,   411,    -1,    -1,    -1,    -1,
     416,   417,    -1,   419,    -1,    -1,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,    -1,   432,   433,   434,   435,
     436,    -1,    -1,   439,   440,   441,   442,   443,    -1,    -1,
      -1,   447,   448,   449,   450,   451,   452,    -1,    -1,   455,
      -1,    -1,   458,   459,   460,   461,   462,   463,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,
     476,   477
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    30,    32,    33,    50,    60,    72,    74,    75,
      81,    83,    95,    97,   114,   117,   132,   134,   138,   144,
     152,   154,   161,   178,   195,   235,   236,   241,   253,   271,
     307,   315,   329,   335,   336,   338,   343,   349,   352,   359,
     365,   366,   373,   377,   387,   402,   422,   433,   439,   444,
     457,   480,   481,   482,   483,   484,   485,   498,   505,   506,
     507,   508,   509,   510,   516,   517,   519,   520,   521,   522,
     524,   528,   540,   545,   546,   549,   550,   551,   570,   573,
     574,   589,   635,   638,   639,   642,   645,   646,   647,   655,
     662,   664,   665,   668,   671,   672,   676,   685,   689,   690,
     691,   694,   696,   697,   698,   699,   707,   709,   729,   733,
     735,   736,   746,   748,   755,   756,   759,   760,   761,   762,
     763,   772,   774,   776,   779,   783,   784,   792,   793,   796,
     801,   815,   847,   850,   851,   852,   857,   860,   862,   864,
     866,   867,   870,   871,   874,   876,   877,   881,   882,   883,
     886,   887,   888,   889,   890,   897,   899,   900,   901,   902,
     908,   910,   911,   917,   918,   919,   922,   923,   924,   925,
     927,   928,   930,   931,   933,   934,   936,   948,   950,   953,
     955,   957,   966,   968,   974,   979,   983,   984,   985,   986,
     987,   988,   994,  1030,   416,   460,   903,    27,    78,    94,
     112,   118,   136,   147,   156,   169,   174,   181,   200,   225,
     246,   286,   310,   320,   321,   324,   351,   354,   358,   360,
     367,   370,   389,   396,   401,   402,   405,   409,   419,   424,
     437,   450,   661,   903,     3,    20,    21,    22,    23,    24,
      25,    26,    27,    29,    30,    31,    39,    40,    41,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    57,    58,    59,    60,    61,    62,    63,    66,
      67,    68,    69,    70,    72,    73,    74,    75,    76,    78,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      91,    92,    93,    94,    95,    96,    98,    99,   100,   101,
     105,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     119,   121,   122,   123,   124,   125,   126,   127,   129,   130,
     131,   132,   135,   136,   137,   138,   139,   141,   142,   143,
     145,   146,   147,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   160,   162,   163,   164,   165,   166,   168,
     170,   171,   173,   174,   175,   176,   177,   179,   180,   182,
     183,   184,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   197,   198,   199,   200,   201,   202,   203,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   215,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   229,
     230,   231,   232,   233,   235,   236,   237,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   270,   271,   272,   273,
     275,   276,   277,   278,   279,   280,   282,   283,   286,   287,
     288,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   309,   310,   311,
     312,   313,   314,   315,   316,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   367,   368,   369,   370,   371,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   400,   401,   403,   404,   405,   406,   407,   408,   409,
     411,   412,   413,   416,   417,   418,   419,   420,   422,   423,
     424,   425,   426,   427,   428,   429,   432,   433,   434,   435,
     436,   439,   440,   441,   442,   443,   444,   445,   447,   448,
     449,   450,   451,   452,   455,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,  1090,  1160,  1172,  1173,  1177,
    1178,  1179,     3,    28,   980,  1157,  1172,  1177,   448,   498,
     941,   284,   316,   903,    53,   498,   581,    22,    40,    65,
      78,   112,   118,   136,   147,   156,   169,   177,   181,   237,
     286,   289,   310,   324,   351,   360,   370,   389,   396,   405,
     406,   408,   409,   424,   431,   434,   437,   590,   644,   751,
     802,   816,    28,   315,  1157,   980,    28,   309,   368,   406,
     408,     6,   224,   858,   859,  1163,    22,    27,    65,    78,
      94,   112,   136,   147,   156,   169,   174,   181,   200,   246,
     286,   299,   310,   321,   324,   351,   354,   358,   360,   367,
     370,   389,   396,   402,   405,   409,   417,   419,   424,   437,
     450,   661,   764,   766,   767,   903,  1157,    97,   448,   498,
     639,   642,   645,   936,   949,   953,   956,   966,   973,   979,
     983,   994,    11,    21,    28,    48,   164,   170,   172,   196,
     226,   260,   318,   337,   489,   490,   780,   781,   980,  1162,
    1164,    28,    97,   333,   366,   785,   786,   787,  1172,   169,
    1172,  1159,  1163,   402,   997,   780,  1172,   343,   373,   377,
     416,  1157,   299,   246,   112,   200,   360,   401,   402,   498,
     868,   869,   359,  1172,    28,   371,   412,   416,   532,   541,
     542,  1172,    25,   178,   785,   786,   316,   903,  1172,   223,
      28,   133,   999,  1000,    66,    91,   237,   255,   351,   360,
     371,   412,   416,   463,   529,   530,   531,   532,    28,   371,
     412,   416,   532,   416,   285,  1042,  1155,  1172,   997,   491,
    1172,   173,   498,   942,   498,   331,   989,   990,  1157,   989,
       3,    52,    54,    55,    68,    69,   115,   116,   137,   165,
     212,   213,   215,   256,   258,   277,   328,   375,   381,   412,
     413,   445,  1064,  1066,  1068,  1070,  1072,  1074,  1075,  1076,
    1078,  1079,  1080,  1082,  1083,  1173,  1177,   999,  1000,  1001,
    1168,    12,  1169,  1170,  1172,  1169,  1169,   984,   985,   988,
       0,   501,   498,   941,   148,   214,   290,   430,  1002,  1003,
     984,   986,   987,   123,   210,   436,   502,    34,   907,   832,
    1160,   769,  1172,   769,  1157,   319,   769,   419,  1157,   111,
     402,   820,  1160,  1172,  1179,     3,   104,   108,   372,  1165,
    1166,  1174,  1177,  1178,  1179,    28,   190,  1155,   278,   450,
      10,    17,    18,    19,    73,   160,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   854,   856,  1120,  1121,  1172,
     190,  1157,   820,  1157,    28,  1165,  1166,   820,  1157,  1157,
     190,  1155,  1157,   190,   769,  1157,   343,   373,    28,   190,
    1042,  1157,   363,  1157,   769,    28,   244,  1165,  1166,   190,
    1155,   224,   120,   220,   269,   327,   904,   905,   906,   498,
     496,   500,  1146,  1148,   935,   936,   937,   938,  1174,  1155,
    1157,  1172,    27,    65,    79,    90,   112,   136,   174,   200,
     225,   286,   321,   351,   354,   396,   405,   417,   424,   764,
     765,   766,   767,  1163,   907,   952,   956,   966,   973,   983,
    1155,   248,   769,   498,   190,   769,  1157,   769,   419,   190,
    1157,   111,   402,   406,   408,  1165,  1166,   406,   408,    73,
     160,   854,   341,  1157,  1157,  1165,   190,   525,  1172,   190,
    1157,   190,   769,  1157,  1157,   363,   769,   244,  1165,   331,
     367,   402,   450,   246,    94,   200,    27,    90,   174,   321,
     358,   417,   419,   423,   656,    28,  1157,   981,   539,  1163,
    1174,   859,   248,   190,   832,   833,   190,   863,   190,  1157,
     190,   771,  1064,   419,   111,   402,   190,   819,   820,   190,
    1166,  1167,    86,   450,    73,   160,   190,   855,   856,    58,
     190,   819,   190,  1167,   190,   819,   190,  1157,   190,  1157,
     363,   863,   190,   771,   190,   244,  1167,   224,   190,   768,
     769,   190,  1156,  1157,   190,  1157,   907,   498,   954,   590,
     949,   444,   935,   941,   210,   436,  1164,   781,   782,    28,
     782,  1164,   782,    28,   782,  1164,   782,   782,   782,  1164,
    1162,  1162,   980,   782,   319,   498,   498,   612,   612,   612,
     284,   414,   502,   612,   360,  1042,  1043,   502,   898,   542,
     530,   532,    28,   532,  1163,   498,   951,    58,   450,   935,
      86,   803,   803,  1172,    47,   477,   220,   500,   287,   287,
     284,   172,  1163,   414,   907,   167,   777,   284,     5,     8,
       9,    10,    12,    36,    52,    54,    55,    64,    65,    68,
      69,    76,    78,   102,   103,   104,   105,   106,   107,   108,
     115,   116,   118,   153,   158,   159,   165,   180,   182,   212,
     213,   215,   230,   238,   239,   256,   258,   267,   269,   274,
     275,   277,   286,   297,   311,   328,   356,   372,   381,   397,
     412,   413,   418,   420,   421,   431,   437,   445,   465,   466,
     467,   468,   470,   471,   472,   473,   478,   489,   490,   491,
     498,   984,  1067,  1070,  1073,  1074,  1075,  1077,  1078,  1079,
    1082,  1083,  1087,  1089,  1090,  1091,  1093,  1116,  1117,  1118,
    1122,  1140,  1145,  1152,  1153,  1160,  1161,  1162,  1163,  1172,
    1151,  1152,  1163,    28,   547,  1154,  1155,   371,   529,   118,
     538,  1163,   539,  1163,    47,    70,   529,   477,   382,   905,
     287,   172,   414,   488,    47,   477,   220,   906,   498,  1155,
     491,  1148,  1043,   935,   171,   943,  1087,  1125,   989,   502,
     498,   944,   447,  1081,  1081,  1081,   498,  1069,  1069,   313,
     498,  1071,    68,    69,  1081,  1069,  1066,   459,   480,   498,
    1084,   498,  1084,    36,  1065,   498,   113,   188,   249,   252,
     364,   475,   498,  1085,  1086,   500,   770,  1069,  1151,  1149,
     499,   499,   507,   935,   945,   946,   947,  1155,    28,   133,
     998,   998,    58,   998,   161,   167,   234,   281,  1006,  1008,
    1009,  1024,  1026,  1027,  1028,  1002,  1003,   172,   216,  1042,
    1044,   498,    67,   265,   300,   339,   373,   498,   830,   300,
     335,   339,   373,   770,   300,   339,   373,     3,    89,   142,
     240,   300,   307,   339,   373,   405,   407,   457,   540,   543,
     912,   913,   914,   915,   797,    24,   138,   300,   339,   373,
     441,   556,  1157,    24,   138,   373,   436,   523,   461,   190,
    1042,    61,    96,   157,   193,   229,   265,   269,   300,   301,
     339,   348,   357,   365,   373,   385,   394,   398,   452,   540,
     544,   836,   848,   875,   498,   817,  1148,   339,   523,   196,
     153,    24,    30,    45,    75,   131,   138,   141,   168,   202,
     265,   269,   279,   288,   300,   339,   342,   343,   373,   441,
     552,   554,   555,   679,   875,     5,   489,   490,   653,  1164,
      28,   190,  1155,   769,   769,   498,   853,   300,   373,   500,
     153,   284,   300,   339,   373,   848,   875,    24,   138,   300,
     339,   373,   196,   518,   339,   457,   480,   511,   518,   300,
     339,   373,   848,   875,   284,   300,   339,   153,    37,    59,
     110,   199,   247,   250,   265,   299,   339,   344,   367,   373,
     387,   552,   650,   651,   300,   339,   449,   679,   687,   153,
     300,   339,   373,    24,    89,   131,   138,   141,   300,   335,
     339,   373,   542,   530,   196,   153,    45,   129,   265,   339,
     373,   552,   553,   300,   339,   343,   373,    87,   130,   302,
     407,   284,    24,    30,   138,   300,   339,   373,   571,   572,
     518,   167,   339,   511,   518,   153,   339,   373,   552,  1157,
     232,   120,   285,   462,   502,   904,    28,   133,   446,   491,
     499,   825,  1087,  1126,  1127,  1173,  1087,  1147,     3,    28,
      32,    33,    34,    35,    36,    37,    38,    42,    56,    64,
      65,    71,    77,    79,    90,    97,   102,   103,   104,   106,
     107,   108,   118,   120,   128,   133,   134,   140,   144,   148,
     159,   161,   167,   169,   172,   178,   181,   185,   196,   204,
     214,   216,   227,   228,   234,   238,   239,   269,   274,   281,
     284,   285,   289,   290,   308,   317,   333,   347,   366,   372,
     383,   399,   402,   410,   414,   415,   421,   430,   431,   437,
     438,   446,   453,   454,   456,   457,   491,  1158,  1175,  1177,
    1178,  1179,  1180,  1146,   499,   502,   159,   284,   421,   536,
     539,   653,   939,   438,   932,   284,   832,   498,   769,  1157,
    1064,   820,   278,    73,   160,   856,   820,   820,   167,  1064,
     769,  1157,  1157,   499,   612,  1157,    71,  1064,   269,   172,
     498,   737,   511,    37,   926,  1157,   269,   511,   461,   190,
    1155,   511,   769,   769,   737,   434,   590,   284,   167,   884,
     885,   511,   269,    47,   526,   269,   424,   686,   269,   944,
      89,   300,   663,    87,   130,   302,   407,    37,   737,   167,
     190,   511,   450,   190,  1155,   190,   640,  1155,  1155,   450,
     769,   803,  1160,   419,  1160,  1160,  1157,   167,  1157,   661,
      39,    53,   109,   209,   265,   362,   153,    62,   345,   502,
     557,   153,   498,   153,   511,   153,   502,   557,   461,   153,
     502,   557,   153,   502,   190,   768,   190,   769,   190,   769,
     153,   502,   557,  1167,   153,   557,   153,   153,   557,   153,
     557,   153,    87,   130,   302,   407,   167,   153,   557,   153,
     167,   190,   153,   502,   557,   153,   502,   557,   153,   284,
    1125,   402,   499,   949,   216,  1044,   782,   980,   782,   980,
     782,   980,   782,   980,   782,   980,   980,   980,   782,   980,
     498,   613,   614,  1172,   613,    28,   112,   136,   169,   174,
     224,   225,   321,   354,   360,   367,   402,   405,   424,   788,
    1154,  1167,   787,  1157,   196,   502,   969,  1163,  1064,  1129,
      37,  1167,   803,   499,  1155,  1157,   232,  1172,   167,   167,
     788,  1167,   359,  1172,   539,   284,   498,  1149,   496,   984,
    1130,  1087,  1144,   498,   498,   167,   498,   498,   984,   498,
     498,   498,   498,   498,   498,   498,  1087,   498,   498,   498,
     498,   498,   498,   498,   498,   984,   498,   498,   498,   498,
     498,   498,   498,   498,  1087,  1087,  1087,   984,  1087,  1125,
    1148,  1163,   498,  1163,     3,    10,    13,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   163,   164,   165,   166,   168,
     169,   170,   171,   173,   174,   175,   176,   177,   179,   180,
     182,   183,   184,   186,   187,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     215,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   250,   251,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   282,   283,   285,   286,   287,   288,   289,   291,
     292,   293,   294,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   308,   309,   310,   311,   312,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   448,   449,   450,
     451,   452,   453,   455,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   476,
     477,   478,   486,   487,   488,   489,   490,   491,   492,   493,
     494,  1120,  1122,  1124,  1176,  1181,   458,  1103,   296,  1087,
     216,   502,   995,   498,  1163,  1148,   995,   121,   192,   548,
     502,    70,   118,   539,    37,     3,   118,   237,   537,   653,
    1083,  1163,  1163,    92,   135,  1099,   101,   118,   533,   534,
     536,   653,   118,   533,   232,  1155,    93,   344,   773,   499,
     941,    34,    44,    51,    77,   191,   196,   218,   233,   286,
     289,   378,   499,   502,   990,  1156,    37,   498,  1125,  1162,
    1081,  1081,    36,  1065,   412,   412,  1162,  1162,   496,   496,
    1162,   414,   414,   414,   498,   414,  1162,  1158,   500,  1069,
     172,  1031,    15,   488,  1146,  1171,   499,   502,   944,   986,
     986,  1004,  1005,  1087,   986,   164,   260,  1015,   222,   265,
     327,   376,   436,    28,  1010,  1087,   489,   490,  1011,  1012,
    1087,  1089,  1024,  1025,  1009,  1008,  1006,  1007,   167,  1027,
     279,  1029,  1006,  1024,  1044,   958,  1155,    37,  1172,  1125,
      67,   414,   414,   360,   196,   207,   290,   293,   375,   446,
     491,   823,   824,   825,   827,   829,   831,  1064,  1173,   414,
     449,   414,   360,   414,   414,   360,   234,   414,   414,   405,
     529,   300,   912,   914,   488,   916,   167,   178,   196,   349,
     798,   799,    71,    90,   149,   169,   317,   431,   609,   610,
      90,   118,   269,   414,    90,   414,   118,   269,   360,    90,
     131,   141,   300,   339,   734,   360,   669,    27,    65,   136,
     174,   286,   321,   354,   417,   424,   764,   765,  1157,   153,
     339,   373,   552,   284,   653,   365,   229,   414,  1172,   414,
     274,   653,   122,   217,   360,   371,   416,   531,   769,   345,
     373,   836,   849,   126,   499,   818,   823,   414,   437,   405,
    1155,    79,   149,   190,   597,   609,  1172,    79,    90,   872,
     304,   284,   356,   358,   419,    90,   872,    31,   342,   356,
     358,   419,   356,  1155,   168,   202,   279,   769,   498,   414,
     414,   189,   498,   561,   243,   405,   434,   459,   561,    90,
     502,   126,     5,     5,   300,   196,   153,   339,   373,   552,
     875,   438,   438,   266,  1064,   414,   360,   498,   854,  1157,
    1155,   414,   414,   360,   849,   126,   402,   402,   414,   414,
     402,   737,   112,   373,   543,   414,   513,   543,   414,   414,
     360,   849,   126,  1155,   414,   414,  1155,  1066,   653,    58,
     652,   653,   653,   110,   247,   250,    58,   414,   511,   254,
     360,   511,   265,   651,   414,   414,   274,  1163,   679,   769,
     414,   414,   360,   389,   324,  1163,   324,   414,   324,   414,
     324,   737,   405,  1042,   304,   304,    90,   414,   872,   360,
     414,   414,   561,   561,   769,   769,   769,   769,  1155,    46,
     443,    46,    46,   414,    46,   414,   443,   360,   498,   502,
     543,   437,   695,  1166,   414,   513,   543,  1155,   414,   872,
     360,   300,   339,   327,   340,   369,   535,   904,  1126,  1126,
    1127,   499,    15,    16,   502,  1002,  1003,   497,   503,  1155,
     937,  1157,  1155,   218,  1064,   218,   284,   218,   218,   653,
     769,   769,   218,   218,   218,  1064,   218,   218,   218,   284,
     414,   172,   414,   575,   424,   498,    37,   153,   769,   738,
     739,  1175,   912,  1064,   284,   153,   666,  1157,   269,   304,
     498,   512,   751,   438,   331,   450,  1155,    28,   402,   457,
     844,   512,   153,  1166,    97,   178,   527,   589,   646,   709,
     783,   801,   908,   153,  1163,   687,   688,   153,   284,  1163,
    1166,   240,   769,   769,   769,   769,   145,   326,   498,   695,
     269,   512,  1155,   269,   648,   650,   269,    37,   279,   304,
     498,   612,   612,   190,   643,  1155,   167,   190,   804,  1157,
     498,   741,   830,  1157,   498,   821,   821,    37,  1064,    26,
      49,   211,   710,   224,   457,   459,   982,   362,   833,   832,
    1064,  1157,   498,   771,  1064,   819,   820,  1167,  1166,   153,
     557,   153,   438,   153,   438,   855,   856,   557,   819,  1167,
     819,  1157,  1157,  1064,   771,  1167,   695,   153,   768,   769,
    1156,  1157,  1157,   769,   499,   190,  1155,   949,   958,   373,
     980,   980,   980,   980,   980,   980,   613,   499,   502,   499,
     175,   322,   355,   368,   403,  1156,   768,   111,   370,   819,
    1156,   278,   819,   819,  1156,  1154,  1154,  1156,   768,   414,
     457,   794,   148,   234,   692,   693,    22,   151,   356,   376,
     970,  1042,   273,   971,   499,   502,   952,   414,  1155,   868,
     869,   786,   785,   786,   172,   179,   795,  1172,    27,    79,
     136,   174,   225,   321,   354,   424,   764,   765,  1125,   497,
    1125,  1130,  1131,   453,  1141,  1142,  1087,  1125,   498,  1162,
    1162,     3,   113,   188,   249,   252,   364,   475,  1132,  1133,
    1163,  1125,  1125,  1125,  1162,  1162,  1087,  1087,   854,  1087,
    1126,  1128,  1135,   356,   489,   490,   498,  1088,  1089,  1122,
    1136,   499,  1125,  1087,  1128,  1137,  1087,    56,   172,   228,
     415,  1087,  1125,  1138,  1125,   254,  1089,  1087,  1097,  1098,
    1099,   254,  1087,  1099,   499,   502,  1162,  1085,  1064,  1087,
    1087,  1087,  1087,  1175,   412,    42,   399,  1150,   769,  1087,
     498,   984,  1139,   133,   135,   159,   261,   262,   263,   264,
     268,   269,   274,   421,   432,  1134,  1087,   498,  1087,   414,
      51,   191,   196,   233,   378,  1087,  1087,  1087,  1087,  1087,
    1087,  1087,  1087,  1087,  1087,    28,    35,   383,  1119,   181,
     162,  1104,   356,   498,  1116,   177,   237,   402,   406,   408,
     434,   996,  1155,  1153,  1031,  1126,  1031,  1155,   416,   498,
    1163,   502,   499,   189,   189,   557,   947,   936,   940,  1087,
     499,   246,   269,   991,  1125,   499,   499,   496,   477,   477,
     499,   499,  1162,   497,  1162,   499,   188,   249,  1086,   249,
    1086,  1086,  1162,   252,   499,  1158,   227,   357,   474,   498,
     984,  1032,  1033,  1034,  1042,  1047,  1057,  1090,  1092,  1093,
    1172,   454,  1052,  1168,   947,   945,   502,    38,   128,   438,
     813,   356,   357,   489,   490,  1012,  1014,  1089,   376,   222,
     285,   502,     5,  1013,  1162,  1013,   356,   357,  1014,  1154,
     273,   380,   972,  1025,  1007,   438,   967,    37,  1172,   499,
    1166,  1157,  1157,   293,    58,  1173,   499,   825,   827,   824,
     827,  1173,   290,   499,   502,   770,  1166,  1157,  1157,  1166,
    1157,  1157,  1166,  1157,  1157,   118,   536,  1164,   351,   437,
     785,   360,   178,   785,   498,  1157,   438,   805,   222,   222,
     438,   498,   634,   190,  1157,   274,  1166,  1157,  1157,  1087,
     274,  1157,  1157,    31,   342,   414,   414,  1157,   414,   670,
     832,   498,  1064,   820,    73,   160,   856,   820,   820,   167,
    1064,   769,  1157,   184,   265,   300,   339,   442,   673,   674,
     675,  1042,   414,   872,   360,   274,   122,   217,  1166,  1157,
     284,  1157,   284,   499,   502,  1165,  1167,  1157,   339,   552,
     190,   597,   269,  1064,  1157,  1162,  1172,  1155,  1157,   232,
    1157,    28,   437,  1157,   190,  1157,   190,  1172,   358,   419,
     358,   419,   232,  1157,    28,   437,  1157,   232,   356,  1155,
      24,   138,   373,   680,   681,   682,   683,  1175,  1166,  1157,
     118,   173,   270,   438,   560,   563,   564,  1175,  1157,    75,
     282,  1157,   555,   284,   414,   405,  1155,   414,   872,   360,
     126,  1157,  1157,   502,   499,   502,  1166,  1157,   878,   879,
    1175,   284,   339,   414,   703,  1166,  1157,  1157,   284,  1043,
    1043,  1166,  1157,  1043,  1157,  1165,     3,    89,   143,   202,
     306,   429,   437,   440,   514,  1166,  1157,  1157,   284,   339,
    1166,  1157,   339,   373,   552,   650,   653,   769,  1157,   653,
     769,  1157,   653,  1166,  1157,   373,  1166,  1157,  1157,  1164,
    1156,  1156,  1166,   844,  1157,  1156,  1157,   339,   373,   552,
     553,  1155,  1155,  1157,  1157,  1157,  1157,  1166,  1157,    24,
      30,   138,   300,   339,   373,   300,   339,   373,   737,   339,
     373,   339,   373,   339,   875,  1056,  1172,   190,   747,  1172,
     190,  1172,  1166,  1157,  1157,  1163,  1157,   878,    24,   572,
     370,  1165,   339,   373,   552,  1157,  1157,  1157,   414,   414,
      84,   428,   327,   502,  1002,  1002,  1002,  1087,  1087,   446,
    1127,   499,  1087,  1147,   932,   274,   775,  1163,    37,   775,
     136,   769,   775,   775,   218,   438,   438,   775,   775,   775,
     224,   775,   775,   775,   769,   323,   576,   576,   200,   402,
     708,  1087,  1064,   769,   499,   502,   488,   601,  1175,  1157,
      62,   172,   360,   449,   667,   674,   675,   153,   279,   233,
     591,   593,   595,   597,   606,   609,    25,   196,   351,   400,
     514,   515,   167,  1157,   450,  1155,    37,   704,   403,  1043,
     737,   525,  1172,   526,   590,   816,  1157,   169,   769,   498,
     636,   637,  1092,  1172,   324,  1163,   737,   737,   737,   737,
     498,   737,  1054,  1055,  1056,   370,   153,   498,   153,   153,
     152,   983,   769,   279,   591,  1172,   438,   629,   457,   562,
     269,    37,   612,  1163,   269,   284,     3,   742,   743,   737,
      26,   499,   822,   823,   828,    37,   224,   348,   417,   456,
     834,   835,   836,   837,   834,   284,   224,   279,   123,   210,
     422,   436,   711,   712,  1157,   187,   187,   167,   557,    37,
     511,   168,   920,   921,   557,   557,   768,   769,  1157,   769,
    1157,   557,   557,   557,   557,   224,   557,   370,   167,   557,
     557,   284,   557,   269,   118,   298,   498,   959,   983,   498,
     975,   976,   977,  1172,   499,   614,   196,   196,   196,   196,
     196,   461,  1156,   653,   654,   181,   789,   790,  1166,    25,
     795,   414,   498,   172,   151,   376,   151,   376,   356,   436,
     251,  1064,  1166,   457,   641,   803,   803,   172,   284,   789,
      58,   557,   832,   769,  1064,   820,   278,   820,   820,  1064,
     769,  1157,   499,   497,   497,   502,  1087,   140,  1142,  1143,
      37,   499,  1087,   499,   499,   499,   172,   499,   499,   499,
     499,   499,   499,   502,   502,   499,   308,   499,   499,   498,
    1088,  1088,  1125,    13,    17,    18,    19,   196,   218,   286,
     486,   487,   488,   489,   490,   491,   492,   493,   494,  1122,
    1088,   499,   499,   167,   172,   378,   499,   499,    37,  1138,
    1125,  1138,  1138,   172,   499,   499,  1175,   305,  1101,    37,
     499,   502,  1087,  1175,   502,  1087,  1149,  1087,   499,   477,
    1088,  1088,   146,  1125,   172,   133,   135,   159,   268,   274,
     421,   432,  1134,   268,   146,   854,  1087,   399,  1150,  1087,
    1139,  1087,   414,   498,   984,   498,   498,   295,  1108,   498,
    1125,   406,   408,   406,   408,  1155,   997,   997,   997,  1052,
    1002,  1052,   905,  1162,  1085,   534,   947,   246,   498,   499,
    1162,  1084,  1084,   497,   497,   499,   984,  1047,  1057,   172,
     498,   984,  1033,  1034,    37,  1035,  1036,  1172,   502,    98,
     173,   206,   221,   231,   257,   350,  1039,  1036,    37,  1035,
    1038,  1172,  1036,   480,  1051,  1148,  1087,   181,  1016,  1005,
     286,  1120,  1123,   479,   814,     5,  1162,  1014,   285,   457,
     436,  1011,   242,  1032,   454,  1053,  1172,   831,   770,   827,
     827,    58,   829,   493,  1167,  1167,   284,  1156,   287,   284,
    1087,   610,  1157,   498,   498,   498,   634,   200,   613,   727,
     153,   557,   414,  1166,  1157,   539,  1064,   769,   769,  1064,
     657,  1157,   184,   442,   414,   414,   657,   673,   679,   339,
     373,   552,  1157,  1157,  1157,   208,   274,   156,   823,   299,
     373,   414,   269,   153,    85,   599,   600,   727,   373,    24,
     138,   343,   344,   373,   556,   565,   566,   679,   873,   365,
     153,   557,   153,   557,  1157,  1157,  1157,  1157,   365,   365,
     232,   682,   683,   682,   499,   502,   684,  1163,   200,   499,
     502,   488,   500,   156,  1166,  1157,   339,   373,   552,  1157,
    1157,  1157,   284,   300,   339,   373,    24,   138,   300,   339,
     373,  1064,   266,  1064,   499,   502,   488,  1155,   414,  1167,
     438,   700,   156,   234,   306,   274,  1163,   306,  1167,   435,
     156,   414,   414,   360,   389,   844,   844,   844,   299,   373,
      90,   414,   872,   360,   118,   167,   567,   163,   803,   414,
     414,   244,   244,   244,   414,   414,   360,   414,   414,   360,
     414,   360,   414,   360,   414,   126,   557,  1064,   269,  1163,
     373,   873,   153,   557,   414,   414,   499,  1157,   414,   872,
     360,   414,  1166,  1157,   499,   499,   499,  1127,   497,  1064,
     769,   218,   775,  1157,  1157,  1157,   218,   390,   391,   577,
    1163,   577,   184,   499,   499,   172,   737,   739,   266,   286,
     489,   490,   653,   740,   827,  1123,  1163,  1180,    71,    77,
      90,   118,   120,   176,   204,   269,   274,   317,   333,   431,
     602,   603,   605,   152,   453,   511,   539,  1157,   539,   288,
     677,  1155,  1155,  1155,   499,   502,  1167,   181,   351,  1167,
    1162,   424,  1155,   612,     3,   167,   705,    47,   526,   402,
     686,   111,   944,  1087,   172,   502,  1156,   562,   744,   745,
    1163,   499,   502,  1157,   167,   613,  1155,   640,  1155,  1157,
     641,   498,   592,  1155,   499,  1157,   457,   459,   630,   561,
      37,   153,   983,   629,   414,   153,  1042,   488,   499,   502,
     711,   499,   502,   118,   488,   838,  1163,   539,   402,   826,
     827,   167,   843,    50,   346,   839,   840,   837,   840,   123,
     210,   366,   436,   895,  1157,   279,   284,   289,   184,   983,
    1064,   498,   499,   502,   557,   438,   557,   438,   557,  1157,
    1157,   695,   769,   153,   444,   401,   437,   960,   961,   962,
    1172,   284,   963,   977,   978,   502,  1031,   488,  1149,   360,
     360,   360,   360,   360,  1156,   502,  1166,   457,   502,   791,
     287,  1043,   370,   151,   151,   111,   265,  1155,  1157,  1167,
     788,   795,  1166,   218,   218,   218,   218,   653,   218,   218,
     218,   218,   218,  1130,   410,  1087,   144,  1064,   499,  1087,
    1134,  1087,  1087,   499,  1125,   502,  1064,  1088,  1088,  1088,
    1088,   133,   135,   269,  1088,  1088,  1088,  1088,  1088,  1088,
    1088,  1088,  1088,  1088,  1087,  1087,  1087,  1064,   499,   499,
     499,  1125,   499,   502,    58,  1089,  1102,   499,  1175,  1098,
     314,   395,  1100,   499,   502,   449,  1094,    37,   499,  1163,
    1087,    34,    34,  1087,   499,  1087,   172,   268,  1087,   499,
     146,  1088,  1088,   146,   146,  1087,  1087,  1003,   454,   498,
    1109,  1172,   499,  1125,   502,   997,   997,   997,   997,  1155,
    1155,  1155,  1016,   499,  1016,   499,   952,   497,  1036,  1038,
    1036,   498,   469,  1089,   499,  1172,   498,  1033,   221,   294,
    1040,  1033,  1040,   221,  1039,  1040,   221,   404,  1045,   498,
    1172,   498,   291,    58,   185,  1023,   498,   814,   164,   226,
     285,   457,   411,   101,  1087,   347,   965,   499,   493,   831,
     424,   175,   355,   361,   368,   403,   425,   800,   167,   800,
     499,   498,   617,   618,   808,  1092,  1172,   613,   613,   727,
    1157,   499,   120,   204,   265,   269,   728,  1157,  1157,    37,
     438,   438,   224,   770,  1166,  1157,   414,   872,   360,   414,
     208,  1157,    58,   405,  1157,   153,   597,   118,  1172,   677,
     389,   176,   155,   189,   269,   561,   511,   111,   176,   269,
     389,   392,   561,   599,   651,   373,   566,   424,  1157,  1172,
     365,   681,  1157,   564,   740,  1175,  1157,   299,   373,   414,
     872,   360,   414,   156,   414,   414,   360,   174,   286,   392,
     749,   750,   174,   286,   757,   758,   414,   414,   360,   499,
     499,   499,   879,   266,   653,   827,   880,  1123,  1163,  1180,
     339,  1157,   498,   457,   701,  1157,  1164,  1163,  1163,  1163,
    1157,  1157,  1157,  1157,  1164,    58,   405,  1157,  1157,  1157,
    1157,   444,  1157,  1157,   167,   167,   341,   167,   190,  1166,
    1157,  1157,  1166,  1157,  1157,  1157,  1157,  1157,  1157,  1157,
     284,    77,   558,   153,    26,    49,   424,  1172,  1157,  1163,
     679,  1157,  1157,  1157,  1157,  1002,   499,   218,   775,   218,
     218,   218,   775,   511,   438,   582,   583,   657,   727,   457,
     459,   769,   498,   769,  1157,  1088,    31,    58,   604,   121,
     192,   120,   274,   222,  1155,   844,   174,   321,   723,   730,
     731,  1172,   666,   498,   304,   498,   592,   607,   203,   624,
     595,  1167,  1167,  1064,   498,   562,    28,   123,   210,   366,
     436,   706,   414,   702,  1166,   190,  1155,   688,   461,   284,
     499,  1032,   637,   844,   499,   502,  1056,   677,   695,   499,
     648,    37,   279,   304,   498,   954,   594,   596,   598,   609,
    1172,   304,   625,   626,   592,   624,   561,   282,   284,   631,
     983,   643,   641,   562,  1163,  1157,   805,   740,     3,   743,
     284,   828,  1087,  1087,   502,   498,   834,   424,   502,    43,
    1087,   414,   498,   613,  1155,   712,   657,   499,   920,   921,
    1157,  1157,   557,   370,   557,   443,   499,   502,  1149,    88,
     965,   499,   502,   976,  1053,  1087,  1156,  1156,  1156,  1156,
    1156,   653,   178,   790,   795,   499,  1157,   111,   795,   172,
     557,   274,   778,  1163,   778,   778,   778,   218,   778,   778,
     778,   778,   778,  1087,   499,   499,   499,   172,   499,  1087,
     172,   133,   135,   172,   167,   146,   499,   464,  1096,  1125,
     332,   443,    58,  1102,  1089,   455,   455,   499,  1087,   265,
    1087,   502,  1095,  1066,  1087,  1087,  1087,  1087,    34,    34,
    1087,  1087,   146,   499,   499,  1087,  1110,  1172,   499,  1087,
    1155,  1155,  1155,  1155,  1023,  1163,  1023,  1163,   499,  1048,
    1049,  1092,   498,  1101,  1035,   498,  1156,  1033,   284,   438,
    1041,  1033,   221,  1033,  1160,  1055,   498,  1055,  1172,   998,
    1087,   456,  1105,   854,   411,   279,  1152,   424,   499,   414,
     785,   172,   727,  1087,   499,   502,   457,    77,   807,   811,
     807,   499,   499,   197,   615,   121,   192,   202,   120,   440,
     557,  1064,  1157,  1157,  1157,  1157,  1157,  1157,  1157,  1167,
    1157,   597,   601,  1164,   604,   190,   190,   274,   653,   604,
     274,  1164,  1172,  1064,   557,   557,   488,    58,   405,  1157,
    1157,  1157,  1157,  1157,  1166,  1157,  1157,  1162,  1162,  1064,
     502,  1162,  1162,   502,  1166,  1157,  1157,   414,  1087,    71,
    1167,  1157,   414,   414,   172,   196,   457,  1156,  1156,   769,
    1156,   153,   156,   769,  1163,  1163,  1064,   557,   557,   414,
     499,   218,   775,   775,   775,   775,   498,   578,   579,   511,
     125,   174,   207,   174,  1087,   269,   603,   118,    37,   844,
     612,   438,   633,  1160,    34,   152,   196,   678,   682,   279,
     591,   567,   150,   198,   498,   370,   438,   613,    37,  1167,
     700,   526,   269,   498,   169,  1157,   636,  1163,   370,   562,
     152,   983,   769,   279,   591,   641,   499,   502,   457,   601,
      58,   629,   567,   625,    83,   405,   632,   457,   909,    37,
     632,   172,   284,   498,  1155,  1163,   825,   845,   846,  1173,
     840,  1064,   167,   841,  1155,   172,   414,   865,   334,   713,
     205,   658,   557,   499,   557,   557,  1157,   983,   298,   983,
     962,   284,   498,   964,   488,   977,   965,   287,   216,   557,
     789,   778,  1087,   499,  1088,   172,  1087,  1087,  1087,   498,
     499,   502,   499,  1102,   499,   443,   386,   499,   499,  1087,
    1087,  1087,   499,   304,  1111,   499,  1105,  1105,   363,   992,
     499,   502,    37,  1050,   118,  1062,  1063,  1088,    80,  1156,
     499,  1087,   498,  1033,  1041,   498,   499,  1055,   499,   100,
     182,   353,   498,  1017,  1018,  1019,  1020,  1021,  1022,  1087,
    1106,  1107,  1172,  1002,   499,   980,   789,   284,   789,   499,
     615,   618,   286,   854,   769,   769,   812,   333,   615,   498,
     844,   499,   414,   373,   971,    37,   153,   153,   558,   740,
    1167,  1157,   414,   498,   820,   854,   856,   750,   498,   498,
     758,  1157,   499,   498,   373,   971,  1157,  1157,   498,   498,
     498,   457,   480,   929,   341,   929,   929,   167,  1157,   558,
    1157,   775,   584,   585,  1175,    53,    99,   124,   142,   146,
     168,   171,   186,   274,   325,   580,   578,  1163,   820,    37,
     861,   861,   499,   189,   498,   633,   245,   616,   200,   498,
     731,   723,   498,   499,   502,  1155,   499,   370,    28,    82,
      85,    91,   119,   176,   189,   201,   389,   392,   608,   608,
    1154,  1157,  1157,   499,   983,   701,   153,   111,   677,   172,
    1157,    37,  1157,   641,   592,  1155,   499,   596,   288,  1172,
     630,   625,   629,   123,   138,   314,  1157,    63,    71,   237,
     983,   769,  1042,   806,   808,   172,   726,   827,   499,   502,
     424,   144,   508,   839,   842,  1052,   384,   384,   499,   259,
     283,   714,   715,   716,   167,   719,   657,   265,   442,   659,
     660,   960,    90,   806,   134,  1087,  1157,   795,   167,  1088,
    1097,  1125,   265,   476,    58,  1002,    57,   127,   110,   993,
    1051,  1048,   498,  1088,   499,   502,    37,  1058,  1059,  1172,
     499,  1156,  1125,   499,   498,   374,   498,   499,   502,   502,
      37,  1007,   791,   800,   557,   807,   844,   498,   561,   813,
    1155,   844,   613,   633,  1157,   405,   189,   438,   559,   373,
     971,  1157,  1129,   167,   753,   753,  1129,  1129,  1087,   405,
    1125,  1125,   568,   569,  1174,   768,   769,   768,   769,  1156,
     557,   499,   502,   491,   498,   536,   586,   653,   926,  1163,
     926,   269,   274,   325,   926,   926,  1052,   861,    41,   194,
     265,   611,   498,   649,  1087,   173,   303,   379,   284,   620,
     621,   622,   405,   499,  1160,     6,   732,   682,   592,   624,
    1157,   499,   677,   160,   752,   562,   909,  1155,   461,  1032,
     677,   983,   954,   625,   592,   624,   601,   498,   631,   629,
     630,   357,   357,    71,   287,    71,   641,   805,   499,   502,
    1155,   727,   834,   845,  1064,   501,   134,   457,   457,   715,
     356,   402,   717,   139,   720,   453,   722,   442,   657,   443,
    1157,   499,   270,   436,   677,   557,  1087,   499,   499,   443,
    1125,   183,   326,   357,  1112,   164,   164,   613,  1055,   502,
    1063,  1175,   499,   502,   167,  1064,   499,   499,  1125,   498,
    1125,  1018,  1107,  1109,  1025,   172,   633,   854,   813,   814,
     612,   633,   499,   727,  1157,   649,  1087,   405,   499,   290,
     363,   330,   754,   754,   499,   499,   499,  1157,   499,   499,
     499,   502,  1162,   929,   585,   536,   587,   588,  1163,  1163,
     274,   613,   491,   613,  1163,  1163,   202,   650,   499,   123,
     436,   284,   622,   284,   621,  1157,   498,   499,   502,   567,
     370,   677,   769,    37,    37,   498,  1157,   909,   641,   629,
     567,   625,   498,   627,   628,  1092,  1172,   632,   630,   631,
     287,   287,   498,   197,   809,   808,   167,   840,    29,   211,
     896,   174,   174,   926,   356,   388,   721,   498,   152,   983,
    1052,   373,    51,   101,   427,  1087,  1113,  1114,  1113,  1113,
     499,    58,    58,   373,   499,  1089,  1059,   291,     3,   118,
     269,   274,  1060,  1061,    37,  1037,   340,  1046,   499,  1017,
     499,   789,   454,   619,   499,   814,   616,   727,   971,  1157,
     820,    58,   971,   414,   568,   769,   499,   502,   613,   499,
     393,    62,   265,   345,   373,   623,   623,   499,     6,   370,
    1157,   749,   983,   677,   630,   625,   629,  1087,   499,   502,
     811,   811,   631,   632,   806,   498,   562,   139,   270,   498,
     891,   893,   897,   956,   966,   973,   983,   820,   820,   718,
    1172,  1087,   723,   975,  1114,   356,   166,   312,   166,   312,
     149,  1115,  1115,  1115,   613,   613,  1172,  1101,  1088,  1088,
     274,  1061,  1172,   498,   499,   557,   498,   727,   620,   971,
     769,   498,   588,    23,   118,   274,  1157,   677,   909,   631,
     629,   630,   499,   628,   769,   812,   812,   632,   499,   808,
     810,   632,   356,   892,   893,   894,   984,   985,   502,   502,
     499,  1160,  1052,    34,   101,   181,   265,   411,   373,   373,
     414,   438,    80,  1087,  1087,   727,  1125,   677,   632,   630,
     631,   811,   809,   499,   502,  1052,   722,   499,   501,   414,
     172,   498,  1114,   356,   292,  1172,  1172,  1160,  1161,  1172,
    1058,   499,   499,   499,   631,   632,   812,   562,   808,   152,
     894,   384,   384,     5,   724,   725,  1162,  1163,  1175,   498,
     118,   499,   632,   632,   723,   457,   457,   499,   502,  1126,
    1161,  1052,  1160,   174,   174,   725,  1002,   438,   498,   820,
     820,   499,  1172,   724,   499
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   504,   505,   505,   505,   505,   505,   505,   506,   506,
     507,   507,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   509,   510,   511,   511,
     511,   512,   512,   513,   513,   514,   514,   514,   514,   514,
     514,   514,   514,   514,   515,   515,   515,   515,   515,   515,
     516,   517,   517,   518,   518,   519,   519,   519,   519,   520,
     520,   520,   520,   520,   520,   521,   522,   523,   523,   524,
     524,   524,   524,   525,   525,   526,   526,   527,   527,   527,
     527,   527,   527,   528,   528,   528,   528,   529,   529,   529,
     530,   530,   530,   530,   531,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   532,   532,   533,   533,   534,
     534,   535,   535,   535,   535,   536,   536,   536,   536,   537,
     537,   537,   537,   537,   537,   537,   538,   538,   538,   539,
     539,   540,   540,   541,   541,   541,   541,   542,   542,   543,
     543,   544,   544,   545,   545,   545,   545,   545,   545,   545,
     546,   547,   547,   548,   548,   549,   550,   550,   550,   550,
     550,   551,   551,   551,   551,   551,   551,   551,   551,   551,
     551,   551,   551,   551,   551,   551,   551,   551,   551,   551,
     551,   551,   552,   552,   553,   553,   553,   554,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   555,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   556,   556,   557,
     557,   557,   558,   558,   559,   559,   560,   560,   560,   560,
     561,   562,   562,   563,   563,   564,   564,   564,   564,   565,
     565,   566,   566,   566,   566,   567,   567,   567,   567,   568,
     569,   569,   570,   571,   571,   572,   572,   572,   572,   573,
     573,   574,   574,   575,   575,   576,   576,   577,   577,   577,
     578,   578,   579,   579,   580,   580,   580,   580,   580,   580,
     580,   580,   580,   580,   580,   580,   580,   581,   581,   582,
     582,   583,   583,   584,   584,   585,   586,   586,   586,   586,
     586,   587,   587,   588,   589,   589,   589,   589,   589,   589,
     590,   590,   590,   590,   590,   590,   590,   590,   591,   591,
     592,   592,   593,   593,   594,   594,   595,   595,   595,   596,
     596,   597,   598,   598,   599,   599,   600,   600,   601,   601,
     602,   602,   602,   602,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   604,   604,   605,   605,   605,   605,   606,
     607,   607,   607,   608,   608,   608,   608,   608,   608,   608,
     608,   608,   608,   609,   609,   610,   610,   610,   610,   610,
     610,   610,   611,   611,   612,   612,   613,   613,   614,   615,
     615,   616,   616,   616,   616,   617,   617,   618,   618,   619,
     619,   620,   620,   620,   620,   620,   621,   622,   623,   623,
     623,   623,   623,   624,   624,   625,   625,   626,   627,   627,
     628,   628,   628,   629,   629,   630,   630,   630,   631,   631,
     631,   631,   632,   632,   633,   633,   634,   635,   635,   636,
     636,   637,   637,   637,   638,   638,   639,   639,   640,   641,
     641,   641,   642,   642,   643,   644,   644,   645,   646,   646,
     647,   647,   648,   648,   649,   649,   650,   650,   651,   651,
     651,   651,   651,   651,   651,   651,   651,   651,   651,   651,
     651,   651,   652,   652,   653,   653,   653,   653,   654,   654,
     655,   655,   656,   656,   657,   657,   658,   658,   659,   659,
     660,   660,   661,   661,   662,   663,   663,   664,   664,   665,
     665,   666,   666,   667,   667,   667,   667,   668,   669,   669,
     670,   671,   671,   671,   671,   671,   671,   671,   671,   671,
     671,   671,   671,   671,   672,   673,   673,   673,   673,   674,
     674,   675,   675,   676,   676,   677,   677,   678,   678,   679,
     680,   680,   681,   681,   681,   681,   682,   683,   684,   685,
     685,   686,   686,   687,   687,   688,   688,   689,   689,   689,
     690,   690,   690,   690,   691,   692,   692,   693,   693,   694,
     694,   695,   695,   696,   696,   697,   698,   699,   700,   700,
     701,   701,   702,   702,   703,   703,   704,   704,   705,   705,
     706,   706,   706,   706,   706,   707,   708,   708,   709,   709,
     710,   710,   710,   711,   711,   712,   712,   712,   712,   712,
     713,   713,   714,   714,   715,   716,   716,   717,   717,   718,
     719,   719,   720,   720,   721,   721,   722,   722,   723,   723,
     724,   724,   724,   725,   725,   725,   725,   726,   726,   727,
     727,   728,   728,   728,   728,   728,   728,   729,   729,   730,
     730,   731,   732,   732,   733,   734,   734,   734,   734,   735,
     736,   736,   736,   736,   736,   736,   736,   736,   736,   736,
     736,   736,   736,   736,   736,   736,   737,   738,   738,   739,
     739,   740,   740,   740,   740,   740,   740,   741,   742,   742,
     743,   744,   744,   745,   745,   746,   746,   746,   746,   747,
     747,   748,   749,   749,   750,   750,   750,   750,   750,   751,
     751,   752,   752,   753,   753,   753,   754,   754,   755,   756,
     756,   757,   757,   758,   758,   759,   759,   760,   760,   761,
     762,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   765,   765,   765,   765,
     765,   766,   766,   766,   766,   766,   766,   766,   766,   767,
     767,   767,   768,   768,   769,   769,   770,   770,   771,   771,
     772,   773,   773,   773,   774,   774,   774,   774,   774,   774,
     774,   774,   774,   774,   774,   774,   774,   774,   774,   774,
     774,   774,   775,   775,   776,   776,   776,   776,   776,   776,
     776,   776,   776,   776,   777,   777,   778,   778,   779,   779,
     780,   780,   780,   780,   780,   780,   780,   780,   780,   780,
     780,   780,   780,   780,   780,   780,   781,   781,   782,   782,
     783,   784,   784,   785,   785,   785,   785,   785,   786,   786,
     787,   787,   787,   787,   788,   788,   788,   788,   788,   788,
     788,   788,   788,   788,   788,   788,   788,   788,   788,   788,
     788,   788,   788,   788,   789,   789,   790,   790,   791,   791,
     792,   793,   793,   794,   794,   795,   795,   796,   797,   797,
     798,   798,   798,   799,   799,   799,   800,   800,   800,   800,
     800,   800,   801,   801,   802,   802,   803,   803,   804,   804,
     805,   805,   806,   806,   807,   807,   808,   808,   808,   809,
     809,   810,   810,   811,   811,   812,   812,   813,   813,   813,
     814,   814,   814,   815,   815,   815,   815,   816,   816,   817,
     817,   818,   818,   819,   819,   820,   820,   820,   820,   821,
     821,   822,   822,   823,   823,   823,   823,   823,   824,   824,
     824,   824,   824,   825,   826,   827,   827,   827,   828,   828,
     828,   829,   830,   830,   830,   830,   831,   831,   832,   833,
     833,   834,   834,   835,   835,   836,   836,   836,   836,   836,
     836,   836,   836,   836,   836,   836,   836,   836,   836,   836,
     836,   836,   837,   837,   837,   837,   837,   838,   838,   839,
     840,   840,   840,   841,   841,   842,   842,   843,   843,   844,
     844,   845,   846,   846,   847,   847,   847,   848,   848,   849,
     849,   850,   850,   850,   850,   850,   850,   851,   851,   852,
     852,   853,   853,   853,   853,   854,   854,   855,   855,   856,
     857,   858,   858,   859,   859,   860,   860,   860,   861,   861,
     861,   862,   863,   863,   864,   865,   865,   865,   865,   866,
     867,   867,   867,   867,   868,   868,   869,   869,   869,   870,
     870,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   871,   871,   872,   872,   873,   873,
     874,   874,   874,   874,   874,   874,   875,   875,   876,   876,
     876,   876,   876,   876,   876,   876,   876,   876,   876,   876,
     876,   876,   876,   876,   876,   876,   876,   876,   876,   876,
     876,   876,   876,   876,   876,   877,   878,   878,   879,   879,
     880,   880,   880,   880,   880,   881,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     883,   884,   884,   885,   885,   886,   886,   886,   886,   887,
     888,   888,   888,   888,   888,   888,   888,   888,   889,   889,
     890,   891,   891,   891,   892,   892,   893,   893,   893,   893,
     893,   894,   894,   895,   895,   895,   895,   896,   896,   896,
     897,   898,   898,   899,   900,   900,   901,   901,   901,   901,
     901,   901,   901,   901,   901,   901,   901,   901,   902,   902,
     903,   903,   903,   904,   904,   904,   904,   904,   905,   905,
     905,   906,   906,   907,   907,   907,   908,   908,   908,   908,
     909,   909,   909,   909,   910,   911,   912,   912,   913,   913,
     914,   914,   914,   915,   915,   915,   915,   915,   915,   915,
     916,   916,   917,   917,   917,   918,   919,   919,   919,   919,
     920,   920,   921,   922,   923,   923,   924,   925,   925,   925,
     925,   925,   925,   925,   926,   926,   927,   928,   928,   928,
     928,   928,   928,   929,   929,   930,   931,   931,   931,   931,
     932,   932,   933,   933,   934,   934,   935,   935,   936,   936,
     937,   938,   938,   939,   939,   939,   940,   940,   941,   941,
     942,   942,   943,   943,   944,   944,   945,   946,   946,   947,
     947,   948,   948,   948,   948,   949,   949,   949,   949,   949,
     949,   949,   949,   949,   950,   951,   951,   952,   952,   952,
     952,   953,   953,   953,   954,   954,   955,   955,   955,   955,
     956,   957,   958,   958,   959,   959,   959,   959,   959,   960,
     960,   961,   961,   962,   963,   963,   963,   964,   964,   964,
     965,   965,   966,   967,   967,   968,   969,   969,   970,   970,
     970,   970,   970,   970,   970,   970,   971,   971,   972,   972,
     972,   973,   974,   975,   975,   976,   976,   977,   978,   978,
     979,   980,   981,   981,   981,   981,   981,   981,   982,   982,
     982,   983,   983,   984,   984,   985,   985,   985,   985,   985,
     985,   985,   985,   986,   986,   987,   987,   987,   987,   987,
     987,   987,   988,   988,   988,   989,   989,   990,   991,   991,
     991,   992,   992,   992,   993,   993,   993,   994,   994,   995,
     995,   996,   996,   996,   996,   996,   996,   996,   996,   996,
     997,   997,   998,   998,   998,   999,   999,  1000,  1000,  1001,
    1001,  1002,  1002,  1003,  1004,  1004,  1005,  1005,  1006,  1006,
    1006,  1006,  1007,  1007,  1008,  1008,  1008,  1008,  1008,  1008,
    1009,  1009,  1010,  1010,  1011,  1012,  1012,  1012,  1013,  1013,
    1014,  1014,  1015,  1015,  1016,  1016,  1017,  1017,  1018,  1018,
    1018,  1018,  1018,  1019,  1020,  1021,  1022,  1023,  1023,  1024,
    1024,  1025,  1025,  1026,  1026,  1027,  1028,  1028,  1028,  1028,
    1029,  1029,  1030,  1030,  1031,  1031,  1032,  1032,  1033,  1033,
    1033,  1033,  1033,  1033,  1033,  1033,  1033,  1033,  1034,  1034,
    1034,  1034,  1034,  1034,  1035,  1035,  1035,  1035,  1036,  1036,
    1037,  1037,  1038,  1038,  1038,  1038,  1038,  1039,  1039,  1039,
    1039,  1040,  1040,  1041,  1041,  1042,  1042,  1042,  1042,  1043,
    1043,  1044,  1044,  1044,  1045,  1046,  1046,  1047,  1047,  1048,
    1049,  1049,  1050,  1050,  1051,  1051,  1052,  1052,  1053,  1053,
    1053,  1054,  1054,  1055,  1055,  1056,  1057,  1057,  1058,  1058,
    1059,  1059,  1059,  1060,  1060,  1061,  1061,  1061,  1061,  1062,
    1062,  1063,  1063,  1064,  1064,  1064,  1064,  1064,  1064,  1065,
    1065,  1065,  1066,  1066,  1066,  1066,  1066,  1066,  1066,  1067,
    1067,  1067,  1067,  1068,  1068,  1069,  1069,  1070,  1070,  1070,
    1070,  1070,  1070,  1070,  1070,  1070,  1070,  1070,  1071,  1071,
    1072,  1072,  1073,  1073,  1074,  1075,  1076,  1076,  1077,  1077,
    1078,  1079,  1080,  1080,  1080,  1080,  1080,  1080,  1081,  1081,
    1082,  1082,  1082,  1082,  1083,  1084,  1084,  1084,  1085,  1085,
    1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,  1085,
    1085,  1085,  1086,  1086,  1087,  1087,  1087,  1087,  1087,  1087,
    1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,
    1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,
    1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,
    1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,
    1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,
    1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1087,  1088,
    1088,  1088,  1088,  1088,  1088,  1088,  1088,  1088,  1088,  1088,
    1088,  1088,  1088,  1088,  1088,  1088,  1088,  1088,  1088,  1088,
    1088,  1089,  1089,  1089,  1089,  1089,  1089,  1089,  1089,  1089,
    1089,  1089,  1089,  1089,  1089,  1090,  1090,  1090,  1090,  1090,
    1090,  1090,  1091,  1091,  1092,  1092,  1093,  1093,  1093,  1093,
    1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,
    1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,
    1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,
    1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,  1093,
    1093,  1093,  1094,  1094,  1095,  1095,  1095,  1095,  1096,  1097,
    1097,  1098,  1098,  1099,  1099,  1100,  1100,  1100,  1101,  1101,
    1101,  1101,  1102,  1102,  1103,  1103,  1104,  1104,  1105,  1105,
    1106,  1106,  1107,  1108,  1108,  1108,  1109,  1110,  1110,  1111,
    1111,  1112,  1112,  1112,  1112,  1113,  1113,  1114,  1114,  1114,
    1114,  1114,  1115,  1115,  1115,  1115,  1115,  1116,  1116,  1116,
    1117,  1117,  1118,  1119,  1119,  1119,  1120,  1120,  1121,  1121,
    1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,  1121,
    1122,  1122,  1123,  1123,  1124,  1124,  1124,  1124,  1124,  1124,
    1125,  1125,  1126,  1126,  1127,  1127,  1127,  1128,  1128,  1129,
    1129,  1130,  1130,  1130,  1131,  1131,  1132,  1133,  1133,  1133,
    1133,  1133,  1133,  1133,  1133,  1134,  1134,  1134,  1134,  1135,
    1135,  1136,  1137,  1137,  1137,  1137,  1137,  1138,  1138,  1138,
    1139,  1139,  1140,  1141,  1141,  1142,  1143,  1143,  1144,  1144,
    1145,  1145,  1146,  1146,  1146,  1146,  1147,  1147,  1148,  1148,
    1149,  1149,  1150,  1150,  1151,  1151,  1152,  1152,  1153,  1153,
    1153,  1153,  1154,  1154,  1155,  1155,  1156,  1156,  1157,  1158,
    1159,  1160,  1160,  1161,  1161,  1161,  1161,  1161,  1161,  1161,
    1161,  1161,  1161,  1161,  1161,  1161,  1162,  1163,  1164,  1164,
    1164,  1165,  1166,  1166,  1166,  1166,  1167,  1167,  1168,  1169,
    1170,  1170,  1171,  1171,  1172,  1172,  1172,  1173,  1173,  1173,
    1174,  1174,  1174,  1174,  1175,  1175,  1175,  1175,  1175,  1176,
    1176,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,  1177,
    1177,  1177,  1177,  1177,  1177,  1177,  1177,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,
    1178,  1178,  1178,  1178,  1178,  1178,  1178,  1178,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,  1179,
    1179,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,
    1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,
    1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,
    1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,
    1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,
    1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,
    1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,
    1180,  1180,  1180,  1180,  1180,  1180,  1180,  1180,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     5,     1,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       3,     3,     2,     1,     1,     2,     2,     2,     3,     3,
       5,     5,     5,     0,     3,     5,     5,     5,     5,     3,
       5,     3,     5,     3,     5,     5,     6,     1,     1,     6,
       4,     9,     7,     1,     0,     2,     0,     1,     1,     1,
       1,     1,     1,     3,     2,     3,     3,     2,     5,     1,
       3,     3,     3,     3,     1,     3,     3,     2,     2,     2,
       2,     3,     3,     3,     3,     1,     3,     1,     3,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     3,     1,     2,     3,     2,     1,     1,     2,
       1,     2,     1,     3,     3,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     4,     6,     4,     6,    10,    13,     4,     6,     4,
      10,    13,     4,     6,     4,     6,     5,     7,    11,    14,
       5,     7,     1,     3,     4,     4,     4,     3,     2,     5,
       3,     6,     4,     6,     6,     5,     7,     6,     6,     5,
       5,     6,     5,     9,     4,     5,     7,     6,     4,     8,
       4,     2,     4,     3,     6,     4,     3,     3,     3,     2,
       2,     3,     4,     4,     3,     3,     3,     3,     3,     3,
       4,     4,     3,     2,     3,     2,     2,     3,     3,     2,
       2,     3,     4,     4,     4,     5,     1,     3,     2,     1,
       1,     0,     2,     0,     2,     0,     1,     1,     1,     3,
       3,     2,     0,     1,     3,     3,     1,     5,     3,     1,
       2,     1,     3,     2,     3,     6,     6,    10,     1,     2,
       1,     3,     4,     1,     3,     4,     6,     4,     8,     2,
       2,    11,     9,     1,     1,     1,     0,     1,     1,     1,
       1,     3,     2,     0,     1,     1,     3,     3,     1,     1,
       3,     3,     3,     3,     4,     3,     2,     1,     0,     3,
       0,     1,     0,     1,     3,     2,     1,     1,     1,     3,
       0,     1,     3,     1,    13,    16,    12,    15,    14,    17,
       1,     1,     2,     2,     2,     2,     1,     0,     1,     0,
       3,     0,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     5,     2,     4,     2,     2,     1,     0,     2,     0,
       3,     1,     1,     2,     2,     1,     3,     4,     5,     2,
       5,     7,     5,     1,     2,     1,     2,     2,     2,     3,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     5,     8,     3,     9,     4,
      10,    11,     2,     0,     3,     0,     1,     3,     1,     4,
       0,     2,     2,     2,     0,     1,     3,     3,     6,     4,
       0,     1,     1,     2,     2,     0,     3,     3,     2,     1,
       1,     2,     2,     4,     0,     1,     0,     6,     1,     3,
       3,     3,     5,     2,     0,     2,     2,     0,     3,     4,
       4,     0,     2,     0,     4,     0,     3,     8,    11,     1,
       3,     1,     1,     3,     6,     8,     7,    10,     6,     2,
       3,     0,     8,    11,     5,     1,     0,     6,     5,     8,
       4,     6,     1,     0,     3,     0,     1,     2,     2,     2,
       1,     2,     3,     2,     2,     2,     2,     3,     3,     3,
       1,     3,     1,     0,     1,     2,     2,     1,     1,     3,
       6,    10,     1,     0,     1,     2,     2,     0,     2,     2,
       1,     0,     1,     0,     7,     2,     0,     3,     5,     5,
       8,     2,     0,     2,     2,     2,     1,     5,     2,     0,
       2,     6,     6,     6,    10,     6,     6,     6,     9,     9,
       6,     6,     9,     6,     7,     2,     2,     2,     2,     1,
       2,     1,     0,     7,     6,     4,     0,     1,     3,     4,
       1,     3,     1,     2,     2,     2,     2,     1,     1,    10,
      13,     2,     0,     2,     2,     1,     0,     5,     4,     4,
      11,    14,    12,    15,    11,     2,     1,     4,     0,     8,
      11,     1,     1,     7,     9,     8,    10,     8,     4,     0,
       5,     0,     2,     0,     2,     0,     2,     0,     2,     0,
       1,     1,     1,     1,     1,     8,     1,     1,    17,    21,
       1,     1,     2,     1,     3,     1,     1,     1,     3,     1,
       2,     0,     1,     2,     4,     1,     1,     1,     1,     1,
       3,     0,     1,     0,     1,     1,     4,     0,     1,     1,
       1,     3,     0,     1,     1,     1,     1,     2,     0,     0,
       2,     2,     1,     2,     2,     2,     2,    11,    13,     1,
       3,     5,     1,     3,     5,     1,     2,     2,     1,     8,
       6,     5,     4,     4,     3,     7,     8,     6,     6,     6,
       6,     6,     4,     7,     5,     8,     3,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       3,     1,     0,     1,     3,     7,     9,     9,     8,     3,
       0,    13,     1,     3,     5,     5,     3,     6,     2,     1,
       0,     2,     0,     2,     4,     0,     1,     0,     6,     8,
       8,     1,     3,     5,     5,     7,     9,     7,     9,     5,
       6,     6,     4,     6,     4,     6,     8,     4,     6,     4,
       6,     5,     7,     1,     1,     1,     2,     1,     2,     1,
       1,     1,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     2,     2,     1,     3,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     2,     2,     3,     1,     3,
       5,     2,     2,     0,     6,     6,     6,     6,     6,     6,
       6,     6,     8,     9,     8,     6,     6,     9,     9,     9,
       7,    10,     1,     1,     8,     8,     8,     8,     8,     8,
       8,     9,     8,     8,     2,     0,     1,     1,     2,     2,
       1,     2,     3,     3,     3,     3,     4,     4,     3,     3,
       3,     4,     4,     3,     4,     4,     1,     1,     1,     0,
       8,     8,    11,     1,     1,     2,     4,     5,     1,     3,
       2,     2,     2,     2,     1,     2,     2,     4,     3,     2,
       2,     2,     2,     2,     2,     3,     2,     2,     2,     5,
       5,     5,     5,     5,     1,     3,     1,     2,     3,     0,
       6,     6,     9,     3,     0,     3,     0,     5,     2,     0,
       3,     3,     3,     7,     7,    10,     1,     1,     1,     1,
       1,     1,    15,    18,     1,     0,     1,     0,     1,     0,
       2,     0,     1,     3,     4,     5,     2,     2,     4,     4,
       0,     1,     3,     2,     0,     1,     0,     1,     1,     0,
       2,     2,     0,     9,    12,     7,     7,     2,     0,     3,
       2,     1,     3,     1,     3,     2,     1,     1,     2,     3,
       2,     1,     3,     3,     3,     2,     2,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     4,     5,     1,     3,
       3,     1,     3,     3,     5,     6,     1,     3,     2,     1,
       3,     1,     0,     1,     2,     4,     5,     1,     1,     1,
       1,     3,     3,     2,     2,     1,     2,     2,     2,     2,
       1,     2,     2,     2,     2,     1,     1,     1,     3,     2,
       1,     4,     0,     3,     0,     1,     1,     3,     5,     2,
       0,     2,     1,     3,     5,     5,     5,     1,     2,     1,
       0,     4,     6,     4,     6,     4,     6,     4,     6,     4,
       6,     3,     5,     5,     5,     1,     3,     1,     3,     2,
       2,     1,     2,     1,     2,    11,    10,    10,     2,     2,
       0,     9,     2,     0,    10,    11,    11,     5,     5,     8,
       4,     4,     7,     7,     1,     1,     1,     1,     1,     5,
       5,     6,     6,     6,     6,     6,     8,     8,     6,     6,
       7,     9,     9,     8,    10,     6,     6,     6,     6,     6,
       6,     6,     8,     6,     8,     6,     8,     7,     9,     6,
       8,     7,     9,     8,    10,     8,    10,     9,    11,     8,
      10,     9,    11,     8,     8,     7,     6,     6,     6,     6,
       8,     8,     8,     8,     6,     9,     1,     0,     2,     0,
       8,     8,     8,    10,     9,     8,     1,     0,     6,     6,
       6,     6,     6,     6,     6,     9,     9,     6,     6,     6,
       8,     6,     8,     8,     8,     8,     6,     8,     6,     8,
       7,     9,     7,     9,     6,     7,     1,     3,     3,     3,
       1,     1,     1,     1,     1,     7,     6,     6,     6,     6,
       6,     6,     7,     7,     6,     9,     9,     6,     6,     6,
       6,     6,     6,     8,     8,     8,     6,     7,     6,     6,
       5,     1,     0,     3,     3,     5,     6,     6,     6,     8,
       5,     5,     6,     7,     7,     7,     4,     4,     4,     6,
      13,     1,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     0,
       3,     2,     0,     2,     2,     2,     3,     3,     3,     3,
       2,     3,     2,     5,     4,     3,     3,     3,     3,     3,
       1,     1,     0,     3,     2,     2,     1,     2,     1,     3,
       2,     1,     0,     2,     3,     0,     9,    11,    12,    14,
       3,     4,     4,     0,     2,     5,     1,     0,     1,     2,
       3,     3,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     0,     5,     4,     6,     4,     3,     5,     7,     9,
       1,     3,     1,     5,     4,     4,     6,     4,     6,     6,
       5,     7,     9,     6,     1,     0,     6,    11,    11,    11,
      13,     9,    11,     1,     1,    10,     4,     6,     2,     5,
       2,     0,     6,     5,     3,     5,     1,     3,     1,     1,
       2,     1,     1,     1,     1,     0,     1,     0,     1,     0,
       1,     0,     1,     0,     3,     0,     2,     1,     3,     1,
       0,     2,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     5,     3,     0,     1,     1,     1,
       1,     3,     9,    12,     3,     0,     2,     3,     2,     3,
       7,     4,     1,     3,     1,     4,     4,     7,     2,     1,
       1,     1,     3,     2,     8,     5,     0,     4,     3,     0,
       2,     0,     7,     2,     0,     5,     3,     0,     2,     2,
       2,     3,     1,     3,     1,     2,     1,     0,     1,     2,
       0,     8,     3,     1,     3,     3,     5,     2,     1,     3,
       7,     1,     0,     3,     2,     2,     2,     2,     0,     2,
       2,     1,     1,     3,     3,     1,     2,     4,     4,     2,
       3,     5,     5,     1,     1,     9,     9,     1,     2,     4,
       4,     4,     2,     2,     3,     1,     3,     9,     1,     2,
       0,     7,     7,     0,    10,     6,     0,     1,     0,     2,
       0,     3,     3,     4,     4,     4,     4,     3,     2,     1,
       1,     0,     1,     1,     0,     1,     5,     1,     0,     1,
       1,     1,     0,     3,     1,     3,     4,     3,     2,     2,
       1,     1,     1,     0,     2,     4,     5,     6,     4,     5,
       2,     3,     1,     1,     1,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     4,     0,     1,     3,     1,     1,
       1,     1,     1,     2,     4,     4,     5,     2,     0,     1,
       3,     1,     0,     1,     2,     3,     2,     4,     2,     3,
       2,     0,     4,     5,     2,     0,     1,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     1,     4,     3,     4,
       5,     4,     5,     4,     5,     2,     4,     1,     1,     0,
       2,     0,     1,     4,     5,     4,     0,     2,     2,     2,
       1,     1,     0,     5,     2,     1,     2,     2,     4,     1,
       3,     1,     2,     3,     6,     4,     0,     2,     6,     2,
       1,     3,     4,     0,     2,     0,     2,     0,     2,     4,
       0,     1,     0,     1,     3,     3,     7,    12,     1,     3,
       2,     3,     3,     1,     2,     2,     2,     2,     1,     1,
       3,     3,     2,     2,     3,     5,     6,     2,     3,     3,
       4,     0,     1,     1,     1,     1,     1,     2,     4,     1,
       1,     1,     1,     2,     3,     3,     0,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     1,     3,     0,
       1,     1,     1,     1,     5,     2,     1,     1,     1,     1,
       4,     1,     2,     2,     1,     3,     3,     2,     1,     0,
       5,     2,     5,     2,     1,     3,     3,     0,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     0,     1,     4,     1,     3,     3,     5,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     3,     2,     2,     3,     5,
       4,     6,     3,     5,     4,     6,     4,     6,     5,     7,
       3,     2,     4,     2,     3,     3,     4,     3,     4,     3,
       4,     5,     6,     6,     7,     6,     7,     3,     4,     4,
       6,     2,     3,     4,     3,     4,     4,     5,     1,     1,
       3,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     5,     6,     3,
       4,     1,     1,     2,     4,     1,     1,     1,     2,     2,
       2,     2,     1,     1,     4,     3,     5,     6,     8,     6,
       6,     4,     4,     1,     1,     1,     5,     1,     1,     4,
       1,     4,     1,     4,     1,     4,     1,     1,     1,     1,
       1,     1,     6,     4,     4,     6,     4,     4,     4,     4,
       4,     6,     5,     5,     5,     4,     6,     4,     4,     4,
       4,     5,     7,     7,     9,     5,     4,     6,     5,     7,
       7,     7,     2,     3,     3,     3,     4,     0,     4,     1,
       3,     3,     1,     1,     1,     2,     2,     0,     2,     3,
       3,     4,     2,     2,     5,     0,     5,     0,     2,     0,
       1,     3,     3,     2,     2,     0,     6,     1,     0,     3,
       0,     3,     3,     3,     0,     1,     4,     2,     2,     2,
       2,     2,     3,     2,     2,     3,     0,     4,     3,     5,
       4,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     1,     4,     1,     4,     1,     2,     1,     2,
       1,     3,     1,     3,     1,     3,     3,     1,     0,     1,
       3,     3,     3,     2,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     7,
       5,     3,     5,     5,     3,     3,     5,     3,     2,     1,
       1,     3,     5,     1,     2,     4,     2,     0,     1,     0,
       1,     2,     2,     2,     3,     5,     1,     0,     1,     2,
       0,     2,     1,     0,     1,     0,     1,     3,     3,     2,
       1,     1,     1,     3,     1,     2,     1,     3,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     2,     6,
       2,     3,     5,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     3,    10,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 863 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
			}
#line 27628 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 3:
#line 867 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 27636 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 4:
#line 871 "gram_minimal.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 27645 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 5:
#line 876 "gram_minimal.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);
				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 27656 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 6:
#line 883 "gram_minimal.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);
				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 27667 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 7:
#line 890 "gram_minimal.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);
				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 27678 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 8:
#line 909 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 27694 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 9:
#line 921 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 27705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1063 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 27711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1073 "gram_minimal.y" /* yacc.c:1646  */
    {
					CallStmt *n = makeNode(CallStmt);
					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *)n;
				}
#line 27721 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1088 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27733 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1109 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1110 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27745 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1114 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 27751 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1115 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 27757 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1120 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 27766 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1125 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 27774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1129 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 27788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1139 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 27800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1147 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 27808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1151 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 27816 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1155 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 27824 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1160 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 27832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1164 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *)makeInteger(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 27881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1211 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 27887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1214 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 27895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1218 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 27903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1222 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 27911 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1226 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 27919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1230 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 27927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1244 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 27939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1262 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 27951 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1270 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 27963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1280 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 27969 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1281 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 27975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1286 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 27987 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1294 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 27999 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1302 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1310 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 28023 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1331 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1338 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1345 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1352 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1359 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28078 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1366 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28089 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1383 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 28101 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1401 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 28114 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1411 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 28120 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1412 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 28126 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1424 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 28140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1434 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 28154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1444 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 28173 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1459 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 28192 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1476 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28198 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1477 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28204 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1482 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 28214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1488 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28220 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1516 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minimum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1523 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1529 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 28251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1535 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 28261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1544 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1552 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1564 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28297 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1572 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 28309 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1580 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1587 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1596 "gram_minimal.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 28337 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1598 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 28348 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1606 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 28363 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1617 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 28375 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1625 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28387 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1633 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 28402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1644 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28414 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1652 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1660 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 28437 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1667 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1676 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 28461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1685 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28467 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1687 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 28473 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1690 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 28479 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1691 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 28485 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1695 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 28491 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1697 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 28497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1700 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 28503 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1701 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 28509 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1702 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 28515 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1703 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 28521 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1707 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 28527 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1708 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 28533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1709 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 28539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1715 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1728 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 28553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1732 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 28561 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1736 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					if ((yyvsp[0].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[0].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 28580 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1751 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 28591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1757 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].value), (yylsp[0])); }
#line 28597 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1758 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28603 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1759 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 28609 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1763 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28615 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1764 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28621 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1765 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 28627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1769 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1770 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 28639 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1774 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 28645 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1776 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minimum */
					(yyval.node) = (Node *) n;
				}
#line 28655 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1784 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 28661 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1786 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 28672 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1793 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 28683 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1800 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 28694 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1810 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 28705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1817 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 28715 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1826 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 28721 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1827 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 28727 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1832 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 28733 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1833 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 28739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1840 "gram_minimal.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 28749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1846 "gram_minimal.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
#line 28759 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1852 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 28769 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1858 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 28779 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1864 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 28789 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1870 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 28799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1876 "gram_minimal.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 28809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1886 "gram_minimal.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 28820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1895 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 28826 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1896 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 28832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1900 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 28838 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1901 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 28844 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1910 "gram_minimal.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
#line 28853 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1925 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 28863 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1931 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 28873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1937 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 28883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1943 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 28893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1949 "gram_minimal.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 28903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1968 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1977 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1986 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28942 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1995 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 28955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2004 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28970 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2015 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 28985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2026 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 28998 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2035 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2044 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29024 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2053 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2064 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29054 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2075 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29067 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2084 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29080 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2093 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2102 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2111 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29119 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2120 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29132 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2129 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29147 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2140 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 29162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2151 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29175 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2160 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2171 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 29194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2172 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 29200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2178 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29217 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2192 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29234 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2205 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 29250 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2221 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 29267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2238 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29279 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2247 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29291 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2256 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29303 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2265 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29315 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2274 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29327 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2283 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 29338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2291 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *)n;
				}
#line 29349 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2299 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *)n;
				}
#line 29360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2307 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2316 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 29384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2325 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (Node *) makeInteger((yyvsp[0].ival));
					(yyval.node) = (Node *)n;
				}
#line 29403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2341 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2350 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2359 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-3].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 29439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2368 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 29451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2377 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *)n;
				}
#line 29471 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2394 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29483 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2403 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29495 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2412 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29507 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2421 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2431 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29533 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2444 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 29551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2459 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2468 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2477 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 29593 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2492 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29604 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2500 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 29617 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2510 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 29630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2520 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
#line 29640 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2527 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29651 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2535 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
#line 29662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2543 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *)n;
				}
#line 29672 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2550 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *)n;
				}
#line 29682 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2557 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2565 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29704 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2573 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29715 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2581 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 29725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2588 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 29735 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2595 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2603 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
#line 29756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2610 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
#line 29766 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2617 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29777 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2625 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2633 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2641 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29810 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2649 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 29821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2657 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *)n;
				}
#line 29832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2665 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[0].list));
					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
#line 29845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2675 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
#line 29855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2682 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 29866 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2690 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 29877 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2698 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29888 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2706 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 29899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2714 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 29910 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2722 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 29920 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2729 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 29930 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2736 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 29940 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2743 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *)n;
				}
#line 29950 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2749 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 29961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2758 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 29967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2759 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 29973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2763 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 29979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2764 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 29985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2765 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 29991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2770 "gram_minimal.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 30003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2777 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2781 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2782 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2787 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30032 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2794 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2801 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 30054 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2808 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 30065 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2817 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2820 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30077 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 372:
#line 2821 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 373:
#line 2825 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30089 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 374:
#line 2826 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 30095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2832 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 30103 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2836 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 30111 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 377:
#line 2840 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 30120 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 378:
#line 2845 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 30128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 379:
#line 2852 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 30134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2854 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2859 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 30148 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2863 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 30156 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2867 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 30171 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2878 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 30179 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2886 "gram_minimal.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 30234 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2939 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 30249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2952 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 30265 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2966 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 30278 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2978 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 30286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2985 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 30294 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2989 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 30302 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3003 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
#line 30316 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3015 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 30322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3016 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 30328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3022 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 30340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3031 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 30353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3041 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 30366 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3051 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *)n;
				}
#line 30385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3077 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 30395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3083 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 30405 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3118 "gram_minimal.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 30442 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3151 "gram_minimal.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *)n;
				}
#line 30465 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3172 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30471 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3173 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30477 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3177 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 30483 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3178 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 30489 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3187 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 30495 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3188 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30501 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3189 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 30507 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3192 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30513 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3193 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30519 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3198 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 30525 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3199 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30531 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3204 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 30539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3208 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 30547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3212 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30555 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3216 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3220 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"), (yylsp[0]));
				}
#line 30571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3224 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 30579 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3228 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30587 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3232 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 30595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3236 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 30603 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3240 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star), (yylsp[-2]));
				}
#line 30611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3244 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[0].list), (yylsp[-3]));
				}
#line 30619 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3248 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 30627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3252 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30635 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3261 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"), (yylsp[0]));
				}
#line 30643 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3264 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 30649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3269 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 30657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3272 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 30663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3283 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 30671 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3287 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 30679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3294 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 30687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3300 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 30693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3301 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 30699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3302 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 30705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3303 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 30711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3304 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 30717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3309 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 30725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3313 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 30733 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3320 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 30739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3334 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 30760 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3353 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 30781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3372 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 30803 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3392 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 30825 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3412 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 30847 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3432 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 30869 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3462 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30875 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3463 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3464 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3465 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 30893 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3467 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 30904 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3474 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 30915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3480 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 30921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3481 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 30927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3485 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 30933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3486 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3490 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 30945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3491 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 30951 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3496 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 30959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3500 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 30967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3507 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 30975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3511 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 30983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3517 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30989 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3518 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 30995 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3519 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31001 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3523 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31007 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3524 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3528 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 31037 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3550 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31059 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3568 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *)n;
				}
#line 31081 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3588 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3589 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 31093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3593 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3594 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31105 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3598 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 31111 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3599 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31117 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3604 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 31128 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3610 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3611 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3613 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 31157 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3644 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31168 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3651 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31179 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3658 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3669 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 31209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3680 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 31225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3692 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *)n;
				}
#line 31240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3703 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *)n;
				}
#line 31253 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3712 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *)n;
				}
#line 31280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3735 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable			= (yyvsp[-3].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[-2].list);
					n->fk_matchtype		= (yyvsp[-1].ival);
					n->fk_upd_action	= (char) ((yyvsp[0].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[0].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
#line 31299 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3752 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 31305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3753 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 31311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3773 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 31322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3780 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3787 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3794 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 31355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3805 "gram_minimal.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *)n;
				}
#line 31367 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3815 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 31373 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3816 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 31379 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3817 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 31385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3821 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 31391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3822 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 31397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3823 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 31403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3824 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 31409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3825 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 31415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3826 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 31421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 509:
#line 3827 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 31427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 510:
#line 3828 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 31433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3829 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 31439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3830 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 31445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3840 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));
					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 31456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3846 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 31462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3851 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 31479 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3865 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-7]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3880 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3896 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31536 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3911 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31555 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3928 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method	= (yyvsp[-8].str);
					n->exclusions		= (yyvsp[-6].list);
					n->including		= (yyvsp[-4].list);
					n->options			= (yyvsp[-3].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[-2].str);
					n->where_clause		= (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 31576 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3946 "gram_minimal.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable			= (yyvsp[-4].range);
					n->fk_attrs			= (yyvsp[-7].list);
					n->pk_attrs			= (yyvsp[-3].list);
					n->fk_matchtype		= (yyvsp[-2].ival);
					n->fk_upd_action	= (char) ((yyvsp[-1].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[-1].ival) & 0xFF);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
#line 31598 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3965 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 31604 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3966 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 31610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3970 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3971 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31622 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3975 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31628 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3976 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31634 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3980 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 31642 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3985 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31648 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3986 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3990 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 31662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3994 "gram_minimal.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 31674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 533:
#line 4002 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 31682 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 534:
#line 4006 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 31690 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 535:
#line 4012 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 31696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 536:
#line 4014 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 31702 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 537:
#line 4018 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 31710 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 538:
#line 4023 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 31718 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 539:
#line 4029 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 31724 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 540:
#line 4030 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31730 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 541:
#line 4041 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 31736 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 542:
#line 4043 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 31742 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 543:
#line 4045 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[-1].ival) << 8) | ((yyvsp[0].ival) & 0xFF); }
#line 31748 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 544:
#line 4047 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ((yyvsp[0].ival) << 8) | ((yyvsp[-1].ival) & 0xFF); }
#line 31754 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4049 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
#line 31760 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4052 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 31766 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4055 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 31772 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4059 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
#line 31778 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4060 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
#line 31784 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4061 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
#line 31790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4062 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
#line 31796 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4063 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
#line 31802 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4066 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 31808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4067 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31814 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4071 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 31820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4072 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 31826 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4076 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = (yyvsp[-3].str);
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 31840 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4087 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 31846 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4088 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 31852 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4092 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 31867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4103 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 31882 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4114 "gram_minimal.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 31897 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4127 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4128 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4133 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4134 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4135 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4138 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 31933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4139 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 31939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4140 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 31945 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4141 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 31951 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4144 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31957 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4145 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4148 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31969 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4149 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4152 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4172 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 31996 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4184 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);
					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 32011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4203 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 32017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4204 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 32023 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4208 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 32033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4214 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 32043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4220 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 32053 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4237 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);
					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 32065 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4245 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);
					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].ival);
					(yyval.node) = (Node *)n;
				}
#line 32077 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4266 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4279 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32111 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4296 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 32127 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4310 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32133 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4311 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32139 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4312 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32145 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4325 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4338 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 32179 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4354 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 32195 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4367 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 32201 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4368 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 32207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4381 "gram_minimal.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 32219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4401 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
#line 32233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4411 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 32247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4424 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 32259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4432 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 32271 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4442 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32277 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4443 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32283 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4446 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32289 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4447 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32295 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4450 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32301 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4451 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4455 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].typnam), (yylsp[-1]));
				}
#line 32315 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4459 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 32323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4463 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 32331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4467 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 32339 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4471 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 32347 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4475 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 32355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4479 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 32363 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4483 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 32371 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4487 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 32379 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4491 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 32387 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4495 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 32396 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4500 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 32404 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4504 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 32412 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4508 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[0].value), (yylsp[-2]));
				}
#line 32420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4518 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 32426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4519 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeFloat((yyvsp[0].str)); }
#line 32432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4521 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeFloat((yyvsp[0].str));
					doNegateFloat((yyval.value));
				}
#line 32441 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4525 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeInteger((yyvsp[0].ival)); }
#line 32447 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4528 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 32453 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4529 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 32459 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4542 "gram_minimal.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *)n;
			}
#line 32478 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4558 "gram_minimal.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *)n;
			}
#line 32493 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4571 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4572 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4580 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 32511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4581 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 32517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4585 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4586 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32529 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4590 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4591 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32541 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4595 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4596 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4612 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32566 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4622 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 32572 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4623 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 32578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4637 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32589 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4644 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4661 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4669 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32624 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4680 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4682 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32636 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4687 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32644 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4691 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32652 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4695 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 32663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4702 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 32671 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4714 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32682 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4724 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32688 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4726 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32694 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4731 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 32702 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4744 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *)n;
				}
#line 32715 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4753 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 32728 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 663:
#line 4762 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 664:
#line 4771 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 32754 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 665:
#line 4780 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 32767 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 666:
#line 4789 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32780 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 667:
#line 4798 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 668:
#line 4807 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 32806 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 669:
#line 4816 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *)n;
				}
#line 32819 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 670:
#line 4825 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 671:
#line 4834 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *)n;
				}
#line 32845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 672:
#line 4843 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *)n;
				}
#line 32858 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 673:
#line 4852 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *)n;
				}
#line 32871 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 674:
#line 4870 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 675:
#line 4880 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 32889 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 676:
#line 4881 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 32895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 677:
#line 4882 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[0].list), (yylsp[-1])); }
#line 32901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 678:
#line 4883 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 32907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 679:
#line 4887 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 32913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 680:
#line 4888 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 32919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 681:
#line 4892 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 682:
#line 4893 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 683:
#line 4904 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 684:
#line 4912 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 32955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 685:
#line 4923 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 686:
#line 4924 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 687:
#line 4929 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 32975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 688:
#line 4933 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 32983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 689:
#line 4940 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 32989 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 690:
#line 4945 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 32997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 691:
#line 4949 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 33005 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 692:
#line 4956 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 33013 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 693:
#line 4960 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 33022 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 694:
#line 4965 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 33031 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 695:
#line 4970 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 33039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 696:
#line 4977 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 33047 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 697:
#line 4983 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33053 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 698:
#line 4988 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 33059 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5000 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5012 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33089 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5025 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5026 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33101 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5031 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33107 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5032 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33113 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5036 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33119 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5037 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33125 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5048 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 33138 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5057 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 33150 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5065 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33161 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5084 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33183 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5104 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33205 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5124 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33228 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5145 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5177 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);
				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 33266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5190 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 33272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5191 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 33278 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5196 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 33289 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5203 "gram_minimal.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 33300 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5219 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 33313 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5228 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 33326 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5239 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 33332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5240 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 33338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5253 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33350 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5261 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33362 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5278 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33374 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5304 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);
					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 33390 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5320 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);
					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 33404 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5332 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 33410 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5333 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33416 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5337 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 33422 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5338 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33428 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5342 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5343 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 33440 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5347 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33446 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5348 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 33452 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5353 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
									 parser_errposition((yylsp[0]))));

				}
#line 33470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5366 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5370 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33482 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5371 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 33488 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5375 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 33494 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5376 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 33500 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5377 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 33506 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5378 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 33512 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 33518 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5390 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);
					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 33530 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5400 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 33536 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5401 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 33542 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5415 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
#line 33566 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5438 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *)n;
				}
#line 33595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5465 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 33601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5466 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 33607 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5467 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 33613 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5472 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33619 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5474 "gram_minimal.y" /* yacc.c:1646  */
    {
					int		events1 = intVal(linitial((yyvsp[-2].list)));
					int		events2 = intVal(linitial((yyvsp[0].list)));
					List   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 33642 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5496 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 33648 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5498 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 33654 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5500 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 33660 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5502 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 33666 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5504 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 33672 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5508 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33678 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5509 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33684 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5513 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33690 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5514 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 33696 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5519 "gram_minimal.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);
					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *)n;
				}
#line 33708 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5529 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33714 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5530 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33720 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5534 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33726 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5543 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33732 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5547 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5552 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 33746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5556 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 33758 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5571 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 33764 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5572 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 33770 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5576 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 33776 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 777:
#line 5577 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33782 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 780:
#line 5586 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].value)); }
#line 33788 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 781:
#line 5587 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].value)); }
#line 33794 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 782:
#line 5588 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33800 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 783:
#line 5593 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.value) = makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 33808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 784:
#line 5596 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 33814 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 785:
#line 5597 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 33820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 786:
#line 5598 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.value) = makeString((yyvsp[0].str)); }
#line 33826 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 787:
#line 5602 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 33832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 788:
#line 5603 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 33838 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 789:
#line 5608 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 33844 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 790:
#line 5610 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 33872 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 791:
#line 5636 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 33878 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 792:
#line 5637 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 33884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 793:
#line 5638 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 33890 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 794:
#line 5639 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 33896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 795:
#line 5640 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 33902 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 796:
#line 5641 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 33908 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 797:
#line 5656 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 33921 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 798:
#line 5667 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 33934 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 799:
#line 5679 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33940 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 800:
#line 5681 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33946 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 801:
#line 5686 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 33952 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 802:
#line 5691 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 33958 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 803:
#line 5693 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 33964 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 804:
#line 5698 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 33975 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 805:
#line 5707 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 33981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 806:
#line 5708 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 33987 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 807:
#line 5709 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 33993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 808:
#line 5710 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 33999 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 809:
#line 5722 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 34011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 810:
#line 5741 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34026 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 811:
#line 5752 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34042 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 812:
#line 5764 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 813:
#line 5774 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34070 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 814:
#line 5784 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
#line 34085 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 815:
#line 5795 "gram_minimal.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 34098 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 816:
#line 5804 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 34109 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 817:
#line 5811 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[-3].list);
					n->params	= (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34120 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 818:
#line 5818 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34133 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 819:
#line 5827 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 820:
#line 5836 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34159 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 821:
#line 5845 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34172 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 822:
#line 5854 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 34185 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 823:
#line 5863 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 34199 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 824:
#line 5873 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *)n;
				}
#line 34212 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 825:
#line 5882 "gram_minimal.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
#line 34226 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 826:
#line 5893 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34232 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 827:
#line 5896 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34238 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 828:
#line 5897 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 34244 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 829:
#line 5901 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 34252 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 830:
#line 5905 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 34260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 831:
#line 5911 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 34266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 832:
#line 5912 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 34272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 833:
#line 5913 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 34278 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 834:
#line 5914 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 34284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 835:
#line 5915 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 34290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 836:
#line 5916 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 34296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 837:
#line 5919 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34302 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 838:
#line 5922 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 34308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 839:
#line 5923 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 34314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 840:
#line 5932 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)(yyvsp[0].node), (yylsp[-2]));
				}
#line 34322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 841:
#line 5938 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 842:
#line 5939 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34334 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 843:
#line 5943 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 34340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 844:
#line 5945 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 34346 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 845:
#line 5956 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 34361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 846:
#line 5967 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 34376 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 847:
#line 5978 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 34391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 848:
#line 5989 "gram_minimal.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 34406 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6001 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34412 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6002 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34418 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6020 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6033 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6034 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6039 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);
					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 34461 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6052 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 34474 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6061 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 34486 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6069 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 34499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6078 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 34510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6086 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34516 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6087 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34522 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6090 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6091 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6094 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6095 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6096 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6100 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 34570 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6113 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34576 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6119 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34587 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6129 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6138 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 34613 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6149 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 34619 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6150 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 34625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6155 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 34637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6163 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 34649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6175 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6185 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6198 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34691 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6208 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6230 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 34716 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6240 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 34727 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6258 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6268 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6278 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34769 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6288 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 34783 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6298 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6308 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34811 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6318 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34825 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6328 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6338 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34853 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6348 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 34867 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6358 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 34881 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6368 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
#line 34895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6381 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 34901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6382 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 34907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6383 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 34913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6384 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 34919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6385 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 34925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6386 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 34931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6387 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 34937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6388 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 34943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6389 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 34949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6390 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 34955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6391 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 34961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6392 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 34967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6393 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 34973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6403 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = (yyvsp[0].objtype); }
#line 34979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6404 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 34985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6405 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 34991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6406 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 34997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6407 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 35003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6411 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 35009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6412 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 35015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6413 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 35021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6414 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 35027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6415 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 35033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6416 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 35039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6417 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 35045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6418 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 35051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6423 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 35057 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 920:
#line 6424 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 35063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 921:
#line 6425 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 35069 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 922:
#line 6429 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 35075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 923:
#line 6430 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 35081 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 924:
#line 6433 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 925:
#line 6434 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 35093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 926:
#line 6438 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 35099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 927:
#line 6440 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 35105 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 928:
#line 6444 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 35111 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 929:
#line 6445 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 35117 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 930:
#line 6457 "gram_minimal.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35129 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 931:
#line 6467 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35135 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 932:
#line 6468 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35141 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 933:
#line 6469 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35147 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 934:
#line 6480 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35159 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 935:
#line 6488 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35171 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 936:
#line 6496 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35183 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 937:
#line 6504 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35195 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 938:
#line 6512 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35207 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 939:
#line 6520 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 940:
#line 6528 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 941:
#line 6536 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35243 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 942:
#line 6544 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35255 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 943:
#line 6552 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 944:
#line 6565 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 945:
#line 6573 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 946:
#line 6581 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 947:
#line 6589 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 948:
#line 6597 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 949:
#line 6605 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 950:
#line 6613 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35356 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 951:
#line 6621 "gram_minimal.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35368 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 952:
#line 6631 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35374 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 953:
#line 6632 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35380 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 954:
#line 6648 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35393 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 955:
#line 6658 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35406 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 956:
#line 6668 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35419 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 957:
#line 6678 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 958:
#line 6688 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 959:
#line 6698 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 960:
#line 6708 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35471 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 961:
#line 6718 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].value);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35484 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 962:
#line 6728 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 963:
#line 6738 "gram_minimal.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 35510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 964:
#line 6748 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35516 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 965:
#line 6749 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35522 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 966:
#line 6752 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 967:
#line 6753 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 968:
#line 6764 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = false;
					(yyval.node) = (Node *)n;
				}
#line 35544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 969:
#line 6770 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);
					n->ismove = true;
					(yyval.node) = (Node *)n;
				}
#line 35554 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 970:
#line 6778 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35566 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 971:
#line 6786 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 972:
#line 6794 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35590 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 973:
#line 6802 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35602 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 974:
#line 6810 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35614 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 975:
#line 6818 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
#line 35626 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 976:
#line 6826 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 977:
#line 6834 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35650 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 978:
#line 6842 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35662 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 979:
#line 6850 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 35674 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 980:
#line 6858 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35686 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 981:
#line 6866 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35698 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 982:
#line 6874 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 35710 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 983:
#line 6882 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
#line 35722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 984:
#line 6890 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *)n;
				}
#line 35734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 985:
#line 6898 "gram_minimal.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
#line 35746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 990:
#line 6924 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node*)n;
				}
#line 35763 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 991:
#line 6941 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 992:
#line 6956 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 35799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 993:
#line 6982 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35805 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 994:
#line 6984 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35811 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 995:
#line 6986 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35817 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 996:
#line 6988 "gram_minimal.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 35828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 997:
#line 6995 "gram_minimal.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 35839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7003 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 35845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 999:
#line 7004 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 35851 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 7008 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35862 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 7015 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 7022 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7029 "gram_minimal.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 35895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 7043 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 7051 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 7059 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 7067 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7075 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7083 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7091 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7099 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 35991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 7107 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 7115 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 7123 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 7131 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1016:
#line 7139 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1017:
#line 7147 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7155 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7163 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7171 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7179 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36111 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7187 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36123 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7195 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 36135 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7206 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 36141 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7207 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 36147 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7211 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36153 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7212 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36159 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7217 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36165 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7218 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36171 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7229 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->admin_opt = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node*)n;
				}
#line 36185 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7242 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 36199 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7252 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node*)n;
				}
#line 36213 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7263 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7264 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7267 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36231 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7268 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 36237 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7279 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node*)n;
				}
#line 36248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7288 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7289 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7294 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 36268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7298 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 36276 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7302 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[0].list), (yylsp[-2]));
				}
#line 36284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7314 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node*)n;
				}
#line 36300 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7327 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 36317 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7341 "gram_minimal.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *)n;
				}
#line 36334 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7356 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 36340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7357 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 36346 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7358 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 36352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7359 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 36358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7360 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 36364 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7361 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 36370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7376 "gram_minimal.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-13].boolean);
					n->concurrent = (yyvsp[-11].boolean);
					n->idxname = (yyvsp[-10].str);
					n->relation = (yyvsp[-8].range);
					n->accessMethod = (yyvsp[-7].str);
					n->indexParams = (yyvsp[-5].list);
					n->indexIncludingParams = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 36402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7406 "gram_minimal.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[-16].boolean);
					n->concurrent = (yyvsp[-14].boolean);
					n->idxname = (yyvsp[-10].str);
					n->relation = (yyvsp[-8].range);
					n->accessMethod = (yyvsp[-7].str);
					n->indexParams = (yyvsp[-5].list);
					n->indexIncludingParams = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilenodeSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *)n;
				}
#line 36434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7436 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36440 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7437 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36446 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7441 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36452 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7442 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36458 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7446 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36464 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7447 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7451 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7452 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 36482 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7455 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 36488 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7456 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 36494 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7462 "gram_minimal.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 36510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7474 "gram_minimal.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 36526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 7493 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 36535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 7498 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 36544 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 7503 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 36553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 7509 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 7510 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36565 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 7513 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 36571 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 7514 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 36577 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 7517 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 7518 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36589 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 7521 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 7522 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 7525 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 36607 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 7526 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 36613 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 7527 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 36619 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 7530 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 36625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 7531 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 36631 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 7532 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 36637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 7550 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 36653 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 7563 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 36670 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 7577 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 36686 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 7590 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 36702 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 7604 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36708 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 7605 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36714 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 7608 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36720 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 7609 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36726 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 7613 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 36732 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 7614 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 36738 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 7618 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 36744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 7620 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 36750 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 7625 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 36762 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 7638 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 36773 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 7645 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 36784 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 7652 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 36796 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 7666 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36802 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 7667 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36808 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 7671 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 36814 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 7673 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 36820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 7688 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36833 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 7697 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36846 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 7706 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36859 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 7715 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36872 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 7724 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 36885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 7735 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 36891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 7736 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 36897 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 7737 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 36903 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 7738 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 36909 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 7739 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 36915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 7750 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 36927 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 7764 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 36933 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 7766 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 36943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 7772 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 36954 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 7782 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 36962 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 7786 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 36971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 7791 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 36980 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 7799 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 36995 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 7841 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 37003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 7845 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 37011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 7849 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 37019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 7853 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 37028 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 7860 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 37034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 7861 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 37040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 7866 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 37052 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 7876 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 37058 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 7878 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 37064 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 7883 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37070 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 7888 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37076 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 7889 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37082 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 7897 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(false), (yylsp[-3]));
				}
#line 37090 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 7901 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(true), (yylsp[-4]));
				}
#line 37098 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 7905 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 37106 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 7909 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"), (yylsp[0]));
				}
#line 37114 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 7913 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"), (yylsp[0]));
				}
#line 37122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 7917 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"), (yylsp[0]));
				}
#line 37130 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 7921 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(true), (yylsp[-2]));
				}
#line 37138 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 7925 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(false), (yylsp[-2]));
				}
#line 37146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 7929 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(true), (yylsp[-1]));
				}
#line 37154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 7933 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 37162 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 7937 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 37170 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1146:
#line 7941 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(false), (yylsp[-1]));
				}
#line 37178 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 7945 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 37186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 7949 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[0].value), (yylsp[-1]));
				}
#line 37194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 7953 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 37202 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 7957 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 37211 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 7962 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 37219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 7969 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 37227 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 7973 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 37235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 7977 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *)(yyvsp[0].list), (yylsp[-1]));
				}
#line 37243 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 7981 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(true), (yylsp[0]));
				}
#line 37251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 7985 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 37259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 7990 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37265 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 7992 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 37273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 7998 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReturnStmt *r = makeNode(ReturnStmt);
					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 37283 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 8007 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 37291 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 8011 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 37305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 8021 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = NULL;
				}
#line 37313 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 8028 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 37325 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1164:
#line 8036 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 37333 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 8047 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 37339 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 8048 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 37345 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 8052 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37351 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 8053 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37357 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8057 "gram_minimal.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 37370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8069 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 37378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8073 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 37386 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8088 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37398 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8096 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37410 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8104 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37422 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8115 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37428 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8116 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8140 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37448 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8150 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8160 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8170 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37490 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8180 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37504 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8190 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37518 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8203 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37532 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8213 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8226 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37560 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8236 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37574 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8249 "gram_minimal.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 37586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8257 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 37592 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8259 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 37598 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8261 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 37604 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8266 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37610 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8268 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 37616 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8272 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 37622 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1198:
#line 8274 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 37628 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1199:
#line 8279 "gram_minimal.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);
					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 37639 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8297 "gram_minimal.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 37649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8305 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37655 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8306 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 37661 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8311 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 37669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8315 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 37677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8328 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 37691 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8339 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
#line 37705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8350 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
#line 37719 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8361 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 37725 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8362 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 37731 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8363 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 37737 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8368 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
#line 37751 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1212:
#line 8379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37757 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1213:
#line 8380 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37763 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8391 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);
					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *)n;
				}
#line 37777 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8403 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 37785 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8407 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 37793 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8411 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 37801 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8415 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 37809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8422 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *)n;
				}
#line 37822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 8442 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
								makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37838 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 8454 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = NIL;
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
								makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37854 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 8466 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
								makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37870 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 8478 "gram_minimal.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[-2].ival);
					n->name = (yyvsp[0].str);
					n->relation = NULL;
					n->params = (yyvsp[-4].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
								makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *)n;
				}
#line 37886 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 8491 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 37892 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 8492 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 37898 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 8495 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SCHEMA; }
#line 37904 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 8496 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 37910 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 8497 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 37916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 8508 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *)n;
				}
#line 37929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 8517 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *)n;
				}
#line 37942 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 8534 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 8543 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37968 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 8552 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 8561 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 37994 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 8570 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38007 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 8579 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38020 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 8588 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 8597 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38046 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 8606 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38059 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 8615 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38072 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 8624 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38085 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 8633 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38098 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 8642 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 8652 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38126 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 8662 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38139 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 8671 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 8680 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38165 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 8689 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38178 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 8698 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38191 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 8707 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38204 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 8716 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38218 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 8726 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38232 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 8736 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38246 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 8746 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 8756 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38274 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 8766 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38288 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 8776 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38302 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 8786 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38316 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 8796 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38330 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 8806 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38344 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 8816 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 8826 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 8836 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38387 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 8847 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38402 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 8858 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38417 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 8869 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 8880 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38447 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 8891 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 8902 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38476 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 8912 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38490 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 8922 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 8933 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38520 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 8944 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 8954 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38548 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 8964 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 38560 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 8972 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38573 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 8981 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38586 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 8990 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38599 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 8999 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 9008 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 9017 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38638 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 9026 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38651 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 9035 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38664 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 9044 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 9053 "gram_minimal.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 9070 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 38699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 9071 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 38705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 9082 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38718 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 9091 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38731 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 9100 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 9109 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38758 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 9119 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38771 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 9128 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);
					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *)n;
				}
#line 38784 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 9138 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38790 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 9139 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 38796 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 9150 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 9159 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38822 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 9168 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 9177 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38848 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9186 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9195 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38874 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9204 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38887 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9213 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38900 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9222 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9231 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38926 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9240 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38939 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9249 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38952 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9258 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 38965 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9267 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38978 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9276 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 38991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9285 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9294 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39017 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9303 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39030 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9312 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9321 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39056 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 9330 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39069 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1319:
#line 9339 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39082 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1320:
#line 9348 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39095 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9357 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39108 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9366 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39121 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9375 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 39134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9384 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 39147 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9402 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);
					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 39158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9410 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 39164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9411 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 39170 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9415 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 39176 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 9417 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 39182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 9422 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].typnam); }
#line 39188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 9423 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[0].keyword))); }
#line 39194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 9424 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].list); }
#line 39200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 9425 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[0].value); }
#line 39206 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 9426 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)makeString((yyvsp[0].str)); }
#line 39212 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 9439 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);
					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 39223 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 9454 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 9462 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 9470 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39259 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 9478 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39271 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 9486 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39283 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 9494 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39295 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 9502 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 9510 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].value);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39319 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 9518 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 9526 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39343 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 9534 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 9542 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39367 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 9550 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39379 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 9558 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 9566 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 9574 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 9582 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 9590 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 9598 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 9606 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39463 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 9614 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 9622 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 9630 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 9638 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *)n;
				}
#line 39511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 9656 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					if ((yyvsp[-1].node) != NULL)
					{
						/* FOR TABLE */
						if (IsA((yyvsp[-1].node), List))
							n->tables = (List *)(yyvsp[-1].node);
						/* FOR ALL TABLES */
						else
							n->for_all_tables = true;
					}
					(yyval.node) = (Node *)n;
				}
#line 39531 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 9674 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39537 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 9675 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 39543 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 9680 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].list);
				}
#line 39551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 9684 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeInteger(true);
				}
#line 39559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 9704 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39570 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 9711 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_ADD;
					(yyval.node) = (Node *)n;
				}
#line 39582 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 9719 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_SET;
					(yyval.node) = (Node *)n;
				}
#line 39594 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 9727 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);
					n->pubname = (yyvsp[-3].str);
					n->tables = (yyvsp[0].list);
					n->tableAction = DEFELEM_DROP;
					(yyval.node) = (Node *)n;
				}
#line 39606 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 9744 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39620 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 9763 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 9772 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39646 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 9781 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39659 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 9790 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 9800 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39687 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 9810 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 9820 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(true), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 39715 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 9830 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);
					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *)makeInteger(false), (yylsp[-3])));
					(yyval.node) = (Node *)n;
				}
#line 39729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 9848 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 9856 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);
					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 9874 "gram_minimal.y" /* yacc.c:1646  */
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39769 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 9888 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 9889 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 39781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 9890 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 39787 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 9896 "gram_minimal.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 39797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 9902 "gram_minimal.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 39807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 9918 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 39813 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 9919 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 39819 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 9922 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 39825 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 9923 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 39831 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 9924 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 39837 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 9925 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 39843 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 9929 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 9930 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39855 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 9931 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39861 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 9944 "gram_minimal.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39872 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 9953 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39878 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 9954 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39884 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 9958 "gram_minimal.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39894 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 9967 "gram_minimal.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39904 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 9973 "gram_minimal.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
#line 39914 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 9992 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39926 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 10000 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 39937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 10007 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 10015 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 39961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 10023 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 10030 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39983 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 10037 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 39994 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 10044 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40005 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 10051 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40016 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 10058 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 10065 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40038 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 10072 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 10082 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40060 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 10089 "gram_minimal.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 40072 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 10105 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 40079 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 10108 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 40086 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 10111 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 40093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 10114 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 40100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 10117 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 40107 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1428:
#line 10124 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40113 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1429:
#line 10126 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 40119 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1430:
#line 10128 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40125 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1432:
#line 10134 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40131 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10138 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40137 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10139 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40143 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10140 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40149 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10154 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 40165 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10167 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 40181 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10180 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 40202 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10198 "gram_minimal.y" /* yacc.c:1646  */
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 40223 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10217 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 40229 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 10218 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 40235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 10219 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 40241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 10220 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 40247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 10231 "gram_minimal.y" /* yacc.c:1646  */
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40257 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 10247 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40268 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 10256 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40274 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 10257 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40280 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 10261 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40286 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 10262 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40292 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 10267 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 40300 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 10271 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *)makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 40308 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 10275 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 40316 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 10292 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 10293 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 40328 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 10294 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40334 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 10295 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 10296 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40346 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 10297 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40352 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 10298 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 40358 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1462:
#line 10318 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 40369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1463:
#line 10325 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				 }
#line 40380 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1464:
#line 10332 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *)makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *)n;
				 }
#line 40392 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 10343 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 40403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 10360 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *)n;
				}
#line 40415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 10368 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *)n;
				}
#line 40427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 10376 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 40439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 10384 "gram_minimal.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 40451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 10395 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 40459 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 10399 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 40467 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 10410 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 40475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1473:
#line 10422 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);
					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *)n;
				}
#line 40485 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 10439 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 40495 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 10445 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *)n;
				}
#line 40505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 10461 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
#line 40518 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 10474 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 40530 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 10483 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 40541 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 10491 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *)n;
				}
#line 40552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 10499 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 40564 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 10508 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
#line 40578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 10519 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
#line 40592 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 10530 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *)n;
				}
#line 40604 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 10552 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 40615 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 10562 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 40630 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 10573 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
#line 40645 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 10584 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 40660 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 10595 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
#line 40675 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 10606 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
#line 40688 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 10615 "gram_minimal.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
#line 40701 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 10643 "gram_minimal.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *)n;
			}
#line 40715 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 10666 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node*)n;
				}
#line 40729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 10677 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node*)n;
				}
#line 40741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 10685 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node*)n;
				}
#line 40755 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 10696 "gram_minimal.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node*)n;
				}
#line 40769 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 10708 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40775 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 10709 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 40781 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1502:
#line 10722 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *)n;
				}
#line 40805 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1503:
#line 10742 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 40817 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 10752 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *)n;
				}
#line 40832 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 10763 "gram_minimal.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 40844 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 10774 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 40852 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 10778 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 40860 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 10790 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 40868 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 10796 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40874 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 10797 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 40880 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 10801 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 40886 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 10802 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].value); }
#line 40892 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 10803 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 40898 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 10807 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40904 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 10808 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40910 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 10812 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40916 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 10813 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40922 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 10816 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40928 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 10817 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40934 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 10820 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40940 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 10821 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40946 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 10825 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40952 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 10826 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40958 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 10831 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 40966 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1527:
#line 10838 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 40972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1528:
#line 10840 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 40978 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 10844 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40984 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 10845 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40990 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 10859 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 41001 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 10866 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 10876 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41026 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 10883 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 41037 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 10911 "gram_minimal.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 41049 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 10920 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41055 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 10921 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41061 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 10939 "gram_minimal.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41072 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1552:
#line 10947 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 41092 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1553:
#line 10964 "gram_minimal.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 41112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 10981 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 41118 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 10982 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 10993 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 41134 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 10999 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[0].str);
						(yyval.node) = (Node *) n;
					}
#line 41144 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 11005 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 41154 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 11011 "gram_minimal.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
#line 41164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 11028 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 41176 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 11038 "gram_minimal.y" /* yacc.c:1646  */
    {
				InsertStmt *insert = makeNode(InsertStmt);
				insert->relation = (yyvsp[0].range);
				(yyval.node) = (Node *) insert;
				/*
				 * Assign the node directly to the parsetree and exit the scanner
				 * we don't want to keep parsing for information we don't need
				 */
				pg_yyget_extra(yyscanner)->parsetree = list_make1(makeRawStmt((yyval.node), 0));
				YYACCEPT;
			}
#line 41192 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 11059 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 41200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 11063 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 41209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 11071 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41219 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 11077 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41230 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 11084 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41240 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 11090 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 41251 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 11097 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 41261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 11105 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 41267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 11106 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 41273 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 11111 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 41279 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 11113 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 41285 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 11118 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 41297 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 11129 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 41310 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 11139 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 41323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 11148 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 41331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 11155 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 41343 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 11164 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 41355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 11172 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 41363 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1580:
#line 11178 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41369 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1581:
#line 11179 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41375 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1582:
#line 11192 "gram_minimal.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *)n;
				}
#line 41389 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1583:
#line 11204 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1584:
#line 11205 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1585:
#line 11217 "gram_minimal.y" /* yacc.c:1646  */
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *)n;
				}
#line 41414 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1586:
#line 11227 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 41420 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1587:
#line 11228 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 41426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1588:
#line 11231 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 41432 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1589:
#line 11232 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 41438 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 11233 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 41444 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 11234 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 41450 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 11235 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 41456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1593:
#line 11236 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 41462 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1594:
#line 11237 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 41468 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1595:
#line 11238 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 41474 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1596:
#line 11241 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41480 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1597:
#line 11242 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41486 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 11246 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 41492 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 11247 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 41498 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 11248 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 41504 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 11264 "gram_minimal.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *)n;
				}
#line 41519 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 11276 "gram_minimal.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[0].range);
					n->targetList = NULL;
					n->fromClause = NULL;
					n->whereClause = NULL;
					n->returningList = NULL;
					n->withClause = (yyvsp[-2].with);
					(yyval.node) = (Node *)n;
					pg_yyget_extra(yyscanner)->parsetree = list_make1(makeRawStmt((yyval.node), 0));
					YYACCEPT;
				}
#line 41536 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 11290 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41542 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 11291 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 41548 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 11296 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 41557 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 11301 "gram_minimal.y" /* yacc.c:1646  */
    {
					int ncolumns = list_length((yyvsp[-3].list));
					int i = 1;
					ListCell *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 41582 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 11325 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 41594 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 11335 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 41600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 11336 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 41606 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 11347 "gram_minimal.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *)n;
				}
#line 41619 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 11357 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 41625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 11360 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41631 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 11361 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 41637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 11362 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 41643 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 11363 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 41649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 11364 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 41655 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 11365 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 41661 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 11368 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41667 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 11369 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 41673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 11370 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 41679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 11423 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 41685 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 11424 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 41691 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 11439 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41697 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 11441 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 41708 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 11448 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41720 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 11456 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41732 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 11464 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 41744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 11472 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 41756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 11480 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41768 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 11488 "gram_minimal.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 41780 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 11498 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41786 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 11499 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41792 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 11534 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41809 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 11549 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *)n;
				}
#line 41827 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 11562 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 41833 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 11564 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *)n;
				}
#line 41856 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 11583 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41864 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 11587 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41872 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 11591 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 41880 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 11606 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 41891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 11613 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 41902 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 11620 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 41913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 11629 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 41919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 11630 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 41925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 11634 "gram_minimal.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 41941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 11648 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 41947 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 11649 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 41953 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 11650 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 41959 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 11655 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);
				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 41972 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 11664 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);
				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 41985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 11673 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 41993 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 11680 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);
				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 42008 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 11691 "gram_minimal.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);
				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 42023 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 11702 "gram_minimal.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 42031 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 11708 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 42037 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 11709 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 42043 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 11714 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 42058 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 11725 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 42064 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 11734 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42073 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 11739 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42082 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 11744 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42091 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 11749 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42100 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 11754 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42112 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 11762 "gram_minimal.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 42124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 11770 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 42133 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 11775 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 42142 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 11780 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 42151 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 11791 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 42157 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 11792 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 42163 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 11793 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 42169 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 11800 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 42175 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 11801 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42181 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 11810 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42187 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 11811 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42193 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 11815 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42199 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 11816 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42205 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 11820 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42211 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 11824 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 42217 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 11825 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 42223 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 11829 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 42236 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 11838 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 42249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1688:
#line 11851 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 42258 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1689:
#line 11856 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 42267 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 11861 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 42275 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 11865 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 42287 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 11875 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 42293 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 11876 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 42299 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 11881 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 42311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 11889 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 42324 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 11905 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 42336 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 11913 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 42348 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 11921 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 42360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 11929 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));
					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 42372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 11940 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 11943 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 42384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 11947 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42390 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 11949 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 42399 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 11956 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42405 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 11976 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42411 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 11978 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 42417 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 11980 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 42423 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 11984 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 42429 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 11985 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 42435 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 11989 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42441 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 11990 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42447 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 11993 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42453 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 11994 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42459 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 12020 "gram_minimal.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));
					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 42470 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 12027 "gram_minimal.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));
					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 42481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 12036 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 12037 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 42493 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 12041 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 12042 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 12043 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 12044 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 12045 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 12050 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 42531 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 12063 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 12070 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 42547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 12077 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 42555 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 12083 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 42561 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 12084 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 42567 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 12088 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42573 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 12089 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42579 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 12093 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 12094 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 12098 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42597 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 12099 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 42603 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 12104 "gram_minimal.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 42615 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 12114 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 42621 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1737:
#line 12115 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 42627 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1738:
#line 12116 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 42633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 12117 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 42639 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 12121 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42645 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 12122 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42651 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 12133 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 42661 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 12139 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 42671 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1744:
#line 12156 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 42677 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1745:
#line 12157 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 42683 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 12161 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 42689 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 12162 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 42695 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 12169 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 42704 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 12174 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);
					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 42716 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 12182 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 42727 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 12189 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 42739 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 12197 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 42749 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 12203 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);
					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 42760 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 12210 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 42799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 12245 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					/* same comment as above */
					if ((yyvsp[0].alias) == NULL)
					{
						if (IsA((yyvsp[-1].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[-1].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[-1]))));
					}
					(yyval.node) = (Node *) n;
				}
#line 42828 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 12270 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 42836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 12274 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 42845 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 12300 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 42853 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 12304 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 42870 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 12317 "gram_minimal.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 42894 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 12337 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 42919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 12358 "gram_minimal.y" /* yacc.c:1646  */
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 42935 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 12370 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 42952 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 12386 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42962 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 12392 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 12397 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 42981 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 12403 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 42990 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 12409 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 42996 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 12410 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 43002 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 12421 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 43012 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 12426 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 43018 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 12435 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 43026 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 12439 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 43034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 12443 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 43044 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 12449 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 43054 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 12455 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 43062 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 12460 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 43068 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 12461 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 43074 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 12462 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 43080 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 12463 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 43086 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 12484 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 43094 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 12488 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 43102 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 12496 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 43113 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 12503 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 43124 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 12510 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 43135 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 12517 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 43146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 12527 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 43152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 12528 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 43158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 12542 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 43166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 12546 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 43177 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 12553 "gram_minimal.y" /* yacc.c:1646  */
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 43188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 12566 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);
					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 43202 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 12578 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 43208 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 12579 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43214 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 12595 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 43228 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 12605 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 43242 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 12617 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 43248 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 12621 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 43254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 12622 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 43260 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 12625 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43266 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 12626 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43272 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 12629 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 43278 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 12630 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 43284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 12635 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43290 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 12636 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 12641 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 43302 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 12643 "gram_minimal.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 43314 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 12650 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 43320 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 12655 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 43326 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 12656 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43332 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 12661 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 43340 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 12665 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 43348 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 12671 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 43370 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 12695 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 43384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 12706 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);
					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *)n;
				}
#line 43398 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 12717 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 43404 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 12718 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 43410 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 12723 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 43428 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 12737 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);
					ListCell		   *option;
					bool				nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = intVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 43489 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 12794 "gram_minimal.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol	   *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 43504 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 12808 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 43510 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 12810 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 43516 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 12815 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 43522 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 12817 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 43528 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 12819 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(true), (yylsp[-1])); }
#line 43534 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 12821 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeInteger(false), (yylsp[0])); }
#line 43540 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 12826 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 43546 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 12828 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 43552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 12833 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 43564 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 12841 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 43576 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 12861 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 43585 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 12866 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 43595 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 12873 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 43604 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 12878 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 43614 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 12884 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 43623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 12889 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 43633 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 12898 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 43639 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 12900 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 43645 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 12902 "gram_minimal.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 43651 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 12906 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 12907 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43663 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 12908 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43669 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 12909 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43675 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 12910 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43681 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 12912 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 43690 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 12917 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 43700 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 12936 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43706 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1850:
#line 12937 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43712 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1851:
#line 12938 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43718 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 12939 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 43724 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 12951 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 12957 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 43744 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 12964 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 43750 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 12965 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 43756 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 12972 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43765 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 12977 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 12982 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43783 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 12987 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43792 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 12992 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43801 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 12997 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43810 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 13002 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43819 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 13007 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43829 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 13013 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43839 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 13019 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43849 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 13025 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 43858 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 13032 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 43883 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 13053 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 43891 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 13063 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 13067 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 13075 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43915 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 13079 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 43924 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 13087 "gram_minimal.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 43937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 13099 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 43955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 13120 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 13124 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 13130 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 43979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 13134 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 43994 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 13147 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 44004 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 13155 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 44016 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 13165 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44022 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 13167 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44028 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 13169 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 44034 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 13171 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44040 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 13173 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44046 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 13175 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 44052 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 13179 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44058 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 13180 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44064 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 13188 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 44077 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 13197 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 44089 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 13205 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 44102 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 13214 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 44114 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 13225 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 44123 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 13232 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44129 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 13233 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44135 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 13234 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44141 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 13239 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 44147 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 13241 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 44153 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 13243 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 44159 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 13245 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 44165 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 13247 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 44171 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 13249 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44177 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 13251 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 44186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 13256 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 44195 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 13261 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 44205 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 13267 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 44217 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 13275 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 44226 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 13280 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 44237 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 13287 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 44247 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 13293 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44253 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 13298 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 44261 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 13302 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 44270 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 13337 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44276 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1915:
#line 13339 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 44282 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1916:
#line 13341 "gram_minimal.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 44294 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 13349 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 44305 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 13365 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44311 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 13367 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44317 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 13369 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44323 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 13371 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44329 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 13373 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44335 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 13375 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44341 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 13377 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44347 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 13379 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44353 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 13381 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44359 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 13383 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44365 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 13385 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44371 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 13387 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44377 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 13389 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44383 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 13391 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44389 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 13394 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44395 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 13396 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44401 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 13399 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44407 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 13401 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44413 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 13403 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 44419 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 13405 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 44425 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 13408 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 44434 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 13413 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 44447 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 13422 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 44456 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 13427 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 44469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 13436 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 44478 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 13441 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 44491 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 13450 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 44500 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 13455 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("like_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 44513 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 13465 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make1((yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 44526 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 13474 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 44539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 13483 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make1((yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 44552 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 13492 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall(SystemFuncName("similar_to_escape"),
											   list_make2((yyvsp[-2].node), (yyvsp[0].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 44565 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 13511 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 44577 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 13519 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44589 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 13527 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 44601 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 13535 "gram_minimal.y" /* yacc.c:1646  */
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44613 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 13543 "gram_minimal.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 44634 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 13560 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 44646 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 13568 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 44658 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 13576 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 44670 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 13584 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 44682 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 13592 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *)b;
				}
#line 44694 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 13600 "gram_minimal.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *)b;
				}
#line 44706 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 13608 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 44714 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 13612 "gram_minimal.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 44722 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 13616 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 44734 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 13624 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 44746 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 13632 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 44758 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 13640 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 44770 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 13648 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 44794 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 13668 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[0].node);
						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 44820 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 13690 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *)n;
				}
#line 44835 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 13701 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 44846 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 13708 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-1]))));
				}
#line 44866 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 13724 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 44875 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 13729 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 44885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 13735 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 44896 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 13742 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 44907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 13749 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 44919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 13757 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 44931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 13765 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);
					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 44949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 13790 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 13792 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 44961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 13794 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 44967 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 13796 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 44973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 13798 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 13800 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 13802 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 13804 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 44997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 13806 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 13808 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 13810 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 13812 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 13814 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 13816 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 13818 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 13820 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 13822 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 45051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 13824 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 45057 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 13826 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 45065 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 13830 "gram_minimal.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 45073 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 13834 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 45082 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 13839 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 45092 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 13854 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45098 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 13855 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45104 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 13857 "gram_minimal.y" /* yacc.c:1646  */
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 45123 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 13872 "gram_minimal.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 45139 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 13884 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45145 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 13886 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45151 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 13888 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *)n;
				}
#line 45166 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 13899 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
#line 45194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 13923 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 45209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 13934 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 45224 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 13945 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *)n;
				}
#line 45235 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 13952 "gram_minimal.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 45249 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 13962 "gram_minimal.y" /* yacc.c:1646  */
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *)r;
				}
#line 45263 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 13972 "gram_minimal.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);
				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *)g;
			  }
#line 45274 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 13981 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 45284 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 13987 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-4]));
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 45296 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 13995 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 45309 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 14004 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-7]));
					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *)n;
				}
#line 45322 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 14013 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
#line 45338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 14025 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *)n;
				}
#line 45351 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 14034 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[-3].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
					n->agg_star = true;
					(yyval.node) = (Node *)n;
				}
#line 45373 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 14064 "gram_minimal.y" /* yacc.c:1646  */
    {
					FuncCall *n = (FuncCall *) (yyvsp[-3].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 45412 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 14099 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45418 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 14109 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45424 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 14110 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45430 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 14118 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45441 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 14125 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 45449 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 14129 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 45457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 14133 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 45465 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 14137 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 45473 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 14141 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 45481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 14145 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 45489 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 14149 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 45497 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 14153 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 45505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 14157 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 45513 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 14161 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 45521 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 14165 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 45529 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 14169 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 45537 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 14173 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 45545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 14177 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 45553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 14181 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 45561 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 14185 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 45567 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 14187 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45578 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 14194 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45589 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 14201 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 45600 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 14208 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 14215 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 45626 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 14226 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45644 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 14240 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45658 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 14250 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 45673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 14261 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 45693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 14277 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45707 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 14287 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45718 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 14294 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 14301 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 45740 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 14308 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 45748 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 14312 "gram_minimal.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *)c;
				}
#line 45759 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 14319 "gram_minimal.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 45771 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 14327 "gram_minimal.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *)v;
				}
#line 45783 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 14335 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 45791 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 14339 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 45799 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 14343 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 45807 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 14347 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 45815 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 14351 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 45823 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 14355 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 45836 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 14364 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 45844 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 14368 "gram_minimal.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));
					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *)x;
				}
#line 45857 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 14377 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 45865 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 14381 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 45873 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 14385 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 45882 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 14390 "gram_minimal.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[-4].ival);
					n->expr = (yyvsp[-3].node);
					n->typeName = (yyvsp[-1].typnam);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *)n;
				}
#line 45895 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 14404 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 45901 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 14406 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 45907 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 14410 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 45913 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 14412 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 45919 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 14414 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 45925 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 14416 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 45931 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 14419 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45937 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 14422 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45943 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 14423 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45949 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 14427 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 45961 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 14435 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 45973 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 14444 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 45979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 14445 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 45985 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 14448 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 14449 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45997 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 14450 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 46003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 14456 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 46011 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 14460 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46019 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 14464 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 46027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 14468 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46035 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 14483 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46041 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 14484 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46047 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 14488 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 46053 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 14489 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46059 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 14497 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46065 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 14498 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46071 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 14502 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 46077 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 14504 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 46083 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 14509 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 46093 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 14517 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 46099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 14519 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 46116 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 14532 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 46122 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 14537 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 46140 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 14562 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46146 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 14563 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 46152 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 14566 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46158 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 14567 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 14576 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 46175 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 14583 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 46186 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 14590 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[-1].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 46197 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 14597 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 14607 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = (yyvsp[0].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 46230 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 14624 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n1 = (yyvsp[-2].windef);
					WindowDef *n2 = (yyvsp[0].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 46271 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 14669 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46283 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 14677 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46295 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 14685 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46307 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 14693 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46319 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 14701 "gram_minimal.y" /* yacc.c:1646  */
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 46331 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 14711 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 46337 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 14712 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 46343 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 14713 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 46349 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 14714 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46355 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 14715 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46361 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 14729 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46367 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 14730 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46373 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 14731 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 46379 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 14734 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46385 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 14735 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46391 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 14738 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 46397 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 14741 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 46403 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 14742 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 46409 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 14743 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 46415 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 14746 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46421 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 14747 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46427 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 14750 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 46433 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 14751 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 46439 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 14752 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 46445 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 14753 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 46451 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 14754 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 46457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 14755 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 46463 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 14756 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 46469 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 14757 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 46475 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 14758 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 46481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 14759 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 46487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 14760 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 46493 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 14761 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 46499 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 14765 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46505 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 14767 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46511 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 14772 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46517 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 14774 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46523 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 14779 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 46529 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 14781 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46535 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 14783 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 46541 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 14785 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 46547 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 14787 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 46553 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 14789 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 46559 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 14801 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 46567 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 14805 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 46575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 14812 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 46583 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 14816 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 46591 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 14822 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 46599 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 14826 "gram_minimal.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 46612 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 14835 "gram_minimal.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 46625 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 14845 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46631 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 14846 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46637 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 14849 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 46643 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 14850 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 46649 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 14854 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 46657 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 14858 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 46665 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 14862 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 46673 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 14867 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46679 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 14868 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46685 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 14874 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 46693 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 14883 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46699 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 14884 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 46705 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 14885 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 46711 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 14886 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 46717 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 14887 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 46723 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 14888 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 46729 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 14889 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 46735 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 14890 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46741 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 14894 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFC"; }
#line 46747 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 14895 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFD"; }
#line 46753 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 14896 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKC"; }
#line 46759 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 14897 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKD"; }
#line 46765 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 14903 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46774 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 14908 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46783 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 14916 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 46789 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 14938 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46797 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 14942 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 46806 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 14947 "gram_minimal.y" /* yacc.c:1646  */
    {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46821 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 14958 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 46842 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 14975 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 46850 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 14980 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 46856 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 14981 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46862 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 14982 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46868 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 14986 "gram_minimal.y" /* yacc.c:1646  */
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
#line 46879 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 14992 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *)(yyvsp[-1].list); }
#line 46885 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 15003 "gram_minimal.y" /* yacc.c:1646  */
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *)c;
				}
#line 46899 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2203:
#line 15016 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46905 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2204:
#line 15017 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 46911 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 15022 "gram_minimal.y" /* yacc.c:1646  */
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *)w;
				}
#line 46923 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 15032 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46929 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 15033 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46935 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 15036 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46941 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 15037 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46947 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 15041 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 46955 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 15045 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 46963 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 15052 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 46971 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 15056 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 46979 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 15060 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 46991 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 15068 "gram_minimal.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 47003 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 15078 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47009 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 15079 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47015 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 15083 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47021 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 15084 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 47027 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 15088 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47033 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 15089 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 47039 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 15103 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47045 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 15104 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47051 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 15108 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 47057 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 15109 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 47063 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 15113 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 47075 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 15121 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 47087 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 15129 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 47099 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 15137 "gram_minimal.y" /* yacc.c:1646  */
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 47115 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 15158 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 47121 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 15159 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 47127 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 15171 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 47135 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 15175 "gram_minimal.y" /* yacc.c:1646  */
    {
					check_qualified_name((yyvsp[0].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[-1]));
					switch (list_length((yyvsp[0].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[-1].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[0].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[-1].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[0].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[0].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)))),
									 parser_errposition((yylsp[-1]))));
							break;
					}
				}
#line 47164 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 15202 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 47170 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 15204 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 47176 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 15208 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47182 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 15210 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47188 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 15212 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47194 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 15223 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 47200 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 15225 "gram_minimal.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 47209 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 15236 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 47217 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 15240 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 47225 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 15244 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 47233 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 15248 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 47241 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 15252 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 47254 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 15261 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-1].list));
					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 47265 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 15268 "gram_minimal.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 47301 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 15300 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 47309 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 15304 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-2].typnam);
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 47319 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 15310 "gram_minimal.y" /* yacc.c:1646  */
    {
					TypeName *t = (yyvsp[-4].typnam);
					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 47330 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 15317 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 47338 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 15321 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 47346 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 15325 "gram_minimal.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 47354 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 15330 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 47360 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 15331 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47366 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 15333 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 47372 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 15334 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 47378 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 15335 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 47384 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 15340 "gram_minimal.y" /* yacc.c:1646  */
    {
					RoleSpec *spc = (RoleSpec *) (yyvsp[0].rolespec);
					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 47426 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 15380 "gram_minimal.y" /* yacc.c:1646  */
    {
						/*
						 * "public" and "none" are not keywords, but they must
						 * be treated specially here.
						 */
						RoleSpec *n;
						if (strcmp((yyvsp[0].str), "public") == 0)
						{
							n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
							n->roletype = ROLESPEC_PUBLIC;
						}
						else if (strcmp((yyvsp[0].str), "none") == 0)
						{
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"none"),
									 parser_errposition((yylsp[0]))));
						}
						else
						{
							n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
							n->rolename = pstrdup((yyvsp[0].str));
						}
						(yyval.rolespec) = n;
					}
#line 47457 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 15407 "gram_minimal.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
					}
#line 47465 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 15411 "gram_minimal.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
					}
#line 47473 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 15415 "gram_minimal.y" /* yacc.c:1646  */
    {
						(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
					}
#line 47481 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 15421 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 47487 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 15423 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 47493 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 15440 "gram_minimal.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 47524 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 15473 "gram_minimal.y" /* yacc.c:1646  */
    {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 47539 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 15485 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47545 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 15486 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 47551 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 15507 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47557 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 15508 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47563 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 15509 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47569 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 15514 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47575 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 15515 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47581 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 15516 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47587 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 15521 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47593 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 15522 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47599 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 15523 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47605 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 15524 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47611 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 15530 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47617 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 15531 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47623 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 15532 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47629 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 15533 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47635 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 15534 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47641 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 15540 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 47647 "gram_minimal.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 15541 "gram_minimal.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 47653 "gram_minimal.c" /* yacc.c:1646  */
    break;


#line 47657 "gram_minimal.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 16485 "gram_minimal.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
minimal_base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}


static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}


static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Value	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause && limitClause->limitOption != LIMIT_OPTION_DEFAULT)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
minimal_parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

